(window.Physics = (function (t) {
  "use strict";
  void 0 === Number.EPSILON && (Number.EPSILON = Math.pow(2, -52)),
    void 0 === Math.sign &&
      (Math.sign = function (t) {
        return t < 0 ? -1 : t > 0 ? 1 : +t;
      }),
    void 0 === Function.prototype.name &&
      Object.defineProperty(Function.prototype, "name", {
        get: function () {
          return this.toString().match(/^\s*function\s*([^\(\s]*)/)[1];
        },
      }),
    void 0 === Object.assign &&
      (Object.assign = function (t) {
        if (null == t)
          throw new TypeError("Cannot convert undefined or null to object");
        for (var e = Object(t), a = 1; a < arguments.length; a++) {
          var n = arguments[a];
          if (null != n)
            for (var u in n)
              Object.prototype.hasOwnProperty.call(n, u) && (e[u] = n[u]);
        }
        return e;
      });
  var e,
    a,
    n,
    u,
    m = {
      sqrt: Math.sqrt,
      abs: Math.abs,
      floor: Math.floor,
      cos: Math.cos,
      sin: Math.sin,
      acos: Math.acos,
      asin: Math.asin,
      atan2: Math.atan2,
      round: Math.round,
      pow: Math.pow,
      max: Math.max,
      min: Math.min,
      random: Math.random,
      degtorad: 0.017453292519943295,
      radtodeg: 57.29577951308232,
      PI: 3.141592653589793,
      TwoPI: 6.283185307179586,
      PI90: 1.570796326794896,
      PI270: 4.712388980384689,
      INF: 1 / 0,
      EPZ: 1e-6,
      EPZ2: 1e-6,
      isZero: function (t) {
        return Math.abs(t) < m.EPZ;
      },
      lerp: function (t, e, a) {
        return (1 - a) * t + a * e;
      },
      randInt: function (t, e) {
        return t + m.floor(m.random() * (e - t + 1));
      },
      rand: function (t, e) {
        return t + m.random() * (e - t);
      },
      generateUUID:
        ((a =
          "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(
            ""
          )),
        (n = new Array(36)),
        (u = 0),
        function () {
          for (var t = 0; t < 36; t++)
            8 === t || 13 === t || 18 === t || 23 === t
              ? (n[t] = "-")
              : 14 === t
              ? (n[t] = "4")
              : (u <= 2 && (u = (33554432 + 16777216 * Math.random()) | 0),
                (e = 15 & u),
                (u >>= 4),
                (n[t] = a[19 === t ? (3 & e) | 8 : e]));
          return n.join("");
        }),
      int: function (t) {
        return m.floor(t);
      },
      fix: function (t, e) {
        return t.toFixed(e || 3, 10);
      },
      clamp: function (t, e, a) {
        return m.max(e, m.min(a, t));
      },
      distance: function (t, e) {
        var a = e[0] - t[0],
          n = e[1] - t[1],
          u = e[2] - t[2];
        return m.sqrt(a * a + n * n + u * u);
      },
      acosClamp: function (t) {
        return t > 1 ? 0 : t < -1 ? m.PI : m.acos(t);
      },
      distanceVector: function (t, e) {
        var a = t.x - e.x,
          n = t.y - e.y,
          u = t.z - e.z;
        return a * a + n * n + u * u;
      },
      dotVectors: function (t, e) {
        return t.x * e.x + t.y * e.y + t.z * e.z;
      },
    };
  function printError(t, e) {
    console.error("[OIMO] " + t + ": " + e);
  }
  function InfoDisplay(t) {
    (this.parent = t),
      (this.infos = new Float32Array(13)),
      (this.f = [0, 0, 0]),
      (this.times = [0, 0, 0, 0]),
      (this.broadPhase = this.parent.broadPhaseType),
      (this.version = "1.0.9"),
      (this.fps = 0),
      (this.tt = 0),
      (this.broadPhaseTime = 0),
      (this.narrowPhaseTime = 0),
      (this.solvingTime = 0),
      (this.totalTime = 0),
      (this.updateTime = 0),
      (this.MaxBroadPhaseTime = 0),
      (this.MaxNarrowPhaseTime = 0),
      (this.MaxSolvingTime = 0),
      (this.MaxTotalTime = 0),
      (this.MaxUpdateTime = 0);
  }
  function Vec3(t, e, a) {
    (this.x = t || 0), (this.y = e || 0), (this.z = a || 0);
  }
  function Quat(t, e, a, n) {
    (this.x = t || 0),
      (this.y = e || 0),
      (this.z = a || 0),
      (this.w = void 0 !== n ? n : 1);
  }
  function Mat33(t, e, a, n, u, m, f, p, y) {
    (this.elements = [1, 0, 0, 0, 1, 0, 0, 0, 1]),
      arguments.length > 0 &&
        console.error(
          "OIMO.Mat33: the constructor no longer reads arguments. use .set() instead."
        );
  }
  function AABB(t, e, a, n, u, m) {
    this.elements = new Float32Array(6);
    var f = this.elements;
    (f[0] = t || 0),
      (f[1] = a || 0),
      (f[2] = u || 0),
      (f[3] = e || 0),
      (f[4] = n || 0),
      (f[5] = m || 0);
  }
  Object.assign(InfoDisplay.prototype, {
    setTime: function (t) {
      this.times[t || 0] = performance.now();
    },
    resetMax: function () {
      (this.MaxBroadPhaseTime = 0),
        (this.MaxNarrowPhaseTime = 0),
        (this.MaxSolvingTime = 0),
        (this.MaxTotalTime = 0),
        (this.MaxUpdateTime = 0);
    },
    calcBroadPhase: function () {
      this.setTime(2), (this.broadPhaseTime = this.times[2] - this.times[1]);
    },
    calcNarrowPhase: function () {
      this.setTime(3), (this.narrowPhaseTime = this.times[3] - this.times[2]);
    },
    calcEnd: function () {
      this.setTime(2),
        (this.solvingTime = this.times[2] - this.times[1]),
        (this.totalTime = this.times[2] - this.times[0]),
        (this.updateTime =
          this.totalTime -
          (this.broadPhaseTime + this.narrowPhaseTime + this.solvingTime)),
        100 === this.tt && this.resetMax(),
        this.tt > 100 &&
          (this.broadPhaseTime > this.MaxBroadPhaseTime &&
            (this.MaxBroadPhaseTime = this.broadPhaseTime),
          this.narrowPhaseTime > this.MaxNarrowPhaseTime &&
            (this.MaxNarrowPhaseTime = this.narrowPhaseTime),
          this.solvingTime > this.MaxSolvingTime &&
            (this.MaxSolvingTime = this.solvingTime),
          this.totalTime > this.MaxTotalTime &&
            (this.MaxTotalTime = this.totalTime),
          this.updateTime > this.MaxUpdateTime &&
            (this.MaxUpdateTime = this.updateTime)),
        this.upfps(),
        this.tt++,
        this.tt > 500 && (this.tt = 0);
    },
    upfps: function () {
      (this.f[1] = Date.now()),
        this.f[1] - 1e3 > this.f[0] &&
          ((this.f[0] = this.f[1]), (this.fps = this.f[2]), (this.f[2] = 0)),
        this.f[2]++;
    },
    show: function () {
      return [
        "Oimo.js " + this.version + "<br>",
        this.broadPhase + "<br><br>",
        "FPS: " + this.fps + " fps<br><br>",
        "rigidbody " + this.parent.numRigidBodies + "<br>",
        "contact &nbsp;&nbsp;" + this.parent.numContacts + "<br>",
        "ct-point &nbsp;" + this.parent.numContactPoints + "<br>",
        "paircheck " + this.parent.broadPhase.numPairChecks + "<br>",
        "island &nbsp;&nbsp;&nbsp;" + this.parent.numIslands + "<br><br>",
        "Time in milliseconds<br><br>",
        "broadphase &nbsp;" +
          m.fix(this.broadPhaseTime) +
          " | " +
          m.fix(this.MaxBroadPhaseTime) +
          "<br>",
        "narrowphase " +
          m.fix(this.narrowPhaseTime) +
          " | " +
          m.fix(this.MaxNarrowPhaseTime) +
          "<br>",
        "solving &nbsp;&nbsp;&nbsp;&nbsp;" +
          m.fix(this.solvingTime) +
          " | " +
          m.fix(this.MaxSolvingTime) +
          "<br>",
        "total &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" +
          m.fix(this.totalTime) +
          " | " +
          m.fix(this.MaxTotalTime) +
          "<br>",
        "updating &nbsp;&nbsp;&nbsp;" +
          m.fix(this.updateTime) +
          " | " +
          m.fix(this.MaxUpdateTime) +
          "<br>",
      ].join("\n");
    },
    toArray: function () {
      return (
        (this.infos[0] = this.parent.broadPhase.types),
        (this.infos[1] = this.parent.numRigidBodies),
        (this.infos[2] = this.parent.numContacts),
        (this.infos[3] = this.parent.broadPhase.numPairChecks),
        (this.infos[4] = this.parent.numContactPoints),
        (this.infos[5] = this.parent.numIslands),
        (this.infos[6] = this.broadPhaseTime),
        (this.infos[7] = this.narrowPhaseTime),
        (this.infos[8] = this.solvingTime),
        (this.infos[9] = this.updateTime),
        (this.infos[10] = this.totalTime),
        (this.infos[11] = this.fps),
        this.infos
      );
    },
  }),
    Object.assign(Vec3.prototype, {
      Vec3: !0,
      set: function (t, e, a) {
        return (this.x = t), (this.y = e), (this.z = a), this;
      },
      add: function (t, e) {
        return void 0 !== e
          ? this.addVectors(t, e)
          : ((this.x += t.x), (this.y += t.y), (this.z += t.z), this);
      },
      addVectors: function (t, e) {
        return (
          (this.x = t.x + e.x), (this.y = t.y + e.y), (this.z = t.z + e.z), this
        );
      },
      addEqual: function (t) {
        return (this.x += t.x), (this.y += t.y), (this.z += t.z), this;
      },
      sub: function (t, e) {
        return void 0 !== e
          ? this.subVectors(t, e)
          : ((this.x -= t.x), (this.y -= t.y), (this.z -= t.z), this);
      },
      subVectors: function (t, e) {
        return (
          (this.x = t.x - e.x), (this.y = t.y - e.y), (this.z = t.z - e.z), this
        );
      },
      subEqual: function (t) {
        return (this.x -= t.x), (this.y -= t.y), (this.z -= t.z), this;
      },
      scale: function (t, e) {
        return (this.x = t.x * e), (this.y = t.y * e), (this.z = t.z * e), this;
      },
      scaleEqual: function (t) {
        return (this.x *= t), (this.y *= t), (this.z *= t), this;
      },
      multiply: function (t) {
        return (this.x *= t.x), (this.y *= t.y), (this.z *= t.z), this;
      },
      addScaledVector: function (t, e) {
        return (
          (this.x += t.x * e), (this.y += t.y * e), (this.z += t.z * e), this
        );
      },
      subScaledVector: function (t, e) {
        return (
          (this.x -= t.x * e), (this.y -= t.y * e), (this.z -= t.z * e), this
        );
      },
      cross: function (t, e) {
        if (void 0 !== e) return this.crossVectors(t, e);
        var a = this.x,
          n = this.y,
          u = this.z;
        return (
          (this.x = n * t.z - u * t.y),
          (this.y = u * t.x - a * t.z),
          (this.z = a * t.y - n * t.x),
          this
        );
      },
      crossVectors: function (t, e) {
        var a = t.x,
          n = t.y,
          u = t.z,
          m = e.x,
          f = e.y,
          p = e.z;
        return (
          (this.x = n * p - u * f),
          (this.y = u * m - a * p),
          (this.z = a * f - n * m),
          this
        );
      },
      tangent: function (t) {
        var e = t.x,
          a = t.y,
          n = t.z;
        return (
          (this.x = a * e - n * n),
          (this.y = -n * a - e * e),
          (this.z = e * n + a * a),
          this
        );
      },
      invert: function (t) {
        return (this.x = -t.x), (this.y = -t.y), (this.z = -t.z), this;
      },
      negate: function () {
        return (this.x = -this.x), (this.y = -this.y), (this.z = -this.z), this;
      },
      dot: function (t) {
        return this.x * t.x + this.y * t.y + this.z * t.z;
      },
      addition: function () {
        return this.x + this.y + this.z;
      },
      lengthSq: function () {
        return this.x * this.x + this.y * this.y + this.z * this.z;
      },
      length: function () {
        return m.sqrt(this.x * this.x + this.y * this.y + this.z * this.z);
      },
      copy: function (t) {
        return (this.x = t.x), (this.y = t.y), (this.z = t.z), this;
      },
      applyMatrix3: function (t, e) {
        var a = this.x,
          n = this.y,
          u = this.z,
          m = t.elements;
        return (
          e
            ? ((this.x = m[0] * a + m[1] * n + m[2] * u),
              (this.y = m[3] * a + m[4] * n + m[5] * u),
              (this.z = m[6] * a + m[7] * n + m[8] * u))
            : ((this.x = m[0] * a + m[3] * n + m[6] * u),
              (this.y = m[1] * a + m[4] * n + m[7] * u),
              (this.z = m[2] * a + m[5] * n + m[8] * u)),
          this
        );
      },
      applyQuaternion: function (t) {
        var e = this.x,
          a = this.y,
          n = this.z,
          u = t.x,
          m = t.y,
          f = t.z,
          p = t.w,
          y = p * e + m * n - f * a,
          g = p * a + f * e - u * n,
          _ = p * n + u * a - m * e,
          x = -u * e - m * a - f * n;
        return (
          (this.x = y * p + x * -u + g * -f - _ * -m),
          (this.y = g * p + x * -m + _ * -u - y * -f),
          (this.z = _ * p + x * -f + y * -m - g * -u),
          this
        );
      },
      testZero: function () {
        return 0 !== this.x || 0 !== this.y || 0 !== this.z;
      },
      testDiff: function (t) {
        return !this.equals(t);
      },
      equals: function (t) {
        return t.x === this.x && t.y === this.y && t.z === this.z;
      },
      clone: function () {
        return new this.constructor(this.x, this.y, this.z);
      },
      toString: function () {
        return (
          "Vec3[" +
          this.x.toFixed(4) +
          ", " +
          this.y.toFixed(4) +
          ", " +
          this.z.toFixed(4) +
          "]"
        );
      },
      multiplyScalar: function (t) {
        return (
          Number.isFinite(t)
            ? ((this.x *= t), (this.y *= t), (this.z *= t))
            : ((this.x = 0), (this.y = 0), (this.z = 0)),
          this
        );
      },
      divideScalar: function (t) {
        return this.multiplyScalar(1 / t);
      },
      normalize: function (t) {
        return isNaN(t)
          ? this.divideScalar(this.length())
          : this.multiplyScalar(t / this.length());
      },
      toArray: function (t, e) {
        void 0 === e && (e = 0),
          (t[e] = this.x),
          (t[e + 1] = this.y),
          (t[e + 2] = this.z);
      },
      fromArray: function (t, e) {
        return (
          void 0 === e && (e = 0),
          (this.x = t[e]),
          (this.y = t[e + 1]),
          (this.z = t[e + 2]),
          this
        );
      },
      lerp: function (t, e) {
        var a = this.x,
          n = this.y,
          u = this.z;
        return (
          (this.x = a + e * (t.x - a)),
          (this.y = n + e * (t.y - n)),
          (this.z = u + e * (t.z - u)),
          this
        );
      },
      distanceTo: function (t) {
        var e = this.x,
          a = this.y,
          n = this.z,
          u = t.x,
          m = t.y,
          f = t.z;
        return Math.sqrt(
          (u - e) * (u - e) + (m - a) * (m - a) + (f - n) * (f - n)
        );
      },
    }),
    Object.assign(Quat.prototype, {
      Quat: !0,
      set: function (t, e, a, n) {
        return (this.x = t), (this.y = e), (this.z = a), (this.w = n), this;
      },
      addTime: function (t, e) {
        var a = t.x,
          n = t.y,
          u = t.z,
          m = this.w,
          f = this.x,
          p = this.y,
          y = this.z;
        return (
          (e *= 0.5),
          (this.x += e * (a * m + n * y - u * p)),
          (this.y += e * (n * m + u * f - a * y)),
          (this.z += e * (u * m + a * p - n * f)),
          (this.w += e * (-a * f - n * p - u * y)),
          this.normalize(),
          this
        );
      },
      multiply: function (t, e) {
        return void 0 !== e
          ? this.multiplyQuaternions(t, e)
          : this.multiplyQuaternions(this, t);
      },
      multiplyQuaternions: function (t, e) {
        var a = t.x,
          n = t.y,
          u = t.z,
          m = t.w,
          f = e.x,
          p = e.y,
          y = e.z,
          g = e.w;
        return (
          (this.x = a * g + m * f + n * y - u * p),
          (this.y = n * g + m * p + u * f - a * y),
          (this.z = u * g + m * y + a * p - n * f),
          (this.w = m * g - a * f - n * p - u * y),
          this
        );
      },
      setFromUnitVectors: function (t, e) {
        var a = new Vec3(),
          n = t.dot(e) + 1;
        return (
          n < m.EPS2
            ? ((n = 0),
              m.abs(t.x) > m.abs(t.z)
                ? a.set(-t.y, t.x, 0)
                : a.set(0, -t.z, t.y))
            : a.crossVectors(t, e),
          (this._x = a.x),
          (this._y = a.y),
          (this._z = a.z),
          (this._w = n),
          this.normalize()
        );
      },
      arc: function (t, e) {
        var a = t.x,
          n = t.y,
          u = t.z,
          f = e.x,
          p = e.y,
          y = e.z,
          g = a * f + n * p + u * y;
        if (-1 == g)
          return (
            (f = n * a - u * u),
            (p = -u * n - a * a),
            (y = a * u + n * n),
            (g = 1 / m.sqrt(f * f + p * p + y * y)),
            (this.w = 0),
            (this.x = f * g),
            (this.y = p * g),
            (this.z = y * g),
            this
          );
        var _ = n * y - u * p,
          x = u * f - a * y,
          b = a * p - n * f;
        return (
          (this.w = m.sqrt(0.5 * (1 + g))),
          (g = 0.5 / this.w),
          (this.x = _ * g),
          (this.y = x * g),
          (this.z = b * g),
          this
        );
      },
      normalize: function () {
        var t = this.length();
        return (
          0 === t
            ? this.set(0, 0, 0, 1)
            : ((t = 1 / t),
              (this.x = this.x * t),
              (this.y = this.y * t),
              (this.z = this.z * t),
              (this.w = this.w * t)),
          this
        );
      },
      inverse: function () {
        return this.conjugate().normalize();
      },
      invert: function (t) {
        return (
          (this.x = t.x),
          (this.y = t.y),
          (this.z = t.z),
          (this.w = t.w),
          this.conjugate().normalize(),
          this
        );
      },
      conjugate: function () {
        return (this.x *= -1), (this.y *= -1), (this.z *= -1), this;
      },
      length: function () {
        return m.sqrt(
          this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w
        );
      },
      lengthSq: function () {
        return (
          this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w
        );
      },
      copy: function (t) {
        return (
          (this.x = t.x), (this.y = t.y), (this.z = t.z), (this.w = t.w), this
        );
      },
      clone: function (t) {
        return new Quat(this.x, this.y, this.z, this.w);
      },
      testDiff: function (t) {
        return !this.equals(t);
      },
      equals: function (t) {
        return (
          this.x === t.x && this.y === t.y && this.z === t.z && this.w === t.w
        );
      },
      toString: function () {
        return (
          "Quat[" +
          this.x.toFixed(4) +
          ", (" +
          this.y.toFixed(4) +
          ", " +
          this.z.toFixed(4) +
          ", " +
          this.w.toFixed(4) +
          ")]"
        );
      },
      setFromAxis: function (t, e) {
        t.normalize(), (e *= 0.5);
        var a = m.sin(e);
        return (
          (this.x = a * t.x),
          (this.y = a * t.y),
          (this.z = a * t.z),
          (this.w = m.cos(e)),
          this
        );
      },
      setFromMat33: function (t) {
        var e,
          a = (t = t.elements)[0] + t[4] + t[8];
        if (a > 0)
          (e = m.sqrt(a + 1)),
            (this.w = 0.5 / e),
            (e = 0.5 / e),
            (this.x = (t[5] - t[7]) * e),
            (this.y = (t[6] - t[2]) * e),
            (this.z = (t[1] - t[3]) * e);
        else {
          var n = [],
            u = 0;
          t[4] > t[0] && (u = 1), t[8] > t[3 * u + u] && (u = 2);
          var f = (u + 1) % 3,
            p = (u + 2) % 3;
          (e = m.sqrt(t[3 * u + u] - t[3 * f + f] - t[3 * p + p] + 1)),
            (n[u] = 0.5 * fRoot),
            (e = 0.5 / fRoot),
            (this.w = (t[3 * f + p] - t[3 * p + f]) * e),
            (n[f] = (t[3 * f + u] + t[3 * u + f]) * e),
            (n[p] = (t[3 * p + u] + t[3 * u + p]) * e),
            (this.x = n[1]),
            (this.y = n[2]),
            (this.z = n[3]);
        }
        return this;
      },
      toArray: function (t, e) {
        (t[(e = e || 0)] = this.x),
          (t[e + 1] = this.y),
          (t[e + 2] = this.z),
          (t[e + 3] = this.w);
      },
      fromArray: function (t, e) {
        return (e = e || 0), this.set(t[e], t[e + 1], t[e + 2], t[e + 3]), this;
      },
      toAxisAngle: function (t) {
        var e = m.clamp(this.w, 0, 0.9999),
          a = 2 * m.acos(e);
        return (
          (t.x = this.x / m.sqrt(1 - e * e)),
          (t.y = this.y / m.sqrt(1 - e * e)),
          (t.z = this.z / m.sqrt(1 - e * e)),
          a
        );
      },
    }),
    Object.assign(Mat33.prototype, {
      Mat33: !0,
      set: function (t, e, a, n, u, m, f, p, y) {
        var g = this.elements;
        return (
          (g[0] = t),
          (g[1] = e),
          (g[2] = a),
          (g[3] = n),
          (g[4] = u),
          (g[5] = m),
          (g[6] = f),
          (g[7] = p),
          (g[8] = y),
          this
        );
      },
      add: function (t, e) {
        if (void 0 !== e) return this.addMatrixs(t, e);
        var a = this.elements,
          n = t.elements;
        return (
          (a[0] += n[0]),
          (a[1] += n[1]),
          (a[2] += n[2]),
          (a[3] += n[3]),
          (a[4] += n[4]),
          (a[5] += n[5]),
          (a[6] += n[6]),
          (a[7] += n[7]),
          (a[8] += n[8]),
          this
        );
      },
      addMatrixs: function (t, e) {
        var a = this.elements,
          n = t.elements,
          u = e.elements;
        return (
          (a[0] = n[0] + u[0]),
          (a[1] = n[1] + u[1]),
          (a[2] = n[2] + u[2]),
          (a[3] = n[3] + u[3]),
          (a[4] = n[4] + u[4]),
          (a[5] = n[5] + u[5]),
          (a[6] = n[6] + u[6]),
          (a[7] = n[7] + u[7]),
          (a[8] = n[8] + u[8]),
          this
        );
      },
      addEqual: function (t) {
        var e = this.elements,
          a = t.elements;
        return (
          (e[0] += a[0]),
          (e[1] += a[1]),
          (e[2] += a[2]),
          (e[3] += a[3]),
          (e[4] += a[4]),
          (e[5] += a[5]),
          (e[6] += a[6]),
          (e[7] += a[7]),
          (e[8] += a[8]),
          this
        );
      },
      sub: function (t, e) {
        if (void 0 !== e) return this.subMatrixs(t, e);
        var a = this.elements,
          n = t.elements;
        return (
          (a[0] -= n[0]),
          (a[1] -= n[1]),
          (a[2] -= n[2]),
          (a[3] -= n[3]),
          (a[4] -= n[4]),
          (a[5] -= n[5]),
          (a[6] -= n[6]),
          (a[7] -= n[7]),
          (a[8] -= n[8]),
          this
        );
      },
      subMatrixs: function (t, e) {
        var a = this.elements,
          n = t.elements,
          u = e.elements;
        return (
          (a[0] = n[0] - u[0]),
          (a[1] = n[1] - u[1]),
          (a[2] = n[2] - u[2]),
          (a[3] = n[3] - u[3]),
          (a[4] = n[4] - u[4]),
          (a[5] = n[5] - u[5]),
          (a[6] = n[6] - u[6]),
          (a[7] = n[7] - u[7]),
          (a[8] = n[8] - u[8]),
          this
        );
      },
      subEqual: function (t) {
        var e = this.elements,
          a = t.elements;
        return (
          (e[0] -= a[0]),
          (e[1] -= a[1]),
          (e[2] -= a[2]),
          (e[3] -= a[3]),
          (e[4] -= a[4]),
          (e[5] -= a[5]),
          (e[6] -= a[6]),
          (e[7] -= a[7]),
          (e[8] -= a[8]),
          this
        );
      },
      scale: function (t, e) {
        var a = this.elements,
          n = t.elements;
        return (
          (a[0] = n[0] * e),
          (a[1] = n[1] * e),
          (a[2] = n[2] * e),
          (a[3] = n[3] * e),
          (a[4] = n[4] * e),
          (a[5] = n[5] * e),
          (a[6] = n[6] * e),
          (a[7] = n[7] * e),
          (a[8] = n[8] * e),
          this
        );
      },
      scaleEqual: function (t) {
        var e = this.elements;
        return (
          (e[0] *= t),
          (e[1] *= t),
          (e[2] *= t),
          (e[3] *= t),
          (e[4] *= t),
          (e[5] *= t),
          (e[6] *= t),
          (e[7] *= t),
          (e[8] *= t),
          this
        );
      },
      multiplyMatrices: function (t, e, a) {
        a && (e = e.clone().transpose());
        var n = this.elements,
          u = t.elements,
          m = e.elements,
          f = u[0],
          p = u[3],
          y = u[6],
          g = u[1],
          _ = u[4],
          x = u[7],
          b = u[2],
          v = u[5],
          w = u[8],
          S = m[0],
          C = m[3],
          E = m[6],
          z = m[1],
          A = m[4],
          k = m[7],
          B = m[2],
          V = m[5],
          R = m[8];
        return (
          (n[0] = f * S + g * C + b * E),
          (n[1] = f * z + g * A + b * k),
          (n[2] = f * B + g * V + b * R),
          (n[3] = p * S + _ * C + v * E),
          (n[4] = p * z + _ * A + v * k),
          (n[5] = p * B + _ * V + v * R),
          (n[6] = y * S + x * C + w * E),
          (n[7] = y * z + x * A + w * k),
          (n[8] = y * B + x * V + w * R),
          this
        );
      },
      transpose: function (t) {
        if (void 0 !== t) {
          var e = t.elements;
          return (
            this.set(e[0], e[3], e[6], e[1], e[4], e[7], e[2], e[5], e[8]), this
          );
        }
        var a = this.elements,
          n = a[1],
          u = a[2],
          m = a[5];
        return (
          (a[1] = a[3]),
          (a[2] = a[6]),
          (a[3] = n),
          (a[5] = a[7]),
          (a[6] = u),
          (a[7] = m),
          this
        );
      },
      setQuat: function (t) {
        var e = this.elements,
          a = t.x,
          n = t.y,
          u = t.z,
          m = t.w,
          f = a + a,
          p = n + n,
          y = u + u,
          g = a * f,
          _ = a * p,
          x = a * y,
          b = n * p,
          v = n * y,
          w = u * y,
          S = m * f,
          C = m * p,
          E = m * y;
        return (
          (e[0] = 1 - (b + w)),
          (e[1] = _ - E),
          (e[2] = x + C),
          (e[3] = _ + E),
          (e[4] = 1 - (g + w)),
          (e[5] = v - S),
          (e[6] = x - C),
          (e[7] = v + S),
          (e[8] = 1 - (g + b)),
          this
        );
      },
      invert: function (t) {
        var e = this.elements,
          a = t.elements,
          n = a[0],
          u = a[3],
          m = a[6],
          f = a[1],
          p = a[4],
          y = a[7],
          g = a[2],
          _ = a[5],
          x = a[8],
          b = x * p - _ * y,
          v = -x * u + _ * m,
          w = y * u - p * m,
          S = n * b + f * v + g * w;
        return 0 === S
          ? (console.log("can't invert matrix, determinant is 0"),
            this.identity())
          : ((S = 1 / S),
            (e[0] = b * S),
            (e[1] = (-x * f + g * y) * S),
            (e[2] = (_ * f - g * p) * S),
            (e[3] = v * S),
            (e[4] = (x * n - g * m) * S),
            (e[5] = (-_ * n + g * u) * S),
            (e[6] = w * S),
            (e[7] = (-y * n + f * m) * S),
            (e[8] = (p * n - f * u) * S),
            this);
      },
      addOffset: function (t, e) {
        var a = e.x,
          n = e.y,
          u = e.z,
          m = this.elements;
        (m[0] += t * (n * n + u * u)),
          (m[4] += t * (a * a + u * u)),
          (m[8] += t * (a * a + n * n));
        var f = t * a * n,
          p = t * n * u,
          y = t * u * a;
        return (
          (m[1] -= f),
          (m[3] -= f),
          (m[2] -= p),
          (m[6] -= p),
          (m[5] -= y),
          (m[7] -= y),
          this
        );
      },
      subOffset: function (t, e) {
        var a = e.x,
          n = e.y,
          u = e.z,
          m = this.elements;
        (m[0] -= t * (n * n + u * u)),
          (m[4] -= t * (a * a + u * u)),
          (m[8] -= t * (a * a + n * n));
        var f = t * a * n,
          p = t * n * u,
          y = t * u * a;
        return (
          (m[1] += f),
          (m[3] += f),
          (m[2] += p),
          (m[6] += p),
          (m[5] += y),
          (m[7] += y),
          this
        );
      },
      multiplyScalar: function (t) {
        var e = this.elements;
        return (
          (e[0] *= t),
          (e[3] *= t),
          (e[6] *= t),
          (e[1] *= t),
          (e[4] *= t),
          (e[7] *= t),
          (e[2] *= t),
          (e[5] *= t),
          (e[8] *= t),
          this
        );
      },
      identity: function () {
        return this.set(1, 0, 0, 0, 1, 0, 0, 0, 1), this;
      },
      clone: function () {
        return new Mat33().fromArray(this.elements);
      },
      copy: function (t) {
        for (var e = 0; e < 9; e++) this.elements[e] = t.elements[e];
        return this;
      },
      determinant: function () {
        var t = this.elements,
          e = t[0],
          a = t[1],
          n = t[2],
          u = t[3],
          m = t[4],
          f = t[5],
          p = t[6],
          y = t[7],
          g = t[8];
        return (
          e * m * g - e * f * y - a * u * g + a * f * p + n * u * y - n * m * p
        );
      },
      fromArray: function (t, e) {
        void 0 === e && (e = 0);
        for (var a = 0; a < 9; a++) this.elements[a] = t[a + e];
        return this;
      },
      toArray: function (t, e) {
        void 0 === t && (t = []), void 0 === e && (e = 0);
        var a = this.elements;
        return (
          (t[e] = a[0]),
          (t[e + 1] = a[1]),
          (t[e + 2] = a[2]),
          (t[e + 3] = a[3]),
          (t[e + 4] = a[4]),
          (t[e + 5] = a[5]),
          (t[e + 6] = a[6]),
          (t[e + 7] = a[7]),
          (t[e + 8] = a[8]),
          t
        );
      },
    }),
    Object.assign(AABB.prototype, {
      AABB: !0,
      set: function (t, e, a, n, u, m) {
        var f = this.elements;
        return (
          (f[0] = t),
          (f[3] = e),
          (f[1] = a),
          (f[4] = n),
          (f[2] = u),
          (f[5] = m),
          this
        );
      },
      intersectTest: function (t) {
        var e = this.elements,
          a = t.elements;
        return (
          e[0] > a[3] ||
          e[1] > a[4] ||
          e[2] > a[5] ||
          e[3] < a[0] ||
          e[4] < a[1] ||
          e[5] < a[2]
        );
      },
      intersectTestTwo: function (t) {
        var e = this.elements,
          a = t.elements;
        return (
          e[0] < a[0] ||
          e[1] < a[1] ||
          e[2] < a[2] ||
          e[3] > a[3] ||
          e[4] > a[4] ||
          e[5] > a[5]
        );
      },
      clone: function () {
        return new this.constructor().fromArray(this.elements);
      },
      copy: function (t, e) {
        var a = e || 0,
          n = t.elements;
        return (
          this.set(n[0] - a, n[3] + a, n[1] - a, n[4] + a, n[2] - a, n[5] + a),
          this
        );
      },
      fromArray: function (t) {
        return this.elements.set(t), this;
      },
      combine: function (t, e) {
        var a = t.elements,
          n = e.elements,
          u = this.elements;
        return (
          (u[0] = a[0] < n[0] ? a[0] : n[0]),
          (u[1] = a[1] < n[1] ? a[1] : n[1]),
          (u[2] = a[2] < n[2] ? a[2] : n[2]),
          (u[3] = a[3] > n[3] ? a[3] : n[3]),
          (u[4] = a[4] > n[4] ? a[4] : n[4]),
          (u[5] = a[5] > n[5] ? a[5] : n[5]),
          this
        );
      },
      surfaceArea: function () {
        var t = this.elements,
          e = t[3] - t[0],
          a = t[4] - t[1],
          n = t[5] - t[2];
        return 2 * (e * (a + n) + a * n);
      },
      intersectsWithPoint: function (t, e, a) {
        var n = this.elements;
        return (
          t >= n[0] &&
          t <= n[3] &&
          e >= n[1] &&
          e <= n[4] &&
          a >= n[2] &&
          a <= n[5]
        );
      },
      setFromPoints: function (t) {
        this.makeEmpty();
        for (var e = 0; e < t.length; e++) this.expandByPoint(t[e]);
      },
      makeEmpty: function () {
        this.set(-1 / 0, -1 / 0, -1 / 0, 1 / 0, 1 / 0, 1 / 0);
      },
      expandByPoint: function (t) {
        var e = this.elements;
        this.set(
          m.min(e[0], t.x),
          m.min(e[1], t.y),
          m.min(e[2], t.z),
          m.max(e[3], t.x),
          m.max(e[4], t.y),
          m.max(e[5], t.z)
        );
      },
      expandByScalar: function (t) {
        var e = this.elements;
        (e[0] += -t),
          (e[1] += -t),
          (e[2] += -t),
          (e[3] += t),
          (e[4] += t),
          (e[5] += t);
      },
      getCenter: function () {
        var t = this.elements,
          e = t[3] - t[0],
          a = t[4] - t[1],
          n = t[5] - t[2];
        return new Vec3(t[0] + 0.5 * e, t[1] + 0.5 * a, t[2] + 0.5 * n);
      },
    });
  var f = 0;
  function ShapeIdCount() {
    return f++;
  }
  function Shape(t) {
    (this.type = 0),
      (this.id = ShapeIdCount()),
      (this.prev = null),
      (this.next = null),
      (this.proxy = null),
      (this.parent = null),
      (this.contactLink = null),
      (this.numContacts = 0),
      (this.position = new Vec3()),
      (this.rotation = new Mat33()),
      (this.relativePosition = new Vec3().copy(t.relativePosition)),
      (this.relativeRotation = new Mat33().copy(t.relativeRotation)),
      (this.aabb = new AABB()),
      (this.lastAABB = new AABB()),
      (this.tempAABB = new AABB()),
      (this.density = t.density),
      (this.friction = t.friction),
      (this.restitution = t.restitution),
      (this.belongsTo = t.belongsTo),
      (this.collidesWith = t.collidesWith),
      (this.localRotation = t.localRotation),
      (this.mass = null);
  }
  function Box(t, e, a, n) {
    Shape.call(this, t),
      (this.type = 2),
      (this.width = e),
      (this.height = a),
      (this.depth = n),
      (this.halfWidth = 0.5 * e),
      (this.halfHeight = 0.5 * a),
      (this.halfDepth = 0.5 * n),
      (this.dimentions = new Float32Array(18)),
      (this.elements = new Float32Array(24));
  }
  function Sphere(t, e) {
    Shape.call(this, t), (this.type = 1), (this.radius = e);
  }
  function Cylinder(t, e, a) {
    Shape.call(this, t),
      (this.type = 3),
      (this.radius = e),
      (this.height = a),
      (this.halfHeight = 0.5 * a),
      (this.normalDirection = new Vec3()),
      (this.halfDirection = new Vec3());
  }
  function Plane(t, e) {
    Shape.call(this, t), (this.type = 4), (this.normal = new Vec3(0, 1, 0));
  }
  function Particle(t, e) {
    Shape.call(this, t), (this.type = 5);
  }
  function ShapeConfig() {
    (this.relativePosition = new Vec3()),
      (this.relativeRotation = new Mat33()),
      (this.friction = 0.2),
      (this.restitution = 0.2),
      (this.density = 1),
      (this.belongsTo = 1),
      (this.collidesWith = 4294967295);
  }
  function LimitMotor(t, e) {
    (e = e || !1),
      (this.axis = t),
      (this.angle = 0),
      (this.lowerLimit = e ? 0 : 1),
      (this.upperLimit = 0),
      (this.motorSpeed = 0),
      (this.maxMotorForce = 0),
      (this.frequency = 0),
      (this.dampingRatio = 0);
  }
  function Constraint() {
    (this.parent = null),
      (this.body1 = null),
      (this.body2 = null),
      (this.addedToIsland = !1);
  }
  function JointLink(t) {
    (this.prev = null),
      (this.next = null),
      (this.body = null),
      (this.joint = t);
  }
  function Joint(t) {
    Constraint.call(this),
      (this.scale = 1),
      (this.invScale = 1),
      (this.name = ""),
      (this.id = NaN),
      (this.type = 0),
      (this.prev = null),
      (this.next = null),
      (this.body1 = t.body1),
      (this.body2 = t.body2),
      (this.localAnchorPoint1 = new Vec3().copy(t.localAnchorPoint1)),
      (this.localAnchorPoint2 = new Vec3().copy(t.localAnchorPoint2)),
      (this.relativeAnchorPoint1 = new Vec3()),
      (this.relativeAnchorPoint2 = new Vec3()),
      (this.anchorPoint1 = new Vec3()),
      (this.anchorPoint2 = new Vec3()),
      (this.allowCollision = t.allowCollision),
      (this.b1Link = new JointLink(this)),
      (this.b2Link = new JointLink(this));
  }
  function LinearConstraint(t) {
    (this.m1 = NaN),
      (this.m2 = NaN),
      (this.ii1 = null),
      (this.ii2 = null),
      (this.dd = null),
      (this.r1x = NaN),
      (this.r1y = NaN),
      (this.r1z = NaN),
      (this.r2x = NaN),
      (this.r2y = NaN),
      (this.r2z = NaN),
      (this.ax1x = NaN),
      (this.ax1y = NaN),
      (this.ax1z = NaN),
      (this.ay1x = NaN),
      (this.ay1y = NaN),
      (this.ay1z = NaN),
      (this.az1x = NaN),
      (this.az1y = NaN),
      (this.az1z = NaN),
      (this.ax2x = NaN),
      (this.ax2y = NaN),
      (this.ax2z = NaN),
      (this.ay2x = NaN),
      (this.ay2y = NaN),
      (this.ay2z = NaN),
      (this.az2x = NaN),
      (this.az2y = NaN),
      (this.az2z = NaN),
      (this.vel = NaN),
      (this.velx = NaN),
      (this.vely = NaN),
      (this.velz = NaN),
      (this.joint = t),
      (this.r1 = t.relativeAnchorPoint1),
      (this.r2 = t.relativeAnchorPoint2),
      (this.p1 = t.anchorPoint1),
      (this.p2 = t.anchorPoint2),
      (this.b1 = t.body1),
      (this.b2 = t.body2),
      (this.l1 = this.b1.linearVelocity),
      (this.l2 = this.b2.linearVelocity),
      (this.a1 = this.b1.angularVelocity),
      (this.a2 = this.b2.angularVelocity),
      (this.i1 = this.b1.inverseInertia),
      (this.i2 = this.b2.inverseInertia),
      (this.impx = 0),
      (this.impy = 0),
      (this.impz = 0);
  }
  function Rotational3Constraint(t, e, a, n) {
    (this.cfm1 = NaN),
      (this.cfm2 = NaN),
      (this.cfm3 = NaN),
      (this.i1e00 = NaN),
      (this.i1e01 = NaN),
      (this.i1e02 = NaN),
      (this.i1e10 = NaN),
      (this.i1e11 = NaN),
      (this.i1e12 = NaN),
      (this.i1e20 = NaN),
      (this.i1e21 = NaN),
      (this.i1e22 = NaN),
      (this.i2e00 = NaN),
      (this.i2e01 = NaN),
      (this.i2e02 = NaN),
      (this.i2e10 = NaN),
      (this.i2e11 = NaN),
      (this.i2e12 = NaN),
      (this.i2e20 = NaN),
      (this.i2e21 = NaN),
      (this.i2e22 = NaN),
      (this.ax1 = NaN),
      (this.ay1 = NaN),
      (this.az1 = NaN),
      (this.ax2 = NaN),
      (this.ay2 = NaN),
      (this.az2 = NaN),
      (this.ax3 = NaN),
      (this.ay3 = NaN),
      (this.az3 = NaN),
      (this.a1x1 = NaN),
      (this.a1y1 = NaN),
      (this.a1z1 = NaN),
      (this.a2x1 = NaN),
      (this.a2y1 = NaN),
      (this.a2z1 = NaN),
      (this.a1x2 = NaN),
      (this.a1y2 = NaN),
      (this.a1z2 = NaN),
      (this.a2x2 = NaN),
      (this.a2y2 = NaN),
      (this.a2z2 = NaN),
      (this.a1x3 = NaN),
      (this.a1y3 = NaN),
      (this.a1z3 = NaN),
      (this.a2x3 = NaN),
      (this.a2y3 = NaN),
      (this.a2z3 = NaN),
      (this.lowerLimit1 = NaN),
      (this.upperLimit1 = NaN),
      (this.limitVelocity1 = NaN),
      (this.limitState1 = 0),
      (this.enableMotor1 = !1),
      (this.motorSpeed1 = NaN),
      (this.maxMotorForce1 = NaN),
      (this.maxMotorImpulse1 = NaN),
      (this.lowerLimit2 = NaN),
      (this.upperLimit2 = NaN),
      (this.limitVelocity2 = NaN),
      (this.limitState2 = 0),
      (this.enableMotor2 = !1),
      (this.motorSpeed2 = NaN),
      (this.maxMotorForce2 = NaN),
      (this.maxMotorImpulse2 = NaN),
      (this.lowerLimit3 = NaN),
      (this.upperLimit3 = NaN),
      (this.limitVelocity3 = NaN),
      (this.limitState3 = 0),
      (this.enableMotor3 = !1),
      (this.motorSpeed3 = NaN),
      (this.maxMotorForce3 = NaN),
      (this.maxMotorImpulse3 = NaN),
      (this.k00 = NaN),
      (this.k01 = NaN),
      (this.k02 = NaN),
      (this.k10 = NaN),
      (this.k11 = NaN),
      (this.k12 = NaN),
      (this.k20 = NaN),
      (this.k21 = NaN),
      (this.k22 = NaN),
      (this.kv00 = NaN),
      (this.kv11 = NaN),
      (this.kv22 = NaN),
      (this.dv00 = NaN),
      (this.dv11 = NaN),
      (this.dv22 = NaN),
      (this.d00 = NaN),
      (this.d01 = NaN),
      (this.d02 = NaN),
      (this.d10 = NaN),
      (this.d11 = NaN),
      (this.d12 = NaN),
      (this.d20 = NaN),
      (this.d21 = NaN),
      (this.d22 = NaN),
      (this.limitMotor1 = e),
      (this.limitMotor2 = a),
      (this.limitMotor3 = n),
      (this.b1 = t.body1),
      (this.b2 = t.body2),
      (this.a1 = this.b1.angularVelocity),
      (this.a2 = this.b2.angularVelocity),
      (this.i1 = this.b1.inverseInertia),
      (this.i2 = this.b2.inverseInertia),
      (this.limitImpulse1 = 0),
      (this.motorImpulse1 = 0),
      (this.limitImpulse2 = 0),
      (this.motorImpulse2 = 0),
      (this.limitImpulse3 = 0),
      (this.motorImpulse3 = 0);
  }
  function HingeJoint(t, e, a) {
    Joint.call(this, t),
      (this.type = 3),
      (this.localAxis1 = t.localAxis1.clone().normalize()),
      (this.localAxis2 = t.localAxis2.clone().normalize());
    var n = new Mat33().setQuat(
      new Quat().setFromUnitVectors(this.localAxis1, this.localAxis2)
    );
    (this.localAngle1 = new Vec3().tangent(this.localAxis1).normalize()),
      (this.localAngle2 = this.localAngle1.clone().applyMatrix3(n, !0)),
      (this.ax1 = new Vec3()),
      (this.ax2 = new Vec3()),
      (this.an1 = new Vec3()),
      (this.an2 = new Vec3()),
      (this.tmp = new Vec3()),
      (this.nor = new Vec3()),
      (this.tan = new Vec3()),
      (this.bin = new Vec3()),
      (this.limitMotor = new LimitMotor(this.nor, !1)),
      (this.limitMotor.lowerLimit = e),
      (this.limitMotor.upperLimit = a),
      (this.lc = new LinearConstraint(this)),
      (this.r3 = new Rotational3Constraint(
        this,
        this.limitMotor,
        new LimitMotor(this.tan, !0),
        new LimitMotor(this.bin, !0)
      ));
  }
  function BallAndSocketJoint(t) {
    Joint.call(this, t),
      (this.type = 2),
      (this.lc = new LinearConstraint(this));
  }
  function TranslationalConstraint(t, e) {
    (this.cfm = NaN),
      (this.m1 = NaN),
      (this.m2 = NaN),
      (this.i1e00 = NaN),
      (this.i1e01 = NaN),
      (this.i1e02 = NaN),
      (this.i1e10 = NaN),
      (this.i1e11 = NaN),
      (this.i1e12 = NaN),
      (this.i1e20 = NaN),
      (this.i1e21 = NaN),
      (this.i1e22 = NaN),
      (this.i2e00 = NaN),
      (this.i2e01 = NaN),
      (this.i2e02 = NaN),
      (this.i2e10 = NaN),
      (this.i2e11 = NaN),
      (this.i2e12 = NaN),
      (this.i2e20 = NaN),
      (this.i2e21 = NaN),
      (this.i2e22 = NaN),
      (this.motorDenom = NaN),
      (this.invMotorDenom = NaN),
      (this.invDenom = NaN),
      (this.ax = NaN),
      (this.ay = NaN),
      (this.az = NaN),
      (this.r1x = NaN),
      (this.r1y = NaN),
      (this.r1z = NaN),
      (this.r2x = NaN),
      (this.r2y = NaN),
      (this.r2z = NaN),
      (this.t1x = NaN),
      (this.t1y = NaN),
      (this.t1z = NaN),
      (this.t2x = NaN),
      (this.t2y = NaN),
      (this.t2z = NaN),
      (this.l1x = NaN),
      (this.l1y = NaN),
      (this.l1z = NaN),
      (this.l2x = NaN),
      (this.l2y = NaN),
      (this.l2z = NaN),
      (this.a1x = NaN),
      (this.a1y = NaN),
      (this.a1z = NaN),
      (this.a2x = NaN),
      (this.a2y = NaN),
      (this.a2z = NaN),
      (this.lowerLimit = NaN),
      (this.upperLimit = NaN),
      (this.limitVelocity = NaN),
      (this.limitState = 0),
      (this.enableMotor = !1),
      (this.motorSpeed = NaN),
      (this.maxMotorForce = NaN),
      (this.maxMotorImpulse = NaN),
      (this.limitMotor = e),
      (this.b1 = t.body1),
      (this.b2 = t.body2),
      (this.p1 = t.anchorPoint1),
      (this.p2 = t.anchorPoint2),
      (this.r1 = t.relativeAnchorPoint1),
      (this.r2 = t.relativeAnchorPoint2),
      (this.l1 = this.b1.linearVelocity),
      (this.l2 = this.b2.linearVelocity),
      (this.a1 = this.b1.angularVelocity),
      (this.a2 = this.b2.angularVelocity),
      (this.i1 = this.b1.inverseInertia),
      (this.i2 = this.b2.inverseInertia),
      (this.limitImpulse = 0),
      (this.motorImpulse = 0);
  }
  function DistanceJoint(t, e, a) {
    Joint.call(this, t),
      (this.type = 1),
      (this.nor = new Vec3()),
      (this.limitMotor = new LimitMotor(this.nor, !0)),
      (this.limitMotor.lowerLimit = e),
      (this.limitMotor.upperLimit = a),
      (this.t = new TranslationalConstraint(this, this.limitMotor));
  }
  function AngularConstraint(t, e) {
    (this.joint = t),
      (this.targetOrientation = new Quat().invert(e)),
      (this.relativeOrientation = new Quat()),
      (this.ii1 = null),
      (this.ii2 = null),
      (this.dd = null),
      (this.vel = new Vec3()),
      (this.imp = new Vec3()),
      (this.rn0 = new Vec3()),
      (this.rn1 = new Vec3()),
      (this.rn2 = new Vec3()),
      (this.b1 = t.body1),
      (this.b2 = t.body2),
      (this.a1 = this.b1.angularVelocity),
      (this.a2 = this.b2.angularVelocity),
      (this.i1 = this.b1.inverseInertia),
      (this.i2 = this.b2.inverseInertia);
  }
  function Translational3Constraint(t, e, a, n) {
    (this.m1 = NaN),
      (this.m2 = NaN),
      (this.i1e00 = NaN),
      (this.i1e01 = NaN),
      (this.i1e02 = NaN),
      (this.i1e10 = NaN),
      (this.i1e11 = NaN),
      (this.i1e12 = NaN),
      (this.i1e20 = NaN),
      (this.i1e21 = NaN),
      (this.i1e22 = NaN),
      (this.i2e00 = NaN),
      (this.i2e01 = NaN),
      (this.i2e02 = NaN),
      (this.i2e10 = NaN),
      (this.i2e11 = NaN),
      (this.i2e12 = NaN),
      (this.i2e20 = NaN),
      (this.i2e21 = NaN),
      (this.i2e22 = NaN),
      (this.ax1 = NaN),
      (this.ay1 = NaN),
      (this.az1 = NaN),
      (this.ax2 = NaN),
      (this.ay2 = NaN),
      (this.az2 = NaN),
      (this.ax3 = NaN),
      (this.ay3 = NaN),
      (this.az3 = NaN),
      (this.r1x = NaN),
      (this.r1y = NaN),
      (this.r1z = NaN),
      (this.r2x = NaN),
      (this.r2y = NaN),
      (this.r2z = NaN),
      (this.t1x1 = NaN),
      (this.t1y1 = NaN),
      (this.t1z1 = NaN),
      (this.t2x1 = NaN),
      (this.t2y1 = NaN),
      (this.t2z1 = NaN),
      (this.l1x1 = NaN),
      (this.l1y1 = NaN),
      (this.l1z1 = NaN),
      (this.l2x1 = NaN),
      (this.l2y1 = NaN),
      (this.l2z1 = NaN),
      (this.a1x1 = NaN),
      (this.a1y1 = NaN),
      (this.a1z1 = NaN),
      (this.a2x1 = NaN),
      (this.a2y1 = NaN),
      (this.a2z1 = NaN),
      (this.t1x2 = NaN),
      (this.t1y2 = NaN),
      (this.t1z2 = NaN),
      (this.t2x2 = NaN),
      (this.t2y2 = NaN),
      (this.t2z2 = NaN),
      (this.l1x2 = NaN),
      (this.l1y2 = NaN),
      (this.l1z2 = NaN),
      (this.l2x2 = NaN),
      (this.l2y2 = NaN),
      (this.l2z2 = NaN),
      (this.a1x2 = NaN),
      (this.a1y2 = NaN),
      (this.a1z2 = NaN),
      (this.a2x2 = NaN),
      (this.a2y2 = NaN),
      (this.a2z2 = NaN),
      (this.t1x3 = NaN),
      (this.t1y3 = NaN),
      (this.t1z3 = NaN),
      (this.t2x3 = NaN),
      (this.t2y3 = NaN),
      (this.t2z3 = NaN),
      (this.l1x3 = NaN),
      (this.l1y3 = NaN),
      (this.l1z3 = NaN),
      (this.l2x3 = NaN),
      (this.l2y3 = NaN),
      (this.l2z3 = NaN),
      (this.a1x3 = NaN),
      (this.a1y3 = NaN),
      (this.a1z3 = NaN),
      (this.a2x3 = NaN),
      (this.a2y3 = NaN),
      (this.a2z3 = NaN),
      (this.lowerLimit1 = NaN),
      (this.upperLimit1 = NaN),
      (this.limitVelocity1 = NaN),
      (this.limitState1 = 0),
      (this.enableMotor1 = !1),
      (this.motorSpeed1 = NaN),
      (this.maxMotorForce1 = NaN),
      (this.maxMotorImpulse1 = NaN),
      (this.lowerLimit2 = NaN),
      (this.upperLimit2 = NaN),
      (this.limitVelocity2 = NaN),
      (this.limitState2 = 0),
      (this.enableMotor2 = !1),
      (this.motorSpeed2 = NaN),
      (this.maxMotorForce2 = NaN),
      (this.maxMotorImpulse2 = NaN),
      (this.lowerLimit3 = NaN),
      (this.upperLimit3 = NaN),
      (this.limitVelocity3 = NaN),
      (this.limitState3 = 0),
      (this.enableMotor3 = !1),
      (this.motorSpeed3 = NaN),
      (this.maxMotorForce3 = NaN),
      (this.maxMotorImpulse3 = NaN),
      (this.k00 = NaN),
      (this.k01 = NaN),
      (this.k02 = NaN),
      (this.k10 = NaN),
      (this.k11 = NaN),
      (this.k12 = NaN),
      (this.k20 = NaN),
      (this.k21 = NaN),
      (this.k22 = NaN),
      (this.kv00 = NaN),
      (this.kv11 = NaN),
      (this.kv22 = NaN),
      (this.dv00 = NaN),
      (this.dv11 = NaN),
      (this.dv22 = NaN),
      (this.d00 = NaN),
      (this.d01 = NaN),
      (this.d02 = NaN),
      (this.d10 = NaN),
      (this.d11 = NaN),
      (this.d12 = NaN),
      (this.d20 = NaN),
      (this.d21 = NaN),
      (this.d22 = NaN),
      (this.limitMotor1 = e),
      (this.limitMotor2 = a),
      (this.limitMotor3 = n),
      (this.b1 = t.body1),
      (this.b2 = t.body2),
      (this.p1 = t.anchorPoint1),
      (this.p2 = t.anchorPoint2),
      (this.r1 = t.relativeAnchorPoint1),
      (this.r2 = t.relativeAnchorPoint2),
      (this.l1 = this.b1.linearVelocity),
      (this.l2 = this.b2.linearVelocity),
      (this.a1 = this.b1.angularVelocity),
      (this.a2 = this.b2.angularVelocity),
      (this.i1 = this.b1.inverseInertia),
      (this.i2 = this.b2.inverseInertia),
      (this.limitImpulse1 = 0),
      (this.motorImpulse1 = 0),
      (this.limitImpulse2 = 0),
      (this.motorImpulse2 = 0),
      (this.limitImpulse3 = 0),
      (this.motorImpulse3 = 0),
      (this.cfm1 = 0),
      (this.cfm2 = 0),
      (this.cfm3 = 0),
      (this.weight = -1);
  }
  function PrismaticJoint(t, e, a) {
    Joint.call(this, t),
      (this.type = 6),
      (this.localAxis1 = t.localAxis1.clone().normalize()),
      (this.localAxis2 = t.localAxis2.clone().normalize()),
      (this.ax1 = new Vec3()),
      (this.ax2 = new Vec3()),
      (this.nor = new Vec3()),
      (this.tan = new Vec3()),
      (this.bin = new Vec3()),
      (this.ac = new AngularConstraint(
        this,
        new Quat().setFromUnitVectors(this.localAxis1, this.localAxis2)
      )),
      (this.limitMotor = new LimitMotor(this.nor, !0)),
      (this.limitMotor.lowerLimit = e),
      (this.limitMotor.upperLimit = a),
      (this.t3 = new Translational3Constraint(
        this,
        this.limitMotor,
        new LimitMotor(this.tan, !0),
        new LimitMotor(this.bin, !0)
      ));
  }
  function SliderJoint(t, e, a) {
    Joint.call(this, t),
      (this.type = 5),
      (this.localAxis1 = t.localAxis1.clone().normalize()),
      (this.localAxis2 = t.localAxis2.clone().normalize());
    var n = new Mat33().setQuat(
      new Quat().setFromUnitVectors(this.localAxis1, this.localAxis2)
    );
    (this.localAngle1 = new Vec3().tangent(this.localAxis1).normalize()),
      (this.localAngle2 = this.localAngle1.clone().applyMatrix3(n, !0)),
      (this.ax1 = new Vec3()),
      (this.ax2 = new Vec3()),
      (this.an1 = new Vec3()),
      (this.an2 = new Vec3()),
      (this.tmp = new Vec3()),
      (this.nor = new Vec3()),
      (this.tan = new Vec3()),
      (this.bin = new Vec3()),
      (this.rotationalLimitMotor = new LimitMotor(this.nor, !1)),
      (this.r3 = new Rotational3Constraint(
        this,
        this.rotationalLimitMotor,
        new LimitMotor(this.tan, !0),
        new LimitMotor(this.bin, !0)
      )),
      (this.translationalLimitMotor = new LimitMotor(this.nor, !0)),
      (this.translationalLimitMotor.lowerLimit = e),
      (this.translationalLimitMotor.upperLimit = a),
      (this.t3 = new Translational3Constraint(
        this,
        this.translationalLimitMotor,
        new LimitMotor(this.tan, !0),
        new LimitMotor(this.bin, !0)
      ));
  }
  function WheelJoint(t) {
    Joint.call(this, t),
      (this.type = 4),
      (this.localAxis1 = t.localAxis1.clone().normalize()),
      (this.localAxis2 = t.localAxis2.clone().normalize()),
      (this.localAngle1 = new Vec3()),
      (this.localAngle2 = new Vec3());
    var e = m.dotVectors(this.localAxis1, this.localAxis2);
    if (e > -1 && e < 1)
      this.localAngle1
        .set(
          this.localAxis2.x - e * this.localAxis1.x,
          this.localAxis2.y - e * this.localAxis1.y,
          this.localAxis2.z - e * this.localAxis1.z
        )
        .normalize(),
        this.localAngle2
          .set(
            this.localAxis1.x - e * this.localAxis2.x,
            this.localAxis1.y - e * this.localAxis2.y,
            this.localAxis1.z - e * this.localAxis2.z
          )
          .normalize();
    else {
      var a = new Mat33().setQuat(
        new Quat().setFromUnitVectors(this.localAxis1, this.localAxis2)
      );
      this.localAngle1.tangent(this.localAxis1).normalize(),
        (this.localAngle2 = this.localAngle1.clone().applyMatrix3(a, !0));
    }
    (this.ax1 = new Vec3()),
      (this.ax2 = new Vec3()),
      (this.an1 = new Vec3()),
      (this.an2 = new Vec3()),
      (this.tmp = new Vec3()),
      (this.nor = new Vec3()),
      (this.tan = new Vec3()),
      (this.bin = new Vec3()),
      (this.translationalLimitMotor = new LimitMotor(this.tan, !0)),
      (this.translationalLimitMotor.frequency = 8),
      (this.translationalLimitMotor.dampingRatio = 1),
      (this.rotationalLimitMotor1 = new LimitMotor(this.tan, !1)),
      (this.rotationalLimitMotor2 = new LimitMotor(this.bin, !1)),
      (this.t3 = new Translational3Constraint(
        this,
        new LimitMotor(this.nor, !0),
        this.translationalLimitMotor,
        new LimitMotor(this.bin, !0)
      )),
      (this.t3.weight = 1),
      (this.r3 = new Rotational3Constraint(
        this,
        new LimitMotor(this.nor, !0),
        this.rotationalLimitMotor1,
        this.rotationalLimitMotor2
      ));
  }
  function JointConfig() {
    (this.scale = 1),
      (this.invScale = 1),
      (this.body1 = null),
      (this.body2 = null),
      (this.localAnchorPoint1 = new Vec3()),
      (this.localAnchorPoint2 = new Vec3()),
      (this.localAxis1 = new Vec3()),
      (this.localAxis2 = new Vec3()),
      (this.allowCollision = !1);
  }
  function MassInfo() {
    (this.mass = 0), (this.inertia = new Mat33());
  }
  function ContactLink(t) {
    (this.prev = null),
      (this.next = null),
      (this.shape = null),
      (this.body = null),
      (this.contact = t);
  }
  function ImpulseDataBuffer() {
    (this.lp1X = NaN),
      (this.lp1Y = NaN),
      (this.lp1Z = NaN),
      (this.lp2X = NaN),
      (this.lp2Y = NaN),
      (this.lp2Z = NaN),
      (this.impulse = NaN);
  }
  function ManifoldPoint() {
    (this.warmStarted = !1),
      (this.position = new Vec3()),
      (this.localPoint1 = new Vec3()),
      (this.localPoint2 = new Vec3()),
      (this.normal = new Vec3()),
      (this.tangent = new Vec3()),
      (this.binormal = new Vec3()),
      (this.normalImpulse = 0),
      (this.tangentImpulse = 0),
      (this.binormalImpulse = 0),
      (this.normalDenominator = 0),
      (this.tangentDenominator = 0),
      (this.binormalDenominator = 0),
      (this.penetration = 0);
  }
  function ContactManifold() {
    (this.body1 = null),
      (this.body2 = null),
      (this.numPoints = 0),
      (this.points = [
        new ManifoldPoint(),
        new ManifoldPoint(),
        new ManifoldPoint(),
        new ManifoldPoint(),
      ]);
  }
  function ContactPointDataBuffer() {
    (this.nor = new Vec3()),
      (this.tan = new Vec3()),
      (this.bin = new Vec3()),
      (this.norU1 = new Vec3()),
      (this.tanU1 = new Vec3()),
      (this.binU1 = new Vec3()),
      (this.norU2 = new Vec3()),
      (this.tanU2 = new Vec3()),
      (this.binU2 = new Vec3()),
      (this.norT1 = new Vec3()),
      (this.tanT1 = new Vec3()),
      (this.binT1 = new Vec3()),
      (this.norT2 = new Vec3()),
      (this.tanT2 = new Vec3()),
      (this.binT2 = new Vec3()),
      (this.norTU1 = new Vec3()),
      (this.tanTU1 = new Vec3()),
      (this.binTU1 = new Vec3()),
      (this.norTU2 = new Vec3()),
      (this.tanTU2 = new Vec3()),
      (this.binTU2 = new Vec3()),
      (this.norImp = 0),
      (this.tanImp = 0),
      (this.binImp = 0),
      (this.norDen = 0),
      (this.tanDen = 0),
      (this.binDen = 0),
      (this.norTar = 0),
      (this.next = null),
      (this.last = !1);
  }
  function ContactConstraint(t) {
    Constraint.call(this),
      (this.manifold = t),
      (this.restitution = NaN),
      (this.friction = NaN),
      (this.p1 = null),
      (this.p2 = null),
      (this.lv1 = null),
      (this.lv2 = null),
      (this.av1 = null),
      (this.av2 = null),
      (this.i1 = null),
      (this.i2 = null),
      (this.tmp = new Vec3()),
      (this.tmpC1 = new Vec3()),
      (this.tmpC2 = new Vec3()),
      (this.tmpP1 = new Vec3()),
      (this.tmpP2 = new Vec3()),
      (this.tmplv1 = new Vec3()),
      (this.tmplv2 = new Vec3()),
      (this.tmpav1 = new Vec3()),
      (this.tmpav2 = new Vec3()),
      (this.m1 = NaN),
      (this.m2 = NaN),
      (this.num = 0),
      (this.ps = t.points),
      (this.cs = new ContactPointDataBuffer()),
      (this.cs.next = new ContactPointDataBuffer()),
      (this.cs.next.next = new ContactPointDataBuffer()),
      (this.cs.next.next.next = new ContactPointDataBuffer());
  }
  function Contact() {
    (this.shape1 = null),
      (this.shape2 = null),
      (this.body1 = null),
      (this.body2 = null),
      (this.prev = null),
      (this.next = null),
      (this.persisting = !1),
      (this.sleeping = !1),
      (this.detector = null),
      (this.constraint = null),
      (this.touching = !1),
      (this.close = !1),
      (this.dist = m.INF),
      (this.b1Link = new ContactLink(this)),
      (this.b2Link = new ContactLink(this)),
      (this.s1Link = new ContactLink(this)),
      (this.s2Link = new ContactLink(this)),
      (this.manifold = new ContactManifold()),
      (this.buffer = [
        new ImpulseDataBuffer(),
        new ImpulseDataBuffer(),
        new ImpulseDataBuffer(),
        new ImpulseDataBuffer(),
      ]),
      (this.points = this.manifold.points),
      (this.constraint = new ContactConstraint(this.manifold));
  }
  function RigidBody(t, e) {
    (this.position = t || new Vec3()),
      (this.orientation = e || new Quat()),
      (this.scale = 1),
      (this.invScale = 1),
      (this.mesh = null),
      (this.id = NaN),
      (this.name = ""),
      (this.prev = null),
      (this.next = null),
      (this.type = 0),
      (this.massInfo = new MassInfo()),
      (this.newPosition = new Vec3()),
      (this.controlPos = !1),
      (this.newOrientation = new Quat()),
      (this.newRotation = new Vec3()),
      (this.currentRotation = new Vec3()),
      (this.controlRot = !1),
      (this.controlRotInTime = !1),
      (this.quaternion = new Quat()),
      (this.pos = new Vec3()),
      (this.linearVelocity = new Vec3()),
      (this.linearSpeed = new Vec3()),
      (this.linearVelocityConstraint = ""),
      (this.angularVelocityConstraint = ""),
      (this.linearVelocityMax = null),
      (this.angularVelocityMax = null),
      (this.positionConstraint = null),
      (this.angularConstraint = null),
      (this.angularVelocity = new Vec3()),
      (this.parent = null),
      (this.contactLink = null),
      (this.numContacts = 0),
      (this.shapes = null),
      (this.numShapes = 0),
      (this.jointLink = null),
      (this.numJoints = 0),
      (this.sleepPosition = new Vec3()),
      (this.sleepOrientation = new Quat()),
      (this.isStatic = !1),
      (this.isDynamic = !1),
      (this.isKinematic = !1),
      (this.rotation = new Mat33()),
      (this.mass = 0),
      (this.inverseMass = 0),
      (this.inverseInertia = new Mat33()),
      (this.localInertia = new Mat33()),
      (this.inverseLocalInertia = new Mat33()),
      (this.tmpInertia = new Mat33()),
      (this.addedToIsland = !1),
      (this.allowSleep = !0),
      (this.sleepTime = 0),
      (this.sleeping = !1);
  }
  function Pair(t, e) {
    (this.shape1 = t || null), (this.shape2 = e || null);
  }
  function BroadPhase() {
    (this.types = 0),
      (this.numPairChecks = 0),
      (this.numPairs = 0),
      (this.pairs = []);
  }
  Object.assign(Shape.prototype, {
    Shape: !0,
    calculateMassInfo: function (t) {
      printError("Shape", "Inheritance error.");
    },
    updateProxy: function () {
      printError("Shape", "Inheritance error.");
    },
    intersectRay: function () {
      printError("Shape", "intersectRay error.");
    },
  }),
    (Box.prototype = Object.assign(Object.create(Shape.prototype), {
      constructor: Box,
      calculateMassInfo: function (t) {
        var e = this.width * this.height * this.depth * this.density;
        this.mass && (e = this.mass), (this.mass = e);
        (t.mass = e),
          t.inertia.set(
            e *
              (this.height * this.height + this.depth * this.depth) *
              (1 / 12),
            0,
            0,
            0,
            e * (this.width * this.width + this.depth * this.depth) * (1 / 12),
            0,
            0,
            0,
            e * (this.width * this.width + this.height * this.height) * (1 / 12)
          );
      },
      updateProxy: function () {
        var t = this.rotation.elements,
          e = this.dimentions;
        (e[0] = t[0]),
          (e[1] = t[3]),
          (e[2] = t[6]),
          (e[3] = t[1]),
          (e[4] = t[4]),
          (e[5] = t[7]),
          (e[6] = t[2]),
          (e[7] = t[5]),
          (e[8] = t[8]),
          (e[9] = t[0] * this.halfWidth),
          (e[10] = t[3] * this.halfWidth),
          (e[11] = t[6] * this.halfWidth),
          (e[12] = t[1] * this.halfHeight),
          (e[13] = t[4] * this.halfHeight),
          (e[14] = t[7] * this.halfHeight),
          (e[15] = t[2] * this.halfDepth),
          (e[16] = t[5] * this.halfDepth),
          (e[17] = t[8] * this.halfDepth);
        var a = e[9],
          n = e[10],
          u = e[11],
          m = e[12],
          f = e[13],
          p = e[14],
          y = e[15],
          g = e[16],
          _ = e[17],
          x = this.position.x,
          b = this.position.y,
          v = this.position.z,
          w = this.elements;
        (w[0] = x + a + m + y),
          (w[1] = b + n + f + g),
          (w[2] = v + u + p + _),
          (w[3] = x + a + m - y),
          (w[4] = b + n + f - g),
          (w[5] = v + u + p - _),
          (w[6] = x + a - m + y),
          (w[7] = b + n - f + g),
          (w[8] = v + u - p + _),
          (w[9] = x + a - m - y),
          (w[10] = b + n - f - g),
          (w[11] = v + u - p - _),
          (w[12] = x - a + m + y),
          (w[13] = b - n + f + g),
          (w[14] = v - u + p + _),
          (w[15] = x - a + m - y),
          (w[16] = b - n + f - g),
          (w[17] = v - u + p - _),
          (w[18] = x - a - m + y),
          (w[19] = b - n - f + g),
          (w[20] = v - u - p + _),
          (w[21] = x - a - m - y),
          (w[22] = b - n - f - g),
          (w[23] = v - u - p - _);
        var S = e[9] < 0 ? -e[9] : e[9],
          C = e[10] < 0 ? -e[10] : e[10],
          E = e[11] < 0 ? -e[11] : e[11];
        (S = e[12] < 0 ? S - e[12] : S + e[12]),
          (C = e[13] < 0 ? C - e[13] : C + e[13]),
          (E = e[14] < 0 ? E - e[14] : E + e[14]),
          (S = e[15] < 0 ? S - e[15] : S + e[15]),
          (C = e[16] < 0 ? C - e[16] : C + e[16]),
          (E = e[17] < 0 ? E - e[17] : E + e[17]);
        var z = 0.005;
        this.lastAABB.copy(this.aabb),
          this.aabb.set(
            this.position.x - S - z,
            this.position.x + S + z,
            this.position.y - C - z,
            this.position.y + C + z,
            this.position.z - E - z,
            this.position.z + E + z
          ),
          null != this.proxy && this.proxy.update();
      },
      intersectRay: function (t, e, a, n) {
        var u = [],
          m = [this.halfWidth + 0, this.halfHeight + 0, this.halfDepth + 0],
          f = [-m[0], -m[1], -m[2]],
          p = [-1, -1, -1],
          y = !0,
          g = [t.x, t.y, t.z],
          _ = [e.x, e.y, e.z];
        for (let t = 0; t < 3; t++)
          g[t] < f[t]
            ? ((u[t] = f[t]),
              (y = !1),
              0 != _[t] && (p[t] = (f[t] - g[t]) / _[t]))
            : g[t] > m[t] &&
              ((u[t] = m[t]),
              (y = !1),
              0 != _[t] && (p[t] = (m[t] - g[t]) / _[t]));
        if (y)
          return (
            (n.hasHit = !0),
            (n.distance = 0),
            (n.intersectionPoint = new Vec3(g[0], g[1], g[2])),
            (n.normal = new Vec3(-_[0], -_[1], -_[2])),
            !0
          );
        var x = 0;
        if ((p[1] > p[x] && (x = 1), p[2] > p[x] && (x = 2), p[x] > a))
          return !1;
        for (let t = 0; t < 3; t++)
          if (
            t != x &&
            ((u[t] = g[t] + p[x] * _[t]), u[t] < f[t] || u[t] > m[t])
          )
            return !1;
        (n.hasHit = !0),
          (n.distance = p[x]),
          (n.intersectionPoint = new Vec3(u[0], u[1], u[2]));
        var b = _;
        return (
          (b[0] = b[1] = b[2] = 0),
          (b[x] = u[x] > 0 ? 1 : -1),
          (n.normal = new Vec3(b[0], b[1], b[2])),
          !0
        );
      },
    })),
    (Sphere.prototype = Object.assign(Object.create(Shape.prototype), {
      constructor: Sphere,
      volume: function () {
        return m.PI * this.radius * 1.333333;
      },
      calculateMassInfo: function (t) {
        var e = this.volume() * this.radius * this.radius * this.density;
        this.mass && (e = this.mass), (this.mass = e), (t.mass = e);
        var a = e * this.radius * this.radius * 0.4;
        t.inertia.set(a, 0, 0, 0, a, 0, 0, 0, a);
      },
      updateProxy: function () {
        var t = 0.005;
        this.lastAABB.copy(this.aabb),
          this.aabb.set(
            this.position.x - this.radius - t,
            this.position.x + this.radius + t,
            this.position.y - this.radius - t,
            this.position.y + this.radius + t,
            this.position.z - this.radius - t,
            this.position.z + this.radius + t
          ),
          null != this.proxy && this.proxy.update();
      },
      intersectRay: function (t, e, a, n) {
        var u = this.radius,
          m = n.temp,
          f = this.position;
        m.copy(t).subEqual(f);
        var p = m.dot(e),
          y = m.dot(m) - u * u;
        if (!(y > 0 && p > 0)) {
          var g = p * p - y;
          if (!(g < 0)) {
            var _ = -p - Math.sqrt(g);
            _ < 0 && (_ = 0), (n.hasHit = !0), (n.distance = _);
            var x = new Vec3();
            x.copy(e).scaleEqual(_).addEqual(t), (n.intersectionPoint = x);
          }
        }
      },
    })),
    (Cylinder.prototype = Object.assign(Object.create(Shape.prototype), {
      constructor: Cylinder,
      calculateMassInfo: function (t) {
        var e = this.radius * this.radius,
          a = m.PI * e * this.height * this.density;
        this.mass && (a = this.mass), (this.mass = a);
        var n = (0.25 * e + 0.0833 * this.height * this.height) * a,
          u = 0.5 * e;
        (t.mass = a), t.inertia.set(n, 0, 0, 0, u, 0, 0, 0, n);
      },
      updateProxy: function () {
        var t,
          e,
          a,
          n,
          u,
          f,
          p,
          y,
          g,
          _,
          x,
          b = this.rotation.elements;
        (u = b[1] * b[1]),
          (f = b[4] * b[4]),
          (p = b[7] * b[7]),
          this.normalDirection.set(b[1], b[4], b[7]),
          this.halfDirection.scale(this.normalDirection, this.halfHeight),
          (e = 1 - u),
          (t = m.sqrt(e * e + u * f + u * p)) > 0 && (t = this.radius / t),
          (e *= t),
          (a = 1 - f),
          (t = m.sqrt(f * u + a * a + f * p)) > 0 && (t = this.radius / t),
          (a *= t),
          (n = 1 - p),
          (t = m.sqrt(p * u + p * f + n * n)) > 0 && (t = this.radius / t),
          (n *= t),
          (y =
            this.halfDirection.x < 0
              ? -this.halfDirection.x
              : this.halfDirection.x),
          (g =
            this.halfDirection.y < 0
              ? -this.halfDirection.y
              : this.halfDirection.y),
          (_ =
            this.halfDirection.z < 0
              ? -this.halfDirection.z
              : this.halfDirection.z),
          (y = e < 0 ? y - e : y + e),
          (g = a < 0 ? g - a : g + a),
          (_ = n < 0 ? _ - n : _ + n),
          (x = 0.005),
          this.lastAABB.copy(this.aabb),
          this.aabb.set(
            this.position.x - y - x,
            this.position.x + y + x,
            this.position.y - g - x,
            this.position.y + g + x,
            this.position.z - _ - x,
            this.position.z + _ + x
          ),
          null != this.proxy && this.proxy.update();
      },
      intersectRay: function (t, e, a, n) {
        var u = [],
          m = [this.halfWidth + 0, this.halfHeight + 0, this.halfDepth + 0],
          f = [-m[0], -m[1], -m[2]],
          p = [-1, -1, -1],
          y = !0,
          g = [t.x, t.y, t.z],
          _ = [e.x, e.y, e.z];
        for (let t = 0; t < 3; t++)
          g[t] < f[t]
            ? ((u[t] = f[t]),
              (y = !1),
              0 != _[t] && (p[t] = (f[t] - g[t]) / _[t]))
            : g[t] > m[t] &&
              ((u[t] = m[t]),
              (y = !1),
              0 != _[t] && (p[t] = (m[t] - g[t]) / _[t]));
        if (y)
          return (
            (n.hasHit = !0),
            (n.distance = 0),
            (n.intersectionPoint = new Vec3(g[0], g[1], g[2])),
            (n.normal = new Vec3(-_[0], -_[1], -_[2])),
            !0
          );
        var x = 0;
        if ((p[1] > p[x] && (x = 1), p[2] > p[x] && (x = 2), p[x] > a))
          return !1;
        for (let t = 0; t < 3; t++)
          if (
            t != x &&
            ((u[t] = g[t] + p[x] * _[t]), u[t] < f[t] || u[t] > m[t])
          )
            return !1;
        (n.hasHit = !0),
          (n.distance = p[x]),
          (n.intersectionPoint = new Vec3(u[0], u[1], u[2]));
        var b = _;
        return (
          (b[0] = b[1] = b[2] = 0),
          (b[x] = u[x] > 0 ? 1 : -1),
          (n.normal = new Vec3(b[0], b[1], b[2])),
          !0
        );
      },
    })),
    (Plane.prototype = Object.assign(Object.create(Shape.prototype), {
      constructor: Plane,
      volume: function () {
        return Number.MAX_VALUE;
      },
      calculateMassInfo: function (t) {
        t.mass = this.density;
        t.inertia.set(1, 0, 0, 0, 1, 0, 0, 0, 1);
      },
      updateProxy: function () {
        var t = 0.005,
          e = -m.INF,
          a = m.INF,
          n = this.normal;
        this.lastAABB.copy(this.aabb),
          this.aabb.set(
            -1 === n.x ? this.position.x - t : e,
            1 === n.x ? this.position.x + t : a,
            -1 === n.y ? this.position.y - t : e,
            1 === n.y ? this.position.y + t : a,
            -1 === n.z ? this.position.z - t : e,
            1 === n.z ? this.position.z + t : a
          ),
          null != this.proxy && this.proxy.update();
      },
    })),
    (Particle.prototype = Object.assign(Object.create(Shape.prototype), {
      constructor: Particle,
      volume: function () {
        return Number.MAX_VALUE;
      },
      calculateMassInfo: function (t) {
        t.inertia.set(0, 0, 0, 0, 0, 0, 0, 0, 0);
      },
      updateProxy: function () {
        this.lastAABB.copy(this.aabb),
          this.aabb.set(
            this.position.x - 0,
            this.position.x + 0,
            this.position.y - 0,
            this.position.y + 0,
            this.position.z - 0,
            this.position.z + 0
          ),
          null != this.proxy && this.proxy.update();
      },
    })),
    Object.assign(LimitMotor.prototype, {
      LimitMotor: !0,
      setLimit: function (t, e) {
        (this.lowerLimit = t), (this.upperLimit = e);
      },
      setMotor: function (t, e) {
        (this.motorSpeed = t), (this.maxMotorForce = e);
      },
      setSpring: function (t, e) {
        (this.frequency = t), (this.dampingRatio = e);
      },
    }),
    Object.assign(Constraint.prototype, {
      Constraint: !0,
      preSolve: function (t, e) {
        printError("Constraint", "Inheritance error.");
      },
      solve: function () {
        printError("Constraint", "Inheritance error.");
      },
      postSolve: function () {
        printError("Constraint", "Inheritance error.");
      },
    }),
    (Joint.prototype = Object.assign(Object.create(Constraint.prototype), {
      constructor: Joint,
      setId: function (t) {
        this.id = i;
      },
      setParent: function (t) {
        (this.parent = t),
          (this.scale = this.parent.scale),
          (this.invScale = this.parent.invScale),
          (this.id = this.parent.numJoints),
          this.name || (this.name = "J" + this.id);
      },
      updateAnchorPoints: function () {
        this.relativeAnchorPoint1
          .copy(this.localAnchorPoint1)
          .applyMatrix3(this.body1.rotation, !0),
          this.relativeAnchorPoint2
            .copy(this.localAnchorPoint2)
            .applyMatrix3(this.body2.rotation, !0),
          this.anchorPoint1.add(this.relativeAnchorPoint1, this.body1.position),
          this.anchorPoint2.add(this.relativeAnchorPoint2, this.body2.position);
      },
      attach: function (t) {
        (this.b1Link.body = this.body2),
          (this.b2Link.body = this.body1),
          t
            ? (this.body1.jointLink.push(this.b1Link),
              this.body2.jointLink.push(this.b2Link))
            : (null != this.body1.jointLink
                ? ((this.b1Link.next = this.body1.jointLink).prev = this.b1Link)
                : (this.b1Link.next = null),
              (this.body1.jointLink = this.b1Link),
              this.body1.numJoints++,
              null != this.body2.jointLink
                ? ((this.b2Link.next = this.body2.jointLink).prev = this.b2Link)
                : (this.b2Link.next = null),
              (this.body2.jointLink = this.b2Link),
              this.body2.numJoints++);
      },
      detach: function (t) {
        if (t)
          this.body1.jointLink.splice(
            this.body1.jointLink.indexOf(this.b1Link),
            1
          ),
            this.body2.jointLink.splice(
              this.body2.jointLink.indexOf(this.b2Link),
              1
            );
        else {
          var e = this.b1Link.prev,
            a = this.b1Link.next;
          null != e && (e.next = a),
            null != a && (a.prev = e),
            this.body1.jointLink == this.b1Link && (this.body1.jointLink = a),
            (this.b1Link.prev = null),
            (this.b1Link.next = null),
            (this.b1Link.body = null),
            this.body1.numJoints--,
            (e = this.b2Link.prev),
            (a = this.b2Link.next),
            null != e && (e.next = a),
            null != a && (a.prev = e),
            this.body2.jointLink == this.b2Link && (this.body2.jointLink = a),
            (this.b2Link.prev = null),
            (this.b2Link.next = null),
            (this.b2Link.body = null),
            this.body2.numJoints--;
        }
        (this.b1Link.body = null), (this.b2Link.body = null);
      },
      awake: function () {
        this.body1.awake(), this.body2.awake();
      },
      preSolve: function (t, e) {},
      solve: function () {},
      postSolve: function () {},
      remove: function () {
        this.dispose();
      },
      dispose: function () {
        this.parent.removeJoint(this);
      },
      getPosition: function () {
        return [
          new Vec3().scale(this.anchorPoint1, this.scale),
          new Vec3().scale(this.anchorPoint2, this.scale),
        ];
      },
    })),
    Object.assign(LinearConstraint.prototype, {
      LinearConstraint: !0,
      preSolve: function (t, e) {
        (this.r1x = this.r1.x),
          (this.r1y = this.r1.y),
          (this.r1z = this.r1.z),
          (this.r2x = this.r2.x),
          (this.r2y = this.r2.y),
          (this.r2z = this.r2.z),
          (this.m1 = this.b1.inverseMass),
          (this.m2 = this.b2.inverseMass),
          (this.ii1 = this.i1.clone()),
          (this.ii2 = this.i2.clone());
        var a = this.ii1.elements,
          n = this.ii2.elements;
        (this.ax1x = this.r1z * a[1] + -this.r1y * a[2]),
          (this.ax1y = this.r1z * a[4] + -this.r1y * a[5]),
          (this.ax1z = this.r1z * a[7] + -this.r1y * a[8]),
          (this.ay1x = -this.r1z * a[0] + this.r1x * a[2]),
          (this.ay1y = -this.r1z * a[3] + this.r1x * a[5]),
          (this.ay1z = -this.r1z * a[6] + this.r1x * a[8]),
          (this.az1x = this.r1y * a[0] + -this.r1x * a[1]),
          (this.az1y = this.r1y * a[3] + -this.r1x * a[4]),
          (this.az1z = this.r1y * a[6] + -this.r1x * a[7]),
          (this.ax2x = this.r2z * n[1] + -this.r2y * n[2]),
          (this.ax2y = this.r2z * n[4] + -this.r2y * n[5]),
          (this.ax2z = this.r2z * n[7] + -this.r2y * n[8]),
          (this.ay2x = -this.r2z * n[0] + this.r2x * n[2]),
          (this.ay2y = -this.r2z * n[3] + this.r2x * n[5]),
          (this.ay2z = -this.r2z * n[6] + this.r2x * n[8]),
          (this.az2x = this.r2y * n[0] + -this.r2x * n[1]),
          (this.az2y = this.r2y * n[3] + -this.r2x * n[4]),
          (this.az2z = this.r2y * n[6] + -this.r2x * n[7]);
        var u = this.m1 + this.m2,
          f = new Mat33().set(u, 0, 0, 0, u, 0, 0, 0, u).elements;
        (f[0] +=
          a[4] * this.r1z * this.r1z -
          (a[7] + a[5]) * this.r1y * this.r1z +
          a[8] * this.r1y * this.r1y),
          (f[1] +=
            (a[6] * this.r1y + a[5] * this.r1x) * this.r1z -
            a[3] * this.r1z * this.r1z -
            a[8] * this.r1x * this.r1y),
          (f[2] +=
            (a[3] * this.r1y - a[4] * this.r1x) * this.r1z -
            a[6] * this.r1y * this.r1y +
            a[7] * this.r1x * this.r1y),
          (f[3] +=
            (a[2] * this.r1y + a[7] * this.r1x) * this.r1z -
            a[1] * this.r1z * this.r1z -
            a[8] * this.r1x * this.r1y),
          (f[4] +=
            a[0] * this.r1z * this.r1z -
            (a[6] + a[2]) * this.r1x * this.r1z +
            a[8] * this.r1x * this.r1x),
          (f[5] +=
            (a[1] * this.r1x - a[0] * this.r1y) * this.r1z -
            a[7] * this.r1x * this.r1x +
            a[6] * this.r1x * this.r1y),
          (f[6] +=
            (a[1] * this.r1y - a[4] * this.r1x) * this.r1z -
            a[2] * this.r1y * this.r1y +
            a[5] * this.r1x * this.r1y),
          (f[7] +=
            (a[3] * this.r1x - a[0] * this.r1y) * this.r1z -
            a[5] * this.r1x * this.r1x +
            a[2] * this.r1x * this.r1y),
          (f[8] +=
            a[0] * this.r1y * this.r1y -
            (a[3] + a[1]) * this.r1x * this.r1y +
            a[4] * this.r1x * this.r1x),
          (f[0] +=
            n[4] * this.r2z * this.r2z -
            (n[7] + n[5]) * this.r2y * this.r2z +
            n[8] * this.r2y * this.r2y),
          (f[1] +=
            (n[6] * this.r2y + n[5] * this.r2x) * this.r2z -
            n[3] * this.r2z * this.r2z -
            n[8] * this.r2x * this.r2y),
          (f[2] +=
            (n[3] * this.r2y - n[4] * this.r2x) * this.r2z -
            n[6] * this.r2y * this.r2y +
            n[7] * this.r2x * this.r2y),
          (f[3] +=
            (n[2] * this.r2y + n[7] * this.r2x) * this.r2z -
            n[1] * this.r2z * this.r2z -
            n[8] * this.r2x * this.r2y),
          (f[4] +=
            n[0] * this.r2z * this.r2z -
            (n[6] + n[2]) * this.r2x * this.r2z +
            n[8] * this.r2x * this.r2x),
          (f[5] +=
            (n[1] * this.r2x - n[0] * this.r2y) * this.r2z -
            n[7] * this.r2x * this.r2x +
            n[6] * this.r2x * this.r2y),
          (f[6] +=
            (n[1] * this.r2y - n[4] * this.r2x) * this.r2z -
            n[2] * this.r2y * this.r2y +
            n[5] * this.r2x * this.r2y),
          (f[7] +=
            (n[3] * this.r2x - n[0] * this.r2y) * this.r2z -
            n[5] * this.r2x * this.r2x +
            n[2] * this.r2x * this.r2y),
          (f[8] +=
            n[0] * this.r2y * this.r2y -
            (n[3] + n[1]) * this.r2x * this.r2y +
            n[4] * this.r2x * this.r2x);
        var p =
          1 /
          (f[0] * (f[4] * f[8] - f[7] * f[5]) +
            f[3] * (f[7] * f[2] - f[1] * f[8]) +
            f[6] * (f[1] * f[5] - f[4] * f[2]));
        (this.dd = new Mat33()
          .set(
            f[4] * f[8] - f[5] * f[7],
            f[2] * f[7] - f[1] * f[8],
            f[1] * f[5] - f[2] * f[4],
            f[5] * f[6] - f[3] * f[8],
            f[0] * f[8] - f[2] * f[6],
            f[2] * f[3] - f[0] * f[5],
            f[3] * f[7] - f[4] * f[6],
            f[1] * f[6] - f[0] * f[7],
            f[0] * f[4] - f[1] * f[3]
          )
          .scaleEqual(p)),
          (this.velx = this.p2.x - this.p1.x),
          (this.vely = this.p2.y - this.p1.y),
          (this.velz = this.p2.z - this.p1.z);
        var y = m.sqrt(
          this.velx * this.velx + this.vely * this.vely + this.velz * this.velz
        );
        y > 0.005
          ? ((y = ((0.005 - y) / y) * e * 0.05),
            (this.velx *= y),
            (this.vely *= y),
            (this.velz *= y))
          : ((this.velx = 0), (this.vely = 0), (this.velz = 0)),
          (this.impx *= 0.95),
          (this.impy *= 0.95),
          (this.impz *= 0.95),
          (this.l1.x += this.impx * this.m1),
          (this.l1.y += this.impy * this.m1),
          (this.l1.z += this.impz * this.m1),
          (this.a1.x +=
            this.impx * this.ax1x +
            this.impy * this.ay1x +
            this.impz * this.az1x),
          (this.a1.y +=
            this.impx * this.ax1y +
            this.impy * this.ay1y +
            this.impz * this.az1y),
          (this.a1.z +=
            this.impx * this.ax1z +
            this.impy * this.ay1z +
            this.impz * this.az1z),
          (this.l2.x -= this.impx * this.m2),
          (this.l2.y -= this.impy * this.m2),
          (this.l2.z -= this.impz * this.m2),
          (this.a2.x -=
            this.impx * this.ax2x +
            this.impy * this.ay2x +
            this.impz * this.az2x),
          (this.a2.y -=
            this.impx * this.ax2y +
            this.impy * this.ay2y +
            this.impz * this.az2y),
          (this.a2.z -=
            this.impx * this.ax2z +
            this.impy * this.ay2z +
            this.impz * this.az2z);
      },
      solve: function () {
        var t = this.dd.elements,
          e =
            this.l2.x -
            this.l1.x +
            this.a2.y * this.r2z -
            this.a2.z * this.r2y -
            this.a1.y * this.r1z +
            this.a1.z * this.r1y -
            this.velx,
          a =
            this.l2.y -
            this.l1.y +
            this.a2.z * this.r2x -
            this.a2.x * this.r2z -
            this.a1.z * this.r1x +
            this.a1.x * this.r1z -
            this.vely,
          n =
            this.l2.z -
            this.l1.z +
            this.a2.x * this.r2y -
            this.a2.y * this.r2x -
            this.a1.x * this.r1y +
            this.a1.y * this.r1x -
            this.velz,
          u = e * t[0] + a * t[1] + n * t[2],
          m = e * t[3] + a * t[4] + n * t[5],
          f = e * t[6] + a * t[7] + n * t[8];
        (this.impx += u),
          (this.impy += m),
          (this.impz += f),
          (this.l1.x += u * this.m1),
          (this.l1.y += m * this.m1),
          (this.l1.z += f * this.m1),
          (this.a1.x += u * this.ax1x + m * this.ay1x + f * this.az1x),
          (this.a1.y += u * this.ax1y + m * this.ay1y + f * this.az1y),
          (this.a1.z += u * this.ax1z + m * this.ay1z + f * this.az1z),
          (this.l2.x -= u * this.m2),
          (this.l2.y -= m * this.m2),
          (this.l2.z -= f * this.m2),
          (this.a2.x -= u * this.ax2x + m * this.ay2x + f * this.az2x),
          (this.a2.y -= u * this.ax2y + m * this.ay2y + f * this.az2y),
          (this.a2.z -= u * this.ax2z + m * this.ay2z + f * this.az2z);
      },
    }),
    Object.assign(Rotational3Constraint.prototype, {
      Rotational3Constraint: !0,
      preSolve: function (t, e) {
        (this.ax1 = this.limitMotor1.axis.x),
          (this.ay1 = this.limitMotor1.axis.y),
          (this.az1 = this.limitMotor1.axis.z),
          (this.ax2 = this.limitMotor2.axis.x),
          (this.ay2 = this.limitMotor2.axis.y),
          (this.az2 = this.limitMotor2.axis.z),
          (this.ax3 = this.limitMotor3.axis.x),
          (this.ay3 = this.limitMotor3.axis.y),
          (this.az3 = this.limitMotor3.axis.z),
          (this.lowerLimit1 = this.limitMotor1.lowerLimit),
          (this.upperLimit1 = this.limitMotor1.upperLimit),
          (this.motorSpeed1 = this.limitMotor1.motorSpeed),
          (this.maxMotorForce1 = this.limitMotor1.maxMotorForce),
          (this.enableMotor1 = this.maxMotorForce1 > 0),
          (this.lowerLimit2 = this.limitMotor2.lowerLimit),
          (this.upperLimit2 = this.limitMotor2.upperLimit),
          (this.motorSpeed2 = this.limitMotor2.motorSpeed),
          (this.maxMotorForce2 = this.limitMotor2.maxMotorForce),
          (this.enableMotor2 = this.maxMotorForce2 > 0),
          (this.lowerLimit3 = this.limitMotor3.lowerLimit),
          (this.upperLimit3 = this.limitMotor3.upperLimit),
          (this.motorSpeed3 = this.limitMotor3.motorSpeed),
          (this.maxMotorForce3 = this.limitMotor3.maxMotorForce),
          (this.enableMotor3 = this.maxMotorForce3 > 0);
        var a = this.i1.elements,
          n = this.i2.elements;
        (this.i1e00 = a[0]),
          (this.i1e01 = a[1]),
          (this.i1e02 = a[2]),
          (this.i1e10 = a[3]),
          (this.i1e11 = a[4]),
          (this.i1e12 = a[5]),
          (this.i1e20 = a[6]),
          (this.i1e21 = a[7]),
          (this.i1e22 = a[8]),
          (this.i2e00 = n[0]),
          (this.i2e01 = n[1]),
          (this.i2e02 = n[2]),
          (this.i2e10 = n[3]),
          (this.i2e11 = n[4]),
          (this.i2e12 = n[5]),
          (this.i2e20 = n[6]),
          (this.i2e21 = n[7]),
          (this.i2e22 = n[8]);
        var u = this.limitMotor1.frequency,
          m = this.limitMotor2.frequency,
          f = this.limitMotor3.frequency,
          p = u > 0,
          y = m > 0,
          g = f > 0,
          _ = this.lowerLimit1 <= this.upperLimit1,
          x = this.lowerLimit2 <= this.upperLimit2,
          b = this.lowerLimit3 <= this.upperLimit3,
          v = this.limitMotor1.angle;
        _
          ? (this.lowerLimit1 == this.upperLimit1
              ? (0 != this.limitState1 &&
                  ((this.limitState1 = 0), (this.limitImpulse1 = 0)),
                (this.limitVelocity1 = this.lowerLimit1 - v))
              : v < this.lowerLimit1
              ? (-1 != this.limitState1 &&
                  ((this.limitState1 = -1), (this.limitImpulse1 = 0)),
                (this.limitVelocity1 = this.lowerLimit1 - v))
              : v > this.upperLimit1
              ? (1 != this.limitState1 &&
                  ((this.limitState1 = 1), (this.limitImpulse1 = 0)),
                (this.limitVelocity1 = this.upperLimit1 - v))
              : ((this.limitState1 = 2),
                (this.limitImpulse1 = 0),
                (this.limitVelocity1 = 0)),
            p ||
              (this.limitVelocity1 > 0.02
                ? (this.limitVelocity1 -= 0.02)
                : this.limitVelocity1 < -0.02
                ? (this.limitVelocity1 += 0.02)
                : (this.limitVelocity1 = 0)))
          : ((this.limitState1 = 2), (this.limitImpulse1 = 0));
        var w = this.limitMotor2.angle;
        x
          ? (this.lowerLimit2 == this.upperLimit2
              ? (0 != this.limitState2 &&
                  ((this.limitState2 = 0), (this.limitImpulse2 = 0)),
                (this.limitVelocity2 = this.lowerLimit2 - w))
              : w < this.lowerLimit2
              ? (-1 != this.limitState2 &&
                  ((this.limitState2 = -1), (this.limitImpulse2 = 0)),
                (this.limitVelocity2 = this.lowerLimit2 - w))
              : w > this.upperLimit2
              ? (1 != this.limitState2 &&
                  ((this.limitState2 = 1), (this.limitImpulse2 = 0)),
                (this.limitVelocity2 = this.upperLimit2 - w))
              : ((this.limitState2 = 2),
                (this.limitImpulse2 = 0),
                (this.limitVelocity2 = 0)),
            y ||
              (this.limitVelocity2 > 0.02
                ? (this.limitVelocity2 -= 0.02)
                : this.limitVelocity2 < -0.02
                ? (this.limitVelocity2 += 0.02)
                : (this.limitVelocity2 = 0)))
          : ((this.limitState2 = 2), (this.limitImpulse2 = 0));
        var S = this.limitMotor3.angle;
        if (
          (b
            ? (this.lowerLimit3 == this.upperLimit3
                ? (0 != this.limitState3 &&
                    ((this.limitState3 = 0), (this.limitImpulse3 = 0)),
                  (this.limitVelocity3 = this.lowerLimit3 - S))
                : S < this.lowerLimit3
                ? (-1 != this.limitState3 &&
                    ((this.limitState3 = -1), (this.limitImpulse3 = 0)),
                  (this.limitVelocity3 = this.lowerLimit3 - S))
                : S > this.upperLimit3
                ? (1 != this.limitState3 &&
                    ((this.limitState3 = 1), (this.limitImpulse3 = 0)),
                  (this.limitVelocity3 = this.upperLimit3 - S))
                : ((this.limitState3 = 2),
                  (this.limitImpulse3 = 0),
                  (this.limitVelocity3 = 0)),
              g ||
                (this.limitVelocity3 > 0.02
                  ? (this.limitVelocity3 -= 0.02)
                  : this.limitVelocity3 < -0.02
                  ? (this.limitVelocity3 += 0.02)
                  : (this.limitVelocity3 = 0)))
            : ((this.limitState3 = 2), (this.limitImpulse3 = 0)),
          this.enableMotor1 && (0 != this.limitState1 || p)
            ? (this.maxMotorImpulse1 = this.maxMotorForce1 * t)
            : ((this.motorImpulse1 = 0), (this.maxMotorImpulse1 = 0)),
          this.enableMotor2 && (0 != this.limitState2 || y)
            ? (this.maxMotorImpulse2 = this.maxMotorForce2 * t)
            : ((this.motorImpulse2 = 0), (this.maxMotorImpulse2 = 0)),
          this.enableMotor3 && (0 != this.limitState3 || g)
            ? (this.maxMotorImpulse3 = this.maxMotorForce3 * t)
            : ((this.motorImpulse3 = 0), (this.maxMotorImpulse3 = 0)),
          (this.a1x1 =
            this.ax1 * this.i1e00 +
            this.ay1 * this.i1e01 +
            this.az1 * this.i1e02),
          (this.a1y1 =
            this.ax1 * this.i1e10 +
            this.ay1 * this.i1e11 +
            this.az1 * this.i1e12),
          (this.a1z1 =
            this.ax1 * this.i1e20 +
            this.ay1 * this.i1e21 +
            this.az1 * this.i1e22),
          (this.a2x1 =
            this.ax1 * this.i2e00 +
            this.ay1 * this.i2e01 +
            this.az1 * this.i2e02),
          (this.a2y1 =
            this.ax1 * this.i2e10 +
            this.ay1 * this.i2e11 +
            this.az1 * this.i2e12),
          (this.a2z1 =
            this.ax1 * this.i2e20 +
            this.ay1 * this.i2e21 +
            this.az1 * this.i2e22),
          (this.a1x2 =
            this.ax2 * this.i1e00 +
            this.ay2 * this.i1e01 +
            this.az2 * this.i1e02),
          (this.a1y2 =
            this.ax2 * this.i1e10 +
            this.ay2 * this.i1e11 +
            this.az2 * this.i1e12),
          (this.a1z2 =
            this.ax2 * this.i1e20 +
            this.ay2 * this.i1e21 +
            this.az2 * this.i1e22),
          (this.a2x2 =
            this.ax2 * this.i2e00 +
            this.ay2 * this.i2e01 +
            this.az2 * this.i2e02),
          (this.a2y2 =
            this.ax2 * this.i2e10 +
            this.ay2 * this.i2e11 +
            this.az2 * this.i2e12),
          (this.a2z2 =
            this.ax2 * this.i2e20 +
            this.ay2 * this.i2e21 +
            this.az2 * this.i2e22),
          (this.a1x3 =
            this.ax3 * this.i1e00 +
            this.ay3 * this.i1e01 +
            this.az3 * this.i1e02),
          (this.a1y3 =
            this.ax3 * this.i1e10 +
            this.ay3 * this.i1e11 +
            this.az3 * this.i1e12),
          (this.a1z3 =
            this.ax3 * this.i1e20 +
            this.ay3 * this.i1e21 +
            this.az3 * this.i1e22),
          (this.a2x3 =
            this.ax3 * this.i2e00 +
            this.ay3 * this.i2e01 +
            this.az3 * this.i2e02),
          (this.a2y3 =
            this.ax3 * this.i2e10 +
            this.ay3 * this.i2e11 +
            this.az3 * this.i2e12),
          (this.a2z3 =
            this.ax3 * this.i2e20 +
            this.ay3 * this.i2e21 +
            this.az3 * this.i2e22),
          (this.k00 =
            this.ax1 * (this.a1x1 + this.a2x1) +
            this.ay1 * (this.a1y1 + this.a2y1) +
            this.az1 * (this.a1z1 + this.a2z1)),
          (this.k01 =
            this.ax1 * (this.a1x2 + this.a2x2) +
            this.ay1 * (this.a1y2 + this.a2y2) +
            this.az1 * (this.a1z2 + this.a2z2)),
          (this.k02 =
            this.ax1 * (this.a1x3 + this.a2x3) +
            this.ay1 * (this.a1y3 + this.a2y3) +
            this.az1 * (this.a1z3 + this.a2z3)),
          (this.k10 =
            this.ax2 * (this.a1x1 + this.a2x1) +
            this.ay2 * (this.a1y1 + this.a2y1) +
            this.az2 * (this.a1z1 + this.a2z1)),
          (this.k11 =
            this.ax2 * (this.a1x2 + this.a2x2) +
            this.ay2 * (this.a1y2 + this.a2y2) +
            this.az2 * (this.a1z2 + this.a2z2)),
          (this.k12 =
            this.ax2 * (this.a1x3 + this.a2x3) +
            this.ay2 * (this.a1y3 + this.a2y3) +
            this.az2 * (this.a1z3 + this.a2z3)),
          (this.k20 =
            this.ax3 * (this.a1x1 + this.a2x1) +
            this.ay3 * (this.a1y1 + this.a2y1) +
            this.az3 * (this.a1z1 + this.a2z1)),
          (this.k21 =
            this.ax3 * (this.a1x2 + this.a2x2) +
            this.ay3 * (this.a1y2 + this.a2y2) +
            this.az3 * (this.a1z2 + this.a2z2)),
          (this.k22 =
            this.ax3 * (this.a1x3 + this.a2x3) +
            this.ay3 * (this.a1y3 + this.a2y3) +
            this.az3 * (this.a1z3 + this.a2z3)),
          (this.kv00 = this.k00),
          (this.kv11 = this.k11),
          (this.kv22 = this.k22),
          (this.dv00 = 1 / this.kv00),
          (this.dv11 = 1 / this.kv11),
          (this.dv22 = 1 / this.kv22),
          p && 2 != this.limitState1)
        ) {
          var C = 6.2831853 * u,
            E = C * C * t,
            z = e / (E + 2 * this.limitMotor1.dampingRatio * C);
          (this.cfm1 = this.kv00 * z), (this.limitVelocity1 *= E * z);
        } else (this.cfm1 = 0), (this.limitVelocity1 *= 0.05 * e);
        y && 2 != this.limitState2
          ? ((z =
              e /
              ((E = (C = 6.2831853 * m) * C * t) +
                2 * this.limitMotor2.dampingRatio * C)),
            (this.cfm2 = this.kv11 * z),
            (this.limitVelocity2 *= E * z))
          : ((this.cfm2 = 0), (this.limitVelocity2 *= 0.05 * e)),
          g && 2 != this.limitState3
            ? ((z =
                e /
                ((E = (C = 6.2831853 * f) * C * t) +
                  2 * this.limitMotor3.dampingRatio * C)),
              (this.cfm3 = this.kv22 * z),
              (this.limitVelocity3 *= E * z))
            : ((this.cfm3 = 0), (this.limitVelocity3 *= 0.05 * e)),
          (this.k00 += this.cfm1),
          (this.k11 += this.cfm2),
          (this.k22 += this.cfm3);
        var A =
          1 /
          (this.k00 * (this.k11 * this.k22 - this.k21 * this.k12) +
            this.k10 * (this.k21 * this.k02 - this.k01 * this.k22) +
            this.k20 * (this.k01 * this.k12 - this.k11 * this.k02));
        (this.d00 = (this.k11 * this.k22 - this.k12 * this.k21) * A),
          (this.d01 = (this.k02 * this.k21 - this.k01 * this.k22) * A),
          (this.d02 = (this.k01 * this.k12 - this.k02 * this.k11) * A),
          (this.d10 = (this.k12 * this.k20 - this.k10 * this.k22) * A),
          (this.d11 = (this.k00 * this.k22 - this.k02 * this.k20) * A),
          (this.d12 = (this.k02 * this.k10 - this.k00 * this.k12) * A),
          (this.d20 = (this.k10 * this.k21 - this.k11 * this.k20) * A),
          (this.d21 = (this.k01 * this.k20 - this.k00 * this.k21) * A),
          (this.d22 = (this.k00 * this.k11 - this.k01 * this.k10) * A),
          (this.limitImpulse1 *= 0.95),
          (this.motorImpulse1 *= 0.95),
          (this.limitImpulse2 *= 0.95),
          (this.motorImpulse2 *= 0.95),
          (this.limitImpulse3 *= 0.95),
          (this.motorImpulse3 *= 0.95);
        var k = this.limitImpulse1 + this.motorImpulse1,
          B = this.limitImpulse2 + this.motorImpulse2,
          V = this.limitImpulse3 + this.motorImpulse3;
        (this.a1.x += k * this.a1x1 + B * this.a1x2 + V * this.a1x3),
          (this.a1.y += k * this.a1y1 + B * this.a1y2 + V * this.a1y3),
          (this.a1.z += k * this.a1z1 + B * this.a1z2 + V * this.a1z3),
          (this.a2.x -= k * this.a2x1 + B * this.a2x2 + V * this.a2x3),
          (this.a2.y -= k * this.a2y1 + B * this.a2y2 + V * this.a2y3),
          (this.a2.z -= k * this.a2z1 + B * this.a2z2 + V * this.a2z3);
      },
      solve_: function () {
        var t = this.a2.x - this.a1.x,
          e = this.a2.y - this.a1.y,
          a = this.a2.z - this.a1.z;
        this.limitVelocity3 = 30;
        var n =
            t * this.ax1 + e * this.ay1 + a * this.az1 - this.limitVelocity1,
          u = t * this.ax2 + e * this.ay2 + a * this.az2 - this.limitVelocity2,
          m = t * this.ax3 + e * this.ay3 + a * this.az3 - this.limitVelocity3,
          f = n * this.d00 + u * this.d01 + m * this.d02,
          p = n * this.d10 + u * this.d11 + m * this.d12,
          y = n * this.d20 + u * this.d21 + m * this.d22;
        (this.limitImpulse1 += f),
          (this.limitImpulse2 += p),
          (this.limitImpulse3 += y),
          (this.a1.x += f * this.a1x1 + p * this.a1x2 + y * this.a1x3),
          (this.a1.y += f * this.a1y1 + p * this.a1y2 + y * this.a1y3),
          (this.a1.z += f * this.a1z1 + p * this.a1z2 + y * this.a1z3),
          (this.a2.x -= f * this.a2x1 + p * this.a2x2 + y * this.a2x3),
          (this.a2.y -= f * this.a2y1 + p * this.a2y2 + y * this.a2y3),
          (this.a2.z -= f * this.a2z1 + p * this.a2z2 + y * this.a2z3);
      },
      solve: function () {
        var t = this.a2.x - this.a1.x,
          e = this.a2.y - this.a1.y,
          a = this.a2.z - this.a1.z,
          n = t * this.ax1 + e * this.ay1 + a * this.az1,
          u = t * this.ax2 + e * this.ay2 + a * this.az2,
          m = t * this.ax3 + e * this.ay3 + a * this.az3,
          f = this.motorImpulse1,
          p = this.motorImpulse2,
          y = this.motorImpulse3,
          g = 0,
          _ = 0,
          x = 0;
        this.enableMotor1 &&
          ((g = (n - this.motorSpeed1) * this.dv00),
          (this.motorImpulse1 += g),
          this.motorImpulse1 > this.maxMotorImpulse1
            ? (this.motorImpulse1 = this.maxMotorImpulse1)
            : this.motorImpulse1 < -this.maxMotorImpulse1 &&
              (this.motorImpulse1 = -this.maxMotorImpulse1),
          (g = this.motorImpulse1 - f)),
          this.enableMotor2 &&
            ((_ = (u - this.motorSpeed2) * this.dv11),
            (this.motorImpulse2 += _),
            this.motorImpulse2 > this.maxMotorImpulse2
              ? (this.motorImpulse2 = this.maxMotorImpulse2)
              : this.motorImpulse2 < -this.maxMotorImpulse2 &&
                (this.motorImpulse2 = -this.maxMotorImpulse2),
            (_ = this.motorImpulse2 - p)),
          this.enableMotor3 &&
            ((x = (m - this.motorSpeed3) * this.dv22),
            (this.motorImpulse3 += x),
            this.motorImpulse3 > this.maxMotorImpulse3
              ? (this.motorImpulse3 = this.maxMotorImpulse3)
              : this.motorImpulse3 < -this.maxMotorImpulse3 &&
                (this.motorImpulse3 = -this.maxMotorImpulse3),
            (x = this.motorImpulse3 - y)),
          (n += g * this.kv00 + _ * this.k01 + x * this.k02),
          (u += g * this.k10 + _ * this.kv11 + x * this.k12),
          (m += g * this.k20 + _ * this.k21 + x * this.kv22),
          (n -= this.limitVelocity1 + this.limitImpulse1 * this.cfm1),
          (u -= this.limitVelocity2 + this.limitImpulse2 * this.cfm2),
          (m -= this.limitVelocity3 + this.limitImpulse3 * this.cfm3);
        var b = this.limitImpulse1,
          v = this.limitImpulse2,
          w = this.limitImpulse3,
          S = n * this.d00 + u * this.d01 + m * this.d02,
          C = n * this.d10 + u * this.d11 + m * this.d12,
          E = n * this.d20 + u * this.d21 + m * this.d22;
        (this.limitImpulse1 += S),
          (this.limitImpulse2 += C),
          (this.limitImpulse3 += E);
        var z,
          A = 0;
        switch (
          ((2 == this.limitState1 ||
            this.limitImpulse1 * this.limitState1 < 0) &&
            ((u += (S = -b) * this.k10), (m += S * this.k20), (A |= 1)),
          (2 == this.limitState2 ||
            this.limitImpulse2 * this.limitState2 < 0) &&
            ((n += (C = -v) * this.k01), (m += C * this.k21), (A |= 2)),
          (2 == this.limitState3 ||
            this.limitImpulse3 * this.limitState3 < 0) &&
            ((n += (E = -w) * this.k02), (u += E * this.k12), (A |= 4)),
          A)
        ) {
          case 1:
            (z = 1 / (this.k11 * this.k22 - this.k12 * this.k21)),
              (C = (this.k22 * u + -this.k12 * m) * z),
              (E = (-this.k21 * u + this.k11 * m) * z);
            break;
          case 2:
            (z = 1 / (this.k00 * this.k22 - this.k02 * this.k20)),
              (S = (this.k22 * n + -this.k02 * m) * z),
              (E = (-this.k20 * n + this.k00 * m) * z);
            break;
          case 3:
            E = m / this.k22;
            break;
          case 4:
            (z = 1 / (this.k00 * this.k11 - this.k01 * this.k10)),
              (S = (this.k11 * n + -this.k01 * u) * z),
              (C = (-this.k10 * n + this.k00 * u) * z);
            break;
          case 5:
            C = u / this.k11;
            break;
          case 6:
            S = n / this.k00;
        }
        (this.limitImpulse1 = S + b),
          (this.limitImpulse2 = C + v),
          (this.limitImpulse3 = E + w);
        var k = g + S,
          B = _ + C,
          V = x + E;
        (this.a1.x += k * this.a1x1 + B * this.a1x2 + V * this.a1x3),
          (this.a1.y += k * this.a1y1 + B * this.a1y2 + V * this.a1y3),
          (this.a1.z += k * this.a1z1 + B * this.a1z2 + V * this.a1z3),
          (this.a2.x -= k * this.a2x1 + B * this.a2x2 + V * this.a2x3),
          (this.a2.y -= k * this.a2y1 + B * this.a2y2 + V * this.a2y3),
          (this.a2.z -= k * this.a2z1 + B * this.a2z2 + V * this.a2z3),
          (t = this.a2.x - this.a1.x),
          (e = this.a2.y - this.a1.y),
          (a = this.a2.z - this.a1.z),
          (u = t * this.ax2 + e * this.ay2 + a * this.az2);
      },
    }),
    (HingeJoint.prototype = Object.assign(Object.create(Joint.prototype), {
      constructor: HingeJoint,
      preSolve: function (t, e) {
        this.updateAnchorPoints(),
          this.ax1.copy(this.localAxis1).applyMatrix3(this.body1.rotation, !0),
          this.ax2.copy(this.localAxis2).applyMatrix3(this.body2.rotation, !0),
          this.an1.copy(this.localAngle1).applyMatrix3(this.body1.rotation, !0),
          this.an2.copy(this.localAngle2).applyMatrix3(this.body2.rotation, !0),
          this.nor
            .set(
              this.ax1.x * this.body2.inverseMass +
                this.ax2.x * this.body1.inverseMass,
              this.ax1.y * this.body2.inverseMass +
                this.ax2.y * this.body1.inverseMass,
              this.ax1.z * this.body2.inverseMass +
                this.ax2.z * this.body1.inverseMass
            )
            .normalize(),
          this.tan.tangent(this.nor).normalize(),
          this.bin.crossVectors(this.nor, this.tan);
        var a = m.acosClamp(m.dotVectors(this.an1, this.an2));
        this.tmp.crossVectors(this.an1, this.an2),
          m.dotVectors(this.nor, this.tmp) < 0
            ? (this.limitMotor.angle = -a)
            : (this.limitMotor.angle = a),
          this.tmp.crossVectors(this.ax1, this.ax2),
          (this.r3.limitMotor2.angle = m.dotVectors(this.tan, this.tmp)),
          (this.r3.limitMotor3.angle = m.dotVectors(this.bin, this.tmp)),
          this.r3.preSolve(t, e),
          this.lc.preSolve(t, e);
      },
      solve: function () {
        this.r3.solve(), this.lc.solve();
      },
      postSolve: function () {},
    })),
    (BallAndSocketJoint.prototype = Object.assign(
      Object.create(Joint.prototype),
      {
        constructor: BallAndSocketJoint,
        preSolve: function (t, e) {
          this.updateAnchorPoints(), this.lc.preSolve(t, e);
        },
        solve: function () {
          this.lc.solve();
        },
        postSolve: function () {},
      }
    )),
    Object.assign(TranslationalConstraint.prototype, {
      TranslationalConstraint: !0,
      preSolve: function (t, e) {
        (this.ax = this.limitMotor.axis.x),
          (this.ay = this.limitMotor.axis.y),
          (this.az = this.limitMotor.axis.z),
          (this.lowerLimit = this.limitMotor.lowerLimit),
          (this.upperLimit = this.limitMotor.upperLimit),
          (this.motorSpeed = this.limitMotor.motorSpeed),
          (this.maxMotorForce = this.limitMotor.maxMotorForce),
          (this.enableMotor = this.maxMotorForce > 0),
          (this.m1 = this.b1.inverseMass),
          (this.m2 = this.b2.inverseMass);
        var a = this.i1.elements,
          n = this.i2.elements;
        (this.i1e00 = a[0]),
          (this.i1e01 = a[1]),
          (this.i1e02 = a[2]),
          (this.i1e10 = a[3]),
          (this.i1e11 = a[4]),
          (this.i1e12 = a[5]),
          (this.i1e20 = a[6]),
          (this.i1e21 = a[7]),
          (this.i1e22 = a[8]),
          (this.i2e00 = n[0]),
          (this.i2e01 = n[1]),
          (this.i2e02 = n[2]),
          (this.i2e10 = n[3]),
          (this.i2e11 = n[4]),
          (this.i2e12 = n[5]),
          (this.i2e20 = n[6]),
          (this.i2e21 = n[7]),
          (this.i2e22 = n[8]);
        var u = this.p2.x - this.p1.x,
          m = this.p2.y - this.p1.y,
          f = this.p2.z - this.p1.z,
          p = u * this.ax + m * this.ay + f * this.az,
          y = this.limitMotor.frequency,
          g = y > 0;
        ((g && p > 20) || p < -20) && (g = !1),
          this.lowerLimit <= this.upperLimit
            ? (this.lowerLimit == this.upperLimit
                ? (0 != this.limitState &&
                    ((this.limitState = 0), (this.limitImpulse = 0)),
                  (this.limitVelocity = this.lowerLimit - p),
                  g || (p = this.lowerLimit))
                : p < this.lowerLimit
                ? (-1 != this.limitState &&
                    ((this.limitState = -1), (this.limitImpulse = 0)),
                  (this.limitVelocity = this.lowerLimit - p),
                  g || (p = this.lowerLimit))
                : p > this.upperLimit
                ? (1 != this.limitState &&
                    ((this.limitState = 1), (this.limitImpulse = 0)),
                  (this.limitVelocity = this.upperLimit - p),
                  g || (p = this.upperLimit))
                : ((this.limitState = 2),
                  (this.limitImpulse = 0),
                  (this.limitVelocity = 0)),
              g ||
                (this.limitVelocity > 0.005
                  ? (this.limitVelocity -= 0.005)
                  : this.limitVelocity < -0.005
                  ? (this.limitVelocity += 0.005)
                  : (this.limitVelocity = 0)))
            : ((this.limitState = 2), (this.limitImpulse = 0)),
          this.enableMotor && (0 != this.limitState || g)
            ? (this.maxMotorImpulse = this.maxMotorForce * t)
            : ((this.motorImpulse = 0), (this.maxMotorImpulse = 0));
        var _ = p * this.ax,
          x = p * this.ay,
          b = p * this.az,
          v = this.m1 / (this.m1 + this.m2),
          w = 1 - v;
        if (
          ((this.r1x = this.r1.x + _ * v),
          (this.r1y = this.r1.y + x * v),
          (this.r1z = this.r1.z + b * v),
          (this.r2x = this.r2.x - _ * w),
          (this.r2y = this.r2.y - x * w),
          (this.r2z = this.r2.z - b * w),
          (this.t1x = this.r1y * this.az - this.r1z * this.ay),
          (this.t1y = this.r1z * this.ax - this.r1x * this.az),
          (this.t1z = this.r1x * this.ay - this.r1y * this.ax),
          (this.t2x = this.r2y * this.az - this.r2z * this.ay),
          (this.t2y = this.r2z * this.ax - this.r2x * this.az),
          (this.t2z = this.r2x * this.ay - this.r2y * this.ax),
          (this.l1x = this.ax * this.m1),
          (this.l1y = this.ay * this.m1),
          (this.l1z = this.az * this.m1),
          (this.l2x = this.ax * this.m2),
          (this.l2y = this.ay * this.m2),
          (this.l2z = this.az * this.m2),
          (this.a1x =
            this.t1x * this.i1e00 +
            this.t1y * this.i1e01 +
            this.t1z * this.i1e02),
          (this.a1y =
            this.t1x * this.i1e10 +
            this.t1y * this.i1e11 +
            this.t1z * this.i1e12),
          (this.a1z =
            this.t1x * this.i1e20 +
            this.t1y * this.i1e21 +
            this.t1z * this.i1e22),
          (this.a2x =
            this.t2x * this.i2e00 +
            this.t2y * this.i2e01 +
            this.t2z * this.i2e02),
          (this.a2y =
            this.t2x * this.i2e10 +
            this.t2y * this.i2e11 +
            this.t2z * this.i2e12),
          (this.a2z =
            this.t2x * this.i2e20 +
            this.t2y * this.i2e21 +
            this.t2z * this.i2e22),
          (this.motorDenom =
            this.m1 +
            this.m2 +
            this.ax *
              (this.a1y * this.r1z -
                this.a1z * this.r1y +
                this.a2y * this.r2z -
                this.a2z * this.r2y) +
            this.ay *
              (this.a1z * this.r1x -
                this.a1x * this.r1z +
                this.a2z * this.r2x -
                this.a2x * this.r2z) +
            this.az *
              (this.a1x * this.r1y -
                this.a1y * this.r1x +
                this.a2x * this.r2y -
                this.a2y * this.r2x)),
          (this.invMotorDenom = 1 / this.motorDenom),
          g && 2 != this.limitState)
        ) {
          var S = 6.2831853 * y,
            C = S * S * t,
            E = e / (C + 2 * this.limitMotor.dampingRatio * S);
          (this.cfm = this.motorDenom * E), (this.limitVelocity *= C * E);
        } else (this.cfm = 0), (this.limitVelocity *= 0.05 * e);
        this.invDenom = 1 / (this.motorDenom + this.cfm);
        var z = this.limitImpulse + this.motorImpulse;
        (this.l1.x += z * this.l1x),
          (this.l1.y += z * this.l1y),
          (this.l1.z += z * this.l1z),
          (this.a1.x += z * this.a1x),
          (this.a1.y += z * this.a1y),
          (this.a1.z += z * this.a1z),
          (this.l2.x -= z * this.l2x),
          (this.l2.y -= z * this.l2y),
          (this.l2.z -= z * this.l2z),
          (this.a2.x -= z * this.a2x),
          (this.a2.y -= z * this.a2y),
          (this.a2.z -= z * this.a2z);
      },
      solve: function () {
        var t,
          e,
          a =
            this.ax * (this.l2.x - this.l1.x) +
            this.ay * (this.l2.y - this.l1.y) +
            this.az * (this.l2.z - this.l1.z) +
            this.t2x * this.a2.x -
            this.t1x * this.a1.x +
            this.t2y * this.a2.y -
            this.t1y * this.a1.y +
            this.t2z * this.a2.z -
            this.t1z * this.a1.z;
        if (this.enableMotor) {
          t = (a - this.motorSpeed) * this.invMotorDenom;
          var n = this.motorImpulse;
          (this.motorImpulse += t),
            this.motorImpulse > this.maxMotorImpulse
              ? (this.motorImpulse = this.maxMotorImpulse)
              : this.motorImpulse < -this.maxMotorImpulse &&
                (this.motorImpulse = -this.maxMotorImpulse),
            (a -= (t = this.motorImpulse - n) * this.motorDenom);
        } else t = 0;
        if (2 != this.limitState) {
          e =
            (a - this.limitVelocity - this.limitImpulse * this.cfm) *
            this.invDenom;
          var u = this.limitImpulse;
          (this.limitImpulse += e),
            this.limitImpulse * this.limitState < 0 && (this.limitImpulse = 0),
            (e = this.limitImpulse - u);
        } else e = 0;
        var m = e + t;
        (this.l1.x += m * this.l1x),
          (this.l1.y += m * this.l1y),
          (this.l1.z += m * this.l1z),
          (this.a1.x += m * this.a1x),
          (this.a1.y += m * this.a1y),
          (this.a1.z += m * this.a1z),
          (this.l2.x -= m * this.l2x),
          (this.l2.y -= m * this.l2y),
          (this.l2.z -= m * this.l2z),
          (this.a2.x -= m * this.a2x),
          (this.a2.y -= m * this.a2y),
          (this.a2.z -= m * this.a2z);
      },
    }),
    (DistanceJoint.prototype = Object.assign(Object.create(Joint.prototype), {
      constructor: DistanceJoint,
      preSolve: function (t, e) {
        this.updateAnchorPoints(),
          this.nor.sub(this.anchorPoint2, this.anchorPoint1).normalize(),
          this.t.preSolve(t, e);
      },
      solve: function () {
        this.t.solve();
      },
      postSolve: function () {},
    })),
    Object.assign(AngularConstraint.prototype, {
      AngularConstraint: !0,
      preSolve: function (t, e) {
        var a, n, u;
        (this.ii1 = this.i1.clone()),
          (this.ii2 = this.i2.clone()),
          (a =
            1 /
            ((u = new Mat33().add(this.ii1, this.ii2).elements)[0] *
              (u[4] * u[8] - u[7] * u[5]) +
              u[3] * (u[7] * u[2] - u[1] * u[8]) +
              u[6] * (u[1] * u[5] - u[4] * u[2]))),
          (this.dd = new Mat33()
            .set(
              u[4] * u[8] - u[5] * u[7],
              u[2] * u[7] - u[1] * u[8],
              u[1] * u[5] - u[2] * u[4],
              u[5] * u[6] - u[3] * u[8],
              u[0] * u[8] - u[2] * u[6],
              u[2] * u[3] - u[0] * u[5],
              u[3] * u[7] - u[4] * u[6],
              u[1] * u[6] - u[0] * u[7],
              u[0] * u[4] - u[1] * u[3]
            )
            .multiplyScalar(a)),
          this.relativeOrientation
            .invert(this.b1.orientation)
            .multiply(this.targetOrientation)
            .multiply(this.b2.orientation),
          (a = 2 * this.relativeOrientation.w),
          this.vel.copy(this.relativeOrientation).multiplyScalar(a),
          (n = this.vel.length()) > 0.02
            ? ((n = ((0.02 - n) / n) * e * 0.05), this.vel.multiplyScalar(n))
            : this.vel.set(0, 0, 0),
          this.rn1.copy(this.imp).applyMatrix3(this.ii1, !0),
          this.rn2.copy(this.imp).applyMatrix3(this.ii2, !0),
          this.a1.add(this.rn1),
          this.a2.sub(this.rn2);
      },
      solve: function () {
        var t = this.a2.clone().sub(this.a1).sub(this.vel);
        this.rn0.copy(t).applyMatrix3(this.dd, !0),
          this.rn1.copy(this.rn0).applyMatrix3(this.ii1, !0),
          this.rn2.copy(this.rn0).applyMatrix3(this.ii2, !0),
          this.imp.add(this.rn0),
          this.a1.add(this.rn1),
          this.a2.sub(this.rn2);
      },
    }),
    Object.assign(Translational3Constraint.prototype, {
      Translational3Constraint: !0,
      preSolve: function (t, e) {
        (this.ax1 = this.limitMotor1.axis.x),
          (this.ay1 = this.limitMotor1.axis.y),
          (this.az1 = this.limitMotor1.axis.z),
          (this.ax2 = this.limitMotor2.axis.x),
          (this.ay2 = this.limitMotor2.axis.y),
          (this.az2 = this.limitMotor2.axis.z),
          (this.ax3 = this.limitMotor3.axis.x),
          (this.ay3 = this.limitMotor3.axis.y),
          (this.az3 = this.limitMotor3.axis.z),
          (this.lowerLimit1 = this.limitMotor1.lowerLimit),
          (this.upperLimit1 = this.limitMotor1.upperLimit),
          (this.motorSpeed1 = this.limitMotor1.motorSpeed),
          (this.maxMotorForce1 = this.limitMotor1.maxMotorForce),
          (this.enableMotor1 = this.maxMotorForce1 > 0),
          (this.lowerLimit2 = this.limitMotor2.lowerLimit),
          (this.upperLimit2 = this.limitMotor2.upperLimit),
          (this.motorSpeed2 = this.limitMotor2.motorSpeed),
          (this.maxMotorForce2 = this.limitMotor2.maxMotorForce),
          (this.enableMotor2 = this.maxMotorForce2 > 0),
          (this.lowerLimit3 = this.limitMotor3.lowerLimit),
          (this.upperLimit3 = this.limitMotor3.upperLimit),
          (this.motorSpeed3 = this.limitMotor3.motorSpeed),
          (this.maxMotorForce3 = this.limitMotor3.maxMotorForce),
          (this.enableMotor3 = this.maxMotorForce3 > 0),
          (this.m1 = this.b1.inverseMass),
          (this.m2 = this.b2.inverseMass);
        var a = this.i1.elements,
          n = this.i2.elements;
        (this.i1e00 = a[0]),
          (this.i1e01 = a[1]),
          (this.i1e02 = a[2]),
          (this.i1e10 = a[3]),
          (this.i1e11 = a[4]),
          (this.i1e12 = a[5]),
          (this.i1e20 = a[6]),
          (this.i1e21 = a[7]),
          (this.i1e22 = a[8]),
          (this.i2e00 = n[0]),
          (this.i2e01 = n[1]),
          (this.i2e02 = n[2]),
          (this.i2e10 = n[3]),
          (this.i2e11 = n[4]),
          (this.i2e12 = n[5]),
          (this.i2e20 = n[6]),
          (this.i2e21 = n[7]),
          (this.i2e22 = n[8]);
        var u = this.p2.x - this.p1.x,
          m = this.p2.y - this.p1.y,
          f = this.p2.z - this.p1.z,
          p = u * this.ax1 + m * this.ay1 + f * this.az1,
          y = u * this.ax2 + m * this.ay2 + f * this.az2,
          g = u * this.ax3 + m * this.ay3 + f * this.az3,
          _ = this.limitMotor1.frequency,
          x = this.limitMotor2.frequency,
          b = this.limitMotor3.frequency,
          v = _ > 0,
          w = x > 0,
          S = b > 0,
          C = this.lowerLimit1 <= this.upperLimit1,
          E = this.lowerLimit2 <= this.upperLimit2,
          z = this.lowerLimit3 <= this.upperLimit3;
        ((v && p > 20) || p < -20) && (v = !1),
          ((w && y > 20) || y < -20) && (w = !1),
          ((S && g > 20) || g < -20) && (S = !1),
          C
            ? (this.lowerLimit1 == this.upperLimit1
                ? (0 != this.limitState1 &&
                    ((this.limitState1 = 0), (this.limitImpulse1 = 0)),
                  (this.limitVelocity1 = this.lowerLimit1 - p),
                  v || (p = this.lowerLimit1))
                : p < this.lowerLimit1
                ? (-1 != this.limitState1 &&
                    ((this.limitState1 = -1), (this.limitImpulse1 = 0)),
                  (this.limitVelocity1 = this.lowerLimit1 - p),
                  v || (p = this.lowerLimit1))
                : p > this.upperLimit1
                ? (1 != this.limitState1 &&
                    ((this.limitState1 = 1), (this.limitImpulse1 = 0)),
                  (this.limitVelocity1 = this.upperLimit1 - p),
                  v || (p = this.upperLimit1))
                : ((this.limitState1 = 2),
                  (this.limitImpulse1 = 0),
                  (this.limitVelocity1 = 0)),
              v ||
                (this.limitVelocity1 > 0.005
                  ? (this.limitVelocity1 -= 0.005)
                  : this.limitVelocity1 < -0.005
                  ? (this.limitVelocity1 += 0.005)
                  : (this.limitVelocity1 = 0)))
            : ((this.limitState1 = 2), (this.limitImpulse1 = 0)),
          E
            ? (this.lowerLimit2 == this.upperLimit2
                ? (0 != this.limitState2 &&
                    ((this.limitState2 = 0), (this.limitImpulse2 = 0)),
                  (this.limitVelocity2 = this.lowerLimit2 - y),
                  w || (y = this.lowerLimit2))
                : y < this.lowerLimit2
                ? (-1 != this.limitState2 &&
                    ((this.limitState2 = -1), (this.limitImpulse2 = 0)),
                  (this.limitVelocity2 = this.lowerLimit2 - y),
                  w || (y = this.lowerLimit2))
                : y > this.upperLimit2
                ? (1 != this.limitState2 &&
                    ((this.limitState2 = 1), (this.limitImpulse2 = 0)),
                  (this.limitVelocity2 = this.upperLimit2 - y),
                  w || (y = this.upperLimit2))
                : ((this.limitState2 = 2),
                  (this.limitImpulse2 = 0),
                  (this.limitVelocity2 = 0)),
              w ||
                (this.limitVelocity2 > 0.005
                  ? (this.limitVelocity2 -= 0.005)
                  : this.limitVelocity2 < -0.005
                  ? (this.limitVelocity2 += 0.005)
                  : (this.limitVelocity2 = 0)))
            : ((this.limitState2 = 2), (this.limitImpulse2 = 0)),
          z
            ? (this.lowerLimit3 == this.upperLimit3
                ? (0 != this.limitState3 &&
                    ((this.limitState3 = 0), (this.limitImpulse3 = 0)),
                  (this.limitVelocity3 = this.lowerLimit3 - g),
                  S || (g = this.lowerLimit3))
                : g < this.lowerLimit3
                ? (-1 != this.limitState3 &&
                    ((this.limitState3 = -1), (this.limitImpulse3 = 0)),
                  (this.limitVelocity3 = this.lowerLimit3 - g),
                  S || (g = this.lowerLimit3))
                : g > this.upperLimit3
                ? (1 != this.limitState3 &&
                    ((this.limitState3 = 1), (this.limitImpulse3 = 0)),
                  (this.limitVelocity3 = this.upperLimit3 - g),
                  S || (g = this.upperLimit3))
                : ((this.limitState3 = 2),
                  (this.limitImpulse3 = 0),
                  (this.limitVelocity3 = 0)),
              S ||
                (this.limitVelocity3 > 0.005
                  ? (this.limitVelocity3 -= 0.005)
                  : this.limitVelocity3 < -0.005
                  ? (this.limitVelocity3 += 0.005)
                  : (this.limitVelocity3 = 0)))
            : ((this.limitState3 = 2), (this.limitImpulse3 = 0)),
          this.enableMotor1 && (0 != this.limitState1 || v)
            ? (this.maxMotorImpulse1 = this.maxMotorForce1 * t)
            : ((this.motorImpulse1 = 0), (this.maxMotorImpulse1 = 0)),
          this.enableMotor2 && (0 != this.limitState2 || w)
            ? (this.maxMotorImpulse2 = this.maxMotorForce2 * t)
            : ((this.motorImpulse2 = 0), (this.maxMotorImpulse2 = 0)),
          this.enableMotor3 && (0 != this.limitState3 || S)
            ? (this.maxMotorImpulse3 = this.maxMotorForce3 * t)
            : ((this.motorImpulse3 = 0), (this.maxMotorImpulse3 = 0));
        var A = p * this.ax1 + y * this.ax2 + g * this.ax2,
          k = p * this.ay1 + y * this.ay2 + g * this.ay2,
          B = p * this.az1 + y * this.az2 + g * this.az2,
          V = this.m2 / (this.m1 + this.m2);
        this.weight >= 0 && (V = this.weight);
        var R = 1 - V;
        (this.r1x = this.r1.x + A * V),
          (this.r1y = this.r1.y + k * V),
          (this.r1z = this.r1.z + B * V),
          (this.r2x = this.r2.x - A * R),
          (this.r2y = this.r2.y - k * R),
          (this.r2z = this.r2.z - B * R),
          (this.t1x1 = this.r1y * this.az1 - this.r1z * this.ay1),
          (this.t1y1 = this.r1z * this.ax1 - this.r1x * this.az1),
          (this.t1z1 = this.r1x * this.ay1 - this.r1y * this.ax1),
          (this.t2x1 = this.r2y * this.az1 - this.r2z * this.ay1),
          (this.t2y1 = this.r2z * this.ax1 - this.r2x * this.az1),
          (this.t2z1 = this.r2x * this.ay1 - this.r2y * this.ax1),
          (this.l1x1 = this.ax1 * this.m1),
          (this.l1y1 = this.ay1 * this.m1),
          (this.l1z1 = this.az1 * this.m1),
          (this.l2x1 = this.ax1 * this.m2),
          (this.l2y1 = this.ay1 * this.m2),
          (this.l2z1 = this.az1 * this.m2),
          (this.a1x1 =
            this.t1x1 * this.i1e00 +
            this.t1y1 * this.i1e01 +
            this.t1z1 * this.i1e02),
          (this.a1y1 =
            this.t1x1 * this.i1e10 +
            this.t1y1 * this.i1e11 +
            this.t1z1 * this.i1e12),
          (this.a1z1 =
            this.t1x1 * this.i1e20 +
            this.t1y1 * this.i1e21 +
            this.t1z1 * this.i1e22),
          (this.a2x1 =
            this.t2x1 * this.i2e00 +
            this.t2y1 * this.i2e01 +
            this.t2z1 * this.i2e02),
          (this.a2y1 =
            this.t2x1 * this.i2e10 +
            this.t2y1 * this.i2e11 +
            this.t2z1 * this.i2e12),
          (this.a2z1 =
            this.t2x1 * this.i2e20 +
            this.t2y1 * this.i2e21 +
            this.t2z1 * this.i2e22),
          (this.t1x2 = this.r1y * this.az2 - this.r1z * this.ay2),
          (this.t1y2 = this.r1z * this.ax2 - this.r1x * this.az2),
          (this.t1z2 = this.r1x * this.ay2 - this.r1y * this.ax2),
          (this.t2x2 = this.r2y * this.az2 - this.r2z * this.ay2),
          (this.t2y2 = this.r2z * this.ax2 - this.r2x * this.az2),
          (this.t2z2 = this.r2x * this.ay2 - this.r2y * this.ax2),
          (this.l1x2 = this.ax2 * this.m1),
          (this.l1y2 = this.ay2 * this.m1),
          (this.l1z2 = this.az2 * this.m1),
          (this.l2x2 = this.ax2 * this.m2),
          (this.l2y2 = this.ay2 * this.m2),
          (this.l2z2 = this.az2 * this.m2),
          (this.a1x2 =
            this.t1x2 * this.i1e00 +
            this.t1y2 * this.i1e01 +
            this.t1z2 * this.i1e02),
          (this.a1y2 =
            this.t1x2 * this.i1e10 +
            this.t1y2 * this.i1e11 +
            this.t1z2 * this.i1e12),
          (this.a1z2 =
            this.t1x2 * this.i1e20 +
            this.t1y2 * this.i1e21 +
            this.t1z2 * this.i1e22),
          (this.a2x2 =
            this.t2x2 * this.i2e00 +
            this.t2y2 * this.i2e01 +
            this.t2z2 * this.i2e02),
          (this.a2y2 =
            this.t2x2 * this.i2e10 +
            this.t2y2 * this.i2e11 +
            this.t2z2 * this.i2e12),
          (this.a2z2 =
            this.t2x2 * this.i2e20 +
            this.t2y2 * this.i2e21 +
            this.t2z2 * this.i2e22),
          (this.t1x3 = this.r1y * this.az3 - this.r1z * this.ay3),
          (this.t1y3 = this.r1z * this.ax3 - this.r1x * this.az3),
          (this.t1z3 = this.r1x * this.ay3 - this.r1y * this.ax3),
          (this.t2x3 = this.r2y * this.az3 - this.r2z * this.ay3),
          (this.t2y3 = this.r2z * this.ax3 - this.r2x * this.az3),
          (this.t2z3 = this.r2x * this.ay3 - this.r2y * this.ax3),
          (this.l1x3 = this.ax3 * this.m1),
          (this.l1y3 = this.ay3 * this.m1),
          (this.l1z3 = this.az3 * this.m1),
          (this.l2x3 = this.ax3 * this.m2),
          (this.l2y3 = this.ay3 * this.m2),
          (this.l2z3 = this.az3 * this.m2),
          (this.a1x3 =
            this.t1x3 * this.i1e00 +
            this.t1y3 * this.i1e01 +
            this.t1z3 * this.i1e02),
          (this.a1y3 =
            this.t1x3 * this.i1e10 +
            this.t1y3 * this.i1e11 +
            this.t1z3 * this.i1e12),
          (this.a1z3 =
            this.t1x3 * this.i1e20 +
            this.t1y3 * this.i1e21 +
            this.t1z3 * this.i1e22),
          (this.a2x3 =
            this.t2x3 * this.i2e00 +
            this.t2y3 * this.i2e01 +
            this.t2z3 * this.i2e02),
          (this.a2y3 =
            this.t2x3 * this.i2e10 +
            this.t2y3 * this.i2e11 +
            this.t2z3 * this.i2e12),
          (this.a2z3 =
            this.t2x3 * this.i2e20 +
            this.t2y3 * this.i2e21 +
            this.t2z3 * this.i2e22);
        var J = this.m1 + this.m2;
        if (
          ((this.k00 =
            (this.ax1 * this.ax1 + this.ay1 * this.ay1 + this.az1 * this.az1) *
            J),
          (this.k01 =
            (this.ax1 * this.ax2 + this.ay1 * this.ay2 + this.az1 * this.az2) *
            J),
          (this.k02 =
            (this.ax1 * this.ax3 + this.ay1 * this.ay3 + this.az1 * this.az3) *
            J),
          (this.k10 =
            (this.ax2 * this.ax1 + this.ay2 * this.ay1 + this.az2 * this.az1) *
            J),
          (this.k11 =
            (this.ax2 * this.ax2 + this.ay2 * this.ay2 + this.az2 * this.az2) *
            J),
          (this.k12 =
            (this.ax2 * this.ax3 + this.ay2 * this.ay3 + this.az2 * this.az3) *
            J),
          (this.k20 =
            (this.ax3 * this.ax1 + this.ay3 * this.ay1 + this.az3 * this.az1) *
            J),
          (this.k21 =
            (this.ax3 * this.ax2 + this.ay3 * this.ay2 + this.az3 * this.az2) *
            J),
          (this.k22 =
            (this.ax3 * this.ax3 + this.ay3 * this.ay3 + this.az3 * this.az3) *
            J),
          (this.k00 +=
            this.t1x1 * this.a1x1 +
            this.t1y1 * this.a1y1 +
            this.t1z1 * this.a1z1),
          (this.k01 +=
            this.t1x1 * this.a1x2 +
            this.t1y1 * this.a1y2 +
            this.t1z1 * this.a1z2),
          (this.k02 +=
            this.t1x1 * this.a1x3 +
            this.t1y1 * this.a1y3 +
            this.t1z1 * this.a1z3),
          (this.k10 +=
            this.t1x2 * this.a1x1 +
            this.t1y2 * this.a1y1 +
            this.t1z2 * this.a1z1),
          (this.k11 +=
            this.t1x2 * this.a1x2 +
            this.t1y2 * this.a1y2 +
            this.t1z2 * this.a1z2),
          (this.k12 +=
            this.t1x2 * this.a1x3 +
            this.t1y2 * this.a1y3 +
            this.t1z2 * this.a1z3),
          (this.k20 +=
            this.t1x3 * this.a1x1 +
            this.t1y3 * this.a1y1 +
            this.t1z3 * this.a1z1),
          (this.k21 +=
            this.t1x3 * this.a1x2 +
            this.t1y3 * this.a1y2 +
            this.t1z3 * this.a1z2),
          (this.k22 +=
            this.t1x3 * this.a1x3 +
            this.t1y3 * this.a1y3 +
            this.t1z3 * this.a1z3),
          (this.k00 +=
            this.t2x1 * this.a2x1 +
            this.t2y1 * this.a2y1 +
            this.t2z1 * this.a2z1),
          (this.k01 +=
            this.t2x1 * this.a2x2 +
            this.t2y1 * this.a2y2 +
            this.t2z1 * this.a2z2),
          (this.k02 +=
            this.t2x1 * this.a2x3 +
            this.t2y1 * this.a2y3 +
            this.t2z1 * this.a2z3),
          (this.k10 +=
            this.t2x2 * this.a2x1 +
            this.t2y2 * this.a2y1 +
            this.t2z2 * this.a2z1),
          (this.k11 +=
            this.t2x2 * this.a2x2 +
            this.t2y2 * this.a2y2 +
            this.t2z2 * this.a2z2),
          (this.k12 +=
            this.t2x2 * this.a2x3 +
            this.t2y2 * this.a2y3 +
            this.t2z2 * this.a2z3),
          (this.k20 +=
            this.t2x3 * this.a2x1 +
            this.t2y3 * this.a2y1 +
            this.t2z3 * this.a2z1),
          (this.k21 +=
            this.t2x3 * this.a2x2 +
            this.t2y3 * this.a2y2 +
            this.t2z3 * this.a2z2),
          (this.k22 +=
            this.t2x3 * this.a2x3 +
            this.t2y3 * this.a2y3 +
            this.t2z3 * this.a2z3),
          (this.kv00 = this.k00),
          (this.kv11 = this.k11),
          (this.kv22 = this.k22),
          (this.dv00 = 1 / this.kv00),
          (this.dv11 = 1 / this.kv11),
          (this.dv22 = 1 / this.kv22),
          v && 2 != this.limitState1)
        ) {
          var Z = 6.2831853 * _,
            $ = Z * Z * t,
            tt = e / ($ + 2 * this.limitMotor1.dampingRatio * Z);
          (this.cfm1 = this.kv00 * tt), (this.limitVelocity1 *= $ * tt);
        } else (this.cfm1 = 0), (this.limitVelocity1 *= 0.05 * e);
        w && 2 != this.limitState2
          ? ((tt =
              e /
              (($ = (Z = 6.2831853 * x) * Z * t) +
                2 * this.limitMotor2.dampingRatio * Z)),
            (this.cfm2 = this.kv11 * tt),
            (this.limitVelocity2 *= $ * tt))
          : ((this.cfm2 = 0), (this.limitVelocity2 *= 0.05 * e)),
          S && 2 != this.limitState3
            ? ((tt =
                e /
                (($ = (Z = 6.2831853 * b) * Z * t) +
                  2 * this.limitMotor3.dampingRatio * Z)),
              (this.cfm3 = this.kv22 * tt),
              (this.limitVelocity3 *= $ * tt))
            : ((this.cfm3 = 0), (this.limitVelocity3 *= 0.05 * e)),
          (this.k00 += this.cfm1),
          (this.k11 += this.cfm2),
          (this.k22 += this.cfm3);
        var et =
          1 /
          (this.k00 * (this.k11 * this.k22 - this.k21 * this.k12) +
            this.k10 * (this.k21 * this.k02 - this.k01 * this.k22) +
            this.k20 * (this.k01 * this.k12 - this.k11 * this.k02));
        (this.d00 = (this.k11 * this.k22 - this.k12 * this.k21) * et),
          (this.d01 = (this.k02 * this.k21 - this.k01 * this.k22) * et),
          (this.d02 = (this.k01 * this.k12 - this.k02 * this.k11) * et),
          (this.d10 = (this.k12 * this.k20 - this.k10 * this.k22) * et),
          (this.d11 = (this.k00 * this.k22 - this.k02 * this.k20) * et),
          (this.d12 = (this.k02 * this.k10 - this.k00 * this.k12) * et),
          (this.d20 = (this.k10 * this.k21 - this.k11 * this.k20) * et),
          (this.d21 = (this.k01 * this.k20 - this.k00 * this.k21) * et),
          (this.d22 = (this.k00 * this.k11 - this.k01 * this.k10) * et);
        var it = this.limitImpulse1 + this.motorImpulse1,
          st = this.limitImpulse2 + this.motorImpulse2,
          at = this.limitImpulse3 + this.motorImpulse3;
        (this.l1.x += it * this.l1x1 + st * this.l1x2 + at * this.l1x3),
          (this.l1.y += it * this.l1y1 + st * this.l1y2 + at * this.l1y3),
          (this.l1.z += it * this.l1z1 + st * this.l1z2 + at * this.l1z3),
          (this.a1.x += it * this.a1x1 + st * this.a1x2 + at * this.a1x3),
          (this.a1.y += it * this.a1y1 + st * this.a1y2 + at * this.a1y3),
          (this.a1.z += it * this.a1z1 + st * this.a1z2 + at * this.a1z3),
          (this.l2.x -= it * this.l2x1 + st * this.l2x2 + at * this.l2x3),
          (this.l2.y -= it * this.l2y1 + st * this.l2y2 + at * this.l2y3),
          (this.l2.z -= it * this.l2z1 + st * this.l2z2 + at * this.l2z3),
          (this.a2.x -= it * this.a2x1 + st * this.a2x2 + at * this.a2x3),
          (this.a2.y -= it * this.a2y1 + st * this.a2y2 + at * this.a2y3),
          (this.a2.z -= it * this.a2z1 + st * this.a2z2 + at * this.a2z3);
      },
      solve: function () {
        var t =
            this.l2.x -
            this.l1.x +
            this.a2.y * this.r2z -
            this.a2.z * this.r2y -
            this.a1.y * this.r1z +
            this.a1.z * this.r1y,
          e =
            this.l2.y -
            this.l1.y +
            this.a2.z * this.r2x -
            this.a2.x * this.r2z -
            this.a1.z * this.r1x +
            this.a1.x * this.r1z,
          a =
            this.l2.z -
            this.l1.z +
            this.a2.x * this.r2y -
            this.a2.y * this.r2x -
            this.a1.x * this.r1y +
            this.a1.y * this.r1x,
          n = t * this.ax1 + e * this.ay1 + a * this.az1,
          u = t * this.ax2 + e * this.ay2 + a * this.az2,
          m = t * this.ax3 + e * this.ay3 + a * this.az3,
          f = this.motorImpulse1,
          p = this.motorImpulse2,
          y = this.motorImpulse3,
          g = 0,
          _ = 0,
          x = 0;
        this.enableMotor1 &&
          ((g = (n - this.motorSpeed1) * this.dv00),
          (this.motorImpulse1 += g),
          this.motorImpulse1 > this.maxMotorImpulse1
            ? (this.motorImpulse1 = this.maxMotorImpulse1)
            : this.motorImpulse1 < -this.maxMotorImpulse1 &&
              (this.motorImpulse1 = -this.maxMotorImpulse1),
          (g = this.motorImpulse1 - f)),
          this.enableMotor2 &&
            ((_ = (u - this.motorSpeed2) * this.dv11),
            (this.motorImpulse2 += _),
            this.motorImpulse2 > this.maxMotorImpulse2
              ? (this.motorImpulse2 = this.maxMotorImpulse2)
              : this.motorImpulse2 < -this.maxMotorImpulse2 &&
                (this.motorImpulse2 = -this.maxMotorImpulse2),
            (_ = this.motorImpulse2 - p)),
          this.enableMotor3 &&
            ((x = (m - this.motorSpeed3) * this.dv22),
            (this.motorImpulse3 += x),
            this.motorImpulse3 > this.maxMotorImpulse3
              ? (this.motorImpulse3 = this.maxMotorImpulse3)
              : this.motorImpulse3 < -this.maxMotorImpulse3 &&
                (this.motorImpulse3 = -this.maxMotorImpulse3),
            (x = this.motorImpulse3 - y)),
          (n += g * this.kv00 + _ * this.k01 + x * this.k02),
          (u += g * this.k10 + _ * this.kv11 + x * this.k12),
          (m += g * this.k20 + _ * this.k21 + x * this.kv22),
          (n -= this.limitVelocity1 + this.limitImpulse1 * this.cfm1),
          (u -= this.limitVelocity2 + this.limitImpulse2 * this.cfm2),
          (m -= this.limitVelocity3 + this.limitImpulse3 * this.cfm3);
        var b = this.limitImpulse1,
          v = this.limitImpulse2,
          w = this.limitImpulse3,
          S = n * this.d00 + u * this.d01 + m * this.d02,
          C = n * this.d10 + u * this.d11 + m * this.d12,
          E = n * this.d20 + u * this.d21 + m * this.d22;
        (this.limitImpulse1 += S),
          (this.limitImpulse2 += C),
          (this.limitImpulse3 += E);
        var z,
          A = 0;
        switch (
          ((2 == this.limitState1 ||
            this.limitImpulse1 * this.limitState1 < 0) &&
            ((u += (S = -b) * this.k10), (m += S * this.k20), (A |= 1)),
          (2 == this.limitState2 ||
            this.limitImpulse2 * this.limitState2 < 0) &&
            ((n += (C = -v) * this.k01), (m += C * this.k21), (A |= 2)),
          (2 == this.limitState3 ||
            this.limitImpulse3 * this.limitState3 < 0) &&
            ((n += (E = -w) * this.k02), (u += E * this.k12), (A |= 4)),
          A)
        ) {
          case 1:
            (z = 1 / (this.k11 * this.k22 - this.k12 * this.k21)),
              (C = (this.k22 * u + -this.k12 * m) * z),
              (E = (-this.k21 * u + this.k11 * m) * z);
            break;
          case 2:
            (z = 1 / (this.k00 * this.k22 - this.k02 * this.k20)),
              (S = (this.k22 * n + -this.k02 * m) * z),
              (E = (-this.k20 * n + this.k00 * m) * z);
            break;
          case 3:
            E = m / this.k22;
            break;
          case 4:
            (z = 1 / (this.k00 * this.k11 - this.k01 * this.k10)),
              (S = (this.k11 * n + -this.k01 * u) * z),
              (C = (-this.k10 * n + this.k00 * u) * z);
            break;
          case 5:
            C = u / this.k11;
            break;
          case 6:
            S = n / this.k00;
        }
        (this.limitImpulse1 = b + S),
          (this.limitImpulse2 = v + C),
          (this.limitImpulse3 = w + E);
        var k = g + S,
          B = _ + C,
          V = x + E;
        (this.l1.x += k * this.l1x1 + B * this.l1x2 + V * this.l1x3),
          (this.l1.y += k * this.l1y1 + B * this.l1y2 + V * this.l1y3),
          (this.l1.z += k * this.l1z1 + B * this.l1z2 + V * this.l1z3),
          (this.a1.x += k * this.a1x1 + B * this.a1x2 + V * this.a1x3),
          (this.a1.y += k * this.a1y1 + B * this.a1y2 + V * this.a1y3),
          (this.a1.z += k * this.a1z1 + B * this.a1z2 + V * this.a1z3),
          (this.l2.x -= k * this.l2x1 + B * this.l2x2 + V * this.l2x3),
          (this.l2.y -= k * this.l2y1 + B * this.l2y2 + V * this.l2y3),
          (this.l2.z -= k * this.l2z1 + B * this.l2z2 + V * this.l2z3),
          (this.a2.x -= k * this.a2x1 + B * this.a2x2 + V * this.a2x3),
          (this.a2.y -= k * this.a2y1 + B * this.a2y2 + V * this.a2y3),
          (this.a2.z -= k * this.a2z1 + B * this.a2z2 + V * this.a2z3);
      },
    }),
    (PrismaticJoint.prototype = Object.assign(Object.create(Joint.prototype), {
      constructor: PrismaticJoint,
      preSolve: function (t, e) {
        this.updateAnchorPoints(),
          this.ax1.copy(this.localAxis1).applyMatrix3(this.body1.rotation, !0),
          this.ax2.copy(this.localAxis2).applyMatrix3(this.body2.rotation, !0),
          this.nor
            .set(
              this.ax1.x * this.body2.inverseMass +
                this.ax2.x * this.body1.inverseMass,
              this.ax1.y * this.body2.inverseMass +
                this.ax2.y * this.body1.inverseMass,
              this.ax1.z * this.body2.inverseMass +
                this.ax2.z * this.body1.inverseMass
            )
            .normalize(),
          this.tan.tangent(this.nor).normalize(),
          this.bin.crossVectors(this.nor, this.tan),
          this.ac.preSolve(t, e),
          this.t3.preSolve(t, e);
      },
      solve: function () {
        this.ac.solve(), this.t3.solve();
      },
      postSolve: function () {},
    })),
    (SliderJoint.prototype = Object.assign(Object.create(Joint.prototype), {
      constructor: SliderJoint,
      preSolve: function (t, e) {
        this.updateAnchorPoints(),
          this.ax1.copy(this.localAxis1).applyMatrix3(this.body1.rotation, !0),
          this.an1.copy(this.localAngle1).applyMatrix3(this.body1.rotation, !0),
          this.ax2.copy(this.localAxis2).applyMatrix3(this.body2.rotation, !0),
          this.an2.copy(this.localAngle2).applyMatrix3(this.body2.rotation, !0),
          this.nor
            .set(
              this.ax1.x * this.body2.inverseMass +
                this.ax2.x * this.body1.inverseMass,
              this.ax1.y * this.body2.inverseMass +
                this.ax2.y * this.body1.inverseMass,
              this.ax1.z * this.body2.inverseMass +
                this.ax2.z * this.body1.inverseMass
            )
            .normalize(),
          this.tan.tangent(this.nor).normalize(),
          this.bin.crossVectors(this.nor, this.tan),
          this.tmp.crossVectors(this.an1, this.an2);
        var a = m.acosClamp(m.dotVectors(this.an1, this.an2));
        m.dotVectors(this.nor, this.tmp) < 0
          ? (this.rotationalLimitMotor.angle = -a)
          : (this.rotationalLimitMotor.angle = a),
          this.tmp.crossVectors(this.ax1, this.ax2),
          (this.r3.limitMotor2.angle = m.dotVectors(this.tan, this.tmp)),
          (this.r3.limitMotor3.angle = m.dotVectors(this.bin, this.tmp)),
          this.r3.preSolve(t, e),
          this.t3.preSolve(t, e);
      },
      solve: function () {
        this.r3.solve(), this.t3.solve();
      },
      postSolve: function () {},
    })),
    (WheelJoint.prototype = Object.assign(Object.create(Joint.prototype), {
      constructor: WheelJoint,
      preSolve: function (t, e) {
        this.updateAnchorPoints(),
          this.ax1.copy(this.localAxis1).applyMatrix3(this.body1.rotation, !0),
          this.an1.copy(this.localAngle1).applyMatrix3(this.body1.rotation, !0),
          this.ax2.copy(this.localAxis2).applyMatrix3(this.body2.rotation, !0),
          this.an2.copy(this.localAngle2).applyMatrix3(this.body2.rotation, !0),
          (this.r3.limitMotor1.angle = m.dotVectors(this.ax1, this.ax2));
        var a = m.dotVectors(this.an1, this.ax2);
        m.dotVectors(this.ax1, this.tmp.crossVectors(this.an1, this.ax2)) < 0
          ? (this.rotationalLimitMotor1.angle = -a)
          : (this.rotationalLimitMotor1.angle = a),
          (a = m.dotVectors(this.an2, this.ax1)),
          m.dotVectors(this.ax2, this.tmp.crossVectors(this.an2, this.ax1)) < 0
            ? (this.rotationalLimitMotor2.angle = -a)
            : (this.rotationalLimitMotor2.angle = a),
          this.nor.crossVectors(this.ax1, this.ax2).normalize(),
          this.tan.crossVectors(this.nor, this.ax2).normalize(),
          this.bin.crossVectors(this.nor, this.ax1).normalize(),
          this.r3.preSolve(t, e),
          this.t3.preSolve(t, e);
      },
      solve: function () {
        this.r3.solve(), this.t3.solve();
      },
      postSolve: function () {},
    })),
    (ContactManifold.prototype = {
      constructor: ContactManifold,
      reset: function (t, e) {
        (this.body1 = t.parent), (this.body2 = e.parent), (this.numPoints = 0);
      },
      addPointVec: function (t, e, a, n) {
        var u = this.points[this.numPoints++];
        u.position.copy(t),
          u.localPoint1
            .sub(t, this.body1.position)
            .applyMatrix3(this.body1.rotation),
          u.localPoint2
            .sub(t, this.body2.position)
            .applyMatrix3(this.body2.rotation),
          u.normal.copy(e),
          n && u.normal.negate(),
          (u.normalImpulse = 0),
          (u.penetration = a),
          (u.warmStarted = !1);
      },
      addPoint: function (t, e, a, n, u, m, f, p) {
        var y = this.points[this.numPoints++];
        y.position.set(t, e, a),
          y.localPoint1
            .sub(y.position, this.body1.position)
            .applyMatrix3(this.body1.rotation),
          y.localPoint2
            .sub(y.position, this.body2.position)
            .applyMatrix3(this.body2.rotation),
          (y.normalImpulse = 0),
          y.normal.set(n, u, m),
          p && y.normal.negate(),
          (y.penetration = f),
          (y.warmStarted = !1);
      },
    }),
    (ContactConstraint.prototype = Object.assign(
      Object.create(Constraint.prototype),
      {
        constructor: ContactConstraint,
        attach: function () {
          (this.p1 = this.body1.position),
            (this.p2 = this.body2.position),
            (this.lv1 = this.body1.linearVelocity),
            (this.av1 = this.body1.angularVelocity),
            (this.lv2 = this.body2.linearVelocity),
            (this.av2 = this.body2.angularVelocity),
            (this.i1 = this.body1.inverseInertia),
            (this.i2 = this.body2.inverseInertia);
        },
        detach: function () {
          (this.p1 = null),
            (this.p2 = null),
            (this.lv1 = null),
            (this.lv2 = null),
            (this.av1 = null),
            (this.av2 = null),
            (this.i1 = null),
            (this.i2 = null);
        },
        preSolve: function (t, e) {
          (this.m1 = this.body1.inverseMass),
            (this.m2 = this.body2.inverseMass);
          var a = this.m1 + this.m2;
          this.num = this.manifold.numPoints;
          for (var n, u, f, p, y, g, _, x = this.cs, b = 0; b < this.num; b++)
            (n = this.ps[b]),
              this.tmpP1.sub(n.position, this.p1),
              this.tmpP2.sub(n.position, this.p2),
              this.tmpC1.crossVectors(this.av1, this.tmpP1),
              this.tmpC2.crossVectors(this.av2, this.tmpP2),
              (x.norImp = n.normalImpulse),
              (x.tanImp = n.tangentImpulse),
              (x.binImp = n.binormalImpulse),
              x.nor.copy(n.normal),
              this.tmp.set(
                this.lv2.x + this.tmpC2.x - (this.lv1.x + this.tmpC1.x),
                this.lv2.y + this.tmpC2.y - (this.lv1.y + this.tmpC1.y),
                this.lv2.z + this.tmpC2.z - (this.lv1.z + this.tmpC1.z)
              ),
              (u = m.dotVectors(x.nor, this.tmp)),
              x.tan.set(
                this.tmp.x - u * x.nor.x,
                this.tmp.y - u * x.nor.y,
                this.tmp.z - u * x.nor.z
              ),
              m.dotVectors(x.tan, x.tan) <= 0.04 && x.tan.tangent(x.nor),
              x.tan.normalize(),
              x.bin.crossVectors(x.nor, x.tan),
              x.norU1.scale(x.nor, this.m1),
              x.norU2.scale(x.nor, this.m2),
              x.tanU1.scale(x.tan, this.m1),
              x.tanU2.scale(x.tan, this.m2),
              x.binU1.scale(x.bin, this.m1),
              x.binU2.scale(x.bin, this.m2),
              x.norT1.crossVectors(this.tmpP1, x.nor),
              x.tanT1.crossVectors(this.tmpP1, x.tan),
              x.binT1.crossVectors(this.tmpP1, x.bin),
              x.norT2.crossVectors(this.tmpP2, x.nor),
              x.tanT2.crossVectors(this.tmpP2, x.tan),
              x.binT2.crossVectors(this.tmpP2, x.bin),
              (g = this.i1),
              (_ = this.i2),
              x.norTU1.copy(x.norT1).applyMatrix3(g, !0),
              x.tanTU1.copy(x.tanT1).applyMatrix3(g, !0),
              x.binTU1.copy(x.binT1).applyMatrix3(g, !0),
              x.norTU2.copy(x.norT2).applyMatrix3(_, !0),
              x.tanTU2.copy(x.tanT2).applyMatrix3(_, !0),
              x.binTU2.copy(x.binT2).applyMatrix3(_, !0),
              this.tmpC1.crossVectors(x.norTU1, this.tmpP1),
              this.tmpC2.crossVectors(x.norTU2, this.tmpP2),
              this.tmp.add(this.tmpC1, this.tmpC2),
              (x.norDen = 1 / (a + m.dotVectors(x.nor, this.tmp))),
              this.tmpC1.crossVectors(x.tanTU1, this.tmpP1),
              this.tmpC2.crossVectors(x.tanTU2, this.tmpP2),
              this.tmp.add(this.tmpC1, this.tmpC2),
              (x.tanDen = 1 / (a + m.dotVectors(x.tan, this.tmp))),
              this.tmpC1.crossVectors(x.binTU1, this.tmpP1),
              this.tmpC2.crossVectors(x.binTU2, this.tmpP2),
              this.tmp.add(this.tmpC1, this.tmpC2),
              (x.binDen = 1 / (a + m.dotVectors(x.bin, this.tmp))),
              n.warmStarted
                ? ((f = n.normalImpulse),
                  this.lv1.addScaledVector(x.norU1, f),
                  this.av1.addScaledVector(x.norTU1, f),
                  this.lv2.subScaledVector(x.norU2, f),
                  this.av2.subScaledVector(x.norTU2, f),
                  (x.norImp = f),
                  (x.tanImp = 0),
                  (x.binImp = 0),
                  (u = 0))
                : ((x.norImp = 0), (x.tanImp = 0), (x.binImp = 0)),
              u > -1 && (u = 0),
              (p = this.restitution * -u) <
                (y = -(n.penetration + 0.005) * e * 0.05) && (p = y),
              (x.norTar = p),
              (x.last = b == this.num - 1),
              (x = x.next);
        },
        solve: function () {
          var t, e, a, n, u, f, p, y, g;
          this.tmplv1.copy(this.lv1),
            this.tmplv2.copy(this.lv2),
            this.tmpav1.copy(this.av1),
            this.tmpav2.copy(this.av2);
          for (
            var _ = this.cs;
            (u = _.norImp),
              (f = _.tanImp),
              (p = _.binImp),
              (y = -u * this.friction),
              this.tmp.sub(this.tmplv2, this.tmplv1),
              (t = f),
              (a = p),
              (g =
                (f += e =
                  (m.dotVectors(this.tmp, _.tan) +
                    m.dotVectors(this.tmpav2, _.tanT2) -
                    m.dotVectors(this.tmpav1, _.tanT1)) *
                  _.tanDen) *
                  f +
                (p += n =
                  (m.dotVectors(this.tmp, _.bin) +
                    m.dotVectors(this.tmpav2, _.binT2) -
                    m.dotVectors(this.tmpav1, _.binT1)) *
                  _.binDen) *
                  p) >
                y * y && ((f *= g = y / m.sqrt(g)), (p *= g)),
              (e = f - t),
              (n = p - a),
              this.tmp.set(
                _.tanU1.x * e + _.binU1.x * n,
                _.tanU1.y * e + _.binU1.y * n,
                _.tanU1.z * e + _.binU1.z * n
              ),
              this.tmplv1.addEqual(this.tmp),
              this.tmp.set(
                _.tanTU1.x * e + _.binTU1.x * n,
                _.tanTU1.y * e + _.binTU1.y * n,
                _.tanTU1.z * e + _.binTU1.z * n
              ),
              this.tmpav1.addEqual(this.tmp),
              this.tmp.set(
                _.tanU2.x * e + _.binU2.x * n,
                _.tanU2.y * e + _.binU2.y * n,
                _.tanU2.z * e + _.binU2.z * n
              ),
              this.tmplv2.subEqual(this.tmp),
              this.tmp.set(
                _.tanTU2.x * e + _.binTU2.x * n,
                _.tanTU2.y * e + _.binTU2.y * n,
                _.tanTU2.z * e + _.binTU2.z * n
              ),
              this.tmpav2.subEqual(this.tmp),
              this.tmp.sub(this.tmplv2, this.tmplv1),
              (t = u),
              (u += e =
                (m.dotVectors(this.tmp, _.nor) +
                  m.dotVectors(this.tmpav2, _.norT2) -
                  m.dotVectors(this.tmpav1, _.norT1) -
                  _.norTar) *
                _.norDen) > 0 && (u = 0),
              (e = u - t),
              this.tmplv1.addScaledVector(_.norU1, e),
              this.tmpav1.addScaledVector(_.norTU1, e),
              this.tmplv2.subScaledVector(_.norU2, e),
              this.tmpav2.subScaledVector(_.norTU2, e),
              (_.norImp = u),
              (_.tanImp = f),
              (_.binImp = p),
              !_.last;

          )
            _ = _.next;
          this.lv1.copy(this.tmplv1),
            this.lv2.copy(this.tmplv2),
            this.av1.copy(this.tmpav1),
            this.av2.copy(this.tmpav2);
        },
        postSolve: function () {
          for (var t, e = this.cs, a = this.num; a--; )
            (t = this.ps[a]).normal.copy(e.nor),
              t.tangent.copy(e.tan),
              t.binormal.copy(e.bin),
              (t.normalImpulse = e.norImp),
              (t.tangentImpulse = e.tanImp),
              (t.binormalImpulse = e.binImp),
              (t.normalDenominator = e.norDen),
              (t.tangentDenominator = e.tanDen),
              (t.binormalDenominator = e.binDen),
              (e = e.next);
        },
      }
    )),
    Object.assign(Contact.prototype, {
      Contact: !0,
      mixRestitution: function (t, e) {
        return m.sqrt(t * e);
      },
      mixFriction: function (t, e) {
        return m.sqrt(t * e);
      },
      fixPenetration: function (t, e) {
        var a = t.parent,
          n = e.parent,
          u = this.world.detectors[2][2];
        if (((this.manifold.numPoints = 0), t.fixed || e.fixed)) {
          var m = t;
          if (2 != m.type) {
            var f = m.tempAABB.elements;
            (m = new Box(
              {
                collidesWith: m.collidesWith,
                belongsTo: m.belongsTo,
                restitution: m.restitution,
                friction: m.friction,
                density: m.density,
                relativeRotation: m.relativeRotation,
                relativePosition: m.relativePosition,
              },
              f[3] - f[0],
              f[4] - f[1],
              f[5] - f[2]
            )).position.copy(t.position),
              m.rotation.copy(t.rotation),
              m.updateProxy();
          }
          var p = e;
          if (2 != p.type) {
            f = p.tempAABB.elements;
            (p = new Box(
              {
                collidesWith: p.collidesWith,
                belongsTo: p.belongsTo,
                restitution: p.restitution,
                friction: p.friction,
                density: p.density,
                relativeRotation: p.relativeRotation,
                relativePosition: p.relativePosition,
              },
              f[3] - f[0],
              f[4] - f[1],
              f[5] - f[2]
            )).position.copy(e.position),
              p.rotation.copy(e.rotation),
              p.updateProxy();
          }
          u.detectCollision(m, p, this.manifold);
        }
        var y = this.manifold.numPoints;
        if (y > 0) {
          var g = new Vec3();
          g.copy(this.points[0].position);
          for (var _ = 1; _ < y; ) g.add(this.points[_].position), _++;
          g.scaleEqual(1 / y);
          var x = this.points[0].position;
          t.fixed &&
            (x.copy(a.position).sub(g).normalize(0.01),
            a.position.copy(g).add(x),
            a.syncShapes(),
            (t.fixed = !1)),
            e.fixed &&
              (x.copy(n.position).sub(g).normalize(0.01),
              n.position.copy(g).add(x),
              n.syncShapes(),
              (e.fixed = !1));
        }
      },
      updateManifold: function () {
        (this.constraint.restitution = this.mixRestitution(
          this.shape1.restitution,
          this.shape2.restitution
        )),
          (this.constraint.friction = this.mixFriction(
            this.shape1.friction,
            this.shape2.friction
          ));
        for (var t = this.manifold.numPoints, e = t; e--; ) {
          var a = this.buffer[e],
            n = this.points[e];
          (a.lp1X = n.localPoint1.x),
            (a.lp1Y = n.localPoint1.y),
            (a.lp1Z = n.localPoint1.z),
            (a.lp2X = n.localPoint2.x),
            (a.lp2Y = n.localPoint2.y),
            (a.lp2Z = n.localPoint2.z),
            (a.impulse = n.normalImpulse);
        }
        this.fixPenetration(this.shape1, this.shape2),
          (this.manifold.numPoints = 0),
          this.detector.detectCollision(
            this.shape1,
            this.shape2,
            this.manifold
          );
        var u = this.manifold.numPoints;
        if (0 == u)
          return (
            (this.touching = !1), (this.close = !1), void (this.dist = m.INF)
          );
        for (
          (this.touching || this.dist < 0.001) && (this.close = !0),
            this.touching = !0,
            e = u;
          e--;

        ) {
          for (
            var f = (n = this.points[e]).localPoint1.x,
              p = n.localPoint1.y,
              y = n.localPoint1.z,
              g = n.localPoint2.x,
              _ = n.localPoint2.y,
              x = n.localPoint2.z,
              b = -1,
              v = 4e-4,
              w = t;
            w--;

          ) {
            var S = (a = this.buffer[w]).lp1X - f,
              C = a.lp1Y - p,
              E = a.lp1Z - y,
              z = S * S + C * C + E * E,
              A =
                (S = a.lp2X - g) * S +
                (C = a.lp2Y - _) * C +
                (E = a.lp2Z - x) * E;
            z < A ? z < v && ((v = z), (b = w)) : A < v && ((v = A), (b = w)),
              v < this.dist && (this.dist = v);
          }
          if (-1 != b) {
            var k = this.buffer[b];
            (this.buffer[b] = this.buffer[--t]),
              (this.buffer[t] = k),
              (n.normalImpulse = k.impulse),
              (n.warmStarted = !0);
          } else (n.normalImpulse = 0), (n.warmStarted = !1);
        }
        var B = this.shape1.parent,
          V = this.shape2.parent;
        B.event_cb && B.event_cb(V, this.shape2, this, this.shape1),
          V.event_cb && V.event_cb(B, this.shape1, this, this.shape2);
      },
      attach: function (t, e) {
        (this.shape1 = t),
          (this.shape2 = e),
          (this.body1 = t.parent),
          (this.body2 = e.parent),
          (this.manifold.body1 = this.body1),
          (this.manifold.body2 = this.body2),
          (this.constraint.body1 = this.body1),
          (this.constraint.body2 = this.body2),
          this.constraint.attach(),
          (this.s1Link.shape = e),
          (this.s1Link.body = this.body2),
          (this.s2Link.shape = t),
          (this.s2Link.body = this.body1),
          null != t.contactLink
            ? ((this.s1Link.next = t.contactLink).prev = this.s1Link)
            : (this.s1Link.next = null),
          (t.contactLink = this.s1Link),
          t.numContacts++,
          null != e.contactLink
            ? ((this.s2Link.next = e.contactLink).prev = this.s2Link)
            : (this.s2Link.next = null),
          (e.contactLink = this.s2Link),
          e.numContacts++,
          (this.b1Link.shape = e),
          (this.b1Link.body = this.body2),
          (this.b2Link.shape = t),
          (this.b2Link.body = this.body1),
          null != this.body1.contactLink
            ? ((this.b1Link.next = this.body1.contactLink).prev = this.b1Link)
            : (this.b1Link.next = null),
          (this.body1.contactLink = this.b1Link),
          this.body1.numContacts++,
          null != this.body2.contactLink
            ? ((this.b2Link.next = this.body2.contactLink).prev = this.b2Link)
            : (this.b2Link.next = null),
          (this.body2.contactLink = this.b2Link),
          this.body2.numContacts++,
          (this.prev = null),
          (this.next = null),
          (this.persisting = !0),
          (this.sleeping = this.body1.sleeping && this.body2.sleeping),
          (this.manifold.numPoints = 0);
      },
      detach: function () {
        var t = this.s1Link.prev,
          e = this.s1Link.next;
        null !== t && (t.next = e),
          null !== e && (e.prev = t),
          this.shape1.contactLink == this.s1Link &&
            (this.shape1.contactLink = e),
          (this.s1Link.prev = null),
          (this.s1Link.next = null),
          (this.s1Link.shape = null),
          (this.s1Link.body = null),
          this.shape1.numContacts--,
          (t = this.s2Link.prev),
          (e = this.s2Link.next),
          null !== t && (t.next = e),
          null !== e && (e.prev = t),
          this.shape2.contactLink == this.s2Link &&
            (this.shape2.contactLink = e),
          (this.s2Link.prev = null),
          (this.s2Link.next = null),
          (this.s2Link.shape = null),
          (this.s2Link.body = null),
          this.shape2.numContacts--,
          (t = this.b1Link.prev),
          (e = this.b1Link.next),
          null !== t && (t.next = e),
          null !== e && (e.prev = t),
          this.body1.contactLink == this.b1Link && (this.body1.contactLink = e),
          (this.b1Link.prev = null),
          (this.b1Link.next = null),
          (this.b1Link.shape = null),
          (this.b1Link.body = null),
          this.body1.numContacts--,
          (t = this.b2Link.prev),
          (e = this.b2Link.next),
          null !== t && (t.next = e),
          null !== e && (e.prev = t),
          this.body2.contactLink == this.b2Link && (this.body2.contactLink = e),
          (this.b2Link.prev = null),
          (this.b2Link.next = null),
          (this.b2Link.shape = null),
          (this.b2Link.body = null),
          this.body2.numContacts--,
          (this.manifold.body1 = null),
          (this.manifold.body2 = null),
          (this.constraint.body1 = null),
          (this.constraint.body2 = null),
          this.constraint.detach(),
          (this.shape1 = null),
          (this.shape2 = null),
          (this.body1 = null),
          (this.body2 = null);
      },
    }),
    Object.assign(RigidBody.prototype, {
      setParent: function (t) {
        (this.parent = t),
          (this.scale = this.parent.scale),
          (this.invScale = this.parent.invScale),
          (this.id = ShapeIdCount()),
          this.name || (this.name = this.id),
          this.updateMesh();
      },
      addShape: function (t) {
        t.parent &&
          printError(
            "RigidBody",
            "It is not possible that you add a shape which already has an associated body."
          ),
          null != this.shapes && ((this.shapes.prev = t).next = this.shapes),
          (this.shapes = t),
          (t.parent = this),
          this.parent && this.parent.addShape(t),
          this.numShapes++;
      },
      removeShape: function (t) {
        var e = t;
        if (e.parent == this) {
          var a = e.prev,
            n = e.next;
          null != a && (a.next = n),
            null != n && (n.prev = a),
            this.shapes == e && (this.shapes = n),
            (e.prev = null),
            (e.next = null),
            (e.parent = null),
            this.parent && this.parent.removeShape(e),
            this.numShapes--;
        }
      },
      remove: function () {
        this.dispose();
      },
      dispose: function () {
        this.parent.removeRigidBody(this);
      },
      checkContact: function (t) {
        this.parent.checkContact(this.name, t);
      },
      setupMass: function (t, e) {
        var a = void 0 === e || e;
        (this.type = t || 2),
          (this.isDynamic = 1 === this.type),
          (this.isStatic = 2 === this.type),
          (this.mass = 0),
          this.localInertia.set(0, 0, 0, 0, 0, 0, 0, 0, 0);
        for (
          var n = new Mat33(), u = new Vec3(), m = this.shapes;
          null !== m;
          m = m.next
        ) {
          m.calculateMassInfo(this.massInfo);
          var f = this.massInfo.mass;
          u.addScaledVector(m.relativePosition, f),
            (this.mass += f),
            this.rotateInertia(m.relativeRotation, this.massInfo.inertia, n),
            this.localInertia.add(n),
            this.localInertia.addOffset(f, m.relativePosition);
        }
        if (
          ((this.inverseMass = 1 / this.mass),
          u.scaleEqual(this.inverseMass),
          a)
        ) {
          var p = this.position.clone();
          for (
            this.position.copy(u).applyQuaternion(this.orientation).add(p),
              m = this.shapes;
            null !== m;
            m = m.next
          )
            m.relativePosition.subEqual(u);
          this.localInertia.subOffset(this.mass, u);
        }
        this.inverseLocalInertia.invert(this.localInertia),
          2 === this.type &&
            ((this.inverseMass = 0),
            this.inverseLocalInertia.set(0, 0, 0, 0, 0, 0, 0, 0, 0)),
          this.syncShapes(),
          this.awake();
      },
      setMass: function (t) {
        if (!isNaN(t)) {
          for (var e = this.shapes; null !== e; e = e.next)
            e.mass = (e.mass / this.mass) * t;
          (this.mass = t), (this.inverseMass = 0 === t ? 1 : 1 / t);
        }
      },
      awake: function () {
        if (this.allowSleep && this.sleeping) {
          (this.sleeping = !1), (this.sleepTime = 0);
          for (var t = this.contactLink; null != t; )
            (t.body.sleepTime = 0), (t.body.sleeping = !1), (t = t.next);
          for (var e = this.jointLink; null != e; )
            (e.body.sleepTime = 0), (e.body.sleeping = !1), (e = e.next);
          for (var a = this.shapes; null != a; a = a.next) a.updateProxy();
        }
      },
      sleep: function () {
        if (this.allowSleep && !this.sleeping) {
          this.linearVelocity.set(0, 0, 0),
            this.angularVelocity.set(0, 0, 0),
            this.sleepPosition.copy(this.position),
            this.sleepOrientation.copy(this.orientation),
            (this.sleepTime = 0),
            (this.sleeping = !0);
          for (var t = this.shapes; null != t; t = t.next) t.updateProxy();
        }
      },
      testWakeUp: function () {
        (this.linearVelocity.testZero() ||
          this.angularVelocity.testZero() ||
          this.position.testDiff(this.sleepPosition) ||
          this.orientation.testDiff(this.sleepOrientation)) &&
          this.awake();
      },
      isLonely: function () {
        return 0 == this.numJoints && 0 == this.numContacts;
      },
      updatePosition: function (t) {
        switch (this.type) {
          case 2:
            this.linearVelocity.set(0, 0, 0),
              this.angularVelocity.set(0, 0, 0),
              this.controlPos &&
                (this.position.copy(this.newPosition), (this.controlPos = !1)),
              this.controlRot &&
                (this.orientation.copy(this.newOrientation),
                (this.controlRot = !1));
            break;
          case 1:
            if (
              (this.isKinematic &&
                (this.linearVelocity.set(0, 0, 0),
                this.angularVelocity.set(0, 0, 0)),
              this.controlPos &&
                (t > 0
                  ? this.linearVelocity
                      .subVectors(this.newPosition, this.position)
                      .multiplyScalar(1 / t)
                  : this.position.copy(this.newPosition),
                (this.controlPos = !1)),
              this.controlRot)
            ) {
              if (t > 0) {
                var e = this.getAngularVelocity(
                  this.orientation,
                  this.newOrientation
                ).multiplyScalar(1 / t);
                this.angularVelocity.copy(e);
              } else this.orientation.copy(this.newOrientation);
              this.controlRot = !1;
            }
            if (this.linearVelocityConstraint) {
              let t = this.linearVelocityConstraint;
              -1 != t.indexOf("x") &&
                ((this.linearVelocity.x = 0), (this.linearSpeed.x = 0)),
                -1 != t.indexOf("y") &&
                  ((this.linearVelocity.y = 0), (this.linearSpeed.y = 0)),
                -1 != t.indexOf("z") &&
                  ((this.linearVelocity.z = 0), (this.linearSpeed.z = 0));
            }
            if (
              (Number.isFinite(this.linearVelocityMax) &&
                this.limitVelocity(this.linearVelocity, this.linearVelocityMax),
              t > 0 &&
                (this.position.addScaledVector(this.linearVelocity, t),
                this.position.addScaledVector(this.linearSpeed, t)),
              this.positionConstraint)
            ) {
              let t = this.positionConstraint;
              Number.isFinite(t[0]) &&
                Number.isFinite(t[1]) &&
                (this.position.x = Math.clamp(this.position.x, t[0], t[1])),
                Number.isFinite(t[2]) &&
                  Number.isFinite(t[3]) &&
                  (this.position.y = Math.clamp(this.position.y, t[2], t[3])),
                Number.isFinite(t[4]) &&
                  Number.isFinite(t[5]) &&
                  (this.position.z = Math.clamp(this.position.z, t[4], t[5]));
            }
            if (this.angularVelocityConstraint) {
              let t = this.angularVelocityConstraint;
              -1 != t.indexOf("x") && (this.angularVelocity.x = 0),
                -1 != t.indexOf("y") && (this.angularVelocity.y = 0),
                -1 != t.indexOf("z") && (this.angularVelocity.z = 0);
            }
            if (
              (Number.isFinite(this.angularVelocityMax) &&
                this.limitVelocity(
                  this.angularVelocity,
                  this.angularVelocityMax
                ),
              this.controlRotInTime
                ? this.angularVelocity.set(0, 0, 0)
                : t > 0 && this.orientation.addTime(this.angularVelocity, t),
              this.angularConstraint)
            ) {
              let t = this.angularConstraint;
              Number.isFinite(t[0]) &&
                Number.isFinite(t[1]) &&
                (this.angularVelocity.x = Math.clamp(
                  this.angularVelocity.x,
                  t[0],
                  t[1]
                )),
                Number.isFinite(t[2]) &&
                  Number.isFinite(t[3]) &&
                  (this.angularVelocity.y = Math.clamp(
                    this.angularVelocity.y,
                    t[2],
                    t[3]
                  )),
                Number.isFinite(t[4]) &&
                  Number.isFinite(t[5]) &&
                  (this.angularVelocity.z = Math.clamp(
                    this.angularVelocity.z,
                    t[4],
                    t[5]
                  ));
            }
            this.updateMesh();
            break;
          default:
            printError("RigidBody", "Invalid type.");
        }
        this.syncShapes(), this.updateMesh();
      },
      getAngularVelocity: function (t, e) {
        if (!t.testDiff(e)) return new Vec3();
        var a = new Quat().invert(t),
          n = e.clone().multiply(a),
          u = new Vec3(),
          m = n.toAxisAngle(u);
        return u.scaleEqual(m);
      },
      rotateInertia: function (t, e, a) {
        this.tmpInertia.multiplyMatrices(t, e),
          a.multiplyMatrices(this.tmpInertia, t, !0);
      },
      syncShapes: function () {
        this.rotation.setQuat(this.orientation),
          this.rotateInertia(
            this.rotation,
            this.inverseLocalInertia,
            this.inverseInertia
          );
        for (var t = this.shapes; null != t; t = t.next)
          t.position
            .copy(t.relativePosition)
            .applyMatrix3(this.rotation, !0)
            .add(this.position),
            t.rotation.multiplyMatrices(this.rotation, t.relativeRotation),
            t.updateProxy();
      },
      limitVelocity: function (t, e) {
        t.lengthSq() > e * e && t.normalize(e);
      },
      applyImpulse: function (t, e, a) {
        this.linearVelocity.addScaledVector(t, this.inverseMass),
          Number.isFinite(e) && this.limitVelocity(this.linearVelocity, e);
        var n = new Vec3()
          .copy(t)
          .cross(new Vec3(0, -1, 0))
          .applyMatrix3(this.inverseInertia, !0);
        (a = a || 0.1), this.angularVelocity.addScaledVector(n, a);
      },
      setPosition: function (t) {
        this.newPosition.copy(t).multiplyScalar(this.invScale),
          (this.controlPos = !0);
      },
      setQuaternion: function (t) {
        this.newOrientation.set(t.x, t.y, t.z, t.w), (this.controlRot = !0);
      },
      resetPosition: function (t, e, a) {
        this.linearVelocity.set(0, 0, 0),
          this.angularVelocity.set(0, 0, 0),
          this.position.set(t, e, a).multiplyScalar(this.invScale),
          this.awake();
      },
      resetQuaternion: function (t) {
        this.angularVelocity.set(0, 0, 0),
          (this.orientation = new Quat(t.x, t.y, t.z, t.w)),
          this.awake();
      },
      getPosition: function () {
        return this.pos;
      },
      getQuaternion: function () {
        return this.quaternion;
      },
      connectMesh: function (t) {
        (this.mesh = t), this.updateMesh();
      },
      updateMesh: function () {
        this.pos.scale(this.position, this.scale),
          this.quaternion.copy(this.orientation),
          null !== this.mesh &&
            (this.mesh.position.copy(this.getPosition()),
            this.mesh.quaternion.copy(this.getQuaternion()));
      },
    }),
    Object.assign(BroadPhase.prototype, {
      BroadPhase: !0,
      createProxy: function (t) {
        printError("BroadPhase", "Inheritance error.");
      },
      addProxy: function (t) {
        printError("BroadPhase", "Inheritance error.");
      },
      removeProxy: function (t) {
        printError("BroadPhase", "Inheritance error.");
      },
      isAvailablePair: function (t, e) {
        var a,
          n = t.parent,
          u = e.parent;
        if (
          n == u ||
          (!n.isDynamic && !u.isDynamic) ||
          0 == (t.belongsTo & e.collidesWith) ||
          0 == (e.belongsTo & t.collidesWith) ||
          (n.ignore && -1 != n.ignore.indexOf(u)) ||
          (u.ignore && -1 != u.ignore.indexOf(n))
        )
          return !1;
        for (
          a = n.numJoints < u.numJoints ? n.jointLink : u.jointLink;
          null !== a;

        ) {
          var m = a.joint;
          if (
            !m.allowCollision &&
            ((m.body1 == n && m.body2 == u) || (m.body1 == u && m.body2 == n))
          )
            return !1;
          a = a.next;
        }
        return !0;
      },
      detectPairs: function () {
        (this.pairs = []),
          (this.numPairs = 0),
          (this.numPairChecks = 0),
          this.collectPairs();
      },
      collectPairs: function () {},
      addPair: function (t, e) {
        var a = new Pair(t, e);
        this.pairs.push(a), this.numPairs++;
      },
    });
  var p = 0;
  function Proxy(t) {
    (this.shape = t),
      (this.aabb = t.aabb),
      (this.lastAABB = t.lastAABB),
      (this.tempAABB = t.tempAABB);
  }
  function BasicProxy(t) {
    Proxy.call(this, t), (this.id = p++);
  }
  function BruteForceBroadPhase() {
    BroadPhase.call(this), (this.types = 1), (this.proxies = []);
  }
  function SAPAxis() {
    (this.numElements = 0),
      (this.bufferSize = 256),
      (this.elements = []),
      (this.elements.length = this.bufferSize),
      (this.stack = new Float32Array(64));
  }
  function SAPElement(t, e) {
    (this.proxy = t),
      (this.pair = null),
      (this.min1 = null),
      (this.max1 = null),
      (this.min2 = null),
      (this.max2 = null),
      (this.max = e),
      (this.value = 0);
  }
  function SAPProxy(t, e) {
    Proxy.call(this, e),
      (this.belongsTo = 0),
      (this.max = []),
      (this.min = []),
      (this.sap = t),
      (this.min[0] = new SAPElement(this, !1)),
      (this.max[0] = new SAPElement(this, !0)),
      (this.min[1] = new SAPElement(this, !1)),
      (this.max[1] = new SAPElement(this, !0)),
      (this.min[2] = new SAPElement(this, !1)),
      (this.max[2] = new SAPElement(this, !0)),
      (this.max[0].pair = this.min[0]),
      (this.max[1].pair = this.min[1]),
      (this.max[2].pair = this.min[2]),
      (this.min[0].min1 = this.min[1]),
      (this.min[0].max1 = this.max[1]),
      (this.min[0].min2 = this.min[2]),
      (this.min[0].max2 = this.max[2]),
      (this.min[1].min1 = this.min[0]),
      (this.min[1].max1 = this.max[0]),
      (this.min[1].min2 = this.min[2]),
      (this.min[1].max2 = this.max[2]),
      (this.min[2].min1 = this.min[0]),
      (this.min[2].max1 = this.max[0]),
      (this.min[2].min2 = this.min[1]),
      (this.min[2].max2 = this.max[1]);
  }
  function SAPBroadPhase() {
    BroadPhase.call(this),
      (this.types = 2),
      (this.numElementsD = 0),
      (this.numElementsS = 0),
      (this.axesD = [new SAPAxis(), new SAPAxis(), new SAPAxis()]),
      (this.axesS = [new SAPAxis(), new SAPAxis(), new SAPAxis()]),
      (this.index1 = 0),
      (this.index2 = 1);
  }
  function DBVTNode() {
    (this.child1 = null),
      (this.child2 = null),
      (this.parent = null),
      (this.proxy = null),
      (this.height = 0),
      (this.aabb = new AABB());
  }
  function DBVT() {
    (this.root = null),
      (this.freeNodes = []),
      (this.freeNodes.length = 16384),
      (this.numFreeNodes = 0),
      (this.aabb = new AABB());
  }
  function DBVTProxy(t) {
    Proxy.call(this, t), (this.leaf = new DBVTNode()), (this.leaf.proxy = this);
  }
  function DBVTBroadPhase() {
    BroadPhase.call(this),
      (this.types = 3),
      (this.tree = new DBVT()),
      (this.stack = []),
      (this.leaves = []),
      (this.numLeaves = 0);
  }
  function CollisionDetector() {
    this.flip = !1;
  }
  function BoxBoxCollisionDetector() {
    CollisionDetector.call(this),
      (this.clipVertices1 = new Float32Array(24)),
      (this.clipVertices2 = new Float32Array(24)),
      (this.used = new Float32Array(8)),
      (this.INF = 1 / 0);
  }
  function BoxCylinderCollisionDetector(t) {
    CollisionDetector.call(this), (this.flip = t);
  }
  function CylinderCylinderCollisionDetector() {
    CollisionDetector.call(this);
  }
  function SphereBoxCollisionDetector(t) {
    CollisionDetector.call(this), (this.flip = t);
  }
  function SphereCylinderCollisionDetector(t) {
    CollisionDetector.call(this), (this.flip = t);
  }
  function SphereSphereCollisionDetector() {
    CollisionDetector.call(this);
  }
  function SpherePlaneCollisionDetector(t) {
    CollisionDetector.call(this),
      (this.flip = t),
      (this.n = new Vec3()),
      (this.p = new Vec3());
  }
  function BoxPlaneCollisionDetector(t) {
    CollisionDetector.call(this),
      (this.flip = t),
      (this.n = new Vec3()),
      (this.p = new Vec3()),
      (this.dix = new Vec3()),
      (this.diy = new Vec3()),
      (this.diz = new Vec3()),
      (this.cc = new Vec3()),
      (this.cc2 = new Vec3());
  }
  function World(t) {
    switch (
      (t instanceof Object || (t = {}),
      (this.scale = t.worldscale || 1),
      (this.invScale = 1 / this.scale),
      (this.timeStep = t.timestep || 0.01666),
      (this.timerate = 1e3 * this.timeStep),
      (this.timer = null),
      (this.preLoop = null),
      (this.postLoop = null),
      (this.numIterations = t.iterations || 8),
      t.broadphase || 2)
    ) {
      case 1:
        this.broadPhase = new BruteForceBroadPhase();
        break;
      case 2:
      default:
        this.broadPhase = new SAPBroadPhase();
        break;
      case 3:
        this.broadPhase = new DBVTBroadPhase();
    }
    (this.Btypes = [
      "None",
      "BruteForce",
      "Sweep & Prune",
      "Bounding Volume Tree",
    ]),
      (this.broadPhaseType = this.Btypes[t.broadphase || 2]),
      (this.performance = null),
      (this.isStat = void 0 !== t.info && t.info),
      this.isStat && (this.performance = new InfoDisplay(this)),
      (this.enableRandomizer = void 0 === t.random || t.random),
      (this.rigidBodies = null),
      (this.numRigidBodies = 0),
      (this.contacts = null),
      (this.unusedContacts = null),
      (this.numContacts = 0),
      (this.numContactPoints = 0),
      (this.joints = null),
      (this.numJoints = 0),
      (this.numIslands = 0),
      (this.gravity = new Vec3(0, -9.8, 0)),
      void 0 !== t.gravity && this.gravity.fromArray(t.gravity);
    (this.detectors = []), (this.detectors.length = 5);
    for (var e = 5; e--; )
      (this.detectors[e] = []), (this.detectors[e].length = 5);
    (this.detectors[1][1] = new SphereSphereCollisionDetector()),
      (this.detectors[1][2] = new SphereBoxCollisionDetector(!1)),
      (this.detectors[2][1] = new SphereBoxCollisionDetector(!0)),
      (this.detectors[2][2] = new BoxBoxCollisionDetector()),
      (this.detectors[3][3] = new CylinderCylinderCollisionDetector()),
      (this.detectors[3][2] = new BoxCylinderCollisionDetector(!0)),
      (this.detectors[2][3] = new BoxCylinderCollisionDetector(!1)),
      (this.detectors[3][1] = new SphereCylinderCollisionDetector(!0)),
      (this.detectors[1][3] = new SphereCylinderCollisionDetector(!1)),
      (this.detectors[4][1] = new SpherePlaneCollisionDetector(!0)),
      (this.detectors[1][4] = new SpherePlaneCollisionDetector(!1)),
      (this.detectors[4][2] = new BoxPlaneCollisionDetector(!0)),
      (this.detectors[2][4] = new BoxPlaneCollisionDetector(!1)),
      (this.randX = 65535),
      (this.randA = 98765),
      (this.randB = 123456789),
      (this.islandRigidBodies = []),
      (this.islandStack = []),
      (this.islandConstraints = []);
  }
  return (
    Object.assign(Proxy.prototype, {
      Proxy: !0,
      update: function () {
        printError("Proxy", "Inheritance error.");
      },
    }),
    (BasicProxy.prototype = Object.assign(Object.create(Proxy.prototype), {
      constructor: BasicProxy,
      update: function () {},
    })),
    (BruteForceBroadPhase.prototype = Object.assign(
      Object.create(BroadPhase.prototype),
      {
        constructor: BruteForceBroadPhase,
        createProxy: function (t) {
          return new BasicProxy(t);
        },
        addProxy: function (t) {
          this.proxies.push(t);
        },
        removeProxy: function (t) {
          var e = this.proxies.indexOf(t);
          e > -1 && this.proxies.splice(e, 1);
        },
        collectPairs: function () {
          var t,
            e,
            a,
            n = 0,
            u = this.proxies,
            m = u.length;
          for (this.numPairChecks = (m * (m - 1)) >> 1; n < m; )
            for (e = u[n++], t = n + 1; t < m; )
              (a = u[t++]),
                !e.aabb.intersectTest(a.aabb) &&
                  this.isAvailablePair(e.shape, a.shape) &&
                  this.addPair(e.shape, a.shape);
        },
      }
    )),
    Object.assign(SAPAxis.prototype, {
      SAPAxis: !0,
      addElements: function (t, e) {
        if (this.numElements + 2 >= this.bufferSize) {
          this.bufferSize *= 2;
          for (var a = [], n = this.numElements; n--; ) a[n] = this.elements[n];
        }
        (this.elements[this.numElements++] = t),
          (this.elements[this.numElements++] = e);
      },
      removeElements: function (t, e) {
        for (var a = -1, n = -1, u = 0, m = this.numElements; u < m; u++) {
          var f = this.elements[u];
          if (f == t || f == e) {
            if (-1 != a) {
              n = u;
              break;
            }
            a = u;
          }
        }
        for (u = a + 1, m = n; u < m; u++)
          this.elements[u - 1] = this.elements[u];
        for (u = n + 1, m = this.numElements; u < m; u++)
          this.elements[u - 2] = this.elements[u];
        (this.elements[--this.numElements] = null),
          (this.elements[--this.numElements] = null);
      },
      sort: function () {
        for (var t = 0, e = 1; this.numElements >> e != 0; ) e++;
        (e = (e * this.numElements) >> 2), (t = 0);
        for (
          var a = !1, n = this.elements, u = 1, f = this.numElements;
          u < f;
          u++
        ) {
          var p = n[u],
            y = p.value,
            g = n[u - 1];
          if (g.value > y) {
            var _ = u;
            do {
              if (((n[_] = g), 0 == --_)) break;
              g = n[_ - 1];
            } while (g.value > y);
            if (((n[_] = p), (t += u - _) > e)) {
              a = !0;
              break;
            }
          }
        }
        if (a) {
          t = 2;
          var x = this.stack;
          for (x[0] = 0, x[1] = this.numElements - 1; t > 0; ) {
            var b = x[--t],
              v = x[--t],
              w = b - v;
            if (w > 16) {
              var S = v + m.floor(0.5 * w);
              for (
                p = n[S], n[S] = n[b], n[b] = p, y = p.value, u = v - 1, _ = b;
                ;

              ) {
                var C, E;
                do {
                  C = n[++u];
                } while (C.value < y);
                do {
                  E = n[--_];
                } while (y < E.value && _ != v);
                if (u >= _) break;
                (n[u] = E), (n[_] = C);
              }
              (n[b] = n[u]),
                (n[u] = p),
                u - v > b - u
                  ? ((x[t++] = v),
                    (x[t++] = u - 1),
                    (x[t++] = u + 1),
                    (x[t++] = b))
                  : ((x[t++] = u + 1),
                    (x[t++] = b),
                    (x[t++] = v),
                    (x[t++] = u - 1));
            } else
              for (u = v + 1; u <= b; u++)
                if (((y = (p = n[u]).value), (g = n[u - 1]).value > y)) {
                  _ = u;
                  do {
                    if (((n[_] = g), 0 == --_)) break;
                    g = n[_ - 1];
                  } while (g.value > y);
                  n[_] = p;
                }
          }
        }
      },
      calculateTestCount: function () {
        for (var t = 1, e = 0, a = 1, n = this.numElements; a < n; a++)
          this.elements[a].max ? t-- : ((e += t), t++);
        return e;
      },
    }),
    (SAPProxy.prototype = Object.assign(Object.create(Proxy.prototype), {
      constructor: SAPProxy,
      isDynamic: function () {
        var t = this.shape.parent;
        return t.isDynamic && !t.sleeping;
      },
      update: function () {
        var t = this.aabb.getCenter(),
          e = this.lastAABB.getCenter(),
          a = t.sub(e).lengthSq();
        this.isDynamic() && a > World.FIX_PENETRATE_SQ
          ? ((this.shape.fixed = !0),
            this.tempAABB.combine(this.aabb, this.lastAABB))
          : this.tempAABB.copy(this.aabb);
        var n = this.tempAABB.elements;
        (this.min[0].value = n[0]),
          (this.min[1].value = n[1]),
          (this.min[2].value = n[2]),
          (this.max[0].value = n[3]),
          (this.max[1].value = n[4]),
          (this.max[2].value = n[5]),
          ((1 == this.belongsTo && !this.isDynamic()) ||
            (2 == this.belongsTo && this.isDynamic())) &&
            (this.sap.removeProxy(this), this.sap.addProxy(this));
      },
    })),
    (SAPBroadPhase.prototype = Object.assign(
      Object.create(BroadPhase.prototype),
      {
        constructor: SAPBroadPhase,
        createProxy: function (t) {
          return new SAPProxy(this, t);
        },
        addProxy: function (t) {
          var e = t;
          e.isDynamic()
            ? (this.axesD[0].addElements(e.min[0], e.max[0]),
              this.axesD[1].addElements(e.min[1], e.max[1]),
              this.axesD[2].addElements(e.min[2], e.max[2]),
              (e.belongsTo = 1),
              (this.numElementsD += 2))
            : (this.axesS[0].addElements(e.min[0], e.max[0]),
              this.axesS[1].addElements(e.min[1], e.max[1]),
              this.axesS[2].addElements(e.min[2], e.max[2]),
              (e.belongsTo = 2),
              (this.numElementsS += 2));
        },
        removeProxy: function (t) {
          var e = t;
          if (0 != e.belongsTo) {
            switch (e.belongsTo) {
              case 1:
                this.axesD[0].removeElements(e.min[0], e.max[0]),
                  this.axesD[1].removeElements(e.min[1], e.max[1]),
                  this.axesD[2].removeElements(e.min[2], e.max[2]),
                  (this.numElementsD -= 2);
                break;
              case 2:
                this.axesS[0].removeElements(e.min[0], e.max[0]),
                  this.axesS[1].removeElements(e.min[1], e.max[1]),
                  this.axesS[2].removeElements(e.min[2], e.max[2]),
                  (this.numElementsS -= 2);
            }
            e.belongsTo = 0;
          }
        },
        collectPairs: function () {
          if (0 != this.numElementsD) {
            var t,
              e,
              a,
              n,
              u = this.axesD[this.index1],
              m = this.axesD[this.index2];
            u.sort(),
              m.sort(),
              u.calculateTestCount() <= m.calculateTestCount()
                ? ((m = this.axesS[this.index1]).sort(),
                  (t = u.elements),
                  (e = m.elements))
                : ((u = this.axesS[this.index2]).sort(),
                  (t = m.elements),
                  (e = u.elements),
                  (this.index1 ^= this.index2),
                  (this.index2 ^= this.index1),
                  (this.index1 ^= this.index2));
            for (var f = 0, p = 0; f < this.numElementsD; ) {
              var y, g;
              if (p == this.numElementsS) (y = t[f]), (g = !0), f++;
              else {
                var _ = t[f],
                  x = e[p];
                _.value < x.value
                  ? ((y = _), (g = !0), f++)
                  : ((y = x), (g = !1), p++);
              }
              if (y.max) {
                var b = y.pair;
                if (g) {
                  if (b == a) {
                    a = a.pair;
                    continue;
                  }
                  y = a;
                } else {
                  if (b == n) {
                    n = n.pair;
                    continue;
                  }
                  y = n;
                }
                for (; y; ) {
                  if ((z = y.pair) == b) {
                    y.pair = z.pair;
                    break;
                  }
                  y = z;
                }
              } else {
                for (
                  var v = y.proxy.shape,
                    w = y.min1.value,
                    S = y.max1.value,
                    C = y.min2.value,
                    E = y.max2.value,
                    z = a;
                  null != z;
                  z = z.pair
                ) {
                  var A = z.proxy.shape;
                  this.numPairChecks++,
                    w > z.max1.value ||
                      S < z.min1.value ||
                      C > z.max2.value ||
                      E < z.min2.value ||
                      !this.isAvailablePair(v, A) ||
                      this.addPair(v, A);
                }
                if (g) {
                  for (z = n; null != z; z = z.pair)
                    (A = z.proxy.shape),
                      this.numPairChecks++,
                      w > z.max1.value ||
                        S < z.min1.value ||
                        C > z.max2.value ||
                        E < z.min2.value ||
                        !this.isAvailablePair(v, A) ||
                        this.addPair(v, A);
                  (y.pair = a), (a = y);
                } else (y.pair = n), (n = y);
              }
            }
            this.index2 = 3 ^ (this.index1 | this.index2);
          }
        },
      }
    )),
    Object.assign(DBVT.prototype, {
      DBVT: !0,
      moveLeaf: function (t) {
        this.deleteLeaf(t), this.insertLeaf(t);
      },
      insertLeaf: function (t) {
        if (null != this.root) {
          for (var e, a, n = t.aabb, u = this.root; null == u.proxy; ) {
            var m = u.child1,
              f = u.child2,
              p = u.aabb,
              y = m.aabb,
              g = f.aabb;
            (e = p.surfaceArea()), this.aabb.combine(n, p);
            var _ = 2 * (a = this.aabb.surfaceArea()),
              x = 2 * (a - e),
              b = x;
            this.aabb.combine(n, y),
              null != m.proxy
                ? (b += this.aabb.surfaceArea())
                : (b += this.aabb.surfaceArea() - y.surfaceArea());
            var v = x;
            if (
              (this.aabb.combine(n, g),
              null != f.proxy
                ? (v += this.aabb.surfaceArea())
                : (v += this.aabb.surfaceArea() - g.surfaceArea()),
              b < v)
            ) {
              if (_ < b) break;
              u = m;
            } else {
              if (_ < v) break;
              u = f;
            }
          }
          var w,
            S = u.parent;
          ((w =
            this.numFreeNodes > 0
              ? this.freeNodes[--this.numFreeNodes]
              : new DBVTNode()).parent = S),
            (w.child1 = t),
            (w.child2 = u),
            w.aabb.combine(t.aabb, u.aabb),
            (w.height = u.height + 1),
            (u.parent = w),
            (t.parent = w),
            u == this.root
              ? (this.root = w)
              : S.child1 == u
              ? (S.child1 = w)
              : (S.child2 = w);
          do {
            (w = this.balance(w)), this.fix(w), (w = w.parent);
          } while (null != w);
        } else this.root = t;
      },
      getBalance: function (t) {
        return null != t.proxy ? 0 : t.child1.height - t.child2.height;
      },
      deleteLeaf: function (t) {
        if (t != this.root) {
          var e,
            a = t.parent;
          if (((e = a.child1 == t ? a.child2 : a.child1), a == this.root))
            return (this.root = e), void (e.parent = null);
          var n = a.parent;
          (e.parent = n),
            n.child1 == a ? (n.child1 = e) : (n.child2 = e),
            this.numFreeNodes < 16384 &&
              (this.freeNodes[this.numFreeNodes++] = a);
          do {
            (n = this.balance(n)), this.fix(n), (n = n.parent);
          } while (null != n);
        } else this.root = null;
      },
      balance: function (t) {
        var e = t.height;
        if (e < 2) return t;
        var a,
          n = t.parent,
          u = t.child1,
          m = t.child2,
          f = u.height,
          p = m.height,
          y = f - p;
        if (y > 1) {
          var g = u.child1,
            _ = u.child2,
            x = g.height,
            b = _.height;
          return (
            x > b
              ? ((u.child2 = t),
                (t.parent = u),
                (t.child1 = _),
                (_.parent = t),
                t.aabb.combine(_.aabb, m.aabb),
                (a = b - p),
                (t.height = b - (a & (a >> 31)) + 1),
                u.aabb.combine(g.aabb, t.aabb),
                (a = x - e),
                (u.height = x - (a & (a >> 31)) + 1))
              : ((u.child1 = t),
                (t.parent = u),
                (t.child1 = g),
                (g.parent = t),
                t.aabb.combine(g.aabb, m.aabb),
                (a = x - p),
                (t.height = x - (a & (a >> 31)) + 1),
                u.aabb.combine(t.aabb, _.aabb),
                (a = e - b),
                (u.height = e - (a & (a >> 31)) + 1)),
            null != n
              ? n.child1 == t
                ? (n.child1 = u)
                : (n.child2 = u)
              : (this.root = u),
            (u.parent = n),
            u
          );
        }
        if (y < -1) {
          var v = m.child1,
            w = m.child2,
            S = v.height,
            C = w.height;
          return (
            S > C
              ? ((m.child2 = t),
                (t.parent = m),
                (t.child2 = w),
                (w.parent = t),
                t.aabb.combine(u.aabb, w.aabb),
                (a = f - C),
                (t.height = f - (a & (a >> 31)) + 1),
                m.aabb.combine(v.aabb, t.aabb),
                (a = S - e),
                (m.height = S - (a & (a >> 31)) + 1))
              : ((m.child1 = t),
                (t.parent = m),
                (t.child2 = v),
                (v.parent = t),
                t.aabb.combine(u.aabb, v.aabb),
                (a = f - S),
                (t.height = f - (a & (a >> 31)) + 1),
                m.aabb.combine(t.aabb, w.aabb),
                (a = e - C),
                (m.height = e - (a & (a >> 31)) + 1)),
            null != n
              ? n.child1 == t
                ? (n.child1 = m)
                : (n.child2 = m)
              : (this.root = m),
            (m.parent = n),
            m
          );
        }
        return t;
      },
      fix: function (t) {
        var e = t.child1,
          a = t.child2;
        t.aabb.combine(e.aabb, a.aabb),
          (t.height = e.height < a.height ? a.height + 1 : e.height + 1);
      },
    }),
    (DBVTProxy.prototype = Object.assign(Object.create(Proxy.prototype), {
      constructor: DBVTProxy,
      update: function () {},
    })),
    (DBVTBroadPhase.prototype = Object.assign(
      Object.create(BroadPhase.prototype),
      {
        constructor: DBVTBroadPhase,
        createProxy: function (t) {
          return new DBVTProxy(t);
        },
        addProxy: function (t) {
          this.tree.insertLeaf(t.leaf),
            this.leaves.push(t.leaf),
            this.numLeaves++;
        },
        removeProxy: function (t) {
          this.tree.deleteLeaf(t.leaf);
          var e = this.leaves.indexOf(t.leaf);
          e > -1 && (this.leaves.splice(e, 1), this.numLeaves--);
        },
        collectPairs: function () {
          if (!(this.numLeaves < 2))
            for (var t, e = this.numLeaves; e--; )
              (t = this.leaves[e]).proxy.aabb.intersectTestTwo(t.aabb) &&
                (t.aabb.copy(t.proxy.aabb, 0.1),
                this.tree.deleteLeaf(t),
                this.tree.insertLeaf(t),
                this.collide(t, this.tree.root));
        },
        collide: function (t, e) {
          var a,
            n,
            u,
            m,
            f,
            p,
            y = 2;
          for (this.stack[0] = t, this.stack[1] = e; y > 0; )
            if (
              ((u = this.stack[--y]),
              (m = this.stack[--y]),
              (f = null != u.proxy),
              (p = null != m.proxy),
              this.numPairChecks++,
              f && p)
            ) {
              if (
                (a = u.proxy.shape) == (n = m.proxy.shape) ||
                a.aabb.intersectTest(n.aabb) ||
                !this.isAvailablePair(a, n)
              )
                continue;
              this.addPair(a, n);
            } else {
              if (u.aabb.intersectTest(m.aabb)) continue;
              p || (!f && u.aabb.surfaceArea() > m.aabb.surfaceArea())
                ? ((this.stack[y++] = u.child1),
                  (this.stack[y++] = m),
                  (this.stack[y++] = u.child2),
                  (this.stack[y++] = m))
                : ((this.stack[y++] = u),
                  (this.stack[y++] = m.child1),
                  (this.stack[y++] = u),
                  (this.stack[y++] = m.child2));
            }
        },
      }
    )),
    Object.assign(CollisionDetector.prototype, {
      CollisionDetector: !0,
      detectCollision: function (t, e, a) {
        printError("CollisionDetector", "Inheritance error.");
      },
    }),
    (BoxBoxCollisionDetector.prototype = Object.assign(
      Object.create(CollisionDetector.prototype),
      {
        constructor: BoxBoxCollisionDetector,
        detectCollision: function (t, e, a) {
          var n, u;
          t.id < e.id ? ((n = t), (u = e)) : ((n = e), (u = t));
          var f,
            p,
            y,
            g,
            _,
            x,
            b,
            v,
            w,
            S,
            C,
            E,
            z,
            A,
            k,
            B,
            V,
            R,
            J,
            Z,
            $,
            tt,
            et,
            it,
            st,
            at,
            nt,
            ot,
            rt,
            ht,
            lt,
            ct,
            dt,
            ut,
            mt,
            ft = n.elements,
            pt = u.elements,
            yt = n.dimentions,
            gt = u.dimentions,
            _t = n.position,
            xt = u.position,
            bt = _t.x,
            vt = _t.y,
            Lt = _t.z,
            wt = xt.x,
            St = xt.y,
            Mt = xt.z,
            Ct = wt - bt,
            Nt = St - vt,
            Et = Mt - Lt,
            Tt = n.halfWidth,
            It = n.halfHeight,
            zt = n.halfDepth,
            Pt = u.halfWidth,
            At = u.halfHeight,
            kt = u.halfDepth,
            Dt = yt[0],
            Bt = yt[1],
            Vt = yt[2],
            Ot = yt[3],
            Rt = yt[4],
            Ut = yt[5],
            Ft = yt[6],
            Ht = yt[7],
            Wt = yt[8],
            Gt = yt[9],
            jt = yt[10],
            Xt = yt[11],
            Yt = yt[12],
            qt = yt[13],
            Qt = yt[14],
            Jt = yt[15],
            Zt = yt[16],
            Kt = yt[17],
            $t = gt[0],
            te = gt[1],
            ee = gt[2],
            ie = gt[3],
            se = gt[4],
            ae = gt[5],
            ne = gt[6],
            oe = gt[7],
            re = gt[8],
            he = gt[9],
            le = gt[10],
            ce = gt[11],
            de = gt[12],
            ue = gt[13],
            me = gt[14],
            fe = gt[15],
            pe = gt[16],
            ye = gt[17],
            ge = Bt * ee - Vt * te,
            _e = Vt * $t - Dt * ee,
            xe = Dt * te - Bt * $t,
            be = Bt * ae - Vt * se,
            ve = Vt * ie - Dt * ae,
            Le = Dt * se - Bt * ie,
            we = Bt * re - Vt * oe,
            Se = Vt * ne - Dt * re,
            Me = Dt * oe - Bt * ne,
            Ce = Rt * ee - Ut * te,
            Ne = Ut * $t - Ot * ee,
            Ee = Ot * te - Rt * $t,
            Te = Rt * ae - Ut * se,
            Ie = Ut * ie - Ot * ae,
            ze = Ot * se - Rt * ie,
            Pe = Rt * re - Ut * oe,
            Ae = Ut * ne - Ot * re,
            ke = Ot * oe - Rt * ne,
            De = Ht * ee - Wt * te,
            Be = Wt * $t - Ft * ee,
            Ve = Ft * te - Ht * $t,
            Oe = Ht * ae - Wt * se,
            Re = Wt * ie - Ft * ae,
            Ue = Ft * se - Ht * ie,
            Fe = Ht * re - Wt * oe,
            He = Wt * ne - Ft * re,
            We = Ft * oe - Ht * ne,
            Ge = !1,
            je = !1,
            Xe = !1,
            Ye = !1,
            qe = !1,
            Qe = !1,
            Je = !1,
            Ze = !1,
            Ke = !1;
          if (
            ((f = (lt = Dt * Ct + Bt * Nt + Vt * Et) > 0) || (lt = -lt),
            (dt = Dt * $t + Bt * te + Vt * ee) < 0 && (dt = -dt),
            (ut = Dt * ie + Bt * se + Vt * ae) < 0 && (ut = -ut),
            (mt = Dt * ne + Bt * oe + Vt * re) < 0 && (mt = -mt),
            !(
              (B = lt - (ct = Tt) - (dt * Pt + ut * At + mt * kt)) > 0 ||
              ((p = (lt = Ot * Ct + Rt * Nt + Ut * Et) > 0) || (lt = -lt),
              (dt = Ot * $t + Rt * te + Ut * ee) < 0 && (dt = -dt),
              (ut = Ot * ie + Rt * se + Ut * ae) < 0 && (ut = -ut),
              (mt = Ot * ne + Rt * oe + Ut * re) < 0 && (mt = -mt),
              (V = lt - (ct = It) - (dt * Pt + ut * At + mt * kt)) > 0 ||
                ((y = (lt = Ft * Ct + Ht * Nt + Wt * Et) > 0) || (lt = -lt),
                (dt = Ft * $t + Ht * te + Wt * ee) < 0 && (dt = -dt),
                (ut = Ft * ie + Ht * se + Wt * ae) < 0 && (ut = -ut),
                (mt = Ft * ne + Ht * oe + Wt * re) < 0 && (mt = -mt),
                (R = lt - (ct = zt) - (dt * Pt + ut * At + mt * kt)) > 0 ||
                  ((g = (lt = $t * Ct + te * Nt + ee * Et) > 0) || (lt = -lt),
                  (dt = $t * Dt + te * Bt + ee * Vt) < 0 && (dt = -dt),
                  (ut = $t * Ot + te * Rt + ee * Ut) < 0 && (ut = -ut),
                  (mt = $t * Ft + te * Ht + ee * Wt) < 0 && (mt = -mt),
                  (J = 1 * (lt - (ct = dt * Tt + ut * It + mt * zt) - Pt)) >
                    0 ||
                    ((_ = (lt = ie * Ct + se * Nt + ae * Et) > 0) || (lt = -lt),
                    (dt = ie * Dt + se * Bt + ae * Vt) < 0 && (dt = -dt),
                    (ut = ie * Ot + se * Rt + ae * Ut) < 0 && (ut = -ut),
                    (mt = ie * Ft + se * Ht + ae * Wt) < 0 && (mt = -mt),
                    (Z = 1 * (lt - (ct = dt * Tt + ut * It + mt * zt) - At)) >
                      0 ||
                      ((x = (lt = ne * Ct + oe * Nt + re * Et) > 0) ||
                        (lt = -lt),
                      (dt = ne * Dt + oe * Bt + re * Vt) < 0 && (dt = -dt),
                      (ut = ne * Ot + oe * Rt + re * Ut) < 0 && (ut = -ut),
                      (mt = ne * Ft + oe * Ht + re * Wt) < 0 && (mt = -mt),
                      ($ = 1 * (lt - (ct = dt * Tt + ut * It + mt * zt) - kt)) >
                        0)))))
            ))
          ) {
            if ((lt = ge * ge + _e * _e + xe * xe) > 1e-5) {
              if (
                ((b =
                  (lt =
                    (ge *= lt = 1 / m.sqrt(lt)) * Ct +
                    (_e *= lt) * Nt +
                    (xe *= lt) * Et) > 0) || (lt = -lt),
                (dt = ge * Ot + _e * Rt + xe * Ut) < 0 && (dt = -dt),
                (ut = ge * Ft + _e * Ht + xe * Wt) < 0 && (ut = -ut),
                (ct = dt * It + ut * zt),
                (dt = ge * ie + _e * se + xe * ae) < 0 && (dt = -dt),
                (ut = ge * ne + _e * oe + xe * re) < 0 && (ut = -ut),
                (tt = lt - ct - (dt * At + ut * kt)) > 0)
              )
                return;
            } else (b = !1), (tt = 0), (Ge = !0);
            if ((lt = be * be + ve * ve + Le * Le) > 1e-5) {
              if (
                ((v =
                  (lt =
                    (be *= lt = 1 / m.sqrt(lt)) * Ct +
                    (ve *= lt) * Nt +
                    (Le *= lt) * Et) > 0) || (lt = -lt),
                (dt = be * Ot + ve * Rt + Le * Ut) < 0 && (dt = -dt),
                (ut = be * Ft + ve * Ht + Le * Wt) < 0 && (ut = -ut),
                (ct = dt * It + ut * zt),
                (dt = be * $t + ve * te + Le * ee) < 0 && (dt = -dt),
                (ut = be * ne + ve * oe + Le * re) < 0 && (ut = -ut),
                (et = lt - ct - (dt * Pt + ut * kt)) > 0)
              )
                return;
            } else (v = !1), (et = 0), (je = !0);
            if ((lt = we * we + Se * Se + Me * Me) > 1e-5) {
              if (
                ((w =
                  (lt =
                    (we *= lt = 1 / m.sqrt(lt)) * Ct +
                    (Se *= lt) * Nt +
                    (Me *= lt) * Et) > 0) || (lt = -lt),
                (dt = we * Ot + Se * Rt + Me * Ut) < 0 && (dt = -dt),
                (ut = we * Ft + Se * Ht + Me * Wt) < 0 && (ut = -ut),
                (ct = dt * It + ut * zt),
                (dt = we * $t + Se * te + Me * ee) < 0 && (dt = -dt),
                (ut = we * ie + Se * se + Me * ae) < 0 && (ut = -ut),
                (it = lt - ct - (dt * Pt + ut * At)) > 0)
              )
                return;
            } else (w = !1), (it = 0), (Xe = !0);
            if ((lt = Ce * Ce + Ne * Ne + Ee * Ee) > 1e-5) {
              if (
                ((S =
                  (lt =
                    (Ce *= lt = 1 / m.sqrt(lt)) * Ct +
                    (Ne *= lt) * Nt +
                    (Ee *= lt) * Et) > 0) || (lt = -lt),
                (dt = Ce * Dt + Ne * Bt + Ee * Vt) < 0 && (dt = -dt),
                (ut = Ce * Ft + Ne * Ht + Ee * Wt) < 0 && (ut = -ut),
                (ct = dt * Tt + ut * zt),
                (dt = Ce * ie + Ne * se + Ee * ae) < 0 && (dt = -dt),
                (ut = Ce * ne + Ne * oe + Ee * re) < 0 && (ut = -ut),
                (st = lt - ct - (dt * At + ut * kt)) > 0)
              )
                return;
            } else (S = !1), (st = 0), (Ye = !0);
            if ((lt = Te * Te + Ie * Ie + ze * ze) > 1e-5) {
              if (
                ((C =
                  (lt =
                    (Te *= lt = 1 / m.sqrt(lt)) * Ct +
                    (Ie *= lt) * Nt +
                    (ze *= lt) * Et) > 0) || (lt = -lt),
                (dt = Te * Dt + Ie * Bt + ze * Vt) < 0 && (dt = -dt),
                (ut = Te * Ft + Ie * Ht + ze * Wt) < 0 && (ut = -ut),
                (ct = dt * Tt + ut * zt),
                (dt = Te * $t + Ie * te + ze * ee) < 0 && (dt = -dt),
                (ut = Te * ne + Ie * oe + ze * re) < 0 && (ut = -ut),
                (at = lt - ct - (dt * Pt + ut * kt)) > 0)
              )
                return;
            } else (C = !1), (at = 0), (qe = !0);
            if ((lt = Pe * Pe + Ae * Ae + ke * ke) > 1e-5) {
              if (
                ((E =
                  (lt =
                    (Pe *= lt = 1 / m.sqrt(lt)) * Ct +
                    (Ae *= lt) * Nt +
                    (ke *= lt) * Et) > 0) || (lt = -lt),
                (dt = Pe * Dt + Ae * Bt + ke * Vt) < 0 && (dt = -dt),
                (ut = Pe * Ft + Ae * Ht + ke * Wt) < 0 && (ut = -ut),
                (ct = dt * Tt + ut * zt),
                (dt = Pe * $t + Ae * te + ke * ee) < 0 && (dt = -dt),
                (ut = Pe * ie + Ae * se + ke * ae) < 0 && (ut = -ut),
                (nt = lt - ct - (dt * Pt + ut * At)) > 0)
              )
                return;
            } else (E = !1), (nt = 0), (Qe = !0);
            if ((lt = De * De + Be * Be + Ve * Ve) > 1e-5) {
              if (
                ((z =
                  (lt =
                    (De *= lt = 1 / m.sqrt(lt)) * Ct +
                    (Be *= lt) * Nt +
                    (Ve *= lt) * Et) > 0) || (lt = -lt),
                (dt = De * Dt + Be * Bt + Ve * Vt) < 0 && (dt = -dt),
                (ut = De * Ot + Be * Rt + Ve * Ut) < 0 && (ut = -ut),
                (ct = dt * Tt + ut * It),
                (dt = De * ie + Be * se + Ve * ae) < 0 && (dt = -dt),
                (ut = De * ne + Be * oe + Ve * re) < 0 && (ut = -ut),
                (ot = lt - ct - (dt * At + ut * kt)) > 0)
              )
                return;
            } else (z = !1), (ot = 0), (Je = !0);
            if ((lt = Oe * Oe + Re * Re + Ue * Ue) > 1e-5) {
              if (
                ((A =
                  (lt =
                    (Oe *= lt = 1 / m.sqrt(lt)) * Ct +
                    (Re *= lt) * Nt +
                    (Ue *= lt) * Et) > 0) || (lt = -lt),
                (dt = Oe * Dt + Re * Bt + Ue * Vt) < 0 && (dt = -dt),
                (ut = Oe * Ot + Re * Rt + Ue * Ut) < 0 && (ut = -ut),
                (ct = dt * Tt + ut * It),
                (dt = Oe * $t + Re * te + Ue * ee) < 0 && (dt = -dt),
                (ut = Oe * ne + Re * oe + Ue * re) < 0 && (ut = -ut),
                (rt = lt - ct - (dt * Pt + ut * kt)) > 0)
              )
                return;
            } else (A = !1), (rt = 0), (Ze = !0);
            if ((lt = Fe * Fe + He * He + We * We) > 1e-5) {
              if (
                ((k =
                  (lt =
                    (Fe *= lt = 1 / m.sqrt(lt)) * Ct +
                    (He *= lt) * Nt +
                    (We *= lt) * Et) > 0) || (lt = -lt),
                (dt = Fe * Dt + He * Bt + We * Vt) < 0 && (dt = -dt),
                (ut = Fe * Ot + He * Rt + We * Ut) < 0 && (ut = -ut),
                (ct = dt * Tt + ut * It),
                (dt = Fe * $t + He * te + We * ee) < 0 && (dt = -dt),
                (ut = Fe * ie + He * se + We * ae) < 0 && (ut = -ut),
                (ht = lt - ct - (dt * Pt + ut * At)) > 0)
              )
                return;
            } else (k = !1), (ht = 0), (Ke = !0);
            var $e = B,
              ti = B,
              ei = 0,
              ii = f;
            V > ti && (($e = V), (ti = V), (ei = 1), (ii = p)),
              R > ti && (($e = R), (ti = R), (ei = 2), (ii = y)),
              J > ti && (($e = J), (ti = J), (ei = 3), (ii = g)),
              Z > ti && (($e = Z), (ti = Z), (ei = 4), (ii = _)),
              $ > ti && (($e = $), (ti = $), (ei = 5), (ii = x)),
              tt - 0.01 > ti &&
                !Ge &&
                (($e = tt), (ti = tt - 0.01), (ei = 6), (ii = b)),
              et - 0.01 > ti &&
                !je &&
                (($e = et), (ti = et - 0.01), (ei = 7), (ii = v)),
              it - 0.01 > ti &&
                !Xe &&
                (($e = it), (ti = it - 0.01), (ei = 8), (ii = w)),
              st - 0.01 > ti &&
                !Ye &&
                (($e = st), (ti = st - 0.01), (ei = 9), (ii = S)),
              at - 0.01 > ti &&
                !qe &&
                (($e = at), (ti = at - 0.01), (ei = 10), (ii = C)),
              nt - 0.01 > ti &&
                !Qe &&
                (($e = nt), (ti = nt - 0.01), (ei = 11), (ii = E)),
              ot - 0.01 > ti &&
                !Je &&
                (($e = ot), (ti = ot - 0.01), (ei = 12), (ii = z)),
              rt - 0.01 > ti &&
                !Ze &&
                (($e = rt), (ti = rt - 0.01), (ei = 13), (ii = A)),
              ht - 0.01 > ti && !Ke && (($e = ht), (ei = 14), (ii = k));
            var si = 0,
              ai = 0,
              ni = 0,
              oi = 0,
              ri = 0,
              hi = 0,
              li = 0,
              ci = 0,
              di = 0,
              ui = 0,
              mi = 0,
              fi = 0,
              pi = 0,
              yi = 0,
              gi = 0,
              _i = 0,
              xi = 0,
              bi = 0,
              vi = !1;
            if (
              (0 == ei
                ? (ii
                    ? ((ui = bt + Gt),
                      (mi = vt + jt),
                      (fi = Lt + Xt),
                      (si = Dt),
                      (ai = Bt),
                      (ni = Vt))
                    : ((ui = bt - Gt),
                      (mi = vt - jt),
                      (fi = Lt - Xt),
                      (si = -Dt),
                      (ai = -Bt),
                      (ni = -Vt)),
                  (pi = Yt),
                  (yi = qt),
                  (gi = Qt),
                  (oi = -Ot),
                  (ri = -Rt),
                  (hi = -Ut),
                  (_i = Jt),
                  (xi = Zt),
                  (bi = Kt),
                  (li = -Ft),
                  (ci = -Ht),
                  (di = -Wt))
                : 1 == ei
                ? (ii
                    ? ((ui = bt + Yt),
                      (mi = vt + qt),
                      (fi = Lt + Qt),
                      (si = Ot),
                      (ai = Rt),
                      (ni = Ut))
                    : ((ui = bt - Yt),
                      (mi = vt - qt),
                      (fi = Lt - Qt),
                      (si = -Ot),
                      (ai = -Rt),
                      (ni = -Ut)),
                  (pi = Gt),
                  (yi = jt),
                  (gi = Xt),
                  (oi = -Dt),
                  (ri = -Bt),
                  (hi = -Vt),
                  (_i = Jt),
                  (xi = Zt),
                  (bi = Kt),
                  (li = -Ft),
                  (ci = -Ht),
                  (di = -Wt))
                : 2 == ei
                ? (ii
                    ? ((ui = bt + Jt),
                      (mi = vt + Zt),
                      (fi = Lt + Kt),
                      (si = Ft),
                      (ai = Ht),
                      (ni = Wt))
                    : ((ui = bt - Jt),
                      (mi = vt - Zt),
                      (fi = Lt - Kt),
                      (si = -Ft),
                      (ai = -Ht),
                      (ni = -Wt)),
                  (pi = Gt),
                  (yi = jt),
                  (gi = Xt),
                  (oi = -Dt),
                  (ri = -Bt),
                  (hi = -Vt),
                  (_i = Yt),
                  (xi = qt),
                  (bi = Qt),
                  (li = -Ot),
                  (ci = -Rt),
                  (di = -Ut))
                : 3 == ei
                ? ((vi = !0),
                  ii
                    ? ((ui = wt - he),
                      (mi = St - le),
                      (fi = Mt - ce),
                      (si = -$t),
                      (ai = -te),
                      (ni = -ee))
                    : ((ui = wt + he),
                      (mi = St + le),
                      (fi = Mt + ce),
                      (si = $t),
                      (ai = te),
                      (ni = ee)),
                  (pi = de),
                  (yi = ue),
                  (gi = me),
                  (oi = -ie),
                  (ri = -se),
                  (hi = -ae),
                  (_i = fe),
                  (xi = pe),
                  (bi = ye),
                  (li = -ne),
                  (ci = -oe),
                  (di = -re))
                : 4 == ei
                ? ((vi = !0),
                  ii
                    ? ((ui = wt - de),
                      (mi = St - ue),
                      (fi = Mt - me),
                      (si = -ie),
                      (ai = -se),
                      (ni = -ae))
                    : ((ui = wt + de),
                      (mi = St + ue),
                      (fi = Mt + me),
                      (si = ie),
                      (ai = se),
                      (ni = ae)),
                  (pi = he),
                  (yi = le),
                  (gi = ce),
                  (oi = -$t),
                  (ri = -te),
                  (hi = -ee),
                  (_i = fe),
                  (xi = pe),
                  (bi = ye),
                  (li = -ne),
                  (ci = -oe),
                  (di = -re))
                : 5 == ei
                ? ((vi = !0),
                  ii
                    ? ((ui = wt - fe),
                      (mi = St - pe),
                      (fi = Mt - ye),
                      (si = -ne),
                      (ai = -oe),
                      (ni = -re))
                    : ((ui = wt + fe),
                      (mi = St + pe),
                      (fi = Mt + ye),
                      (si = ne),
                      (ai = oe),
                      (ni = re)),
                  (pi = he),
                  (yi = le),
                  (gi = ce),
                  (oi = -$t),
                  (ri = -te),
                  (hi = -ee),
                  (_i = de),
                  (xi = ue),
                  (bi = me),
                  (li = -ie),
                  (ci = -se),
                  (di = -ae))
                : 6 == ei
                ? ((si = ge),
                  (ai = _e),
                  (ni = xe),
                  (oi = Dt),
                  (ri = Bt),
                  (hi = Vt),
                  (li = $t),
                  (ci = te),
                  (di = ee))
                : 7 == ei
                ? ((si = be),
                  (ai = ve),
                  (ni = Le),
                  (oi = Dt),
                  (ri = Bt),
                  (hi = Vt),
                  (li = ie),
                  (ci = se),
                  (di = ae))
                : 8 == ei
                ? ((si = we),
                  (ai = Se),
                  (ni = Me),
                  (oi = Dt),
                  (ri = Bt),
                  (hi = Vt),
                  (li = ne),
                  (ci = oe),
                  (di = re))
                : 9 == ei
                ? ((si = Ce),
                  (ai = Ne),
                  (ni = Ee),
                  (oi = Ot),
                  (ri = Rt),
                  (hi = Ut),
                  (li = $t),
                  (ci = te),
                  (di = ee))
                : 10 == ei
                ? ((si = Te),
                  (ai = Ie),
                  (ni = ze),
                  (oi = Ot),
                  (ri = Rt),
                  (hi = Ut),
                  (li = ie),
                  (ci = se),
                  (di = ae))
                : 11 == ei
                ? ((si = Pe),
                  (ai = Ae),
                  (ni = ke),
                  (oi = Ot),
                  (ri = Rt),
                  (hi = Ut),
                  (li = ne),
                  (ci = oe),
                  (di = re))
                : 12 == ei
                ? ((si = De),
                  (ai = Be),
                  (ni = Ve),
                  (oi = Ft),
                  (ri = Ht),
                  (hi = Wt),
                  (li = $t),
                  (ci = te),
                  (di = ee))
                : 13 == ei
                ? ((si = Oe),
                  (ai = Re),
                  (ni = Ue),
                  (oi = Ft),
                  (ri = Ht),
                  (hi = Wt),
                  (li = ie),
                  (ci = se),
                  (di = ae))
                : 14 == ei &&
                  ((si = Fe),
                  (ai = He),
                  (ni = We),
                  (oi = Ft),
                  (ri = Ht),
                  (hi = Wt),
                  (li = ne),
                  (ci = oe),
                  (di = re)),
              ei > 5)
            ) {
              var Li, wi, Si, Mi, Ci, Ni, Ei, Ti, Ii, zi, Pi;
              ii || ((si = -si), (ai = -ai), (ni = -ni)),
                (wi =
                  si * (Ni = ft[0]) + ai * (Ei = ft[1]) + ni * (Ti = ft[2])),
                (Li =
                  si * (Si = ft[3]) + ai * (Mi = ft[4]) + ni * (Ci = ft[5])) >
                  wi && ((wi = Li), (Ni = Si), (Ei = Mi), (Ti = Ci)),
                (Li =
                  si * (Si = ft[6]) + ai * (Mi = ft[7]) + ni * (Ci = ft[8])) >
                  wi && ((wi = Li), (Ni = Si), (Ei = Mi), (Ti = Ci)),
                (Li =
                  si * (Si = ft[9]) + ai * (Mi = ft[10]) + ni * (Ci = ft[11])) >
                  wi && ((wi = Li), (Ni = Si), (Ei = Mi), (Ti = Ci)),
                (Li =
                  si * (Si = ft[12]) +
                  ai * (Mi = ft[13]) +
                  ni * (Ci = ft[14])) > wi &&
                  ((wi = Li), (Ni = Si), (Ei = Mi), (Ti = Ci)),
                (Li =
                  si * (Si = ft[15]) +
                  ai * (Mi = ft[16]) +
                  ni * (Ci = ft[17])) > wi &&
                  ((wi = Li), (Ni = Si), (Ei = Mi), (Ti = Ci)),
                (Li =
                  si * (Si = ft[18]) +
                  ai * (Mi = ft[19]) +
                  ni * (Ci = ft[20])) > wi &&
                  ((wi = Li), (Ni = Si), (Ei = Mi), (Ti = Ci)),
                (Li =
                  si * (Si = ft[21]) +
                  ai * (Mi = ft[22]) +
                  ni * (Ci = ft[23])) > wi &&
                  ((wi = Li), (Ni = Si), (Ei = Mi), (Ti = Ci)),
                (wi =
                  si * (Ii = pt[0]) + ai * (zi = pt[1]) + ni * (Pi = pt[2])),
                (Li =
                  si * (Si = pt[3]) + ai * (Mi = pt[4]) + ni * (Ci = pt[5])) <
                  wi && ((wi = Li), (Ii = Si), (zi = Mi), (Pi = Ci)),
                (Li =
                  si * (Si = pt[6]) + ai * (Mi = pt[7]) + ni * (Ci = pt[8])) <
                  wi && ((wi = Li), (Ii = Si), (zi = Mi), (Pi = Ci)),
                (Li =
                  si * (Si = pt[9]) + ai * (Mi = pt[10]) + ni * (Ci = pt[11])) <
                  wi && ((wi = Li), (Ii = Si), (zi = Mi), (Pi = Ci)),
                (Li =
                  si * (Si = pt[12]) +
                  ai * (Mi = pt[13]) +
                  ni * (Ci = pt[14])) < wi &&
                  ((wi = Li), (Ii = Si), (zi = Mi), (Pi = Ci)),
                (Li =
                  si * (Si = pt[15]) +
                  ai * (Mi = pt[16]) +
                  ni * (Ci = pt[17])) < wi &&
                  ((wi = Li), (Ii = Si), (zi = Mi), (Pi = Ci)),
                (Li =
                  si * (Si = pt[18]) +
                  ai * (Mi = pt[19]) +
                  ni * (Ci = pt[20])) < wi &&
                  ((wi = Li), (Ii = Si), (zi = Mi), (Pi = Ci)),
                (Li =
                  si * (Si = pt[21]) +
                  ai * (Mi = pt[22]) +
                  ni * (Ci = pt[23])) < wi &&
                  ((wi = Li), (Ii = Si), (zi = Mi), (Pi = Ci));
              var Ai =
                ((Si = Ii - Ni) *
                  (oi - li * (dt = oi * li + ri * ci + hi * di)) +
                  (Mi = zi - Ei) * (ri - ci * dt) +
                  (Ci = Pi - Ti) * (hi - di * dt)) /
                (1 - dt * dt);
              a.addPoint(
                Ni + oi * Ai + si * $e * 0.5,
                Ei + ri * Ai + ai * $e * 0.5,
                Ti + hi * Ai + ni * $e * 0.5,
                si,
                ai,
                ni,
                $e,
                !1
              );
            } else {
              var ki,
                Di,
                Bi,
                Vi,
                Oi,
                Ri,
                Ui,
                Fi,
                Hi,
                Wi,
                Gi,
                ji,
                Xi,
                Yi,
                qi,
                Qi,
                Ji,
                Zi,
                Ki,
                $i,
                ts,
                es = 1,
                is = 0,
                ss = 0;
              vi
                ? ((is = Dt * si + Bt * ai + Vt * ni) < es &&
                    ((es = is), (ss = 0)),
                  -is < es && ((es = -is), (ss = 1)),
                  (is = Ot * si + Rt * ai + Ut * ni) < es &&
                    ((es = is), (ss = 2)),
                  -is < es && ((es = -is), (ss = 3)),
                  (is = Ft * si + Ht * ai + Wt * ni) < es &&
                    ((es = is), (ss = 4)),
                  -is < es && ((es = -is), (ss = 5)),
                  0 == ss
                    ? ((ki = ft[0]),
                      (Di = ft[1]),
                      (Bi = ft[2]),
                      (Vi = ft[6]),
                      (Oi = ft[7]),
                      (Ri = ft[8]),
                      (Ui = ft[9]),
                      (Fi = ft[10]),
                      (Hi = ft[11]),
                      (Wi = ft[3]),
                      (Gi = ft[4]),
                      (ji = ft[5]))
                    : 1 == ss
                    ? ((ki = ft[15]),
                      (Di = ft[16]),
                      (Bi = ft[17]),
                      (Vi = ft[21]),
                      (Oi = ft[22]),
                      (Ri = ft[23]),
                      (Ui = ft[18]),
                      (Fi = ft[19]),
                      (Hi = ft[20]),
                      (Wi = ft[12]),
                      (Gi = ft[13]),
                      (ji = ft[14]))
                    : 2 == ss
                    ? ((ki = ft[12]),
                      (Di = ft[13]),
                      (Bi = ft[14]),
                      (Vi = ft[0]),
                      (Oi = ft[1]),
                      (Ri = ft[2]),
                      (Ui = ft[3]),
                      (Fi = ft[4]),
                      (Hi = ft[5]),
                      (Wi = ft[15]),
                      (Gi = ft[16]),
                      (ji = ft[17]))
                    : 3 == ss
                    ? ((ki = ft[21]),
                      (Di = ft[22]),
                      (Bi = ft[23]),
                      (Vi = ft[9]),
                      (Oi = ft[10]),
                      (Ri = ft[11]),
                      (Ui = ft[6]),
                      (Fi = ft[7]),
                      (Hi = ft[8]),
                      (Wi = ft[18]),
                      (Gi = ft[19]),
                      (ji = ft[20]))
                    : 4 == ss
                    ? ((ki = ft[12]),
                      (Di = ft[13]),
                      (Bi = ft[14]),
                      (Vi = ft[18]),
                      (Oi = ft[19]),
                      (Ri = ft[20]),
                      (Ui = ft[6]),
                      (Fi = ft[7]),
                      (Hi = ft[8]),
                      (Wi = ft[0]),
                      (Gi = ft[1]),
                      (ji = ft[2]))
                    : 5 == ss &&
                      ((ki = ft[3]),
                      (Di = ft[4]),
                      (Bi = ft[5]),
                      (Vi = pt[9]),
                      (Oi = pt[10]),
                      (Ri = pt[11]),
                      (Ui = ft[21]),
                      (Fi = ft[22]),
                      (Hi = ft[23]),
                      (Wi = ft[15]),
                      (Gi = ft[16]),
                      (ji = ft[17])))
                : ((is = $t * si + te * ai + ee * ni) < es &&
                    ((es = is), (ss = 0)),
                  -is < es && ((es = -is), (ss = 1)),
                  (is = ie * si + se * ai + ae * ni) < es &&
                    ((es = is), (ss = 2)),
                  -is < es && ((es = -is), (ss = 3)),
                  (is = ne * si + oe * ai + re * ni) < es &&
                    ((es = is), (ss = 4)),
                  -is < es && ((es = -is), (ss = 5)),
                  0 == ss
                    ? ((ki = pt[0]),
                      (Di = pt[1]),
                      (Bi = pt[2]),
                      (Vi = pt[6]),
                      (Oi = pt[7]),
                      (Ri = pt[8]),
                      (Ui = pt[9]),
                      (Fi = pt[10]),
                      (Hi = pt[11]),
                      (Wi = pt[3]),
                      (Gi = pt[4]),
                      (ji = pt[5]))
                    : 1 == ss
                    ? ((ki = pt[15]),
                      (Di = pt[16]),
                      (Bi = pt[17]),
                      (Vi = pt[21]),
                      (Oi = pt[22]),
                      (Ri = pt[23]),
                      (Ui = pt[18]),
                      (Fi = pt[19]),
                      (Hi = pt[20]),
                      (Wi = pt[12]),
                      (Gi = pt[13]),
                      (ji = pt[14]))
                    : 2 == ss
                    ? ((ki = pt[12]),
                      (Di = pt[13]),
                      (Bi = pt[14]),
                      (Vi = pt[0]),
                      (Oi = pt[1]),
                      (Ri = pt[2]),
                      (Ui = pt[3]),
                      (Fi = pt[4]),
                      (Hi = pt[5]),
                      (Wi = pt[15]),
                      (Gi = pt[16]),
                      (ji = pt[17]))
                    : 3 == ss
                    ? ((ki = pt[21]),
                      (Di = pt[22]),
                      (Bi = pt[23]),
                      (Vi = pt[9]),
                      (Oi = pt[10]),
                      (Ri = pt[11]),
                      (Ui = pt[6]),
                      (Fi = pt[7]),
                      (Hi = pt[8]),
                      (Wi = pt[18]),
                      (Gi = pt[19]),
                      (ji = pt[20]))
                    : 4 == ss
                    ? ((ki = pt[12]),
                      (Di = pt[13]),
                      (Bi = pt[14]),
                      (Vi = pt[18]),
                      (Oi = pt[19]),
                      (Ri = pt[20]),
                      (Ui = pt[6]),
                      (Fi = pt[7]),
                      (Hi = pt[8]),
                      (Wi = pt[0]),
                      (Gi = pt[1]),
                      (ji = pt[2]))
                    : 5 == ss &&
                      ((ki = pt[3]),
                      (Di = pt[4]),
                      (Bi = pt[5]),
                      (Vi = pt[9]),
                      (Oi = pt[10]),
                      (Ri = pt[11]),
                      (Ui = pt[21]),
                      (Fi = pt[22]),
                      (Hi = pt[23]),
                      (Wi = pt[15]),
                      (Gi = pt[16]),
                      (ji = pt[17]))),
                (this.clipVertices1[0] = ki),
                (this.clipVertices1[1] = Di),
                (this.clipVertices1[2] = Bi),
                (this.clipVertices1[3] = Vi),
                (this.clipVertices1[4] = Oi),
                (this.clipVertices1[5] = Ri),
                (this.clipVertices1[6] = Ui),
                (this.clipVertices1[7] = Fi),
                (this.clipVertices1[8] = Hi),
                (this.clipVertices1[9] = Wi),
                (this.clipVertices1[10] = Gi),
                (this.clipVertices1[11] = ji),
                (Yi = 0),
                (dt =
                  ((Qi = this.clipVertices1[9]) - ui - pi) * oi +
                  ((Ji = this.clipVertices1[10]) - mi - yi) * ri +
                  ((Zi = this.clipVertices1[11]) - fi - gi) * hi);
              for (var as = 0; as < 4; as++)
                (qi = 3 * as),
                  (ut =
                    ((Ki = this.clipVertices1[qi]) - ui - pi) * oi +
                    (($i = this.clipVertices1[qi + 1]) - mi - yi) * ri +
                    ((ts = this.clipVertices1[qi + 2]) - fi - gi) * hi),
                  dt > 0
                    ? ut > 0
                      ? ((qi = 3 * Yi),
                        Yi++,
                        (this.clipVertices2[qi] = Ki),
                        (this.clipVertices2[qi + 1] = $i),
                        (this.clipVertices2[qi + 2] = ts))
                      : ((qi = 3 * Yi),
                        Yi++,
                        (Ai = dt / (dt - ut)),
                        (this.clipVertices2[qi] = Qi + (Ki - Qi) * Ai),
                        (this.clipVertices2[qi + 1] = Ji + ($i - Ji) * Ai),
                        (this.clipVertices2[qi + 2] = Zi + (ts - Zi) * Ai))
                    : ut > 0 &&
                      ((qi = 3 * Yi),
                      Yi++,
                      (Ai = dt / (dt - ut)),
                      (this.clipVertices2[qi] = Qi + (Ki - Qi) * Ai),
                      (this.clipVertices2[qi + 1] = Ji + ($i - Ji) * Ai),
                      (this.clipVertices2[qi + 2] = Zi + (ts - Zi) * Ai),
                      (qi = 3 * Yi),
                      Yi++,
                      (this.clipVertices2[qi] = Ki),
                      (this.clipVertices2[qi + 1] = $i),
                      (this.clipVertices2[qi + 2] = ts)),
                  (Qi = Ki),
                  (Ji = $i),
                  (Zi = ts),
                  (dt = ut);
              if (0 != (Xi = Yi)) {
                for (
                  Yi = 0,
                    qi = 3 * (Xi - 1),
                    dt =
                      ((Qi = this.clipVertices2[qi]) - ui - _i) * li +
                      ((Ji = this.clipVertices2[qi + 1]) - mi - xi) * ci +
                      ((Zi = this.clipVertices2[qi + 2]) - fi - bi) * di,
                    as = 0;
                  as < Xi;
                  as++
                )
                  (qi = 3 * as),
                    (ut =
                      ((Ki = this.clipVertices2[qi]) - ui - _i) * li +
                      (($i = this.clipVertices2[qi + 1]) - mi - xi) * ci +
                      ((ts = this.clipVertices2[qi + 2]) - fi - bi) * di),
                    dt > 0
                      ? ut > 0
                        ? ((qi = 3 * Yi),
                          Yi++,
                          (this.clipVertices1[qi] = Ki),
                          (this.clipVertices1[qi + 1] = $i),
                          (this.clipVertices1[qi + 2] = ts))
                        : ((qi = 3 * Yi),
                          Yi++,
                          (Ai = dt / (dt - ut)),
                          (this.clipVertices1[qi] = Qi + (Ki - Qi) * Ai),
                          (this.clipVertices1[qi + 1] = Ji + ($i - Ji) * Ai),
                          (this.clipVertices1[qi + 2] = Zi + (ts - Zi) * Ai))
                      : ut > 0 &&
                        ((qi = 3 * Yi),
                        Yi++,
                        (Ai = dt / (dt - ut)),
                        (this.clipVertices1[qi] = Qi + (Ki - Qi) * Ai),
                        (this.clipVertices1[qi + 1] = Ji + ($i - Ji) * Ai),
                        (this.clipVertices1[qi + 2] = Zi + (ts - Zi) * Ai),
                        (qi = 3 * Yi),
                        Yi++,
                        (this.clipVertices1[qi] = Ki),
                        (this.clipVertices1[qi + 1] = $i),
                        (this.clipVertices1[qi + 2] = ts)),
                    (Qi = Ki),
                    (Ji = $i),
                    (Zi = ts),
                    (dt = ut);
                if (0 != (Xi = Yi)) {
                  for (
                    Yi = 0,
                      qi = 3 * (Xi - 1),
                      dt =
                        ((Qi = this.clipVertices1[qi]) - ui + pi) * -oi +
                        ((Ji = this.clipVertices1[qi + 1]) - mi + yi) * -ri +
                        ((Zi = this.clipVertices1[qi + 2]) - fi + gi) * -hi,
                      as = 0;
                    as < Xi;
                    as++
                  )
                    (qi = 3 * as),
                      (ut =
                        ((Ki = this.clipVertices1[qi]) - ui + pi) * -oi +
                        (($i = this.clipVertices1[qi + 1]) - mi + yi) * -ri +
                        ((ts = this.clipVertices1[qi + 2]) - fi + gi) * -hi),
                      dt > 0
                        ? ut > 0
                          ? ((qi = 3 * Yi),
                            Yi++,
                            (this.clipVertices2[qi] = Ki),
                            (this.clipVertices2[qi + 1] = $i),
                            (this.clipVertices2[qi + 2] = ts))
                          : ((qi = 3 * Yi),
                            Yi++,
                            (Ai = dt / (dt - ut)),
                            (this.clipVertices2[qi] = Qi + (Ki - Qi) * Ai),
                            (this.clipVertices2[qi + 1] = Ji + ($i - Ji) * Ai),
                            (this.clipVertices2[qi + 2] = Zi + (ts - Zi) * Ai))
                        : ut > 0 &&
                          ((qi = 3 * Yi),
                          Yi++,
                          (Ai = dt / (dt - ut)),
                          (this.clipVertices2[qi] = Qi + (Ki - Qi) * Ai),
                          (this.clipVertices2[qi + 1] = Ji + ($i - Ji) * Ai),
                          (this.clipVertices2[qi + 2] = Zi + (ts - Zi) * Ai),
                          (qi = 3 * Yi),
                          Yi++,
                          (this.clipVertices2[qi] = Ki),
                          (this.clipVertices2[qi + 1] = $i),
                          (this.clipVertices2[qi + 2] = ts)),
                      (Qi = Ki),
                      (Ji = $i),
                      (Zi = ts),
                      (dt = ut);
                  if (0 != (Xi = Yi)) {
                    for (
                      Yi = 0,
                        qi = 3 * (Xi - 1),
                        dt =
                          ((Qi = this.clipVertices2[qi]) - ui + _i) * -li +
                          ((Ji = this.clipVertices2[qi + 1]) - mi + xi) * -ci +
                          ((Zi = this.clipVertices2[qi + 2]) - fi + bi) * -di,
                        as = 0;
                      as < Xi;
                      as++
                    )
                      (qi = 3 * as),
                        (ut =
                          ((Ki = this.clipVertices2[qi]) - ui + _i) * -li +
                          (($i = this.clipVertices2[qi + 1]) - mi + xi) * -ci +
                          ((ts = this.clipVertices2[qi + 2]) - fi + bi) * -di),
                        dt > 0
                          ? ut > 0
                            ? ((qi = 3 * Yi),
                              Yi++,
                              (this.clipVertices1[qi] = Ki),
                              (this.clipVertices1[qi + 1] = $i),
                              (this.clipVertices1[qi + 2] = ts))
                            : ((qi = 3 * Yi),
                              Yi++,
                              (Ai = dt / (dt - ut)),
                              (this.clipVertices1[qi] = Qi + (Ki - Qi) * Ai),
                              (this.clipVertices1[qi + 1] =
                                Ji + ($i - Ji) * Ai),
                              (this.clipVertices1[qi + 2] =
                                Zi + (ts - Zi) * Ai))
                          : ut > 0 &&
                            ((qi = 3 * Yi),
                            Yi++,
                            (Ai = dt / (dt - ut)),
                            (this.clipVertices1[qi] = Qi + (Ki - Qi) * Ai),
                            (this.clipVertices1[qi + 1] = Ji + ($i - Ji) * Ai),
                            (this.clipVertices1[qi + 2] = Zi + (ts - Zi) * Ai),
                            (qi = 3 * Yi),
                            Yi++,
                            (this.clipVertices1[qi] = Ki),
                            (this.clipVertices1[qi + 1] = $i),
                            (this.clipVertices1[qi + 2] = ts)),
                        (Qi = Ki),
                        (Ji = $i),
                        (Zi = ts),
                        (dt = ut);
                    if (vi) {
                      var ns = n;
                      (n = u), (u = ns);
                    }
                    if (0 != (Xi = Yi)) {
                      var os = n != t;
                      if (Xi > 4) {
                        (oi = ki - (Qi = 0.25 * (ki + Vi + Ui + Wi))),
                          (ri = Di - (Ji = 0.25 * (Di + Oi + Fi + Gi))),
                          (hi = Bi - (Zi = 0.25 * (Bi + Ri + Hi + ji))),
                          (li = Vi - Qi),
                          (ci = Oi - Ji),
                          (di = Ri - Zi);
                        var rs = 0,
                          hs = 0,
                          ls = 0,
                          cs = 0,
                          ds = -this.INF;
                        for (es = this.INF, as = 0; as < Xi; as++)
                          (this.used[as] = !1),
                            (qi = 3 * as),
                            (is =
                              (Qi = this.clipVertices1[qi]) * oi +
                              (Ji = this.clipVertices1[qi + 1]) * ri +
                              (Zi = this.clipVertices1[qi + 2]) * hi) < es &&
                              ((es = is), (rs = as)),
                            is > ds && ((ds = is), (ls = as));
                        for (
                          this.used[rs] = !0,
                            this.used[ls] = !0,
                            ds = -this.INF,
                            es = this.INF,
                            as = 0;
                          as < Xi;
                          as++
                        )
                          this.used[as] ||
                            ((qi = 3 * as),
                            (is =
                              (Qi = this.clipVertices1[qi]) * li +
                              (Ji = this.clipVertices1[qi + 1]) * ci +
                              (Zi = this.clipVertices1[qi + 2]) * di) < es &&
                              ((es = is), (hs = as)),
                            is > ds && ((ds = is), (cs = as)));
                        (qi = 3 * rs),
                          (is =
                            ((Qi = this.clipVertices1[qi]) - ui) * si +
                            ((Ji = this.clipVertices1[qi + 1]) - mi) * ai +
                            ((Zi = this.clipVertices1[qi + 2]) - fi) * ni) <
                            0 && a.addPoint(Qi, Ji, Zi, si, ai, ni, is, os),
                          (qi = 3 * hs),
                          (is =
                            ((Qi = this.clipVertices1[qi]) - ui) * si +
                            ((Ji = this.clipVertices1[qi + 1]) - mi) * ai +
                            ((Zi = this.clipVertices1[qi + 2]) - fi) * ni) <
                            0 && a.addPoint(Qi, Ji, Zi, si, ai, ni, is, os),
                          (qi = 3 * ls),
                          (is =
                            ((Qi = this.clipVertices1[qi]) - ui) * si +
                            ((Ji = this.clipVertices1[qi + 1]) - mi) * ai +
                            ((Zi = this.clipVertices1[qi + 2]) - fi) * ni) <
                            0 && a.addPoint(Qi, Ji, Zi, si, ai, ni, is, os),
                          (qi = 3 * cs),
                          (is =
                            ((Qi = this.clipVertices1[qi]) - ui) * si +
                            ((Ji = this.clipVertices1[qi + 1]) - mi) * ai +
                            ((Zi = this.clipVertices1[qi + 2]) - fi) * ni) <
                            0 && a.addPoint(Qi, Ji, Zi, si, ai, ni, is, os);
                      } else
                        for (as = 0; as < Xi; as++)
                          (qi = 3 * as),
                            (is =
                              ((Qi = this.clipVertices1[qi]) - ui) * si +
                              ((Ji = this.clipVertices1[qi + 1]) - mi) * ai +
                              ((Zi = this.clipVertices1[qi + 2]) - fi) * ni) <
                              0 && a.addPoint(Qi, Ji, Zi, si, ai, ni, is, os);
                    }
                  }
                }
              }
            }
          }
        },
      }
    )),
    (BoxCylinderCollisionDetector.prototype = Object.assign(
      Object.create(CollisionDetector.prototype),
      {
        constructor: BoxCylinderCollisionDetector,
        getSep: function (t, e, a, n, u) {
          var f,
            p,
            y,
            g,
            _,
            x,
            b,
            v,
            w,
            S,
            C,
            E,
            z,
            A = new Vec3(),
            k = t.position.x,
            B = t.position.y,
            V = t.position.z,
            R = e.position.x,
            J = e.position.y,
            Z = e.position.z,
            $ = R - k,
            tt = J - B,
            et = Z - V;
          $ * $ + tt * tt + et * et == 0 && (tt = 0.001);
          var it = -$,
            st = -tt,
            at = -et;
          this.supportPointB(t, -it, -st, -at, A);
          var nt = A.x,
            ot = A.y,
            rt = A.z;
          this.supportPointC(e, it, st, at, A);
          var ht = A.x,
            lt = A.y,
            ct = A.z,
            dt = ht - nt,
            ut = lt - ot,
            mt = ct - rt;
          if (dt * it + ut * st + mt * at <= 0) return !1;
          if (
            (it = ut * et - mt * tt) * it +
              (st = mt * $ - dt * et) * st +
              (at = dt * tt - ut * $) * at ==
            0
          )
            return (
              a.set(dt - $, ut - tt, mt - et).normalize(),
              n.set(0.5 * (nt + ht), 0.5 * (ot + lt), 0.5 * (rt + ct)),
              !0
            );
          this.supportPointB(t, -it, -st, -at, A);
          var ft = A.x,
            pt = A.y,
            yt = A.z;
          this.supportPointC(e, it, st, at, A);
          var gt = A.x,
            _t = A.y,
            xt = A.z,
            bt = gt - ft,
            vt = _t - pt,
            Lt = xt - yt;
          if (bt * it + vt * st + Lt * at <= 0) return !1;
          (it = (p = ut - tt) * (x = Lt - et) - (y = mt - et) * (_ = vt - tt)) *
            $ +
            (st = y * (g = bt - $) - (f = dt - $) * x) * tt +
            (at = f * _ - p * g) * et >
            0 &&
            ((f = dt),
            (p = ut),
            (y = mt),
            (dt = bt),
            (ut = vt),
            (mt = Lt),
            (bt = f),
            (vt = p),
            (Lt = y),
            (f = nt),
            (p = ot),
            (y = rt),
            (nt = ft),
            (ot = pt),
            (rt = yt),
            (ft = f),
            (pt = p),
            (yt = y),
            (f = ht),
            (p = lt),
            (y = ct),
            (ht = gt),
            (lt = _t),
            (ct = xt),
            (gt = f),
            (_t = p),
            (xt = y),
            (it = -it),
            (st = -st),
            (at = -at));
          for (var wt = 0; ; ) {
            if (++wt > 100) return !1;
            this.supportPointB(t, -it, -st, -at, A);
            var St = A.x,
              Mt = A.y,
              Ct = A.z;
            this.supportPointC(e, it, st, at, A);
            var Nt = A.x,
              Et = A.y,
              Tt = A.z,
              It = Nt - St,
              zt = Et - Mt,
              Pt = Tt - Ct;
            if (It * it + zt * st + Pt * at <= 0) return !1;
            if (
              (ut * Pt - mt * zt) * $ +
                (mt * It - dt * Pt) * tt +
                (dt * zt - ut * It) * et <
              0
            )
              (bt = It),
                (vt = zt),
                (Lt = Pt),
                (ft = St),
                (pt = Mt),
                (yt = Ct),
                (gt = Nt),
                (_t = Et),
                (xt = Tt),
                (it =
                  (p = ut - tt) * (x = Pt - et) -
                  (y = mt - et) * (_ = zt - tt)),
                (st = y * (g = It - $) - (f = dt - $) * x),
                (at = f * _ - p * g);
            else if (
              (zt * Lt - Pt * vt) * $ +
                (Pt * bt - It * Lt) * tt +
                (It * vt - zt * bt) * et <
              0
            )
              (dt = It),
                (ut = zt),
                (mt = Pt),
                (nt = St),
                (ot = Mt),
                (rt = Ct),
                (ht = Nt),
                (lt = Et),
                (ct = Tt),
                (it =
                  (p = zt - tt) * (x = Lt - et) -
                  (y = Pt - et) * (_ = vt - tt)),
                (st = y * (g = bt - $) - (f = It - $) * x),
                (at = f * _ - p * g);
            else
              for (var At = !1; ; ) {
                if (
                  ((it =
                    (p = vt - ut) * (x = Pt - mt) -
                    (y = Lt - mt) * (_ = zt - ut)),
                  (st = y * (g = It - dt) - (f = bt - dt) * x),
                  (at = f * _ - p * g),
                  (it *= b = 1 / m.sqrt(it * it + st * st + at * at)) * dt +
                    (st *= b) * ut +
                    (at *= b) * mt >=
                    0 && !At)
                ) {
                  var kt =
                      (ut * Lt - mt * vt) * It +
                      (mt * bt - dt * Lt) * zt +
                      (dt * vt - ut * bt) * Pt,
                    Dt =
                      (zt * Lt - Pt * vt) * $ +
                      (Pt * bt - It * Lt) * tt +
                      (It * vt - zt * bt) * et,
                    Bt =
                      (tt * mt - et * ut) * It +
                      (et * dt - $ * mt) * zt +
                      ($ * ut - tt * dt) * Pt,
                    Vt =
                      (vt * mt - Lt * ut) * $ +
                      (Lt * dt - bt * mt) * tt +
                      (bt * ut - vt * dt) * et,
                    Ot = kt + Dt + Bt + Vt;
                  Ot <= 0 &&
                    ((kt = 0),
                    (Ot =
                      (Dt =
                        (vt * Pt - Lt * zt) * it +
                        (Lt * It - bt * Pt) * st +
                        (bt * zt - vt * It) * at) +
                      (Bt =
                        (zt * Lt - Pt * vt) * it +
                        (Pt * bt - It * Lt) * st +
                        (It * vt - zt * bt) * at) +
                      (Vt =
                        (ut * Lt - mt * vt) * it +
                        (mt * bt - dt * Lt) * st +
                        (dt * vt - ut * bt) * at)));
                  var Rt = 1 / Ot;
                  (v = (k * kt + nt * Dt + ft * Bt + St * Vt) * Rt),
                    (w = (B * kt + ot * Dt + pt * Bt + Mt * Vt) * Rt),
                    (S = (V * kt + rt * Dt + yt * Bt + Ct * Vt) * Rt),
                    (C = (R * kt + ht * Dt + gt * Bt + Nt * Vt) * Rt),
                    (E = (J * kt + lt * Dt + _t * Bt + Et * Vt) * Rt),
                    (z = (Z * kt + ct * Dt + xt * Bt + Tt * Vt) * Rt),
                    (At = !0);
                }
                this.supportPointB(t, -it, -st, -at, A);
                var Ut = A.x,
                  Ft = A.y,
                  Ht = A.z;
                this.supportPointC(e, it, st, at, A);
                var Wt = A.x,
                  Gt = A.y,
                  jt = A.z,
                  Xt = Wt - Ut,
                  Yt = Gt - Ft,
                  qt = jt - Ht,
                  Qt = -(Xt * it + Yt * st + qt * at);
                if (
                  (Xt - It) * it + (Yt - zt) * st + (qt - Pt) * at <= 0.01 ||
                  Qt >= 0
                )
                  return (
                    !!At &&
                    (a.set(-it, -st, -at),
                    n.set(0.5 * (v + C), 0.5 * (w + E), 0.5 * (S + z)),
                    (u.x = Qt),
                    !0)
                  );
                (Yt * mt - qt * ut) * $ +
                  (qt * dt - Xt * mt) * tt +
                  (Xt * ut - Yt * dt) * et <
                0
                  ? (Yt * Lt - qt * vt) * $ +
                      (qt * bt - Xt * Lt) * tt +
                      (Xt * vt - Yt * bt) * et <
                    0
                    ? ((dt = Xt),
                      (ut = Yt),
                      (mt = qt),
                      (nt = Ut),
                      (ot = Ft),
                      (rt = Ht),
                      (ht = Wt),
                      (lt = Gt),
                      (ct = jt))
                    : ((It = Xt),
                      (zt = Yt),
                      (Pt = qt),
                      (St = Ut),
                      (Mt = Ft),
                      (Ct = Ht),
                      (Nt = Wt),
                      (Et = Gt),
                      (Tt = jt))
                  : (Yt * Pt - qt * zt) * $ +
                      (qt * It - Xt * Pt) * tt +
                      (Xt * zt - Yt * It) * et <
                    0
                  ? ((bt = Xt),
                    (vt = Yt),
                    (Lt = qt),
                    (ft = Ut),
                    (pt = Ft),
                    (yt = Ht),
                    (gt = Wt),
                    (_t = Gt),
                    (xt = jt))
                  : ((dt = Xt),
                    (ut = Yt),
                    (mt = qt),
                    (nt = Ut),
                    (ot = Ft),
                    (rt = Ht),
                    (ht = Wt),
                    (lt = Gt),
                    (ct = jt));
              }
          }
        },
        supportPointB: function (t, e, a, n, u) {
          var m,
            f,
            p,
            y = t.rotation.elements,
            g = y[0] * e + y[3] * a + y[6] * n,
            _ = y[1] * e + y[4] * a + y[7] * n,
            x = y[2] * e + y[5] * a + y[8] * n,
            b = t.halfWidth,
            v = t.halfHeight,
            w = t.halfDepth;
          (m = g < 0 ? -b : b),
            (f = _ < 0 ? -v : v),
            (p = x < 0 ? -w : w),
            (g = y[0] * m + y[1] * f + y[2] * p + t.position.x),
            (_ = y[3] * m + y[4] * f + y[5] * p + t.position.y),
            (x = y[6] * m + y[7] * f + y[8] * p + t.position.z),
            u.set(g, _, x);
        },
        supportPointC: function (t, e, a, n, u) {
          var f,
            p,
            y,
            g = t.rotation.elements,
            _ = g[0] * e + g[3] * a + g[6] * n,
            x = g[1] * e + g[4] * a + g[7] * n,
            b = g[2] * e + g[5] * a + g[8] * n,
            v = _,
            w = b,
            S = v * v + w * w,
            C = t.radius,
            E = t.halfHeight;
          0 == S
            ? x < 0
              ? ((f = C), (p = -E), (y = 0))
              : ((f = C), (p = E), (y = 0))
            : ((S = t.radius / m.sqrt(S)),
              x < 0
                ? ((f = v * S), (p = -E), (y = w * S))
                : ((f = v * S), (p = E), (y = w * S))),
            (_ = g[0] * f + g[1] * p + g[2] * y + t.position.x),
            (x = g[3] * f + g[4] * p + g[5] * y + t.position.y),
            (b = g[6] * f + g[7] * p + g[8] * y + t.position.z),
            u.set(_, x, b);
        },
        detectCollision: function (t, e, a) {
          var n, u;
          this.flip ? ((n = e), (u = t)) : ((n = t), (u = e));
          var f = new Vec3(),
            p = new Vec3(),
            y = new Vec3();
          if (this.getSep(n, u, f, p, y)) {
            var g = n.position.x,
              _ = n.position.y,
              x = n.position.z,
              b = u.position.x,
              v = u.position.y,
              w = u.position.z,
              S = n.halfWidth,
              C = n.halfHeight,
              E = n.halfDepth,
              z = u.halfHeight,
              A = u.radius,
              k = n.dimentions,
              B = k[0],
              V = k[1],
              R = k[2],
              J = k[3],
              Z = k[4],
              $ = k[5],
              tt = k[6],
              et = k[7],
              it = k[8],
              st = k[9],
              at = k[10],
              nt = k[11],
              ot = k[12],
              rt = k[13],
              ht = k[14],
              lt = k[15],
              ct = k[16],
              dt = k[17],
              ut = u.normalDirection.x,
              mt = u.normalDirection.y,
              ft = u.normalDirection.z,
              pt = u.halfDirection.x,
              yt = u.halfDirection.y,
              gt = u.halfDirection.z,
              _t = f.x,
              xt = f.y,
              bt = f.z,
              vt = _t * B + xt * V + bt * R,
              Lt = _t * J + xt * Z + bt * $,
              wt = _t * tt + xt * et + bt * it,
              St = _t * ut + xt * mt + bt * ft,
              Mt = vt > 0,
              Ct = Lt > 0,
              Nt = wt > 0,
              Et = St > 0;
            Mt || (vt = -vt),
              Ct || (Lt = -Lt),
              Nt || (wt = -wt),
              Et || (St = -St);
            var Tt,
              It,
              zt,
              Pt,
              At,
              kt,
              Dt,
              Bt,
              Vt,
              Ot,
              Rt,
              Ut,
              Ft,
              Ht,
              Wt,
              Gt,
              jt,
              Xt,
              Yt,
              qt,
              Qt,
              Jt,
              Zt,
              Kt,
              $t,
              te,
              ee,
              ie,
              se,
              ae,
              ne,
              oe,
              re,
              he,
              le,
              ce,
              de,
              ue,
              me,
              fe,
              pe,
              ye,
              ge,
              _e,
              xe,
              be,
              ve,
              Le,
              we,
              Se,
              Me,
              Ce,
              Ne,
              Ee = 0;
            if (
              (St > 0.999
                ? (Ee =
                    vt > 0.999
                      ? vt > St
                        ? 1
                        : 4
                      : Lt > 0.999
                      ? Lt > St
                        ? 2
                        : 4
                      : wt > 0.999 && wt > St
                      ? 3
                      : 4)
                : vt > 0.999
                ? (Ee = 1)
                : Lt > 0.999
                ? (Ee = 2)
                : wt > 0.999 && (Ee = 3),
              0 == Ee)
            )
              a.addPoint(p.x, p.y, p.z, _t, xt, bt, y.x, this.flip);
            else if (4 == Ee) {
              var Te, Ie, ze, Pe, Ae, ke, De, Be, Ve, Oe, Re, Ue;
              Et
                ? ((Pt = b - pt),
                  (At = v - yt),
                  (kt = w - gt),
                  (_t = -ut),
                  (xt = -mt),
                  (bt = -ft))
                : ((Pt = b + pt),
                  (At = v + yt),
                  (kt = w + gt),
                  (_t = ut),
                  (xt = mt),
                  (bt = ft)),
                (Ee = 0),
                (ge = B * _t + V * xt + R * bt) < (qt = 1) &&
                  ((qt = ge), (Ee = 0)),
                -ge < qt && ((qt = -ge), (Ee = 1)),
                (ge = J * _t + Z * xt + $ * bt) < qt && ((qt = ge), (Ee = 2)),
                -ge < qt && ((qt = -ge), (Ee = 3)),
                (ge = tt * _t + et * xt + it * bt) < qt &&
                  ((qt = ge), (Ee = 4)),
                -ge < qt && ((qt = -ge), (Ee = 5));
              var Fe = n.elements;
              switch (Ee) {
                case 0:
                  (Te = Fe[0]),
                    (Ie = Fe[1]),
                    (ze = Fe[2]),
                    (Pe = Fe[6]),
                    (Ae = Fe[7]),
                    (ke = Fe[8]),
                    (De = Fe[9]),
                    (Be = Fe[10]),
                    (Ve = Fe[11]),
                    (Oe = Fe[3]),
                    (Re = Fe[4]),
                    (Ue = Fe[5]);
                  break;
                case 1:
                  (Te = Fe[15]),
                    (Ie = Fe[16]),
                    (ze = Fe[17]),
                    (Pe = Fe[21]),
                    (Ae = Fe[22]),
                    (ke = Fe[23]),
                    (De = Fe[18]),
                    (Be = Fe[19]),
                    (Ve = Fe[20]),
                    (Oe = Fe[12]),
                    (Re = Fe[13]),
                    (Ue = Fe[14]);
                  break;
                case 2:
                  (Te = Fe[12]),
                    (Ie = Fe[13]),
                    (ze = Fe[14]),
                    (Pe = Fe[0]),
                    (Ae = Fe[1]),
                    (ke = Fe[2]),
                    (De = Fe[3]),
                    (Be = Fe[4]),
                    (Ve = Fe[5]),
                    (Oe = Fe[15]),
                    (Re = Fe[16]),
                    (Ue = Fe[17]);
                  break;
                case 3:
                  (Te = Fe[21]),
                    (Ie = Fe[22]),
                    (ze = Fe[23]),
                    (Pe = Fe[9]),
                    (Ae = Fe[10]),
                    (ke = Fe[11]),
                    (De = Fe[6]),
                    (Be = Fe[7]),
                    (Ve = Fe[8]),
                    (Oe = Fe[18]),
                    (Re = Fe[19]),
                    (Ue = Fe[20]);
                  break;
                case 4:
                  (Te = Fe[12]),
                    (Ie = Fe[13]),
                    (ze = Fe[14]),
                    (Pe = Fe[18]),
                    (Ae = Fe[19]),
                    (ke = Fe[20]),
                    (De = Fe[6]),
                    (Be = Fe[7]),
                    (Ve = Fe[8]),
                    (Oe = Fe[0]),
                    (Re = Fe[1]),
                    (Ue = Fe[2]);
                  break;
                case 5:
                  (Te = Fe[3]),
                    (Ie = Fe[4]),
                    (ze = Fe[5]),
                    (Pe = Fe[9]),
                    (Ae = Fe[10]),
                    (ke = Fe[11]),
                    (De = Fe[21]),
                    (Be = Fe[22]),
                    (Ve = Fe[23]),
                    (Oe = Fe[15]),
                    (Re = Fe[16]),
                    (Ue = Fe[17]);
              }
              (Yt = _t * (Te - Pt) + xt * (Ie - At) + bt * (ze - kt)) <= 0 &&
                a.addPoint(Te, Ie, ze, -_t, -xt, -bt, Yt, this.flip),
                (Yt = _t * (Pe - Pt) + xt * (Ae - At) + bt * (ke - kt)) <= 0 &&
                  a.addPoint(Pe, Ae, ke, -_t, -xt, -bt, Yt, this.flip),
                (Yt = _t * (De - Pt) + xt * (Be - At) + bt * (Ve - kt)) <= 0 &&
                  a.addPoint(De, Be, Ve, -_t, -xt, -bt, Yt, this.flip),
                (Yt = _t * (Oe - Pt) + xt * (Re - At) + bt * (Ue - kt)) <= 0 &&
                  a.addPoint(Oe, Re, Ue, -_t, -xt, -bt, Yt, this.flip);
            } else {
              switch (Ee) {
                case 1:
                  Mt
                    ? ((Tt = g + st),
                      (It = _ + at),
                      (zt = x + nt),
                      (_t = B),
                      (xt = V),
                      (bt = R))
                    : ((Tt = g - st),
                      (It = _ - at),
                      (zt = x - nt),
                      (_t = -B),
                      (xt = -V),
                      (bt = -R)),
                    (be = J),
                    (ve = Z),
                    (Le = $),
                    (Ce = C),
                    (we = tt),
                    (Se = et),
                    (Me = it),
                    (Ne = E);
                  break;
                case 2:
                  Ct
                    ? ((Tt = g + ot),
                      (It = _ + rt),
                      (zt = x + ht),
                      (_t = J),
                      (xt = Z),
                      (bt = $))
                    : ((Tt = g - ot),
                      (It = _ - rt),
                      (zt = x - ht),
                      (_t = -J),
                      (xt = -Z),
                      (bt = -$)),
                    (be = B),
                    (ve = V),
                    (Le = R),
                    (Ce = S),
                    (we = tt),
                    (Se = et),
                    (Me = it),
                    (Ne = E);
                  break;
                case 3:
                  Nt
                    ? ((Tt = g + lt),
                      (It = _ + ct),
                      (zt = x + dt),
                      (_t = tt),
                      (xt = et),
                      (bt = it))
                    : ((Tt = g - lt),
                      (It = _ - ct),
                      (zt = x - dt),
                      (_t = -tt),
                      (xt = -et),
                      (bt = -it)),
                    (be = B),
                    (ve = V),
                    (Le = R),
                    (Ce = S),
                    (we = J),
                    (Se = Z),
                    (Me = $),
                    (Ne = C);
              }
              if (
                ((Pt =
                  b +
                  (Qt = (qt = _t * ut + xt * mt + bt * ft) < 0 ? z : -z) * ut),
                (At = v + Qt * mt),
                (kt = w + Qt * ft),
                St >= 0.999999
                  ? ((Jt = -xt), (Zt = bt), (Kt = _t))
                  : ((Jt = _t), (Zt = xt), (Kt = bt)),
                (te = (Qt = Jt * ut + Zt * mt + Kt * ft) * ut - Jt),
                (ee = Qt * mt - Zt),
                (ie = Qt * ft - Kt),
                0 == (Qt = m.sqrt(te * te + ee * ee + ie * ie)))
              )
                return;
              if (
                ((Jt = Pt + (te *= Qt = A / Qt)),
                (Zt = At + (ee *= Qt)),
                (Kt = kt + (ie *= Qt)),
                qt < -0.96 || qt > 0.96)
              )
                (Dt = ut * ut * 1.5 - 0.5),
                  (Bt = ut * mt * 1.5 - 0.866025403 * ft),
                  (Vt = ut * ft * 1.5 + 0.866025403 * mt),
                  (Ot = mt * ut * 1.5 + 0.866025403 * ft),
                  (Rt = mt * mt * 1.5 - 0.5),
                  (Ut = mt * ft * 1.5 - 0.866025403 * ut),
                  (Ft = ft * ut * 1.5 - 0.866025403 * mt),
                  (Ht = ft * mt * 1.5 + 0.866025403 * ut),
                  (Wt = ft * ft * 1.5 - 0.5),
                  (ue =
                    be *
                      (Jt =
                        (Gt = Jt) -
                        (Yt =
                          _t * (Gt - Tt) +
                          xt * ((jt = Zt) - It) +
                          bt * ((Xt = Kt) - zt)) *
                          _t -
                        Tt) +
                    ve * (Zt = jt - Yt * xt - It) +
                    Le * (Kt = Xt - Yt * bt - zt)) < -Ce
                    ? (ue = -Ce)
                    : ue > Ce && (ue = Ce),
                  (ye = we * Jt + Se * Zt + Me * Kt) < -Ne
                    ? (ye = -Ne)
                    : ye > Ne && (ye = Ne),
                  (Gt = Tt + (Jt = ue * be + ye * we)),
                  (jt = It + (Zt = ue * ve + ye * Se)),
                  (Xt = zt + (Kt = ue * Le + ye * Me)),
                  a.addPoint(Gt, jt, Xt, _t, xt, bt, Yt, this.flip),
                  (jt = te * Ot + ee * Rt + ie * Ut),
                  (Xt = te * Ft + ee * Ht + ie * Wt),
                  (Yt =
                    _t *
                      ((Gt = (te = Gt = te * Dt + ee * Bt + ie * Vt) + Pt) -
                        Tt) +
                    xt * ((jt = (ee = jt) + At) - It) +
                    bt * ((Xt = (ie = Xt) + kt) - zt)) <= 0 &&
                    ((ue =
                      be * (Jt = Gt - Yt * _t - Tt) +
                      ve * (Zt = jt - Yt * xt - It) +
                      Le * (Kt = Xt - Yt * bt - zt)) < -Ce
                      ? (ue = -Ce)
                      : ue > Ce && (ue = Ce),
                    (ye = we * Jt + Se * Zt + Me * Kt) < -Ne
                      ? (ye = -Ne)
                      : ye > Ne && (ye = Ne),
                    (Gt = Tt + (Jt = ue * be + ye * we)),
                    (jt = It + (Zt = ue * ve + ye * Se)),
                    (Xt = zt + (Kt = ue * Le + ye * Me)),
                    a.addPoint(Gt, jt, Xt, _t, xt, bt, Yt, this.flip)),
                  (jt = te * Ot + ee * Rt + ie * Ut),
                  (Xt = te * Ft + ee * Ht + ie * Wt),
                  (Yt =
                    _t *
                      ((Gt = (te = Gt = te * Dt + ee * Bt + ie * Vt) + Pt) -
                        Tt) +
                    xt * ((jt = (ee = jt) + At) - It) +
                    bt * ((Xt = (ie = Xt) + kt) - zt)) <= 0 &&
                    ((ue =
                      be * (Jt = Gt - Yt * _t - Tt) +
                      ve * (Zt = jt - Yt * xt - It) +
                      Le * (Kt = Xt - Yt * bt - zt)) < -Ce
                      ? (ue = -Ce)
                      : ue > Ce && (ue = Ce),
                    (ye = we * Jt + Se * Zt + Me * Kt) < -Ne
                      ? (ye = -Ne)
                      : ye > Ne && (ye = Ne),
                    (Gt = Tt + (Jt = ue * be + ye * we)),
                    (jt = It + (Zt = ue * ve + ye * Se)),
                    (Xt = zt + (Kt = ue * Le + ye * Me)),
                    a.addPoint(Gt, jt, Xt, _t, xt, bt, Yt, this.flip));
              else {
                if (
                  ((le = Jt),
                  qt > 0
                    ? ((me = Jt + 2 * pt),
                      (fe = Zt + 2 * yt),
                      (pe = Kt + 2 * gt))
                    : ((me = Jt - 2 * pt),
                      (fe = Zt - 2 * yt),
                      (pe = Kt - 2 * gt)),
                  (Jt =
                    (me -=
                      (ye = _t * (me - Tt) + xt * (fe - It) + bt * (pe - zt)) *
                      _t) -
                    (le -=
                      (ue =
                        _t * (le - Tt) +
                        xt * ((ce = Zt) - It) +
                        bt * ((de = Kt) - zt)) * _t)),
                  (Zt = (fe -= ye * xt) - (ce -= ue * xt)),
                  (Kt = (pe -= ye * bt) - (de -= ue * bt)),
                  ($t = ye - ue),
                  (_e =
                    (Lt =
                      (oe = me - Tt) * be +
                      (re = fe - It) * ve +
                      (he = pe - zt) * Le) - Ce),
                  (ge =
                    (vt =
                      (se = le - Tt) * be +
                      (ae = ce - It) * ve +
                      (ne = de - zt) * Le) - Ce) > 0)
                ) {
                  if (_e > 0) return;
                  (vt =
                    (se = (le += Jt * (xe = ge / (ge - _e))) - Tt) * be +
                    (ae = (ce += Zt * xe) - It) * ve +
                    (ne = (de += Kt * xe) - zt) * Le),
                    (Jt = me - le),
                    (Zt = fe - ce),
                    (Kt = pe - de),
                    ($t = ye - (ue += $t * xe));
                } else
                  _e > 0 &&
                    ((Lt =
                      (oe = (me = le + Jt * (xe = ge / (ge - _e))) - Tt) * be +
                      (re = (fe = ce + Zt * xe) - It) * ve +
                      (he = (pe = de + Kt * xe) - zt) * Le),
                    (Jt = me - le),
                    (Zt = fe - ce),
                    (Kt = pe - de),
                    ($t = (ye = ue + $t * xe) - ue));
                if (((_e = Lt + Ce), (ge = vt + Ce) < 0)) {
                  if (_e < 0) return;
                  (se = (le += Jt * (xe = ge / (ge - _e))) - Tt),
                    (ae = (ce += Zt * xe) - It),
                    (ne = (de += Kt * xe) - zt),
                    (Jt = me - le),
                    (Zt = fe - ce),
                    (Kt = pe - de),
                    ($t = ye - (ue += $t * xe));
                } else
                  _e < 0 &&
                    ((oe = (me = le + Jt * (xe = ge / (ge - _e))) - Tt),
                    (re = (fe = ce + Zt * xe) - It),
                    (he = (pe = de + Kt * xe) - zt),
                    (Jt = me - le),
                    (Zt = fe - ce),
                    (Kt = pe - de),
                    ($t = (ye = ue + $t * xe) - ue));
                if (
                  ((_e = (Lt = oe * we + re * Se + he * Me) - Ne),
                  (ge = (vt = se * we + ae * Se + ne * Me) - Ne) > 0)
                ) {
                  if (_e > 0) return;
                  (vt =
                    (se = (le += Jt * (xe = ge / (ge - _e))) - Tt) * we +
                    (ae = (ce += Zt * xe) - It) * Se +
                    (ne = (de += Kt * xe) - zt) * Me),
                    (Jt = me - le),
                    (Zt = fe - ce),
                    (Kt = pe - de),
                    ($t = ye - (ue += $t * xe));
                } else
                  _e > 0 &&
                    ((Lt =
                      (oe = (me = le + Jt * (xe = ge / (ge - _e))) - Tt) * we +
                      (re = (fe = ce + Zt * xe) - It) * Se +
                      (he = (pe = de + Kt * xe) - zt) * Me),
                    (Jt = me - le),
                    (Zt = fe - ce),
                    (Kt = pe - de),
                    ($t = (ye = ue + $t * xe) - ue));
                if (((_e = Lt + Ne), (ge = vt + Ne) < 0)) {
                  if (_e < 0) return;
                  (le += Jt * (xe = ge / (ge - _e))),
                    (ce += Zt * xe),
                    (de += Kt * xe),
                    (ue += $t * xe);
                } else
                  _e < 0 &&
                    ((me = le + Jt * (xe = ge / (ge - _e))),
                    (fe = ce + Zt * xe),
                    (pe = de + Kt * xe),
                    (ye = ue + $t * xe));
                ue < 0 && a.addPoint(le, ce, de, _t, xt, bt, ue, this.flip),
                  ye < 0 && a.addPoint(me, fe, pe, _t, xt, bt, ye, this.flip);
              }
            }
          }
        },
      }
    )),
    (CylinderCylinderCollisionDetector.prototype = Object.assign(
      Object.create(CollisionDetector.prototype),
      {
        constructor: CylinderCylinderCollisionDetector,
        getSep: function (t, e, a, n, u) {
          var f,
            p,
            y,
            g,
            _,
            x,
            b,
            v,
            w,
            S,
            C,
            E,
            z,
            A = new Vec3(),
            k = t.position.x,
            B = t.position.y,
            V = t.position.z,
            R = e.position.x,
            J = e.position.y,
            Z = e.position.z,
            $ = R - k,
            tt = J - B,
            et = Z - V;
          $ * $ + tt * tt + et * et == 0 && (tt = 0.001);
          var it = -$,
            st = -tt,
            at = -et;
          this.supportPoint(t, -it, -st, -at, A);
          var nt = A.x,
            ot = A.y,
            rt = A.z;
          this.supportPoint(e, it, st, at, A);
          var ht = A.x,
            lt = A.y,
            ct = A.z,
            dt = ht - nt,
            ut = lt - ot,
            mt = ct - rt;
          if (dt * it + ut * st + mt * at <= 0) return !1;
          if (
            (it = ut * et - mt * tt) * it +
              (st = mt * $ - dt * et) * st +
              (at = dt * tt - ut * $) * at ==
            0
          )
            return (
              a.set(dt - $, ut - tt, mt - et).normalize(),
              n.set(0.5 * (nt + ht), 0.5 * (ot + lt), 0.5 * (rt + ct)),
              !0
            );
          this.supportPoint(t, -it, -st, -at, A);
          var ft = A.x,
            pt = A.y,
            yt = A.z;
          this.supportPoint(e, it, st, at, A);
          var gt = A.x,
            _t = A.y,
            xt = A.z,
            bt = gt - ft,
            vt = _t - pt,
            Lt = xt - yt;
          if (bt * it + vt * st + Lt * at <= 0) return !1;
          (it = (p = ut - tt) * (x = Lt - et) - (y = mt - et) * (_ = vt - tt)) *
            $ +
            (st = y * (g = bt - $) - (f = dt - $) * x) * tt +
            (at = f * _ - p * g) * et >
            0 &&
            ((f = dt),
            (p = ut),
            (y = mt),
            (dt = bt),
            (ut = vt),
            (mt = Lt),
            (bt = f),
            (vt = p),
            (Lt = y),
            (f = nt),
            (p = ot),
            (y = rt),
            (nt = ft),
            (ot = pt),
            (rt = yt),
            (ft = f),
            (pt = p),
            (yt = y),
            (f = ht),
            (p = lt),
            (y = ct),
            (ht = gt),
            (lt = _t),
            (ct = xt),
            (gt = f),
            (_t = p),
            (xt = y),
            (it = -it),
            (st = -st),
            (at = -at));
          for (var wt = 0; ; ) {
            if (++wt > 100) return !1;
            this.supportPoint(t, -it, -st, -at, A);
            var St = A.x,
              Mt = A.y,
              Ct = A.z;
            this.supportPoint(e, it, st, at, A);
            var Nt = A.x,
              Et = A.y,
              Tt = A.z,
              It = Nt - St,
              zt = Et - Mt,
              Pt = Tt - Ct;
            if (It * it + zt * st + Pt * at <= 0) return !1;
            if (
              (ut * Pt - mt * zt) * $ +
                (mt * It - dt * Pt) * tt +
                (dt * zt - ut * It) * et <
              0
            )
              (bt = It),
                (vt = zt),
                (Lt = Pt),
                (ft = St),
                (pt = Mt),
                (yt = Ct),
                (gt = Nt),
                (_t = Et),
                (xt = Tt),
                (it =
                  (p = ut - tt) * (x = Pt - et) -
                  (y = mt - et) * (_ = zt - tt)),
                (st = y * (g = It - $) - (f = dt - $) * x),
                (at = f * _ - p * g);
            else if (
              (zt * Lt - Pt * vt) * $ +
                (Pt * bt - It * Lt) * tt +
                (It * vt - zt * bt) * et <
              0
            )
              (dt = It),
                (ut = zt),
                (mt = Pt),
                (nt = St),
                (ot = Mt),
                (rt = Ct),
                (ht = Nt),
                (lt = Et),
                (ct = Tt),
                (it =
                  (p = zt - tt) * (x = Lt - et) -
                  (y = Pt - et) * (_ = vt - tt)),
                (st = y * (g = bt - $) - (f = It - $) * x),
                (at = f * _ - p * g);
            else
              for (var At = !1; ; ) {
                if (
                  ((it =
                    (p = vt - ut) * (x = Pt - mt) -
                    (y = Lt - mt) * (_ = zt - ut)),
                  (st = y * (g = It - dt) - (f = bt - dt) * x),
                  (at = f * _ - p * g),
                  (it *= b = 1 / m.sqrt(it * it + st * st + at * at)) * dt +
                    (st *= b) * ut +
                    (at *= b) * mt >=
                    0 && !At)
                ) {
                  var kt =
                      (ut * Lt - mt * vt) * It +
                      (mt * bt - dt * Lt) * zt +
                      (dt * vt - ut * bt) * Pt,
                    Dt =
                      (zt * Lt - Pt * vt) * $ +
                      (Pt * bt - It * Lt) * tt +
                      (It * vt - zt * bt) * et,
                    Bt =
                      (tt * mt - et * ut) * It +
                      (et * dt - $ * mt) * zt +
                      ($ * ut - tt * dt) * Pt,
                    Vt =
                      (vt * mt - Lt * ut) * $ +
                      (Lt * dt - bt * mt) * tt +
                      (bt * ut - vt * dt) * et,
                    Ot = kt + Dt + Bt + Vt;
                  Ot <= 0 &&
                    ((kt = 0),
                    (Ot =
                      (Dt =
                        (vt * Pt - Lt * zt) * it +
                        (Lt * It - bt * Pt) * st +
                        (bt * zt - vt * It) * at) +
                      (Bt =
                        (zt * Lt - Pt * vt) * it +
                        (Pt * bt - It * Lt) * st +
                        (It * vt - zt * bt) * at) +
                      (Vt =
                        (ut * Lt - mt * vt) * it +
                        (mt * bt - dt * Lt) * st +
                        (dt * vt - ut * bt) * at)));
                  var Rt = 1 / Ot;
                  (v = (k * kt + nt * Dt + ft * Bt + St * Vt) * Rt),
                    (w = (B * kt + ot * Dt + pt * Bt + Mt * Vt) * Rt),
                    (S = (V * kt + rt * Dt + yt * Bt + Ct * Vt) * Rt),
                    (C = (R * kt + ht * Dt + gt * Bt + Nt * Vt) * Rt),
                    (E = (J * kt + lt * Dt + _t * Bt + Et * Vt) * Rt),
                    (z = (Z * kt + ct * Dt + xt * Bt + Tt * Vt) * Rt),
                    (At = !0);
                }
                this.supportPoint(t, -it, -st, -at, A);
                var Ut = A.x,
                  Ft = A.y,
                  Ht = A.z;
                this.supportPoint(e, it, st, at, A);
                var Wt = A.x,
                  Gt = A.y,
                  jt = A.z,
                  Xt = Wt - Ut,
                  Yt = Gt - Ft,
                  qt = jt - Ht,
                  Qt = -(Xt * it + Yt * st + qt * at);
                if (
                  (Xt - It) * it + (Yt - zt) * st + (qt - Pt) * at <= 0.01 ||
                  Qt >= 0
                )
                  return (
                    !!At &&
                    (a.set(-it, -st, -at),
                    n.set(0.5 * (v + C), 0.5 * (w + E), 0.5 * (S + z)),
                    (u.x = Qt),
                    !0)
                  );
                (Yt * mt - qt * ut) * $ +
                  (qt * dt - Xt * mt) * tt +
                  (Xt * ut - Yt * dt) * et <
                0
                  ? (Yt * Lt - qt * vt) * $ +
                      (qt * bt - Xt * Lt) * tt +
                      (Xt * vt - Yt * bt) * et <
                    0
                    ? ((dt = Xt),
                      (ut = Yt),
                      (mt = qt),
                      (nt = Ut),
                      (ot = Ft),
                      (rt = Ht),
                      (ht = Wt),
                      (lt = Gt),
                      (ct = jt))
                    : ((It = Xt),
                      (zt = Yt),
                      (Pt = qt),
                      (St = Ut),
                      (Mt = Ft),
                      (Ct = Ht),
                      (Nt = Wt),
                      (Et = Gt),
                      (Tt = jt))
                  : (Yt * Pt - qt * zt) * $ +
                      (qt * It - Xt * Pt) * tt +
                      (Xt * zt - Yt * It) * et <
                    0
                  ? ((bt = Xt),
                    (vt = Yt),
                    (Lt = qt),
                    (ft = Ut),
                    (pt = Ft),
                    (yt = Ht),
                    (gt = Wt),
                    (_t = Gt),
                    (xt = jt))
                  : ((dt = Xt),
                    (ut = Yt),
                    (mt = qt),
                    (nt = Ut),
                    (ot = Ft),
                    (rt = Ht),
                    (ht = Wt),
                    (lt = Gt),
                    (ct = jt));
              }
          }
        },
        supportPoint: function (t, e, a, n, u) {
          var f,
            p,
            y,
            g = t.rotation.elements,
            _ = g[0] * e + g[3] * a + g[6] * n,
            x = g[1] * e + g[4] * a + g[7] * n,
            b = g[2] * e + g[5] * a + g[8] * n,
            v = _,
            w = b,
            S = v * v + w * w,
            C = t.radius,
            E = t.halfHeight;
          0 == S
            ? x < 0
              ? ((f = C), (p = -E), (y = 0))
              : ((f = C), (p = E), (y = 0))
            : ((S = t.radius / m.sqrt(S)),
              x < 0
                ? ((f = v * S), (p = -E), (y = w * S))
                : ((f = v * S), (p = E), (y = w * S))),
            (_ = g[0] * f + g[1] * p + g[2] * y + t.position.x),
            (x = g[3] * f + g[4] * p + g[5] * y + t.position.y),
            (b = g[6] * f + g[7] * p + g[8] * y + t.position.z),
            u.set(_, x, b);
        },
        detectCollision: function (t, e, a) {
          var n, u;
          t.id < e.id ? ((n = t), (u = e)) : ((n = e), (u = t));
          var f,
            p,
            y,
            g,
            _,
            x,
            b,
            v,
            w,
            S,
            C,
            E,
            z,
            A,
            k,
            B,
            V,
            R,
            J,
            Z,
            $,
            tt = n.position,
            et = u.position,
            it = tt.x,
            st = tt.y,
            at = tt.z,
            nt = et.x,
            ot = et.y,
            rt = et.z,
            ht = n.halfHeight,
            lt = u.halfHeight,
            ct = n.normalDirection,
            dt = u.normalDirection,
            ut = n.halfDirection,
            mt = u.halfDirection,
            ft = n.radius,
            pt = u.radius,
            yt = ct.x,
            gt = ct.y,
            _t = ct.z,
            xt = dt.x,
            bt = dt.y,
            vt = dt.z,
            Lt = ut.x,
            wt = ut.y,
            St = ut.z,
            Mt = mt.x,
            Ct = mt.y,
            Nt = mt.z,
            Et = it - nt,
            Tt = st - ot,
            It = at - rt,
            zt = new Vec3(),
            Pt = new Vec3(),
            At = new Vec3();
          if (this.getSep(n, u, zt, Pt, At)) {
            var kt = zt.x * yt + zt.y * gt + zt.z * _t,
              Dt = zt.x * xt + zt.y * bt + zt.z * vt,
              Bt = kt > 0,
              Vt = Dt > 0;
            Bt || (kt = -kt), Vt || (Dt = -Dt);
            var Ot,
              Rt,
              Ut,
              Ft = 0;
            (kt > 0.999 || Dt > 0.999) && (Ft = kt > Dt ? 1 : 2);
            var Ht,
              Wt,
              Gt,
              jt,
              Xt,
              Yt,
              qt,
              Qt,
              Jt,
              Zt,
              Kt,
              $t,
              te,
              ee,
              ie,
              se,
              ae = At.x;
            switch (((Ot = zt.x), (Rt = zt.y), (Ut = zt.z), Ft)) {
              case 0:
                a.addPoint(Pt.x, Pt.y, Pt.z, Ot, Rt, Ut, ae, !1);
                break;
              case 1:
                if (
                  (Bt
                    ? ((p = it + Lt),
                      (y = st + wt),
                      (g = at + St),
                      (Ot = yt),
                      (Rt = gt),
                      (Ut = _t))
                    : ((p = it - Lt),
                      (y = st - wt),
                      (g = at - St),
                      (Ot = -yt),
                      (Rt = -gt),
                      (Ut = -_t)),
                  (_ =
                    nt +
                    (f = (J = Ot * xt + Rt * bt + Ut * vt) < 0 ? lt : -lt) *
                      xt),
                  (x = ot + f * bt),
                  (b = rt + f * vt),
                  Dt >= 0.999999
                    ? ((v = -Rt), (w = Ut), (S = Ot))
                    : ((v = Ot), (w = Rt), (S = Ut)),
                  (Et = (f = v * xt + w * bt + S * vt) * xt - v),
                  (Tt = f * bt - w),
                  (It = f * vt - S),
                  0 == (f = m.sqrt(Et * Et + Tt * Tt + It * It)))
                )
                  break;
                if (
                  ((v = _ + (Et *= f = pt / f)),
                  (w = x + (Tt *= f)),
                  (S = b + (It *= f)),
                  J < -0.96 || J > 0.96)
                )
                  (Ht = xt * xt * 1.5 - 0.5),
                    (Wt = xt * bt * 1.5 - 0.866025403 * vt),
                    (Gt = xt * vt * 1.5 + 0.866025403 * bt),
                    (jt = bt * xt * 1.5 + 0.866025403 * vt),
                    (Xt = bt * bt * 1.5 - 0.5),
                    (Yt = bt * vt * 1.5 - 0.866025403 * xt),
                    (qt = vt * xt * 1.5 - 0.866025403 * bt),
                    (Qt = vt * bt * 1.5 + 0.866025403 * xt),
                    (Jt = vt * vt * 1.5 - 0.5),
                    (f =
                      (v =
                        (Zt = v) -
                        (te =
                          Ot * (Zt - p) +
                          Rt * ((Kt = w) - y) +
                          Ut * (($t = S) - g)) *
                          Ot -
                        p) *
                        v +
                      (w = Kt - te * Rt - y) * w +
                      (S = $t - te * Ut - g) * S) >
                      ft * ft &&
                      ((v *= f = ft / m.sqrt(f)), (w *= f), (S *= f)),
                    (Zt = p + v),
                    (Kt = y + w),
                    ($t = g + S),
                    a.addPoint(Zt, Kt, $t, Ot, Rt, Ut, te, !1),
                    (Kt = Et * jt + Tt * Xt + It * Yt),
                    ($t = Et * qt + Tt * Qt + It * Jt),
                    (te =
                      Ot *
                        ((Zt = (Et = Zt = Et * Ht + Tt * Wt + It * Gt) + _) -
                          p) +
                      Rt * ((Kt = (Tt = Kt) + x) - y) +
                      Ut * (($t = (It = $t) + b) - g)) <= 0 &&
                      ((f =
                        (v = Zt - te * Ot - p) * v +
                        (w = Kt - te * Rt - y) * w +
                        (S = $t - te * Ut - g) * S) >
                        ft * ft &&
                        ((v *= f = ft / m.sqrt(f)), (w *= f), (S *= f)),
                      (Zt = p + v),
                      (Kt = y + w),
                      ($t = g + S),
                      a.addPoint(Zt, Kt, $t, Ot, Rt, Ut, te, !1)),
                    (Kt = Et * jt + Tt * Xt + It * Yt),
                    ($t = Et * qt + Tt * Qt + It * Jt),
                    (te =
                      Ot *
                        ((Zt = (Et = Zt = Et * Ht + Tt * Wt + It * Gt) + _) -
                          p) +
                      Rt * ((Kt = (Tt = Kt) + x) - y) +
                      Ut * (($t = (It = $t) + b) - g)) <= 0 &&
                      ((f =
                        (v = Zt - te * Ot - p) * v +
                        (w = Kt - te * Rt - y) * w +
                        (S = $t - te * Ut - g) * S) >
                        ft * ft &&
                        ((v *= f = ft / m.sqrt(f)), (w *= f), (S *= f)),
                      (Zt = p + v),
                      (Kt = y + w),
                      ($t = g + S),
                      a.addPoint(Zt, Kt, $t, Ot, Rt, Ut, te, !1));
                else {
                  if (
                    ((C = v),
                    J > 0
                      ? ((A = v + xt * lt * 2),
                        (k = w + bt * lt * 2),
                        (B = S + vt * lt * 2))
                      : ((A = v - xt * lt * 2),
                        (k = w - bt * lt * 2),
                        (B = S - vt * lt * 2)),
                    (se =
                      (ee =
                        (Et =
                          p -
                          (C -=
                            (V =
                              Ot * (C - p) +
                              Rt * ((E = w) - y) +
                              Ut * ((z = S) - g)) * Ot)) *
                          (v =
                            (A -=
                              (R = Ot * (A - p) + Rt * (k - y) + Ut * (B - g)) *
                              Ot) - C) +
                        (Tt = y - (E -= V * Rt)) * (w = (k -= R * Rt) - E) +
                        (It = g - (z -= V * Ut)) * (S = (B -= R * Ut) - z)) *
                        ee -
                      (ie = v * v + w * w + S * S) *
                        (Et * Et + Tt * Tt + It * It - ft * ft)) < 0)
                  )
                    break;
                  ($ = (ee - (se = m.sqrt(se))) / ie) < (Z = (ee + se) / ie) &&
                    ((f = Z), (Z = $), ($ = f)),
                    $ > 1 && ($ = 1),
                    Z < 0 && (Z = 0),
                    (v = C + (A - C) * Z),
                    (w = E + (k - E) * Z),
                    (S = z + (B - z) * Z),
                    (A = C + (A - C) * $),
                    (k = E + (k - E) * $),
                    (B = z + (B - z) * $),
                    (C = v),
                    (E = w),
                    (z = S),
                    (f = V + (R - V) * Z),
                    (R = V + (R - V) * $),
                    (V = f) < 0 && a.addPoint(C, E, z, Ot, Rt, Ut, te, !1),
                    R < 0 && a.addPoint(A, k, B, Ot, Rt, Ut, te, !1);
                }
                break;
              case 2:
                if (
                  (Vt
                    ? ((_ = nt - Mt),
                      (x = ot - Ct),
                      (b = rt - Nt),
                      (Ot = -xt),
                      (Rt = -bt),
                      (Ut = -vt))
                    : ((_ = nt + Mt),
                      (x = ot + Ct),
                      (b = rt + Nt),
                      (Ot = xt),
                      (Rt = bt),
                      (Ut = vt)),
                  (p =
                    it +
                    (f = (J = Ot * yt + Rt * gt + Ut * _t) < 0 ? ht : -ht) *
                      yt),
                  (y = st + f * gt),
                  (g = at + f * _t),
                  kt >= 0.999999
                    ? ((v = -Rt), (w = Ut), (S = Ot))
                    : ((v = Ot), (w = Rt), (S = Ut)),
                  (Et = (f = v * yt + w * gt + S * _t) * yt - v),
                  (Tt = f * gt - w),
                  (It = f * _t - S),
                  0 == (f = m.sqrt(Et * Et + Tt * Tt + It * It)))
                )
                  break;
                if (
                  ((v = p + (Et *= f = ft / f)),
                  (w = y + (Tt *= f)),
                  (S = g + (It *= f)),
                  J < -0.96 || J > 0.96)
                )
                  (Ht = yt * yt * 1.5 - 0.5),
                    (Wt = yt * gt * 1.5 - 0.866025403 * _t),
                    (Gt = yt * _t * 1.5 + 0.866025403 * gt),
                    (jt = gt * yt * 1.5 + 0.866025403 * _t),
                    (Xt = gt * gt * 1.5 - 0.5),
                    (Yt = gt * _t * 1.5 - 0.866025403 * yt),
                    (qt = _t * yt * 1.5 - 0.866025403 * gt),
                    (Qt = _t * gt * 1.5 + 0.866025403 * yt),
                    (Jt = _t * _t * 1.5 - 0.5),
                    (f =
                      (v =
                        (Zt = v) -
                        (te =
                          Ot * (Zt - _) +
                          Rt * ((Kt = w) - x) +
                          Ut * (($t = S) - b)) *
                          Ot -
                        _) *
                        v +
                      (w = Kt - te * Rt - x) * w +
                      (S = $t - te * Ut - b) * S) >
                      pt * pt &&
                      ((v *= f = pt / m.sqrt(f)), (w *= f), (S *= f)),
                    (Zt = _ + v),
                    (Kt = x + w),
                    ($t = b + S),
                    a.addPoint(Zt, Kt, $t, -Ot, -Rt, -Ut, te, !1),
                    (Kt = Et * jt + Tt * Xt + It * Yt),
                    ($t = Et * qt + Tt * Qt + It * Jt),
                    (te =
                      Ot *
                        ((Zt = (Et = Zt = Et * Ht + Tt * Wt + It * Gt) + p) -
                          _) +
                      Rt * ((Kt = (Tt = Kt) + y) - x) +
                      Ut * (($t = (It = $t) + g) - b)) <= 0 &&
                      ((f =
                        (v = Zt - te * Ot - _) * v +
                        (w = Kt - te * Rt - x) * w +
                        (S = $t - te * Ut - b) * S) >
                        pt * pt &&
                        ((v *= f = pt / m.sqrt(f)), (w *= f), (S *= f)),
                      (Zt = _ + v),
                      (Kt = x + w),
                      ($t = b + S),
                      a.addPoint(Zt, Kt, $t, -Ot, -Rt, -Ut, te, !1)),
                    (Kt = Et * jt + Tt * Xt + It * Yt),
                    ($t = Et * qt + Tt * Qt + It * Jt),
                    (te =
                      Ot *
                        ((Zt = (Et = Zt = Et * Ht + Tt * Wt + It * Gt) + p) -
                          _) +
                      Rt * ((Kt = (Tt = Kt) + y) - x) +
                      Ut * (($t = (It = $t) + g) - b)) <= 0 &&
                      ((f =
                        (v = Zt - te * Ot - _) * v +
                        (w = Kt - te * Rt - x) * w +
                        (S = $t - te * Ut - b) * S) >
                        pt * pt &&
                        ((v *= f = pt / m.sqrt(f)), (w *= f), (S *= f)),
                      (Zt = _ + v),
                      (Kt = x + w),
                      ($t = b + S),
                      a.addPoint(Zt, Kt, $t, -Ot, -Rt, -Ut, te, !1));
                else {
                  if (
                    ((C = v),
                    J > 0
                      ? ((A = v + yt * ht * 2),
                        (k = w + gt * ht * 2),
                        (B = S + _t * ht * 2))
                      : ((A = v - yt * ht * 2),
                        (k = w - gt * ht * 2),
                        (B = S - _t * ht * 2)),
                    (se =
                      (ee =
                        (Et =
                          _ -
                          (C -=
                            (V =
                              Ot * (C - _) +
                              Rt * ((E = w) - x) +
                              Ut * ((z = S) - b)) * Ot)) *
                          (v =
                            (A -=
                              (R = Ot * (A - _) + Rt * (k - x) + Ut * (B - b)) *
                              Ot) - C) +
                        (Tt = x - (E -= V * Rt)) * (w = (k -= R * Rt) - E) +
                        (It = b - (z -= V * Ut)) * (S = (B -= R * Ut) - z)) *
                        ee -
                      (ie = v * v + w * w + S * S) *
                        (Et * Et + Tt * Tt + It * It - pt * pt)) < 0)
                  )
                    break;
                  ($ = (ee - (se = m.sqrt(se))) / ie) < (Z = (ee + se) / ie) &&
                    ((f = Z), (Z = $), ($ = f)),
                    $ > 1 && ($ = 1),
                    Z < 0 && (Z = 0),
                    (v = C + (A - C) * Z),
                    (w = E + (k - E) * Z),
                    (S = z + (B - z) * Z),
                    (A = C + (A - C) * $),
                    (k = E + (k - E) * $),
                    (B = z + (B - z) * $),
                    (C = v),
                    (E = w),
                    (z = S),
                    (f = V + (R - V) * Z),
                    (R = V + (R - V) * $),
                    (V = f) < 0 && a.addPoint(C, E, z, -Ot, -Rt, -Ut, V, !1),
                    R < 0 && a.addPoint(A, k, B, -Ot, -Rt, -Ut, R, !1);
                }
            }
          }
        },
      }
    )),
    (SphereBoxCollisionDetector.prototype = Object.assign(
      Object.create(CollisionDetector.prototype),
      {
        constructor: SphereBoxCollisionDetector,
        detectCollision: function (t, e, a) {
          var n, u;
          this.flip ? ((n = e), (u = t)) : ((n = t), (u = e));
          var f,
            p,
            y,
            g,
            _,
            x = u.dimentions,
            b = n.position,
            v = b.x,
            w = b.y,
            S = b.z,
            C = u.position,
            E = C.x,
            z = C.y,
            A = C.z,
            k = n.radius,
            B = u.halfWidth,
            V = u.halfHeight,
            R = u.halfDepth,
            J = v - E,
            Z = w - z,
            $ = S - A,
            tt = x[0] * J + x[1] * Z + x[2] * $,
            et = x[3] * J + x[4] * Z + x[5] * $,
            it = x[6] * J + x[7] * Z + x[8] * $,
            st = 0;
          tt > B ? (tt = B) : tt < -B ? (tt = -B) : (st = 1),
            et > V ? (et = V) : et < -V ? (et = -V) : (st |= 2),
            it > R ? (it = R) : it < -R ? (it = -R) : (st |= 4),
            7 == st
              ? (($ = it < 0 ? R + it : R - it),
                (J = tt < 0 ? B + tt : B - tt) < (Z = et < 0 ? V + et : V - et)
                  ? J < $
                    ? ((g = J - B),
                      tt < 0
                        ? ((tt = -B), (J = x[0]), (Z = x[1]), ($ = x[2]))
                        : ((tt = B), (J = -x[0]), (Z = -x[1]), ($ = -x[2])))
                    : ((g = $ - R),
                      it < 0
                        ? ((it = -R), (J = x[6]), (Z = x[7]), ($ = x[8]))
                        : ((it = R), (J = -x[6]), (Z = -x[7]), ($ = -x[8])))
                  : Z < $
                  ? ((g = Z - V),
                    et < 0
                      ? ((et = -V), (J = x[3]), (Z = x[4]), ($ = x[5]))
                      : ((et = V), (J = -x[3]), (Z = -x[4]), ($ = -x[5])))
                  : ((g = $ - R),
                    it < 0
                      ? ((it = -R), (J = x[6]), (Z = x[7]), ($ = x[8]))
                      : ((it = R), (J = -x[6]), (Z = -x[7]), ($ = -x[8]))),
                a.addPoint(
                  v + k * J,
                  w + k * Z,
                  S + k * $,
                  J,
                  Z,
                  $,
                  g - k,
                  this.flip
                ))
              : ((f = E + tt * x[0] + et * x[3] + it * x[6]),
                (p = z + tt * x[1] + et * x[4] + it * x[7]),
                (y = A + tt * x[2] + et * x[5] + it * x[8]),
                (g =
                  (J = f - b.x) * J + (Z = p - b.y) * Z + ($ = y - b.z) * $) >
                  0 &&
                  g < k * k &&
                  ((J *= _ = 1 / (g = m.sqrt(g))),
                  (Z *= _),
                  ($ *= _),
                  a.addPoint(
                    v + k * J,
                    w + k * Z,
                    S + k * $,
                    J,
                    Z,
                    $,
                    g - k,
                    this.flip
                  )));
        },
      }
    )),
    (SphereCylinderCollisionDetector.prototype = Object.assign(
      Object.create(CollisionDetector.prototype),
      {
        constructor: SphereCylinderCollisionDetector,
        detectCollision: function (t, e, a) {
          var n, u;
          this.flip ? ((n = e), (u = t)) : ((n = t), (u = e));
          var f = n.position,
            p = f.x,
            y = f.y,
            g = f.z,
            _ = u.position,
            x = _.x,
            b = _.y,
            v = _.z,
            w = u.normalDirection.x,
            S = u.normalDirection.y,
            C = u.normalDirection.z,
            E = n.radius,
            z = u.radius,
            A = E + z,
            k = u.halfHeight,
            B = p - x,
            V = y - b,
            R = g - v,
            J = B * w + V * S + R * C;
          if (!(J < -k - E || J > k + E)) {
            var Z,
              $ = x + J * w,
              tt = b + J * S,
              et = v + J * C,
              it = p - $,
              st = y - tt,
              at = g - et,
              nt = it * it + st * st + at * at;
            if (!(nt > A * A))
              nt > z * z &&
                ((it *= nt = z / m.sqrt(nt)), (st *= nt), (at *= nt)),
                J < -k ? (J = -k) : J > k && (J = k),
                (B = ($ = x + J * w + it) - p),
                (V = (tt = b + J * S + st) - y),
                (R = (et = v + J * C + at) - g),
                (nt = Math.max(B * B + V * V + R * R, 0.001)) > 0 &&
                  nt < E * E &&
                  ((B *= Z = 1 / (nt = m.sqrt(nt))),
                  (V *= Z),
                  (R *= Z),
                  a.addPoint(
                    p + B * E,
                    y + V * E,
                    g + R * E,
                    B,
                    V,
                    R,
                    nt - E,
                    this.flip
                  ));
          }
        },
      }
    )),
    (SphereSphereCollisionDetector.prototype = Object.assign(
      Object.create(CollisionDetector.prototype),
      {
        constructor: SphereSphereCollisionDetector,
        detectCollision: function (t, e, a) {
          var n = t,
            u = e,
            f = n.position,
            p = u.position,
            y = p.x - f.x,
            g = p.y - f.y,
            _ = p.z - f.z,
            x = y * y + g * g + _ * _,
            b = n.radius,
            v = b + u.radius;
          if (x > 0 && x < v * v) {
            var w = 1 / (x = m.sqrt(x));
            (y *= w),
              (g *= w),
              (_ *= w),
              a.addPoint(
                f.x + y * b,
                f.y + g * b,
                f.z + _ * b,
                y,
                g,
                _,
                x - v,
                !1
              );
          }
        },
      }
    )),
    (SpherePlaneCollisionDetector.prototype = Object.assign(
      Object.create(CollisionDetector.prototype),
      {
        constructor: SpherePlaneCollisionDetector,
        detectCollision: function (t, e, a) {
          var n,
            u = this.n,
            f = this.p,
            p = this.flip ? e : t,
            y = this.flip ? t : e,
            g = p.radius;
          u.sub(p.position, y.position),
            (u.x *= y.normal.x),
            (u.y *= y.normal.y),
            (u.z *= y.normal.z),
            (n = u.lengthSq()) > 0 &&
              n < g * g &&
              ((n = m.sqrt(n)),
              u.copy(y.normal).negate(),
              f.copy(p.position).addScaledVector(u, g),
              a.addPointVec(f, u, n - g, this.flip));
        },
      }
    )),
    (BoxPlaneCollisionDetector.prototype = Object.assign(
      Object.create(CollisionDetector.prototype),
      {
        constructor: BoxPlaneCollisionDetector,
        detectCollision: function (t, e, a) {
          var n,
            u = this.n,
            f = this.p,
            p = this.cc,
            y = this.flip ? e : t,
            g = this.flip ? t : e,
            _ = y.dimentions,
            x = y.halfWidth,
            b = y.halfHeight,
            v = y.halfDepth,
            w = 0;
          this.dix.set(_[0], _[1], _[2]),
            this.diy.set(_[3], _[4], _[5]),
            this.diz.set(_[6], _[7], _[8]),
            u.sub(y.position, g.position),
            (u.x *= g.normal.x),
            (u.y *= g.normal.y),
            (u.z *= g.normal.z),
            p.set(
              m.dotVectors(this.dix, u),
              m.dotVectors(this.diy, u),
              m.dotVectors(this.diz, u)
            ),
            p.x > x ? (p.x = x) : p.x < -x ? (p.x = -x) : (w = 1),
            p.y > b ? (p.y = b) : p.y < -b ? (p.y = -b) : (w |= 2),
            p.z > v ? (p.z = v) : p.z < -v ? (p.z = -v) : (w |= 4),
            7 === w &&
              (u.set(
                p.x < 0 ? x + p.x : x - p.x,
                p.y < 0 ? b + p.y : b - p.y,
                p.z < 0 ? v + p.z : v - p.z
              ),
              u.x < u.y
                ? u.x < u.z
                  ? ((n = u.x - x),
                    p.x < 0
                      ? ((p.x = -x), u.copy(this.dix))
                      : ((p.x = x), u.subEqual(this.dix)))
                  : ((n = u.z - v),
                    p.z < 0
                      ? ((p.z = -v), u.copy(this.diz))
                      : ((p.z = v), u.subEqual(this.diz)))
                : u.y < u.z
                ? ((n = u.y - b),
                  p.y < 0
                    ? ((p.y = -b), u.copy(this.diy))
                    : ((p.y = b), u.subEqual(this.diy)))
                : ((n = u.z - v),
                  p.z < 0
                    ? ((p.z = -v), u.copy(this.diz))
                    : ((p.z = v), u.subEqual(this.diz))),
              f.copy(g.position).addScaledVector(u, 1),
              a.addPointVec(f, u, n, this.flip));
        },
      }
    )),
    (World.SLEEP_LINEAR_VELOCITY = 0.04),
    (World.SLEEP_ANGULAR_VELOCITY = 0.25),
    (World.SLEEP_DELTA_TIME = 0.5),
    (World.FIX_PENETRATE_SQ = 0.01),
    Object.assign(World.prototype, {
      World: !0,
      play: function () {
        if (null === this.timer) {
          var t = this;
          this.timer = setInterval(function () {
            t.step();
          }, this.timerate);
        }
      },
      stop: function () {
        null !== this.timer && (clearInterval(this.timer), (this.timer = null));
      },
      setGravity: function (t) {
        this.gravity.fromArray(t);
      },
      getInfo: function () {
        return this.isStat ? this.performance.show() : "";
      },
      clear: function () {
        for (
          this.stop(),
            this.preLoop = null,
            this.postLoop = null,
            this.randX = 65535;
          null !== this.joints;

        )
          this.removeJoint(this.joints);
        for (; null !== this.contacts; ) this.removeContact(this.contacts);
        for (; null !== this.rigidBodies; )
          this.removeRigidBody(this.rigidBodies);
      },
      addRigidBody: function (t) {
        t.parent &&
          printError(
            "World",
            "It is not possible to be added to more than one world one of the rigid body"
          ),
          t.setParent(this);
        for (var e = t.shapes; null !== e; e = e.next) this.addShape(e);
        null !== this.rigidBodies &&
          ((this.rigidBodies.prev = t).next = this.rigidBodies),
          (this.rigidBodies = t),
          this.numRigidBodies++;
      },
      removeRigidBody: function (t) {
        var e = t;
        if (e.parent === this) {
          e.awake();
          for (var a = e.jointLink; null != a; ) {
            var n = a.joint;
            (a = a.next), this.removeJoint(n);
          }
          for (var u = t.shapes; null !== u; u = u.next) this.removeShape(u);
          var m = e.prev,
            f = e.next;
          null !== m && (m.next = f),
            null !== f && (f.prev = m),
            this.rigidBodies == e && (this.rigidBodies = f),
            (e.prev = null),
            (e.next = null),
            (e.parent = null),
            this.numRigidBodies--;
        }
      },
      getByName: function (t) {
        for (var e = this.rigidBodies; null !== e; ) {
          if (e.name === t) return e;
          e = e.next;
        }
        for (var a = this.joints; null !== a; ) {
          if (a.name === t) return a;
          a = a.next;
        }
        return null;
      },
      addShape: function (t) {
        (t.parent && t.parent.parent) ||
          printError(
            "World",
            "It is not possible to be added alone to shape world"
          ),
          (t.proxy = this.broadPhase.createProxy(t)),
          t.updateProxy(),
          this.broadPhase.addProxy(t.proxy);
      },
      removeShape: function (t) {
        this.broadPhase.removeProxy(t.proxy), (t.proxy = null);
      },
      addJoint: function (t) {
        t.parent &&
          printError(
            "World",
            "It is not possible to be added to more than one world one of the joint"
          ),
          null != this.joints && ((this.joints.prev = t).next = this.joints),
          (this.joints = t),
          t.setParent(this),
          this.numJoints++,
          t.awake(),
          t.attach();
      },
      removeJoint: function (t) {
        var e = t,
          a = e.prev,
          n = e.next;
        null !== a && (a.next = n),
          null !== n && (n.prev = a),
          this.joints == e && (this.joints = n),
          (e.prev = null),
          (e.next = null),
          this.numJoints--,
          e.awake(),
          e.detach(),
          (e.parent = null);
      },
      addContact: function (t, e) {
        var a;
        null !== this.unusedContacts
          ? ((a = this.unusedContacts),
            (this.unusedContacts = this.unusedContacts.next))
          : (a = new Contact()),
          a.attach(t, e),
          (a.detector = this.detectors[t.type][e.type]),
          (a.world = this),
          this.contacts && ((this.contacts.prev = a).next = this.contacts),
          (this.contacts = a),
          this.numContacts++;
      },
      removeContact: function (t) {
        var e = t.prev,
          a = t.next;
        a && (a.prev = e),
          e && (e.next = a),
          this.contacts == t && (this.contacts = a),
          (t.prev = null),
          (t.next = null),
          t.detach(),
          (t.next = this.unusedContacts),
          (this.unusedContacts = t),
          this.numContacts--;
      },
      getContact: function (t, e) {
        var a, n;
        (t = t.constructor === RigidBody ? t.name : t),
          (e = e.constructor === RigidBody ? e.name : e);
        for (var u = this.contacts; null !== u; ) {
          if (
            ((a = u.body1.name),
            (n = u.body2.name),
            (a === t && n === e) || (n === t && a === e))
          )
            return u.touching ? u : null;
          u = u.next;
        }
        return null;
      },
      checkContact: function (t, e) {
        for (var a, n, u = this.contacts; null !== u; ) {
          if (
            ((a = u.body1.name || " "),
            (n = u.body2.name || " "),
            (a == t && n == e) || (n == t && a == e))
          )
            return !!u.touching;
          u = u.next;
        }
      },
      callSleep: function (t) {
        return (
          !!t.allowSleep &&
          !(t.linearVelocity.lengthSq() > World.SLEEP_LINEAR_VELOCITY) &&
          !(t.angularVelocity.lengthSq() > World.SLEEP_ANGULAR_VELOCITY)
        );
      },
      step: function () {
        var t = this.isStat;
        t && this.performance.setTime(0);
        for (var e = this.rigidBodies; null !== e; )
          (e.addedToIsland = !1), e.sleeping && e.testWakeUp(), (e = e.next);
        t && this.performance.setTime(1), this.broadPhase.detectPairs();
        for (
          var a = this.broadPhase.pairs, n = this.broadPhase.numPairs;
          n--;

        ) {
          var u,
            m,
            f,
            p = a[n];
          p.shape1.id < p.shape2.id
            ? ((u = p.shape1), (m = p.shape2))
            : ((u = p.shape2), (m = p.shape1)),
            (f = u.numContacts < m.numContacts ? u.contactLink : m.contactLink);
          for (var y = !1; f; ) {
            if ((B = f.contact).shape1 == u && B.shape2 == m) {
              (B.persisting = !0), (y = !0);
              break;
            }
            f = f.next;
          }
          y || this.addContact(u, m);
        }
        for (
          t && this.performance.calcBroadPhase(),
            this.numContactPoints = 0,
            B = this.contacts;
          null !== B;

        )
          if (
            B.persisting ||
            (B.shape1.proxy &&
              B.shape2.proxy &&
              !B.shape1.aabb.intersectTest(B.shape2.aabb))
          ) {
            var g = B.body1,
              _ = B.body2;
            ((g.isDynamic && !g.sleeping) || (_.isDynamic && !_.sleeping)) &&
              B.updateManifold(),
              (this.numContactPoints += B.manifold.numPoints),
              (B.persisting = !1),
              (B.constraint.addedToIsland = !1),
              (B = B.next);
          } else {
            var x = B.next;
            this.removeContact(B), (B = x);
          }
        t && this.performance.calcNarrowPhase();
        var b,
          v,
          w = 1 / this.timeStep;
        for (b = this.joints; null !== b; b = b.next) b.addedToIsland = !1;
        (this.islandRigidBodies = []),
          (this.islandConstraints = []),
          (this.islandStack = []),
          t && this.performance.setTime(1),
          (this.numIslands = 0);
        for (var S = this.rigidBodies; null !== S; S = S.next) {
          if (S.event_cb) {
            let t = [],
              e = S.contactLink;
            for (; e; ) {
              let a = e.contact;
              t.push(a), (e = e.next);
            }
            S.event_cb(t);
          }
          if (!(S.addedToIsland || S.isStatic || S.sleeping))
            if (S.isLonely()) {
              if (S.isDynamic) {
                var C = S.overrideGravity || this.gravity;
                S.linearVelocity.addScaledVector(C, this.timeStep);
              }
              this.callSleep(S)
                ? ((S.sleepTime += this.timeStep),
                  S.sleepTime > World.SLEEP_DELTA_TIME
                    ? S.sleep()
                    : S.updatePosition(this.timeStep))
                : ((S.sleepTime = 0), S.updatePosition(this.timeStep)),
                this.numIslands++;
            } else {
              var E = 0,
                z = 0,
                A = 1;
              (this.islandStack[0] = S), (S.addedToIsland = !0);
              do {
                if (
                  ((e = this.islandStack[--A]),
                  (this.islandStack[A] = null),
                  (e.sleeping = !1),
                  (this.islandRigidBodies[E++] = e),
                  !e.isStatic)
                ) {
                  for (var k = e.contactLink; null !== k; k = k.next) {
                    var B;
                    if (
                      !(v = (B = k.contact).constraint).addedToIsland &&
                      B.touching
                    )
                      (this.islandConstraints[z++] = v),
                        (v.addedToIsland = !0),
                        (x = k.body).addedToIsland ||
                          ((this.islandStack[A++] = x), (x.addedToIsland = !0));
                  }
                  for (var V = e.jointLink; null !== V; V = V.next)
                    (v = V.joint).addedToIsland ||
                      ((this.islandConstraints[z++] = v),
                      (v.addedToIsland = !0),
                      !(x = V.body).addedToIsland &&
                        x.isDynamic &&
                        ((this.islandStack[A++] = x), (x.addedToIsland = !0)));
                }
              } while (0 != A);
              for (var R = E; R--; )
                if ((e = this.islandRigidBodies[R]).isDynamic) {
                  C = e.overrideGravity || this.gravity;
                  e.linearVelocity.addScaledVector(C, this.timeStep);
                }
              if (this.enableRandomizer)
                for (R = z; R--; )
                  if (0 !== R) {
                    var J =
                      (((this.randX =
                        (this.randX * this.randA + this.randB) & 2147483647) /
                        2147483648) *
                        R) |
                      0;
                    (v = this.islandConstraints[R]),
                      (this.islandConstraints[R] = this.islandConstraints[J]),
                      (this.islandConstraints[J] = v);
                  }
              for (R = z; R--; )
                this.islandConstraints[R].preSolve(this.timeStep, w);
              for (var Z = this.numIterations; Z--; )
                for (R = z; R--; ) this.islandConstraints[R].solve();
              for (R = z; R--; )
                this.islandConstraints[R].postSolve(),
                  (this.islandConstraints[R] = null);
              var $ = 10;
              for (R = E; R--; )
                (e = this.islandRigidBodies[R]),
                  this.callSleep(e)
                    ? ((e.sleepTime += this.timeStep),
                      e.sleepTime < $ && ($ = e.sleepTime))
                    : ((e.sleepTime = 0), ($ = 0));
              if ($ > World.SLEEP_DELTA_TIME)
                for (R = E; R--; )
                  this.islandRigidBodies[R].sleep(),
                    (this.islandRigidBodies[R] = null);
              else
                for (R = E; R--; )
                  this.islandRigidBodies[R].updatePosition(this.timeStep),
                    (this.islandRigidBodies[R] = null);
              this.numIslands++;
            }
        }
        t && this.performance.calcEnd(),
          null !== this.postLoop && this.postLoop();
      },
      remove: function (t) {},
      add: function (t) {
        var e = (t = t || {}).type || "box";
        return (
          e.constructor === String && (e = [e]),
          "joint" === e[0].substring(0, 5)
            ? this.initJoint(e[0], t)
            : this.initBody(e, t)
        );
      },
      initBody: function (t, e) {
        var a = this.invScale,
          n = e.move || !1,
          u = e.kinematic || !1,
          m = e.pos || [0, 0, 0];
        m = m.map(function (t) {
          return t * a;
        });
        var f = e.posShape || [0, 0, 0];
        f = f.map(function (t) {
          return t * a;
        });
        var p = e.rot || [0, 0, 0, 1],
          y = e.rotShape || [0, 0, 0, 1],
          g = void 0 === e.size ? [1, 1, 1] : e.size;
        1 === g.length && (g[1] = g[0]),
          2 === g.length && (g[2] = g[0]),
          (g = g.map(function (t) {
            return t * a;
          }));
        var _ = new ShapeConfig();
        void 0 !== e.density && (_.density = e.density),
          void 0 !== e.friction && (_.friction = e.friction),
          void 0 !== e.restitution && (_.restitution = e.restitution),
          void 0 !== e.belongsTo && (_.belongsTo = e.belongsTo),
          void 0 !== e.collidesWith && (_.collidesWith = e.collidesWith),
          void 0 !== e.config &&
            (void 0 !== e.config[0] && (_.density = e.config[0]),
            void 0 !== e.config[1] && (_.friction = e.config[1]),
            void 0 !== e.config[2] && (_.restitution = e.config[2]),
            void 0 !== e.config[3] && (_.belongsTo = e.config[3]),
            void 0 !== e.config[4] && (_.collidesWith = e.config[4]));
        for (
          var x,
            b,
            v,
            w = new RigidBody(
              new Vec3(m[0], m[1], m[2]),
              new Quat(p[0], p[1], p[2], p[3])
            ),
            S = 0;
          S < t.length;
          S++
        ) {
          switch (
            ((v = 4 * S),
            void 0 !== f[(b = 3 * S)] &&
              _.relativePosition.set(f[b], f[b + 1], f[b + 2]),
            void 0 !== y[v] &&
              _.relativeRotation.setQuat(
                new Quat(y[v], y[v + 1], y[v + 2], y[v + 3])
              ),
            void 0 !== y[v] &&
              (_.localRotation = new Quat(y[v], y[v + 1], y[v + 2], y[v + 3])),
            t[S])
          ) {
            case "sphere":
              x = new Sphere(_, g[b]);
              break;
            case "cylinder":
              x = new Cylinder(_, g[b], g[b + 1]);
              break;
            case "box":
              x = new Box(_, g[b], g[b + 1], g[b + 2]);
              break;
            case "plane":
              x = new Plane(_);
          }
          e.nameShape && e.nameShape[S] && (x.name = e.nameShape[S]),
            e.massShape && e.massShape[S] && (x.mass = e.massShape[S]),
            w.addShape(x);
        }
        return (
          e.neverSleep || u ? (w.allowSleep = !1) : (w.allowSleep = !0),
          (w.isKinematic = u),
          void 0 !== e.overrideGravity &&
            (w.overrideGravity = new Vec3(
              e.overrideGravity.x,
              e.overrideGravity.y,
              e.overrideGravity.z
            )),
          void 0 !== e.name && (w.name = e.name),
          n
            ? e.massPos || e.massRot
              ? w.setupMass(1, !1)
              : w.setupMass(1, !0)
            : w.setupMass(2),
          this.addRigidBody(w),
          n && (e.sleep ? w.sleep() : w.awake()),
          w
        );
      },
      initJoint: function (t, e) {
        var a,
          n,
          u = this.invScale,
          f = e.axe1 || [1, 0, 0],
          p = e.axe2 || [1, 0, 0],
          y = e.pos1 || [0, 0, 0],
          g = e.pos2 || [0, 0, 0];
        (y = y.map(function (t) {
          return t * u;
        })),
          (g = g.map(function (t) {
            return t * u;
          })),
          "jointDistance" === t
            ? ((a = e.min || 0), (n = e.max || 10), (a *= u), (n *= u))
            : ((a = e.min || 57.29578),
              (n = e.max || 0),
              (a *= m.degtorad),
              (n *= m.degtorad));
        var _ = e.limit || null,
          x = e.spring || null,
          b = e.motor || null,
          v = new JointConfig();
        (v.scale = this.scale),
          (v.invScale = this.invScale),
          (v.allowCollision = e.collision || !1),
          v.localAxis1.set(f[0], f[1], f[2]),
          v.localAxis2.set(p[0], p[1], p[2]),
          v.localAnchorPoint1.set(y[0], y[1], y[2]),
          v.localAnchorPoint2.set(g[0], g[1], g[2]);
        var w,
          S = null,
          C = null;
        if (void 0 === e.body1 || void 0 === e.body2)
          return printError(
            "World",
            "Can't add joint if attach rigidbodys not define !"
          );
        if (
          (e.body1.constructor === String || e.body1.constructor === Number
            ? (S = this.getByName(e.body1))
            : e.body1.constructor === RigidBody && (S = e.body1),
          e.body2.constructor === String || e.body2.constructor === Number
            ? (C = this.getByName(e.body2))
            : e.body2.constructor === RigidBody && (C = e.body2),
          null === S || null === C)
        )
          return printError(
            "World",
            "Can't add joint attach rigidbodys not find !"
          );
        switch (((v.body1 = S), (v.body2 = C), t)) {
          case "jointDistance":
            (w = new DistanceJoint(v, a, n)),
              null !== x && w.limitMotor.setSpring(x[0], x[1]),
              null !== b && w.limitMotor.setMotor(b[0], b[1]);
            break;
          case "jointHinge":
          case "joint":
            (w = new HingeJoint(v, a, n)),
              null !== x && w.limitMotor.setSpring(x[0], x[1]),
              null !== b && w.limitMotor.setMotor(b[0], b[1]);
            break;
          case "jointPrisme":
            w = new PrismaticJoint(v, a, n);
            break;
          case "jointSlide":
            w = new SliderJoint(v, a, n);
            break;
          case "jointBall":
            w = new BallAndSocketJoint(v);
            break;
          case "jointWheel":
            (w = new WheelJoint(v)),
              null !== _ && w.rotationalLimitMotor1.setLimit(_[0], _[1]),
              null !== x && w.rotationalLimitMotor1.setSpring(x[0], x[1]),
              null !== b && w.rotationalLimitMotor1.setMotor(b[0], b[1]);
        }
        return (w.name = e.name || ""), this.addJoint(w), w;
      },
      rayCast: function (t, e, a, n, u = -1) {
        a = a || 2147483647;
        let m = new Vec3(),
          f = new Vec3(t.origin.x, t.origin.y, t.origin.z);
        for (
          var p = this.rigidBodies,
            y = new Vec3(),
            g = new Quat(),
            _ = [],
            x = new Vec3();
          null !== p;

        ) {
          for (var b = p.shapes; null !== b; b = b.next)
            if (0 != (u & b.belongsTo)) {
              var v = { temp: y, hasHit: !1, distance: -1, owner: p.owner };
              g.copy(p.orientation), g.inverse();
              var w = b.aabb.getCenter();
              1 == b.type
                ? (m.copy(f), x.copy(t.direction))
                : (m.copy(f).subEqual(w),
                  m.applyQuaternion(g),
                  x.copy(t.direction).applyQuaternion(g)),
                b.intersectRay(m, x, a, v),
                v.hasHit &&
                  (1 == b.type
                    ? (v.normal = x)
                    : (v.intersectionPoint
                        .applyQuaternion(p.orientation)
                        .addEqual(w),
                      v.normal.applyQuaternion(p.orientation)),
                  _.push(v),
                  (v.shapeName = b.name));
            }
          p = p.next;
        }
        if (_.length > 0) {
          var S;
          for (const t of _)
            t.distance > 0 && t.distance <= a && ((a = t.distance), (S = t));
          S &&
            ((e.succeeded = !0),
            (e.hitFraction = S.distance),
            e.point.from(S.intersectionPoint),
            e.normal.from(S.normal),
            (e.collider = { owner: S.owner, shapeName: S.shapeName }));
        }
      },
      ignoreCollision: function (t, e, a) {
        t.ignore || (t.ignore = []);
        let n = t.ignore.indexOf(e);
        a && -1 == n ? t.ignore.push(e) : a || -1 == n || t.ignore.splice(n);
      },
    }),
    (t.Math = m),
    (t.Vec3 = Vec3),
    (t.Quat = Quat),
    (t.Mat33 = Mat33),
    (t.Shape = Shape),
    (t.Box = Box),
    (t.Sphere = Sphere),
    (t.Cylinder = Cylinder),
    (t.Plane = Plane),
    (t.Particle = Particle),
    (t.ShapeConfig = ShapeConfig),
    (t.LimitMotor = LimitMotor),
    (t.HingeJoint = HingeJoint),
    (t.BallAndSocketJoint = BallAndSocketJoint),
    (t.DistanceJoint = DistanceJoint),
    (t.PrismaticJoint = PrismaticJoint),
    (t.SliderJoint = SliderJoint),
    (t.WheelJoint = WheelJoint),
    (t.JointConfig = JointConfig),
    (t.RigidBody = RigidBody),
    (t.World = World),
    (t.REVISION = "1.0.9"),
    (t.BR_NULL = 0),
    (t.BR_BRUTE_FORCE = 1),
    (t.BR_SWEEP_AND_PRUNE = 2),
    (t.BR_BOUNDING_VOLUME_TREE = 3),
    (t.BODY_NULL = 0),
    (t.BODY_DYNAMIC = 1),
    (t.BODY_STATIC = 2),
    (t.BODY_KINEMATIC = 3),
    (t.BODY_GHOST = 4),
    (t.SHAPE_NULL = 0),
    (t.SHAPE_SPHERE = 1),
    (t.SHAPE_BOX = 2),
    (t.SHAPE_CYLINDER = 3),
    (t.SHAPE_PLANE = 4),
    (t.SHAPE_PARTICLE = 5),
    (t.SHAPE_TETRA = 6),
    (t.JOINT_NULL = 0),
    (t.JOINT_DISTANCE = 1),
    (t.JOINT_BALL_AND_SOCKET = 2),
    (t.JOINT_HINGE = 3),
    (t.JOINT_WHEEL = 4),
    (t.JOINT_SLIDER = 5),
    (t.JOINT_PRISMATIC = 6),
    (t.AABB_PROX = 0.005),
    (t.printError = printError),
    (t.InfoDisplay = InfoDisplay),
    t
  );
})({})),
  (window.pako = (function r(t, e, a) {
    function h(u, m) {
      if (!e[u]) {
        if (!t[u]) {
          var f = "function" == typeof require && require;
          if (!m && f) return f(u, !0);
          if (n) return n(u, !0);
          var p = new Error("Cannot find module '" + u + "'");
          throw ((p.code = "MODULE_NOT_FOUND"), p);
        }
        var y = (e[u] = { exports: {} });
        t[u][0].call(
          y.exports,
          function (e) {
            return h(t[u][1][e] || e);
          },
          y,
          y.exports,
          r,
          t,
          e,
          a
        );
      }
      return e[u].exports;
    }
    for (
      var n = "function" == typeof require && require, u = 0;
      u < a.length;
      u++
    )
      h(a[u]);
    return h;
  })(
    {
      1: [
        function (t, e, a) {
          "use strict";
          var n = t("./zlib/deflate"),
            u = t("./utils/common"),
            m = t("./utils/strings"),
            f = t("./zlib/messages"),
            p = t("./zlib/zstream"),
            y = Object.prototype.toString;
          function c(t) {
            if (!(this instanceof c)) return new c(t);
            this.options = u.assign(
              {
                level: -1,
                method: 8,
                chunkSize: 16384,
                windowBits: 15,
                memLevel: 8,
                strategy: 0,
                to: "",
              },
              t || {}
            );
            var e = this.options;
            e.raw && 0 < e.windowBits
              ? (e.windowBits = -e.windowBits)
              : e.gzip &&
                0 < e.windowBits &&
                e.windowBits < 16 &&
                (e.windowBits += 16),
              (this.err = 0),
              (this.msg = ""),
              (this.ended = !1),
              (this.chunks = []),
              (this.strm = new p()),
              (this.strm.avail_out = 0);
            var a = n.deflateInit2(
              this.strm,
              e.level,
              e.method,
              e.windowBits,
              e.memLevel,
              e.strategy
            );
            if (0 !== a) throw new Error(f[a]);
            if (
              (e.header && n.deflateSetHeader(this.strm, e.header),
              e.dictionary)
            ) {
              var g;
              if (
                ((g =
                  "string" == typeof e.dictionary
                    ? m.string2buf(e.dictionary)
                    : "[object ArrayBuffer]" === y.call(e.dictionary)
                    ? new Uint8Array(e.dictionary)
                    : e.dictionary),
                0 !== (a = n.deflateSetDictionary(this.strm, g)))
              )
                throw new Error(f[a]);
              this._dict_set = !0;
            }
          }
          function i(t, e) {
            var a = new c(e);
            if ((a.push(t, !0), a.err)) throw a.msg || f[a.err];
            return a.result;
          }
          (c.prototype.push = function (t, e) {
            var a,
              f,
              p = this.strm,
              g = this.options.chunkSize;
            if (this.ended) return !1;
            (f = e === ~~e ? e : !0 === e ? 4 : 0),
              "string" == typeof t
                ? (p.input = m.string2buf(t))
                : "[object ArrayBuffer]" === y.call(t)
                ? (p.input = new Uint8Array(t))
                : (p.input = t),
              (p.next_in = 0),
              (p.avail_in = p.input.length);
            do {
              if (
                (0 === p.avail_out &&
                  ((p.output = new u.Buf8(g)),
                  (p.next_out = 0),
                  (p.avail_out = g)),
                1 !== (a = n.deflate(p, f)) && 0 !== a)
              )
                return this.onEnd(a), !(this.ended = !0);
              (0 !== p.avail_out &&
                (0 !== p.avail_in || (4 !== f && 2 !== f))) ||
                ("string" === this.options.to
                  ? this.onData(
                      m.buf2binstring(u.shrinkBuf(p.output, p.next_out))
                    )
                  : this.onData(u.shrinkBuf(p.output, p.next_out)));
            } while ((0 < p.avail_in || 0 === p.avail_out) && 1 !== a);
            return 4 === f
              ? ((a = n.deflateEnd(this.strm)),
                this.onEnd(a),
                (this.ended = !0),
                0 === a)
              : 2 !== f || (this.onEnd(0), !(p.avail_out = 0));
          }),
            (c.prototype.onData = function (t) {
              this.chunks.push(t);
            }),
            (c.prototype.onEnd = function (t) {
              0 === t &&
                ("string" === this.options.to
                  ? (this.result = this.chunks.join(""))
                  : (this.result = u.flattenChunks(this.chunks))),
                (this.chunks = []),
                (this.err = t),
                (this.msg = this.strm.msg);
            }),
            (a.Deflate = c),
            (a.deflate = i),
            (a.deflateRaw = function (t, e) {
              return ((e = e || {}).raw = !0), i(t, e);
            }),
            (a.gzip = function (t, e) {
              return ((e = e || {}).gzip = !0), i(t, e);
            });
        },
        {
          "./utils/common": 3,
          "./utils/strings": 4,
          "./zlib/deflate": 8,
          "./zlib/messages": 13,
          "./zlib/zstream": 15,
        },
      ],
      2: [
        function (t, e, a) {
          "use strict";
          var n = t("./zlib/inflate"),
            u = t("./utils/common"),
            m = t("./utils/strings"),
            f = t("./zlib/constants"),
            p = t("./zlib/messages"),
            y = t("./zlib/zstream"),
            g = t("./zlib/gzheader"),
            _ = Object.prototype.toString;
          function s(t) {
            if (!(this instanceof s)) return new s(t);
            this.options = u.assign(
              { chunkSize: 16384, windowBits: 0, to: "" },
              t || {}
            );
            var e = this.options;
            e.raw &&
              0 <= e.windowBits &&
              e.windowBits < 16 &&
              ((e.windowBits = -e.windowBits),
              0 === e.windowBits && (e.windowBits = -15)),
              !(0 <= e.windowBits && e.windowBits < 16) ||
                (t && t.windowBits) ||
                (e.windowBits += 32),
              15 < e.windowBits &&
                e.windowBits < 48 &&
                0 == (15 & e.windowBits) &&
                (e.windowBits |= 15),
              (this.err = 0),
              (this.msg = ""),
              (this.ended = !1),
              (this.chunks = []),
              (this.strm = new y()),
              (this.strm.avail_out = 0);
            var a = n.inflateInit2(this.strm, e.windowBits);
            if (a !== f.Z_OK) throw new Error(p[a]);
            (this.header = new g()), n.inflateGetHeader(this.strm, this.header);
          }
          function o(t, e) {
            var a = new s(e);
            if ((a.push(t, !0), a.err)) throw a.msg || p[a.err];
            return a.result;
          }
          (s.prototype.push = function (t, e) {
            var a,
              p,
              y,
              g,
              x,
              b,
              v = this.strm,
              w = this.options.chunkSize,
              S = this.options.dictionary,
              C = !1;
            if (this.ended) return !1;
            (p = e === ~~e ? e : !0 === e ? f.Z_FINISH : f.Z_NO_FLUSH),
              "string" == typeof t
                ? (v.input = m.binstring2buf(t))
                : "[object ArrayBuffer]" === _.call(t)
                ? (v.input = new Uint8Array(t))
                : (v.input = t),
              (v.next_in = 0),
              (v.avail_in = v.input.length);
            do {
              if (
                (0 === v.avail_out &&
                  ((v.output = new u.Buf8(w)),
                  (v.next_out = 0),
                  (v.avail_out = w)),
                (a = n.inflate(v, f.Z_NO_FLUSH)) === f.Z_NEED_DICT &&
                  S &&
                  ((b =
                    "string" == typeof S
                      ? m.string2buf(S)
                      : "[object ArrayBuffer]" === _.call(S)
                      ? new Uint8Array(S)
                      : S),
                  (a = n.inflateSetDictionary(this.strm, b))),
                a === f.Z_BUF_ERROR && !0 === C && ((a = f.Z_OK), (C = !1)),
                a !== f.Z_STREAM_END && a !== f.Z_OK)
              )
                return this.onEnd(a), !(this.ended = !0);
              v.next_out &&
                ((0 !== v.avail_out &&
                  a !== f.Z_STREAM_END &&
                  (0 !== v.avail_in ||
                    (p !== f.Z_FINISH && p !== f.Z_SYNC_FLUSH))) ||
                  ("string" === this.options.to
                    ? ((y = m.utf8border(v.output, v.next_out)),
                      (g = v.next_out - y),
                      (x = m.buf2string(v.output, y)),
                      (v.next_out = g),
                      (v.avail_out = w - g),
                      g && u.arraySet(v.output, v.output, y, g, 0),
                      this.onData(x))
                    : this.onData(u.shrinkBuf(v.output, v.next_out)))),
                0 === v.avail_in && 0 === v.avail_out && (C = !0);
            } while (
              (0 < v.avail_in || 0 === v.avail_out) &&
              a !== f.Z_STREAM_END
            );
            return (
              a === f.Z_STREAM_END && (p = f.Z_FINISH),
              p === f.Z_FINISH
                ? ((a = n.inflateEnd(this.strm)),
                  this.onEnd(a),
                  (this.ended = !0),
                  a === f.Z_OK)
                : p !== f.Z_SYNC_FLUSH ||
                  (this.onEnd(f.Z_OK), !(v.avail_out = 0))
            );
          }),
            (s.prototype.onData = function (t) {
              this.chunks.push(t);
            }),
            (s.prototype.onEnd = function (t) {
              t === f.Z_OK &&
                ("string" === this.options.to
                  ? (this.result = this.chunks.join(""))
                  : (this.result = u.flattenChunks(this.chunks))),
                (this.chunks = []),
                (this.err = t),
                (this.msg = this.strm.msg);
            }),
            (a.Inflate = s),
            (a.inflate = o),
            (a.inflateRaw = function (t, e) {
              return ((e = e || {}).raw = !0), o(t, e);
            }),
            (a.ungzip = o);
        },
        {
          "./utils/common": 3,
          "./utils/strings": 4,
          "./zlib/constants": 6,
          "./zlib/gzheader": 9,
          "./zlib/inflate": 11,
          "./zlib/messages": 13,
          "./zlib/zstream": 15,
        },
      ],
      3: [
        function (t, e, a) {
          "use strict";
          var n =
            "undefined" != typeof Uint8Array &&
            "undefined" != typeof Uint16Array &&
            "undefined" != typeof Int32Array;
          (a.assign = function (t) {
            for (
              var e, a, n = Array.prototype.slice.call(arguments, 1);
              n.length;

            ) {
              var u = n.shift();
              if (u) {
                if ("object" != typeof u)
                  throw new TypeError(u + "must be non-object");
                for (var m in u)
                  (e = u),
                    (a = m),
                    Object.prototype.hasOwnProperty.call(e, a) && (t[m] = u[m]);
              }
            }
            return t;
          }),
            (a.shrinkBuf = function (t, e) {
              return t.length === e
                ? t
                : t.subarray
                ? t.subarray(0, e)
                : ((t.length = e), t);
            });
          var u = {
              arraySet: function (t, e, a, n, u) {
                if (e.subarray && t.subarray) t.set(e.subarray(a, a + n), u);
                else for (var m = 0; m < n; m++) t[u + m] = e[a + m];
              },
              flattenChunks: function (t) {
                var e, a, n, u, m, f;
                for (e = n = 0, a = t.length; e < a; e++) n += t[e].length;
                for (f = new Uint8Array(n), e = u = 0, a = t.length; e < a; e++)
                  (m = t[e]), f.set(m, u), (u += m.length);
                return f;
              },
            },
            m = {
              arraySet: function (t, e, a, n, u) {
                for (var m = 0; m < n; m++) t[u + m] = e[a + m];
              },
              flattenChunks: function (t) {
                return [].concat.apply([], t);
              },
            };
          (a.setTyped = function (t) {
            t
              ? ((a.Buf8 = Uint8Array),
                (a.Buf16 = Uint16Array),
                (a.Buf32 = Int32Array),
                a.assign(a, u))
              : ((a.Buf8 = Array),
                (a.Buf16 = Array),
                (a.Buf32 = Array),
                a.assign(a, m));
          }),
            a.setTyped(n);
        },
        {},
      ],
      4: [
        function (t, e, a) {
          "use strict";
          var n = t("./common"),
            u = !0,
            m = !0;
          try {
            String.fromCharCode.apply(null, [0]);
          } catch (t) {
            u = !1;
          }
          try {
            String.fromCharCode.apply(null, new Uint8Array(1));
          } catch (t) {
            m = !1;
          }
          for (var f = new n.Buf8(256), p = 0; p < 256; p++)
            f[p] =
              252 <= p
                ? 6
                : 248 <= p
                ? 5
                : 240 <= p
                ? 4
                : 224 <= p
                ? 3
                : 192 <= p
                ? 2
                : 1;
          function d(t, e) {
            if (e < 65534 && ((t.subarray && m) || (!t.subarray && u)))
              return String.fromCharCode.apply(null, n.shrinkBuf(t, e));
            for (var a = "", f = 0; f < e; f++) a += String.fromCharCode(t[f]);
            return a;
          }
          (f[254] = f[254] = 1),
            (a.string2buf = function (t) {
              var e,
                a,
                u,
                m,
                f,
                p = t.length,
                y = 0;
              for (m = 0; m < p; m++)
                55296 == (64512 & (a = t.charCodeAt(m))) &&
                  m + 1 < p &&
                  56320 == (64512 & (u = t.charCodeAt(m + 1))) &&
                  ((a = 65536 + ((a - 55296) << 10) + (u - 56320)), m++),
                  (y += a < 128 ? 1 : a < 2048 ? 2 : a < 65536 ? 3 : 4);
              for (e = new n.Buf8(y), m = f = 0; f < y; m++)
                55296 == (64512 & (a = t.charCodeAt(m))) &&
                  m + 1 < p &&
                  56320 == (64512 & (u = t.charCodeAt(m + 1))) &&
                  ((a = 65536 + ((a - 55296) << 10) + (u - 56320)), m++),
                  (e[f++] =
                    a < 128
                      ? a
                      : ((e[f++] =
                          a < 2048
                            ? 192 | (a >>> 6)
                            : ((e[f++] =
                                a < 65536
                                  ? 224 | (a >>> 12)
                                  : ((e[f++] = 240 | (a >>> 18)),
                                    128 | ((a >>> 12) & 63))),
                              128 | ((a >>> 6) & 63))),
                        128 | (63 & a)));
              return e;
            }),
            (a.buf2binstring = function (t) {
              return d(t, t.length);
            }),
            (a.binstring2buf = function (t) {
              for (
                var e = new n.Buf8(t.length), a = 0, u = e.length;
                a < u;
                a++
              )
                e[a] = t.charCodeAt(a);
              return e;
            }),
            (a.buf2string = function (t, e) {
              var a,
                n,
                u,
                m,
                p = e || t.length,
                y = new Array(2 * p);
              for (a = n = 0; a < p; )
                if ((u = t[a++]) < 128) y[n++] = u;
                else if (4 < (m = f[u])) (y[n++] = 65533), (a += m - 1);
                else {
                  for (u &= 2 === m ? 31 : 3 === m ? 15 : 7; 1 < m && a < p; )
                    (u = (u << 6) | (63 & t[a++])), m--;
                  y[n++] =
                    1 < m
                      ? 65533
                      : u < 65536
                      ? u
                      : ((u -= 65536),
                        (y[n++] = 55296 | ((u >> 10) & 1023)),
                        56320 | (1023 & u));
                }
              return d(y, n);
            }),
            (a.utf8border = function (t, e) {
              var a;
              for (
                (e = e || t.length) > t.length && (e = t.length), a = e - 1;
                0 <= a && 128 == (192 & t[a]);

              )
                a--;
              return a < 0 || 0 === a ? e : a + f[t[a]] > e ? a : e;
            });
        },
        { "./common": 3 },
      ],
      5: [
        function (t, e, a) {
          "use strict";
          e.exports = function (t, e, a, n) {
            for (
              var u = (65535 & t) | 0, m = ((t >>> 16) & 65535) | 0, f = 0;
              0 !== a;

            ) {
              for (
                a -= f = 2e3 < a ? 2e3 : a;
                (m = (m + (u = (u + e[n++]) | 0)) | 0), --f;

              );
              (u %= 65521), (m %= 65521);
            }
            return u | (m << 16) | 0;
          };
        },
        {},
      ],
      6: [
        function (t, e, a) {
          "use strict";
          e.exports = {
            Z_NO_FLUSH: 0,
            Z_PARTIAL_FLUSH: 1,
            Z_SYNC_FLUSH: 2,
            Z_FULL_FLUSH: 3,
            Z_FINISH: 4,
            Z_BLOCK: 5,
            Z_TREES: 6,
            Z_OK: 0,
            Z_STREAM_END: 1,
            Z_NEED_DICT: 2,
            Z_ERRNO: -1,
            Z_STREAM_ERROR: -2,
            Z_DATA_ERROR: -3,
            Z_BUF_ERROR: -5,
            Z_NO_COMPRESSION: 0,
            Z_BEST_SPEED: 1,
            Z_BEST_COMPRESSION: 9,
            Z_DEFAULT_COMPRESSION: -1,
            Z_FILTERED: 1,
            Z_HUFFMAN_ONLY: 2,
            Z_RLE: 3,
            Z_FIXED: 4,
            Z_DEFAULT_STRATEGY: 0,
            Z_BINARY: 0,
            Z_TEXT: 1,
            Z_UNKNOWN: 2,
            Z_DEFLATED: 8,
          };
        },
        {},
      ],
      7: [
        function (t, e, a) {
          "use strict";
          var n = (function () {
            for (var t, e = [], a = 0; a < 256; a++) {
              t = a;
              for (var n = 0; n < 8; n++)
                t = 1 & t ? 3988292384 ^ (t >>> 1) : t >>> 1;
              e[a] = t;
            }
            return e;
          })();
          e.exports = function (t, e, a, u) {
            var m = n,
              f = u + a;
            t ^= -1;
            for (var p = u; p < f; p++) t = (t >>> 8) ^ m[255 & (t ^ e[p])];
            return -1 ^ t;
          };
        },
        {},
      ],
      8: [
        function (t, e, a) {
          "use strict";
          var n,
            u = t("../utils/common"),
            m = t("./trees"),
            f = t("./adler32"),
            p = t("./crc32"),
            y = t("./messages"),
            g = -2,
            _ = 258,
            x = 262,
            b = 113;
          function N(t, e) {
            return (t.msg = y[e]), e;
          }
          function O(t) {
            return (t << 1) - (4 < t ? 9 : 0);
          }
          function D(t) {
            for (var e = t.length; 0 <= --e; ) t[e] = 0;
          }
          function I(t) {
            var e = t.state,
              a = e.pending;
            a > t.avail_out && (a = t.avail_out),
              0 !== a &&
                (u.arraySet(
                  t.output,
                  e.pending_buf,
                  e.pending_out,
                  a,
                  t.next_out
                ),
                (t.next_out += a),
                (e.pending_out += a),
                (t.total_out += a),
                (t.avail_out -= a),
                (e.pending -= a),
                0 === e.pending && (e.pending_out = 0));
          }
          function U(t, e) {
            m._tr_flush_block(
              t,
              0 <= t.block_start ? t.block_start : -1,
              t.strstart - t.block_start,
              e
            ),
              (t.block_start = t.strstart),
              I(t.strm);
          }
          function T(t, e) {
            t.pending_buf[t.pending++] = e;
          }
          function F(t, e) {
            (t.pending_buf[t.pending++] = (e >>> 8) & 255),
              (t.pending_buf[t.pending++] = 255 & e);
          }
          function L(t, e) {
            var a,
              n,
              u = t.max_chain_length,
              m = t.strstart,
              f = t.prev_length,
              p = t.nice_match,
              y = t.strstart > t.w_size - x ? t.strstart - (t.w_size - x) : 0,
              g = t.window,
              b = t.w_mask,
              v = t.prev,
              w = t.strstart + _,
              S = g[m + f - 1],
              C = g[m + f];
            t.prev_length >= t.good_match && (u >>= 2),
              p > t.lookahead && (p = t.lookahead);
            do {
              if (
                g[(a = e) + f] === C &&
                g[a + f - 1] === S &&
                g[a] === g[m] &&
                g[++a] === g[m + 1]
              ) {
                (m += 2), a++;
                do {} while (
                  g[++m] === g[++a] &&
                  g[++m] === g[++a] &&
                  g[++m] === g[++a] &&
                  g[++m] === g[++a] &&
                  g[++m] === g[++a] &&
                  g[++m] === g[++a] &&
                  g[++m] === g[++a] &&
                  g[++m] === g[++a] &&
                  m < w
                );
                if (((n = _ - (w - m)), (m = w - _), f < n)) {
                  if (((t.match_start = e), p <= (f = n))) break;
                  (S = g[m + f - 1]), (C = g[m + f]);
                }
              }
            } while ((e = v[e & b]) > y && 0 != --u);
            return f <= t.lookahead ? f : t.lookahead;
          }
          function H(t) {
            var e,
              a,
              n,
              m,
              y,
              g,
              _,
              b,
              v,
              w,
              S = t.w_size;
            do {
              if (
                ((m = t.window_size - t.lookahead - t.strstart),
                t.strstart >= S + (S - x))
              ) {
                for (
                  u.arraySet(t.window, t.window, S, S, 0),
                    t.match_start -= S,
                    t.strstart -= S,
                    t.block_start -= S,
                    e = a = t.hash_size;
                  (n = t.head[--e]), (t.head[e] = S <= n ? n - S : 0), --a;

                );
                for (
                  e = a = S;
                  (n = t.prev[--e]), (t.prev[e] = S <= n ? n - S : 0), --a;

                );
                m += S;
              }
              if (0 === t.strm.avail_in) break;
              if (
                ((g = t.strm),
                (_ = t.window),
                (b = t.strstart + t.lookahead),
                (w = void 0),
                (v = m) < (w = g.avail_in) && (w = v),
                (a =
                  0 === w
                    ? 0
                    : ((g.avail_in -= w),
                      u.arraySet(_, g.input, g.next_in, w, b),
                      1 === g.state.wrap
                        ? (g.adler = f(g.adler, _, w, b))
                        : 2 === g.state.wrap && (g.adler = p(g.adler, _, w, b)),
                      (g.next_in += w),
                      (g.total_in += w),
                      w)),
                (t.lookahead += a),
                t.lookahead + t.insert >= 3)
              )
                for (
                  y = t.strstart - t.insert,
                    t.ins_h = t.window[y],
                    t.ins_h =
                      ((t.ins_h << t.hash_shift) ^ t.window[y + 1]) &
                      t.hash_mask;
                  t.insert &&
                  ((t.ins_h =
                    ((t.ins_h << t.hash_shift) ^ t.window[y + 3 - 1]) &
                    t.hash_mask),
                  (t.prev[y & t.w_mask] = t.head[t.ins_h]),
                  (t.head[t.ins_h] = y),
                  y++,
                  t.insert--,
                  !(t.lookahead + t.insert < 3));

                );
            } while (t.lookahead < x && 0 !== t.strm.avail_in);
          }
          function j(t, e) {
            for (var a, n; ; ) {
              if (t.lookahead < x) {
                if ((H(t), t.lookahead < x && 0 === e)) return 1;
                if (0 === t.lookahead) break;
              }
              if (
                ((a = 0),
                t.lookahead >= 3 &&
                  ((t.ins_h =
                    ((t.ins_h << t.hash_shift) ^ t.window[t.strstart + 3 - 1]) &
                    t.hash_mask),
                  (a = t.prev[t.strstart & t.w_mask] = t.head[t.ins_h]),
                  (t.head[t.ins_h] = t.strstart)),
                0 !== a &&
                  t.strstart - a <= t.w_size - x &&
                  (t.match_length = L(t, a)),
                t.match_length >= 3)
              )
                if (
                  ((n = m._tr_tally(
                    t,
                    t.strstart - t.match_start,
                    t.match_length - 3
                  )),
                  (t.lookahead -= t.match_length),
                  t.match_length <= t.max_lazy_match && t.lookahead >= 3)
                ) {
                  for (
                    t.match_length--;
                    t.strstart++,
                      (t.ins_h =
                        ((t.ins_h << t.hash_shift) ^
                          t.window[t.strstart + 3 - 1]) &
                        t.hash_mask),
                      (a = t.prev[t.strstart & t.w_mask] = t.head[t.ins_h]),
                      (t.head[t.ins_h] = t.strstart),
                      0 != --t.match_length;

                  );
                  t.strstart++;
                } else
                  (t.strstart += t.match_length),
                    (t.match_length = 0),
                    (t.ins_h = t.window[t.strstart]),
                    (t.ins_h =
                      ((t.ins_h << t.hash_shift) ^ t.window[t.strstart + 1]) &
                      t.hash_mask);
              else
                (n = m._tr_tally(t, 0, t.window[t.strstart])),
                  t.lookahead--,
                  t.strstart++;
              if (n && (U(t, !1), 0 === t.strm.avail_out)) return 1;
            }
            return (
              (t.insert = t.strstart < 2 ? t.strstart : 2),
              4 === e
                ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4)
                : t.last_lit && (U(t, !1), 0 === t.strm.avail_out)
                ? 1
                : 2
            );
          }
          function K(t, e) {
            for (var a, n, u; ; ) {
              if (t.lookahead < x) {
                if ((H(t), t.lookahead < x && 0 === e)) return 1;
                if (0 === t.lookahead) break;
              }
              if (
                ((a = 0),
                t.lookahead >= 3 &&
                  ((t.ins_h =
                    ((t.ins_h << t.hash_shift) ^ t.window[t.strstart + 3 - 1]) &
                    t.hash_mask),
                  (a = t.prev[t.strstart & t.w_mask] = t.head[t.ins_h]),
                  (t.head[t.ins_h] = t.strstart)),
                (t.prev_length = t.match_length),
                (t.prev_match = t.match_start),
                (t.match_length = 2),
                0 !== a &&
                  t.prev_length < t.max_lazy_match &&
                  t.strstart - a <= t.w_size - x &&
                  ((t.match_length = L(t, a)),
                  t.match_length <= 5 &&
                    (1 === t.strategy ||
                      (3 === t.match_length &&
                        4096 < t.strstart - t.match_start)) &&
                    (t.match_length = 2)),
                t.prev_length >= 3 && t.match_length <= t.prev_length)
              ) {
                for (
                  u = t.strstart + t.lookahead - 3,
                    n = m._tr_tally(
                      t,
                      t.strstart - 1 - t.prev_match,
                      t.prev_length - 3
                    ),
                    t.lookahead -= t.prev_length - 1,
                    t.prev_length -= 2;
                  ++t.strstart <= u &&
                    ((t.ins_h =
                      ((t.ins_h << t.hash_shift) ^
                        t.window[t.strstart + 3 - 1]) &
                      t.hash_mask),
                    (a = t.prev[t.strstart & t.w_mask] = t.head[t.ins_h]),
                    (t.head[t.ins_h] = t.strstart)),
                    0 != --t.prev_length;

                );
                if (
                  ((t.match_available = 0),
                  (t.match_length = 2),
                  t.strstart++,
                  n && (U(t, !1), 0 === t.strm.avail_out))
                )
                  return 1;
              } else if (t.match_available) {
                if (
                  ((n = m._tr_tally(t, 0, t.window[t.strstart - 1])) &&
                    U(t, !1),
                  t.strstart++,
                  t.lookahead--,
                  0 === t.strm.avail_out)
                )
                  return 1;
              } else (t.match_available = 1), t.strstart++, t.lookahead--;
            }
            return (
              t.match_available &&
                ((n = m._tr_tally(t, 0, t.window[t.strstart - 1])),
                (t.match_available = 0)),
              (t.insert = t.strstart < 2 ? t.strstart : 2),
              4 === e
                ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4)
                : t.last_lit && (U(t, !1), 0 === t.strm.avail_out)
                ? 1
                : 2
            );
          }
          function M(t, e, a, n, u) {
            (this.good_length = t),
              (this.max_lazy = e),
              (this.nice_length = a),
              (this.max_chain = n),
              (this.func = u);
          }
          function P() {
            (this.strm = null),
              (this.status = 0),
              (this.pending_buf = null),
              (this.pending_buf_size = 0),
              (this.pending_out = 0),
              (this.pending = 0),
              (this.wrap = 0),
              (this.gzhead = null),
              (this.gzindex = 0),
              (this.method = 8),
              (this.last_flush = -1),
              (this.w_size = 0),
              (this.w_bits = 0),
              (this.w_mask = 0),
              (this.window = null),
              (this.window_size = 0),
              (this.prev = null),
              (this.head = null),
              (this.ins_h = 0),
              (this.hash_size = 0),
              (this.hash_bits = 0),
              (this.hash_mask = 0),
              (this.hash_shift = 0),
              (this.block_start = 0),
              (this.match_length = 0),
              (this.prev_match = 0),
              (this.match_available = 0),
              (this.strstart = 0),
              (this.match_start = 0),
              (this.lookahead = 0),
              (this.prev_length = 0),
              (this.max_chain_length = 0),
              (this.max_lazy_match = 0),
              (this.level = 0),
              (this.strategy = 0),
              (this.good_match = 0),
              (this.nice_match = 0),
              (this.dyn_ltree = new u.Buf16(1146)),
              (this.dyn_dtree = new u.Buf16(122)),
              (this.bl_tree = new u.Buf16(78)),
              D(this.dyn_ltree),
              D(this.dyn_dtree),
              D(this.bl_tree),
              (this.l_desc = null),
              (this.d_desc = null),
              (this.bl_desc = null),
              (this.bl_count = new u.Buf16(16)),
              (this.heap = new u.Buf16(573)),
              D(this.heap),
              (this.heap_len = 0),
              (this.heap_max = 0),
              (this.depth = new u.Buf16(573)),
              D(this.depth),
              (this.l_buf = 0),
              (this.lit_bufsize = 0),
              (this.last_lit = 0),
              (this.d_buf = 0),
              (this.opt_len = 0),
              (this.static_len = 0),
              (this.matches = 0),
              (this.insert = 0),
              (this.bi_buf = 0),
              (this.bi_valid = 0);
          }
          function Y(t) {
            var e;
            return t && t.state
              ? ((t.total_in = t.total_out = 0),
                (t.data_type = 2),
                ((e = t.state).pending = 0),
                (e.pending_out = 0),
                e.wrap < 0 && (e.wrap = -e.wrap),
                (e.status = e.wrap ? 42 : b),
                (t.adler = 2 === e.wrap ? 0 : 1),
                (e.last_flush = 0),
                m._tr_init(e),
                0)
              : N(t, g);
          }
          function q(t) {
            var e,
              a = Y(t);
            return (
              0 === a &&
                (((e = t.state).window_size = 2 * e.w_size),
                D(e.head),
                (e.max_lazy_match = n[e.level].max_lazy),
                (e.good_match = n[e.level].good_length),
                (e.nice_match = n[e.level].nice_length),
                (e.max_chain_length = n[e.level].max_chain),
                (e.strstart = 0),
                (e.block_start = 0),
                (e.lookahead = 0),
                (e.insert = 0),
                (e.match_length = e.prev_length = 2),
                (e.match_available = 0),
                (e.ins_h = 0)),
              a
            );
          }
          function G(t, e, a, n, m, f) {
            if (!t) return g;
            var p = 1;
            if (
              (-1 === e && (e = 6),
              n < 0 ? ((p = 0), (n = -n)) : 15 < n && ((p = 2), (n -= 16)),
              m < 1 ||
                9 < m ||
                8 !== a ||
                n < 8 ||
                15 < n ||
                e < 0 ||
                9 < e ||
                f < 0 ||
                4 < f)
            )
              return N(t, g);
            8 === n && (n = 9);
            var y = new P();
            return (
              ((t.state = y).strm = t),
              (y.wrap = p),
              (y.gzhead = null),
              (y.w_bits = n),
              (y.w_size = 1 << y.w_bits),
              (y.w_mask = y.w_size - 1),
              (y.hash_bits = m + 7),
              (y.hash_size = 1 << y.hash_bits),
              (y.hash_mask = y.hash_size - 1),
              (y.hash_shift = ~~((y.hash_bits + 3 - 1) / 3)),
              (y.window = new u.Buf8(2 * y.w_size)),
              (y.head = new u.Buf16(y.hash_size)),
              (y.prev = new u.Buf16(y.w_size)),
              (y.lit_bufsize = 1 << (m + 6)),
              (y.pending_buf_size = 4 * y.lit_bufsize),
              (y.pending_buf = new u.Buf8(y.pending_buf_size)),
              (y.d_buf = 1 * y.lit_bufsize),
              (y.l_buf = 3 * y.lit_bufsize),
              (y.level = e),
              (y.strategy = f),
              (y.method = a),
              q(t)
            );
          }
          (n = [
            new M(0, 0, 0, 0, function (t, e) {
              var a = 65535;
              for (
                a > t.pending_buf_size - 5 && (a = t.pending_buf_size - 5);
                ;

              ) {
                if (t.lookahead <= 1) {
                  if ((H(t), 0 === t.lookahead && 0 === e)) return 1;
                  if (0 === t.lookahead) break;
                }
                (t.strstart += t.lookahead), (t.lookahead = 0);
                var n = t.block_start + a;
                if (
                  (0 === t.strstart || t.strstart >= n) &&
                  ((t.lookahead = t.strstart - n),
                  (t.strstart = n),
                  U(t, !1),
                  0 === t.strm.avail_out)
                )
                  return 1;
                if (
                  t.strstart - t.block_start >= t.w_size - x &&
                  (U(t, !1), 0 === t.strm.avail_out)
                )
                  return 1;
              }
              return (
                (t.insert = 0),
                4 === e
                  ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4)
                  : (t.strstart > t.block_start && (U(t, !1), t.strm.avail_out),
                    1)
              );
            }),
            new M(4, 4, 8, 4, j),
            new M(4, 5, 16, 8, j),
            new M(4, 6, 32, 32, j),
            new M(4, 4, 16, 16, K),
            new M(8, 16, 32, 32, K),
            new M(8, 16, 128, 128, K),
            new M(8, 32, 128, 256, K),
            new M(32, 128, 258, 1024, K),
            new M(32, 258, 258, 4096, K),
          ]),
            (a.deflateInit = function (t, e) {
              return G(t, e, 8, 15, 8, 0);
            }),
            (a.deflateInit2 = G),
            (a.deflateReset = q),
            (a.deflateResetKeep = Y),
            (a.deflateSetHeader = function (t, e) {
              return t && t.state
                ? 2 !== t.state.wrap
                  ? g
                  : ((t.state.gzhead = e), 0)
                : g;
            }),
            (a.deflate = function (t, e) {
              var a, u, f, y;
              if (!t || !t.state || 5 < e || e < 0) return t ? N(t, g) : g;
              if (
                ((u = t.state),
                !t.output ||
                  (!t.input && 0 !== t.avail_in) ||
                  (666 === u.status && 4 !== e))
              )
                return N(t, 0 === t.avail_out ? -5 : g);
              if (
                ((u.strm = t),
                (a = u.last_flush),
                (u.last_flush = e),
                42 === u.status)
              )
                if (2 === u.wrap)
                  (t.adler = 0),
                    T(u, 31),
                    T(u, 139),
                    T(u, 8),
                    u.gzhead
                      ? (T(
                          u,
                          (u.gzhead.text ? 1 : 0) +
                            (u.gzhead.hcrc ? 2 : 0) +
                            (u.gzhead.extra ? 4 : 0) +
                            (u.gzhead.name ? 8 : 0) +
                            (u.gzhead.comment ? 16 : 0)
                        ),
                        T(u, 255 & u.gzhead.time),
                        T(u, (u.gzhead.time >> 8) & 255),
                        T(u, (u.gzhead.time >> 16) & 255),
                        T(u, (u.gzhead.time >> 24) & 255),
                        T(
                          u,
                          9 === u.level
                            ? 2
                            : 2 <= u.strategy || u.level < 2
                            ? 4
                            : 0
                        ),
                        T(u, 255 & u.gzhead.os),
                        u.gzhead.extra &&
                          u.gzhead.extra.length &&
                          (T(u, 255 & u.gzhead.extra.length),
                          T(u, (u.gzhead.extra.length >> 8) & 255)),
                        u.gzhead.hcrc &&
                          (t.adler = p(t.adler, u.pending_buf, u.pending, 0)),
                        (u.gzindex = 0),
                        (u.status = 69))
                      : (T(u, 0),
                        T(u, 0),
                        T(u, 0),
                        T(u, 0),
                        T(u, 0),
                        T(
                          u,
                          9 === u.level
                            ? 2
                            : 2 <= u.strategy || u.level < 2
                            ? 4
                            : 0
                        ),
                        T(u, 3),
                        (u.status = b));
                else {
                  var x = (8 + ((u.w_bits - 8) << 4)) << 8;
                  (x |=
                    (2 <= u.strategy || u.level < 2
                      ? 0
                      : u.level < 6
                      ? 1
                      : 6 === u.level
                      ? 2
                      : 3) << 6),
                    0 !== u.strstart && (x |= 32),
                    (x += 31 - (x % 31)),
                    (u.status = b),
                    F(u, x),
                    0 !== u.strstart &&
                      (F(u, t.adler >>> 16), F(u, 65535 & t.adler)),
                    (t.adler = 1);
                }
              if (69 === u.status)
                if (u.gzhead.extra) {
                  for (
                    f = u.pending;
                    u.gzindex < (65535 & u.gzhead.extra.length) &&
                    (u.pending !== u.pending_buf_size ||
                      (u.gzhead.hcrc &&
                        u.pending > f &&
                        (t.adler = p(t.adler, u.pending_buf, u.pending - f, f)),
                      I(t),
                      (f = u.pending),
                      u.pending !== u.pending_buf_size));

                  )
                    T(u, 255 & u.gzhead.extra[u.gzindex]), u.gzindex++;
                  u.gzhead.hcrc &&
                    u.pending > f &&
                    (t.adler = p(t.adler, u.pending_buf, u.pending - f, f)),
                    u.gzindex === u.gzhead.extra.length &&
                      ((u.gzindex = 0), (u.status = 73));
                } else u.status = 73;
              if (73 === u.status)
                if (u.gzhead.name) {
                  f = u.pending;
                  do {
                    if (
                      u.pending === u.pending_buf_size &&
                      (u.gzhead.hcrc &&
                        u.pending > f &&
                        (t.adler = p(t.adler, u.pending_buf, u.pending - f, f)),
                      I(t),
                      (f = u.pending),
                      u.pending === u.pending_buf_size)
                    ) {
                      y = 1;
                      break;
                    }
                    T(
                      u,
                      (y =
                        u.gzindex < u.gzhead.name.length
                          ? 255 & u.gzhead.name.charCodeAt(u.gzindex++)
                          : 0)
                    );
                  } while (0 !== y);
                  u.gzhead.hcrc &&
                    u.pending > f &&
                    (t.adler = p(t.adler, u.pending_buf, u.pending - f, f)),
                    0 === y && ((u.gzindex = 0), (u.status = 91));
                } else u.status = 91;
              if (91 === u.status)
                if (u.gzhead.comment) {
                  f = u.pending;
                  do {
                    if (
                      u.pending === u.pending_buf_size &&
                      (u.gzhead.hcrc &&
                        u.pending > f &&
                        (t.adler = p(t.adler, u.pending_buf, u.pending - f, f)),
                      I(t),
                      (f = u.pending),
                      u.pending === u.pending_buf_size)
                    ) {
                      y = 1;
                      break;
                    }
                    T(
                      u,
                      (y =
                        u.gzindex < u.gzhead.comment.length
                          ? 255 & u.gzhead.comment.charCodeAt(u.gzindex++)
                          : 0)
                    );
                  } while (0 !== y);
                  u.gzhead.hcrc &&
                    u.pending > f &&
                    (t.adler = p(t.adler, u.pending_buf, u.pending - f, f)),
                    0 === y && (u.status = 103);
                } else u.status = 103;
              if (
                (103 === u.status &&
                  (u.gzhead.hcrc
                    ? (u.pending + 2 > u.pending_buf_size && I(t),
                      u.pending + 2 <= u.pending_buf_size &&
                        (T(u, 255 & t.adler),
                        T(u, (t.adler >> 8) & 255),
                        (t.adler = 0),
                        (u.status = b)))
                    : (u.status = b)),
                0 !== u.pending)
              ) {
                if ((I(t), 0 === t.avail_out)) return (u.last_flush = -1), 0;
              } else if (0 === t.avail_in && O(e) <= O(a) && 4 !== e)
                return N(t, -5);
              if (666 === u.status && 0 !== t.avail_in) return N(t, -5);
              if (
                0 !== t.avail_in ||
                0 !== u.lookahead ||
                (0 !== e && 666 !== u.status)
              ) {
                var v =
                  2 === u.strategy
                    ? (function (t, e) {
                        for (var a; ; ) {
                          if (0 === t.lookahead && (H(t), 0 === t.lookahead)) {
                            if (0 === e) return 1;
                            break;
                          }
                          if (
                            ((t.match_length = 0),
                            (a = m._tr_tally(t, 0, t.window[t.strstart])),
                            t.lookahead--,
                            t.strstart++,
                            a && (U(t, !1), 0 === t.strm.avail_out))
                          )
                            return 1;
                        }
                        return (
                          (t.insert = 0),
                          4 === e
                            ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4)
                            : t.last_lit && (U(t, !1), 0 === t.strm.avail_out)
                            ? 1
                            : 2
                        );
                      })(u, e)
                    : 3 === u.strategy
                    ? (function (t, e) {
                        for (var a, n, u, f, p = t.window; ; ) {
                          if (t.lookahead <= _) {
                            if ((H(t), t.lookahead <= _ && 0 === e)) return 1;
                            if (0 === t.lookahead) break;
                          }
                          if (
                            ((t.match_length = 0),
                            t.lookahead >= 3 &&
                              0 < t.strstart &&
                              (n = p[(u = t.strstart - 1)]) === p[++u] &&
                              n === p[++u] &&
                              n === p[++u])
                          ) {
                            f = t.strstart + _;
                            do {} while (
                              n === p[++u] &&
                              n === p[++u] &&
                              n === p[++u] &&
                              n === p[++u] &&
                              n === p[++u] &&
                              n === p[++u] &&
                              n === p[++u] &&
                              n === p[++u] &&
                              u < f
                            );
                            (t.match_length = _ - (f - u)),
                              t.match_length > t.lookahead &&
                                (t.match_length = t.lookahead);
                          }
                          if (
                            (t.match_length >= 3
                              ? ((a = m._tr_tally(t, 1, t.match_length - 3)),
                                (t.lookahead -= t.match_length),
                                (t.strstart += t.match_length),
                                (t.match_length = 0))
                              : ((a = m._tr_tally(t, 0, t.window[t.strstart])),
                                t.lookahead--,
                                t.strstart++),
                            a && (U(t, !1), 0 === t.strm.avail_out))
                          )
                            return 1;
                        }
                        return (
                          (t.insert = 0),
                          4 === e
                            ? (U(t, !0), 0 === t.strm.avail_out ? 3 : 4)
                            : t.last_lit && (U(t, !1), 0 === t.strm.avail_out)
                            ? 1
                            : 2
                        );
                      })(u, e)
                    : n[u.level].func(u, e);
                if (
                  ((3 !== v && 4 !== v) || (u.status = 666), 1 === v || 3 === v)
                )
                  return 0 === t.avail_out && (u.last_flush = -1), 0;
                if (
                  2 === v &&
                  (1 === e
                    ? m._tr_align(u)
                    : 5 !== e &&
                      (m._tr_stored_block(u, 0, 0, !1),
                      3 === e &&
                        (D(u.head),
                        0 === u.lookahead &&
                          ((u.strstart = 0),
                          (u.block_start = 0),
                          (u.insert = 0)))),
                  I(t),
                  0 === t.avail_out)
                )
                  return (u.last_flush = -1), 0;
              }
              return 4 !== e
                ? 0
                : u.wrap <= 0
                ? 1
                : (2 === u.wrap
                    ? (T(u, 255 & t.adler),
                      T(u, (t.adler >> 8) & 255),
                      T(u, (t.adler >> 16) & 255),
                      T(u, (t.adler >> 24) & 255),
                      T(u, 255 & t.total_in),
                      T(u, (t.total_in >> 8) & 255),
                      T(u, (t.total_in >> 16) & 255),
                      T(u, (t.total_in >> 24) & 255))
                    : (F(u, t.adler >>> 16), F(u, 65535 & t.adler)),
                  I(t),
                  0 < u.wrap && (u.wrap = -u.wrap),
                  0 !== u.pending ? 0 : 1);
            }),
            (a.deflateEnd = function (t) {
              var e;
              return t && t.state
                ? 42 !== (e = t.state.status) &&
                  69 !== e &&
                  73 !== e &&
                  91 !== e &&
                  103 !== e &&
                  e !== b &&
                  666 !== e
                  ? N(t, g)
                  : ((t.state = null), e === b ? N(t, -3) : 0)
                : g;
            }),
            (a.deflateSetDictionary = function (t, e) {
              var a,
                n,
                m,
                p,
                y,
                _,
                x,
                b,
                v = e.length;
              if (!t || !t.state) return g;
              if (
                2 === (p = (a = t.state).wrap) ||
                (1 === p && 42 !== a.status) ||
                a.lookahead
              )
                return g;
              for (
                1 === p && (t.adler = f(t.adler, e, v, 0)),
                  a.wrap = 0,
                  v >= a.w_size &&
                    (0 === p &&
                      (D(a.head),
                      (a.strstart = 0),
                      (a.block_start = 0),
                      (a.insert = 0)),
                    (b = new u.Buf8(a.w_size)),
                    u.arraySet(b, e, v - a.w_size, a.w_size, 0),
                    (e = b),
                    (v = a.w_size)),
                  y = t.avail_in,
                  _ = t.next_in,
                  x = t.input,
                  t.avail_in = v,
                  t.next_in = 0,
                  t.input = e,
                  H(a);
                a.lookahead >= 3;

              ) {
                for (
                  n = a.strstart, m = a.lookahead - 2;
                  (a.ins_h =
                    ((a.ins_h << a.hash_shift) ^ a.window[n + 3 - 1]) &
                    a.hash_mask),
                    (a.prev[n & a.w_mask] = a.head[a.ins_h]),
                    (a.head[a.ins_h] = n),
                    n++,
                    --m;

                );
                (a.strstart = n), (a.lookahead = 2), H(a);
              }
              return (
                (a.strstart += a.lookahead),
                (a.block_start = a.strstart),
                (a.insert = a.lookahead),
                (a.lookahead = 0),
                (a.match_length = a.prev_length = 2),
                (a.match_available = 0),
                (t.next_in = _),
                (t.input = x),
                (t.avail_in = y),
                (a.wrap = p),
                0
              );
            }),
            (a.deflateInfo = "pako deflate (from Nodeca project)");
        },
        {
          "../utils/common": 3,
          "./adler32": 5,
          "./crc32": 7,
          "./messages": 13,
          "./trees": 14,
        },
      ],
      9: [
        function (t, e, a) {
          "use strict";
          e.exports = function () {
            (this.text = 0),
              (this.time = 0),
              (this.xflags = 0),
              (this.os = 0),
              (this.extra = null),
              (this.extra_len = 0),
              (this.name = ""),
              (this.comment = ""),
              (this.hcrc = 0),
              (this.done = !1);
          };
        },
        {},
      ],
      10: [
        function (t, e, a) {
          "use strict";
          e.exports = function (t, e) {
            var a,
              n,
              u,
              m,
              f,
              p,
              y,
              g,
              _,
              x,
              b,
              v,
              w,
              S,
              C,
              E,
              z,
              A,
              k,
              B,
              V,
              R,
              J,
              Z,
              $;
            (a = t.state),
              (n = t.next_in),
              (Z = t.input),
              (u = n + (t.avail_in - 5)),
              (m = t.next_out),
              ($ = t.output),
              (f = m - (e - t.avail_out)),
              (p = m + (t.avail_out - 257)),
              (y = a.dmax),
              (g = a.wsize),
              (_ = a.whave),
              (x = a.wnext),
              (b = a.window),
              (v = a.hold),
              (w = a.bits),
              (S = a.lencode),
              (C = a.distcode),
              (E = (1 << a.lenbits) - 1),
              (z = (1 << a.distbits) - 1);
            t: do {
              w < 15 &&
                ((v += Z[n++] << w), (w += 8), (v += Z[n++] << w), (w += 8)),
                (A = S[v & E]);
              e: for (;;) {
                if (
                  ((v >>>= k = A >>> 24), (w -= k), 0 == (k = (A >>> 16) & 255))
                )
                  $[m++] = 65535 & A;
                else {
                  if (!(16 & k)) {
                    if (0 == (64 & k)) {
                      A = S[(65535 & A) + (v & ((1 << k) - 1))];
                      continue e;
                    }
                    if (32 & k) {
                      a.mode = 12;
                      break t;
                    }
                    (t.msg = "invalid literal/length code"), (a.mode = 30);
                    break t;
                  }
                  (B = 65535 & A),
                    (k &= 15) &&
                      (w < k && ((v += Z[n++] << w), (w += 8)),
                      (B += v & ((1 << k) - 1)),
                      (v >>>= k),
                      (w -= k)),
                    w < 15 &&
                      ((v += Z[n++] << w),
                      (w += 8),
                      (v += Z[n++] << w),
                      (w += 8)),
                    (A = C[v & z]);
                  i: for (;;) {
                    if (
                      ((v >>>= k = A >>> 24),
                      (w -= k),
                      !(16 & (k = (A >>> 16) & 255)))
                    ) {
                      if (0 == (64 & k)) {
                        A = C[(65535 & A) + (v & ((1 << k) - 1))];
                        continue i;
                      }
                      (t.msg = "invalid distance code"), (a.mode = 30);
                      break t;
                    }
                    if (
                      ((V = 65535 & A),
                      w < (k &= 15) &&
                        ((v += Z[n++] << w),
                        (w += 8) < k && ((v += Z[n++] << w), (w += 8))),
                      y < (V += v & ((1 << k) - 1)))
                    ) {
                      (t.msg = "invalid distance too far back"), (a.mode = 30);
                      break t;
                    }
                    if (((v >>>= k), (w -= k), (k = m - f) < V)) {
                      if (_ < (k = V - k) && a.sane) {
                        (t.msg = "invalid distance too far back"),
                          (a.mode = 30);
                        break t;
                      }
                      if (((J = b), (R = 0) === x)) {
                        if (((R += g - k), k < B)) {
                          for (B -= k; ($[m++] = b[R++]), --k; );
                          (R = m - V), (J = $);
                        }
                      } else if (x < k) {
                        if (((R += g + x - k), (k -= x) < B)) {
                          for (B -= k; ($[m++] = b[R++]), --k; );
                          if (((R = 0), x < B)) {
                            for (B -= k = x; ($[m++] = b[R++]), --k; );
                            (R = m - V), (J = $);
                          }
                        }
                      } else if (((R += x - k), k < B)) {
                        for (B -= k; ($[m++] = b[R++]), --k; );
                        (R = m - V), (J = $);
                      }
                      for (; 2 < B; )
                        ($[m++] = J[R++]),
                          ($[m++] = J[R++]),
                          ($[m++] = J[R++]),
                          (B -= 3);
                      B && (($[m++] = J[R++]), 1 < B && ($[m++] = J[R++]));
                    } else {
                      for (
                        R = m - V;
                        ($[m++] = $[R++]),
                          ($[m++] = $[R++]),
                          ($[m++] = $[R++]),
                          2 < (B -= 3);

                      );
                      B && (($[m++] = $[R++]), 1 < B && ($[m++] = $[R++]));
                    }
                    break;
                  }
                }
                break;
              }
            } while (n < u && m < p);
            (n -= B = w >> 3),
              (v &= (1 << (w -= B << 3)) - 1),
              (t.next_in = n),
              (t.next_out = m),
              (t.avail_in = n < u ? u - n + 5 : 5 - (n - u)),
              (t.avail_out = m < p ? p - m + 257 : 257 - (m - p)),
              (a.hold = v),
              (a.bits = w);
          };
        },
        {},
      ],
      11: [
        function (t, e, a) {
          "use strict";
          var n = t("../utils/common"),
            u = t("./adler32"),
            m = t("./crc32"),
            f = t("./inffast"),
            p = t("./inftrees"),
            y = -2;
          function L(t) {
            return (
              ((t >>> 24) & 255) +
              ((t >>> 8) & 65280) +
              ((65280 & t) << 8) +
              ((255 & t) << 24)
            );
          }
          function r() {
            (this.mode = 0),
              (this.last = !1),
              (this.wrap = 0),
              (this.havedict = !1),
              (this.flags = 0),
              (this.dmax = 0),
              (this.check = 0),
              (this.total = 0),
              (this.head = null),
              (this.wbits = 0),
              (this.wsize = 0),
              (this.whave = 0),
              (this.wnext = 0),
              (this.window = null),
              (this.hold = 0),
              (this.bits = 0),
              (this.length = 0),
              (this.offset = 0),
              (this.extra = 0),
              (this.lencode = null),
              (this.distcode = null),
              (this.lenbits = 0),
              (this.distbits = 0),
              (this.ncode = 0),
              (this.nlen = 0),
              (this.ndist = 0),
              (this.have = 0),
              (this.next = null),
              (this.lens = new n.Buf16(320)),
              (this.work = new n.Buf16(288)),
              (this.lendyn = null),
              (this.distdyn = null),
              (this.sane = 0),
              (this.back = 0),
              (this.was = 0);
          }
          function s(t) {
            var e;
            return t && t.state
              ? ((e = t.state),
                (t.total_in = t.total_out = e.total = 0),
                (t.msg = ""),
                e.wrap && (t.adler = 1 & e.wrap),
                (e.mode = 1),
                (e.last = 0),
                (e.havedict = 0),
                (e.dmax = 32768),
                (e.head = null),
                (e.hold = 0),
                (e.bits = 0),
                (e.lencode = e.lendyn = new n.Buf32(852)),
                (e.distcode = e.distdyn = new n.Buf32(592)),
                (e.sane = 1),
                (e.back = -1),
                0)
              : y;
          }
          function o(t) {
            var e;
            return t && t.state
              ? (((e = t.state).wsize = 0), (e.whave = 0), (e.wnext = 0), s(t))
              : y;
          }
          function l(t, e) {
            var a, n;
            return t && t.state
              ? ((n = t.state),
                e < 0
                  ? ((a = 0), (e = -e))
                  : ((a = 1 + (e >> 4)), e < 48 && (e &= 15)),
                e && (e < 8 || 15 < e)
                  ? y
                  : (null !== n.window && n.wbits !== e && (n.window = null),
                    (n.wrap = a),
                    (n.wbits = e),
                    o(t)))
              : y;
          }
          function h(t, e) {
            var a, n;
            return t
              ? ((n = new r()),
                ((t.state = n).window = null),
                0 !== (a = l(t, e)) && (t.state = null),
                a)
              : y;
          }
          var g,
            _,
            x = !0;
          function H(t) {
            if (x) {
              var e;
              for (g = new n.Buf32(512), _ = new n.Buf32(32), e = 0; e < 144; )
                t.lens[e++] = 8;
              for (; e < 256; ) t.lens[e++] = 9;
              for (; e < 280; ) t.lens[e++] = 7;
              for (; e < 288; ) t.lens[e++] = 8;
              for (
                p(1, t.lens, 0, 288, g, 0, t.work, { bits: 9 }), e = 0;
                e < 32;

              )
                t.lens[e++] = 5;
              p(2, t.lens, 0, 32, _, 0, t.work, { bits: 5 }), (x = !1);
            }
            (t.lencode = g),
              (t.lenbits = 9),
              (t.distcode = _),
              (t.distbits = 5);
          }
          function j(t, e, a, u) {
            var m,
              f = t.state;
            return (
              null === f.window &&
                ((f.wsize = 1 << f.wbits),
                (f.wnext = 0),
                (f.whave = 0),
                (f.window = new n.Buf8(f.wsize))),
              u >= f.wsize
                ? (n.arraySet(f.window, e, a - f.wsize, f.wsize, 0),
                  (f.wnext = 0),
                  (f.whave = f.wsize))
                : (u < (m = f.wsize - f.wnext) && (m = u),
                  n.arraySet(f.window, e, a - u, m, f.wnext),
                  (u -= m)
                    ? (n.arraySet(f.window, e, a - u, u, 0),
                      (f.wnext = u),
                      (f.whave = f.wsize))
                    : ((f.wnext += m),
                      f.wnext === f.wsize && (f.wnext = 0),
                      f.whave < f.wsize && (f.whave += m))),
              0
            );
          }
          (a.inflateReset = o),
            (a.inflateReset2 = l),
            (a.inflateResetKeep = s),
            (a.inflateInit = function (t) {
              return h(t, 15);
            }),
            (a.inflateInit2 = h),
            (a.inflate = function (t, e) {
              var a,
                g,
                _,
                x,
                b,
                v,
                w,
                S,
                C,
                E,
                z,
                A,
                k,
                B,
                V,
                R,
                J,
                Z,
                $,
                tt,
                et,
                it,
                st,
                at,
                nt = 0,
                ot = new n.Buf8(4),
                rt = [
                  16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1,
                  15,
                ];
              if (!t || !t.state || !t.output || (!t.input && 0 !== t.avail_in))
                return y;
              12 === (a = t.state).mode && (a.mode = 13),
                (b = t.next_out),
                (_ = t.output),
                (w = t.avail_out),
                (x = t.next_in),
                (g = t.input),
                (v = t.avail_in),
                (S = a.hold),
                (C = a.bits),
                (E = v),
                (z = w),
                (it = 0);
              t: for (;;)
                switch (a.mode) {
                  case 1:
                    if (0 === a.wrap) {
                      a.mode = 13;
                      break;
                    }
                    for (; C < 16; ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    if (2 & a.wrap && 35615 === S) {
                      (ot[(a.check = 0)] = 255 & S),
                        (ot[1] = (S >>> 8) & 255),
                        (a.check = m(a.check, ot, 2, 0)),
                        (C = S = 0),
                        (a.mode = 2);
                      break;
                    }
                    if (
                      ((a.flags = 0),
                      a.head && (a.head.done = !1),
                      !(1 & a.wrap) || (((255 & S) << 8) + (S >> 8)) % 31)
                    ) {
                      (t.msg = "incorrect header check"), (a.mode = 30);
                      break;
                    }
                    if (8 != (15 & S)) {
                      (t.msg = "unknown compression method"), (a.mode = 30);
                      break;
                    }
                    if (((C -= 4), (et = 8 + (15 & (S >>>= 4))), 0 === a.wbits))
                      a.wbits = et;
                    else if (et > a.wbits) {
                      (t.msg = "invalid window size"), (a.mode = 30);
                      break;
                    }
                    (a.dmax = 1 << et),
                      (t.adler = a.check = 1),
                      (a.mode = 512 & S ? 10 : 12),
                      (C = S = 0);
                    break;
                  case 2:
                    for (; C < 16; ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    if (((a.flags = S), 8 != (255 & a.flags))) {
                      (t.msg = "unknown compression method"), (a.mode = 30);
                      break;
                    }
                    if (57344 & a.flags) {
                      (t.msg = "unknown header flags set"), (a.mode = 30);
                      break;
                    }
                    a.head && (a.head.text = (S >> 8) & 1),
                      512 & a.flags &&
                        ((ot[0] = 255 & S),
                        (ot[1] = (S >>> 8) & 255),
                        (a.check = m(a.check, ot, 2, 0))),
                      (C = S = 0),
                      (a.mode = 3);
                  case 3:
                    for (; C < 32; ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    a.head && (a.head.time = S),
                      512 & a.flags &&
                        ((ot[0] = 255 & S),
                        (ot[1] = (S >>> 8) & 255),
                        (ot[2] = (S >>> 16) & 255),
                        (ot[3] = (S >>> 24) & 255),
                        (a.check = m(a.check, ot, 4, 0))),
                      (C = S = 0),
                      (a.mode = 4);
                  case 4:
                    for (; C < 16; ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    a.head && ((a.head.xflags = 255 & S), (a.head.os = S >> 8)),
                      512 & a.flags &&
                        ((ot[0] = 255 & S),
                        (ot[1] = (S >>> 8) & 255),
                        (a.check = m(a.check, ot, 2, 0))),
                      (C = S = 0),
                      (a.mode = 5);
                  case 5:
                    if (1024 & a.flags) {
                      for (; C < 16; ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      (a.length = S),
                        a.head && (a.head.extra_len = S),
                        512 & a.flags &&
                          ((ot[0] = 255 & S),
                          (ot[1] = (S >>> 8) & 255),
                          (a.check = m(a.check, ot, 2, 0))),
                        (C = S = 0);
                    } else a.head && (a.head.extra = null);
                    a.mode = 6;
                  case 6:
                    if (
                      1024 & a.flags &&
                      (v < (A = a.length) && (A = v),
                      A &&
                        (a.head &&
                          ((et = a.head.extra_len - a.length),
                          a.head.extra ||
                            (a.head.extra = new Array(a.head.extra_len)),
                          n.arraySet(a.head.extra, g, x, A, et)),
                        512 & a.flags && (a.check = m(a.check, g, A, x)),
                        (v -= A),
                        (x += A),
                        (a.length -= A)),
                      a.length)
                    )
                      break t;
                    (a.length = 0), (a.mode = 7);
                  case 7:
                    if (2048 & a.flags) {
                      if (0 === v) break t;
                      for (
                        A = 0;
                        (et = g[x + A++]),
                          a.head &&
                            et &&
                            a.length < 65536 &&
                            (a.head.name += String.fromCharCode(et)),
                          et && A < v;

                      );
                      if (
                        (512 & a.flags && (a.check = m(a.check, g, A, x)),
                        (v -= A),
                        (x += A),
                        et)
                      )
                        break t;
                    } else a.head && (a.head.name = null);
                    (a.length = 0), (a.mode = 8);
                  case 8:
                    if (4096 & a.flags) {
                      if (0 === v) break t;
                      for (
                        A = 0;
                        (et = g[x + A++]),
                          a.head &&
                            et &&
                            a.length < 65536 &&
                            (a.head.comment += String.fromCharCode(et)),
                          et && A < v;

                      );
                      if (
                        (512 & a.flags && (a.check = m(a.check, g, A, x)),
                        (v -= A),
                        (x += A),
                        et)
                      )
                        break t;
                    } else a.head && (a.head.comment = null);
                    a.mode = 9;
                  case 9:
                    if (512 & a.flags) {
                      for (; C < 16; ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      if (S !== (65535 & a.check)) {
                        (t.msg = "header crc mismatch"), (a.mode = 30);
                        break;
                      }
                      C = S = 0;
                    }
                    a.head &&
                      ((a.head.hcrc = (a.flags >> 9) & 1), (a.head.done = !0)),
                      (t.adler = a.check = 0),
                      (a.mode = 12);
                    break;
                  case 10:
                    for (; C < 32; ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    (t.adler = a.check = L(S)), (C = S = 0), (a.mode = 11);
                  case 11:
                    if (0 === a.havedict)
                      return (
                        (t.next_out = b),
                        (t.avail_out = w),
                        (t.next_in = x),
                        (t.avail_in = v),
                        (a.hold = S),
                        (a.bits = C),
                        2
                      );
                    (t.adler = a.check = 1), (a.mode = 12);
                  case 12:
                    if (5 === e || 6 === e) break t;
                  case 13:
                    if (a.last) {
                      (S >>>= 7 & C), (C -= 7 & C), (a.mode = 27);
                      break;
                    }
                    for (; C < 3; ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    switch (((a.last = 1 & S), (C -= 1), 3 & (S >>>= 1))) {
                      case 0:
                        a.mode = 14;
                        break;
                      case 1:
                        if ((H(a), (a.mode = 20), 6 !== e)) break;
                        (S >>>= 2), (C -= 2);
                        break t;
                      case 2:
                        a.mode = 17;
                        break;
                      case 3:
                        (t.msg = "invalid block type"), (a.mode = 30);
                    }
                    (S >>>= 2), (C -= 2);
                    break;
                  case 14:
                    for (S >>>= 7 & C, C -= 7 & C; C < 32; ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    if ((65535 & S) != ((S >>> 16) ^ 65535)) {
                      (t.msg = "invalid stored block lengths"), (a.mode = 30);
                      break;
                    }
                    if (
                      ((a.length = 65535 & S),
                      (C = S = 0),
                      (a.mode = 15),
                      6 === e)
                    )
                      break t;
                  case 15:
                    a.mode = 16;
                  case 16:
                    if ((A = a.length)) {
                      if ((v < A && (A = v), w < A && (A = w), 0 === A))
                        break t;
                      n.arraySet(_, g, x, A, b),
                        (v -= A),
                        (x += A),
                        (w -= A),
                        (b += A),
                        (a.length -= A);
                      break;
                    }
                    a.mode = 12;
                    break;
                  case 17:
                    for (; C < 14; ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    if (
                      ((a.nlen = 257 + (31 & S)),
                      (S >>>= 5),
                      (C -= 5),
                      (a.ndist = 1 + (31 & S)),
                      (S >>>= 5),
                      (C -= 5),
                      (a.ncode = 4 + (15 & S)),
                      (S >>>= 4),
                      (C -= 4),
                      286 < a.nlen || 30 < a.ndist)
                    ) {
                      (t.msg = "too many length or distance symbols"),
                        (a.mode = 30);
                      break;
                    }
                    (a.have = 0), (a.mode = 18);
                  case 18:
                    for (; a.have < a.ncode; ) {
                      for (; C < 3; ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      (a.lens[rt[a.have++]] = 7 & S), (S >>>= 3), (C -= 3);
                    }
                    for (; a.have < 19; ) a.lens[rt[a.have++]] = 0;
                    if (
                      ((a.lencode = a.lendyn),
                      (a.lenbits = 7),
                      (st = { bits: a.lenbits }),
                      (it = p(0, a.lens, 0, 19, a.lencode, 0, a.work, st)),
                      (a.lenbits = st.bits),
                      it)
                    ) {
                      (t.msg = "invalid code lengths set"), (a.mode = 30);
                      break;
                    }
                    (a.have = 0), (a.mode = 19);
                  case 19:
                    for (; a.have < a.nlen + a.ndist; ) {
                      for (
                        ;
                        (R =
                          ((nt = a.lencode[S & ((1 << a.lenbits) - 1)]) >>>
                            16) &
                          255),
                          (J = 65535 & nt),
                          !((V = nt >>> 24) <= C);

                      ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      if (J < 16) (S >>>= V), (C -= V), (a.lens[a.have++] = J);
                      else {
                        if (16 === J) {
                          for (at = V + 2; C < at; ) {
                            if (0 === v) break t;
                            v--, (S += g[x++] << C), (C += 8);
                          }
                          if (((S >>>= V), (C -= V), 0 === a.have)) {
                            (t.msg = "invalid bit length repeat"),
                              (a.mode = 30);
                            break;
                          }
                          (et = a.lens[a.have - 1]),
                            (A = 3 + (3 & S)),
                            (S >>>= 2),
                            (C -= 2);
                        } else if (17 === J) {
                          for (at = V + 3; C < at; ) {
                            if (0 === v) break t;
                            v--, (S += g[x++] << C), (C += 8);
                          }
                          (C -= V),
                            (et = 0),
                            (A = 3 + (7 & (S >>>= V))),
                            (S >>>= 3),
                            (C -= 3);
                        } else {
                          for (at = V + 7; C < at; ) {
                            if (0 === v) break t;
                            v--, (S += g[x++] << C), (C += 8);
                          }
                          (C -= V),
                            (et = 0),
                            (A = 11 + (127 & (S >>>= V))),
                            (S >>>= 7),
                            (C -= 7);
                        }
                        if (a.have + A > a.nlen + a.ndist) {
                          (t.msg = "invalid bit length repeat"), (a.mode = 30);
                          break;
                        }
                        for (; A--; ) a.lens[a.have++] = et;
                      }
                    }
                    if (30 === a.mode) break;
                    if (0 === a.lens[256]) {
                      (t.msg = "invalid code -- missing end-of-block"),
                        (a.mode = 30);
                      break;
                    }
                    if (
                      ((a.lenbits = 9),
                      (st = { bits: a.lenbits }),
                      (it = p(1, a.lens, 0, a.nlen, a.lencode, 0, a.work, st)),
                      (a.lenbits = st.bits),
                      it)
                    ) {
                      (t.msg = "invalid literal/lengths set"), (a.mode = 30);
                      break;
                    }
                    if (
                      ((a.distbits = 6),
                      (a.distcode = a.distdyn),
                      (st = { bits: a.distbits }),
                      (it = p(
                        2,
                        a.lens,
                        a.nlen,
                        a.ndist,
                        a.distcode,
                        0,
                        a.work,
                        st
                      )),
                      (a.distbits = st.bits),
                      it)
                    ) {
                      (t.msg = "invalid distances set"), (a.mode = 30);
                      break;
                    }
                    if (((a.mode = 20), 6 === e)) break t;
                  case 20:
                    a.mode = 21;
                  case 21:
                    if (6 <= v && 258 <= w) {
                      (t.next_out = b),
                        (t.avail_out = w),
                        (t.next_in = x),
                        (t.avail_in = v),
                        (a.hold = S),
                        (a.bits = C),
                        f(t, z),
                        (b = t.next_out),
                        (_ = t.output),
                        (w = t.avail_out),
                        (x = t.next_in),
                        (g = t.input),
                        (v = t.avail_in),
                        (S = a.hold),
                        (C = a.bits),
                        12 === a.mode && (a.back = -1);
                      break;
                    }
                    for (
                      a.back = 0;
                      (R =
                        ((nt = a.lencode[S & ((1 << a.lenbits) - 1)]) >>> 16) &
                        255),
                        (J = 65535 & nt),
                        !((V = nt >>> 24) <= C);

                    ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    if (R && 0 == (240 & R)) {
                      for (
                        Z = V, $ = R, tt = J;
                        (R =
                          ((nt =
                            a.lencode[
                              tt + ((S & ((1 << (Z + $)) - 1)) >> Z)
                            ]) >>>
                            16) &
                          255),
                          (J = 65535 & nt),
                          !(Z + (V = nt >>> 24) <= C);

                      ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      (S >>>= Z), (C -= Z), (a.back += Z);
                    }
                    if (
                      ((S >>>= V),
                      (C -= V),
                      (a.back += V),
                      (a.length = J),
                      0 === R)
                    ) {
                      a.mode = 26;
                      break;
                    }
                    if (32 & R) {
                      (a.back = -1), (a.mode = 12);
                      break;
                    }
                    if (64 & R) {
                      (t.msg = "invalid literal/length code"), (a.mode = 30);
                      break;
                    }
                    (a.extra = 15 & R), (a.mode = 22);
                  case 22:
                    if (a.extra) {
                      for (at = a.extra; C < at; ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      (a.length += S & ((1 << a.extra) - 1)),
                        (S >>>= a.extra),
                        (C -= a.extra),
                        (a.back += a.extra);
                    }
                    (a.was = a.length), (a.mode = 23);
                  case 23:
                    for (
                      ;
                      (R =
                        ((nt = a.distcode[S & ((1 << a.distbits) - 1)]) >>>
                          16) &
                        255),
                        (J = 65535 & nt),
                        !((V = nt >>> 24) <= C);

                    ) {
                      if (0 === v) break t;
                      v--, (S += g[x++] << C), (C += 8);
                    }
                    if (0 == (240 & R)) {
                      for (
                        Z = V, $ = R, tt = J;
                        (R =
                          ((nt =
                            a.distcode[
                              tt + ((S & ((1 << (Z + $)) - 1)) >> Z)
                            ]) >>>
                            16) &
                          255),
                          (J = 65535 & nt),
                          !(Z + (V = nt >>> 24) <= C);

                      ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      (S >>>= Z), (C -= Z), (a.back += Z);
                    }
                    if (((S >>>= V), (C -= V), (a.back += V), 64 & R)) {
                      (t.msg = "invalid distance code"), (a.mode = 30);
                      break;
                    }
                    (a.offset = J), (a.extra = 15 & R), (a.mode = 24);
                  case 24:
                    if (a.extra) {
                      for (at = a.extra; C < at; ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      (a.offset += S & ((1 << a.extra) - 1)),
                        (S >>>= a.extra),
                        (C -= a.extra),
                        (a.back += a.extra);
                    }
                    if (a.offset > a.dmax) {
                      (t.msg = "invalid distance too far back"), (a.mode = 30);
                      break;
                    }
                    a.mode = 25;
                  case 25:
                    if (0 === w) break t;
                    if (((A = z - w), a.offset > A)) {
                      if ((A = a.offset - A) > a.whave && a.sane) {
                        (t.msg = "invalid distance too far back"),
                          (a.mode = 30);
                        break;
                      }
                      (k =
                        A > a.wnext
                          ? ((A -= a.wnext), a.wsize - A)
                          : a.wnext - A),
                        A > a.length && (A = a.length),
                        (B = a.window);
                    } else (B = _), (k = b - a.offset), (A = a.length);
                    for (
                      w < A && (A = w), w -= A, a.length -= A;
                      (_[b++] = B[k++]), --A;

                    );
                    0 === a.length && (a.mode = 21);
                    break;
                  case 26:
                    if (0 === w) break t;
                    (_[b++] = a.length), w--, (a.mode = 21);
                    break;
                  case 27:
                    if (a.wrap) {
                      for (; C < 32; ) {
                        if (0 === v) break t;
                        v--, (S |= g[x++] << C), (C += 8);
                      }
                      if (
                        ((z -= w),
                        (t.total_out += z),
                        (a.total += z),
                        z &&
                          (t.adler = a.check =
                            a.flags
                              ? m(a.check, _, z, b - z)
                              : u(a.check, _, z, b - z)),
                        (z = w),
                        (a.flags ? S : L(S)) !== a.check)
                      ) {
                        (t.msg = "incorrect data check"), (a.mode = 30);
                        break;
                      }
                      C = S = 0;
                    }
                    a.mode = 28;
                  case 28:
                    if (a.wrap && a.flags) {
                      for (; C < 32; ) {
                        if (0 === v) break t;
                        v--, (S += g[x++] << C), (C += 8);
                      }
                      if (S !== (4294967295 & a.total)) {
                        (t.msg = "incorrect length check"), (a.mode = 30);
                        break;
                      }
                      C = S = 0;
                    }
                    a.mode = 29;
                  case 29:
                    it = 1;
                    break t;
                  case 30:
                    it = -3;
                    break t;
                  case 31:
                    return -4;
                  case 32:
                  default:
                    return y;
                }
              return (
                (t.next_out = b),
                (t.avail_out = w),
                (t.next_in = x),
                (t.avail_in = v),
                (a.hold = S),
                (a.bits = C),
                (a.wsize ||
                  (z !== t.avail_out &&
                    a.mode < 30 &&
                    (a.mode < 27 || 4 !== e))) &&
                j(t, t.output, t.next_out, z - t.avail_out)
                  ? ((a.mode = 31), -4)
                  : ((E -= t.avail_in),
                    (z -= t.avail_out),
                    (t.total_in += E),
                    (t.total_out += z),
                    (a.total += z),
                    a.wrap &&
                      z &&
                      (t.adler = a.check =
                        a.flags
                          ? m(a.check, _, z, t.next_out - z)
                          : u(a.check, _, z, t.next_out - z)),
                    (t.data_type =
                      a.bits +
                      (a.last ? 64 : 0) +
                      (12 === a.mode ? 128 : 0) +
                      (20 === a.mode || 15 === a.mode ? 256 : 0)),
                    ((0 === E && 0 === z) || 4 === e) && 0 === it && (it = -5),
                    it)
              );
            }),
            (a.inflateEnd = function (t) {
              if (!t || !t.state) return y;
              var e = t.state;
              return e.window && (e.window = null), (t.state = null), 0;
            }),
            (a.inflateGetHeader = function (t, e) {
              var a;
              return t && t.state
                ? 0 == (2 & (a = t.state).wrap)
                  ? y
                  : (((a.head = e).done = !1), 0)
                : y;
            }),
            (a.inflateSetDictionary = function (t, e) {
              var a,
                n = e.length;
              return t && t.state
                ? 0 !== (a = t.state).wrap && 11 !== a.mode
                  ? y
                  : 11 === a.mode && u(1, e, n, 0) !== a.check
                  ? -3
                  : j(t, e, n, n)
                  ? ((a.mode = 31), -4)
                  : ((a.havedict = 1), 0)
                : y;
            }),
            (a.inflateInfo = "pako inflate (from Nodeca project)");
        },
        {
          "../utils/common": 3,
          "./adler32": 5,
          "./crc32": 7,
          "./inffast": 10,
          "./inftrees": 12,
        },
      ],
      12: [
        function (t, e, a) {
          "use strict";
          var n = t("../utils/common"),
            u = [
              3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 15, 17, 19, 23, 27, 31, 35, 43,
              51, 59, 67, 83, 99, 115, 131, 163, 195, 227, 258, 0, 0,
            ],
            m = [
              16, 16, 16, 16, 16, 16, 16, 16, 17, 17, 17, 17, 18, 18, 18, 18,
              19, 19, 19, 19, 20, 20, 20, 20, 21, 21, 21, 21, 16, 72, 78,
            ],
            f = [
              1, 2, 3, 4, 5, 7, 9, 13, 17, 25, 33, 49, 65, 97, 129, 193, 257,
              385, 513, 769, 1025, 1537, 2049, 3073, 4097, 6145, 8193, 12289,
              16385, 24577, 0, 0,
            ],
            p = [
              16, 16, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
              23, 23, 24, 24, 25, 25, 26, 26, 27, 27, 28, 28, 29, 29, 64, 64,
            ];
          e.exports = function (t, e, a, y, g, _, x, b) {
            var v,
              w,
              S,
              C,
              E,
              z,
              A,
              k,
              B,
              V = b.bits,
              R = 0,
              J = 0,
              Z = 0,
              $ = 0,
              tt = 0,
              et = 0,
              it = 0,
              st = 0,
              at = 0,
              nt = 0,
              ot = null,
              rt = 0,
              ht = new n.Buf16(16),
              lt = new n.Buf16(16),
              ct = null,
              dt = 0;
            for (R = 0; R <= 15; R++) ht[R] = 0;
            for (J = 0; J < y; J++) ht[e[a + J]]++;
            for (tt = V, $ = 15; 1 <= $ && 0 === ht[$]; $--);
            if (($ < tt && (tt = $), 0 === $))
              return (g[_++] = 20971520), (g[_++] = 20971520), (b.bits = 1), 0;
            for (Z = 1; Z < $ && 0 === ht[Z]; Z++);
            for (tt < Z && (tt = Z), R = st = 1; R <= 15; R++)
              if (((st <<= 1), (st -= ht[R]) < 0)) return -1;
            if (0 < st && (0 === t || 1 !== $)) return -1;
            for (lt[1] = 0, R = 1; R < 15; R++) lt[R + 1] = lt[R] + ht[R];
            for (J = 0; J < y; J++) 0 !== e[a + J] && (x[lt[e[a + J]]++] = J);
            if (
              ((z =
                0 === t
                  ? ((ot = ct = x), 19)
                  : 1 === t
                  ? ((ot = u), (rt -= 257), (ct = m), (dt -= 257), 256)
                  : ((ot = f), (ct = p), -1)),
              (R = Z),
              (E = _),
              (it = J = nt = 0),
              (S = -1),
              (C = (at = 1 << (et = tt)) - 1),
              (1 === t && 852 < at) || (2 === t && 592 < at))
            )
              return 1;
            for (;;) {
              for (
                A = R - it,
                  B =
                    x[J] < z
                      ? ((k = 0), x[J])
                      : x[J] > z
                      ? ((k = ct[dt + x[J]]), ot[rt + x[J]])
                      : ((k = 96), 0),
                  v = 1 << (R - it),
                  Z = w = 1 << et;
                (g[E + (nt >> it) + (w -= v)] = (A << 24) | (k << 16) | B | 0),
                  0 !== w;

              );
              for (v = 1 << (R - 1); nt & v; ) v >>= 1;
              if (
                (0 !== v ? ((nt &= v - 1), (nt += v)) : (nt = 0),
                J++,
                0 == --ht[R])
              ) {
                if (R === $) break;
                R = e[a + x[J]];
              }
              if (tt < R && (nt & C) !== S) {
                for (
                  0 === it && (it = tt), E += Z, st = 1 << (et = R - it);
                  et + it < $ && !((st -= ht[et + it]) <= 0);

                )
                  et++, (st <<= 1);
                if (
                  ((at += 1 << et),
                  (1 === t && 852 < at) || (2 === t && 592 < at))
                )
                  return 1;
                g[(S = nt & C)] = (tt << 24) | (et << 16) | (E - _) | 0;
              }
            }
            return (
              0 !== nt && (g[E + nt] = ((R - it) << 24) | (64 << 16) | 0),
              (b.bits = tt),
              0
            );
          };
        },
        { "../utils/common": 3 },
      ],
      13: [
        function (t, e, a) {
          "use strict";
          e.exports = {
            2: "need dictionary",
            1: "stream end",
            0: "",
            "-1": "file error",
            "-2": "stream error",
            "-3": "data error",
            "-4": "insufficient memory",
            "-5": "buffer error",
            "-6": "incompatible version",
          };
        },
        {},
      ],
      14: [
        function (t, e, a) {
          "use strict";
          var n = t("../utils/common");
          function i(t) {
            for (var e = t.length; 0 <= --e; ) t[e] = 0;
          }
          var u = 256,
            m = 286,
            f = 30,
            p = 15,
            y = [
              0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4,
              4, 4, 5, 5, 5, 5, 0,
            ],
            g = [
              0, 0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9,
              10, 10, 11, 11, 12, 12, 13, 13,
            ],
            _ = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 7],
            x = [
              16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15,
            ],
            b = new Array(576);
          i(b);
          var v = new Array(60);
          i(v);
          var w = new Array(512);
          i(w);
          var S = new Array(256);
          i(S);
          var C = new Array(29);
          i(C);
          var E,
            z,
            A,
            k = new Array(f);
          function I(t, e, a, n, u) {
            (this.static_tree = t),
              (this.extra_bits = e),
              (this.extra_base = a),
              (this.elems = n),
              (this.max_length = u),
              (this.has_stree = t && t.length);
          }
          function r(t, e) {
            (this.dyn_tree = t), (this.max_code = 0), (this.stat_desc = e);
          }
          function U(t) {
            return t < 256 ? w[t] : w[256 + (t >>> 7)];
          }
          function T(t, e) {
            (t.pending_buf[t.pending++] = 255 & e),
              (t.pending_buf[t.pending++] = (e >>> 8) & 255);
          }
          function F(t, e, a) {
            t.bi_valid > 16 - a
              ? ((t.bi_buf |= (e << t.bi_valid) & 65535),
                T(t, t.bi_buf),
                (t.bi_buf = e >> (16 - t.bi_valid)),
                (t.bi_valid += a - 16))
              : ((t.bi_buf |= (e << t.bi_valid) & 65535), (t.bi_valid += a));
          }
          function L(t, e, a) {
            F(t, a[2 * e], a[2 * e + 1]);
          }
          function H(t, e) {
            for (var a = 0; (a |= 1 & t), (t >>>= 1), (a <<= 1), 0 < --e; );
            return a >>> 1;
          }
          function j(t, e, a) {
            var n,
              u,
              m = new Array(16),
              f = 0;
            for (n = 1; n <= p; n++) m[n] = f = (f + a[n - 1]) << 1;
            for (u = 0; u <= e; u++) {
              var y = t[2 * u + 1];
              0 !== y && (t[2 * u] = H(m[y]++, y));
            }
          }
          function K(t) {
            var e;
            for (e = 0; e < m; e++) t.dyn_ltree[2 * e] = 0;
            for (e = 0; e < f; e++) t.dyn_dtree[2 * e] = 0;
            for (e = 0; e < 19; e++) t.bl_tree[2 * e] = 0;
            (t.dyn_ltree[512] = 1),
              (t.opt_len = t.static_len = 0),
              (t.last_lit = t.matches = 0);
          }
          function M(t) {
            8 < t.bi_valid
              ? T(t, t.bi_buf)
              : 0 < t.bi_valid && (t.pending_buf[t.pending++] = t.bi_buf),
              (t.bi_buf = 0),
              (t.bi_valid = 0);
          }
          function P(t, e, a, n) {
            var u = 2 * e,
              m = 2 * a;
            return t[u] < t[m] || (t[u] === t[m] && n[e] <= n[a]);
          }
          function Y(t, e, a) {
            for (
              var n = t.heap[a], u = a << 1;
              u <= t.heap_len &&
              (u < t.heap_len && P(e, t.heap[u + 1], t.heap[u], t.depth) && u++,
              !P(e, n, t.heap[u], t.depth));

            )
              (t.heap[a] = t.heap[u]), (a = u), (u <<= 1);
            t.heap[a] = n;
          }
          function q(t, e, a) {
            var n,
              m,
              f,
              p,
              _ = 0;
            if (0 !== t.last_lit)
              for (
                ;
                (n =
                  (t.pending_buf[t.d_buf + 2 * _] << 8) |
                  t.pending_buf[t.d_buf + 2 * _ + 1]),
                  (m = t.pending_buf[t.l_buf + _]),
                  _++,
                  0 === n
                    ? L(t, m, e)
                    : (L(t, (f = S[m]) + u + 1, e),
                      0 !== (p = y[f]) && F(t, (m -= C[f]), p),
                      L(t, (f = U(--n)), a),
                      0 !== (p = g[f]) && F(t, (n -= k[f]), p)),
                  _ < t.last_lit;

              );
            L(t, 256, e);
          }
          function G(t, e) {
            var a,
              n,
              u,
              m = e.dyn_tree,
              f = e.stat_desc.static_tree,
              y = e.stat_desc.has_stree,
              g = e.stat_desc.elems,
              _ = -1;
            for (t.heap_len = 0, t.heap_max = 573, a = 0; a < g; a++)
              0 !== m[2 * a]
                ? ((t.heap[++t.heap_len] = _ = a), (t.depth[a] = 0))
                : (m[2 * a + 1] = 0);
            for (; t.heap_len < 2; )
              (m[2 * (u = t.heap[++t.heap_len] = _ < 2 ? ++_ : 0)] = 1),
                (t.depth[u] = 0),
                t.opt_len--,
                y && (t.static_len -= f[2 * u + 1]);
            for (e.max_code = _, a = t.heap_len >> 1; 1 <= a; a--) Y(t, m, a);
            for (
              u = g;
              (a = t.heap[1]),
                (t.heap[1] = t.heap[t.heap_len--]),
                Y(t, m, 1),
                (n = t.heap[1]),
                (t.heap[--t.heap_max] = a),
                (t.heap[--t.heap_max] = n),
                (m[2 * u] = m[2 * a] + m[2 * n]),
                (t.depth[u] =
                  (t.depth[a] >= t.depth[n] ? t.depth[a] : t.depth[n]) + 1),
                (m[2 * a + 1] = m[2 * n + 1] = u),
                (t.heap[1] = u++),
                Y(t, m, 1),
                2 <= t.heap_len;

            );
            (t.heap[--t.heap_max] = t.heap[1]),
              (function (t, e) {
                var a,
                  n,
                  u,
                  m,
                  f,
                  y,
                  g = e.dyn_tree,
                  _ = e.max_code,
                  x = e.stat_desc.static_tree,
                  b = e.stat_desc.has_stree,
                  v = e.stat_desc.extra_bits,
                  w = e.stat_desc.extra_base,
                  S = e.stat_desc.max_length,
                  C = 0;
                for (m = 0; m <= p; m++) t.bl_count[m] = 0;
                for (
                  g[2 * t.heap[t.heap_max] + 1] = 0, a = t.heap_max + 1;
                  a < 573;
                  a++
                )
                  S < (m = g[2 * g[2 * (n = t.heap[a]) + 1] + 1] + 1) &&
                    ((m = S), C++),
                    (g[2 * n + 1] = m),
                    _ < n ||
                      (t.bl_count[m]++,
                      (f = 0),
                      w <= n && (f = v[n - w]),
                      (y = g[2 * n]),
                      (t.opt_len += y * (m + f)),
                      b && (t.static_len += y * (x[2 * n + 1] + f)));
                if (0 !== C) {
                  do {
                    for (m = S - 1; 0 === t.bl_count[m]; ) m--;
                    t.bl_count[m]--,
                      (t.bl_count[m + 1] += 2),
                      t.bl_count[S]--,
                      (C -= 2);
                  } while (0 < C);
                  for (m = S; 0 !== m; m--)
                    for (n = t.bl_count[m]; 0 !== n; )
                      _ < (u = t.heap[--a]) ||
                        (g[2 * u + 1] !== m &&
                          ((t.opt_len += (m - g[2 * u + 1]) * g[2 * u]),
                          (g[2 * u + 1] = m)),
                        n--);
                }
              })(t, e),
              j(m, _, t.bl_count);
          }
          function X(t, e, a) {
            var n,
              u,
              m = -1,
              f = e[1],
              p = 0,
              y = 7,
              g = 4;
            for (
              0 === f && ((y = 138), (g = 3)),
                e[2 * (a + 1) + 1] = 65535,
                n = 0;
              n <= a;
              n++
            )
              (u = f),
                (f = e[2 * (n + 1) + 1]),
                (++p < y && u === f) ||
                  (p < g
                    ? (t.bl_tree[2 * u] += p)
                    : 0 !== u
                    ? (u !== m && t.bl_tree[2 * u]++, t.bl_tree[32]++)
                    : p <= 10
                    ? t.bl_tree[34]++
                    : t.bl_tree[36]++,
                  (m = u),
                  (g =
                    (p = 0) === f
                      ? ((y = 138), 3)
                      : u === f
                      ? ((y = 6), 3)
                      : ((y = 7), 4)));
          }
          function W(t, e, a) {
            var n,
              u,
              m = -1,
              f = e[1],
              p = 0,
              y = 7,
              g = 4;
            for (0 === f && ((y = 138), (g = 3)), n = 0; n <= a; n++)
              if (((u = f), (f = e[2 * (n + 1) + 1]), !(++p < y && u === f))) {
                if (p < g) for (; L(t, u, t.bl_tree), 0 != --p; );
                else
                  0 !== u
                    ? (u !== m && (L(t, u, t.bl_tree), p--),
                      L(t, 16, t.bl_tree),
                      F(t, p - 3, 2))
                    : p <= 10
                    ? (L(t, 17, t.bl_tree), F(t, p - 3, 3))
                    : (L(t, 18, t.bl_tree), F(t, p - 11, 7));
                (m = u),
                  (g =
                    (p = 0) === f
                      ? ((y = 138), 3)
                      : u === f
                      ? ((y = 6), 3)
                      : ((y = 7), 4));
              }
          }
          i(k);
          var B = !1;
          function Q(t, e, a, u) {
            var m, f, p;
            F(t, 0 + (u ? 1 : 0), 3),
              (f = e),
              (p = a),
              M((m = t)),
              T(m, p),
              T(m, ~p),
              n.arraySet(m.pending_buf, m.window, f, p, m.pending),
              (m.pending += p);
          }
          (a._tr_init = function (t) {
            B ||
              ((function () {
                var t,
                  e,
                  a,
                  n,
                  u,
                  x = new Array(16);
                for (n = a = 0; n < 28; n++)
                  for (C[n] = a, t = 0; t < 1 << y[n]; t++) S[a++] = n;
                for (S[a - 1] = n, n = u = 0; n < 16; n++)
                  for (k[n] = u, t = 0; t < 1 << g[n]; t++) w[u++] = n;
                for (u >>= 7; n < f; n++)
                  for (k[n] = u << 7, t = 0; t < 1 << (g[n] - 7); t++)
                    w[256 + u++] = n;
                for (e = 0; e <= p; e++) x[e] = 0;
                for (t = 0; t <= 143; ) (b[2 * t + 1] = 8), t++, x[8]++;
                for (; t <= 255; ) (b[2 * t + 1] = 9), t++, x[9]++;
                for (; t <= 279; ) (b[2 * t + 1] = 7), t++, x[7]++;
                for (; t <= 287; ) (b[2 * t + 1] = 8), t++, x[8]++;
                for (j(b, 287, x), t = 0; t < f; t++)
                  (v[2 * t + 1] = 5), (v[2 * t] = H(t, 5));
                (E = new I(b, y, 257, m, p)),
                  (z = new I(v, g, 0, f, p)),
                  (A = new I(new Array(0), _, 0, 19, 7));
              })(),
              (B = !0)),
              (t.l_desc = new r(t.dyn_ltree, E)),
              (t.d_desc = new r(t.dyn_dtree, z)),
              (t.bl_desc = new r(t.bl_tree, A)),
              (t.bi_buf = 0),
              (t.bi_valid = 0),
              K(t);
          }),
            (a._tr_stored_block = Q),
            (a._tr_flush_block = function (t, e, a, n) {
              var m,
                f,
                p = 0;
              0 < t.level
                ? (2 === t.strm.data_type &&
                    (t.strm.data_type = (function (t) {
                      var e,
                        a = 4093624447;
                      for (e = 0; e <= 31; e++, a >>>= 1)
                        if (1 & a && 0 !== t.dyn_ltree[2 * e]) return 0;
                      if (
                        0 !== t.dyn_ltree[18] ||
                        0 !== t.dyn_ltree[20] ||
                        0 !== t.dyn_ltree[26]
                      )
                        return 1;
                      for (e = 32; e < u; e++)
                        if (0 !== t.dyn_ltree[2 * e]) return 1;
                      return 0;
                    })(t)),
                  G(t, t.l_desc),
                  G(t, t.d_desc),
                  (p = (function (t) {
                    var e;
                    for (
                      X(t, t.dyn_ltree, t.l_desc.max_code),
                        X(t, t.dyn_dtree, t.d_desc.max_code),
                        G(t, t.bl_desc),
                        e = 18;
                      3 <= e && 0 === t.bl_tree[2 * x[e] + 1];
                      e--
                    );
                    return (t.opt_len += 3 * (e + 1) + 5 + 5 + 4), e;
                  })(t)),
                  (m = (t.opt_len + 3 + 7) >>> 3),
                  (f = (t.static_len + 3 + 7) >>> 3) <= m && (m = f))
                : (m = f = a + 5),
                a + 4 <= m && -1 !== e
                  ? Q(t, e, a, n)
                  : 4 === t.strategy || f === m
                  ? (F(t, 2 + (n ? 1 : 0), 3), q(t, b, v))
                  : (F(t, 4 + (n ? 1 : 0), 3),
                    (function (t, e, a, n) {
                      var u;
                      for (
                        F(t, e - 257, 5), F(t, a - 1, 5), F(t, n - 4, 4), u = 0;
                        u < n;
                        u++
                      )
                        F(t, t.bl_tree[2 * x[u] + 1], 3);
                      W(t, t.dyn_ltree, e - 1), W(t, t.dyn_dtree, a - 1);
                    })(t, t.l_desc.max_code + 1, t.d_desc.max_code + 1, p + 1),
                    q(t, t.dyn_ltree, t.dyn_dtree)),
                K(t),
                n && M(t);
            }),
            (a._tr_tally = function (t, e, a) {
              return (
                (t.pending_buf[t.d_buf + 2 * t.last_lit] = (e >>> 8) & 255),
                (t.pending_buf[t.d_buf + 2 * t.last_lit + 1] = 255 & e),
                (t.pending_buf[t.l_buf + t.last_lit] = 255 & a),
                t.last_lit++,
                0 === e
                  ? t.dyn_ltree[2 * a]++
                  : (t.matches++,
                    e--,
                    t.dyn_ltree[2 * (S[a] + u + 1)]++,
                    t.dyn_dtree[2 * U(e)]++),
                t.last_lit === t.lit_bufsize - 1
              );
            }),
            (a._tr_align = function (t) {
              var e;
              F(t, 2, 3),
                L(t, 256, b),
                16 === (e = t).bi_valid
                  ? (T(e, e.bi_buf), (e.bi_buf = 0), (e.bi_valid = 0))
                  : 8 <= e.bi_valid &&
                    ((e.pending_buf[e.pending++] = 255 & e.bi_buf),
                    (e.bi_buf >>= 8),
                    (e.bi_valid -= 8));
            });
        },
        { "../utils/common": 3 },
      ],
      15: [
        function (t, e, a) {
          "use strict";
          e.exports = function () {
            (this.input = null),
              (this.next_in = 0),
              (this.avail_in = 0),
              (this.total_in = 0),
              (this.output = null),
              (this.next_out = 0),
              (this.avail_out = 0),
              (this.total_out = 0),
              (this.msg = ""),
              (this.state = null),
              (this.data_type = 2),
              (this.adler = 0);
          };
        },
        {},
      ],
      "/": [
        function (t, e, a) {
          "use strict";
          var n = {};
          (0, t("./lib/utils/common").assign)(
            n,
            t("./lib/deflate"),
            t("./lib/inflate"),
            t("./lib/zlib/constants")
          ),
            (e.exports = n);
        },
        {
          "./lib/deflate": 1,
          "./lib/inflate": 2,
          "./lib/utils/common": 3,
          "./lib/zlib/constants": 6,
        },
      ],
    },
    {},
    []
  )("/")),
  (window.fx = (function (t) {
    "use strict";
    var e = Laya.Vector2,
      a = Laya.Vector3,
      n = Laya.Vector4,
      u = Laya.Color,
      m = Laya.Dialog,
      f = Laya.EventDispatcher;
    const p = {
      E_APP_ON_PAUSE: "$ONPAUSE",
      E_APP_ON_RESUME: "$ONRESUME",
      E_PANEL_OPENCLOSE: "$PANEL_OPENCLOSE",
      E_SOUND_PLAY_OK: "$SOUND_PLAY_OK",
      E_UI_ADAPTED: "UI_ADAPTED",
      E_PROP_CHANGED: "$USER_PROP_CHANGED",
      E_PHYSICS_COLLISION: "PHYSICS_COLLISION_ENTER",
      E_PHYSICS_COLLISION_EXIT: "PHYSICS_COLLISION_EXIT",
      E_MATERIAL_LOADED: "MATERIAL_LOAD_COMPLETE",
      E_ANIM_STATE_CHENGED: "$ANIM_STATE_CHENGE",
      E_ANIM_EVENT: "$ANIM_EVENT_TRIGGER",
      E_SERVER_CFG_COMPLETE: "E_SERVER_CFG_COMPLETE",
    };
    var y;
    ((y = t.BaseCode || (t.BaseCode = {}))[(y.PANEL_OPEN = 0)] = "PANEL_OPEN"),
      (y[(y.PANEL_CLOSE = 1)] = "PANEL_CLOSE"),
      (y[(y.VIEW_OPEN = 2)] = "VIEW_OPEN"),
      (y[(y.VIEW_CLOSE = 3)] = "VIEW_CLOSE"),
      (y[(y.SCENE_CHANGE = 4)] = "SCENE_CHANGE"),
      (y[(y.SOUND_MUSIC_PLAY_OK = 5)] = "SOUND_MUSIC_PLAY_OK"),
      (y[(y.SOUND_FX_PLAY_OK = 6)] = "SOUND_FX_PLAY_OK"),
      (y[(y.HTTP_INTERFACE_UNDEFINED = 7)] = "HTTP_INTERFACE_UNDEFINED"),
      (y[(y.E_ANIM_START = 8)] = "E_ANIM_START"),
      (y[(y.E_ANIM_STOP = 9)] = "E_ANIM_STOP"),
      (y[(y.E_ANIM_ABORT = 10)] = "E_ANIM_ABORT");
    class g {
      constructor(t, e, a, n) {
        (this.lb = t), (this.rb = e), (this.lt = a), (this.rt = n);
      }
    }
    const _ = window.Physics;
    class x {}
    var b;
    ((b = t.Gender || (t.Gender = {}))[(b.Male = 0)] = "Male"),
      (b[(b.Female = 1)] = "Female");
    const v = { x: 0.3, y: 0.59, z: 0.11 };
    class w {
      static isNumber(t) {
        return Number.isFinite(t);
      }
      static isStrNumber(t) {
        return Number.isFinite(+t);
      }
      static enableLog() {
        Laya.Log.enable();
        let t = console.log;
        console.log = function (e) {
          Laya.Log.print(e), t(e);
        };
      }
      static profile(t) {
        if (!t) throw Error("profile key is unexpected !!!");
        this.profileMap[t] = Laya.Browser.now();
      }
      static profileEnd(t, e = 0) {
        if (!t) throw Error("profile key is unexpected !!!");
        if (this.profileMap[t]) {
          let a = Laya.Browser.now() - this.profileMap[t];
          return (
            delete this.profileMap[t],
            a > e &&
              console.log("%c################ %s: %sms", "color:#00aa00", t, a),
            a
          );
        }
        return 0;
      }
      static isEmpty(t) {
        for (const e in t) return !1;
        return !0;
      }
      static getGID() {
        return Laya.Utils.getGID();
      }
      static isOnMiniGame() {
        let t = Laya.ClassUtils.getRegClass("Sdk");
        return (
          t.isOnToutiao() ||
          t.isOnWeiXin() ||
          t.isOnQQ() ||
          t.isOnOppo() ||
          t.isOnBaidu() ||
          t.isOnVivo() ||
          t.isOnTapTap() ||
          t.isOnXiaoMi() ||
          t.isOnHuaWei()
        );
      }
      static isOnPC() {
        let t = Laya.Browser,
          e = t._window || window;
        return -1 != (t.userAgent || e.navigator.userAgent).indexOf("Windows");
      }
      static isOnNativeAndroid() {
        if (!window.conchConfig) return !1;
        return "Conch-android" == window.conchConfig.getOS();
      }
      static isOnNativeIos() {
        if (!window.conchConfig) return !1;
        return "Conch-ios" == window.conchConfig.getOS();
      }
      static isQMP() {
        if (void 0 !== this.sIsQMP) return this.sIsQMP;
        let t = !1,
          e = Laya.Browser.clientWidth,
          a = Laya.Browser.clientHeight;
        if (
          (console.log(
            "isQMP userAgent:",
            Laya.Browser.window.navigator.userAgent,
            e,
            a
          ),
          Laya.Browser.onAndroid)
        )
          t =
            Laya.stage.scaleMode == Laya.Stage.SCREEN_VERTICAL
              ? a / e > 2
              : e / a > 2;
        else {
          let n =
              /iPhone/gi.test(Laya.Browser.window.navigator.userAgent) &&
              375 == Math.min(a, e) &&
              812 == Math.max(a, e),
            u = 414 == Math.min(a, e) && 896 == Math.max(a, e),
            m = Laya.MiniAdpter,
            f = Laya.BMiniAdapter;
          ((Laya.Browser.onMiniGame &&
            !Laya.Browser.onAndroid &&
            -1 != m.systemInfo.model.indexOf("iPhone X")) ||
            (Laya.Browser.onBDMiniGame &&
              !Laya.Browser.onAndroid &&
              -1 != f.systemInfo.model.indexOf("iPhone X")) ||
            n ||
            u) &&
            (t = !0);
        }
        return console.log("isQMP = ", t), (this.sIsQMP = t), t;
      }
      static isNotchScreenDevice() {
        if (void 0 !== this.sNotchScreen) return this.sNotchScreen;
        let t = Laya.ClassUtils.getRegClass("Sdk"),
          e = t.instance.getSystemInfo();
        if (e && e.model) {
          for (let t of this.NotchScreenCfg)
            if (-1 != e.model.indexOf(t.model)) {
              this.sNotchScreen = t;
              break;
            }
          if (!this.sNotchScreen)
            if (e.safeArea) {
              if (Laya.stage.scaleMode == Laya.Stage.SCREEN_VERTICAL) {
                let t = e.safeArea.top || 0;
                if (t > 20) {
                  let a = Math.max(
                    Laya.Browser.clientHeight - e.safeArea.bottom,
                    0
                  );
                  this.sNotchScreen = {
                    model: e.model,
                    notchTop: t,
                    notchBottom: a,
                  };
                }
              } else {
                let t = e.safeArea.left || 0;
                if (t > 20) {
                  let a = Math.max(
                    Laya.Browser.clientWidth - e.safeArea.right,
                    0
                  );
                  this.sNotchScreen = {
                    model: e.model,
                    notchTop: t,
                    notchBottom: a,
                  };
                }
              }
              this.sNotchScreen || (this.sNotchScreen = null);
            } else {
              if (Laya.stage.scaleMode == Laya.Stage.SCREEN_VERTICAL) {
                let a = t.instance.getMenuButtonBoundingClientRect();
                a && a.top > 20
                  ? (this.sNotchScreen = {
                      model: e.model,
                      notchTop: a.top,
                      notchBottom: 20,
                    })
                  : (this.sNotchScreen = null);
              }
              !this.sNotchScreen &&
                this.isQMP() &&
                (this.sNotchScreen = {
                  model: e.model,
                  notchTop: 30,
                  notchBottom: 20,
                });
            }
        }
        return (
          this.sNotchScreen
            ? console.log(
                "isNotchScreenDevice: ",
                JSON.stringify(this.sNotchScreen)
              )
            : console.log("isNotchScreenDevice: false"),
          this.sNotchScreen
        );
      }
      static randomArray(t) {
        if (!t || 0 == t.length) return t;
        let e = t.length;
        for (; e; ) {
          let a = Math.floor(Math.random() * e--);
          [t[a], t[e]] = [t[e], t[a]];
        }
        return t;
      }
      static randomArrayEx(t) {
        if (!t || 0 == t.length) return [];
        let e = (t = t.slice()).length;
        for (; e; ) {
          let a = Math.floor(Math.random() * e--);
          [t[a], t[e]] = [t[e], t[a]];
        }
        return t;
      }
      static diffArray(t, e, a = !1) {
        return t && 0 != t.length
          ? e && 0 != e.length
            ? a
              ? t
                  .filter((t) => !e.includes(t))
                  .concat(e.filter((e) => !t.includes(e)))
              : t.filter((t) => !e.includes(t))
            : t.concat([])
          : e.concat([]);
      }
      static randomInArray(t) {
        if (!t || 0 == t.length) return null;
        return t[Math.floor(Math.random() * t.length)];
      }
      static randomInArrayEx(t, e) {
        if (!t || 0 == t.length) return null;
        let a = this.copyArray(t);
        return this.randomArray(a), a.slice(0, Math.min(e, a.length));
      }
      static showTips(t, e = 2, a, n = "#ffffff") {
        let u = new Laya.Label();
        (u.fontSize = 30),
          (u.color = n),
          (u.centerX = 0),
          (u.centerY = 0),
          (u.bold = !0),
          (u.stroke = 5),
          (u.strokeColor = "#000000"),
          (u.text = t);
        let m = u.width + 50,
          f = u.height + 30,
          p = new Laya.Box();
        (p.zOrder = 1e4),
          (p.width = m),
          (p.height = f),
          a
            ? ((p.x = a.x), (p.y = a.y))
            : ((p.x = (Laya.stage.width - p.width) >> 1), (p.y = 300)),
          Laya.stage.addChild(p);
        let y = new Laya.Image("res/img_tips.png");
        (y.sizeGrid = "25,27,30,26"),
          (y.width = m),
          (y.height = f),
          (y.alpha = 0.5),
          p.addChild(y),
          p.addChild(u),
          Laya.Tween.from(
            p,
            { y: 400, alpha: 0 },
            200,
            null,
            Laya.Handler.create(this, () => {
              Laya.Tween.to(
                p,
                { y: 200, alpha: 0 },
                200,
                null,
                Laya.Handler.create(this, () => {
                  p.destroy();
                }),
                1e3 * e,
                !0,
                !0
              );
            })
          );
      }
      static adaptNode(t, e, a, n = !0, u) {
        const adaptFunc = function (m, f) {
          if (u) {
            let u = e / m,
              p = a / f,
              y = n ? Math.max(u, p) : Math.min(u, p);
            t.scaleX = t.scaleY = y;
          } else {
            let u = m / f,
              p = u * a,
              y = e / u;
            n
              ? p * a > e * y
                ? ((m = p), (f = a))
                : ((m = e), (f = y))
              : p * a < e * y
              ? ((m = p), (f = a))
              : ((m = e), (f = y)),
              (t.width = m),
              (t.height = f);
          }
        };
        if (t instanceof Laya.Image && "img_bg" != t.name) {
          if (t._RegisterLoaded) return;
          (t._RegisterLoaded = !0),
            t.on(Laya.Event.LOADED, this, () => {
              t.destroyed ||
                ((t.width = t._bitmap._source.width),
                (t.height = t._bitmap._source.height),
                adaptFunc(t.width, t.height));
            });
        } else adaptFunc(t.width, t.height);
      }
      static getClassName(t) {
        return t.__proto__.constructor.name;
      }
      static checkClick(t = 300) {
        let e = Laya.Browser.now();
        return e - this.lastClickTime <= t
          ? ((this.lastClickTime = e), !0)
          : ((this.lastClickTime = e), !1);
      }
      static getHexColorStringF(t, e, a) {
        return (
          (t = Math.floor(255 * t)),
          (e = Math.floor(255 * e)),
          (a = Math.floor(255 * a)),
          this.getHexColorStringI(t, e, a)
        );
      }
      static getHexColorStringI(t, e, a) {
        let n = (t << 16) + (e << 8) + a;
        return Laya.Utils.toHexColor(n);
      }
      static rgbToHsb(t, e, a) {
        let n, u, m;
        (t /= 255), (e /= 255), (a /= 255);
        let f = Math.min(t, e, a),
          p = (m = Math.max(t, e, a)),
          y = p - f;
        if (p == f) n = 0;
        else {
          switch (p) {
            case t:
              n = (e - a) / y + (e < a ? 6 : 0);
              break;
            case e:
              n = 2 + (a - t) / y;
              break;
            case a:
              n = 4 + (t - e) / y;
          }
          n = Math.round(60 * n) - 180;
        }
        return (
          (u = 0 == p ? 0 : 1 - f / p),
          (u = Math.round(200 * u) - 100),
          (m = Math.round(200 * m) - 100),
          [n, u, m]
        );
      }
      static hsbToRgb(t, e, a) {
        let n = (e + 100) / 200,
          u = (a + 100) / 200,
          m = t + 180,
          f = 0,
          p = 0,
          y = 0,
          g = parseInt(((m / 60) % 6).toString()),
          _ = m / 60 - g,
          x = u * (1 - n),
          b = u * (1 - _ * n),
          v = u * (1 - (1 - _) * n);
        switch (g) {
          case 0:
            (f = u), (p = v), (y = x);
            break;
          case 1:
            (f = b), (p = u), (y = x);
            break;
          case 2:
            (f = x), (p = u), (y = v);
            break;
          case 3:
            (f = x), (p = b), (y = u);
            break;
          case 4:
            (f = v), (p = x), (y = u);
            break;
          case 5:
            (f = u), (p = x), (y = b);
        }
        return (
          (f = parseInt((255 * f).toString())),
          (p = parseInt((255 * p).toString())),
          (y = parseInt((255 * y).toString())),
          [f, p, y]
        );
      }
      static colorHexTo3I(t) {
        if ("#" != t.charAt(0)) return new a();
        t = t.substr(1);
        let e = parseInt(t, 16);
        return new a((16711680 & e) >> 16, (65280 & e) >> 8, 255 & e);
      }
      static colorHexTo3F(t) {
        if ("#" != t.charAt(0)) return new a();
        t = t.substr(1);
        let e = parseInt(t, 16);
        return new a(
          ((16711680 & e) >> 16) / 255,
          ((65280 & e) >> 8) / 255,
          (255 & e) / 255
        );
      }
      static colorHexTo4I(t) {
        if ("#" != t.charAt(0)) return new Laya.Vector4();
        t = t.substr(1);
        let e = parseInt(t, 16);
        return new Laya.Vector4(
          (16711680 & e) >> 16,
          (65280 & e) >> 8,
          255 & e,
          255
        );
      }
      static colorHexTo4F(t) {
        if ("#" != t.charAt(0)) return new Laya.Vector4();
        t = t.substr(1);
        let e = parseInt(t, 16);
        return new Laya.Vector4(
          ((16711680 & e) >> 16) / 255,
          ((65280 & e) >> 8) / 255,
          (255 & e) / 255,
          1
        );
      }
      static getRandomColor4F() {
        let t = this.getNumberRandom(0, 1),
          e = this.getNumberRandom(0, 1),
          a = this.getNumberRandom(0, 1);
        return new Laya.Vector4(t, e, a, 1);
      }
      static getRandomColor3F() {
        let t = this.getNumberRandom(0, 1),
          e = this.getNumberRandom(0, 1),
          n = this.getNumberRandom(0, 1);
        return new a(t, e, n);
      }
      static color3Fto3I(t) {
        return new a(255 * t.x, 255 * t.y, 255 * t.z);
      }
      static color3Ito3F(t) {
        return new a(t.x / 255, t.y / 255, t.z / 255);
      }
      static color3Fto4F(t) {
        return new Laya.Vector4(t.x, t.y, t.z, 1);
      }
      static color4Fto3F(t) {
        return new a(t.x, t.y, t.z);
      }
      static color4Fto3I(t) {
        return new a(255 * t.x, 255 * t.y, 255 * t.z);
      }
      static color3Ito4F(t) {
        return new Laya.Vector4(t.x / 255, t.y / 255, t.z / 255, 1);
      }
      static getColorLumin3F(t) {
        return a.dot(t, v);
      }
      static getColorLumin3I(t) {
        let e = this.color3Ito3F(t);
        return this.getColorLumin3F(e);
      }
      static setColorLumin3F(t, e) {
        let n = this.getColorLumin3F(t);
        return a.scale(t, e / n, t), a.Clamp(t, a.ZERO, a.ONE, t), t;
      }
      static getColorLumin4F(t) {
        return a.dot(t, v);
      }
      static setColorLumin4F(t, e) {
        let a = this.color4Fto3F(t);
        return (
          (a = this.setColorLumin3F(a, e)), t.setValue(a.x, a.y, a.z, t.w), t
        );
      }
      static getRandomColorString() {
        let t = this.getIntRandom(0, 255),
          e = this.getIntRandom(0, 255),
          a = this.getIntRandom(0, 255);
        return this.getHexColorStringI(t, e, a);
      }
      static copyArray(t) {
        if (!t) return t;
        let e = new Array();
        return Laya.Utils.copyArray(e, t);
      }
      static cloneArray(t) {
        if (!t) return t;
        let e = new Array();
        for (let a = 0; a < t.length; a++) {
          let n = t[a];
          e[a] =
            n instanceof Array
              ? this.cloneArray(n)
              : n instanceof Object
              ? this.cloneDeep(n)
              : n;
        }
        return e;
      }
      static clone(t) {
        let e = {},
          a = Object.getOwnPropertyNames(t);
        for (let n of a) e[n] = t[n];
        return e;
      }
      static cloneDeep(t) {
        if (!t) return;
        let e = {},
          a = Object.getOwnPropertyNames(t);
        for (let n of a) {
          let a = t[n];
          e[n] =
            a instanceof Array
              ? this.copyArray(a)
              : a instanceof Object
              ? this.cloneDeep(a)
              : a;
        }
        return e;
      }
      static getFileExt(t) {
        return Laya.Utils.getFileExtension(t);
      }
      static getGlobalBounds(t, e) {
        let a = t.getBounds();
        a = a.clone();
        let n = new Laya.Point(a.x, a.y);
        return (
          (n = t.parent.localToGlobal(n)),
          e
            ? ((n = e.globalToLocal(n)), a.setTo(n.x, n.y, a.width, a.height))
            : a.setTo(n.x, n.y, a.width, a.height),
          a
        );
      }
      static getIntRandom(t, e) {
        return Math.floor(Math.random() * (e - t + 1) + t);
      }
      static getNumberRandom(t, e) {
        return Math.random() * (e - t) + t;
      }
      static getNumberRandomEx(t, e) {
        return Math.randomEx() * (e - t) + t;
      }
      static getSignRandom() {
        return 0 == this.getIntRandom(0, 1) ? -1 : 1;
      }
      static formatNumber(t, e = 0) {
        if (this.isNumber(t)) {
          let a = t.toFixed(e);
          return (
            (a = a
              .split("")
              .reverse()
              .join("")
              .replace(/(\d{3})/g, "$1,")
              .replace(/\,$/, "")
              .split("")
              .reverse()
              .join("")),
            a
          );
        }
        return (t = 0).toFixed(e);
      }
      static checkPowerOf2(t) {
        return 0 == (t &= t - 1);
      }
      static getIndex2N(t) {
        if (1 == t) return 0;
        if (this.checkPowerOf2(t)) {
          let e = 1;
          for (; t; ) {
            if (1 == t || 2 == t) return e;
            t % 2 == 0 && ((t >>= 1), (e += 1));
          }
        }
        return -1;
      }
      static getIndexN(t, e) {
        let a = t;
        for (let n = 0; n < e; ++n) a *= t;
        return a;
      }
      static roundNumber(t, e) {
        let a = Math.pow(10, e);
        return Math.round(t * a) / a;
      }
      static showBorder(t, e = !0, a, n) {
        let u = t;
        if (!e)
          return void (
            u.__border &&
            (Laya.timer.clearAll(u),
            u.__border.removeSelf(),
            (u.__border = null))
          );
        if (u.__border) return;
        let m = new Laya.Sprite();
        (u.__border = m),
          Laya.stage.addChild(m),
          Laya.timer.loop(50, u, function () {
            let e = w.getGlobalBounds(t, n);
            m.graphics.clear(),
              (a = a || "#ff0000"),
              m.graphics.drawRect(e.x, e.y, e.width, e.height, null, a, 2);
          }),
          t.once(Laya.Event.REMOVED, this, function () {
            this.showBorder(t, !1);
          });
      }
      static showBounds(t) {
        let e = t;
        if (e.__linebound) {
          let a = this.get3dModelCenter(t);
          return void (e.__linebound.transform.position = a);
        }
        let a = this.get3dModelSize(t),
          n = new Laya.MeshSprite3D(
            Laya.PrimitiveMesh.createBox(a.x, a.y, a.z)
          ),
          u = this.linearModel(n),
          m = this.get3dModelCenter(t);
        (u.transform.position = m),
          this.getDefault3dScene().addChild(u),
          (e.__linebound = u);
      }
      static showLocalBounds(t) {
        if (t.getChildByName("linebound")) return;
        let e = this.get3dLocalModelSize(t),
          n = new Laya.MeshSprite3D(
            Laya.PrimitiveMesh.createBox(e.x, e.y, e.z)
          ),
          u = this.linearModel(n);
        u.name = "linebound";
        let m = this.get3dModelCenter(t, !0),
          f = this.get3dModelAnchor(t, !0);
        a.subtract(m, f, m), u.transform.translate(m), t.addChild(u);
      }
      static get3dModelCenter(t, e = !1, n, u) {
        let m = this.get3dModelBounds(t, e, n, u),
          f = new a();
        return a.add(m.getMin(), m.getExtent(), f), f;
      }
      static get3dModelAnchor(t, e = !1) {
        let n = new a(),
          u = this.tempMatrix;
        return (
          t.transform.localMatrix.invert(u),
          a.transformV3ToV3(t.transform.localPosition, u, n),
          e || a.transformV3ToV3(n, t.transform.worldMatrix, n),
          n
        );
      }
      static linearModel(t, e = 50, n = Laya.Color.GREEN) {
        let u = new a(),
          m = new a(),
          f = new a(),
          p = new Laya.PixelLineSprite3D(e);
        if (t instanceof Laya.MeshSprite3D) {
          let e = t,
            y = e.meshFilter.sharedMesh,
            g = y._vertexBuffer,
            _ = g.getFloat32Data(),
            x = y._indexBuffer.getData(),
            b = g.vertexDeclaration.vertexStride / 4,
            v = 0,
            w = 0;
          for (let t = 0; t < x.length; t += 3)
            (v = 0),
              (w = 0),
              (u.x = _[x[t + v] * b + w++]),
              (u.y = _[x[t + v] * b + w++]),
              (u.z = _[x[t + v] * b + w++]),
              v++,
              (w = 0),
              (m.x = _[x[t + v] * b + w++]),
              (m.y = _[x[t + v] * b + w++]),
              (m.z = _[x[t + v] * b + w++]),
              v++,
              (w = 0),
              (f.x = _[x[t + v] * b + w++]),
              (f.y = _[x[t + v] * b + w++]),
              (f.z = _[x[t + v] * b + w++]),
              v++,
              a.transformCoordinate(u, e.transform.worldMatrix, u),
              a.transformCoordinate(m, e.transform.worldMatrix, m),
              a.transformCoordinate(f, e.transform.worldMatrix, f),
              p.addLine(u, m, n, n),
              p.addLine(m, f, n, n),
              p.addLine(f, u, n, n);
        }
        return p;
      }
      static showRedDot(t, e) {
        let a, n;
        if (
          (t instanceof Laya.Point || t instanceof Laya.Vector2
            ? ((a = Laya.stage), (n = t))
            : ((a = t),
              e
                ? (n = new Laya.Point(e.x, e.y))
                : ((n = new Laya.Point(a.x, a.y)), (n = a.fromParentPoint(n)))),
          a.__reddot)
        )
          return;
        let u = new Laya.Sprite();
        u.scale(1 / a.scaleX, 1 / a.scaleY),
          (u.x = n.x),
          (u.y = n.y),
          a.addChild(u),
          u.graphics.clear(),
          u.graphics.drawCircle(0, 0, 5, "#ff0000", "#ff0000", 2),
          (a.__reddot = u),
          a.once(Laya.Event.REMOVED, this, function () {
            (a.__reddot = void 0), u.removeSelf();
          });
      }
      static showRedDot3d(t, e = 0.1, a, u) {
        let m = a || this.getDefault3dScene(),
          f = m.getChildByName("__reddot");
        if (f)
          return void (u
            ? (f.transform.localPosition = t)
            : (f.transform.position = t));
        let p = Laya.PrimitiveMesh.createSphere(e);
        (f = new Laya.MeshSprite3D(p)), (f.name = "__reddot");
        let y = new Laya.UnlitMaterial();
        (y.depthTest = Laya.RenderState.DEPTHTEST_ALWAYS),
          (y.albedoColor = new n(1, 0, 0, 1)),
          (f.meshRenderer.material = y),
          m.addChild(f),
          u ? (f.transform.localPosition = t) : (f.transform.position = t);
      }
      static pathInfo(t) {
        let e = "",
          a = "",
          n = "",
          u = "",
          m = "",
          f = "",
          p = t;
        if (t) {
          p = t.replace("\\", "/");
          let y = t.match(/((^.+)\/)((\w+)(\.(\w+)))/i);
          y && y.length > 1
            ? ((e = y[1]),
              (a = y[2]),
              (n = y[3]),
              (u = y[4]),
              (m = y[5]),
              (f = y[6]))
            : (u = t);
        }
        return {
          dir: e,
          dirname: a,
          file: n,
          filename: u,
          ext: m,
          extname: f,
          full: p,
        };
      }
      static createAnim(t, e) {
        let a = new Laya.Animation();
        return (
          a.loadAnimation(
            t,
            Laya.Handler.create(this, function () {
              !a.destroyed && e && e.runWith(a);
            })
          ),
          a
        );
      }
      static playAnim(t, e, a, n, u) {
        t.play(a, n, u),
          e &&
            (n
              ? t.on(Laya.Event.COMPLETE, e.caller, function () {
                  e.run();
                })
              : t.once(Laya.Event.COMPLETE, e.caller, function () {
                  e.run();
                }));
      }
      static getAnimSize(t, e) {
        if (t.isPlaying) {
          let a = t.getSelfBounds();
          e.runWith(a);
        } else {
          t.play();
          let func = function () {
            t.gotoAndStop(0);
            let a = t.getSelfBounds();
            e.runWith(a);
          };
          t.once(Laya.Event.REMOVED, this, () => {
            Laya.timer.clear(this, func);
          }),
            Laya.timer.frameOnce(1, this, func);
        }
      }
      static createAni(t) {
        let e = new Laya.Animation();
        return (
          t.parent.addChild(e),
          e.pos(t.pos.x, t.pos.y, !0),
          e.offAll(),
          e.on(Laya.Event.LABEL, t.lbCaller, t.lbCb),
          e.on(Laya.Event.COMPLETE, t.completeCaller, t.completeCb),
          e
        );
      }
      static playAni(t, e, a, n, u, m, f, p) {
        t &&
          t.loadAnimation(
            e,
            Laya.Handler.create(this, () => {
              (t.visible = !0), t.play(n, u, a), m && f && f.apply(m, p);
            })
          );
      }
      static recoverAni(t) {
        t && (t.offAll(), (t.loop = !1), t.removeSelf());
      }
      static createParticle(t, e = !0) {
        let a,
          n = Laya.loader.getRes(t);
        return (
          n
            ? (a = new Laya.Particle2D(n))
            : ((a = new Laya.Particle2D(null)), a.load(t)),
          (a.autoPlay = e),
          a
        );
      }
      static getLength(t) {
        return Object.keys(t).length;
      }
      static randomByRate(t) {
        return t > 1 && (t *= 0.01), Math.random() > 1 - t;
      }
      static applyMixins(t, e, a) {
        t.prototype &&
          e.forEach((e) => {
            Object.getOwnPropertyNames(e.prototype).forEach((n) => {
              "constructor" != n &&
                ((t.prototype[n] = e.prototype[n]), (t._super = a));
            });
          });
      }
      static super(t) {
        let e = this.getModule(t);
        return e._super || e.__super || e.__proto__;
      }
      static getModule(t) {
        return t.__proto__.constructor;
      }
      static getNumberZeroAmount(t) {
        if (null == t || isNaN(t)) return console.log("非法参数"), [0, 0];
        let e = 0;
        for (;;) {
          let a = t / 1e3;
          if (a < 1) break;
          (t = a), (e += 1);
        }
        return [(t = 0 !== e ? Number(t.toFixed(2)) : Math.floor(t)), 3 * e];
      }
      static getStringZeroAmount(t) {
        if (null == t || "string" != typeof t)
          return console.log("非法参数"), [0, 0];
        let e = t.indexOf("."),
          a = 0,
          n = 0,
          u = (t = t.slice(0, e)).length;
        (n = Math.floor(u / 3)), (a = u % 3), 0 == a && ((a = 3), (n -= 1));
        let m = Number(t.slice(a, a + 2));
        return (
          (m = Number(t.slice(a + 2, a + 3)) >= 5 ? m + 1 : m),
          [Number(t.slice(0, a) + "." + m), 3 * n]
        );
      }
      static formatNumberWithUnits(t) {
        let [e, a] = w.getFormatNumberWithUnitsInfo(t);
        return e + a;
      }
      static getFormatNumberWithUnitsInfo(t, e) {
        let [a, n] = [null, null];
        "number" == typeof t
          ? ([a, n] = w.getNumberZeroAmount(t))
          : "string" == typeof t && ([a, n] = w.getStringZeroAmount(t));
        let u = "" + n,
          m = null;
        return (
          (m = null != e ? e[u] : w.numberUnit[u]),
          null == m && (m = ""),
          [a, m]
        );
      }
      static takeOneByWeight(t, e) {
        let a = [];
        if (e) {
          let n = t,
            u = e;
          if (n.length !== u.length)
            return void console.log("对象数组和权重数组长度不匹配!!!");
          for (let t = 0; t < n.length; ++t) {
            let e = n[t],
              m = u[t];
            a.push({ o: e, weight: m });
          }
        } else a = t;
        if (!a) return void console.log("带权数组为空!!!");
        let n = 0,
          u = [];
        for (let t = 0; t < a.length; ++t) {
          let e = a[t].weight;
          null != e && ((n += e), u.push({ prob: n, ele: a[t] }));
        }
        let m = null,
          f = 0,
          p = w.getIntRandom(1, n);
        for (let t = 0; t < u.length; ++t)
          if (p <= u[t].prob) {
            (m = u[t].ele), (f = t);
            break;
          }
        return [f, m];
      }
      static takeSomeByWeight(t, e, a) {
        let n = [];
        if (a) {
          let t = e,
            u = a;
          if (t.length !== u.length)
            return void console.log("对象数组和权重数组长度不匹配!!!");
          for (let e = 0; e < t.length; ++e) {
            let a = t[e],
              m = u[e];
            n.push({ o: a, weight: m });
          }
        } else n = e;
        if (null == n) return void console.log("带权数组为空!!!");
        let u = [],
          m = n.slice();
        for (let e = 0; e < t; ++e) {
          let [t, e] = w.takeOneByWeight(m);
          m.splice(t, 1), u.push([t, e]);
        }
        return u;
      }
      static getUIFrameAnimation(t, e) {
        return t[e];
      }
      static getAnimationActionName(t) {
        return t._actionName;
      }
      static getAnimationUrl(t) {
        return t._url;
      }
      static timestampToTime(t, e) {
        e
          ? !e.separator && (e.separator = ["h ", "m ", "s"])
          : (e = { separator: ["h ", "m ", "s"], isAlign: !1 });
        let a = t / 1e3,
          n = Math.floor(a / 3600),
          u = "";
        n >= 0 &&
          (u =
            n < 10 && e.isAlign
              ? "0" + n + e.separator[0]
              : n + e.separator[0]);
        let m = Math.floor((a % 3600) / 60),
          f = "";
        m >= 0 &&
          (f =
            m < 10 && e.isAlign
              ? "0" + m + e.separator[1]
              : m + e.separator[1]);
        let p = Math.floor(a % 60),
          y = "";
        return (
          p >= 0 &&
            (y =
              p < 10 && e.isAlign
                ? "0" + p + e.separator[2]
                : p + e.separator[2]),
          u + f + y
        );
      }
      static timestampToMS(t, e) {
        e
          ? !e.separator && (e.separator = ["m ", "s"])
          : (e = { separator: ["m ", "s"], isAlign: !1 });
        let a = t / 1e3,
          n = Math.floor((a % 3600) / 60),
          u = "";
        n >= 0 &&
          (u =
            n < 10 && e.isAlign
              ? "0" + n + e.separator[0]
              : n + e.separator[0]);
        let m = Math.floor(a % 60),
          f = "";
        return (
          m >= 0 &&
            ((f = m < 10 && e.isAlign ? "0" + m : m + ""),
            e.separator[1] && (f += e.separator[1])),
          u + f
        );
      }
      static timestampToHM(t, e) {
        e
          ? !e.separator && (e.separator = ["h ", "m"])
          : (e = { separator: ["h ", "m"], isAlign: !1 });
        let a = t / 1e3,
          n = Math.floor(a / 3600),
          u = "";
        n >= 0 &&
          (u =
            n < 10 && e.isAlign
              ? "0" + n + e.separator[0]
              : n + e.separator[0]);
        let m = Math.floor((a % 3600) / 60),
          f = "";
        return (
          m >= 0 &&
            (f =
              m < 10 && e.isAlign
                ? "0" + m + e.separator[1]
                : m + e.separator[1]),
          u + f
        );
      }
      static countdown(t, e, a) {
        const clear = function () {
            e.clearTimer(e, tick);
          },
          tick = function () {
            (t = Math.max(t - 1e3, 0)),
              a.call(e, t),
              t <= 0 && (clear(), e.off(Laya.Event.REMOVED, this, clear));
          };
        e.once(Laya.Event.REMOVED, this, clear), e.timerLoop(1e3, e, tick);
      }
      static getDayInYear(t) {
        let e = t || new Date(),
          a = new Date(e.getFullYear().toString()).getTime(),
          n = e.getTime();
        return Math.ceil((n - a) / 864e5);
      }
      static initRelativeDate(t) {
        (w.relativeDate = t), (w.localLaunchDate = new Date());
      }
      static getDate() {
        return w.relativeDate || new Date();
      }
      static getTime() {
        if (w.relativeDate) {
          let t = new Date().getTime() - w.localLaunchDate.getTime();
          return w.relativeDate.getTime() + t;
        }
        return new Date().getTime();
      }
      static isToday(t) {
        let e;
        e = "string" == typeof t ? new Date(t) : t;
        let a = new Date();
        return e >= new Date(a.getFullYear(), a.getMonth(), a.getDate());
      }
      static assign(t, e, a = !0) {
        let n = a ? Object.keys(t) : Object.keys(e);
        return e instanceof Array && n.pop(), this.assignFrom(t, e, n);
      }
      static assignFrom(t, e, a) {
        let n = [];
        for (let u of a)
          null != e[u] && e[u] != t[u] && ((t[u] = e[u]), n.push(u));
        return n;
      }
      static stringformat(t, e) {
        let a = e;
        if ("object" != typeof a) {
          a = {};
          for (let t in arguments)
            "0" !== t && (a[Number(t) - 1] = arguments[t]);
        }
        for (let e in a) {
          let m = a[e];
          (n = e),
            (u = m),
            (t = t.replace(new RegExp("\\{" + n + "\\}", "gm"), u));
        }
        var n, u;
        return t;
      }
      static binarySearch(t, e, a = 1) {
        let n = 0,
          u = t.length - 1;
        for (; n <= u; ) {
          let m = Math.floor((n + u) / 2),
            f = Math.min(m + a, u),
            p = e(t[m], t[f], m);
          if (0 == p) return m;
          p > 0 ? (n = m) : (u = m);
        }
        return -1;
      }
      static get3dModelSize(t, e, n) {
        let u = this.get3dModelBounds(t, !1, e, n),
          m = u.getMax(),
          f = u.getMin(),
          p = new a();
        return a.subtract(m, f, p), p;
      }
      static get3dLocalModelSize(t, e, n) {
        let u = this.get3dModelBounds(t, !0, e, n),
          m = u.getMax(),
          f = u.getMin(),
          p = new a();
        return a.subtract(m, f, p), p;
      }
      static get3dModelBounds(t, e, n, u) {
        let m = new a(1 / 0, 1 / 0, 1 / 0),
          f = new a(-1 / 0, -1 / 0, -1 / 0),
          p = new Laya.Bounds(m, f);
        if (e) {
          let e = t;
          e.meshFilter &&
            ((p = e.meshFilter.sharedMesh.bounds.clone()),
            m.from(p.getMin()),
            f.from(p.getMax()));
        } else {
          let e = this.getSpRenderer(t);
          e && ((p = e.bounds.clone()), m.from(p.getMin()), f.from(p.getMax()));
        }
        if (t.numChildren > 0) {
          let y = t.getChildren(),
            _proc3dModel = (t) => {
              let y = this.get3dModelBounds(t, e, n, u);
              a.min(p.getMin(), y.getMin(), m),
                a.max(p.getMax(), y.getMax(), f),
                p.setMin(m),
                p.setMax(f);
            };
          for (const t of y)
            n
              ? -1 != n.indexOf(t.name) && _proc3dModel(t)
              : (u && -1 != u.indexOf(t.name)) || _proc3dModel(t);
        } else if (e && m.x != 1 / 0 && m.y != 1 / 0 && m.z != 1 / 0) {
          let e = p;
          e._tranform(t.transform.localMatrix, e);
        }
        return p;
      }
      static create3dModel(t, e, n, u = !0) {
        t
          ? Laya.timer.callLater(this, () => {
              u && Laya.loader.setGroup(t, "3DRES_GROUP"),
                Laya.Sprite3D.load(
                  t,
                  Laya.Handler.create(this, (...t) => {
                    if (e && !e.destroyed) {
                      let u = t[t.length - 1];
                      if (u instanceof Laya.Sprite3D) {
                        let t = u.name,
                          e = u.getAllComponents(),
                          n = u.getChildAt(0);
                        n &&
                          n.name == t &&
                          e &&
                          e.length > 0 &&
                          a.equals(u.transform.position, a.ZERO) &&
                          ((u.transform.localPosition = a.ZERO),
                          (u.transform.position = a.ZERO));
                      }
                      n.call(e, ...t);
                    }
                  })
                );
            })
          : console.error("create3dModel lh url is illegal !!!");
      }
      static create3dModels(t, e, n, u = !0) {
        t && 0 != t.length
          ? Laya.timer.callLater(this, () => {
              if (u) for (const e of t) Laya.loader.setGroup(e, "3DRES_GROUP");
              Laya.Sprite3D.load(
                t,
                Laya.Handler.create(this, (...u) => {
                  let m = [];
                  if (e && !e.destroyed) {
                    for (const e of t) {
                      let t = e,
                        n = Laya.loader.getRes(t.url);
                      if (n && (m.push(n), n instanceof Laya.Sprite3D)) {
                        let t = n.name,
                          e = n.getAllComponents(),
                          u = n.getChildAt(0);
                        u &&
                          u.name == t &&
                          e &&
                          e.length > 0 &&
                          a.equals(n.transform.position, a.ZERO) &&
                          ((n.transform.localPosition = a.ZERO),
                          (n.transform.position = a.ZERO));
                      }
                    }
                    n.call(e, m);
                  }
                })
              );
            })
          : console.error("create3dModel lh url is illegal !!!");
      }
      static getDefault3dScene() {
        return Laya.stage._scene3Ds[0];
      }
      static getDefaultCamera() {
        let t = this.getDefault3dScene();
        if (t) return t._cameraPool[0];
      }
      static getAllCameras() {
        let t = this.getDefault3dScene();
        if (t) return t._cameraPool.concat();
      }
      static convert3dto2d(t, e) {
        let a = new n();
        return (
          (e = e || this.getDefaultCamera()).viewport.project(
            t.transform.position,
            e.projectionViewMatrix,
            a
          ),
          new Laya.Vector2(
            a.x / Laya.stage.clientScaleX,
            a.y / Laya.stage.clientScaleY
          )
        );
      }
      static convert3dto2dP(t, e) {
        let a = new n();
        return (
          (e = e || this.getDefaultCamera()).viewport.project(
            t,
            e.projectionViewMatrix,
            a
          ),
          new Laya.Vector2(
            a.x / Laya.stage.clientScaleX,
            a.y / Laya.stage.clientScaleY
          )
        );
      }
      static convert3dtoRect(t, e) {
        e = e || this.getDefaultCamera();
        let a = new n(),
          u = new n(),
          m = w.get3dModelBounds(t);
        e.viewport.project(m.getMin(), e.projectionViewMatrix, a),
          e.viewport.project(m.getMax(), e.projectionViewMatrix, u);
        let f = Math.min(a.x, u.x),
          p = Math.min(a.y, u.y),
          y = Math.max(a.x, u.x),
          g = Math.max(a.y, u.y);
        return new Laya.Rectangle(
          f / Laya.stage.clientScaleX,
          p / Laya.stage.clientScaleY,
          y - f,
          g - p
        );
      }
      static convert2dTo3dN(t, e, n) {
        (n = n || this.getDefaultCamera()), (t = t.clone());
        let u = new Laya.Point(t.x, t.y);
        Laya.stage.transform.transformPoint(u),
          t.setValue(u.x, u.y, 0),
          (e = e.clone()),
          u.setTo(e.x, e.y),
          Laya.stage.transform.transformPoint(u),
          e.setValue(u.x, u.y, 0);
        let m = this.tempMatrix;
        return (
          n.projectionViewMatrix.invert(m),
          n.viewport.unprojectFromMat(t, m, t),
          n.viewport.unprojectFromMat(e, m, e),
          a.subtract(e, t, t),
          a.normalize(t, t),
          t
        );
      }
      static convert2dTo3dP(t, e, a = 0) {
        if (
          ((e = e || this.getDefaultCamera()), (t = t.clone()), e.orthographic)
        )
          e.convertScreenCoordToOrthographicCoord(t, t);
        else {
          t.z = a;
          let n = this.tempMatrix;
          e.projectionViewMatrix.invert(n),
            e.viewport.unprojectFromMat(t, n, t);
        }
        return t;
      }
      static convert2dTo3dRay(t, e) {
        e = e || this.getDefaultCamera();
        let n = new Laya.Vector2(t.x, t.y),
          u = new Laya.Ray(new a(), new a());
        return e.viewportPointToRay(n, u), u;
      }
      static rayCastInfo(t, e, n = -1, u = 2147483647) {
        e = e || this.getDefaultCamera();
        let m = new Laya.Vector2(t.x, t.y),
          f = new Laya.Ray(new a(), new a());
        e.viewportPointToRay(m, f);
        let p = e.scene,
          y = new Laya.HitResult();
        if ((p.physicsSimulation.rayCast(f, y, u, void 0, n), y.succeeded))
          return {
            target: y.collider.owner,
            cp: y.point,
            shapeName: y.collider.shapeName,
            normal: y.normal,
            distance: y.hitFraction,
          };
      }
      static rayCastInfoAll(t, e, n = -1, u = 2147483647) {
        e = e || this.getDefaultCamera();
        let m = new Laya.Vector2(t.x, t.y),
          f = new Laya.Ray(new a(), new a());
        e.viewportPointToRay(m, f);
        let p = [];
        e.scene.physicsSimulation.rayCastAll(f, p, u, void 0, n);
        let y = [];
        for (const t of p) {
          let e = {
            target: t.collider.owner,
            cp: new a(t.point.x, t.point.y, t.point.z),
            distance: t.hitFraction,
            shapeName: t.collider.shapeName,
            normal: new a(t.normal.x, t.normal.y, t.point.z),
          };
          y.push(e);
        }
        return y;
      }
      static rayCastSprite3d(t, e, n, u = -1, m = 2147483647) {
        n = n || this.getDefaultCamera();
        let f = new Laya.Vector2(t, e),
          p = new Laya.Ray(new a(), new a());
        n.viewportPointToRay(f, p);
        let y = n.scene,
          g = new Laya.HitResult();
        if ((y.physicsSimulation.rayCast(p, g, m, void 0, u), g.succeeded))
          return g.collider.owner;
      }
      static rayCastByDir(t, e, n, u = 2147483647, m = -1) {
        let f,
          p,
          y = new Laya.HitResult(),
          g = new Laya.Vector3();
        a.normalize(t, g), a.scale(g, u, g), a.add(e, g, g);
        let _ = new Laya.Ray(e, t);
        if ((n.physicsSimulation.rayCast(_, y, u, void 0, m), y.succeeded))
          return (
            (f = y.collider.owner),
            (p = y.collider.shapeName),
            (g = y.point),
            {
              target: f,
              cp: g,
              shapeName: p,
              normal: y.normal,
              distance: y.hitFraction,
            }
          );
      }
      static rayCastByDirAll(t, e, n, u = 2147483647, m = -1) {
        let f = new Laya.Vector3();
        a.normalize(t, f), a.scale(f, u, f), a.add(e, f, f);
        let p = new Laya.Ray(e, t),
          y = [];
        n.physicsSimulation.rayCastAll(p, y, u, void 0, m);
        let g = [];
        for (const t of y) {
          let e = {
            target: t.collider.owner,
            cp: new a(t.point.x, t.point.y, t.point.z),
            distance: t.hitFraction,
            shapeName: t.collider.shapeName,
            normal: new a(t.normal.x, t.normal.y, t.point.z),
          };
          g.push(e);
        }
        return g;
      }
      static getOrthographicCamreaClickDir(t, e, n, u) {
        if (t && !t.destroyed && t.orthographic) {
          let m = new Laya.Vector3(e.x, e.y, n),
            f = new Laya.Vector3(),
            p = new Laya.Vector3();
          return (
            t.convertScreenCoordToOrthographicCoord(m, f),
            (m.z = u),
            t.convertScreenCoordToOrthographicCoord(m, p),
            a.subtract(p, f, m),
            m.normalize(),
            m
          );
        }
        return null;
      }
      static add3dModelTo(t, e, a, n, u) {
        (a = a || t.transform.position.clone()),
          (u = u || t.transform.getWorldLossyScale().clone()),
          (n = n || t.transform.rotation.clone()),
          e.addChild(t),
          (t.transform.rotation = n),
          (t.transform.position = a),
          t.transform.setWorldLossyScale(u);
      }
      static resetAnchor(t, e, a) {
        if (e < 0 || e > 1 || a < 0 || a > 1 || 0 == t.scaleX || 0 == t.scaleY)
          return;
        let n,
          u,
          m = t.anchorX,
          f = t.anchorY;
        if (e == m && a == f)
          return (n = m * t.width), (u = f * t.height), void t.pivot(n, u);
        !m &&
          t.pivotX &&
          !f &&
          t.pivotY &&
          ((m = t.pivotX / t.width), (f = t.pivotY / t.height)),
          (m = m || 0),
          (f = f || 0),
          (n = (e - m) * t.width),
          (u = (a - f) * t.height),
          (t.anchorX = e),
          (t.anchorY = a),
          t.pivot(n, u),
          (n *= t.scaleX),
          (u *= t.scaleY),
          (t.x += n),
          (t.y += u);
      }
      static resetPivot(t, e, a) {
        let n = t.pivotX,
          u = t.pivotY,
          m = e / t.width,
          f = a / t.height,
          p = n / t.width,
          y = u / t.height,
          g = (m - p) * t.width * t.scaleX,
          _ = (f - y) * t.height * t.scaleY;
        t.pivot(e, a), (t.x += g), (t.y += _);
      }
      static calcBezierPointEx(t, e) {
        t = Math.clamp(t, 0, 1);
        const factorial = function (t) {
          return t <= 1 ? 1 : t * factorial(t - 1);
        };
        let n = new a(),
          u = e.length - 1;
        return (
          e.forEach((e, a) => {
            a
              ? ((n.x +=
                  (factorial(u) / factorial(a) / factorial(u - a)) *
                  e.x *
                  Math.pow(1 - t, u - a) *
                  Math.pow(t, a)),
                (n.y +=
                  (factorial(u) / factorial(a) / factorial(u - a)) *
                  e.y *
                  Math.pow(1 - t, u - a) *
                  Math.pow(t, a)),
                (n.z +=
                  (factorial(u) / factorial(a) / factorial(u - a)) *
                  e.z *
                  Math.pow(1 - t, u - a) *
                  Math.pow(t, a)))
              : ((n.x += e.x * Math.pow(1 - t, u - a) * Math.pow(t, a)),
                (n.y += e.y * Math.pow(1 - t, u - a) * Math.pow(t, a)),
                (n.z += e.z * Math.pow(1 - t, u - a) * Math.pow(t, a)));
          }),
          n
        );
      }
      static getBezierInfo(t, e, n) {
        let u = n || e + 0.1,
          m = { v: null, n: null, nL: null, nR: null, up: null },
          f = this.calcBezierPointEx(e, t),
          p = this.calcBezierPointEx(u, t),
          y = new a();
        a.subtract(p, f, y), null != n && ((m.v = y.clone()), (m.end = p));
        let g = new a();
        a.normalize(y, g);
        let _ = new a();
        a.cross(a.Up, g, _),
          a.normalize(_, _),
          a.cross(g, _, y),
          a.normalize(y, y);
        let x = y.clone();
        a.cross(x, g, _), a.normalize(_, _);
        let b = new a();
        return (
          a.cross(g, x, b),
          a.normalize(b, b),
          (m.n = g),
          (m.nL = _),
          (m.nR = b),
          (m.up = x),
          (m.start = f),
          m
        );
      }
      static calcBezierPointEx_2D(t, e) {
        t = Math.clamp(t, 0, 1);
        const factorial = function (t) {
          return t <= 1 ? 1 : t * factorial(t - 1);
        };
        let a = new Laya.Point(),
          n = e.length - 1;
        return (
          e.forEach((e, u) => {
            u
              ? ((a.x +=
                  (factorial(n) / factorial(u) / factorial(n - u)) *
                  e.x *
                  Math.pow(1 - t, n - u) *
                  Math.pow(t, u)),
                (a.y +=
                  (factorial(n) / factorial(u) / factorial(n - u)) *
                  e.y *
                  Math.pow(1 - t, n - u) *
                  Math.pow(t, u)))
              : ((a.x += e.x * Math.pow(1 - t, n - u) * Math.pow(t, u)),
                (a.y += e.y * Math.pow(1 - t, n - u) * Math.pow(t, u)));
          }),
          a
        );
      }
      static generatePicture(t, e, a, n, u) {
        (e = e || 0), (a = a || 0), (n = n || t.width), (u = u || t.height);
        let m = t.drawToCanvas(n, u, e, a).toBase64("image/png", 0.9);
        m = m.substring(m.indexOf("base64") + 7);
        let f = Laya.MiniFileMgr.fileNativeDir + "/tmp_qrcode.png";
        Laya.MiniFileMgr.fs.writeFile({
          filePath: f,
          data: m,
          encoding: "base64",
          success: (t) => {
            wx.saveImageToPhotosAlbum({
              filePath: f,
              success: (t) => {
                w.showTips("成功");
              },
              fail: (t) => {
                w.showTips("失败");
              },
            });
          },
          fail: (t) => {
            w.showTips("保存失败");
          },
        });
      }
      static renderToTexture(t, e, a, n = 0, u = 0, m) {
        let f;
        if (
          ((e = e || t.width), (a = a || t.height), Laya.stage.addChild(t), m)
        ) {
          f = m;
          let p = t.drawToTexture(e, a, n, u, m.bitmap);
          f.bitmap = p;
        } else
          (f = t.drawToTexture(e, a, n, u)),
            Laya.CallLater.I.callLater(this, () => {
              (f.bitmap.lock = !1), f.destroy();
            });
        return Laya.stage.removeChild(t), f;
      }
      static recurisNode(t, e, a = !1) {
        if (a) {
          const anonymous = function (t) {
            let a = t.getChildren();
            for (const t of a) {
              let e = anonymous(t);
              if (!1 === e) return e;
              if (-1 === e) break;
            }
            return e(t);
          };
          anonymous(t);
        } else {
          let a = [];
          for (a.push(t); a.length > 0; ) {
            let t = a.shift(),
              n = e(t);
            if (!1 === n) return n;
            if (-1 === n) continue;
            let u = t.getChildren();
            for (const t of u) a.push(t);
          }
        }
      }
      static render3dTo2dSprite(t, e, n, u = 0, m, f = 1) {
        if (!m) {
          let e = t.scene,
            n = this.getDefaultCamera();
          ((m = n.clone()).nearPlane = 0.1),
            (m.clearFlag = Laya.CameraClearFlags.DepthOnly),
            e.addChild(m);
          let u = t.transform.position,
            p = new a();
          a.subtract(n.transform.position, u, p),
            p.normalize(f),
            a.add(u, p, p),
            (m.transform.position = p),
            m.transform.lookAt(u, a.Up, !1),
            m.removeAllLayers(),
            m.addLayer(1),
            this.recurisNode(t, (t) => (t.layer = 1));
        }
        m.clearFlag == Laya.CameraClearFlags.DepthOnly
          ? (m.renderTarget = new Laya.RenderTexture(
              e,
              n,
              Laya.RenderTextureFormat.R8G8B8A8
            ))
          : (m.renderTarget = new Laya.RenderTexture(e, n)),
          (m.renderingOrder = -1),
          (m.enableHDR = !1);
        let p = new Laya.Texture(m.renderTarget),
          y = new Laya.Sprite();
        return (
          (y.texture = p),
          u > 0 &&
            ((y.cacheAs = "bitmap"),
            t.timerOnce(u, t, () => {
              (m.active = !1), (t.active = !1);
            })),
          y
        );
      }
      static mixturePicture(t, e) {
        if (!window.wx) return;
        let a = t.width,
          n = t.height,
          u = t.drawToCanvas(a, n, 0, 0).toBase64("image/png", 0.9);
        u = u.substring(u.indexOf("base64") + 7);
        let m = Laya.MiniFileMgr.fileNativeDir + "/tmp_qrcode.png";
        Laya.MiniFileMgr.fs.writeFile({
          filePath: m,
          data: u,
          encoding: "base64",
          success: (t) => {
            console.log(m), e(m);
          },
          fail: (t) => {},
        });
      }
      static deltaDays(t, e) {
        return Math.floor((e - t + 1e6) / 864e5);
      }
      static equal(t, e, a = 1e-6) {
        return Math.abs(t - e) < a;
      }
      static str2Boolean(t) {
        if ("string" != typeof t) return !1;
        let e = t.toLowerCase();
        return "false" !== e && "" !== e;
      }
      static str2Number(t) {
        let e = 0;
        for (let a = 0; a < t.length; a++) {
          let n = t.charCodeAt(a);
          (n <<= a), (e += n);
        }
        return e;
      }
      static getFrameDelta(t) {
        let e = 0.001 * Laya.timer.delta;
        return t && (e = Math.min(e, t)), e;
      }
      static createPrefabs(t, e = 1) {
        let a = [];
        if (!Laya.loader.getRes(t)) throw `需要先加载${t}才可以创建`;
        for (let n = 0; n < e; ++n) a.push(this.createPrefab(t));
        return a;
      }
      static createPrefab(t, e) {
        if (!e) {
          let e = new Laya.Prefab();
          return (e.json = Laya.loader.getRes(t)), e.create();
        }
        Laya.loader.load(
          t,
          Laya.Handler.create(this, () => {
            if (e.caller.destroyed) return;
            let a = new Laya.Prefab();
            a.json = Laya.loader.getRes(t);
            let n = a.create();
            e.runWith(n);
          })
        );
      }
      static getEnumArray(t) {
        let e = 0,
          a = [];
        for (; t[e]; ) a.push(t[e]), e++;
        return a;
      }
      static getEnumKeyMap(t) {
        let e = this.getEnumArray(t),
          a = {};
        for (const n of e) null != t[n] && (a[n] = n);
        return a;
      }
      static getCurDayaStartTime() {
        return new Date(new Date().toLocaleDateString()).getTime();
      }
      static getCurEndStartTime() {
        return new Date(new Date().toLocaleDateString()).getTime() + 864e5 - 1;
      }
      static MeterToKilometer(t) {
        if (t < 1e4) return t + "m";
        return (t / 1e3).toFixed(1) + "km";
      }
      static getYearWeek() {
        let t = new Date(),
          e = t.getDay();
        0 == e && (e = 7);
        let a = new Date(t.getFullYear(), 0, 1),
          n = a.getDay();
        0 == n && (n = 7);
        let u = Math.round(
          (t.getTime() - a.getTime() + 864e5 * (n - e)) / 864e5
        );
        return { year: t.getFullYear(), week: Math.ceil(u / 7) + 1 };
      }
      static getCirclePoint(t, e, a) {
        let n = Math.rad(a),
          u = t.x + Math.sin(n) * e,
          m = t.y - Math.cos(n) * e;
        return new Laya.Vector2(u, m);
      }
      static compareVersion(t, e) {
        let a = t;
        if (!a || !a.split) return 0;
        let n = e;
        if (!n || !n.split) return 0;
        let u = a.split("."),
          m = n.split(".");
        const f = Math.max(u.length, m.length);
        for (; u.length < f; ) u.push("0");
        for (; m.length < f; ) m.push("0");
        for (let t = 0; t < f; t++) {
          const e = parseInt(u[t]),
            a = parseInt(m[t]);
          if (e > a) return 1;
          if (e < a) return -1;
        }
        return 0;
      }
      static compatibleVersion(t, e) {
        return w.compareVersion(t, e) >= 0;
      }
      static warpObjectGetterSetter(t, e) {
        let a = t;
        if (!a.__getter_setter_warpped) {
          for (const n in t)
            if (t.hasOwnProperty(n)) {
              let u = a[n];
              delete a[n],
                u instanceof Object
                  ? Object.defineProperty(t, n, {
                      get: function () {
                        return a["_" + n];
                      },
                      set: function (t) {
                        (a["_" + n] = t), e && e.call(a, n);
                      },
                      enumerable: !1,
                      configurable: !1,
                    })
                  : Object.defineProperty(t, n, {
                      get: function () {
                        return a["_" + n];
                      },
                      set: function (t) {
                        t !== a["_" + n] &&
                          ((a["_" + n] = t), e && e.call(a, n));
                      },
                      enumerable: !1,
                      configurable: !1,
                    }),
                (a["_" + n] = u);
            }
          Object.defineProperty(t, "__getter_setter_warpped", {
            value: e,
            enumerable: !1,
            configurable: !1,
          });
        }
      }
      static warpObjectGetterSetterAppend(t, e, a) {
        a = a || t.__getter_setter_warpped;
        for (const n of e) {
          let e = self[n];
          delete self[n],
            e instanceof Object
              ? Object.defineProperty(t, n, {
                  get: function () {
                    return self["_" + n];
                  },
                  set: function (t) {
                    (self["_" + n] = t), a && a.call(self, n);
                  },
                  enumerable: !1,
                  configurable: !1,
                })
              : Object.defineProperty(t, n, {
                  get: function () {
                    return self["_" + n];
                  },
                  set: function (t) {
                    t !== self["_" + n] &&
                      ((self["_" + n] = t), a && a.call(self, n));
                  },
                  enumerable: !1,
                  configurable: !1,
                }),
            (self["_" + n] = e);
        }
      }
      static getUIComponetRoot(t) {
        if (!t.scene) return;
        let e = t.scene.getModuleUrlName();
        if (e) return e;
        let a = t.scene;
        for (
          ;
          a.parent &&
          ((a = a.parent),
          !a.getModuleUrlName || ((e = a.getModuleUrlName()), !e));

        );
        return e;
      }
      static getAnimatorCurPlayStateName(t) {
        if (t && t.getControllerLayer()) {
          let e = t.getControllerLayer().getCurrentPlayState().animatorState;
          if (e) return e.name;
        }
      }
      static playAnimator3d(t, e = null, a, n, u, m = 0, f = !1) {
        if (t) {
          let p = t.getControllerLayer(m);
          if (!p) return;
          let y = p.getAnimatorState(e);
          y &&
            (void 0 !== n && (y.clip.islooping = n),
            void 0 !== a && (y.speed = a)),
            t.play(e, m, u, f);
        }
      }
      static playAnimator3dCross(t, e, a = null, n, u, m, f = 0) {
        if (t) {
          let p = t.getControllerLayer(f).getAnimatorState(a);
          p &&
            (void 0 !== u && (p.clip.islooping = u),
            void 0 !== n && (p.speed = n)),
            t.crossFade(a, e, f, m);
        }
      }
      static haveAnim(t, e, a = 0) {
        let n = t.getControllerLayer(a);
        return !!n && !!n.getAnimatorState(e);
      }
      static asyncProcess(t, e, a = 30) {
        const clearFunc = () => {
            Laya.timer.clear(this, loopFunc),
              t.off(Laya.Event.REMOVED, this, clearFunc);
          },
          loopFunc = () => {
            Laya.stage.getTimeFromFrameStart() > a || (e.run() && clearFunc());
          };
        Laya.timer.frameLoop(1, this, loopFunc),
          t.once(Laya.Event.REMOVED, this, clearFunc);
      }
      static vOnLeftRight(t, e) {
        let n = new a();
        return (
          n.from(e),
          0 == t.x && 0 == e.x
            ? a.cross(a.UnitX, n, n)
            : ((n.y = 0), a.cross(a.Up, n, n)),
          this.vOnForwardBehind(t, n)
        );
      }
      static vOnForwardBehind(t, e) {
        return (
          (t = t.clone()),
          ((e = e.clone()).y = t.y = 0),
          t.normalize(),
          e.normalize(),
          a.dot(t, e) >= 0
        );
      }
      static getDotRadian(t, e) {
        if (t.isZero() || e.isZero()) return 0;
        return Math.acos(Math.clamp(a.dot(t, e), -1, 1));
      }
      static getDotRadianEx(t, e) {
        if (t.isZero() || e.isZero()) return 0;
        let n = Math.acos(Math.clamp(a.dot(t, e), -1, 1));
        return (
          n > 0 && n < Math.PI && (n = this.vOnLeftRight(t, e) ? -1 * n : n), n
        );
      }
      static getEulerRadian(t, e, n = "y") {
        if (t.isZero() || e.isZero()) return 0;
        (t = t.clone()),
          (e = e.clone()),
          (t[n] = e[n] = 0),
          t.normalize(),
          e.normalize();
        let u = Math.acos(Math.clamp(a.dot(t, e), -1, 1));
        return a.cross(t, e, t), (u = t.y > 0 ? u : -u), u;
      }
      static bindVarByName(t, e) {
        let a = e ? e.getChildren() : t.getChildren(),
          n = t;
        for (const e of a) {
          let a = e.name;
          if (a) {
            if (n[a]) throw Error("bindVarByName failed, already exist !!!");
            n[a] = e;
          }
          e.numChildren > 0 && this.bindVarByName(t, e);
        }
      }
      static bindScriptVarByName(t, e) {
        let a = Object.getOwnPropertyNames(t);
        if (!a || !a.length) return;
        let n = void 0;
        e || (e = t.owner), (n = e.getChildren());
        for (const e of n) {
          let n = e.name;
          n && -1 !== a.indexOf(n) && (t[n] = e),
            e.numChildren > 0 && this.bindScriptVarByName(t, e);
        }
      }
      static clearUIComponentPositionInfo(t) {
        t &&
          (t.x =
            t.y =
            t.left =
            t.right =
            t.top =
            t.bottom =
            t.centerX =
            t.centerY =
              void 0);
      }
      static getHashCode(t, e) {
        e || (t = t.toLowerCase());
        let a,
          n,
          u = 1315423911;
        for (a = t.length - 1; a >= 0; a--)
          (n = t.charCodeAt(a)), (u ^= (u << 5) + n + (u >> 2));
        return 2147483647 & u;
      }
      static getSpMaterial(t, e) {
        let a,
          n = this.getSpRenderer(t);
        return n && (a = e ? n.sharedMaterial : n.material), a;
      }
      static getSpMaterials(t, e) {
        let a,
          n = this.getSpRenderer(t);
        return n && (a = e ? n.sharedMaterials : n.materials), a;
      }
      static getSpRenderer(t) {
        let e;
        return (
          t instanceof Laya.SkinnedMeshSprite3D
            ? (e = t.skinnedMeshRenderer)
            : t instanceof Laya.SimpleSkinnedMeshSprite3D
            ? (e = t.simpleSkinnedMeshRenderer)
            : t instanceof Laya.MeshSprite3D && (e = t.meshRenderer),
          e
        );
      }
      static createUUID() {
        let t = [];
        for (let e = 0; e < 36; e++)
          t[e] = "0123456789abcdef".substr(Math.floor(16 * Math.random()), 1);
        return (
          (t[14] = "4"),
          (t[19] = "0123456789abcdef".substr((3 & t[19]) | 8, 1)),
          (t[8] = t[13] = t[18] = t[23] = "-"),
          t.join("")
        );
      }
      static createUUIDEx(t, e) {
        var a,
          n,
          u =
            "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".split(
              ""
            ),
          m = [];
        if (((e = e || u.length), t))
          for (a = 0; a < t; a++) m[a] = u[0 | (Math.random() * e)];
        else
          for (
            m[8] = m[13] = m[18] = m[23] = "-", m[14] = "4", a = 0;
            a < 36;
            a++
          )
            m[a] ||
              ((n = 0 | (16 * Math.random())),
              (m[a] = u[19 == a ? (3 & n) | 8 : n]));
        return m.join("");
      }
      static getDeltaRotQ(t, e, a) {
        if (t.equals(e)) return a.from(Laya.Quaternion.DEFAULT);
        let n = new Laya.Quaternion();
        return t.invert(n), Laya.Quaternion.multiply(e, n, a), a;
      }
      static randomPointInBounds(t, e = 1, a) {
        let n,
          u,
          m = 2 * e,
          f = !1;
        t.forEach((t) => {
          if (((n = t), !n.__grid)) {
            let e = t.getMin(),
              a = t.getMax(),
              u = Math.ceil((a.x - e.x) / m),
              p = Math.ceil((a.z - e.z) / m);
            n.__grid = [];
            for (let t = 0; t < u; t++) n.__grid[t] = new Array(p).fill(0);
            f = !0;
          }
        }),
          f && a && a.length > 0 && this.occupyPointsInBounds(t, a),
          fx.Utils.randomArray(t);
        let p = t.length;
        for (; p-- && ((u = t[p]), (n = u), "full" == n.__grid); );
        -1 == p &&
          console.warn(
            "randomPointInBounds: 已占满！请缩小radius或者减少数量！"
          );
        let y,
          g,
          _ = u.getMin(),
          x = u.getMax(),
          b = fx.Utils.getNumberRandomEx(_.y, x.y),
          v = n.__grid,
          w = v.length,
          S = v[0].length,
          C = w * S;
        for (; C--; ) {
          (y = fx.Utils.getNumberRandomEx(_.x, x.x)),
            (g = fx.Utils.getNumberRandomEx(_.z, x.z));
          let t = x.x - _.x,
            a = x.z - _.z,
            n = Math.min(Math.floor(((y - _.x) / t) * w), w - 1),
            u = Math.min(Math.floor(((g - _.z) / a) * S), S - 1);
          if (0 == v[n][u]) {
            (v[n][u] = 1),
              (y = ((n + 1) / w) * t + _.x - e),
              (g = ((u + 1) / S) * a + _.z - e);
            break;
          }
        }
        return -1 == C && (n.__grid = "full"), new Laya.Vector3(y, b, g);
      }
      static occupyPointsInBounds(t, e) {
        let a,
          n,
          u = t.length;
        for (; u--; ) {
          (a = t[u]), (n = a);
          let m = n.__grid;
          if (m && "full" != m) {
            let t = a.getMin(),
              n = a.getMax(),
              u = m.length,
              f = m[0].length;
            e.foreachR((a, p) => {
              if (a.x >= t.x && a.x <= n.x && a.z >= t.z && a.z <= n.z) {
                let y = n.x - t.x,
                  g = n.z - t.z,
                  _ = Math.min(Math.floor(((a.x - t.x) / y) * u), u - 1),
                  x = Math.min(Math.floor(((a.z - t.z) / g) * f), f - 1);
                0 == m[_][x] && ((m[_][x] = 1), e.splice(p, 1));
              }
            });
          }
          if (0 == e.length) break;
        }
        -1 == u &&
          console.warn(
            "occupyPointsInBounds 失败！不在范围内? 已占满? 没有创建格子?"
          );
      }
      static randomPointInCircle(t, e = 1, n) {
        let u,
          m = 2 * e,
          f = new a(),
          p = !1;
        t.forEach((t) => {
          if (!t.__grid) {
            let n = 2 * t.radius,
              u = Math.ceil(n / m),
              y = new a();
            (y.x = t.center.x - t.radius),
              (y.y = t.center.y),
              (y.z = t.center.z - t.radius);
            let g = new a();
            (g.x = t.center.x + t.radius),
              (g.y = t.center.y),
              (g.z = t.center.z + t.radius),
              (t.__min = y),
              (t.__max = g);
            let _ = (t.__grid = []);
            for (let m = 0; m < u; m++) {
              _[m] = new Array(u);
              for (let p = 0; p < u; p++) {
                let g = ((m + 1) / u) * n + y.x - e,
                  x = ((p + 1) / u) * n + y.z - e;
                f.setValue(g, y.y, x);
                let b = Math.pow(e + 0.01, 2);
                a.distanceSquared(f, t.center) > b
                  ? (_[m][p] = 1)
                  : (_[m][p] = 0);
              }
            }
            p = !0;
          }
        }),
          p && n && n.length > 0 && this.occupyPointsInCircles(t, n),
          fx.Utils.randomArray(t);
        let y = t.length;
        for (; y-- && ((u = t[y]), "full" == u.__grid); );
        -1 == y &&
          console.warn(
            "randomPointInCircles: 已占满！请缩小radius或者减少数量！"
          );
        let g,
          _,
          x = u.__min,
          b = u.__max,
          v = fx.Utils.getNumberRandomEx(x.y, b.y),
          w = u.__grid,
          S = w.length,
          C = w[0].length,
          E = S * C;
        for (; E--; ) {
          (g = fx.Utils.getNumberRandomEx(x.x, b.x)),
            (_ = fx.Utils.getNumberRandomEx(x.z, b.z));
          let t = b.x - x.x,
            a = Math.min(Math.floor(((g - x.x) / t) * S), S - 1),
            n = Math.min(Math.floor(((_ - x.z) / t) * C), C - 1);
          if (0 == w[a][n]) {
            (w[a][n] = 1),
              (g = ((a + 1) / S) * t + x.x - e),
              (_ = ((n + 1) / C) * t + x.z - e);
            break;
          }
        }
        return -1 == E && (u.__grid = "full"), new Laya.Vector3(g, v, _);
      }
      static occupyPointsInCircles(t, e) {
        let n,
          u = t.length;
        for (; u--; ) {
          n = t[u];
          let m = n.__grid;
          if (m && "full" != m) {
            let t = n.__min,
              u = n.__max,
              f = m.length;
            e.foreachR((p, y) => {
              let g = n.radius * n.radius;
              if (a.distanceSquared(p, n.center) <= g) {
                let a = u.x - t.x,
                  n = Math.min(Math.floor(((p.x - t.x) / a) * f), f - 1),
                  g = Math.min(Math.floor(((p.z - t.z) / a) * f), f - 1);
                0 == m[n][g] && ((m[n][g] = 1), e.splice(y, 1));
              }
            });
          }
          if (0 == e.length) break;
        }
        -1 == u &&
          console.warn(
            "occupyPointsInCircles 失败！不在范围内? 已占满? 没有创建格子?"
          );
      }
      static remap(t, e, a, n, u) {
        return n + ((t - e) / (a - e)) * (u - n);
      }
    }
    (w.NotchScreenCfg = [
      { model: "iPhone X", notchTop: 44, notchBottom: 30 },
      { model: "PAAM00", notchTop: 80, notchBottom: 10 },
      { model: "PAAT00", notchTop: 80, notchBottom: 10 },
      { model: "PACM00", notchTop: 80, notchBottom: 10 },
      { model: "PACT00", notchTop: 80, notchBottom: 10 },
      { model: "CPH1831", notchTop: 80, notchBottom: 10 },
      { model: "CPH1833", notchTop: 80, notchBottom: 10 },
      { model: "PBCM10", notchTop: 80, notchBottom: 10 },
      { model: "V1732A", notchTop: 36, notchBottom: 10 },
    ]),
      (w.profileMap = {}),
      (w.lastClickTime = 0),
      (w.numberUnit = {
        3: "K",
        6: "M",
        9: "B",
        12: "T",
        15: "aa",
        18: "bb",
        21: "cc",
        24: "dd",
        27: "ee",
        30: "ff",
        33: "gg",
        36: "hh",
        39: "ii",
        42: "jj",
        45: "kk",
        48: "ll",
        51: "mm",
        54: "nn",
        57: "oo",
        60: "pp",
        63: "qq",
        66: "rr",
        69: "ss",
        72: "tt",
        75: "uu",
        78: "vv",
        81: "ww",
        84: "xx",
        87: "yy",
        90: "zz",
        93: "Aa",
        96: "Bb",
        99: "Cc",
        102: "Dd",
        105: "Ee",
        108: "Ff",
        111: "Gg",
        114: "Hh",
        117: "Ii",
        120: "Jj",
        123: "Kk",
        126: "Ll",
        129: "Mm",
        132: "Nn",
        135: "Oo",
        138: "Pp",
        141: "Qq",
        144: "Rr",
        147: "Ss",
        150: "Tt",
        153: "Uu",
        156: "Vv",
        159: "Ww",
        162: "Xx",
        165: "Yy",
        168: "Zz",
        171: "AA",
        174: "BB",
        177: "CC",
        180: "DD",
        183: "EE",
        186: "FF",
        189: "GG",
        192: "HH",
        195: "II",
        198: "JJ",
        201: "KK",
        204: "LL",
        207: "MM",
        210: "NN",
        213: "OO",
        216: "PP",
        219: "QQ",
        222: "RR",
        225: "SS",
        228: "TT",
        231: "UU",
        234: "VV",
        237: "WW",
        240: "XX",
        243: "YY",
        246: "ZZ",
      }),
      (w.relativeDate = void 0),
      (w.localLaunchDate = void 0),
      (w.tempMatrix = new Laya.Matrix4x4());
    class S {
      constructor(t, e) {
        (this.parallelCount = 0),
          (this.actions = t || []),
          (this.isRepeat = e),
          (this.pActionIdx = 0);
      }
      get actions() {
        return this._actions;
      }
      set actions(t) {
        this._actions = t;
      }
      get isRepeat() {
        return this._isRepeat;
      }
      set isRepeat(t) {
        this._isRepeat = t;
      }
      get pActionIdx() {
        return this._pActionIdx;
      }
      set pActionIdx(t) {
        this._pActionIdx = t;
      }
      run(t) {
        if (!this.actions || 0 === this.actions.length) return;
        if (this.pActionIdx >= this.actions.length) {
          if (!this.isRepeat) return void (this._curTween = null);
          this.pActionIdx = 0;
        }
        let e = this.actions[this.pActionIdx];
        if (t) {
          if (t.destroyed) return void (this._curTween = null);
          e.target = t;
        }
        let a = !0;
        if (e.parallels && e.parallels.length > 0) {
          (this._recoverProps = {}),
            (a = !1),
            (this.curParallels = e.parallels.concat(e));
          for (const t of e.parallels) (t.target = e.target), this._run(t, !1);
        }
        this._run(e, a);
      }
      _run(t, e = !0) {
        if (t && t.t && t.target && t.props && w.isNumber(t.duration)) {
          if (
            (!t.props.isRecover && e && (this._recoverProps = {}),
            t.recoverKeys)
          )
            for (const e of t.recoverKeys) this.addRecover(e, t.target[e]);
          let a = this;
          if ("delay" == t.t)
            Laya.timer.once(
              t.duration,
              this,
              function (...t) {
                let [e] = t,
                  n = a.curParallels;
                n && n.length > 0
                  ? (n.splice(n.indexOf(e), 1), 0 == n.length && a.runNext(e))
                  : a.runNext(e);
              },
              [t]
            );
          else if ("to" === t.t) {
            let e = t.props;
            "function" == typeof e && (e = e(t.target)),
              (this._curTween = Laya.Tween.to(
                t.target,
                e,
                t.duration,
                t.ease,
                Laya.Handler.create(
                  this,
                  function (...t) {
                    let [e] = t,
                      n = a.curParallels;
                    n && n.length > 0
                      ? (n.splice(n.indexOf(e), 1),
                        0 == n.length && a.runNext(e))
                      : a.runNext(e);
                  },
                  [t]
                ),
                t.delay
              ));
          } else if ("from" === t.t) {
            let e = t.props;
            "function" == typeof e && (e = e(t.target)),
              (this._curTween = Laya.Tween.from(
                t.target,
                e,
                t.duration,
                t.ease,
                Laya.Handler.create(
                  this,
                  function (...t) {
                    let [e] = t,
                      n = a.curParallels;
                    n && n.length > 0
                      ? (n.splice(n.indexOf(e), 1),
                        0 == n.length && a.runNext(e))
                      : a.runNext(e);
                  },
                  [t]
                ),
                t.delay
              ));
          } else if (t.props.exec) {
            t.props.exec.runWith(t.target);
            let e = a.curParallels;
            e && e.length > 0
              ? (e.splice(e.indexOf(t), 1), 0 == e.length && a.runNext(t))
              : this.runNext(t);
          }
        } else {
          let e = this.curParallels;
          e &&
            e.length > 0 &&
            (e.splice(e.indexOf(t), 1), 0 == e.length && this.runNext(t));
        }
      }
      runNext(t) {
        t &&
          t.complete &&
          t.complete.call(t.complete, t.completeCaller, t.completeArgs),
          (this.pActionIdx = this.pActionIdx + 1);
        let e = t && t.target;
        this.run(e);
      }
      getCurTween() {
        return this._curTween;
      }
      addRecover(t, e) {
        this._recoverProps[t] || (this._recoverProps[t] = e);
      }
      pushAction(t) {
        if (this.parallelCount > 0) {
          this.parallelCount--;
          let e = this.actions[this.actions.length - 1];
          e && e.parallels
            ? e.parallels.push(t)
            : ((t.parallels = []), this.actions.push(t));
        } else this.actions.push(t);
      }
      parallel(t) {
        return (this.parallelCount = t), this;
      }
      delay(t) {
        let e = { t: "delay", target: null, props: {}, duration: t };
        return this.pushAction(e), this;
      }
      hide() {
        let t = {
          t: "exec",
          target: null,
          props: { exec: null },
          duration: 0,
          recoverKeys: ["visible"],
        };
        return (
          (t.props.exec = Laya.Handler.create(this, function (t) {
            t.visible = !1;
          })),
          this.pushAction(t),
          this
        );
      }
      show() {
        let t = {
          t: "exec",
          target: null,
          props: { exec: null },
          duration: 0,
          recoverKeys: ["visible"],
        };
        return (
          (t.props.exec = Laya.Handler.create(this, function (t) {
            t.visible = !0;
          })),
          this.pushAction(t),
          this
        );
      }
      recover() {
        let t = {
          t: "exec",
          target: null,
          props: { exec: null, isRecover: !0 },
          duration: 0,
        };
        return (
          (t.props.exec = Laya.Handler.create(this, function (t) {
            for (var e in this._recoverProps)
              this._recoverProps.hasOwnProperty(e) &&
                (t[e] = this._recoverProps[e]);
            this._recoverProps = {};
          })),
          this.pushAction(t),
          this
        );
      }
      removeNode(t) {
        let e = { t: "exec", target: null, props: { exec: null }, duration: 0 };
        return (
          (e.props.exec = Laya.Handler.create(this, function (e) {
            t ? e.destroy() : e.removeSelf();
          })),
          this.pushAction(e),
          this
        );
      }
      scaleIn(t, e, a) {
        let n = {
          t: "from",
          target: null,
          props: { scaleX: t, scaleY: t },
          duration: e,
          recoverKeys: ["scaleX", "scaleY"],
          ease: a,
        };
        return this.pushAction(n), this;
      }
      scaleOut(t, e, a) {
        let n = {
          t: "to",
          target: null,
          props: { scaleX: t, scaleY: t },
          duration: e,
          recoverKeys: ["scaleX", "scaleY"],
          ease: a,
        };
        return this.pushAction(n), this;
      }
      scaleOut2(t, e, a, n) {
        let u = {
          t: "to",
          target: null,
          props: { scaleX: t, scaleY: e },
          duration: a,
          recoverKeys: ["scaleX", "scaleY"],
          ease: n,
        };
        return this.pushAction(u), this;
      }
      up(t, e, a) {
        let n = {
          t: "to",
          target: null,
          props: function (e) {
            return { y: e.y - t };
          },
          duration: e,
          recoverKeys: ["y"],
          ease: a,
        };
        return this.pushAction(n), this;
      }
      down(t, e, a) {
        let n = {
          t: "to",
          target: null,
          props: function (e) {
            return { y: e.y + t };
          },
          duration: e,
          recoverKeys: ["y"],
          ease: a,
        };
        return this.pushAction(n), this;
      }
      fadeIn(t, e) {
        let a = {
          t: "to",
          target: null,
          props: function (t) {
            return (t.alpha = 0), { alpha: 1 };
          },
          duration: t,
          recoverKeys: ["alpha"],
          ease: e,
        };
        return this.pushAction(a), this;
      }
      fadeOut(t, e) {
        let a = {
          t: "to",
          target: null,
          props: { alpha: 0 },
          duration: t,
          recoverKeys: ["alpha"],
          ease: e,
        };
        return this.pushAction(a), this;
      }
      fadeTo(t, e, a) {
        let n = {
          t: "to",
          target: null,
          props: { alpha: t },
          duration: e,
          recoverKeys: ["alpha"],
          ease: a,
        };
        return this.pushAction(n), this;
      }
      pos(t, e, a, n) {
        let u = {
          t: "to",
          target: null,
          props: function (a) {
            return (
              (a.centerX = a.centerY = void 0),
              (a.left = a.right = a.top = a.bottom = void 0),
              { x: t, y: e }
            );
          },
          duration: a,
          recoverKeys: [
            "x",
            "y",
            "centerX",
            "centerY",
            "left",
            "right",
            "top",
            "bottom",
          ],
          ease: n,
        };
        return (
          0 == a &&
            ((u.t = "exec"),
            (u.recoverKeys = null),
            (u.ease = null),
            (u.props = {}),
            (u.props.exec = Laya.Handler.create(this, (a) => {
              (a.centerX = a.centerY = void 0),
                (a.left = a.right = a.top = a.bottom = void 0),
                a.pos(t, e);
            }))),
          this.pushAction(u),
          this
        );
      }
      follow(t, a, n = 4, u) {
        let m = {
          t: "to",
          target: null,
          props: function (m) {
            (m.centerX = m.centerY = void 0),
              (m.left = m.right = m.top = m.bottom = void 0);
            let f = new e(),
              p = u ? u.x : 0,
              y = u ? u.y : 0;
            return {
              update: new Laya.Handler(this, (e) => {
                (f.x = t.x + p - m.x), (f.y = t.y + y - m.y);
                let u = f.len();
                u <= n
                  ? (e._duration = 0)
                  : (f.normalize(Math.min(u, a)), (m.x += f.x), (m.y += f.y));
              }),
            };
          },
          duration: 1e19,
          recoverKeys: [
            "x",
            "y",
            "centerX",
            "centerY",
            "left",
            "right",
            "top",
            "bottom",
          ],
        };
        return this.pushAction(m), this;
      }
      move(t, e, a, n) {
        let u = {
          t: "to",
          target: null,
          props: function (a) {
            return (
              (a.centerX = a.centerY = void 0),
              (a.left = a.right = a.top = a.bottom = void 0),
              { x: a.x + t, y: a.y + e }
            );
          },
          duration: a,
          recoverKeys: [
            "x",
            "y",
            "centerX",
            "centerY",
            "left",
            "right",
            "top",
            "bottom",
          ],
          ease: n,
        };
        return this.pushAction(u), this;
      }
      rotate(t, e, a) {
        let n = {
          t: "to",
          target: null,
          props: { rotation: t },
          duration: e,
          recoverKeys: ["rotation"],
          ease: a,
        };
        return this.pushAction(n), this;
      }
      exec(t) {
        let e = { t: "exec", target: null, props: { exec: t }, duration: 0 };
        return this.pushAction(e), this;
      }
      circle(t, e, a, n) {
        let u = {
          t: "to",
          target: null,
          props: function (t) {
            let n = t.globalToLocal(e, !0);
            return w.resetPivot(t, n.x, n.y), { rotation: a };
          },
          duration: t,
          recoverKeys: ["rotation", "pivotX", "pivotY"],
          ease: n,
        };
        return this.pushAction(u), this;
      }
    }
    class C {
      constructor(t = 0, e = 0) {
        (this.width = t), (this.height = e);
      }
    }
    class E {
      static init() {
        (Math.clamp = function (t, e, a) {
          if (e > a) {
            let t = e;
            (e = a), (a = t);
          }
          return t > a ? a : t < e ? e : t;
        }),
          (Math.rad = function (t) {
            return t * (Math.PI / 180);
          }),
          (Math.deg = function (t) {
            return t * (180 / Math.PI);
          }),
          (Math.sign = function (t) {
            return +(t > 0) - +(t < 0) || +t;
          }),
          (Math.lerp = function (t, e, a) {
            return (a = Math.clamp(a, 0, 1)), Laya.MathUtil.lerp(t, e, a);
          }),
          (Array.prototype.clear = function () {
            this.length = 0;
          }),
          (Array.prototype.foreachR = function (t) {
            let e = this;
            for (let a = e.length - 1; a >= 0; a--) {
              if (!1 === t(e[a], a)) break;
            }
          }),
          (Laya.Node.prototype.getChildBySubName = function (t) {
            let e = this._children;
            for (const a of e) if (-1 != a.name.indexOf(t)) return a;
          }),
          (Laya.Node.prototype.seekChildByName = function (t) {
            if (!t) return;
            let e = this._children;
            for (const a of e) if (a.name == t) return a;
            for (const a of e) {
              let e = a.seekChildByName(t);
              if (e) return e;
            }
          }),
          (Laya.Node.prototype.seekChildBySubName = function (t) {
            if (!t) return;
            let e = this._children;
            for (const a of e) if (-1 != a.name.indexOf(t)) return a;
            for (const a of e) {
              let e = a.seekChildBySubName(t);
              if (e) return e;
            }
          }),
          (Laya.Node.prototype.seekChildrenByName = function (t) {
            let e = [];
            const anonymous = function (a) {
              a.name == t && e.push(a);
              let n = a.getChildren();
              for (const t of n) anonymous(t);
            };
            let a = this.getChildren();
            for (const t of a) anonymous(t);
            return e;
          }),
          (Laya.Node.prototype.seekChildrenBySubName = function (t) {
            let e = [];
            const anonymous = function (a) {
              -1 != a.name.indexOf(t) && e.push(a);
              let n = a.getChildren();
              for (const t of n) anonymous(t);
            };
            let a = this.getChildren();
            for (const t of a) anonymous(t);
            return e;
          }),
          (Laya.Node.prototype.getAllComponents = function () {
            return this._components;
          }),
          (Laya.Node.prototype.destroyAllComponents = function () {
            let t = this.getAllComponents();
            for (let e = t.length - 1; e >= 0; e--) {
              t[e].destroy();
            }
          }),
          (Laya.Node.prototype.getChildren = function () {
            return this._children.concat();
          }),
          (Laya.Node.prototype.getChildrenBySubName = function (t) {
            let e = this._children,
              a = [];
            return (
              e.forEach((e) => {
                -1 != e.name.indexOf(t) && a.push(e);
              }),
              a
            );
          }),
          (Laya.Label.prototype.fitWidth = function (t = !0) {
            let e = this,
              a = e.text,
              n = `${e.fontSize}px ${e.font}`,
              u = Laya.Browser.measureText(a, n).width;
            if (isNaN(e.width) || u <= e.width) return;
            let m = t ? "..." : "";
            for (; u > e.width; )
              (a = a.substr(0, a.length - 1)),
                (u = Laya.Browser.measureText(a + m, n).width);
            e.text = a + m;
          }),
          (Laya.Box.prototype.reverse = function (t) {
            let e,
              a,
              n,
              u = this;
            if (0 != u.numChildren) {
              t
                ? ((e = "x"), (n = "anchorX"), (a = "width"))
                : ((e = "y"), (n = "anchorY"), (a = "height"));
              for (let t = 0; t < u.numChildren; t++) {
                let m = this._children[t];
                m instanceof Laya.Component &&
                  (m[n] = 1 - (isNaN(m[n]) ? 0 : m[n])),
                  (m[e] = u[a] - m[e]);
              }
            }
          }),
          (Laya.Box.prototype.verticalLayout = function (t, e = !0, a = 0) {
            if (0 == this.numChildren) return;
            let n = this;
            n.top = n.left = n.right = n.bottom = void 0;
            let u = 0,
              m = 0,
              f = 0,
              p = ["centerX", "left", "right"][a];
            this._children.forEach((e) => {
              let a = e,
                n = e.layoutGap || 0;
              a instanceof Laya.UIComponent &&
                ((a.top = a.bottom = a.centerY = void 0),
                (a[p] = 0),
                (a.anchorY = 0)),
                (a.y = m),
                (f = m + a.displayHeight),
                (m = f + t + n),
                (u = Math.max(u, a.displayWidth));
            }),
              n.size(u, f),
              e || n.reverse(!1);
          }),
          (Laya.Box.prototype.horizontalLayout = function (t, e = !0, a = 0) {
            if (0 == this.numChildren) return;
            let n = this;
            n.top = n.left = n.right = n.bottom = void 0;
            let u = 0,
              m = 0,
              f = 0,
              p = ["centerY", "top", "bottom"][a];
            this._children.forEach((e) => {
              let a = e.layoutGap || 0,
                n = e;
              n instanceof Laya.UIComponent &&
                ((n.left = n.right = n.centerX = void 0),
                (n[p] = 0),
                (n.anchorX = 0)),
                (n.x = m),
                (u = m + n.displayWidth),
                (m = u + t + a),
                (f = Math.max(f, n.displayHeight));
            }),
              n.size(u, f),
              e || n.reverse(!0);
          }),
          (Laya.Box.prototype.tileLayout = function (t, e, a, n, u = !1) {
            if (t < 1 || e < 1 || a.width < 0 || a.height < 0)
              return console.log("Invalid parameter"), !1;
            if (0 == this.numChildren) return console.log("No Children"), !1;
            if (this.numChildren > t * e)
              return console.log("row or col Not enough"), !1;
            (this.top = this.left = this.right = this.bottom = void 0),
              (this.width = e * (n.width + 2 * a.width)),
              (this.height = t * (n.height + 2 * a.height));
            for (let t = 0; t < this._children.length; ++t) {
              let m = this._children[t];
              m instanceof Laya.UIComponent &&
                ((m.left = m.right = m.top = m.bottom = void 0),
                (m.anchorX = m.anchorY = 0.5)),
                u && ((m.width = n.width), (m.height = n.height));
              let f = t % e,
                p = Math.floor(t / e);
              (m.x = f * (m.width + 2 * a.width) + a.width + m.width / 2),
                (m.y = p * (m.height + 2 * a.height) + a.height + m.height / 2);
            }
            return !0;
          }),
          (Laya.Sprite.prototype.onPressed = function (
            t,
            e,
            a,
            n = !0,
            u,
            m = 100
          ) {
            let f = this;
            function onPressed(a) {
              (f.__pressed = !0),
                null != u
                  ? u > 0
                    ? Laya.timer.loop(u, t, e, [a])
                    : Laya.timer.frameLoop(1, t, e, [a])
                  : e.call(t, [a]);
            }
            function onMouseDown(t) {
              Laya.timer.once(m, f, onPressed, [t]);
            }
            function interupt() {
              Laya.timer.clear(f, onPressed),
                Laya.timer.clear(t, e),
                f.__pressed && a && a.call(t);
            }
            function onMouseUp() {
              interupt(),
                Laya.timer.callLater(f, () => {
                  f.__pressed = !1;
                });
            }
            (f.__pressed = !1),
              f.on(Laya.Event.MOUSE_DOWN, f, onMouseDown),
              n && f.onMoved(f, interupt),
              f.on(Laya.Event.MOUSE_UP, f, onMouseUp),
              f.on(Laya.Event.MOUSE_OUT, f, onMouseUp),
              (f.offPressed = function () {
                Laya.timer.clear(f, onPressed),
                  Laya.timer.clear(t, e),
                  f.off(Laya.Event.MOUSE_DOWN, f, onMouseDown),
                  f.off(Laya.Event.MOUSE_UP, f, onMouseUp),
                  (f.__pressed = !1);
              });
          }),
          (Laya.Sprite.prototype.offPressed = function () {}),
          (Laya.Sprite.prototype.isPressed = function () {
            return this.__pressed;
          }),
          (Laya.Sprite.prototype.onMoved = function (t, e, a = 0, ...n) {
            let u,
              m = this,
              f = new Laya.Point(),
              p = !1;
            function onMouseDown(t) {
              p ||
                ((f.x = t.stageX), (f.y = t.stageY), (p = !0), (u = t.touchId));
            }
            function onMouseMove(m) {
              p &&
                u == m.touchId &&
                f.distance(m.stageX, m.stageY) > a &&
                e.call(t, m, f, ...n);
            }
            function onMouseUp() {
              (p = !1), (u = null);
            }
            m.on(Laya.Event.MOUSE_DOWN, m, onMouseDown),
              m.on(Laya.Event.MOUSE_MOVE, m, onMouseMove),
              m.on(Laya.Event.MOUSE_UP, m, onMouseUp),
              (m.offMoved = function () {
                m.off(Laya.Event.MOUSE_DOWN, m, onMouseDown),
                  m.off(Laya.Event.MOUSE_MOVE, m, onMouseMove),
                  m.off(Laya.Event.MOUSE_UP, m, onMouseUp);
              });
          }),
          (Laya.Sprite.prototype.offMoved = function () {}),
          (Laya.Scene.prototype.showSomething = function () {
            this.onPressed(
              this,
              () => {
                let t =
                  "&#33879;&#20316;&#26435;&#24402;&#25104;&#37117;&#21019;&#19990;&#26041;&#33311;&#31185;&#25216;&#26377;&#38480;&#20844;&#21496;&#25152;&#26377;";
                t = t.replace(/&#[0-9]+;/g, (t) =>
                  String.fromCodePoint(
                    parseInt("" + t.replace("&#", "").replace(";", ""))
                  )
                );
                let e = new Laya.Text();
                (e.text = t),
                  (e.font = "Arial"),
                  (e.color = "#ffffff"),
                  (e.fontSize = 30),
                  (e.x = 300),
                  (e.y = 50),
                  this.addChild(e);
              },
              null,
              !0,
              null,
              1e4
            );
          }),
          Laya.Bone &&
            ((Laya.Bone.prototype.mount = function (t, e) {
              let a = this,
                n = this._sprite;
              return (
                e &&
                  ((this._update = a.update),
                  (a.update = a.updateEx),
                  (this._hUpdate = e)),
                n ? (n.addChild(t), !0) : ((this._sprite = t), !1)
              );
            }),
            (Laya.Bone.prototype.updateEx = function (t) {
              this._update(t), this._hUpdate.runWith(this);
            }),
            (Laya.Bone.prototype.unmount = function (t) {
              this._sprite == t && (this._sprite = null), t.removeSelf();
              let e = this;
              this._hUpdate &&
                ((this._sprite && 0 != this._sprite.numChildren) ||
                  ((e.update = this._update),
                  (this._hUpdate = null),
                  (this._update = null)));
            })),
          (Laya.EventDispatcher.prototype.offAllNot = function (t) {
            let e = this._events;
            if (!e) return this;
            if (t && t.length > 0)
              for (let a in e)
                -1 == t.indexOf(a) &&
                  (this._recoverHandlers(e[a]), delete e[a]);
            return this;
          }),
          (Laya.EventDispatcher.prototype.priorityReverse = function (
            t,
            e = 1
          ) {
            let a = this._events;
            if (!a) return;
            let n = a[t];
            if (n && n.length && n.length > 1 && e > 0) {
              e = Math.min(e, Math.floor(0.5 * n.length));
              let t = n.splice(n.length - e, e);
              for (const e of t) n.unshift(e);
            }
          }),
          (Laya.Vector2.prototype.from = function (t) {
            return (this.x = t.x), (this.y = t.y), this;
          }),
          (Laya.Vector2.prototype.isZero = function () {
            return this.lengthSqr() < 1e-6;
          }),
          (Laya.Vector2.prototype.distance = function (t) {
            let e = this.x - t.x,
              a = this.y - t.y;
            return Math.sqrt(e * e + a * a);
          }),
          (Laya.Vector2.prototype.distanceSq = function (t) {
            let e = this.x - t.x,
              a = this.y - t.y;
            return e * e + a * a;
          }),
          (Laya.Vector2.prototype.sub = function (t) {
            return (this.x -= t.x), (this.y -= t.y), this;
          }),
          (Laya.Vector2.prototype.scale = function (t) {
            return (this.x *= t), (this.y *= t), this;
          }),
          window.Laya3D ? this.init3D() : (Laya.Size = C);
      }
      static init3D() {
        const t = new Laya.Rand(Laya.Browser.now());
        (Math.randomEx = function () {
          return t.getFloat();
        }),
          (Laya.Vector2.prototype.dot = function (t) {
            return this.x * t.x + this.y * t.y;
          }),
          (Laya.Vector2.prototype.cross = function (t) {
            return this.x * t.y - this.y * t.x;
          }),
          (Laya.Vector2.prototype.len = function () {
            return Math.sqrt(this.x * this.x + this.y * this.y);
          }),
          (Laya.Vector2.prototype.lengthSqr = function () {
            return this.x * this.x + this.y * this.y;
          }),
          (Laya.Vector2.prototype.magSqr = function () {
            return this.lengthSqr();
          }),
          (Laya.Vector2.prototype.normalize = function (t = 1) {
            let e = this.x,
              a = this.y,
              n = e * e + a * a;
            return (
              n > 0 &&
                ((n = t / Math.sqrt(n)), (this.x = e * n), (this.y = a * n)),
              this
            );
          }),
          (Laya.Vector2.prototype.angle = function (t) {
            var e = this.magSqr(),
              a = t.magSqr();
            if (0 === e || 0 === a)
              return console.warn("Can't get angle between zero vector"), 0;
            var n = this.dot(t) / Math.sqrt(e * a);
            return (n = Math.clamp(n, -1, 1)), Math.acos(n);
          }),
          (Laya.Vector2.prototype.signAngle = function (t) {
            var e = this.angle(t);
            return this.cross(t) < 0 ? -e : e;
          }),
          (Laya.Vector3.ZERO = new Laya.Vector3(0, 0, 0)),
          (Laya.Vector3.ONE = new Laya.Vector3(1, 1, 1)),
          (Laya.Vector3.UnitX = new Laya.Vector3(1, 0, 0)),
          (Laya.Vector3.NegativeUnitX = new Laya.Vector3(-1, 0, 0)),
          (Laya.Vector3.Up = new Laya.Vector3(0, 1, 0)),
          (Laya.Vector3.Down = new Laya.Vector3(0, -1, 0)),
          (Laya.Vector3.UnitZ = new Laya.Vector3(0, 0, 1)),
          (Laya.Vector3.NegativeUnitZ = new Laya.Vector3(0, 0, -1)),
          (Laya.Vector3.prototype.from = function (t) {
            return (this.x = t.x), (this.y = t.y), (this.z = t.z), this;
          }),
          (Laya.Vector3.prototype.normalize = function (t = 1) {
            let e = this.x,
              a = this.y,
              n = this.z,
              u = e * e + a * a + n * n;
            return (
              u > 0 &&
                ((u = t / Math.sqrt(u)),
                (this.x = e * u),
                (this.y = a * u),
                (this.z = n * u)),
              this
            );
          }),
          (Laya.Vector3.prototype.isZero = function () {
            return Laya.Vector3.scalarLengthSquared(this) < 1e-6;
          }),
          (Laya.Quaternion.prototype.from = function (t) {
            return (
              (this.x = t.x),
              (this.y = t.y),
              (this.z = t.z),
              (this.w = t.w),
              this
            );
          });
        let e = Laya.Loader;
        (Laya.LoaderManager.prototype.takeRes = function (t) {
          let a = e.getRes(t);
          return a && e.clearRes(t), a;
        }),
          (Laya.LoaderManager.prototype.clearRes3d = function () {
            if (!e.groupMap["3DRES_GROUP"]) return;
            let t = e.groupMap["3DRES_GROUP"],
              a = 0,
              n = t.length;
            for (a = 0; a < n; a++) {
              let n = e.getRes(t[a]);
              e.clearRes(t[a]), n && !n.destroyed && n.destroy();
            }
            t.length = 0;
          }),
          (Laya.LocalStorage.getStorageInfoSync = function () {
            let t = Laya.LocalStorage._baseClass;
            return t.getStorageInfoSync
              ? t.getStorageInfoSync()
              : { keys: Object.keys(t.items) };
          }),
          (Laya.Material.prototype.disableShaderDef = function (t) {
            this._disablePublicDefineDatas.add(t);
          }),
          (Laya.ShuriKenParticle3D.prototype.play = function () {
            if (null != this._children) {
              if (this._children.length > 0) {
                let t;
                for (t of this._children)
                  t instanceof Laya.ShuriKenParticle3D && t.play();
              }
              (this.__isPlaying = !0), this.particleSystem.play();
            }
          }),
          (Laya.ShuriKenParticle3D.prototype.isPlaying = function () {
            return this.__isPlaying;
          }),
          (Laya.ShuriKenParticle3D.prototype.stop = function () {
            if (this._children.length > 0) {
              let t;
              for (t of this._children)
                t instanceof Laya.ShuriKenParticle3D && t.stop();
            }
            (this.__isPlaying = !1), this.particleSystem.stop();
          }),
          (Laya.ShuriKenParticle3D.prototype.disableFog = function () {
            if (this._children.length > 0) {
              let t;
              for (t of this._children) t.disableFog();
            }
            let t = this.particleRenderer.material;
            t && t.disableShaderDef(Laya.Shader3D.getDefineByName("FOG"));
          }),
          Laya.CompoundColliderShape &&
            ((Laya.CompoundColliderShape.prototype.getChildShapes =
              function () {
                return this._childColliderShapes;
              }),
            (Laya.Rigidbody3D.prototype.enableProcessCollisions = function (
              t = !0
            ) {
              this._enableProcessCollisions = t;
            }));
      }
    }
    class z {
      constructor() {
        this.mData = {};
      }
      static get instance() {
        return this._instance || (this._instance = new z()), this._instance;
      }
      load(t) {
        Laya.loader.load(
          "json/list.txt",
          new Laya.Handler(this, function (...e) {
            if (e.pop()) {
              var a = Laya.loader
                .getRes("json/list.txt")
                .replace(/\r\n/g, "\n")
                .split("\n");
              a.pop();
              var n = [];
              a.forEach((t) => {
                var e = t.substr(t.indexOf("json"));
                -1 == t.indexOf(".txt") && n.push(e.replace("\\", "/"));
              }),
                Laya.loader.load(
                  n,
                  new Laya.Handler(
                    this,
                    function (...e) {
                      e.pop() &&
                        (e.forEach((t) => {
                          let e = w.pathInfo(t).filename;
                          this.mData[e] = Laya.loader.getRes(t);
                        }),
                        t.run());
                    },
                    n
                  )
                );
            } else t.run();
          })
        );
      }
      get(t, e, a) {
        return null == this.mData[t]
          ? null
          : null == e && null == a
          ? this.mData[t]
          : null == this.mData[t][e]
          ? null
          : null == a
          ? this.mData[t][e]
          : this.mData[t][e][a];
      }
      getConstant(t) {
        return this.get("constant", t);
      }
      getStr(t) {
        return this.get("lang_ch", t);
      }
      loadJson(t, e) {
        t &&
          Laya.loader.load(
            t,
            Laya.Handler.create(this, (a) => {
              (this.mData[t] = a), e && e.runWith(a);
            })
          );
      }
    }
    class A extends f {
      constructor() {
        super(), (this.m_listenerMap = {});
      }
      static get instance() {
        return this._instance || (this._instance = new A()), this._instance;
      }
      find(t, e, a) {
        for (let n = 0; n < a.length; n++) {
          let u = a[n];
          if (t == u.type && e == u.cb) return n;
        }
        return -1;
      }
      findAll(t, e) {
        let a = [];
        for (let n = 0; n < e.length; n++) {
          t == e[n].type && a.push(n);
        }
        return a;
      }
      on(t, e, a, n) {
        let u = super.on(t, e, a, n);
        e.$_GID || (e.$_GID = Laya.Utils.getGID());
        let m = this.m_listenerMap[e.$_GID];
        return (
          m
            ? -1 == this.find(t, a, m)
              ? m.push({ type: t, cb: a })
              : console.log(!1, t + " listener already added!!!")
            : ((m = new Array()),
              m.push({ type: t, cb: a }),
              (this.m_listenerMap[e.$_GID] = m)),
          u
        );
      }
      once(t, e, a, n) {
        let u = super.once(t, e, a, n);
        e.$_GID || (e.$_GID = Laya.Utils.getGID());
        let m = this.m_listenerMap[e.$_GID];
        return (
          m
            ? -1 == this.find(t, a, m)
              ? m.push({ type: t, cb: a })
              : console.log(!1, t + " listener already added!!!")
            : ((m = new Array()),
              m.push({ type: t, cb: a }),
              (this.m_listenerMap[e.$_GID] = m)),
          u
        );
      }
      off(t, e, a, n) {
        if (e.$_GID) {
          let n = this.m_listenerMap[e.$_GID];
          if (n) {
            let e = this.find(t, a, n);
            -1 != e && n.splice(e, 1);
          }
        }
        return super.off(t, e, a, n);
      }
      offAllCaller(t) {
        let e = t.$_GID;
        if (e) {
          let a = this.m_listenerMap[e];
          if (a) {
            for (let e of a) super.off(e.type, t, e.cb);
            delete this.m_listenerMap[e];
          }
        }
        return super.offAllCaller(t);
      }
      offAll(t) {
        if (t)
          for (let e in this.m_listenerMap) {
            let a = this.m_listenerMap[e],
              n = this.findAll(t, a);
            for (let t of n) a.splice(t, 1);
          }
        else this.m_listenerMap = {};
        return super.offAll(t);
      }
      event(t, e) {
        return super.event(t, e);
      }
    }
    class k extends Laya.EventDispatcher {
      constructor() {
        super();
      }
      static superFunc(t, e) {
        if (t instanceof k) return Laya.EventDispatcher.prototype[e].bind(t);
        return w.super(t).prototype[e].bind(t);
      }
      hasListener(t) {
        return "$" == t.charAt(0)
          ? A.instance.hasListener(t)
          : k.superFunc(this, "hasListener")(t);
      }
      event(t, e) {
        return "$" == t.charAt(0)
          ? A.instance.event(t, e)
          : k.superFunc(this, "event")(t, e);
      }
      on(t, e, a, n) {
        return "$" == t.charAt(0)
          ? A.instance.on(t, e, a, n)
          : k.superFunc(this, "on")(t, e, a, n);
      }
      once(t, e, a, n) {
        return "$" == t.charAt(0)
          ? A.instance.once(t, e, a, n)
          : k.superFunc(this, "once")(t, e, a, n);
      }
      off(t, e, a, n) {
        return "$" == t.charAt(0)
          ? A.instance.off(t, e, a, n)
          : k.superFunc(this, "off")(t, e, a, n);
      }
      offAllCaller(t) {
        return A.instance.offAllCaller(t), k.superFunc(this, "offAllCaller")(t);
      }
      offAll(t) {
        return t
          ? "$" == t.charAt(0)
            ? A.instance.offAll(t)
            : k.superFunc(this, "offAll")(t)
          : this.offAllCaller(this);
      }
    }
    class B extends Laya.Scene {
      constructor() {
        super(),
          this.once(Laya.Event.ADDED, this, this.addToStage),
          this.once(Laya.Event.REMOVED, this, this.removeFromStage),
          (this.views = []);
      }
      get curView() {
        return this._curView;
      }
      set curView(t) {
        this._curView = t;
      }
      removeView(t) {
        if (t)
          if (this._curView == t) {
            if (this.views.length > 1)
              throw Error("please use SceneManager.popView instead !!!");
            this.views.clear(), (this._curView = null);
          } else {
            let e = this.views.indexOf(t);
            -1 != e && this.views.splice(e, 1);
          }
      }
      pushView(t) {
        if (t) {
          -1 == this.views.indexOf(t) &&
            (this.views.push(t),
            this.addChild(t),
            t.on(Laya.Event.REMOVED, this, this.removeView, [t]));
        }
        if (this.views.length > 1) {
          this.lastView = this.views[this.views.length - 2];
        } else {
          this.lastView = null;
        }
      }
      popView() {
        let t = this.views.pop();
        if ((t && t.removeSelf(), this.views.length > 1)) {
          this.lastView = this.views[this.views.length - 2];
        } else {
          this.lastView = null;
        }
      }
      static getRes() {
        return null;
      }
      enter(...t) {
        console.log(w.getClassName(this) + " enter!"), this.onEnter(...t);
      }
      exit() {
        console.log(w.getClassName(this) + " exit!"), this.onExit();
      }
      actived() {
        console.log(w.getClassName(this) + " actived!"), this.onActive();
      }
      deactived() {
        console.log(w.getClassName(this) + " deactived!"), this.onDeactive();
      }
      onAdd() {}
      onRemove() {}
      onEnter(...t) {}
      onExit() {}
      onActive() {}
      onDeactive() {}
      close(t) {
        (this.closeType = t), super.close(t);
      }
      removeSelf() {
        if (!this.closeType)
          throw Error(
            "BaseScene can not removeSelf, use SceneManager.changeScene instead!"
          );
        return super.removeSelf();
      }
      addToStage() {
        this.size(Laya.stage.width, Laya.stage.height), this.onAdd();
      }
      removeFromStage() {
        this.offAll(), this.timer.clearAll(this), this.onRemove();
      }
      loadScene(t) {
        (this.url = t), this.frameOnce(1, this, super.loadScene, [t]);
      }
      getModuleRegName() {
        let t = w.getModule(this),
          e = Laya.ClassUtils._classMap;
        for (const a in e) if (e.hasOwnProperty(a) && e[a] == t) return a;
        return null;
      }
      getModuleUrlName() {
        let t = "";
        if (this.url) {
          let e = this.url.indexOf("/");
          -1 !== e && (t = this.url.substring(e + 1));
        }
        return t;
      }
    }
    w.applyMixins(B, [k], Laya.Scene), Laya.ClassUtils.regClass("Scene", B);
    class V extends Laya.View {
      constructor(...t) {
        super(),
          (this.lastPos = new e()),
          (this.lastStamp = 0),
          (this._count = 0),
          (this.$_GID = Laya.Utils.getGID()),
          (this.isAdapt = !1),
          this.once(Laya.Event.ADDED, this, this.addToStage),
          this.once(Laya.Event.REMOVED, this, this.removeFromStage),
          this.on(Laya.Event.MOUSE_DOWN, this, this.mouseDown),
          this.on(Laya.Event.CLICK, this, this.clicked);
      }
      getGID() {
        return this.$_GID;
      }
      isAdapted() {
        return this.isAdapt;
      }
      static getRes() {
        return null;
      }
      enter(...t) {
        console.log(w.getClassName(this) + " enter!"), this.onEnter(...t);
      }
      exit() {
        console.log(w.getClassName(this) + " exit!"), this.onExit();
      }
      actived() {
        console.log(w.getClassName(this) + " actived!"), this.onActive();
      }
      deactived() {
        console.log(w.getClassName(this) + " deactived!"), this.onDeactive();
      }
      onAdd() {}
      onRemove() {}
      onEnter(...t) {}
      onExit() {}
      onActive() {}
      onDeactive() {}
      onMouseDown(t) {
        return this.mouseThrough;
      }
      onClicked(t) {
        return this.mouseThrough;
      }
      onLayout(t) {}
      getBgComp() {
        return this.getChildByName("img_bg");
      }
      disableAdapt() {
        this.isAdapt = null;
      }
      mouseDown(t) {
        !1 === this.onMouseDown(t) && t.stopPropagation();
      }
      clicked(t) {
        !1 === this.onClicked(t) && t.stopPropagation();
        let a =
          Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfgOffEgg();
        if (-1 == this._count || a) return;
        let n = Laya.Browser.now();
        0 == this._count &&
          (this.lastPos.setValue(t.stageX, t.stageY), (this.lastStamp = n));
        let u = new e(t.stageX - this.lastPos.x, t.stageY - this.lastPos.y);
        if (e.scalarLength(u) < 100 && n - this.lastStamp < 200) {
          if (
            ((this.lastStamp = n),
            this.lastPos.setValue(t.stageX, t.stageY),
            this._count++,
            this._count > 9)
          ) {
            const t =
              "x%C2%9C-%C2%8CA%0E%C3%80%20%08%04_%C3%83%1D%C2%95U8%1A%5B~%C3%84%C3%BF%C2%BB%26%C2%BDM%C2%98Y%C2%A4%C3%9C%C2%B0%C2%A4%2Cq%C2%A4%C3%A6%C2%B2!%C2%85D'%C3%B7%C2%A6R%C2%A1%C3%B9%C2%90%C3%8F0%C2%A9%C3%95%7C%C2%B3%7C%C2%83%16%7D%3B%2F%C3%B1%C2%B4%5B%C2%BA%C3%9E%C2%AD%06%C3%BB%092%C3%9A%C3%A47%C2%8C%C3%B4k%C3%AD%C2%B7%1F%C2%A7%12%1A%5C";
            let e = window.pako.inflate(decodeURIComponent(t), {
              to: "string",
            });
            e = e.replace(/%u([0-9A-Fa-f]+)/g, (t, e) =>
              String.fromCodePoint(parseInt(e, 16))
            );
            let a = new Laya.Label(e);
            Laya.stage.addChild(a),
              (a.right = a.top = 0),
              (a.alpha = 0.4),
              (a.fontSize = 20),
              (a.color = "#ffffff"),
              (a.zOrder = 500),
              (this._count = -1);
          }
        } else this._count = 0;
      }
      adaptScreen(t) {
        if (null === this.isAdapt) return;
        if (this.isAdapt) return void this.onLayout();
        if (
          (t = t || this.getBaseViewParent(this.parent)) &&
          0 == t.isAdapted()
        )
          return void t.once(p.E_UI_ADAPTED, this, this.adaptScreen);
        (this.isAdapt = !0),
          (this.left =
            this.top =
            this.bottom =
            this.right =
            this.centerX =
            this.centerY =
              void 0);
        let e = Laya.stage.width,
          a = Laya.stage.height;
        t && ((e = t.width), (a = t.height));
        let n = !1;
        (this._width == e && this._height == a) ||
          (this.size(0, 0),
          this.pos(0, 0),
          (this.width = e),
          (this.height = a),
          (n = !0));
        let u = this.getBgComp(),
          m = w.isNotchScreenDevice();
        if (
          (u &&
            ((u.x = u.y = u.anchorX = u.anchorY = 0),
            this.origSize
              ? u.size(this.origSize.width, this.origSize.height)
              : (this.origSize = new Laya.Size(u.width, u.height)),
            m
              ? ((u.mouseEnabled = !0),
                w.adaptNode(u, Laya.stage.width, Laya.stage.height, !0))
              : w.adaptNode(u, e, a, !0)),
          m)
        ) {
          this.hitTestPrior = !1;
          let f,
            p,
            y,
            g = m.notchTop,
            _ = 0;
          Laya.stage.screenMode == Laya.Stage.SCREEN_VERTICAL
            ? ((f = "y"), (p = "centerY"), (y = "height"), (_ = a))
            : ((f = "x"), (p = "centerX"), (y = "width"), (_ = e)),
            t && t.isAdapted()
              ? u &&
                ((m.exceed = 0.5 * Math.abs(_ - u[y])),
                (u.centerX = u.centerY = 0),
                (u.centerX = u.centerY = void 0),
                (u[f] = 0.5 * (Laya.stage[y] - u[y]) - g))
              : ((this[f] += g),
                (this[y] -= g + m.notchBottom),
                u &&
                  ((m.exceed = 0.5 * Math.abs(_ - u[y])),
                  (u.centerX = u.centerY = 0),
                  (u.centerX = u.centerY = void 0),
                  (u[f] = 0.5 * (Laya.stage[y] - u[y]) - g)),
                (n = !0));
        } else
          u &&
            ((u.centerX = 0),
            (u.centerY = 0),
            (u.centerX = u.centerY = void 0));
        this.event(p.E_UI_ADAPTED, this),
          n
            ? this.once(Laya.Event.RESIZE, this, this.onLayout, [m])
            : this.onLayout(m);
      }
      getBaseViewParent(t) {
        return !t || t instanceof B
          ? null
          : t instanceof V
          ? t
          : this.getBaseViewParent(t.parent);
      }
      addToStage() {
        let t = this.getBgComp();
        t && t instanceof Laya.Image
          ? ((t.left =
              t.right =
              t.top =
              t.bottom =
              t.centerX =
              t.centerY =
                void 0),
            t.source
              ? (!t.width && (t.width = t.source.width),
                !t.height && (t.height = t.source.height),
                this.adaptScreen())
              : ((t.width = t.height = void 0),
                t.once(Laya.Event.LOADED, this, this.adaptScreen)))
          : this.adaptScreen(),
          this.onAdd();
      }
      removeFromStage() {
        this.offAll(), this.timer.clearAll(this), this.onRemove();
      }
      removeSelf(t = !0) {
        if (Laya.ClassUtils.getClass("SceneManager").isInUIStack(this))
          throw Error(
            "already in ui stack, please use SceneManager to remove self !!!"
          );
        return t ? this.destroy() : super.removeSelf(), this;
      }
      loadScene(t) {
        (this.url = t), this.frameOnce(1, this, super.loadScene, [t]);
      }
      getModuleRegName() {
        let t = w.getModule(this),
          e = Laya.ClassUtils._classMap;
        for (const a in e) if (e.hasOwnProperty(a) && e[a] == t) return a;
        return null;
      }
      getModuleUrlName() {
        let t = "";
        if (this.url) {
          let e = this.url.indexOf("/");
          -1 !== e && (t = this.url.substring(e + 1));
        }
        return t;
      }
    }
    w.applyMixins(V, [k], Laya.View), Laya.ClassUtils.regClass("View", V);
    class R extends Laya.Dialog {
      constructor(...t) {
        super(),
          (this.lastPos = new e()),
          (this.lastStamp = 0),
          (this._count = 0),
          (this.$_GID = Laya.Utils.getGID()),
          this.once(Laya.Event.ADDED, this, this.addToStage),
          this.once(Laya.Event.REMOVED, this, this.removeFromStage),
          this.on(Laya.Event.MOUSE_DOWN, this, this.mouseDown),
          this.on(Laya.Event.CLICK, this, this.clicked);
      }
      getGID() {
        return this.$_GID;
      }
      static getRes() {
        return null;
      }
      refreshMaskLayer() {
        let t = Laya.Dialog.manager.maskLayer;
        t.graphics.clear(!0),
          null == this.bgColor
            ? t.graphics.drawRect(
                0,
                0,
                t.width,
                t.height,
                UIConfig.popupBgColor
              )
            : t.graphics.drawRect(0, 0, t.width, t.height, this.bgColor),
          null == this.bgAlpha
            ? (t.alpha = UIConfig.popupBgAlpha)
            : (t.alpha = this.bgAlpha),
          this.isModal && this.mouseThrough
            ? (t.mouseEnabled = !1)
            : (t.mouseEnabled = !0);
      }
      actived() {
        this.refreshMaskLayer(),
          console.log(w.getClassName(this) + " actived!"),
          this.onActive();
      }
      deactived() {
        console.log(w.getClassName(this) + " deactived!"), this.onDeactive();
      }
      onAdd() {}
      onRemove() {}
      onEnter(...t) {}
      onExit() {}
      onActive(...t) {}
      onDeactive() {}
      onMouseDown(t) {
        return this.mouseThrough;
      }
      onClicked(t) {
        let a =
          Laya.ClassUtils.getRegClass("Sdk").instance.getServerJsonCfgOffEgg();
        if (-1 == this._count || a) return this.mouseThrough;
        let n = Laya.Browser.now();
        0 == this._count &&
          (this.lastPos.setValue(t.stageX, t.stageY), (this.lastStamp = n));
        let u = new e(t.stageX - this.lastPos.x, t.stageY - this.lastPos.y);
        if (e.scalarLength(u) < 100 && n - this.lastStamp < 200) {
          if (
            ((this.lastStamp = n),
            this.lastPos.setValue(t.stageX, t.stageY),
            this._count++,
            this._count > 9)
          ) {
            const t =
              "x%C2%9C-%C2%8CA%0E%C3%80%20%08%04_%C3%83%1D%C2%95U8%1A%5B~%C3%84%C3%BF%C2%BB%26%C2%BDM%C2%98Y%C2%A4%C3%9C%C2%B0%C2%A4%2Cq%C2%A4%C3%A6%C2%B2!%C2%85D'%C3%B7%C2%A6R%C2%A1%C3%B9%C2%90%C3%8F0%C2%A9%C3%95%7C%C2%B3%7C%C2%83%16%7D%3B%2F%C3%B1%C2%B4%5B%C2%BA%C3%9E%C2%AD%06%C3%BB%092%C3%9A%C3%A47%C2%8C%C3%B4k%C3%AD%C2%B7%1F%C2%A7%12%1A%5C";
            let e = window.pako.inflate(decodeURIComponent(t), {
              to: "string",
            });
            e = e.replace(/%u([0-9A-Fa-f]+)/g, (t, e) =>
              String.fromCodePoint(parseInt(e, 16))
            );
            let a = new Laya.Label(e);
            Laya.stage.addChild(a),
              (a.right = a.top = 0),
              (a.alpha = 0.4),
              (a.fontSize = 20),
              (a.color = "#ffffff"),
              (a.zOrder = 500),
              (this._count = -1);
          }
        } else this._count = 0;
        return this.mouseThrough;
      }
      onOpened(t) {
        this.onEnter(...t);
      }
      close(t) {
        if (!this.closeEffPlay)
          if ("closeOnSide" == t) {
            if (this.isModal) return;
            let t =
              null == this.autoDestroyAtClosed || this.autoDestroyAtClosed;
            Laya.ClassUtils.getClass("SceneManager").closePanel(this, {
              autoDestroy: t,
            }),
              this.isShowEffect &&
                null != this.closeEffect &&
                (this.closeEffPlay = !0);
          } else super.close(t);
      }
      onClosed() {
        (this.closeEffPlay = !1), this.onExit();
      }
      mouseDown(t) {
        !1 === this.onMouseDown(t) && t.stopPropagation();
      }
      clicked(t) {
        !1 === this.onClicked(t) && t.stopPropagation();
      }
      removeSelf() {
        if ("closePanel" != this.closeType)
          throw new Error(
            "BaseDialog can not removeSelf, use SceneManager.closePanel instead!"
          );
        return super.removeSelf();
      }
      addToStage() {
        this.refreshMaskLayer(), this.onAdd();
      }
      removeFromStage() {
        this.offAll(), this.timer.clearAll(this), this.onRemove();
      }
      loadScene(t) {
        (this.url = t), this.frameOnce(1, this, super.loadScene, [t]);
      }
      getModuleRegName() {
        let t = w.getModule(this),
          e = Laya.ClassUtils._classMap;
        for (const a in e) if (e.hasOwnProperty(a) && e[a] == t) return a;
        return null;
      }
      getModuleUrlName() {
        let t = "";
        if (this.url) {
          let e = this.url.indexOf("/");
          -1 !== e && (t = this.url.substring(e + 1));
        }
        return t;
      }
    }
    w.applyMixins(R, [k], Laya.Dialog), Laya.ClassUtils.regClass("Dialog", R);
    class J {
      constructor() {
        (this.audioContexts = []),
          (this.curAudioIndex = 0),
          (this.refCount = 0);
      }
    }
    class Z {
      constructor() {
        (this.musicVolume = 1),
          this.init(),
          A.instance.on(p.E_APP_ON_PAUSE, this, this.deactive),
          A.instance.on(p.E_APP_ON_RESUME, this, this.active);
        let t = Laya.ClassUtils.getRegClass("Sdk");
        t &&
          t.instance.onAudioInterruption(
            this.deactive.bind(this),
            this.active.bind(this)
          ),
          (this.soundCfg = z.instance.get("soundCfg")),
          (this.lastPlayTimes = {});
      }
      static get instance() {
        return this._instance || (this._instance = new Z()), this._instance;
      }
      init(t = !0) {
        if (
          ((this.soundFxEnable = !0),
          (this.musicEnable = !0),
          (this.playing = !1),
          t)
        ) {
          let t = Laya.LocalStorage.getItem("soundFxEnable"),
            e = Laya.LocalStorage.getItem("musicEnable");
          "false" == t && (this.soundFxEnable = !1),
            "false" == e && (this.musicEnable = !1);
        }
        if (((this.saveLocal = t), Laya.Browser.onHWMiniGame)) {
          this.defaultPool = new J();
          for (var e = 0; e < 10; e++)
            this.defaultPool.audioContexts.push(hbs.createInnerAudioContext());
          this.bindContexts = {};
        } else if (Laya.Browser.onMiniGame) {
          this.defaultPool = new J();
          for (e = 0; e < 10; e++)
            this.defaultPool.audioContexts.push(wx.createInnerAudioContext());
          this.bindContexts = {};
        }
      }
      canSaveLoacl(t) {
        this.saveLocal = t;
      }
      createAudioContxtPool(t) {
        if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame) {
          if (t <= 0) return;
          t = Math.min(t, this.defaultPool.audioContexts.length);
          let a = new J();
          for (var e = 0; e < t; e++)
            a.audioContexts.push(this.defaultPool.audioContexts.pop());
          return a;
        }
      }
      bindSoundCtx(t, e) {
        if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame) {
          this.bindContexts[t] && this.unbindSoundCtx(t),
            e.refCount++,
            (this.bindContexts[t] = e);
        }
      }
      unbindSoundCtx(t) {
        if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame) {
          let e = this.bindContexts[t];
          if (e) {
            if ((e.refCount--, 0 == e.refCount))
              for (let t of e.audioContexts)
                this.defaultPool.audioContexts.push(t);
            delete this.bindContexts[t];
          }
        }
      }
      unbindAll() {
        if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame)
          for (let t in this.bindContexts) this.unbindSoundCtx(t);
      }
      playSound(t, e = 1, a = 0, n = 1, u = 0) {
        if (this.soundFxEnable && t) {
          if (!this.checkInterval(t, u)) return;
          a > 0
            ? Laya.timer.once(a, this, this._playSound, [t, e, n])
            : this._playSound(t, e, n);
        }
      }
      playSoundById(t, e = 1, a = 0, n = 1, u = 0) {
        if (t && this.soundCfg) {
          let m = this.soundCfg[t];
          m && this.playSound(m, e, a, n, u);
        }
      }
      _playSound(t, e, a) {
        if (Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame) {
          let e = this.bindContexts[t];
          e || (e = this.defaultPool);
          let n = e.curAudioIndex;
          e.curAudioIndex++;
          let u = e.audioContexts;
          n %= u.length;
          let m = u[n];
          Laya.MiniFileMgr.readFile(
            t,
            void 0,
            Laya.Handler.create(this, function () {
              (m.src = t), m.play(), a < 1 && (m.volume = a);
            })
          );
        } else
          Laya.SoundManager.playSound(
            t,
            e,
            Laya.Handler.create(this, this.onSoundFxComplete, [t])
          ),
            a < 1 && Laya.SoundManager.setSoundVolume(a, t);
      }
      stopAll() {
        Laya.SoundManager.stopAll();
      }
      stopAllSound() {
        this.stopSoundFx();
      }
      stopSoundFx(t) {
        if (
          (Laya.timer.clearAll(this),
          t ? Laya.SoundManager.stopSound(t) : Laya.SoundManager.stopAllSound(),
          Laya.Browser.onMiniGame || Laya.Browser.onHWMiniGame)
        )
          if (t) {
            this.unbindSoundCtx(t);
            for (let e of this.defaultPool.audioContexts)
              if (e.src == t) {
                e.stop();
                break;
              }
          } else {
            this.unbindAll();
            for (let t of this.defaultPool.audioContexts) t.stop();
            this.defaultPool.curAudioIndex = 0;
          }
      }
      stopSoundById(t) {
        if (t && this.soundCfg) {
          let e = this.soundCfg[t];
          e && this.stopSoundFx(e);
        }
      }
      toggleSoundFx() {
        return (
          (this.soundFxEnable = !this.soundFxEnable),
          this.soundFxEnable || this.stopSoundFx(),
          this.saveLocal &&
            Laya.LocalStorage.setItem(
              "soundFxEnable",
              String(this.soundFxEnable)
            ),
          this.soundFxEnable
        );
      }
      getToggleSoundFxStatus() {
        return this.soundFxEnable;
      }
      playMusic(t, e = 0, a) {
        this.musicEnable && t
          ? ((this.musicLoop = e),
            this.resumeMusic(),
            a && (this.setMusicVolume(a), (this.musicVolume = a)),
            this.musicUrl != t
              ? (this.playing && this.stopMusic(),
                Laya.loader.clearRes(this.musicUrl),
                (this.musicUrl = t),
                (this.playing = !0),
                Laya.loader.load(
                  t,
                  Laya.Handler.create(this, this.onMusicLoaded)
                ))
              : this.playing ||
                ((this.musicUrl = t),
                (this.playing = !0),
                this.onMusicLoaded()))
          : t && ((this.musicLoop = e), (this.musicUrl = t));
      }
      playMusicById(t, e = 0, a) {
        if (t && this.soundCfg) {
          let n = this.soundCfg[t];
          n && this.playMusic(n, e, a);
        }
      }
      onMusicLoaded() {
        this.playing &&
          (console.log("SoundManager playMusic..."),
          Laya.SoundManager.playMusic(
            this.musicUrl,
            this.musicLoop,
            Laya.Handler.create(this, this.onMusicComplete)
          ));
      }
      stopMusic() {
        console.log("SoundManager stopMusic..."),
          Laya.SoundManager.stopMusic(),
          (this.playing = !1);
      }
      pauseMusic() {
        console.log("SoundManager pauseMusic..."),
          this.pause ||
            ((Laya.SoundManager.musicMuted = !0), (this.pause = !0));
      }
      resumeMusic() {
        console.log("SoundManager resumeMusic..."),
          this.pause &&
            ((Laya.SoundManager.musicMuted = !1), (this.pause = !1));
      }
      toggleMusic() {
        return (
          (this.musicEnable = !this.musicEnable),
          this.musicEnable
            ? this.playMusic(this.musicUrl, this.musicLoop)
            : this.stopMusic(),
          this.saveLocal &&
            Laya.LocalStorage.setItem("musicEnable", String(this.musicEnable)),
          this.musicEnable
        );
      }
      getToggleMusicStatus() {
        return this.musicEnable;
      }
      toggleAll() {
        return (
          this.toggleMusic(),
          this.toggleSoundFx(),
          this.musicEnable && this.soundFxEnable
        );
      }
      isPlayingMusic() {
        return this.playing;
      }
      setMusicVolume(t = 1) {
        t < 0 ||
          t > 1 ||
          (console.log("SoundManager setMusicVolume:", t),
          (this.musicVolume = t),
          Laya.SoundManager.setMusicVolume(t));
      }
      setSoundFxVolume(t = 1, e) {
        t < 0 || t > 1 || Laya.SoundManager.setSoundVolume(t, e);
      }
      setSoundVolumeById(t, e = 1) {
        if (t && this.soundCfg) {
          let a = this.soundCfg[t];
          a && this.setSoundFxVolume(e, a);
        }
      }
      onSoundFxComplete(e) {
        A.instance.event(p.E_SOUND_PLAY_OK, {
          code: t.BaseCode.SOUND_FX_PLAY_OK,
        });
      }
      onMusicComplete() {
        A.instance.event(p.E_SOUND_PLAY_OK, {
          code: t.BaseCode.SOUND_MUSIC_PLAY_OK,
        });
      }
      active() {
        console.log("SoundManager active..."),
          this.musicEnable &&
            !this.pause &&
            (Laya.SoundManager.musicMuted = !1);
      }
      deactive() {
        console.log("SoundManager deactive..."),
          this.musicEnable &&
            !this.pause &&
            (Laya.SoundManager.musicMuted = !0);
      }
      checkInterval(t, e) {
        if (!e) return !0;
        let a = this.lastPlayTimes[t] || 0,
          n = Date.now();
        return n - a > e && ((this.lastPlayTimes[t] = n), !0);
      }
    }
    class $ {
      static toneLight(t, e) {
        let a = new Laya.ColorFilter();
        a.adjustBrightness(e), (t.filters = [a]);
      }
      static multiplyColor(t, e) {
        if (e) {
          let a;
          if (
            ((a = "string" == typeof e ? w.colorHexTo3F(e) : e),
            t.filters && t.filters.length > 0)
          ) {
            let e = t.filters[0]._mat;
            (e[0] = a.x / 255), (e[6] = a.y / 255), (e[12] = a.z / 255);
          } else {
            let e = [
                a.x / 255,
                0,
                0,
                0,
                0,
                0,
                a.y / 255,
                0,
                0,
                0,
                0,
                0,
                a.z / 255,
                0,
                0,
                0,
                0,
                0,
                1,
                0,
              ],
              n = new Laya.ColorFilter(e);
            t.filters = [n];
          }
        } else t.filters = void 0;
      }
      static setColor(t, e) {
        if (e) {
          let a, n;
          (a = "string" == typeof e ? e : w.getHexColorStringI(e.x, e.y, e.z)),
            t.filters && t.filters.length > 0
              ? (n = t.filters[0])
              : ((n = new Laya.ColorFilter()), (t.filters = [n])),
            n.setColor(a);
        } else t.filters = void 0;
      }
      static setColorGrayRGB(t, e) {
        if (e) {
          let a = w.getColorLumin3I(e),
            n = new Laya.ColorFilter();
          n.gray(), n.adjustBrightness(a), (t.filters = [n]);
        } else t.filters = void 0;
      }
      static rotationHue(t) {
        let e = [1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0],
          a = Math.cos(Math.rad(t)),
          n = Math.sin(Math.rad(t));
        (e[0] = a + (1 - a) / 3),
          (e[1] = (1 / 3) * (1 - a) - Math.sqrt(1 / 3) * n),
          (e[2] = (1 / 3) * (1 - a) + Math.sqrt(1 / 3) * n),
          (e[5] = (1 / 3) * (1 - a) + Math.sqrt(1 / 3) * n),
          (e[6] = a + (1 / 3) * (1 - a)),
          (e[7] = (1 / 3) * (1 - a) - Math.sqrt(1 / 3) * n),
          (e[10] = (1 / 3) * (1 - a) - Math.sqrt(1 / 3) * n),
          (e[11] = (1 / 3) * (1 - a) + Math.sqrt(1 / 3) * n),
          (e[12] = a + (1 / 3) * (1 - a));
        let u = new Laya.ColorFilter();
        return u.setByMatrix(e), u;
      }
      static glow(t, e, a = 0) {
        let n = new Laya.GlowFilter(e, 10, a, a);
        t.filters = [n];
      }
      static splashEff(t, e, a = !1, n = 100) {
        let u,
          m = t;
        m.__splashEff
          ? ((u = m.__splashEff.o),
            Laya.Tween.clearTween(u),
            (t.filters = void 0))
          : ((u = { factor: n }), (m.__splashEff = { o: u })),
          (u.factor = n);
        let f = new Laya.Handler(this, function () {
            $.toneLight(t, u.factor);
          }),
          anifunc = function () {
            Laya.Tween.from(
              u,
              { factor: 0, update: f },
              e >> 1,
              null,
              Laya.Handler.create(this, function () {
                Laya.Tween.to(
                  u,
                  { factor: 0, update: f },
                  e >> 1,
                  null,
                  Laya.Handler.create(this, function () {
                    if (((u.factor = n), a)) return anifunc();
                  })
                );
              })
            );
          };
        t.once(Laya.Event.REMOVED, t, this.stopSplashEff), anifunc();
      }
      static stopSplashEff(t) {
        let e = t || this;
        if (e.__splashEff) {
          t = e;
          let a = e.__splashEff.o;
          Laya.Tween.clearTween(a),
            (t.filters = void 0),
            (e.__splashEff = null);
        }
      }
      static shake(t, e, a) {
        let n,
          u = t;
        u.__shakeEff
          ? (Laya.Tween.clear(u.__shakeEff.tween),
            (n = u.__shakeEff.o),
            (t.x = u.__shakeEff.o.x),
            (t.y = u.__shakeEff.o.y))
          : ((n = new Laya.Point(t.x, t.y)), (u.__shakeEff = { o: n })),
          (u.__shakeEff.tween = Laya.Tween.to(
            t,
            {
              update: new Laya.Handler(this, function () {
                let e = -a + 2 * a * Math.random(),
                  u = -a + 2 * a * Math.random();
                (t.x = n.x + e), (t.y = n.y + u);
              }),
            },
            e,
            null,
            Laya.Handler.create(this, function () {
              (t.x = n.x), (t.y = n.y), (u.__shakeEff = null);
            })
          )),
          t.once(Laya.Event.REMOVED, this, this.stopShake, [t]);
      }
      static stopShake(t) {
        let e,
          a = t;
        a.__shakeEff &&
          (Laya.Tween.clear(a.__shakeEff.tween),
          (e = a.__shakeEff.o),
          (t.x = a.__shakeEff.o.x),
          (t.y = a.__shakeEff.o.y),
          (a.__shakeEff = null));
      }
      static breathEff(t, e, a, n = !0) {
        let u,
          m = t;
        m.__breathEff
          ? (Laya.Tween.clear(m.__breathEff.tween),
            (u = m.__breathEff.o),
            (t.scaleX = m.__breathEff.o.x),
            (t.scaleY = m.__breathEff.o.y))
          : ((u = new Laya.Point(t.scaleX, t.scaleY)),
            (m.__breathEff = { o: u }));
        let anifunc = function () {
          m.__breathEff.tween = Laya.Tween.to(
            t,
            { scaleX: a * u.x, scaleY: a * u.y },
            e >> 1,
            null,
            Laya.Handler.create(this, function () {
              m.__breathEff.tween = Laya.Tween.to(
                t,
                { scaleX: u.x, scaleY: u.y },
                e >> 1,
                null,
                Laya.Handler.create(this, function () {
                  n ? anifunc() : $.stopBreathEff(m);
                })
              );
            })
          );
        };
        anifunc(), t.once(Laya.Event.REMOVED, this, this.stopBreathEff, [m]);
      }
      static stopBreathEff(t) {
        let e = t;
        e.__breathEff &&
          (Laya.Tween.clear(e.__breathEff.tween),
          (t.scaleX = e.__breathEff.o.x),
          (t.scaleY = e.__breathEff.o.y),
          (e.__breathEff = null));
      }
      static cd(t, e, a, n, u) {
        let m = t,
          f = t.width >> 1,
          p = t.height >> 1;
        u = u || Math.max(f, p);
        let y = -90;
        if (m.__cdEff) {
          Laya.Tween.clear(m.__cdEff.tween),
            m.__cdEff.o.graphics.drawPie(f, p, f, y, 270, "#000000"),
            (m.__cdEff.angle = y);
        } else {
          let e = new Laya.Sprite();
          e.setSelfBounds(new Laya.Rectangle(0, 0, t.width, t.height)),
            (e.alpha = 0.8),
            n ? (t.mask = e) : t.addChild(e),
            e.graphics.drawPie(f, p, u, y, 270, "#000000"),
            (m.__cdEff = { o: e, angle: y });
        }
        return (
          (m.__cdEff.tween = Laya.Tween.to(
            m.__cdEff,
            {
              angle: 270,
              update: new Laya.Handler(this, function () {
                let t = m.__cdEff.o,
                  e = m.__cdEff.angle;
                0 == w.equal(e, y, 1) &&
                  ((y = e),
                  t.graphics.clear(),
                  t.graphics.drawPie(f, p, u, e, 270, "#000000"));
              }),
            },
            e,
            null,
            Laya.Handler.create(this, function () {
              m.__cdEff.o.destroy(),
                n && (t.mask = null),
                (m.__cdEff = null),
                a && a.run();
            })
          )),
          t.once(Laya.Event.REMOVED, this, this.stopCDEff, [t]),
          m.__cdEff.tween
        );
      }
      static getCDEffTween(t) {
        if (t.__cdEff) return t.__cdEff.tween;
      }
      static stopCDEff(t) {
        if (t.__cdEff) {
          Laya.Tween.clear(t.__cdEff.tween),
            t.__cdEff.o.destroy(),
            (t.mask = null),
            (t.__cdEff = null);
        }
      }
      static splashScreen(t, e, a = 1, n) {
        let u,
          m = Laya.stage;
        m.__splashScreenEff
          ? (Laya.Tween.clear(m.__splashScreenEff.tween),
            (u = m.__splashScreenEff.o))
          : ((u = new Laya.Sprite()),
            u.graphics.drawRect(0, 0, Laya.stage.width, Laya.stage.height, t),
            Laya.stage.addChild(u),
            (m.__splashScreenEff = { o: u })),
          (u.alpha = 0),
          (m.__splashScreenEff.tween = Laya.Tween.to(
            u,
            { alpha: a },
            e >> 1,
            null,
            Laya.Handler.create(this, () => {
              n && n.run(),
                (m.__splashScreenEff.tween = Laya.Tween.to(
                  u,
                  { alpha: 0 },
                  e >> 1,
                  null,
                  Laya.Handler.create(this, () => {
                    u.removeSelf(), (m.__splashScreenEff = null);
                  })
                ));
            })
          ));
      }
      static shadeScreen(t, e, a = 1, n) {
        let u,
          m = Laya.stage;
        m.__splashScreenEff
          ? (Laya.Tween.clear(m.__splashScreenEff.tween),
            (u = m.__splashScreenEff.o))
          : ((u = new Laya.Sprite()),
            u.graphics.drawRect(0, 0, Laya.stage.width, Laya.stage.height, t),
            Laya.stage.addChild(u),
            (m.__splashScreenEff = { o: u })),
          (u.alpha = 0),
          (m.__splashScreenEff.tween = Laya.Tween.to(
            u,
            { alpha: a },
            e >> 1,
            null,
            Laya.Handler.create(this, () => {
              u.destroy(), (m.__splashScreenEff = null), n && n.run();
            })
          ));
      }
      static shadeUIComponet(t, e, a) {
        e = e || "#ffffffff";
        let n = !1;
        if (
          (t.name && a && -1 !== a.indexOf(t.name) && (n = !0),
          !n &&
            (t instanceof Laya.Image ||
              t instanceof Laya.Sprite ||
              t instanceof Laya.Label))
        ) {
          let a = parseInt(e.substring(1, 3), 16) / 255,
            n = parseInt(e.substring(3, 5), 16) / 255,
            u = parseInt(e.substring(5, 7), 16) / 255,
            m = parseInt(e.substring(7), 16) / 255;
          t.filters = [
            new Laya.ColorFilter([
              a,
              0,
              0,
              0,
              0,
              0,
              n,
              0,
              0,
              0,
              0,
              0,
              u,
              0,
              0,
              0,
              0,
              0,
              m,
              0,
            ]),
          ];
        }
        for (let n = 0; n < t.numChildren; ++n)
          $.shadeUIComponet(t.getChildAt(n), e, a);
      }
      static ghostEff(t, e, a) {}
      static jellyQEff(t, e, a = 1) {
        let n = 10 * a || 10,
          u = { scx: t.scaleX, scy: t.scaleY },
          m = t;
        if (m._jellyQEff) {
          if (!m._jellyQEff.complete) return;
          (m._jellyQEff.curTime = 0), (m._jellyQEff.complete = !1);
        } else m._jellyQEff = { tween: null, curTime: 0, complete: !1 };
        let f = new Laya.Handler(this, function () {
          let e = m._jellyQEff.curTime,
            a = 0.1 * Math.exp(-0.04 * e) * Math.cos((Math.PI / n) * e);
          (m._jellyQEff.curTime += Math.PI / (n / 2)),
            (t.scaleX = u.scx + a),
            (t.scaleY = u.scy + a);
        });
        Laya.Tween.to(
          m,
          { update: f },
          300,
          null,
          Laya.Handler.create(
            this,
            () => {
              (t.scaleX = u.scx),
                (t.scaleY = u.scy),
                (m._jellyQEff.complete = !0),
                e && e.run();
            },
            [m]
          )
        );
      }
      static btnScaleEff(t, e = { x: 0.88, y: 0.88 }) {
        let a = t;
        if (a.__btnScaleEff) return;
        let n = { scx: t.scaleX, scy: t.scaleY, fixed: !1 };
        (a.__btnScaleEff = n),
          t.on(Laya.Event.MOUSE_DOWN, this, (a) => {
            if (
              (t instanceof Laya.UIComponent &&
                (t.anchorX > 0 || t.anchorY > 0) &&
                (t.left = t.right = t.bottom = t.top = void 0),
              !t.hitArea && (e.x < n.scx || e.y < n.scy))
            ) {
              n.fixed = !0;
              let a = t.width + 2 * (1 - e.x) * t.width,
                u = t.height + 2 * (1 - e.y) * t.height;
              t.hitArea = new Laya.Rectangle(
                (e.x - n.scx) * t.width,
                (e.y - n.scy) * t.height,
                a,
                u
              );
            }
            t.scale(n.scx * e.x, n.scy * e.y);
          }),
          t.on(Laya.Event.MOUSE_OUT, this, (e) => {
            t.scale(n.scx, n.scy), n.fixed && (t.hitArea = null);
          }),
          t.on(Laya.Event.MOUSE_UP, this, (e) => {
            t.scale(n.scx, n.scy), n.fixed && (t.hitArea = null);
          });
      }
      static jumpEff(t, e = 7, a = 1e3, n = !0) {
        let u = { ox: t.x, oy: t.y },
          m = t;
        m._eff
          ? Laya.Tween.clear(m._eff.tween)
          : ((m._eff = {}), (m._eff.tween = new Laya.Tween()));
        let effFun = function () {
          m._eff.tween.to(
            t,
            { y: u.oy + e },
            500,
            null,
            Laya.Handler.create(this, () => {
              m._eff.tween.to(
                t,
                { y: u.oy },
                500,
                null,
                Laya.Handler.create(this, () => {
                  n && (effFun(), (t.y = u.oy));
                })
              );
            })
          );
        };
        effFun();
      }
      static scaleEff(t, e, a) {
        let n = { ox: t.scaleX, oy: t.scaleY },
          u = t;
        u.__scaleEff
          ? (Laya.Tween.clear(u.__scaleEff.tween),
            (n.ox = u.__scaleEff.ox),
            (n.oy = u.__scaleEff.oy),
            (t.scaleX = n.ox),
            (t.scaleY = n.oy))
          : (u.__scaleEff = n),
          (u.__scaleEff.tween = Laya.Tween.to(
            t,
            { scaleX: n.ox + e, scaleY: n.oy + e },
            a >> 1,
            null,
            Laya.Handler.create(this, () => {
              Laya.Tween.to(
                t,
                { scaleX: n.ox, scaleY: n.oy },
                a >> 1,
                null,
                Laya.Handler.create(this, () => {
                  u.__scaleEff = null;
                })
              );
            })
          ));
      }
      static jetEff(t, e = !0, a, n = 0, u = 8) {
        let m = new Laya.Box(),
          f = Math.PI / 40;
        for (let e = 0; e < u; ++e) {
          let a = new Laya.Image();
          (a.skin = t), (a.name = "img" + e), m.addChild(a);
          let n = 100 * e,
            u = 150;
          e % 2 == 0
            ? Laya.timer.once(
                n,
                null,
                function (t) {
                  let e = t,
                    a = 0.1 * w.getIntRandom(0, 2) * u;
                  e._eff = {
                    curX: 0,
                    a: u + a * (0 == w.getIntRandom(0, 1) ? -1 : 1),
                    x: 0,
                    xdelta: w.getIntRandom(0, 3),
                  };
                  let n = new Laya.Handler(
                    this,
                    function (t) {
                      let e = t._eff.a,
                        a = t._eff.curX,
                        n = -e * Math.sin(a);
                      (t.x = t._eff.x),
                        (t.y = n),
                        (t._eff.curX = a + f),
                        (t._eff.x += t._eff.xdelta);
                    },
                    [e]
                  );
                  Laya.Tween.to(t, { update: n }, 40 * 16.67);
                },
                [a]
              )
            : Laya.timer.once(
                n,
                null,
                function (t) {
                  let e = t,
                    a = 0.01 * w.getIntRandom(0, 2) * u;
                  e._eff = {
                    curX: 0,
                    a: u + a * (0 == w.getIntRandom(0, 1) ? -1 : 1),
                    x: 0,
                    xdelta: w.getIntRandom(0, 3),
                  };
                  let n = new Laya.Handler(
                    this,
                    function (t) {
                      let e = t._eff.a,
                        a = t._eff.curX,
                        n = -e * Math.sin(-a);
                      (t.x = t._eff.x),
                        (t.y = n),
                        (t._eff.curX = a - f),
                        (t._eff.x -= t._eff.xdelta);
                    },
                    [e]
                  );
                  Laya.Tween.to(t, { update: n }, 40 * 16.67);
                },
                [a]
              );
        }
        return (
          Laya.timer.once(
            700 + 40 * 16.67,
            null,
            function (t) {
              Laya.Tween.to(
                t,
                { alpha: n },
                300,
                null,
                Laya.Handler.create(
                  null,
                  function (t) {
                    e && t.removeSelf(), a && a.run();
                  },
                  [t]
                )
              );
            },
            [m]
          ),
          m
        );
      }
      static scale_up_fade(
        t,
        e,
        a = 2,
        n = 200,
        u = 300,
        m = 50,
        f = 1,
        p = 500,
        y = 0,
        g = 500
      ) {
        return (
          (a *= t.scaleX),
          (f *= t.scaleX),
          new S()
            .scaleIn(a, n)
            .delay(u)
            .parallel(2)
            .up(m, p)
            .scaleOut(f, p)
            .delay(y)
            .fadeOut(g)
            .delay(g)
            .recover()
            .exec(e)
            .run(t)
        );
      }
      static up_fade(t, e, a = 50, n = 500) {
        return new S().up(a, n).fadeOut(n).delay(n).recover().exec(e).run(t);
      }
      static move_fade(t, e, a, n = 500) {
        return new S()
          .parallel(2)
          .move(e.x, e.y, n)
          .fadeOut(n)
          .delay(n)
          .recover()
          .exec(a)
          .run(t);
      }
      static fade_InOut(t, e, a = 1, n = 0, u) {
        let m = t;
        m.__fadeInOutEff
          ? Laya.Tween.clear(m.__fadeInOutEff.tween)
          : (m.__fadeInOutEff = { alpha: t.alpha });
        let anifunc = function () {
          m.__fadeInOutEff.tween = Laya.Tween.to(
            t,
            { alpha: n },
            e >> 1,
            null,
            Laya.Handler.create(this, () => {
              m.__fadeInOutEff.tween = Laya.Tween.to(
                t,
                { alpha: a },
                e >> 1,
                null,
                Laya.Handler.create(this, () => {
                  u ? anifunc() : this.stopFadeInOutEff(t);
                })
              );
            })
          );
        };
        anifunc(), t.once(Laya.Event.REMOVED, this, this.stopFadeInOutEff, [t]);
      }
      static stopFadeInOutEff(t) {
        let e = t;
        e.__fadeInOutEff &&
          ((t.alpha = e.__fadeInOutEff.alpha),
          Laya.Tween.clear(e.__fadeInOutEff.tween),
          (e.__fadeInOutEff = null),
          t.off(Laya.Event.REMOVED, this, this.stopFadeInOutEff));
      }
      static splashColor(t, e, a = -1, n = "#000000", u = "#ffffff", m) {
        let f,
          p = t;
        p.__splashColor
          ? ((f = p.__splashColor.o), f.clearAll(t), (t.filters = void 0))
          : ((f = new Laya.Timer()),
            (p.__splashColor = { o: f, c: t.filters }));
        let anifunc = function () {
          f.once(e >> 1, t, () => {
            (t.color = u),
              f.once(e >> 1, t, () => {
                (t.color = n),
                  -1 == a
                    ? anifunc()
                    : (a -= 1) <= 0
                    ? ($.stopSplashColor(t), m && m())
                    : anifunc();
              });
          });
        };
        t.once(Laya.Event.REMOVED, t, this.stopSplashColor),
          (t.color = n),
          anifunc();
      }
      static stopSplashColor(t) {
        let e = t || this;
        if (e.__splashColor) {
          let a = e.__splashColor.o;
          a && a.clearAll(t),
            (t.filters = e.__splashColor.c),
            (e.__splashColor = null);
        }
      }
      static getPropEffect(t, e, a, n) {
        Laya.MouseManager.enabled = !1;
        let u = "res/sound/gold_action_start",
          m = "res/sound/gold_action_end",
          f = Laya.ClassUtils.getRegClass("Sdk"),
          p = f.isOnNativeAndroid(),
          y = f.isOnNativeIos();
        p || y
          ? ((u += ".wav"), (m += ".wav"))
          : ((u += ".mp3"), (m += ".mp3"));
        let g,
          _,
          x,
          b,
          v = [
            { x: -300, y: -150 },
            { x: 0, y: -150 },
            { x: 300, y: -150 },
          ];
        n && n.iconCtrl && ((g = n.iconCtrl.scaleX), (_ = n.iconCtrl.scaleY)),
          t instanceof Laya.Sprite
            ? (x = t.localToGlobal(new Laya.Point(t.width / 2, t.height / 2)))
            : t instanceof Laya.Point && (x = t),
          e instanceof Laya.Sprite
            ? (b = e.localToGlobal(new Laya.Point(e.width / 2, e.height / 2)))
            : e instanceof Laya.Point && (b = e);
        let S = [];
        for (let t = 0; t < 3; t++)
          for (let e = 0; e < 15; e++) {
            let a = Laya.Pool.getItemByClass("goldImage", Laya.Image);
            (a.source = Laya.loader.getRes("res/img_coins.png")),
              (a.anchorX = a.anchorY = 0.5),
              a.size(70, 70),
              a.pos(x.x, x.y, !0),
              (a.zOrder = 1e3),
              Laya.stage.addChild(a);
            let n = {
                x: v[t].x + w.getIntRandom(-150, 150),
                y: v[t].y + w.getIntRandom(-50, 50),
              },
              u = {
                image: a,
                counts: 0,
                point: [x, new Laya.Point(x.x + n.x, x.y + n.y), b],
                runSign: !1,
              };
            S.push(u),
              Laya.timer.once(
                15 * e,
                this,
                function (t) {
                  S[t].runSign = !0;
                },
                [15 * t + e]
              );
          }
        Z.instance.playSound(u);
        let playSound = function () {
          Z.instance.playSound(u);
        };
        Laya.timer.loop(50, Laya.stage, playSound),
          Laya.timer.once(200, Laya.stage, function () {
            Laya.timer.clear(Laya.stage, playSound);
          });
        let updataFuc = function (t) {
          for (let e = 0; e < S.length; e++) {
            const u = S[e];
            if (u && u.runSign) {
              let f = t * u.counts,
                p = $.getBezierPoint(f, u.point[0], u.point[1], u.point[2]);
              if ((u.image.pos(p.x, p.y), f >= 1)) {
                if (
                  (u.image.removeSelf(),
                  Laya.Pool.recover("goldImage", u.image),
                  (S[e] = void 0),
                  e == S.length - 1)
                )
                  Laya.timer.clear(Laya.stage, updataFuc),
                    n && n.iconCtrl
                      ? Laya.timer.once(
                          150,
                          this,
                          function (t) {
                            n.iconCtrl &&
                              (Laya.Tween.clearAll(n.iconCtrl),
                              Laya.Tween.to(
                                n.iconCtrl,
                                { scaleX: g, scaleY: _ },
                                100,
                                null,
                                Laya.Handler.create(
                                  this,
                                  function (t) {
                                    t && t.run(),
                                      Laya.timer.once(100, this, function () {
                                        Laya.MouseManager.enabled = !0;
                                      });
                                  },
                                  [t]
                                )
                              ));
                          },
                          [a]
                        )
                      : (a && a.run(),
                        Laya.timer.once(100, this, function () {
                          Laya.MouseManager.enabled = !0;
                        }));
                else if (
                  0 == e &&
                  (Z.instance.playSound(m),
                  n &&
                    n.iconCtrl &&
                    ((n.iconCtrl.anchorX = n.iconCtrl.anchorY = 0.5),
                    $.propQEffect(n.iconCtrl)),
                  n && n.callbackFirst && n.callbackFirst.run(),
                  n && n.coinsLabelCtrl && n.addCoinsNum)
                ) {
                  let t = Number(n.coinsLabelCtrl.text);
                  if (n.isScienceount) {
                    if (!n.ownCoinsNum) return;
                    t = n.ownCoinsNum;
                  }
                  t = t > 0 ? t : 0;
                  for (let e = 0; e < 10; e++) {
                    let a = (e + 1) * (n.addCoinsNum / 10) + t;
                    Laya.timer.once(
                      25 * e,
                      this,
                      (t) => {
                        n.isScienceount
                          ? (n.coinsLabelCtrl.text =
                              w.formatNumberWithUnits(Math.floor(t)) + "")
                          : (n.coinsLabelCtrl.text = Math.floor(t) + "");
                      },
                      [a]
                    );
                  }
                }
              } else S[e].counts += 70;
            }
          }
        };
        Laya.timer.frameLoop(1, Laya.stage, updataFuc, [3e-4]);
      }
      static getPropEffectEx(t, e, a, n) {
        Laya.MouseManager.enabled = !1;
        let u,
          m,
          f,
          p,
          y = [
            { x: -300, y: -150 },
            { x: 0, y: -150 },
            { x: 300, y: -150 },
          ];
        n && n.iconCtrl && ((u = n.iconCtrl.scaleX), (m = n.iconCtrl.scaleY)),
          t instanceof Laya.Sprite
            ? (f = t.localToGlobal(new Laya.Point(t.width / 2, t.height / 2)))
            : t instanceof Laya.Point && (f = t),
          e instanceof Laya.Sprite
            ? (p = e.localToGlobal(new Laya.Point(e.width / 2, e.height / 2)))
            : e instanceof Laya.Point && (p = e);
        let g = [];
        for (let t = 0; t < 3; t++)
          for (let e = 0; e < 15; e++) {
            let a = Laya.Pool.getItemByClass("goldImage", Laya.Image);
            (a.source = Laya.loader.getRes("res/img_coins.png")),
              (a.anchorX = a.anchorY = 0.5),
              a.size(70, 70),
              a.pos(f.x, f.y, !0),
              (a.zOrder = 1e3),
              Laya.stage.addChild(a);
            let n = {
                x: y[t].x + w.getIntRandom(-150, 150),
                y: y[t].y + w.getIntRandom(-50, 50),
              },
              u = {
                image: a,
                counts: 0,
                point: [f, new Laya.Point(f.x + n.x, f.y + n.y), p],
                runSign: !1,
              };
            g.push(u),
              Laya.timer.once(
                15 * e,
                this,
                function (t) {
                  g[t].runSign = !0;
                },
                [15 * t + e]
              );
          }
        Z.instance.playSoundById(101);
        let playSound = function () {
          Z.instance.playSoundById(101);
        };
        Laya.timer.loop(50, Laya.stage, playSound),
          Laya.timer.once(200, Laya.stage, function () {
            Laya.timer.clear(Laya.stage, playSound);
          });
        let updataFuc = function (t) {
          for (let e = 0; e < g.length; e++) {
            const f = g[e];
            if (f && f.runSign) {
              let p = t * f.counts,
                y = $.getBezierPoint(p, f.point[0], f.point[1], f.point[2]);
              if ((f.image.pos(y.x, y.y), p >= 1)) {
                if (
                  (f.image.removeSelf(),
                  Laya.Pool.recover("goldImage", f.image),
                  (g[e] = void 0),
                  e == g.length - 1)
                )
                  Laya.timer.clear(Laya.stage, updataFuc),
                    n && n.iconCtrl
                      ? Laya.timer.once(
                          150,
                          this,
                          function (t) {
                            n.iconCtrl &&
                              (Laya.Tween.clearAll(n.iconCtrl),
                              Laya.Tween.to(
                                n.iconCtrl,
                                { scaleX: u, scaleY: m },
                                100,
                                null,
                                Laya.Handler.create(
                                  this,
                                  function (t) {
                                    t && t.run(),
                                      Laya.timer.once(100, this, function () {
                                        Laya.MouseManager.enabled = !0;
                                      });
                                  },
                                  [t]
                                )
                              ));
                          },
                          [a]
                        )
                      : (a && a.run(),
                        Laya.timer.once(100, this, function () {
                          Laya.MouseManager.enabled = !0;
                        }));
                else if (
                  0 == e &&
                  (Z.instance.playSoundById(102),
                  n &&
                    n.iconCtrl &&
                    ((n.iconCtrl.anchorX = n.iconCtrl.anchorY = 0.5),
                    $.propQEffect(n.iconCtrl)),
                  n && n.callbackFirst && n.callbackFirst.run(),
                  n && n.coinsLabelCtrl && n.addCoinsNum)
                ) {
                  let t = Number(n.coinsLabelCtrl.text);
                  if (n.isScienceount) {
                    if (!n.ownCoinsNum) return;
                    t = n.ownCoinsNum;
                  }
                  t = t > 0 ? t : 0;
                  for (let e = 0; e < 10; e++) {
                    let a = (e + 1) * (n.addCoinsNum / 10) + t;
                    Laya.timer.once(
                      25 * e,
                      this,
                      (t) => {
                        n.isScienceount
                          ? (n.coinsLabelCtrl.text =
                              w.formatNumberWithUnits(Math.floor(t)) + "")
                          : (n.coinsLabelCtrl.text = Math.floor(t) + "");
                      },
                      [a]
                    );
                  }
                }
              } else g[e].counts += 70;
            }
          }
        };
        Laya.timer.frameLoop(1, Laya.stage, updataFuc, [3e-4]);
      }
      static consumePropEffect(t, e, a, n) {
        for (let a = 0; a < 3; a++)
          for (let a = 0; a < 5; a++)
            Laya.timer.once(50 * a, this, function () {
              let a = Laya.Pool.getItemByClass("goldImage", Laya.Image);
              (a.source = Laya.loader.getRes(t)),
                (a.anchorX = 0.5),
                (a.anchorY = 0.5),
                a.size(35, 35),
                a.pos(e.x, e.y, !0),
                (a.zOrder = 1e3),
                Laya.stage.addChild(a),
                Laya.Tween.to(
                  a,
                  {
                    x: e.x + w.getIntRandom(-100, 100),
                    y: e.y + w.getIntRandom(-100, 100),
                  },
                  400,
                  null,
                  Laya.Handler.create(
                    this,
                    function (t) {
                      t.removeSelf(),
                        Laya.Pool.recover("goldImage", t),
                        n && n.run();
                    },
                    [a]
                  )
                );
            });
        let u = new Laya.Label();
        (u.text = "-" + a),
          (u.anchorX = u.anchorY = 0.5),
          (u.fontSize = 45),
          u.pos(e.x, e.y),
          (u.zOrder = 1001),
          (u.color = "#f8f3d3"),
          (u.stroke = 3),
          (u.strokeColor = "#000000"),
          Laya.stage.addChild(u),
          Laya.Tween.to(
            u,
            { x: e.x, y: e.y - 100 },
            500,
            null,
            Laya.Handler.create(
              this,
              function (t) {
                t.removeSelf(), t.destroy();
              },
              [u]
            )
          );
      }
      static propQEffect(t) {
        let e = t.scaleX;
        t.scaleY;
        new S(
          [
            {
              t: "to",
              target: t,
              props: { scaleX: 1.25 * e, scaleY: 0.75 * e },
              duration: 50,
              ease: null,
            },
            {
              t: "to",
              target: t,
              props: { scaleX: 0.75 * e, scaleY: 1.25 * e },
              duration: 50,
              ease: null,
            },
          ],
          !0
        ).run();
      }
      static getBezierPoint(t, e, a, n) {
        let u = 1 - t;
        return {
          x: u * u * e.x + 2 * t * u * a.x + t * t * n.x,
          y: u * u * e.y + 2 * t * u * a.y + t * t * n.y,
        };
      }
      static glowBreath(t, e) {
        if (!t.scene) return void console.log("该控件无所属场景!!!");
        e
          ? (!e.color && (e.color = "#ffffff"),
            !e.blur && (e.blur = 1),
            !e.offX && (e.offX = 0),
            !e.offY && (e.offY = 0))
          : (e = { color: "#fffffff", blur: 1 });
        let a = 0,
          n = e.blur,
          u = !0;
        t.scene.timer.loop(100, t.scene, () => {
          if (u) {
            if ((a++, a > n)) return void (u = !1);
          } else if ((a--, a < 0)) return void (u = !0);
          (t.filters = []),
            (t.filters = [new Laya.GlowFilter(e.color, a, e.offX, e.offY)]);
        });
      }
      static shakeCamrea(t, e = 10) {
        if (!t) return;
        let a = t.viewport,
          n = void 0;
        t.__mViewportTween && t.__mViewportTween instanceof Laya.Tween
          ? ((n = t.__mViewportTween), n.complete(), n.clear())
          : ((n = new Laya.Tween()), (t.__mViewportTween = n));
        let u = new Laya.Point(a.x, a.y);
        n.to(
          a,
          {
            update: new Laya.Handler(this, () => {
              let n = -e + 2 * e * Math.random(),
                m = -e + 2 * e * Math.random();
              (a.x = u.x + n), (a.y = u.y + m), (t.viewport = a);
            }),
          },
          200,
          null,
          Laya.Handler.create(this, () => {
            (a.x = u.x), (a.y = u.y), (t.viewport = a);
          })
        ),
          t.once(Laya.Event.REMOVED, null, () => {
            n.clear(), delete t.__mViewportTween;
          });
      }
      static stopShakeCamrea(t) {
        if (!t) return;
        let e = void 0;
        t.__mViewportTween &&
          t.__mViewportTween instanceof Laya.Tween &&
          ((e = t.__mViewportTween),
          e.complete(),
          e.clear(),
          delete t.__mViewportTween);
      }
    }
    class tt {
      static getSceneUrl(t) {
        return "scenes/" + w.pathInfo(t).filename + ".scene";
      }
      static destroy(t, e) {
        if (t && ((t.autoDestroyAtClosed = !0), t.close("closeByDestroy"), e)) {
          let e = t,
            a = e.__loadedResMap;
          if (a) {
            for (const t of a) t.destroyed || t._removeReference();
            e.__loadedResMap = void 0;
          }
          Laya.Scene.gc();
        }
      }
      static uiChanged(t, e) {
        if (e) {
          if (this.uiStack[this.uiStack.length - 1] == t) {
            t.actived();
            let e = this.uiStack[this.uiStack.length - 2];
            e && e.deactived();
          } else t.deactived();
        } else if (t) {
          if (this.uiStack[this.uiStack.length - 1] == t) {
            this.uiStack.pop(), t.deactived();
            let e = this.uiStack[this.uiStack.length - 1];
            e && e.actived();
          } else {
            let e = this.uiStack.indexOf(t);
            -1 != e && (this.uiStack.splice(e, 1), t.deactived());
          }
        }
      }
      static processRes(t) {
        Laya.loader.clearRes3d && Laya.loader.clearRes3d();
        let e = [],
          a = [];
        for (const n of t)
          -1 != ["ls", "lh"].indexOf(Laya.Utils.getFileExtension(n))
            ? (Laya.loader.setGroup(n, "3DRES_GROUP"), e.push(n))
            : a.push(n);
        return [e, a];
      }
      static changeScene(t, e) {
        if (this.cur_url_module == t) return;
        this.cur_url_module = t;
        let a,
          n = tt;
        e &&
          ((a = e.userArgs),
          null != e.from && (a ? a.unshift(e.from) : (a = [e.from]))),
          (a = a || []),
          (Laya.MouseManager.enabled = !1);
        let listener = function (t) {
          for (const t of n.uiStack)
            t instanceof R && ((t.isShowEffect = !1), tt.closePanel(t));
          let u = e && e.effectFunc;
          u
            ? (t.open(!1),
              u.call(
                n,
                n.curScene,
                () => {
                  n.curScene.exit();
                },
                t,
                () => {
                  (Laya.MouseManager.enabled = !0),
                    (n.cur_url_module = void 0),
                    n.uiStack.push(t),
                    t.enter(a),
                    n.uiChanged(n.curScene, !1),
                    n.uiChanged(t, !0),
                    n.destroy(n.curScene, !0),
                    (n.curScene = t);
                }
              ))
            : (n.curScene && n.curScene.exit(),
              (Laya.MouseManager.enabled = !0),
              (n.cur_url_module = void 0),
              n.uiChanged(n.curScene, !1),
              t.open(!0),
              n.uiStack.push(t),
              t.enter(a),
              n.uiChanged(t, !0),
              n.destroy(n.curScene, !0),
              (n.curScene = t)),
            Laya.ClassUtils.getRegClass("Sdk").instance.sendEvent("面板", {
              打开: t.getModuleUrlName(),
            });
        };
        if ("string" == typeof t) {
          let e = t;
          (e = this.getSceneUrl(e)),
            B.load(e, Laya.Handler.create(n, listener));
        } else {
          let e = t,
            u = 1,
            m = new e(...a),
            f = e.getRes();
          if (f && f.length > 0) {
            let [t, e] = this.processRes(f);
            t.length > 0 &&
              (u++,
              Laya.loader.create(
                t,
                Laya.Handler.create(n, () => {
                  u--, 0 == u && listener(m);
                })
              )),
              e.length > 0 &&
                (u++,
                Laya.loader.load(
                  e,
                  Laya.Handler.create(n, () => {
                    for (const t of e) {
                      let e = Laya.loader.getRes(t);
                      if (e && 0 == e._referenceCount) {
                        e._addReference();
                        let t = m;
                        t.__loadedResMap || (t.__loadedResMap = []),
                          t.__loadedResMap.push(e);
                      }
                    }
                    u--, 0 == u && listener(m);
                  })
                ));
          }
          m.once("onViewCreated", n, () => {
            u--, 0 == u && listener(m);
          });
        }
      }
      static changeView(e, a) {
        let n,
          u = tt;
        a &&
          ((n = a.userArgs),
          null != a.from && (n ? n.unshift(a.from) : (n = [a.from]))),
          (n = n || []),
          (Laya.MouseManager.enabled = !1);
        let listener = function (e) {
          let m = a && a.effectFunc;
          u.curScene.pushView(e);
          let f = u.curScene.curView;
          m
            ? ((e.visible = !1),
              e.once(p.E_UI_ADAPTED, this, () => {
                (e.visible = !0),
                  m.call(
                    u,
                    f,
                    () => {
                      f && f.exit();
                    },
                    e,
                    () => {
                      (Laya.MouseManager.enabled = !0),
                        u.uiStack.push(e),
                        e.enter(n),
                        u.uiChanged(f, !1),
                        u.uiChanged(e, !0),
                        u.destroy(f),
                        (u.curScene.curView = e);
                    }
                  );
              }))
            : (f && f.exit(),
              (Laya.MouseManager.enabled = !0),
              u.uiStack.push(e),
              e.enter(n),
              u.uiChanged(f, !1),
              u.uiChanged(e, !0),
              u.destroy(f),
              (u.curScene.curView = e));
          let y = w.getModule(e);
          A.instance.event(p.E_PANEL_OPENCLOSE, {
            code: t.BaseCode.VIEW_OPEN,
            name: tt.getModuleName(y),
            gid: e.getGID(),
          });
        };
        if ("string" == typeof e) {
          let t = e;
          (t = this.getSceneUrl(t)),
            V.load(t, Laya.Handler.create(u, listener));
        } else {
          let t = e,
            a = t.getRes(),
            m = 1,
            f = new t(...n);
          a &&
            a.length > 0 &&
            (m++,
            Laya.loader.load(
              a,
              Laya.Handler.create(u, () => {
                m--, 0 == m && listener(f);
              })
            )),
            f.once("onViewCreated", u, () => {
              m--, 0 == m && listener(f);
            });
        }
      }
      static pushView(e, a) {
        let n,
          u = tt;
        a &&
          ((n = a.userArgs),
          null != a.from && (n ? n.unshift(a.from) : (n = [a.from]))),
          (n = n || []),
          (Laya.MouseManager.enabled = !1);
        let listener = function (e) {
          let m = a && a.effectFunc;
          u.curScene.pushView(e);
          let f = u.curScene.curView;
          m
            ? ((e.visible = !1),
              e.once(p.E_UI_ADAPTED, this, () => {
                (e.visible = !0),
                  m.call(
                    u,
                    f,
                    () => {
                      f && f.exit();
                    },
                    e,
                    () => {
                      (Laya.MouseManager.enabled = !0),
                        u.uiStack.push(e),
                        e.enter(n),
                        u.uiChanged(e, !0),
                        f && (f.visible = !1),
                        (u.curScene.curView = e);
                    }
                  );
              }))
            : (f && (f.exit(), (f.visible = !1)),
              (Laya.MouseManager.enabled = !0),
              u.uiStack.push(e),
              e.enter(n),
              u.uiChanged(e, !0),
              (u.curScene.curView = e));
          let y = w.getModule(e);
          A.instance.event(p.E_PANEL_OPENCLOSE, {
            code: t.BaseCode.VIEW_OPEN,
            name: tt.getModuleName(y),
            gid: e.getGID(),
          }),
            Laya.ClassUtils.getRegClass("Sdk").instance.sendEvent("面板", {
              打开: e.getModuleUrlName(),
            });
        };
        if ("string" == typeof e) {
          let t = e;
          (t = this.getSceneUrl(t)),
            V.load(t, Laya.Handler.create(u, listener));
        } else {
          let t = e,
            a = t.getRes(),
            m = 1,
            f = new t(...n);
          if (a && a.length > 0) {
            let [t, e] = this.processRes(a);
            t.length > 0 &&
              (m++,
              Laya.loader.create(
                t,
                Laya.Handler.create(u, () => {
                  m--, 0 == m && listener(f);
                })
              )),
              e.length > 0 &&
                (m++,
                Laya.loader.load(
                  e,
                  Laya.Handler.create(u, () => {
                    m--, 0 == m && listener(f);
                  })
                ));
          }
          f.once("onViewCreated", u, () => {
            m--, 0 == m && listener(f);
          });
        }
      }
      static popView(e) {
        let a,
          n = e && e.effectFunc;
        e &&
          ((a = e.userArgs),
          null != e.from && (a ? a.unshift(e.from) : (a = [e.from]))),
          (a = a || []);
        let u = this.curScene.lastView,
          m = this.curScene.curView;
        if (!m) return;
        let f = w.getModule(m);
        (Laya.MouseManager.enabled = !1),
          n
            ? n.call(
                this,
                m,
                () => {
                  m.exit();
                },
                u,
                () => {
                  (Laya.MouseManager.enabled = !0),
                    u && (u.enter(a), (u.visible = !0)),
                    this.uiChanged(m, !1),
                    (this.curScene.curView = u),
                    this.curScene.popView(),
                    this.destroy(m);
                }
              )
            : (m && m.exit(),
              (Laya.MouseManager.enabled = !0),
              u && (u.enter(a), (u.visible = !0)),
              this.uiChanged(m, !1),
              (this.curScene.curView = u),
              this.curScene.popView(),
              this.destroy(m)),
          A.instance.event(p.E_PANEL_OPENCLOSE, {
            code: t.BaseCode.VIEW_CLOSE,
            name: tt.getModuleName(f),
            gid: m.getGID(),
          });
      }
      static getModuleByName(t) {
        return Laya.ClassUtils.getRegClass(t);
      }
      static getModuleName(t) {
        let e = Laya.ClassUtils._classMap;
        for (const a in e) if (e.hasOwnProperty(a) && e[a] == t) return a;
      }
      static openPanel(e, a) {
        let n,
          u = tt;
        a &&
          ((n = a.userArgs),
          null != a.from && (n ? n.unshift(a.from) : (n = [a.from]))),
          (n = n || []),
          (Laya.MouseManager.enabled = !1);
        let listener = function (e) {
          let m = a && a.effectFunc;
          if (m)
            u.uiStack.push(e),
              e.open(!1, n),
              u.uiChanged(e, !0),
              m.call(u, null, null, e, () => {
                Laya.MouseManager.enabled = !0;
              });
          else {
            let t = a && a.closeOther;
            null == t && (t = !0),
              (Laya.MouseManager.enabled = !0),
              u.uiStack.push(e),
              e.open(t, n),
              u.uiChanged(e, !0);
          }
          let f = w.getModule(e);
          A.instance.event(p.E_PANEL_OPENCLOSE, {
            code: t.BaseCode.PANEL_OPEN,
            name: tt.getModuleName(f),
            gid: e.getGID(),
          }),
            Laya.ClassUtils.getRegClass("Sdk").instance.sendEvent("面板", {
              打开: e.getModuleUrlName(),
            });
        };
        if ("string" == typeof e) {
          let t = e;
          (t = this.getSceneUrl(t)),
            Laya.Dialog.load(t, Laya.Handler.create(this, listener));
        } else if (a && a.isInstance) listener(e);
        else {
          let t = e,
            a = t.getRes(),
            m = new t(...n),
            f = 1;
          !m.url && (f = 0),
            a &&
              a.length > 0 &&
              (f++,
              Laya.loader.load(
                a,
                Laya.Handler.create(u, () => {
                  f--, 0 == f && listener(m);
                })
              )),
            m.once("onViewCreated", u, () => {
              f--, 0 == f && listener(m);
            });
        }
      }
      static closePanel(e, a) {
        let n = tt,
          u = w.getModule(e),
          m = a && a.effectFunc,
          f = a && a.autoDestroy;
        null == f && (f = !0);
        let y = e.getGID();
        e.once(Laya.Event.REMOVED, this, () => {
          e && (e.mouseEnabled = !0),
            A.instance.event(p.E_PANEL_OPENCLOSE, {
              code: t.BaseCode.PANEL_CLOSE,
              name: tt.getModuleName(u),
              gid: y,
            });
        }),
          m
            ? ((Laya.MouseManager.enabled = !1),
              m.call(n, e, () => {
                (Laya.MouseManager.enabled = !0),
                  (e.autoDestroyAtClosed = f),
                  (e.isShowEffect = !1),
                  e.close("closePanel"),
                  n.uiChanged(e, !1);
              }))
            : ((e.autoDestroyAtClosed = f),
              n.uiChanged(e, !1),
              e.close("closePanel"),
              e.isShowEffect && (e.mouseEnabled = !1));
      }
      static getCurScene() {
        return this.curScene;
      }
      static getCurSceneRgeName() {
        let t = w.getModule(this.curScene);
        if (t) return this.getModuleName(t);
      }
      static getCurViewRgeName() {
        let t = w.getModule(this.curScene.curView);
        if (t) return this.getModuleName(t);
      }
      static getCurDialogRegName() {
        let t = Laya.Dialog.manager,
          e = t.getChildAt(t.numChildren - 1);
        if (e) return this.getModuleName(w.getModule(e));
      }
      static getCurUIRegName(t = 1) {
        let e = this.uiStack[this.uiStack.length - t];
        if (e) return this.getModuleName(w.getModule(e));
      }
      static isInUIStack(t) {
        return -1 != this.uiStack.indexOf(t);
      }
    }
    (tt.uiStack = []),
      (tt.EF_FADE_OUT_BLACK = function (t, e, a, n, u) {
        (n.visible = !1),
          $.shadeScreen(
            "#000000",
            t,
            1,
            Laya.Handler.create(this, () => {
              (n.visible = !0), a && a(), u && u();
            })
          );
      }),
      (tt.EF_FADE_OUT = function (t, e, a, n, u) {
        (n.visible = !0),
          Laya.Tween.to(
            e,
            { alpha: 0 },
            t,
            null,
            Laya.Handler.create(this, () => {
              (e.visible = !1), a && a(), u && u();
            })
          ),
          (e.alpha = 1),
          (e.zOrder = 1);
      }),
      (tt.EF_FADE_INOUT = function (t, e, a, n, u) {
        (e.alpha = 1),
          (n.alpha = 0),
          Laya.Tween.to(e, { alpha: 0 }, t, null),
          Laya.Tween.to(
            n,
            { alpha: 1 },
            t,
            null,
            Laya.Handler.create(this, () => {
              a && a(), u && u();
            })
          );
      }),
      (tt.EF_FADE_IN_OUT = function (t, e, a, n, u) {
        (e.alpha = 1),
          (n.alpha = 0),
          Laya.Tween.to(
            e,
            { alpha: 0 },
            0.5 * t,
            null,
            Laya.Handler.create(this, () => {
              Laya.Tween.to(
                n,
                { alpha: 1 },
                0.5 * t,
                null,
                Laya.Handler.create(this, () => {
                  a && a(), u && u();
                })
              );
            })
          );
      }),
      (tt.EF_QSCALE_IN = function (t, e, a, n) {
        w.resetAnchor(a, 0.5, 0.5),
          Laya.Tween.from(
            a,
            { scaleX: 0, scaleY: 0 },
            300,
            Laya.Ease.backOut,
            Laya.Handler.create(this, () => {
              e && e(), n && n();
            })
          );
      }),
      (tt.EF_QSCALE_FADE_IN = function (t, e, a, n) {
        (a.alpha = 0),
          w.resetAnchor(a, 0.5, 0.5),
          Laya.Tween.from(
            a,
            { scaleX: 0, scaleY: 0 },
            300,
            Laya.Ease.backOut,
            Laya.Handler.create(this, () => {
              e && e(), n && n();
            })
          ),
          Laya.Tween.to(a, { alpha: 1 }, 400, null, null);
      }),
      (tt.EF_QSCALE_OUT = function (t, e, a, n) {
        Laya.Tween.to(
          t,
          { scaleX: 0, scaleY: 0 },
          300,
          Laya.Ease.strongOut,
          Laya.Handler.create(
            t,
            () => {
              e && e(), n && n();
            },
            [t]
          )
        );
      }),
      (tt.EF_PANEL = function (t, e, a, n, u) {
        (n.alpha = 0),
          tt.openPanel(t, {
            from: "",
            userArgs: [
              n,
              Laya.Handler.create(this, () => {
                a && a(), u && u();
              }),
            ],
          });
      }),
      Laya.ClassUtils.regClass("SceneManager", tt),
      window.Config3D ||
        (window.Config3D = class {
          constructor() {}
        });
    const et = {
      enableShadow: !1,
      enableMultiLight: !1,
      enableAntialias: !0,
      enableRetinalCanvas: !0,
      enableHDR: !1,
    };
    class it extends k {
      constructor() {
        super(), (this._initialized = !1);
      }
      init(...t) {
        0 == this._initialized && this.onInitOnce.apply(this, t),
          this.onInit(...t),
          (this._initialized = !0);
      }
      get initialized() {
        return this._initialized;
      }
      onInit(...t) {}
      onInitOnce(...t) {}
    }
    class st {
      constructor(t) {
        (this.autoSave = !0),
          st.singList.includes(t)
            ? console.error("存储key重复！")
            : ((this.key = t), st.singList.push(t));
      }
      init() {
        let t = this.loadData();
        if (t)
          for (const e in this)
            if (this.hasOwnProperty(e)) {
              let a = t[e];
              null != a && "" !== a && (this[e] = a);
            }
      }
      loadData() {
        let t = Laya.LocalStorage.getItem(this.key);
        if (t) {
          if (t instanceof Object) return t;
          try {
            t = JSON.parse(t);
          } catch (e) {
            console.log("LocalStorage.getItem error: ", this.key, t);
          }
        }
        return t;
      }
      dirty(t) {
        this.autoSave && Laya.CallLater.I.callLater(this, this._save);
      }
      save() {
        Laya.CallLater.I.callLater(this, this._save);
      }
      _save() {
        let t = ["$_GID", "_autoSave", "_key"],
          e = JSON.stringify(this, (e, a) => {
            for (const a of t) if (e == a) return;
            return a;
          });
        Laya.LocalStorage.setItem(this.key, e);
      }
      clear() {
        Laya.LocalStorage.removeItem(this.key);
      }
    }
    var at, nt, ot;
    (st.singList = []),
      ((at = t.BTStatus || (t.BTStatus = {}))[(at.SUCCESS = 1)] = "SUCCESS"),
      (at[(at.FAILURE = 2)] = "FAILURE"),
      (at[(at.RUNNING = 3)] = "RUNNING"),
      ((nt = t.EPolicy || (t.EPolicy = {}))[(nt.RequireOne = 0)] =
        "RequireOne"),
      (nt[(nt.RequireAll = 1)] = "RequireAll"),
      ((ot = t.BTCategory || (t.BTCategory = {})).COMPOSITE = "composite"),
      (ot.DECORATOR = "decorator"),
      (ot.ACTION = "action"),
      (ot.CONDITION = "condition");
    const rt = {},
      ht = {},
      lt = {},
      ct = {};
    class dt {
      constructor({
        category: t = "",
        name: e = "",
        title: a = "",
        description: n = "",
        properties: u,
      }) {
        (this.id = w.createUUID()),
          (this.category = t),
          (this.name = e),
          (this.title = a || e),
          (this.description = n),
          (this.properties = u || {});
      }
      static register(e, a) {
        let n = this;
        switch (((n.bt_category = a), (n.bt_name = e), a)) {
          case t.BTCategory.COMPOSITE:
            ht[e] = n;
            break;
          case t.BTCategory.DECORATOR:
            rt[e] = n;
            break;
          case t.BTCategory.ACTION:
            lt[e] = n;
            break;
          case t.BTCategory.CONDITION:
            ct[e] = n;
            break;
          default:
            throw Error("not found node category !");
        }
      }
      _execute(e) {
        this._enter(e),
          e.blackboard.get("isOpen", e.tree.id, this.id) || this._open(e);
        let a = this._tick(e);
        return a !== t.BTStatus.RUNNING && this._close(e), this._exit(e), a;
      }
      _enter(t) {
        t._enterNode(this), this.enter(t);
      }
      _open(t) {
        t._openNode(this),
          t.blackboard.set("isOpen", !0, t.tree.id, this.id),
          this.open(t);
      }
      _tick(t) {
        return t._tickNode(this), this.tick(t);
      }
      _close(t) {
        t._closeNode(this),
          t.blackboard.set("isOpen", !1, t.tree.id, this.id),
          this.close(t);
      }
      _exit(t) {
        t._exitNode(this), this.exit(t);
      }
      enter(t) {}
      open(t) {}
      tick(t) {
        throw Error("BTBaseNode tick not implement !");
      }
      close(t) {}
      exit(t) {}
      bindout(...t) {
        return (this.out = t), this;
      }
      output(t, e) {
        if (this.out) for (const a of this.out) a.properties[t] = e;
      }
      takeOut(t) {
        let e = this.properties[t];
        return (this.properties[t] = void 0), e;
      }
    }
    class ut extends dt {
      constructor({ name: e = "Action", title: a = "", properties: n }) {
        super({
          category: t.BTCategory.ACTION,
          name: e,
          title: a,
          properties: n,
        });
      }
    }
    class mt extends dt {
      constructor({
        children: e = [],
        name: a = "Composite",
        title: n = "",
        properties: u,
      }) {
        super({
          category: t.BTCategory.COMPOSITE,
          name: a,
          title: n,
          properties: u,
        }),
          (this.children = e.slice(0));
      }
      add(t) {
        this.children.push(t);
      }
    }
    class ft extends dt {
      constructor({
        child: e = null,
        name: a = "Decorator",
        title: n = "",
        properties: u,
      } = {}) {
        super({
          category: t.BTCategory.DECORATOR,
          name: a,
          title: n,
          properties: u,
        }),
          (this.child = e);
      }
      add(t) {
        this.child = t;
      }
    }
    class pt {
      constructor() {
        (this.tree = null),
          (this.debug = null),
          (this.target = null),
          (this.blackboard = null),
          (this._openNodes = []),
          (this._nodeCount = 0);
      }
      _enterNode(t) {
        this._nodeCount++, this._openNodes.push(t);
      }
      _openNode(t) {}
      _tickNode(t) {}
      _closeNode(t) {
        this._openNodes.pop();
      }
      _exitNode(t) {}
    }
    class yt extends ut {
      constructor({ duration: t = 0 } = {}) {
        super({ name: "Continuous" }), (this.duration = t);
      }
      tick(e) {
        let a = new Date().getTime(),
          n = e.blackboard.get("tick_frame", e.tree.id);
        return (
          null == this.curFrame && ((this.curFrame = n), (this.startTime = a)),
          n - this.curFrame > 1 && (this.startTime = a),
          (this.curFrame = n),
          a - this.startTime >= this.duration
            ? t.BTStatus.SUCCESS
            : t.BTStatus.FAILURE
        );
      }
    }
    yt.register("BTContinuous", t.BTCategory.ACTION);
    class gt extends ut {
      constructor() {
        super({ name: "Error" });
      }
      tick(t) {
        throw Error("BTError !");
      }
    }
    gt.register("BTError", t.BTCategory.ACTION);
    class _t extends ut {
      constructor() {
        super({ name: "Failer" });
      }
      tick(e) {
        return t.BTStatus.FAILURE;
      }
    }
    _t.register("BTFailer", t.BTCategory.ACTION);
    class xt extends ut {
      constructor() {
        super({ name: "Runner" });
      }
      tick(e) {
        return t.BTStatus.RUNNING;
      }
    }
    xt.register("BTRunner", t.BTCategory.ACTION);
    class bt extends ut {
      constructor() {
        super({ name: "Succeeder" });
      }
      tick(e) {
        return t.BTStatus.SUCCESS;
      }
    }
    bt.register("BTSucceeder", t.BTCategory.ACTION);
    class vt extends ut {
      constructor({ milliseconds: t = 0 } = {}) {
        super({
          name: "Wait",
          title: "Wait <milliseconds>ms",
          properties: { milliseconds: 0 },
        }),
          (this.endTime = t);
      }
      open(t) {
        let e = new Date().getTime();
        t.blackboard.set("startTime", e, t.tree.id, this.id);
      }
      tick(e) {
        return new Date().getTime() -
          e.blackboard.get("startTime", e.tree.id, this.id) >
          this.endTime
          ? t.BTStatus.SUCCESS
          : t.BTStatus.RUNNING;
      }
    }
    vt.register("BTWait", t.BTCategory.ACTION);
    class Lt extends ut {
      constructor({ condition: t = null, child: e = null } = {}) {
        super({ name: "WaitUtil", title: "WaitUtil <condition>" }),
          (this.cdt = t),
          (this.child = e);
      }
      tick(e) {
        if (!this.cdt) throw Error("must have condition node !");
        let a = this.cdt._execute(e);
        return a == t.BTStatus.SUCCESS
          ? a
          : (this.child && this.child._execute(e), t.BTStatus.RUNNING);
      }
    }
    Lt.register("BTWaitUtil", t.BTCategory.ACTION);
    class wt extends mt {
      constructor({
        children: e = [],
        successPolicy: a = t.EPolicy.RequireOne,
      } = {}) {
        super({ name: "Parallel", children: e }), (this.successPolicy = a);
      }
      tickRunning(e, a) {
        let n = [];
        if (void 0 !== a && a.length > 0) {
          let u = a.length;
          for (; u--; ) {
            let m = a[u],
              f = this.children[m]._execute(e);
            (n[m] = f), f != t.BTStatus.RUNNING && a.splice(u, 1);
          }
          0 == a.length &&
            e.blackboard.set("runningChild", void 0, e.tree.id, this.id);
        }
        return n;
      }
      tick(e) {
        let a,
          n = e.blackboard.get("runningChild", e.tree.id, this.id);
        n && (a = n.splice(0));
        let u = this.tickRunning(e, n);
        if (u.length > 0 && u.includes(t.BTStatus.RUNNING))
          return t.BTStatus.RUNNING;
        let m = 0,
          f = this.children.length;
        for (let f = 0; f < this.children.length; f++) {
          if (a && a.includes(f)) {
            u[f] == t.BTStatus.SUCCESS && m++;
            continue;
          }
          let p = this.children[f]._execute(e);
          p == t.BTStatus.RUNNING && (n ? n.push(f) : (n = [f])),
            p == t.BTStatus.SUCCESS && m++;
        }
        return (this.successPolicy == t.EPolicy.RequireAll && m == f) ||
          (this.successPolicy == t.EPolicy.RequireOne && m > 0)
          ? t.BTStatus.SUCCESS
          : t.BTStatus.FAILURE;
      }
    }
    wt.register("BTParallel", t.BTCategory.COMPOSITE);
    class St extends mt {
      constructor({
        children: e = [],
        continuePolicy: a = t.BTStatus.FAILURE,
        successPolicy: n = t.EPolicy.RequireOne,
      } = {}) {
        super({ name: "Sequence", children: e }),
          (this.continuePolicy = a),
          (this.successPolicy = n);
      }
      open(t) {
        t.blackboard.set("runningChild", 0, t.tree.id, this.id);
      }
      tick(e) {
        let a = 0;
        for (
          let n = e.blackboard.get("runningChild", e.tree.id, this.id);
          n < this.children.length;
          n++
        ) {
          let u = this.children[n]._execute(e);
          if (u === t.BTStatus.RUNNING)
            return e.blackboard.set("runningChild", n, e.tree.id, this.id), u;
          if ((u == t.BTStatus.SUCCESS && a++, u != this.continuePolicy)) break;
        }
        return (this.successPolicy == t.EPolicy.RequireOne && a > 0) ||
          (this.successPolicy == t.EPolicy.RequireAll &&
            a == this.children.length)
          ? t.BTStatus.SUCCESS
          : t.BTStatus.FAILURE;
      }
    }
    St.register("BTSequence", t.BTCategory.COMPOSITE);
    class Mt extends ft {
      constructor({ child: t = null } = {}) {
        super({ child: t, name: "Inverter" });
      }
      tick(e) {
        if (!this.child) throw Error("BTInverter no child !");
        let a = this.child._execute(e);
        return (
          a == t.BTStatus.SUCCESS
            ? (a = t.BTStatus.FAILURE)
            : a == t.BTStatus.FAILURE && (a = t.BTStatus.SUCCESS),
          a
        );
      }
    }
    Mt.register("BTInverter", t.BTCategory.DECORATOR);
    class Ct extends ft {
      constructor({ child: t = null, maxLoop: e = 0 } = {}) {
        if (
          (super({
            child: t,
            name: "Limiter",
            title: "Limit <maxLoop> Activations",
            properties: { maxLoop: 1 },
          }),
          !e)
        )
          throw "maxLoop parameter in Limiter decorator is an obligatory parameter";
        this.maxLoop = e;
      }
      open(t) {
        t.blackboard.set("i", 0, t.tree.id, this.id);
      }
      tick(e) {
        if (!this.child) throw Error("BTLimiter no child !");
        let a = e.blackboard.get("i", e.tree.id, this.id);
        if (a < this.maxLoop) {
          let n = this.child._execute(e);
          return (
            (n != t.BTStatus.SUCCESS && n != t.BTStatus.FAILURE) ||
              e.blackboard.set("i", a + 1, e.tree.id, this.id),
            n
          );
        }
        return t.BTStatus.FAILURE;
      }
    }
    Ct.register("BTLimiter", t.BTCategory.DECORATOR);
    class Nt extends ft {
      constructor({ maxTime: t = 0, child: e = null } = {}) {
        if (
          (super({
            child: e,
            name: "MaxTime",
            title: "Max <maxTime>ms",
            properties: { maxTime: 0 },
          }),
          !t)
        )
          throw "maxTime parameter in MaxTime decorator is an obligatory parameter";
        this.maxTime = t;
      }
      open(t) {
        let e = new Date().getTime();
        t.blackboard.set("startTime", e, t.tree.id, this.id);
      }
      tick(e) {
        if (!this.child) throw Error("BTStatus no child !");
        let a = new Date().getTime(),
          n = e.blackboard.get("startTime", e.tree.id, this.id),
          u = this.child._execute(e);
        return a - n > this.maxTime ? t.BTStatus.FAILURE : u;
      }
    }
    Nt.register("BTMaxTime", t.BTCategory.DECORATOR);
    class Et extends ft {
      constructor({ maxLoop: t = -1, child: e = null } = {}) {
        super({
          child: e,
          name: "RepeatUntilFailure",
          title: "Repeat Until Failure",
          properties: { maxLoop: -1 },
        }),
          (this.maxLoop = t);
      }
      open(t) {
        t.blackboard.set("i", 0, t.tree.id, this.id);
      }
      tick(e) {
        if (!this.child) throw Error("BTRepeatUntilFailure no child !");
        let a = e.blackboard.get("i", e.tree.id, this.id),
          n = t.BTStatus.FAILURE;
        for (
          ;
          (this.maxLoop < 0 || a < this.maxLoop) &&
          ((n = this.child._execute(e)), n == t.BTStatus.SUCCESS);

        )
          a++;
        return (a = e.blackboard.set("i", a, e.tree.id, this.id)), n;
      }
    }
    Et.register("BTRepeatUntilFailure", t.BTCategory.DECORATOR);
    class Tt extends ft {
      constructor({ maxLoop: t = -1, child: e = null } = {}) {
        super({
          child: e,
          name: "RepeatUntilSuccess",
          title: "Repeat Until Success",
          properties: { maxLoop: -1 },
        }),
          (this.maxLoop = t);
      }
      open(t) {
        t.blackboard.set("i", 0, t.tree.id, this.id);
      }
      tick(e) {
        if (!this.child) throw Error("BTRepeatUntilSuccess no child !");
        let a = e.blackboard.get("i", e.tree.id, this.id),
          n = t.BTStatus.FAILURE;
        for (
          ;
          (this.maxLoop < 0 || a < this.maxLoop) &&
          ((n = this.child._execute(e)), n == t.BTStatus.FAILURE);

        )
          a++;
        return (a = e.blackboard.set("i", a, e.tree.id, this.id)), n;
      }
    }
    Tt.register("BTRepeatUntilSuccess", t.BTCategory.DECORATOR);
    class It extends ft {
      constructor({ maxLoop: t = -1, child: e = null } = {}) {
        super({
          child: e,
          name: "Repeater",
          title: "Repeat <maxLoop>x",
          properties: { maxLoop: -1 },
        }),
          (this.maxLoop = t);
      }
      open(t) {
        t.blackboard.set("i", 0, t.tree.id, this.id);
      }
      tick(e) {
        if (!this.child) throw Error("BTRepeater no child !");
        let a = e.blackboard.get("i", e.tree.id, this.id),
          n = t.BTStatus.SUCCESS;
        for (
          ;
          (this.maxLoop < 0 || a < this.maxLoop) &&
          ((n = this.child._execute(e)),
          n == t.BTStatus.SUCCESS || n == t.BTStatus.FAILURE);

        )
          a++;
        return e.blackboard.set("i", a, e.tree.id, this.id), n;
      }
    }
    It.register("BTRepeater", t.BTCategory.DECORATOR);
    class zt extends Laya.BlinnPhongMaterial {
      constructor() {
        super(), zt.initShader(), this.setShaderName("BlendShapeMaterial");
      }
      get blendShapeCount() {
        return this._shaderValues.getInt(zt.BLEND_SHAPE_COUNT);
      }
      set blendShapeCount(t) {
        this._shaderValues.setInt(zt.BLEND_SHAPE_COUNT, t);
      }
      setBlendShapeWeight(t, e) {
        t >= 8 ||
          (this._weights || (this._weights = new Float32Array(8)),
          (this._weights[t] = e),
          this._shaderValues.setBuffer(zt.BLEND_SHAPE_WEIGHT, this._weights));
      }
      clone() {
        var t = new zt();
        return this.cloneTo(t), t;
      }
      static initShader() {
        if (zt.inited) return;
        zt.inited = !0;
        let t = Laya.Shader3D.find("BLINNPHONG").getSubShaderAt(0),
          e = Laya.Shader3D.add("BlendShapeMaterial"),
          a = fx.Utils.clone(t._uniformMap);
        (a.u_BlendShapeCount = Laya.Shader3D.PERIOD_MATERIAL),
          (a.u_BlendShapeWeight = Laya.Shader3D.PERIOD_MATERIAL);
        let n = t._attributeMap;
        (n.a_BlendShape1 = Laya.VertexMesh.MESH_CUSTOME0),
          (n.a_BlendShape2 = Laya.VertexMesh.MESH_CUSTOME1),
          (n.a_BlendShape3 = Laya.VertexMesh.MESH_CUSTOME2),
          (n.a_BlendShape4 = Laya.VertexMesh.MESH_CUSTOME3),
          (n.a_BlendShape5 = Laya.VertexMesh.MESH_WORLDMATRIX_ROW3),
          (n.a_BlendShape6 = Laya.VertexMesh.MESH_WORLDMATRIX_ROW2),
          (n.a_BlendShape7 = Laya.VertexMesh.MESH_WORLDMATRIX_ROW1),
          (n.a_BlendShape8 = Laya.VertexMesh.MESH_WORLDMATRIX_ROW0);
        let u = new Laya.SubShader(n, a);
        e.addSubShader(u);
        u.addShaderPass(
          '\n        #if defined(GL_FRAGMENT_PRECISION_HIGH)// 原来的写法会被我们自己的解析流程处理，而我们的解析是不认内置宏的，导致被删掉，所以改成 if defined 了\n            precision highp float;\n            precision highp int;\n        #else\n            precision mediump float;\n            precision mediump int;\n        #endif\n        #include "Lighting.glsl";\n        #include "LayaUtile.glsl"\n        #include "Shadow.glsl";\n\n\n        attribute vec4 a_Position;\n\n        #ifdef GPU_INSTANCE\n            uniform mat4 u_ViewProjection;\n        #else\n            uniform mat4 u_MvpMatrix;\n        #endif\n\n        #if defined(DIFFUSEMAP)||defined(THICKNESSMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))||(defined(LIGHTMAP)&&defined(UV))\n            attribute vec2 a_Texcoord0;\n            varying vec2 v_Texcoord0;\n        #endif\n\n        #if defined(LIGHTMAP)&&defined(UV1)\n            attribute vec2 a_Texcoord1;\n        #endif\n\n        #ifdef LIGHTMAP\n            uniform vec4 u_LightmapScaleOffset;\n            varying vec2 v_LightMapUV;\n        #endif\n\n        #ifdef COLOR\n            attribute vec4 a_Color;\n            varying vec4 v_Color;\n        #endif\n\n        #ifdef BONE\n            const int c_MaxBoneCount = 24;\n            attribute vec4 a_BoneIndices;\n            attribute vec4 a_BoneWeights;\n            uniform mat4 u_Bones[c_MaxBoneCount];\n        #endif\n\n        attribute vec3 a_Normal;\n        varying vec3 v_Normal; \n\n        #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n            uniform vec3 u_CameraPos;\n            varying vec3 v_ViewDir; \n        #endif\n\n        #if defined(NORMALMAP)\n            attribute vec4 a_Tangent0;\n            varying vec3 v_Tangent;\n            varying vec3 v_Binormal;\n        #endif\n\n        #ifdef GPU_INSTANCE\n            attribute mat4 a_WorldMat;\n        #else\n            uniform mat4 u_WorldMat;\n        #endif\n\n        #if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n            varying vec3 v_PositionWorld;\n        #endif\n\n        #if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\n            varying vec4 v_ShadowCoord;\n        #endif\n\n        #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n            varying vec4 v_SpotShadowCoord;\n        #endif\n\n        uniform vec4 u_TilingOffset;\n\n        attribute vec3 a_BlendShape1;\n        attribute vec3 a_BlendShape2;\n        attribute vec3 a_BlendShape3;\n        attribute vec3 a_BlendShape4;\n        attribute vec3 a_BlendShape5;\n        attribute vec3 a_BlendShape6;\n        attribute vec3 a_BlendShape7;\n        attribute vec3 a_BlendShape8;\n        uniform int u_BlendShapeCount;\n        uniform float u_BlendShapeWeight[8];\n\n        void main()\n        {\n            vec4 aaPosition = a_Position;\n            if (u_BlendShapeCount >= 1) {\n                aaPosition.x = aaPosition.x + a_BlendShape1.x * u_BlendShapeWeight[0];\n                aaPosition.y = aaPosition.y + a_BlendShape1.y * u_BlendShapeWeight[0];\n                aaPosition.z = aaPosition.z + a_BlendShape1.z * u_BlendShapeWeight[0];\n            }\n            if (u_BlendShapeCount >= 2) {\n                aaPosition.x = aaPosition.x + a_BlendShape2.x * u_BlendShapeWeight[1];\n                aaPosition.y = aaPosition.y + a_BlendShape2.y * u_BlendShapeWeight[1];\n                aaPosition.z = aaPosition.z + a_BlendShape2.z * u_BlendShapeWeight[1];\n            }\n            if (u_BlendShapeCount >= 3) {\n                aaPosition.x = aaPosition.x + a_BlendShape3.x * u_BlendShapeWeight[2];\n                aaPosition.y = aaPosition.y + a_BlendShape3.y * u_BlendShapeWeight[2];\n                aaPosition.z = aaPosition.z + a_BlendShape3.z * u_BlendShapeWeight[2];\n            }\n            if (u_BlendShapeCount >= 4) {\n                aaPosition.x = aaPosition.x + a_BlendShape4.x * u_BlendShapeWeight[3];\n                aaPosition.y = aaPosition.y + a_BlendShape4.y * u_BlendShapeWeight[3];\n                aaPosition.z = aaPosition.z + a_BlendShape4.z * u_BlendShapeWeight[3];\n            }\n            if (u_BlendShapeCount >= 5) {\n                aaPosition.x = aaPosition.x + a_BlendShape5.x * u_BlendShapeWeight[4];\n                aaPosition.y = aaPosition.y + a_BlendShape5.y * u_BlendShapeWeight[4];\n                aaPosition.z = aaPosition.z + a_BlendShape5.z * u_BlendShapeWeight[4];\n            }\n            if (u_BlendShapeCount >= 6) {\n                aaPosition.x = aaPosition.x + a_BlendShape6.x * u_BlendShapeWeight[5];\n                aaPosition.y = aaPosition.y + a_BlendShape6.y * u_BlendShapeWeight[5];\n                aaPosition.z = aaPosition.z + a_BlendShape6.z * u_BlendShapeWeight[5];\n            }\n \n\n            vec4 position;\n            #ifdef BONE\n                mat4 skinTransform;\n                #ifdef SIMPLEBONE\n                    float currentPixelPos;\n                    #ifdef GPU_INSTANCE\n                        currentPixelPos = a_SimpleTextureParams.x+a_SimpleTextureParams.y;\n                    #else\n                        currentPixelPos = u_SimpleAnimatorParams.x+u_SimpleAnimatorParams.y;\n                    #endif\n                    float offset = 1.0/u_SimpleAnimatorTextureSize;\n                    skinTransform =  loadMatFromTexture(currentPixelPos,int(a_BoneIndices.x),offset) * a_BoneWeights.x;\n                    skinTransform += loadMatFromTexture(currentPixelPos,int(a_BoneIndices.y),offset) * a_BoneWeights.y;\n                    skinTransform += loadMatFromTexture(currentPixelPos,int(a_BoneIndices.z),offset) * a_BoneWeights.z;\n                    skinTransform += loadMatFromTexture(currentPixelPos,int(a_BoneIndices.w),offset) * a_BoneWeights.w;\n                #else\n                    skinTransform =  u_Bones[int(a_BoneIndices.x)] * a_BoneWeights.x;\n                    skinTransform += u_Bones[int(a_BoneIndices.y)] * a_BoneWeights.y;\n                    skinTransform += u_Bones[int(a_BoneIndices.z)] * a_BoneWeights.z;\n                    skinTransform += u_Bones[int(a_BoneIndices.w)] * a_BoneWeights.w;\n                #endif\n                position=skinTransform*aaPosition;\n            #else\n                position=aaPosition;\n            #endif\n\n            \n            mat4 worldMat;\n            #ifdef GPU_INSTANCE\n                worldMat = a_WorldMat;\n            #else\n                worldMat = u_WorldMat;\n            #endif\n\n            #ifdef GPU_INSTANCE\n                gl_Position = u_ViewProjection * worldMat * position;\n            #else\n                gl_Position = u_MvpMatrix * position;\n            #endif\n\n            mat3 worldInvMat;\n            #ifdef BONE\n                worldInvMat=INVERSE_MAT(mat3(worldMat*skinTransform));\n            #else\n                worldInvMat=INVERSE_MAT(mat3(worldMat));\n            #endif  \n            v_Normal=normalize(a_Normal*worldInvMat);\n            #if defined(NORMALMAP)\n                v_Tangent=normalize(a_Tangent0.xyz*worldInvMat);\n                v_Binormal=cross(v_Normal,v_Tangent)*a_Tangent0.w;\n            #endif\n\n            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n                vec3 positionWS=(worldMat*position).xyz;\n                #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                    v_ViewDir = u_CameraPos-positionWS;\n                #endif\n                #if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n                    v_PositionWorld = positionWS;\n                #endif\n            #endif\n\n            #if defined(DIFFUSEMAP)||defined(THICKNESSMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))\n                v_Texcoord0=TransformUV(a_Texcoord0,u_TilingOffset);\n            #endif\n\n            #ifdef LIGHTMAP\n                #ifdef UV1\n                    v_LightMapUV=vec2(a_Texcoord1.x,1.0-a_Texcoord1.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\n                #else\n                    v_LightMapUV=vec2(a_Texcoord0.x,1.0-a_Texcoord0.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\n                #endif \n                v_LightMapUV.y=1.0-v_LightMapUV.y;\n            #endif\n\n            #if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\n                v_Color=a_Color;\n            #endif\n\n            #if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\n                v_ShadowCoord =getShadowCoord(vec4(positionWS,1.0));\n            #endif\n\n            #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                v_SpotShadowCoord = u_SpotViewProjectMatrix*vec4(positionWS,1.0);\n            #endif\n\n            gl_Position=remapGLPositionZ(gl_Position);\n        }\n        ',
          '\n        #if defined(GL_FRAGMENT_PRECISION_HIGH)// 原来的写法会被我们自己的解析流程处理，而我们的解析是不认内置宏的，导致被删掉，所以改成 if defined 了\n            precision highp float;\n            precision highp int;\n        #else\n            precision mediump float;\n            precision mediump int;\n        #endif\n\n\n        #include "Lighting.glsl";\n        #include "Shadow.glsl"\n\n        uniform vec4 u_DiffuseColor;\n\n        #if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\n            varying vec4 v_Color;\n        #endif\n\n        #ifdef ALPHATEST\n            uniform float u_AlphaTestValue;\n        #endif\n\n        #ifdef DIFFUSEMAP\n            uniform sampler2D u_DiffuseTexture;\n        #endif\n\n\n        #if defined(DIFFUSEMAP)||defined(THICKNESSMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))\n            varying vec2 v_Texcoord0;\n        #endif\n\n        #ifdef LIGHTMAP\n            varying vec2 v_LightMapUV;\n            uniform sampler2D u_LightMap;\n            #ifdef LIGHTMAP_DIRECTIONAL\n                uniform sampler2D u_LightMapDirection;\n            #endif\n        #endif\n\n        varying vec3 v_Normal;\n        #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n            varying vec3 v_ViewDir; \n\n            uniform vec3 u_MaterialSpecular;\n            uniform float u_Shininess;\n\n            #ifdef LEGACYSINGLELIGHTING\n                #ifdef DIRECTIONLIGHT\n                    uniform DirectionLight u_DirectionLight;\n                #endif\n                #ifdef POINTLIGHT\n                    uniform PointLight u_PointLight;\n                #endif\n                #ifdef SPOTLIGHT\n                    uniform SpotLight u_SpotLight;\n                #endif\n            #else\n                uniform mat4 u_View;\n                uniform vec4 u_ProjectionParams;\n                uniform vec4 u_Viewport;\n                uniform int u_DirationLightCount;\n                uniform sampler2D u_LightBuffer;\n                uniform sampler2D u_LightClusterBuffer;\n            #endif\n\n            #ifdef SPECULARMAP \n                uniform sampler2D u_SpecularTexture;\n            #endif\n        #endif\n\n        #ifdef NORMALMAP \n            uniform sampler2D u_NormalTexture;\n            varying vec3 v_Tangent;\n            varying vec3 v_Binormal;\n        #endif\n\n        #ifdef FOG\n            uniform float u_FogStart;\n            uniform float u_FogRange;\n            uniform vec3 u_FogColor;\n        #endif\n\n        #if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n            varying vec3 v_PositionWorld;\n        #endif\n\n\n        #include "GlobalIllumination.glsl";//"GlobalIllumination.glsl use uniform should at front of this\n\n        #if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\n            varying vec4 v_ShadowCoord;\n        #endif\n\n        #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n            varying vec4 v_SpotShadowCoord;\n        #endif\n\n        // uniform float u_Dissolve;\n        // uniform vec3 u_DissolveColor;\n        // uniform sampler2D u_NoiseTexture;\n\n        void main()\n        {\n            vec3 normal;//light and SH maybe use normal\n            #if defined(NORMALMAP)\n                vec3 normalMapSample = texture2D(u_NormalTexture, v_Texcoord0).rgb;\n                normal = normalize(NormalSampleToWorldSpace(normalMapSample, v_Normal, v_Tangent,v_Binormal));\n            #else\n                normal = normalize(v_Normal);\n            #endif\n\n            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                vec3 viewDir= normalize(v_ViewDir);\n            #endif\n\n            LayaGIInput giInput;\n            #ifdef LIGHTMAP\t\n                giInput.lightmapUV=v_LightMapUV;\n            #endif\n            vec3 globalDiffuse=layaGIBase(giInput,1.0,normal);\n            \n            vec4 mainColor=u_DiffuseColor;\n            #ifdef DIFFUSEMAP\n                vec4 difTexColor=texture2D(u_DiffuseTexture, v_Texcoord0);\n                mainColor=mainColor*difTexColor;\n            #endif\n\n            \n            vec3 diffuse = vec3(0.0);\n            vec3 specular= vec3(0.0);\n            vec3 transmissionDiffuse = vec3(0.0);\n            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                vec3 dif,spe,transmis;\n                float transmissionFactor;\n                #ifdef SPECULARMAP\n                    vec3 gloss=texture2D(u_SpecularTexture, v_Texcoord0).rgb;\n                #else\n                    #ifdef DIFFUSEMAP\n                        vec3 gloss=vec3(difTexColor.a);\n                    #else\n                        vec3 gloss=vec3(1.0);\n                    #endif\n                #endif\n                #ifdef THICKNESSMAP\n                    transmissionFactor = texture2D(u_ThinknessTexture, v_Texcoord0).r;\n                #endif\n            #endif\n\n            \n            \n            #ifdef LEGACYSINGLELIGHTING\n                #ifdef DIRECTIONLIGHT\n                    LayaAirBlinnPhongDiectionLight(u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_DirectionLight,transmissionFactor,dif,spe,transmis);\n                    #if defined(CALCULATE_SHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                        #ifdef SHADOW_CASCADE\n                            vec4 shadowCoord = getShadowCoord(vec4(v_PositionWorld,1.0));\n                        #else\n                            vec4 shadowCoord = v_ShadowCoord;\n                        #endif\n                        float shadowAttenuation=sampleShadowmap(shadowCoord);\n                        dif *= shadowAttenuation;\n                        spe *= shadowAttenuation;\n                        transmis *=shadowAttenuation;\n                    #endif\n                    diffuse+=dif;\n                    specular+=spe;\n                    transmissionDiffuse+=transmis;\n                #endif\n            \n                #ifdef POINTLIGHT\n                    LayaAirBlinnPhongPointLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_PointLight,transmissionFactor,dif,spe,transmis);\n                    diffuse+=dif;\n                    specular+=spe;\n                    transmissionDiffuse+=transmis;\n                #endif\n\n                #ifdef SPOTLIGHT\n                    LayaAirBlinnPhongSpotLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_SpotLight,transmissionFactor,dif,spe,transmis);\n                    #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                        vec4 spotShadowcoord = v_SpotShadowCoord;\n                        float spotShadowAttenuation = sampleSpotShadowmap(spotShadowcoord);\n                        dif *= spotShadowAttenuation;\n                        spe *= spotShadowAttenuation;\n                        transmis *=spotShadowAttenuation;\n                    #endif\n                    diffuse+=dif;\n                    specular+=spe;\n                    transmissionDiffuse+=transmis;\n                #endif\n            #else\n                #ifdef DIRECTIONLIGHT\n                    for (int i = 0; i < MAX_LIGHT_COUNT; i++) \n                    {\n                        if(i >= u_DirationLightCount)\n                            break;\n                        DirectionLight directionLight = getDirectionLight(u_LightBuffer,i);\n                        #if defined(CALCULATE_SHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                            if(i == 0)\n                            {\n                                #ifdef SHADOW_CASCADE\n                                    vec4 shadowCoord = getShadowCoord(vec4(v_PositionWorld,1.0));\n                                #else\n                                    vec4 shadowCoord = v_ShadowCoord;\n                                #endif\n                                directionLight.color *= sampleShadowmap(shadowCoord);\n                            }\n                        #endif\n                        LayaAirBlinnPhongDiectionLight(u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,directionLight,transmissionFactor,dif,spe,transmis);\n                        diffuse+=dif;\n                        specular+=spe;\n                        transmissionDiffuse+=transmis;\n                    }\n                #endif\n                #if defined(POINTLIGHT)||defined(SPOTLIGHT)\n                    ivec4 clusterInfo =getClusterInfo(u_LightClusterBuffer,u_View,u_Viewport, v_PositionWorld,gl_FragCoord,u_ProjectionParams);\n                    #ifdef POINTLIGHT\n                        for (int i = 0; i < MAX_LIGHT_COUNT; i++) \n                        {\n                            if(i >= clusterInfo.x)//PointLightCount\n                                break;\n                            PointLight pointLight = getPointLight(u_LightBuffer,u_LightClusterBuffer,clusterInfo,i);\n                            LayaAirBlinnPhongPointLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,pointLight,transmissionFactor,dif,spe,transmis);\n                            diffuse+=dif;\n                            specular+=spe;\n                            transmissionDiffuse+=transmis;\n                        }\n                    #endif\n                    #ifdef SPOTLIGHT\n                        for (int i = 0; i < MAX_LIGHT_COUNT; i++) \n                        {\n                            if(i >= clusterInfo.y)//SpotLightCount\n                                break;\n                            SpotLight spotLight = getSpotLight(u_LightBuffer,u_LightClusterBuffer,clusterInfo,i);\n                            #if defined(CALCULATE_SPOTSHADOWS)//shader中自定义的宏不可用ifdef 必须改成if defined\n                                if(i == 0)\n                                {\n                                    vec4 spotShadowcoord = v_SpotShadowCoord;\n                                    spotLight.color *= sampleSpotShadowmap(spotShadowcoord);\n                                }\n                            #endif\n                            LayaAirBlinnPhongSpotLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,spotLight,transmissionFactor,dif,spe,transmis);\n                            diffuse+=dif;\n                            specular+=spe;\n                            transmissionDiffuse+=transmis;\n                        }\n                    #endif\n                #endif\n            #endif\n\n            gl_FragColor =vec4(mainColor.rgb*(globalDiffuse + diffuse),mainColor.a);\n\n            // float cutout = texture2D(u_NoiseTexture, v_Texcoord0).r;\n            // if (cutout - u_Dissolve < 0.0) {\n            //     gl_FragColor = vec4(u_DissolveColor.rgb, mainColor.a);\n            // }\n\n            #if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\n                gl_FragColor.rgb+=specular;\n            #endif\n\n            #ifdef ENABLETRANSMISSION\n                gl_FragColor.rgb+= transmissionDiffuse;\n            #endif\n            \n            #ifdef FOG\n                float lerpFact=clamp((1.0/gl_FragCoord.w-u_FogStart)/u_FogRange,0.0,1.0);\n                gl_FragColor.rgb=mix(gl_FragColor.rgb,u_FogColor,lerpFact);\n            #endif\n\n            //gl_FragColor.rgb =transmissionDiffuse;\n        }\n        '
        ).renderState.cull = Laya.RenderState.CULL_BACK;
      }
    }
    (zt.BLEND_SHAPE_COUNT =
      Laya.Shader3D.propertyNameToID("u_BlendShapeCount")),
      (zt.BLEND_SHAPE_WEIGHT =
        Laya.Shader3D.propertyNameToID("u_BlendShapeWeight"));
    class Pt extends Laya.Mesh {
      getNewVertexDeclaration(t, e) {
        if (!Pt._vertexDeclaration) {
          let a = [];
          for (let e = 0; e < t.vertexElementCount; ++e) {
            let n = t.getVertexElementByIndex(e);
            a.push(n);
          }
          let n = t.vertexStride,
            u = [
              Laya.VertexMesh.MESH_CUSTOME0,
              Laya.VertexMesh.MESH_CUSTOME1,
              Laya.VertexMesh.MESH_CUSTOME2,
              Laya.VertexMesh.MESH_CUSTOME3,
              Laya.VertexMesh.MESH_WORLDMATRIX_ROW3,
              Laya.VertexMesh.MESH_WORLDMATRIX_ROW2,
              Laya.VertexMesh.MESH_WORLDMATRIX_ROW1,
              Laya.VertexMesh.MESH_WORLDMATRIX_ROW0,
            ];
          e = Math.min(e, u.length);
          for (let t = 0; t < e; ++t) {
            let e = new Laya.VertexElement(
              n,
              Laya.VertexElementFormat.Vector3,
              u[t]
            );
            (n += 12), a.push(e);
          }
          let m = new Laya.VertexDeclaration(n, a);
          Pt._vertexDeclaration = m;
        }
        return Pt._vertexDeclaration;
      }
      createNewVertexBuffer(t, e) {
        let a = t._vertexBuffer,
          n = a.getFloat32Data(),
          u = a.vertexDeclaration.vertexStride,
          m = this.getNewVertexDeclaration(a.vertexDeclaration, e.length),
          f = m.vertexStride,
          p = t.vertexCount,
          y = new ArrayBuffer(f * p),
          g = new Float32Array(y),
          _ = new Uint8Array(y);
        for (var x = 0; x < p; x++) {
          var b,
            v = x * u;
          let t,
            a,
            p = x * f;
          for (var w = 0; w < m.vertexElementCount; w++) {
            switch (m.getVertexElementByIndex(w).elementUsage) {
              case Laya.VertexMesh.MESH_POSITION0:
              case Laya.VertexMesh.MESH_NORMAL0:
                (b = v / 4),
                  (t = p / 4),
                  (g[t] = n[b]),
                  (g[t + 1] = n[b + 1]),
                  (g[t + 2] = n[b + 2]),
                  (v += 12),
                  (p += 12);
                break;
              case Laya.VertexMesh.MESH_COLOR0:
                (b = v / 4),
                  (t = p / 4),
                  (g[t] = n[b]),
                  (g[t + 1] = n[b + 1]),
                  (g[t + 2] = n[b + 2]),
                  (g[t + 3] = n[b + 3]),
                  (v += 16),
                  (p += 16);
                break;
              case Laya.VertexMesh.MESH_TEXTURECOORDINATE0:
              case Laya.VertexMesh.MESH_TEXTURECOORDINATE1:
                (b = v / 4),
                  (t = p / 4),
                  (g[t] = n[b]),
                  (g[t + 1] = n[b + 1]),
                  (v += 8),
                  (p += 8);
                break;
              case Laya.VertexMesh.MESH_BLENDWEIGHT0:
                (b = v / 4),
                  (t = p / 4),
                  (g[t] = n[b]),
                  (g[t + 1] = n[b + 1]),
                  (g[t + 2] = n[b + 2]),
                  (g[t + 3] = n[b + 3]),
                  (v += 16),
                  (p += 16);
                break;
              case Laya.VertexMesh.MESH_BLENDINDICES0:
                (_[t] = _[v]),
                  (_[t + 1] = _[v + 1]),
                  (_[t + 2] = _[v + 2]),
                  (_[t + 3] = _[v + 3]),
                  (v += 4),
                  (p += 4);
                break;
              case Laya.VertexMesh.MESH_TANGENT0:
                (b = v / 4),
                  (t = p / 4),
                  (g[t] = n[b]),
                  (g[t + 1] = n[b + 1]),
                  (g[t + 2] = n[b + 2]),
                  (g[t + 3] = n[b + 3]),
                  (v += 16),
                  (p += 16);
                break;
              case Laya.VertexMesh.MESH_CUSTOME0:
                (a = e[0]),
                  (t = p / 4),
                  (g[t] = a[x].x),
                  (g[t + 1] = a[x].y),
                  (g[t + 2] = a[x].z),
                  (p += 12);
                break;
              case Laya.VertexMesh.MESH_CUSTOME1:
                (a = e[1]),
                  (t = p / 4),
                  (g[t] = a[x].x),
                  (g[t + 1] = a[x].y),
                  (g[t + 2] = a[x].z),
                  (p += 12);
                break;
              case Laya.VertexMesh.MESH_CUSTOME2:
                (a = e[2]),
                  (t = p / 4),
                  (g[t] = a[x].x),
                  (g[t + 1] = a[x].y),
                  (g[t + 2] = a[x].z),
                  (p += 12);
                break;
              case Laya.VertexMesh.MESH_CUSTOME3:
                (a = e[3]),
                  (t = p / 4),
                  (g[t] = a[x].x),
                  (g[t + 1] = a[x].y),
                  (g[t + 2] = a[x].z),
                  (p += 12);
                break;
              case Laya.VertexMesh.MESH_WORLDMATRIX_ROW0:
                (a = e[4]),
                  (t = p / 4),
                  (g[t] = a[x].x),
                  (g[t + 1] = a[x].y),
                  (g[t + 2] = a[x].z),
                  (p += 12);
                break;
              case Laya.VertexMesh.MESH_WORLDMATRIX_ROW1:
                (a = e[5]),
                  (t = p / 4),
                  (g[t] = a[x].x),
                  (g[t + 1] = a[x].y),
                  (g[t + 2] = a[x].z),
                  (p += 12);
                break;
              case Laya.VertexMesh.MESH_WORLDMATRIX_ROW2:
                (a = e[6]),
                  (t = p / 4),
                  (g[t] = a[x].x),
                  (g[t + 1] = a[x].y),
                  (g[t + 2] = a[x].z),
                  (p += 12);
                break;
              case Laya.VertexMesh.MESH_WORLDMATRIX_ROW3:
                (a = e[7]),
                  (t = p / 4),
                  (g[t] = a[x].x),
                  (g[t + 1] = a[x].y),
                  (g[t + 2] = a[x].z),
                  (p += 12);
            }
          }
        }
        var S = new Laya.VertexBuffer3D(
          y.byteLength,
          Laya.LayaGL.instance.STATIC_DRAW,
          !0
        );
        return (S.vertexDeclaration = m), S.setData(y), S;
      }
      createWithMesh(t, e) {
        var a = this.createNewVertexBuffer(t, e);
        (this._vertexBuffer = a), (this._vertexCount = t._vertexCount);
        var n,
          u = t._indexBuffer,
          m = new Laya.IndexBuffer3D(
            Laya.IndexFormat.UInt16,
            u.indexCount,
            u.bufferUsage,
            u.canRead
          );
        m.setData(u.getData().slice()),
          (this._indexBuffer = m),
          this._setBuffer(this._vertexBuffer, m),
          this._setInstanceBuffer(t._instanceBufferStateType),
          this._setCPUMemory(t.cpuMemory),
          this._setGPUMemory(t.gpuMemory);
        var f = t._boneNames;
        if (f) {
          var p = (this._boneNames = []);
          for (n = 0; n < f.length; n++) p[n] = f[n];
        }
        var y = t._inverseBindPoses;
        if (y) {
          var g = (this._inverseBindPoses = []);
          for (n = 0; n < y.length; n++) g[n] = y[n];
        }
        var _ = t._skinnedMatrixCaches.length;
        for (this._skinnedMatrixCaches.length = _, n = 0; n < _; n++) {
          var x = t._skinnedMatrixCaches[n];
          this._skinnedMatrixCaches[n] = new skinnedMatrixCache(
            x.subMeshIndex,
            x.batchIndex,
            x.batchBoneIndex
          );
        }
        for (n = 0; n < t.subMeshCount; n++) {
          var b = t._subMeshes[n],
            v = b._subIndexBufferStart,
            w = b._subIndexBufferCount,
            S = b._boneIndicesList;
          let e = new Laya.SubMesh(this);
          (e._subIndexBufferStart.length = v.length),
            (e._subIndexBufferCount.length = w.length),
            (e._boneIndicesList.length = S.length);
          for (var C = 0; C < v.length; C++) e._subIndexBufferStart[C] = v[C];
          for (C = 0; C < w.length; C++) e._subIndexBufferCount[C] = w[C];
          for (C = 0; C < S.length; C++)
            e._boneIndicesList[C] = new Uint16Array(S[C]);
          (e._indexBuffer = m),
            (e._indexStart = b._indexStart),
            (e._indexCount = b._indexCount),
            (e._indices = new Uint16Array(
              m.getData().buffer,
              2 * b._indexStart,
              b._indexCount
            ));
          var E = this._vertexBuffer;
          (e._vertexBuffer = E), this._subMeshes.push(e);
        }
        this._setSubMeshes(this._subMeshes);
      }
      static loadBlendShapeData(t, e) {
        Laya.loader.load(
          t,
          Laya.Handler.create(this, (t) => {
            if (!t) return;
            let n = new Laya.Byte(t),
              u = n.readInt32(),
              m = n.readInt32(),
              f = [];
            for (let t = 0; t < m; ++t) {
              let t = [];
              for (let e = 0; e < u; ++e) {
                let e = n.readFloat32(),
                  u = n.readFloat32(),
                  m = n.readFloat32();
                t.push(new a(e, u, m));
              }
              f.push(t);
            }
            e.runWith([f]);
          }),
          null,
          Laya.Loader.BUFFER
        );
      }
    }
    class At extends Laya.Script3D {
      onAwake() {
        (this.ownerSp = this.owner),
          (this.blendShapeCnt = 0),
          (this.blendShapeWeight = []),
          this.init();
      }
      geBlendShapeWeight(t) {
        return this.blendShapeWeight[t] || 0;
      }
      seBlendShapeWeight(t, e) {
        (this.blendShapeWeight[t] = e),
          this.blendShapeMat && this.blendShapeMat.setBlendShapeWeight(t, e);
      }
      setBlendShapeWeightAnim(t, e, a) {
        let n = { weight: this.geBlendShapeWeight(t) },
          u = new Laya.Handler(this, () => {
            this.seBlendShapeWeight(t, n.weight);
          });
        Laya.Tween.to(n, { weight: e, update: u }, 1e3 * a);
      }
      getBlendShapeCount() {
        return this.blendShapeCnt;
      }
      onLoadedData(t) {
        let e = new Pt();
        e.createWithMesh(this.ownerSp.meshFilter.sharedMesh, t),
          (this.ownerSp.meshFilter.sharedMesh = e);
        let a = fx.Utils.getSpRenderer(this.ownerSp),
          n = a.material,
          u = new zt();
        (u.albedoTexture = n.albedoTexture),
          (u.albedoColor = n.albedoColor),
          (u.albedoIntensity = n.albedoIntensity),
          (u.specularColor = n.specularColor),
          (u.shininess = n.shininess),
          (u.cull = n.cull),
          (u.blendShapeCount = t.length),
          (this.blendShapeCnt = t.length);
        for (let t = 0; t < this.blendShapeCnt; ++t)
          u.setBlendShapeWeight(t, this.geBlendShapeWeight(t));
        (a.material = u), (this.blendShapeMat = u);
      }
      init(t) {
        t ||
          (t = (t = this.ownerSp.meshFilter.sharedMesh.url).replace(
            ".lm",
            ".bs"
          )),
          Pt.loadBlendShapeData(
            t,
            Laya.Handler.create(this, this.onLoadedData)
          );
      }
    }
    class kt extends Laya.MeshSprite3D {
      constructor(t, e, n, u) {
        super(Laya.PrimitiveMesh.createPlane(t, e, 1, 1), "billboard"),
          n || (n = new Laya.UnlitMaterial()),
          (this.meshRenderer.material = n),
          (n.renderMode = Laya.UnlitMaterial.RENDERMODE_TRANSPARENT),
          (n.cull = Laya.RenderState.CULL_NONE),
          (n.alphaTest = !0),
          (n.alphaTestValue = 0.8),
          (this._width = t),
          (this._height = e),
          (this._autoRender = u),
          this.transform.rotate(new a(-90, 180, 0), !0, !1);
      }
      get width() {
        return this._width;
      }
      get height() {
        return this._height;
      }
      setRenderTarget(t) {
        let e = t.width,
          a = t.height;
        e && a
          ? (this.node != t && this.unregisterNodeEvents(),
            (this.node = t),
            this.registerNodeEvents(),
            this.laterRender())
          : console.error(
              "setRenderTarget: target width or height is illegal !"
            );
      }
      registerNodeEvents() {
        this._autoRender &&
          w.recurisNode(this.node, (t) => {
            t.on(Laya.Event.LOADED, this, this.laterRender),
              t.on(Laya.Event.RESIZE, this, this.laterRender);
          });
      }
      unregisterNodeEvents() {
        this._autoRender &&
          w.recurisNode(this.node, (t) => {
            t.offAllCaller(this);
          });
      }
      laterRender() {
        this.callLater(this.render);
      }
      render() {
        if (this.destroyed || this.node.destroyed) return;
        let t = this.node.width,
          e = this.node.height;
        (this.rt = w.renderToTexture(this.node, t, e, 0, 0, this.rt)),
          (this.meshRenderer.material.albedoTexture = this.rt.bitmap);
      }
      getRenderTexture() {
        return this.rt;
      }
      getRenderTarget() {
        return this.node;
      }
      getMaterial() {
        return this.meshRenderer.material;
      }
      onDestroy() {
        this.rt && this.rt.destroy();
      }
    }
    class Dt extends Laya.MeshSprite3D {
      constructor(t, a, n, m, f = 0, p) {
        super(null, "MeshLine"),
          (this.uv = new g(new e(0, 0), new e(1, 0), new e(0, 1), new e(1, 1))),
          (this.verticles = new Array()),
          (this.bezier = t),
          (this.width = m),
          (this.length = n),
          (this.start = a),
          (this.end = a + n),
          (this.align = f),
          (this.color = p || u.WHITE);
      }
      worldToLocal(t) {
        return (
          0 == this.align
            ? a.scale(t, 0.5, t)
            : 1 == this.align && t.from(a.ZERO),
          t
        );
      }
      localToWorld(t) {
        return (
          0 == this.align
            ? a.scale(t, -0.5, t)
            : 1 == this.align
            ? t.from(a.ZERO)
            : a.scale(t, -1, t),
          t
        );
      }
      init(t, n, u) {
        let m,
          f,
          p,
          y,
          g = new a();
        n
          ? (a.subtract(u, n, g),
            (g = this.worldToLocal(g)),
            (m = new a()),
            a.add(n, g, m))
          : (m = this.bezier.getPoint(0));
        let _ = 4 * t - 2 * (t - 1),
          x = 6 * t,
          b = Laya.VertexMesh.getVertexDeclaration("POSITION,NORMAL,COLOR,UV"),
          v = b.vertexStride / 4;
        this.vertexFloatStride = v;
        let w = new Float32Array(_ * v),
          S = new Uint16Array(x),
          C = new a(),
          E = new e(),
          z = this.bezier.getLength(),
          A = this.length / z / t,
          k = this.start / z;
        for (let n = 0; n < t; n++) {
          let t = m.clone(),
            _ = k + (n + 1) * A;
          (p = this.bezier.getPoint(_)),
            m.from(p),
            a.subtract(p, t, g),
            a.normalize(g, C),
            a.cross(C, a.Up, C),
            a.normalize(C, C),
            a.scale(C, this.width, g),
            (C = this.localToWorld(g.clone())),
            a.add(t, C, t),
            a.add(p, C, p),
            (y = new a()),
            a.add(p, g, y),
            n > 0
              ? (e.scale(this.uv.lt, n + 1, E),
                this.setVerticles(
                  w,
                  this.getVertexIdxBySliceIdx(n, 2),
                  p,
                  E,
                  _
                ),
                e.scale(this.uv.rt, n + 1, E),
                this.setVerticles(
                  w,
                  this.getVertexIdxBySliceIdx(n, 3),
                  y,
                  E,
                  _
                ))
              : (u ? (f = u) : ((f = new a()), a.add(t, g, f)),
                this.setVerticles(
                  w,
                  this.getVertexIdxBySliceIdx(n, 0),
                  t,
                  this.uv.lb,
                  0
                ),
                this.setVerticles(
                  w,
                  this.getVertexIdxBySliceIdx(n, 1),
                  f,
                  this.uv.rb,
                  0
                ),
                this.setVerticles(
                  w,
                  this.getVertexIdxBySliceIdx(n, 2),
                  p,
                  this.uv.lt,
                  _
                ),
                this.setVerticles(
                  w,
                  this.getVertexIdxBySliceIdx(n, 3),
                  y,
                  this.uv.rt,
                  _
                ));
        }
        let B = 0;
        for (let e = 0; e < t; e++)
          (S[B++] = 2 * (e + 1)),
            (S[B++] = 2 * e + 3),
            (S[B++] = 2 * e),
            (S[B++] = 2 * e),
            (S[B++] = 2 * e + 3),
            (S[B++] = 2 * e + 1);
        let V = Laya.PrimitiveMesh._createMesh(b, w, S);
        this.meshFilter.sharedMesh = V;
        let R = new Laya.UnlitMaterial();
        (R.enableVertexColor = !0), (this.meshRenderer.material = R);
      }
      getMaterial() {
        return this.meshRenderer.material;
      }
      setVertexColor(t, e) {
        (t = Math.clamp(t, this.start, this.end)),
          (t /= this.bezier.getLength());
        let a = this.meshFilter.sharedMesh.getSubMesh(0),
          n = a._vertexBuffer.getFloat32Data(),
          u = !1;
        for (let a = this.getSliceIndex(t); a >= 0; a--) {
          let t = this.getVerticleIdxBySliceIdx(a, 2),
            m = this.verticles[t];
          if (m._shade) break;
          m._shade = !0;
          for (let t = 0; t < 4; t++) {
            let u = this.getVertexIdxBySliceIdx(a, t);
            (n[u + 6] = e.r),
              (n[u + 7] = e.g),
              (n[u + 8] = e.b),
              (n[u + 9] = e.a);
          }
          u = !0;
        }
        u && a._vertexBuffer.setData(n.buffer);
      }
      onDestroy() {
        (this.verticles.length = 0),
          (this.verticles = null),
          (this.bezier = null);
      }
      getSliceIndex(t) {
        let e = w.binarySearch(
          this.verticles,
          function (e, a) {
            let n;
            return (
              (n = t > e._start && t <= a._start ? 0 : t <= e._start ? -1 : 1),
              n
            );
          },
          2
        );
        return (
          -1 == e && console.error("getSliceIndex not found ??? !!!"),
          Math.floor((e + 1) / 2) - 1
        );
      }
      getVertexIdxBySliceIdx(t, e = 0) {
        return 2 * t * this.vertexFloatStride + e * this.vertexFloatStride;
      }
      getVerticleIdxBySliceIdx(t, e = 0) {
        return 2 * t + e;
      }
      setVerticles(t, e, a, n, u) {
        (t[e++] = a.x),
          (t[e++] = a.y),
          (t[e++] = a.z),
          (t[e++] = 0),
          (t[e++] = 1),
          (t[e++] = 0);
        let m = this.color;
        (t[e++] = m.r),
          (t[e++] = m.g),
          (t[e++] = m.b),
          (t[e++] = m.a),
          (t[e++] = n.x),
          (t[e++] = n.y);
        let f = a.clone();
        (f._start = u), this.verticles.push(f);
      }
      getLeftBottomVert(t, e) {
        let n = t[(e = this.getVertexIdxBySliceIdx(e))],
          u = t[e + 1],
          m = t[e + 2];
        return new a(n, u, m);
      }
      getInfoByPos(t, e) {
        let n = 0.1;
        null != e && e > 0 && (n = e),
          (t = Math.clamp(t, this.start, this.end));
        let u,
          m = this.bezier.getLength(),
          f = this.bezier.getPoint(t / m),
          p = this.bezier.getPoint((t + n) / m),
          y = new a();
        a.subtract(p, f, y), null != e && (u = y.clone());
        let g = new a();
        a.normalize(y, g);
        let _ = new a();
        a.cross(a.Up, g, _),
          a.normalize(_, _),
          a.cross(g, _, y),
          a.normalize(y, y);
        let x = y.clone();
        a.cross(x, g, _), a.normalize(_, _);
        let b = new a();
        a.cross(g, x, b), a.normalize(b, b);
        let v = new a();
        return (
          1 == this.align
            ? a.scale(b, 0.5 * this.width, v)
            : 2 == this.align && a.scale(_, 0.5 * this.width, v),
          a.add(f, v, v),
          { center: v, n: g, v: u, nL: _, nR: b, up: x }
        );
      }
      getTrailInfo() {
        let t = this.verticles[this.verticles.length - 2],
          e = this.verticles[this.verticles.length - 1];
        return { lb: t.clone(), rb: e.clone() };
      }
      getLength() {
        return this.length;
      }
      getStart() {
        return this.start;
      }
      getEnd() {
        return this.end;
      }
      isEnd(t) {
        return t >= this.end;
      }
      isHalf(t) {
        return t >= this.start + 0.5 * this.length;
      }
    }
    class Bt {
      constructor(t, e, n, u) {
        (this.position = t),
          (this.prevSegment = n),
          (this.nextSegment = u),
          (this.length = this.start = 0),
          (this.up = a.Up.clone()),
          a.transformQuat(this.up, e, this.up),
          (this.approximation = []);
      }
      calcAccumulateSize(t, e) {
        let n = this.nextSegment.position,
          u = Bt.sTempV[0];
        a.subtract(n, this.position, u);
        let m = a.scalarLength(u);
        return Math.floor(this.quadIn(t - 1, 0, e, 99) * m) + 1;
      }
      quadIn(t, e, a, n) {
        return a * (t /= n) * t + e;
      }
      init(t, e) {
        (this.handleIn = new a()), (this.handleOut = new a());
        let n = Bt.sTempV;
        n || (Bt.sTempV = n = [new a(), new a()]);
        let u = this.nextSegment ? this.calcAccumulateSize(t, e) : 0;
        for (let t = 0; t < u; t++) this.approximation.push(new a());
        let m = this.position,
          f = n[0];
        this.nextSegment
          ? a.subtract(this.nextSegment.position, m, f)
          : f.toDefault();
        let p = n[1];
        this.prevSegment
          ? a.subtract(this.prevSegment.position, m, p)
          : p.toDefault(),
          this.setBezierHandles(Bt.sAutoHandleDistance, p, f);
      }
      calcLength() {
        if (!this.nextSegment) return this.length;
        let t = this.approximation,
          [e, n, u, m, f, p, y, g, _, x, b, v] = Bt.bezier(
            this.handleOut,
            this.position,
            this.nextSegment.position,
            this.nextSegment.handleIn
          ),
          w = new a(),
          S = 1 / t.length;
        t[0].from(this.position);
        for (let a = 1; a < t.length; a++) {
          let C = a * S;
          (t[a].x = ((e * C + m) * C + y) * C + x),
            (t[a].y = ((n * C + f) * C + g) * C + b),
            (t[a].z = ((u * C + p) * C + _) * C + v),
            (w.x = t[a].x - t[a - 1].x),
            (w.y = t[a].y - t[a - 1].y),
            (w.z = t[a].z - t[a - 1].z);
          let E = Math.sqrt(w.x * w.x + w.y * w.y + w.z * w.z);
          this.length += E;
        }
        return this.length;
      }
      setBezierHandles(t, e, n) {
        let u = a.scalarLength(e),
          m = a.scalarLength(n);
        if (0 != u || 0 != m) {
          let f = 0 == m ? 0 : u / m;
          a.scale(n, f, n), a.subtract(n, e, e), a.normalize(e, n);
          let p = n;
          a.scale(p, -u * t, this.handleIn), a.scale(p, m * t, this.handleOut);
        }
        a.add(this.handleIn, this.position, this.handleIn),
          a.add(this.handleOut, this.position, this.handleOut);
      }
      getLength() {
        return this.length;
      }
      static bezier(t, e, a, n) {
        let u = -e.x + 3 * t.x + -3 * n.x + a.x,
          m = 3 * e.x + -6 * t.x + 3 * n.x,
          f = -3 * e.x + 3 * t.x,
          p = e.x,
          y = -e.y + 3 * t.y + -3 * n.y + a.y,
          g = 3 * e.y + -6 * t.y + 3 * n.y,
          _ = -3 * e.y + 3 * t.y,
          x = e.y;
        return [
          u,
          y,
          -e.z + 3 * t.z + -3 * n.z + a.z,
          m,
          g,
          3 * e.z + -6 * t.z + 3 * n.z,
          f,
          _,
          -3 * e.z + 3 * t.z,
          p,
          x,
          e.z,
        ];
      }
      getPoint(t) {
        if (!this.nextSegment) return this.position.clone();
        let e = this.nextSegment,
          [n, u, m, f, p, y, g, _, x, b, v, w] = Bt.bezier(
            this.handleOut,
            this.position,
            e.position,
            e.handleIn
          );
        return new a(
          ((n * t + f) * t + g) * t + b,
          ((u * t + p) * t + _) * t + v,
          ((m * t + y) * t + x) * t + w
        );
      }
      getUp(t) {
        if (!this.nextSegment) return this.up.clone();
        let e = new a();
        return a.lerp(this.up, this.nextSegment.up, t, e), e.normalize(), e;
      }
      getNearestPointF(t) {
        let e,
          n,
          u = 1 / 0,
          m = this.approximation,
          f = 1 / m.length,
          p = Bt.sTempV[0];
        for (let f = 0; f < m.length; f++) {
          let y = m[f];
          a.subtract(t, y, p),
            (e = a.scalarLengthSquared(p)),
            e <= u && ((u = e), (n = f));
        }
        let y,
          g,
          _,
          x = n > 0 ? n - 1 : -1,
          b = n < m.length - 1 ? n + 1 : -1,
          v = 1 / 0,
          w = 1 / 0;
        return (
          x > -1 && ([v, y] = this.linePointDistanceSq(m[x], m[n], t)),
          b > -1 && ([w, g] = this.linePointDistanceSq(m[n], m[b], t)),
          (_ = v < w ? (x + y) * f : (n + g) * f),
          _
        );
      }
      linePointDistanceSq(t, e, n) {
        let u = Bt.sTempV,
          m = u[0];
        a.subtract(e, t, m);
        let f = u[1];
        a.subtract(n, t, f);
        let p,
          y,
          g = a.dot(f, m);
        if (g <= 0)
          return (
            (p = 0), a.subtract(n, t, m), (y = a.scalarLengthSquared(m)), [y, p]
          );
        let _ = a.dot(m, m);
        return _ <= g
          ? ((p = 1),
            a.subtract(n, e, m),
            (y = a.scalarLengthSquared(m)),
            [y, p])
          : ((p = g / _),
            a.scale(m, p, m),
            a.add(t, m, m),
            a.subtract(n, m, m),
            (y = a.scalarLengthSquared(m)),
            [y, p]);
      }
    }
    class Vt {
      constructor() {
        (this.releasePool = []), Laya.timer.frameLoop(1, this, this.update);
      }
      static get instance() {
        return this._instance || (this._instance = new Vt()), this._instance;
      }
      add(t, e = !0, a, n) {
        if (!t) return;
        let u = { node: t, delay: a, destroy: e, group: n };
        a && (u.addtime = Laya.Browser.now()), this.releasePool.push(u);
      }
      update() {
        let t = Laya.Browser.now();
        for (let e = this.releasePool.length - 1; e >= 0; e--) {
          let a = this.releasePool[e];
          a.delay
            ? t - a.addtime >= a.delay && this.release(a, e)
            : this.release(a, e);
        }
      }
      release(t, e) {
        t.destroy ? t.node.destroyed || t.node.destroy() : t.node.removeSelf(),
          this.releasePool.splice(e, 1);
      }
      releaseByGroup(t) {
        if (t)
          for (let e = this.releasePool.length - 1; e >= 0; e--) {
            let a = this.releasePool[e];
            a.group == t && this.release(a, e);
          }
      }
    }
    class Ot extends Laya.EventDispatcher {
      constructor(t) {
        super();
        let e = new Laya.HttpRequest();
        (e.http.timeout = 1e4),
          e.once(Laya.Event.COMPLETE, this, this.completeHandler),
          e.once(Laya.Event.ERROR, this, this.errorHandler),
          e.on(Laya.Event.PROGRESS, this, this.processHandler),
          (this.xhr = e),
          (this.encrypt = t);
      }
      send(t, e, a, n, u = "POST") {
        const m = window.pako;
        if (t) {
          this.once("HTTPRSP", n, a);
          let f = Laya.LocalStorage.getItem("AUTHTOKEN"),
            p = ["Content-Type", "application/x-www-form-urlencoded"];
          f && (p.push("authorization"), p.push(f));
          let y = JSON.stringify(e);
          if (
            (console.log("http >>>>>>>>>>>>>>>>>>> url:" + t + " data:" + y),
            "GET" == u.toUpperCase())
          ) {
            let a;
            for (let t in e) {
              let n = e[t];
              "object" == typeof n && (n = JSON.stringify(n)),
                (a =
                  null == a
                    ? t + "=" + encodeURIComponent(n)
                    : a + "&" + t + "=" + encodeURIComponent(n));
            }
            this.xhr.send(t + "?" + a, null, u, "json", p);
          } else
            (p[1] = "application/json"),
              (y = this.encrypt
                ? m.deflate(encodeURIComponent(y), { to: "string" })
                : encodeURIComponent(y)),
              (y = JSON.stringify({ data: y })),
              this.xhr.send(t, y, u, "json", p);
        }
      }
      registerErrHandler(t, e) {
        this.once("HTTPERR", e, t);
      }
      processHandler(t) {}
      errorHandler(t) {
        console.log("http <<<<<<<<<<<<<<<<<<< error:" + JSON.stringify(t)),
          this.event("HTTPERR", t);
      }
      completeHandler(e) {
        const a = window.pako;
        let n = e.data;
        if (n) {
          this.encrypt && (n = a.inflate(n, { to: "string" })),
            (n = decodeURIComponent(n)),
            console.log("http <<<<<<<<<<<<<<<<<<< ok:" + n);
          try {
            n = JSON.parse(n);
          } catch (e) {
            return void this.event("HTTPERR", {
              code: t.BaseCode.HTTP_INTERFACE_UNDEFINED,
            });
          }
          let e = this.xhr.http;
          if (e.getAllResponseHeaders()) {
            const t = ["authorization", "Authorization"];
            for (const a of t) {
              let t = e.getResponseHeader(a);
              if (t) {
                Laya.LocalStorage.setItem("AUTHTOKEN", t);
                break;
              }
            }
          }
          this.event("HTTPRSP", n);
        } else console.log("http <<<<<<<<<<<<<<<<<<< ok: null");
      }
    }
    class Rt extends Laya.Image {
      constructor(t) {
        super(), (this._anisMap = {}), (this._interval = 50), t && this.load(t);
      }
      onDestroy() {
        this.clearTimer(this, this._frameLoop);
      }
      load(t) {
        for (const e of t) this._anisMap[e.name] = e;
        return this;
      }
      play(t, e, a, n, u) {
        (this._isPlaying = !0),
          (this._loop = a),
          (this._animation = this._anisMap[t]),
          (this._count = this._animation.frames.length),
          n
            ? (this._interval = n)
            : this._animation.frameRate &&
              (this._interval = 1e3 / this._animation.frameRate),
          (this._complete = u),
          (this.index = e || 0),
          this.interval > 0 &&
            this.timerLoop(this.interval, this, this._frameLoop, null, !0, !0);
      }
      gotoAndStop(t, e) {
        (this._animation = this._anisMap[t]),
          (this._count = this._animation.frames.length),
          (this.index = e),
          this.stop();
      }
      stop() {
        (this._isPlaying = !1), this.clearTimer(this, this._frameLoop);
      }
      pause() {
        this._isPause = !0;
      }
      resume() {
        this._isPause = !1;
      }
      get isPlaying() {
        return this._isPlaying;
      }
      get index() {
        return this._index;
      }
      set index(t) {
        (this._index = t), this._displayToIndex(t);
      }
      get interval() {
        return this._interval;
      }
      set interval(t) {
        this._interval != t &&
          ((this._interval = t),
          this._isPlaying &&
            t > 0 &&
            this.timerLoop(t, this, this._frameLoop, null, !0, !0));
      }
      _displayToIndex(t) {
        this.skin = this._animation.frames[t];
      }
      _frameLoop() {
        this.destroyed
          ? this.clearTimer(this, this._frameLoop)
          : this.visible &&
            this.parent &&
            this._animation &&
            !this._isPause &&
            (this._index++,
            this._index >= this._count &&
              (this._loop
                ? (this._index = 0)
                : ((this._index = 0),
                  this.stop(),
                  this._complete && this._complete.run())),
            (this.index = this._index));
      }
    }
    class Ut extends Laya.Sprite {
      constructor(t) {
        super(),
          (this._dir = new a()),
          (this._temp = new a()),
          (this._tempPoint = new Laya.Point()),
          (this._pointSize = 11),
          (this._maxWidth = 40),
          (this._minWidth = 2),
          (this._historySize = 10),
          (this._historyX = []),
          (this._historyY = []),
          (this._startTrail = !1),
          (this._skin = t);
      }
      onAwake() {
        (this._lastPos = new a(this.x, this.y, 0)), (this._points = []);
        for (let t = 0; t < this._pointSize; t++)
          this._points.push(new a(0, 0, 0));
        Laya.loader.load(
          this._skin,
          Laya.Handler.create(this, (t) => {
            t && ((this._tex = t), this.initCmd(), this.updateVertices());
          })
        ),
          this.frameLoop(1, this, this.update);
      }
      onDestroy() {
        this.clearTimer(this, this.update);
      }
      initCmd() {
        this._vertices = new Float32Array(4 * this._pointSize);
        let t = new Float32Array(4 * this._pointSize),
          e = new Uint16Array(6 * (this._pointSize - 1));
        for (let t = 1; t < this._pointSize; ++t) {
          let a = 6 * (t - 1),
            n = 2 * (t - 1);
          (e[a] = n),
            (e[a + 1] = n + 1),
            (e[a + 2] = n + 2),
            (e[a + 3] = n + 2),
            (e[a + 4] = n + 1),
            (e[a + 5] = n + 3);
        }
        this._cmd = this.graphics.drawTriangles(
          this._tex,
          0,
          0,
          this._vertices,
          t,
          e
        );
      }
      updateVertices() {
        if (this._points.length <= 1) return;
        let t = 0,
          e = this._points[0],
          n = [0];
        for (let u = 1; u < this._points.length; ++u) {
          let m = this._points[u],
            f = a.distance(m, e);
          (t += f), (e = m), n.push(f);
        }
        let u = 0;
        (e = this._points[0]),
          a.subtract(this._points[0], this._points[1], this._dir);
        for (let e = 0; e < this._points.length; ++e) {
          u += n[e];
          let m = this._points[e],
            f =
              this._minWidth +
              ((this._maxWidth - this._minWidth) * (t - u)) / t;
          a.cross(this._dir, a.UnitZ, this._temp), this._temp.normalize(f / 2);
          let p = 4 * e;
          (this._vertices[p] = m.x + this._temp.x),
            (this._vertices[p + 1] = m.y + this._temp.y),
            (this._vertices[p + 2] = m.x - this._temp.x),
            (this._vertices[p + 3] = m.y - this._temp.y),
            e > 0 && a.subtract(this._points[e - 1], m, this._dir);
        }
      }
      update() {
        if (!this._cmd || !this.visible || !this._startTrail) return;
        this._tempPoint.setTo(0, 0),
          this.localToGlobal(this._tempPoint),
          this._historyX.length >= this._historySize && this._historyX.pop(),
          this._historyX.unshift(this._tempPoint.x),
          this._historyY.length >= this._historySize && this._historyY.pop(),
          this._historyY.unshift(this._tempPoint.y);
        let t = 0,
          e = 0;
        for (var a = 0; a < this._pointSize; a++) {
          var n = this._points[a];
          a < this._historyX.length
            ? ((n.x = this._historyX[a] - this._tempPoint.x),
              (n.y = this._historyY[a] - this._tempPoint.y),
              (t = n.x),
              (e = n.y))
            : ((n.x = t), (n.y = e));
        }
        this.updateVertices(),
          this._lastPos.setValue(this._tempPoint.x, this._tempPoint.y, 0);
      }
      start() {
        this._startTrail ||
          ((this.visible = !0), (this._startTrail = !0), this.update());
      }
      stop() {
        (this.visible = !1), (this._startTrail = !1);
        for (let t = 0; t < this._points.length; t++)
          this._points[t].setValue(0, 0, 0);
        (this._historyX = []), (this._historyY = []);
      }
    }
    class Ft extends Laya.Script3D {
      constructor() {
        super();
      }
      onAwake() {
        let t = this.owner,
          e = t.getComponent(Laya.Animator),
          a = 0;
        for (; e.getControllerLayer(a); ) {
          let n = e.getControllerLayer(a)._statesMap,
            u = Laya.CallLater.I;
          for (const e in n) {
            let m = n[e].clip._animationEvents;
            if (m && m.length > 0)
              for (const n of m) {
                let m = { eventName: n.eventName, name: e, owner: t, layer: a };
                this[m.eventName] = u.callLater.bind(
                  u,
                  this,
                  this.onAnimEvent,
                  [m]
                );
              }
          }
          a++;
        }
        this.ownerSp = t;
      }
      setListener(t) {
        this.listener = t;
      }
      onAnimEvent(t) {
        this.listener && !this.listener.destroyed
          ? this.listener.event(p.E_ANIM_EVENT, t)
          : A.instance.event(p.E_ANIM_EVENT, t);
      }
    }
    class Ht extends Laya.AnimatorStateScript {
      constructor() {
        super(), (this.name = "UnknownAnimState"), (this.layer = 0);
      }
      setName(t) {
        this.name = t;
      }
      setLayer(t) {
        this.layer = t || 0;
      }
      setOwner(t) {
        this.owner = t;
      }
      setListener(t) {
        this.listener = t;
      }
      setDebug(t) {
        this.debug = t;
      }
      setAllStateScripts(t) {
        this.allStateScripts = t;
      }
      onStateEnter() {
        for (const t of this.allStateScripts)
          t.isPlaying && t.name != this.name && t.onStateAbort();
        (this.isPlaying = !0),
          this.debug &&
            console.log(`############ Animator: ${this.name} start...`);
        let e = {
          code: t.BaseCode.E_ANIM_START,
          name: this.name,
          owner: this.owner,
          layer: this.layer,
        };
        this.listener && !this.listener.destroyed
          ? this.listener.event(p.E_ANIM_STATE_CHENGED, e)
          : A.instance.event(p.E_ANIM_STATE_CHENGED, e);
      }
      onStateAbort() {
        if (this.isPlaying) {
          (this.isPlaying = !1),
            this.debug &&
              console.log(`############ Animator: ${this.name} abort !`);
          let e = {
            code: t.BaseCode.E_ANIM_ABORT,
            name: this.name,
            owner: this.owner,
            layer: this.layer,
          };
          this.listener && !this.listener.destroyed
            ? this.listener.event(p.E_ANIM_STATE_CHENGED, e)
            : A.instance.event(p.E_ANIM_STATE_CHENGED, e);
        }
      }
      onStateExit() {
        if (this.isPlaying) {
          (this.isPlaying = !1),
            this.debug &&
              console.log(`############ Animator: ${this.name} stopped !`);
          let e = {
            code: t.BaseCode.E_ANIM_STOP,
            name: this.name,
            owner: this.owner,
            layer: this.layer,
          };
          this.listener && !this.listener.destroyed
            ? this.listener.event(p.E_ANIM_STATE_CHENGED, e)
            : A.instance.event(p.E_ANIM_STATE_CHENGED, e);
        }
      }
    }
    class Wt extends Laya.Script3D {
      constructor() {
        super(),
          (this._tempVector3 = new Laya.Vector3()),
          (this.yawPitchRoll = new Laya.Vector3()),
          (this.resultRotation = new Laya.Quaternion()),
          (this.tempRotationZ = new Laya.Quaternion()),
          (this.tempRotationX = new Laya.Quaternion()),
          (this.tempRotationY = new Laya.Quaternion()),
          (this.rotaionSpeed = 6e-5),
          (this.moveSpeed = 0.001);
      }
      _updateRotation() {
        Math.abs(this.yawPitchRoll.y) < 1.5 &&
          (Laya.Quaternion.createFromYawPitchRoll(
            this.yawPitchRoll.x,
            this.yawPitchRoll.y,
            this.yawPitchRoll.z,
            this.tempRotationZ
          ),
          this.tempRotationZ.cloneTo(this.camera.transform.localRotation),
          (this.camera.transform.localRotation =
            this.camera.transform.localRotation));
      }
      onAwake() {
        Laya.stage.on(Laya.Event.RIGHT_MOUSE_DOWN, this, this.mouseDown),
          Laya.stage.on(Laya.Event.RIGHT_MOUSE_UP, this, this.mouseUp),
          (this.camera = this.owner);
      }
      onUpdate() {
        var t = Laya.timer.delta;
        if (
          w.isNumber(this.lastMouseX) &&
          w.isNumber(this.lastMouseY) &&
          this.isMouseDown
        ) {
          this.owner.scene;
          Laya.KeyBoardManager.hasKeyDown(87) &&
            this.moveForward(-this.moveSpeed * t),
            Laya.KeyBoardManager.hasKeyDown(83) &&
              this.moveForward(this.moveSpeed * t),
            Laya.KeyBoardManager.hasKeyDown(65) &&
              this.moveRight(-this.moveSpeed * t),
            Laya.KeyBoardManager.hasKeyDown(68) &&
              this.moveRight(this.moveSpeed * t),
            Laya.KeyBoardManager.hasKeyDown(81) &&
              this.moveVertical(this.moveSpeed * t),
            Laya.KeyBoardManager.hasKeyDown(69) &&
              this.moveVertical(-this.moveSpeed * t);
          var e = Laya.stage.mouseX - this.lastMouseX,
            a = Laya.stage.mouseY - this.lastMouseY,
            n = this.yawPitchRoll;
          (n.x -= e * this.rotaionSpeed * t),
            (n.y -= a * this.rotaionSpeed * t),
            this._updateRotation();
        }
        (this.lastMouseX = Laya.stage.mouseX),
          (this.lastMouseY = Laya.stage.mouseY);
      }
      onDestroy() {
        Laya.stage.off(Laya.Event.RIGHT_MOUSE_DOWN, this, this.mouseDown),
          Laya.stage.off(Laya.Event.RIGHT_MOUSE_UP, this, this.mouseUp);
      }
      mouseDown(t) {
        this.camera.transform.localRotation.getYawPitchRoll(this.yawPitchRoll),
          (this.lastMouseX = Laya.stage.mouseX),
          (this.lastMouseY = Laya.stage.mouseY),
          (this.isMouseDown = !0);
      }
      mouseUp(t) {
        this.isMouseDown = !1;
      }
      mouseOut(t) {
        this.isMouseDown = !1;
      }
      moveForward(t) {
        (this._tempVector3.x = this._tempVector3.y = 0),
          (this._tempVector3.z = t),
          this.camera.transform.translate(this._tempVector3);
      }
      moveRight(t) {
        (this._tempVector3.y = this._tempVector3.z = 0),
          (this._tempVector3.x = t),
          this.camera.transform.translate(this._tempVector3);
      }
      moveVertical(t) {
        (this._tempVector3.x = this._tempVector3.z = 0),
          (this._tempVector3.y = t),
          this.camera.transform.translate(this._tempVector3, !1);
      }
      setMoveSpeed(t) {
        this.moveSpeed = t;
      }
    }
    class Gt extends Laya.Material {
      constructor() {
        super(),
          (this.lock = !0),
          (this.renderQueue = Laya.Material.RENDERQUEUE_TRANSPARENT),
          (this._albedoColor = new n(1, 0, 0, 1)),
          (this.albedoColor = this._albedoColor),
          (this.maxRadius = 0.5),
          (this.minRadius = 0.3),
          (this.progress = 0.5),
          this._shaderValues.setBool(Gt.CANSAMPLE, !1),
          Gt.initShader(this);
      }
      get albedoTexture() {
        return this._shaderValues.getTexture(Gt.ALBEDOTEXTURE);
      }
      set albedoTexture(t) {
        this._shaderValues.setBool(Gt.CANSAMPLE, !!t),
          this._shaderValues.setTexture(Gt.ALBEDOTEXTURE, t);
      }
      get albedoColor() {
        return this._albedoColor;
      }
      set albedoColor(t) {
        t.cloneTo(this._albedoColor), this._shaderValues.setVector(Gt.COLOR, t);
      }
      get _ColorA() {
        return this._albedoColor.w;
      }
      set _ColorA(t) {
        (this._albedoColor.w = t), (this.albedoColor = this._albedoColor);
      }
      get maxRadius() {
        return this._shaderValues.getNumber(Gt.MAXRADIUS);
      }
      set maxRadius(t) {
        (t = Math.clamp(t, 0, 0.5)),
          this._shaderValues.setNumber(Gt.MAXRADIUS, t);
      }
      get minRadius() {
        return this._shaderValues.getNumber(Gt.MINRADIUS);
      }
      set minRadius(t) {
        (t = Math.clamp(t, 0, 0.5)),
          this._shaderValues.setNumber(Gt.MINRADIUS, t);
      }
      get progress() {
        return this._shaderValues.getNumber(Gt.PROGRESS);
      }
      set progress(t) {
        (t = Math.clamp(t, 0, 1)), this._shaderValues.setNumber(Gt.PROGRESS, t);
      }
      clone() {
        let t = new Gt();
        return this.cloneTo(t), t;
      }
      static initShader(t) {
        let e = {
            a_Position: Laya.VertexMesh.MESH_POSITION0,
            a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
          },
          a = {
            u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
            u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
            u_AlbedoTexture: Laya.Shader3D.PERIOD_MATERIAL,
            u_Color: Laya.Shader3D.PERIOD_MATERIAL,
            u_MaxRadius: Laya.Shader3D.PERIOD_MATERIAL,
            u_MinRadius: Laya.Shader3D.PERIOD_MATERIAL,
            u_Value: Laya.Shader3D.PERIOD_MATERIAL,
            u_Sample: Laya.Shader3D.PERIOD_MATERIAL,
          };
        t.lock = !1;
        let n = Laya.Shader3D.add("CircleProgress3D"),
          u = new Laya.SubShader(e, a);
        n.addSubShader(u);
        let m = u.addShaderPass(
          '#include "Lighting.glsl";\nattribute vec4 a_Position;\nattribute vec2 a_Texcoord0;\nuniform mat4 u_MvpMatrix;\nuniform mat4 u_WorldMat;\nvarying vec2 v_Texcoord0;\nvoid main()\n{\n\tgl_Position = u_MvpMatrix * a_Position;\n\tgl_Position=remapGLPositionZ(gl_Position);\n\tv_Texcoord0 = a_Texcoord0;\n}',
          "#ifdef FSHIGHPRECISION\nprecision highp float;\n#else\nprecision mediump float;\n#endif\n\n#define PI 3.1415926538\n\nuniform vec4 u_Color;\nuniform float u_MaxRadius;\nuniform float u_MinRadius;\nuniform float u_Value;\nuniform bool u_Sample;\nuniform sampler2D u_AlbedoTexture;\n\nvarying vec2 v_Texcoord0;\n\nvoid main()\n{\n//将uv中心平移至旋转中心\nvec2 uv01 = vec2(v_Texcoord0.x, v_Texcoord0.y);\nuv01 = uv01 - vec2(0.5,0.5);\n// 斜率\nfloat radian = mod(atan(uv01.y, uv01.x) + 2.0 * PI, 2.0 * PI);\nfloat radianValue = u_Value * 2.0 * PI;\nif (radian > radianValue) discard;\n\nif (u_Sample) {\n\tvec4 color = texture2D(u_AlbedoTexture, v_Texcoord0);\n\tgl_FragColor = vec4(color.rgb, color.a * u_Color.a);\n} else {\n\t//环形剪裁\n\tfloat len = length(uv01) * 2.0;\n\tlen = (1.0-floor(len + (1.0-u_MaxRadius*2.0))) * floor(len + (1.0-u_MinRadius*2.0));\n\tif(len < 0.001) discard;    \n\tgl_FragColor = u_Color;\n}\n}"
        );
        (m.renderState.blend = Laya.RenderState.BLEND_ENABLE_ALL),
          (m.renderState.srcBlend = Laya.RenderState.BLENDPARAM_SRC_ALPHA),
          (m.renderState.dstBlend =
            Laya.RenderState.BLENDPARAM_ONE_MINUS_SRC_ALPHA),
          t.setShaderName("CircleProgress3D"),
          t.event(p.E_MATERIAL_LOADED);
      }
    }
    (Gt.ALBEDOTEXTURE = Laya.Shader3D.propertyNameToID("u_AlbedoTexture")),
      (Gt.COLOR = Laya.Shader3D.propertyNameToID("u_Color")),
      (Gt.MAXRADIUS = Laya.Shader3D.propertyNameToID("u_MaxRadius")),
      (Gt.MINRADIUS = Laya.Shader3D.propertyNameToID("u_MinRadius")),
      (Gt.PROGRESS = Laya.Shader3D.propertyNameToID("u_Value")),
      (Gt.CANSAMPLE = Laya.Shader3D.propertyNameToID("u_Sample"));
    class jt extends Laya.Script3D {
      constructor() {
        super(),
          (this.collideInfos = []),
          (this.temp = new a()),
          (this.lastPosition = new a()),
          (this.rotQ = new Laya.Quaternion()),
          (this.offset = new a()),
          (this.bodyPos = new a());
        let t = new a(1 / 0, 1 / 0, 1 / 0),
          e = new a(-1 / 0, -1 / 0, -1 / 0);
        this.boundBox = new Laya.BoundBox(t, e);
      }
      isStatic() {
        return this.option.static;
      }
      setStatic() {
        this.body &&
          ((this.option.static = !0), this.body.setupMass(_.BODY_STATIC));
      }
      setDynamic() {
        this.body &&
          ((this.option.static = !1), this.body.setupMass(_.BODY_DYNAMIC));
      }
      setKinematic(t) {
        this.body.isKinematic = t;
      }
      setTrigger(t) {
        this.option.trigger = t;
      }
      isSyncShape() {
        return this.option.syncShape;
      }
      setSyncShape(t, e = !1) {
        (this.option.syncShape = t), (this.option.syncEveryTime = e);
      }
      canRotation() {
        return !this.body.controlRotInTime;
      }
      setRotation(t) {
        this.body.controlRotInTime = !t;
      }
      get collisionGroup() {
        return this.option.belongsTo;
      }
      set collisionGroup(t) {
        this.option.belongsTo = t;
        for (let e = this.body.shapes; null !== e; e = e.next) e.belongsTo = t;
      }
      get collidesWith() {
        return this.option.collidesWith;
      }
      set collidesWith(t) {
        this.option.collidesWith = t;
        for (let e = this.body.shapes; null !== e; e = e.next)
          e.collidesWith = t;
      }
      onAwake() {
        let t = (this.obstacle = this.owner);
        this.lastPosition.from(t.transform.position),
          this.option ? this.initInternal(this.option) : (this.enabled = !1);
      }
      init(t) {
        ((t = w.clone(t)).belongsTo = void 0 !== t.belongsTo ? t.belongsTo : 1),
          (t.collidesWith =
            void 0 !== t.collidesWith ? t.collidesWith : 4294967295),
          (t.move = !t.static),
          (t.restitution = t.restitution || 0),
          (t.friction = t.friction || 0.2),
          t.eventOnce && (this.colliders = []),
          (t.density = t.density ? t.density : 1),
          (this.option = t),
          this.obstacle && this.initInternal(this.option);
      }
      initInternal(t) {
        if (this.initialized) return;
        this.initialized = !0;
        let e = this.obstacle,
          n = e.transform.localScale;
        if (n.x < 0 || n.y < 0 || n.z < 0)
          return void console.warn(
            `模型 ${e.name} 缩放为负值，暂不支持该刚体!`
          );
        let u,
          m,
          f,
          p = t.shape,
          y = e.transform.position,
          g = e.transform.worldMatrix,
          _ = this.rotQ;
        e.transform.rotation.invert(_);
        let x = this.temp;
        a.TransformNormal(a.ONE, g, x),
          a.transformQuat(x, _, x),
          (u = x.x),
          (m = x.y),
          (f = x.z);
        let b = e.transform.rotation;
        t.canScale && (t.scale = x.clone());
        let v = this.temp,
          w = new a(1 / 0, 1 / 0, 1 / 0),
          S = new a(-1 / 0, -1 / 0, -1 / 0);
        const anonymous = function (n, p, g, C, E) {
          let z, A, k, B;
          v.from(n.localOffset), (v.x *= u), (v.y *= m), (v.z *= f);
          let V = new a();
          if (n instanceof Laya.SphereColliderShape) {
            (z = "sphere"), (A = [v.x, v.y, v.z]);
            let e = n.radius * Math.max(u, m, f);
            (e = Math.max(e, 1e-4)),
              (k = [e, e, e]),
              V.setValue(e, e, e),
              t.useShapeLocalRotation &&
                (B = [
                  n.localRotation.x,
                  n.localRotation.y,
                  n.localRotation.z,
                  n.localRotation.w,
                ]);
          } else if (n instanceof Laya.BoxColliderShape)
            (z = "box"),
              (A = [v.x, v.y, v.z]),
              (k = [
                Math.max(n.sizeX * u, 1e-4),
                Math.max(n.sizeY * m, 1e-4),
                Math.max(n.sizeZ * f, 1e-4),
              ]),
              V.setValue(k[0], k[1], k[2]),
              t.useShapeLocalRotation &&
                (B = [
                  n.localRotation.x,
                  n.localRotation.y,
                  n.localRotation.z,
                  n.localRotation.w,
                ]);
          else {
            if (!(n instanceof Laya.CapsuleColliderShape))
              throw Error("unsupported collider shape type !!!");
            {
              (z = "cylinder"), (A = [v.x, v.y, v.z]);
              let t = [];
              1 == n.orientation
                ? ((t[0] = Math.max(u, f)), (t[1] = m))
                : 0 == n.orientation
                ? ((t[0] = Math.max(f, m)),
                  (t[1] = u),
                  a.transformQuat(a.UnitZ, e.transform.localRotation, x),
                  Laya.Quaternion.createFromAxisAngle(x, Math.rad(90), _),
                  (B = [_.x, _.y, _.z, _.w]))
                : ((t[0] = Math.max(u, m)),
                  (t[1] = f),
                  a.transformQuat(a.UnitX, e.transform.localRotation, x),
                  Laya.Quaternion.createFromAxisAngle(x, Math.rad(90), _),
                  (B = [_.x, _.y, _.z, _.w]));
              let p = Math.max(n.radius * t[0], 1e-4);
              (k = [p, Math.max(n.length * t[1] - 2 * p, 1e-4), 0]),
                V.setValue(k[0], k[1], k[0]);
            }
          }
          p
            ? (p.push(z), C.push(...A), B && E.push(...B), g.push(...k))
            : ((t.type = z),
              (t.posShape = A),
              (t.rotShape = B),
              (t.size = k),
              (t.pos = [y.x, y.y, y.z]),
              (t.rot = [b.x, b.y, b.z, b.w]));
          let R = new Laya.BoundBox(w, S);
          return a.scale(V, 0.5, V), R.setCenterAndExtent(v, V), R;
        };
        if (p instanceof Laya.CompoundColliderShape) {
          let e = p.getChildShapes();
          if (e.length > 0) {
            (t.type = []), (t.size = []), (t.posShape = []), (t.rotShape = []);
            for (const a of e) {
              let e = anonymous(a, t.type, t.size, t.posShape, t.rotShape);
              Laya.BoundBox.merge(this.boundBox, e, this.boundBox);
            }
            (t.pos = [y.x, y.y, y.z]), (t.rot = [b.x, b.y, b.z, b.w]);
          }
        } else {
          let t = anonymous(p);
          Laya.BoundBox.merge(this.boundBox, t, this.boundBox);
        }
      }
      createBounds(t, e = Laya.Color.GREEN, a) {
        let n = this.temp,
          u = t.width,
          m = t.depth,
          f = t.height;
        t.radius && ((u = m = 2 * t.radius), f || (f = u));
        let p = [u, f, m],
          y = this.option.shape;
        y.orientation &&
          (0 == y.orientation
            ? ([p[0], p[1]] = [p[1], p[0]])
            : 2 == y.orientation && ([p[1], p[2]] = [p[2], p[1]]));
        let g = new Laya.MeshSprite3D(
            Laya.PrimitiveMesh.createBox(p[0], p[1], p[2])
          ),
          _ = w.linearModel(g, 50, e);
        return (
          n.from(t.relativePosition),
          (_.transform.localPosition = n),
          t.localRotation &&
            (_.transform.localRotation = new Laya.Quaternion(
              t.localRotation.x,
              t.localRotation.y,
              t.localRotation.z,
              t.localRotation.w
            )),
          a.addChild(_),
          _
        );
      }
      onEnable() {
        this.initBody();
      }
      initBody() {
        let t = _.World.instance,
          e = this.obstacle;
        if ((this.clearColliders(), !this.body)) {
          let a = this.option,
            n = t.add(a);
          (this.body = n),
            w.isNumber(a.mass) && this.setMass(a.mass, !0),
            !1 === a.canRotation && this.setRotation(!1),
            this.calcOffset(),
            (this.body.owner = e),
            a.event && (this.body.event_cb = this.onCollisionEx.bind(this)),
            this.showDebugBounds();
        }
        let a = this.body;
        a && !a.parent && (this.syncToBody(), t.addRigidBody(a));
      }
      calcOffset() {
        let t = this.bodyPos;
        if (
          (t.from(this.body.position),
          a.subtract(t, this.obstacle.transform.position, this.offset),
          a.scalarLengthSquared(this.offset) > 0)
        ) {
          let t = this.body.getQuaternion(),
            e = this.rotQ;
          e.from(t), e.invert(e), a.transformQuat(this.offset, e, this.offset);
        }
      }
      onDisable() {
        this.removeBody();
      }
      removeBody() {
        if (this.body && this.body.parent) {
          _.World.instance.removeRigidBody(this.body);
        }
      }
      onDestroy() {
        if ((this.onDisable(), this.clearColliders(), this.debugBounds)) {
          let t = this.debugBounds;
          t.callLater(() => {
            t.destroy();
          }),
            (this.debugBounds = null);
        }
      }
      isCollideWith(t) {
        return -1 != this.colliders.indexOf(t);
      }
      onCollisionEx(t, e, a, n) {
        if (t instanceof Array) {
          let e = t,
            a = this.collideInfos.length;
          for (; a--; ) {
            let t = this.collideInfos[a];
            t.other.destroyed
              ? this.collideInfos.splice(a, 1)
              : e.includes(t.rawInfo) ||
                (this.obstacle.event(p.E_PHYSICS_COLLISION_EXIT, t),
                this.collideInfos.splice(a, 1));
          }
          return;
        }
        let u = t.owner;
        if (this.destroyed || u.destroyed) return;
        let m = u.getComponent(jt);
        if (
          ((this.option.trigger || (m && m.option.trigger)) &&
            (a.touching = !1),
          this.colliders)
        ) {
          if (this.isCollideWith(u)) return;
          this.colliders.push(u),
            u.on(Laya.Event.REMOVED, this, this.removeCollider, [u]),
            u.on(Laya.Event.ACTIVED, this, this.removeCollider, [u]);
        }
        let f = new x();
        f.other = u;
        let y = a.manifold.points[0];
        (f.distance = Math.abs(y.penetration)),
          (f.normal = y.normal),
          (f.contact = y.position),
          (f.mine = this.obstacle),
          (e.name || n.name) &&
            (f.shapesName = { other: e.name, mine: n.name }),
          (f.rawInfo = a),
          this.obstacle.hasListener(p.E_PHYSICS_COLLISION_EXIT) &&
            (this.collideInfos.find((t) => t.rawInfo == a) ||
              this.collideInfos.push(f)),
          this.obstacle.event(p.E_PHYSICS_COLLISION, f);
      }
      removeCollider(t) {
        let e = this.colliders;
        if (e && e.length > 0) {
          let a = e.indexOf(t);
          -1 != a && e.splice(a, 1);
        }
        t.off(Laya.Event.REMOVED, this, this.removeCollider),
          t.off(Laya.Event.ACTIVED, this, this.removeCollider);
      }
      clearColliders() {
        if (this.colliders) {
          let t = this.colliders.length;
          for (; t--; ) {
            let e = this.colliders[t];
            this.removeCollider(e);
          }
          this.colliders.clear();
        }
      }
      _syncToBody(t) {
        let e = this.obstacle,
          n = this.body,
          u = this.option;
        if (u.canScale) {
          let t = e.parent;
          t instanceof Laya.Sprite3D && t.transform.getWorldLossyScale();
          let n = e.transform.getWorldLossyScale();
          if (!a.equals(n, u.scale)) {
            this.removeBody(),
              (this.initialized = !1),
              this.initInternal(this.option);
            let t = this.body;
            (this.body = null), this.initBody(), this.syncBodyProps(t);
          }
        }
        if (!u.syncOnlyRot) {
          let t = e.transform.position,
            u = this.bodyPos;
          if ((u.from(t), a.scalarLengthSquared(this.offset) > 0)) {
            let n = this.temp;
            a.transformQuat(this.offset, e.transform.rotation, n),
              a.add(t, n, u);
          }
          n.setPosition(u), this.lastPosition.from(t);
        }
        u.syncOnlyPos || n.setQuaternion(e.transform.rotation),
          (u.static || t) && n.updatePosition(0);
      }
      syncToBody(t, e) {
        (this.option.syncOnlyRot = t),
          (this.option.syncOnlyPos = e),
          this._syncToBody(!0);
      }
      syncBodyProps(t) {
        let e = this.body;
        (e.name = t.name),
          e.linearVelocity.copy(t.linearVelocity),
          e.angularVelocity.copy(t.angularVelocity),
          (e.linearSpeed = t.linearSpeed),
          (e.linearVelocityConstraint = t.linearVelocityConstraint),
          (e.angularVelocityConstraint = t.angularVelocityConstraint),
          (e.linearVelocityMax = t.linearVelocityMax),
          (e.angularVelocityMax = t.angularVelocityMax),
          (e.positionConstraint = t.positionConstraint),
          (e.angularConstraint = t.angularConstraint),
          (e.overrideGravity = t.overrideGravity);
      }
      onUpdate() {
        let t = this.body,
          e = this.option,
          n = this.obstacle,
          u = t.getPosition(),
          m = this.bodyPos;
        m.from(u);
        let f = this.rotQ;
        if (
          (f.from(t.getQuaternion()),
          this.debugBounds &&
            this.debugBounds.active &&
            ((this.debugBounds.transform.position = m),
            (this.debugBounds.transform.rotation = f)),
          e.syncShape)
        ) {
          let t = n.transform.position;
          (!e.syncEveryTime && a.equals(t, this.lastPosition)) ||
            this._syncToBody();
        } else {
          let t = this.temp;
          t.from(u),
            a.scalarLengthSquared(this.offset) > 0 &&
              (a.transformQuat(this.offset, f, t), a.subtract(m, t, t)),
            (n.transform.position = t),
            (n.transform.rotation = f),
            this.lastPosition.from(t);
        }
      }
      getPhysicsBody() {
        return this.body;
      }
      getSize(t) {
        return this.boundBox.getExtent(t), a.scale(t, 2, t), t;
      }
      isContactWith(t) {
        for (let e = this.getPhysicsBody().shapes; e; e = e.next)
          for (let a = e.contactLink; null !== a; a = a.next)
            if (
              0 != (a.shape.belongsTo & t) &&
              a.contact.manifold.numPoints > 0
            )
              return !0;
        return !1;
      }
      isContactByName(t) {
        return this.getPhysicsBody().checkContact(t);
      }
      wakeUp() {
        this.body.sleeping && this.body.awake();
      }
      sleep() {
        this.body.sleep();
      }
      getBodyName() {
        return this.body.name;
      }
      getCurBodyScale() {
        let t = new a(),
          e = this.rotQ,
          n = this.obstacle.transform;
        return (
          n.rotation.invert(e),
          a.TransformNormal(a.ONE, n.worldMatrix, t),
          a.transformQuat(t, e, t),
          t
        );
      }
      getMass() {
        return this.body.mass;
      }
      getInvMass() {
        return this.body.inverseMass;
      }
      setMass(t, e) {
        this.isStatic() ||
          ((this.option.mass = t),
          this.body.setMass(t),
          e && this.body.setupMass(this.body.type));
      }
      showDebugBounds() {
        if (!this.option.debug) return;
        if (this.debugBounds) {
          this.debugBounds.destroy(), (this.debugBounds = null);
        }
        let t = this.bodyPos;
        t.from(this.body.position), (this.option.debug = !0);
        let e = this.body.shapes,
          a = new Laya.Sprite3D("debugBounds");
        a.transform.position = t;
        let n = this.rotQ;
        n.from(this.body.getQuaternion()),
          (a.transform.rotation = n),
          (this.debugBounds = a),
          this.owner.scene.addChild(a);
        for (let t = e; null !== t; t = t.next)
          this.createBounds(t, this.option.color, a);
        let u = _.World;
        this.debugBounds.active =
          u.showDebugBounds || null == u.showDebugBounds;
      }
      setFriction(t) {
        for (let e = this.body.shapes; e; e = e.next) e.friction = t;
      }
      setLinearVelocityConstraint(t) {
        this.body.linearVelocityConstraint = t;
      }
      setLinearVelocityMax(t) {
        this.body.linearVelocityMax = t;
      }
      setAngularVelocityConstraint(t) {
        this.body.angularVelocityConstraint = t;
      }
      setAngularVelocityMax(t) {
        this.body.angularVelocityMax = t;
      }
      setGravity(t) {
        this.body.overrideGravity = t;
      }
    }
    class Xt extends Laya.Material {
      constructor() {
        super(),
          Xt.initShader(),
          this.setShaderName("OutlineMaterial"),
          this._shaderValues.setNumber(Xt.OUTLINEWIDTH, 0.00621197),
          this._shaderValues.setNumber(Xt.OUTLINELIGHTNESS, 1),
          this._shaderValues.setVector(
            Xt.OUTLINECOLOR,
            new Laya.Vector4(1, 1, 1, 0)
          ),
          this._shaderValues.setBool(Xt.DISABLEOUTLINE, !1);
      }
      static __init__() {}
      get albedoTexture() {
        return this._shaderValues.getTexture(Xt.ALBEDOTEXTURE);
      }
      set albedoTexture(t) {
        this._shaderValues.setTexture(Xt.ALBEDOTEXTURE, t);
      }
      get outlineColor() {
        return this._shaderValues.getVector(Xt.OUTLINECOLOR);
      }
      set outlineColor(t) {
        this._shaderValues.setVector(Xt.OUTLINECOLOR, t);
      }
      get outlineWidth() {
        return this._shaderValues.getNumber(Xt.OUTLINEWIDTH);
      }
      set outlineWidth(t) {
        (t = Math.max(0, Math.min(0.05, t))),
          this._shaderValues.setNumber(Xt.OUTLINEWIDTH, t);
      }
      get outlineLightness() {
        return this._shaderValues.getNumber(Xt.OUTLINELIGHTNESS);
      }
      set outlineLightness(t) {
        (t = Math.max(0, Math.min(1, t))),
          this._shaderValues.setNumber(Xt.OUTLINELIGHTNESS, t);
      }
      set disableOutline(t) {
        this._shaderValues.setBool(Xt.DISABLEOUTLINE, t);
      }
      clone() {
        var t = new Xt();
        return this.cloneTo(t), t;
      }
      static initShader() {
        if (Xt.inited) return;
        (Xt.inited = !0), Xt.__init__();
        var t = {
            a_Position: Laya.VertexMesh.MESH_POSITION0,
            a_Normal: Laya.VertexMesh.MESH_NORMAL0,
            a_Texcoord0: Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
          },
          e = {
            u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
            u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
            u_OutlineWidth: Laya.Shader3D.PERIOD_MATERIAL,
            u_OutlineColor: Laya.Shader3D.PERIOD_MATERIAL,
            u_OutlineLightness: Laya.Shader3D.PERIOD_MATERIAL,
            u_AlbedoTexture: Laya.Shader3D.PERIOD_MATERIAL,
            u_DisableOutline: Laya.Shader3D.PERIOD_MATERIAL,
          },
          a = Laya.Shader3D.add("OutlineMaterial"),
          n = new Laya.SubShader(t, e);
        a.addSubShader(n);
        n.addShaderPass(
          '\n        #include "Lighting.glsl"\n        attribute vec4 a_Position;\n        attribute vec3 a_Normal;\n        \n        uniform mat4 u_MvpMatrix; \n        uniform float u_OutlineWidth;\n        \n        void main() \n        {\n            float w = u_OutlineWidth;\n            w = w * a_Position.z / 0.0955;\n            vec4 position = vec4(a_Position.xyz + a_Normal * w, 1.0);\n            gl_Position = u_MvpMatrix * position;\n            gl_Position=remapGLPositionZ(gl_Position);\n        }',
          "\n        #ifdef FSHIGHPRECISION\n            precision highp float;\n        #else\n           precision mediump float;\n        #endif\n        uniform vec4 u_OutlineColor; \n        uniform float u_OutlineLightness;\n        uniform bool u_DisableOutline;\n    \n        void main()\n        {\n            if (u_DisableOutline) {\n                discard;\n            }\n           vec3 finalColor = u_OutlineColor.rgb * u_OutlineLightness;\n           gl_FragColor = vec4(finalColor,0.0); \n        }"
        ).renderState.cull = Laya.RenderState.CULL_FRONT;
        n.addShaderPass(
          '\n        #include "Lighting.glsl"\n\n        attribute vec4 a_Position; \n        attribute vec2 a_Texcoord0;\n        \n        uniform mat4 u_MvpMatrix;\n        uniform mat4 u_WorldMat;\n\n        attribute vec3 a_Normal; \n        varying vec3 v_Normal; \n        varying vec2 v_Texcoord0; \n        \n        void main() \n        {\n           gl_Position = u_MvpMatrix * a_Position;\n           mat3 worldMat=mat3(u_WorldMat); \n           v_Normal=worldMat*a_Normal; \n           v_Texcoord0 = a_Texcoord0;\n           gl_Position=remapGLPositionZ(gl_Position); \n        }',
          "\n        #ifdef FSHIGHPRECISION\n            precision highp float;\n        #else\n            precision mediump float;\n        #endif\n        varying vec2 v_Texcoord0;\n        varying vec3 v_Normal;\n        \n        uniform sampler2D u_AlbedoTexture;\n\n        void main()\n        {\n            vec4 albedoTextureColor = vec4(1.0);\n            albedoTextureColor = texture2D(u_AlbedoTexture, v_Texcoord0);\n            gl_FragColor=albedoTextureColor;\n        }"
        );
      }
    }
    (Xt.ALBEDOTEXTURE = Laya.Shader3D.propertyNameToID("u_AlbedoTexture")),
      (Xt.OUTLINECOLOR = Laya.Shader3D.propertyNameToID("u_OutlineColor")),
      (Xt.OUTLINEWIDTH = Laya.Shader3D.propertyNameToID("u_OutlineWidth")),
      (Xt.OUTLINELIGHTNESS =
        Laya.Shader3D.propertyNameToID("u_OutlineLightness")),
      (Xt.DISABLEOUTLINE = Laya.Shader3D.propertyNameToID("u_DisableOutline"));
    var Yt = Laya.Sprite3D;
    class qt {
      static locateSprite3D(t, e, n = a.ZERO) {
        let u = this.sN,
          m = this.sT,
          f = this.sRotMatY,
          p = this.sRotMatX;
        Laya.Matrix4x4.createLookAt(e.n, a.ZERO, e.up, p),
          p.setPosition(a.ZERO),
          p.invert(f),
          a.transformV3ToV3(n, f, u),
          a.add(e.center, u, m);
        let y = t,
          g = y.__origXfm;
        g ||
          ((g = t.transform.worldMatrix.clone()),
          g.setPosition(a.ZERO),
          (y.__origXfm = g)),
          Laya.Matrix4x4.multiply(f, g, p),
          (t.transform.worldMatrix = p),
          t.transform.translate(m, !1);
      }
      static randomDirInCone(t, e) {
        let n = this.sN,
          u = n,
          m = Math.sin(Math.rad(e)),
          f = Math.cos(Math.rad(e));
        Laya.ShapeUtils._randomPointInsideUnitCircle(u),
          (n.x = u.x * m),
          (n.z = u.y * m),
          (n.y = f),
          a.normalize(n, n);
        let p = t.clone();
        a.normalize(p, p);
        let y = w.getDotRadian(a.Up, p);
        a.cross(a.Up, p, p), a.normalize(p, p);
        let g = this.sRotMatY;
        return (
          Laya.Matrix4x4.createRotationAxis(p, y, g),
          a.TransformNormal(n, g, p),
          p
        );
      }
      static createPlane(t, e, a) {
        let n = Laya.PrimitiveMesh.createPlane(t, e, 1, 1),
          u = new Laya.MeshSprite3D(n);
        return (u.meshRenderer.material = a || new Laya.UnlitMaterial()), u;
      }
      static genBpMaterial(t, e, a, n, u) {
        let m = new Laya.BlinnPhongMaterial();
        function anonymous(f) {
          if (!f || m.destroyed) return;
          let y = f.bitmap;
          if (
            (y
              ? ((m.albedoTexture = y), Laya.loader.clearRes(t))
              : ((y = f), (m.albedoTexture = y)),
            null != e && (m.renderMode = e),
            null != a && (y.wrapModeU = a),
            null != n && (y.wrapModeV = n),
            u)
          ) {
            m._addReference();
          } else m.lock = !1;
          m.event(p.E_MATERIAL_LOADED);
        }
        m.lock = !0;
        let f = Laya.loader.getRes(t);
        return (
          f
            ? anonymous(f)
            : Laya.loader.load(t, Laya.Handler.create(this, anonymous)),
          m
        );
      }
      static genUnlitMaterial(t, e, a, n, u) {
        let m = new Laya.UnlitMaterial();
        function anonymous(f) {
          if (!f || m.destroyed) return;
          let y = f.bitmap;
          if (
            (y
              ? ((m.albedoTexture = y), Laya.loader.clearRes(t))
              : ((y = f), (m.albedoTexture = y)),
            null != e && (m.renderMode = e),
            null != a && (y.wrapModeU = a),
            null != n && (y.wrapModeV = n),
            u)
          ) {
            m._addReference();
          } else m.lock = !1;
          m.event(p.E_MATERIAL_LOADED);
        }
        m.lock = !0;
        let f = Laya.loader.getRes(t);
        return (
          f
            ? anonymous(f)
            : Laya.loader.load(t, Laya.Handler.create(this, anonymous)),
          m
        );
      }
      static effFadeInOut(t, e, a, n = 1, u = 0, m) {
        t instanceof Laya.MeshSprite3D &&
          this.effFadeInOutMesh(t, e, a, n, u, m);
        let f = t.getChildren();
        for (const t of f) this.effFadeInOut(t, e, a, n, u, m);
      }
      static effFadeInOutMesh(t, e, a, n = 1, u = 0, m) {
        let f,
          p = t;
        p.__fade_in_out_eff
          ? ((f = p.__fade_in_out_eff.material),
            Laya.Tween.clear(p.__fade_in_out_eff.tween))
          : ((f = t.meshRenderer.material),
            (p.__fade_in_out_eff = { alpha: f._ColorA }));
        let anifunc = function () {
          p.__fade_in_out_eff.tween = Laya.Tween.to(
            f,
            { _ColorA: u },
            e >> 1,
            null,
            Laya.Handler.create(this, () => {
              p.__fade_in_out_eff.tween = Laya.Tween.to(
                f,
                { _ColorA: n },
                e >> 1,
                null,
                Laya.Handler.create(this, () => {
                  a ? anifunc() : (qt.stopFadeInOutEffMesh(t), m && m.run());
                })
              );
            })
          );
        };
        anifunc(), t.once(Laya.Event.REMOVED, this, this.stopFadeInOutEff, [t]);
      }
      static stopFadeInOutEff(t) {
        t instanceof Laya.MeshSprite3D && this.stopFadeInOutEffMesh(t);
        let e = t.getChildren();
        for (const t of e) this.stopFadeInOutEff(t);
      }
      static stopFadeInOutEffMesh(t) {
        let e = t;
        if (e.__fade_in_out_eff) {
          (t.meshRenderer.material._ColorA = e.__fade_in_out_eff.alpha),
            Laya.Tween.clear(e.__fade_in_out_eff.tween),
            (e.__fade_in_out_eff = null),
            t.off(Laya.Event.REMOVED, this, this.stopFadeInOutEff);
        }
      }
      static asyncProcess(t, e, a = 30) {
        const clearFunc = () => {
            Laya.timer.clear(this, loopFunc),
              t.off(Laya.Event.REMOVED, this, clearFunc);
          },
          loopFunc = () => {
            Laya.stage.getTimeFromFrameStart() > a || (e.run() && clearFunc());
          };
        Laya.timer.frameLoop(1, this, loopFunc),
          t.once(Laya.Event.REMOVED, this, clearFunc);
      }
      static enableShadow(t, e = !1) {
        w.recurisNode(t, (t) => {
          let a = w.getSpRenderer(t);
          a && ((a.castShadow = !0), (a.receiveShadow = e));
        });
      }
      static receiveShadow(t, e = !0) {
        w.recurisNode(t, (t) => {
          let a = w.getSpRenderer(t);
          a && (a.receiveShadow = e);
        });
      }
      static setMaterial(t, e, a) {
        let n = w.getSpRenderer(t);
        a ? (n.sharedMaterial = e) : (n.material = e);
        let u = t.getChildren();
        for (const t of u) this.setMaterial(t, e, a);
      }
      static createShadow(t, e, a) {
        if (!t) return;
        let n = this.genUnlitMaterial(t, 2);
        return this.createPlane(e, a, n);
      }
      static gradientColorAnim(t, e, a, n = !0, u = !1, m) {
        let f = t;
        if (f.__color_anim || 0 == e.length) return;
        (f.__color_anim = { tween: null }), (a /= e.length);
        let p = w.getSpMaterial(t, u);
        (e = w.cloneArray(e)).unshift(p.albedoColor);
        let y = e[0].clone();
        const g = new Laya.Handler(this, function () {
          p.albedoColor = y;
        });
        let _ = 1;
        const anonymous = function () {
          let u = e[_];
          f.__color_anim.tween = Laya.Tween.to(
            y,
            { x: u.x, y: u.y, z: u.z, update: g },
            a,
            null,
            Laya.Handler.create(this, () => {
              _++,
                _ == e.length
                  ? n
                    ? ((_ = 0), anonymous())
                    : (qt.stopColorAnim(t), m && m.run())
                  : anonymous();
            })
          );
        };
        t.once(Laya.Event.REMOVED, this, this.stopColorAnim, [t]), anonymous();
      }
      static stopColorAnim(t) {
        let e = t;
        e.__color_anim &&
          (t.off(Laya.Event.REMOVED, this, this.stopColorAnim),
          Laya.Tween.clear(e.__color_anim.tween),
          (e.__color_anim = null));
      }
      static faceTo(t, e, n = !1) {
        e.getComponent(Laya.Animator) &&
          console.warn(
            "faceWith|faceTo: Animator Component found, unexpected!"
          ),
          (t = this.sT.from(t));
        let u = e.parent;
        n && u instanceof Yt && u.transform.globalToLocal(t, t),
          e.transform.lookAt(t, a.Up, n);
      }
      static faceWith(t, e, n) {
        if ((t = this.sN.from(t)).isZero()) return;
        let u = this.sT;
        a.add(e.transform.position, t, u), this.faceTo(u, e, n);
      }
      static limitLookAt(t, e, n, u, m, f) {
        let p = t,
          y = t.transform.localRotationEulerX,
          g = t.transform.localRotationEulerY;
        if (f) {
          if (
            !p.__face_limit ||
            !p.__face_limit.specDir ||
            !a.equals(f, p.__face_limit.specDir)
          ) {
            let t = this.sN.from(f);
            (t.x = 0), t.normalize();
            let e = Math.deg(w.getDotRadianEx(a.UnitZ, t));
            t.from(f), (t.y = 0), t.normalize();
            let n = Math.deg(w.getDotRadianEx(a.UnitZ, t));
            p.__face_limit = { rawEulerX: e, rawEulerY: n, specDir: f.clone() };
          }
        } else
          p.__face_limit || (p.__face_limit = { rawEulerX: y, rawEulerY: g });
        let _ = p.__face_limit.rawEulerX,
          x = p.__face_limit.rawEulerY;
        if (w.isNumber(e) && w.isNumber(n)) {
          let a = _ - e,
            u = _ + n;
          t.transform.localRotationEulerX = Math.clamp(y, a, u);
        }
        if (w.isNumber(u) && w.isNumber(m)) {
          let e = x - m,
            a = x + u;
          t.transform.localRotationEulerY = Math.clamp(g, e, a);
        }
      }
      static clearLookAtLimit(t) {
        t.__face_limit = void 0;
      }
      static addAnimatorScript(t, e, a, n = 0, u) {
        let m = t.getComponent(Laya.Animator);
        for (const f of m._controllerLayers) {
          let m = f._statesMap,
            p = [];
          for (const f in m) {
            let y = m[f],
              g = y.getScript(Ht);
            g || (g = y.addScript(Ht)),
              p.push(g),
              g.setName(y.name),
              g.setLayer(n),
              g.setOwner(t),
              g.setDebug(u),
              g.setAllStateScripts(p),
              e && a && g.setListener(e);
          }
        }
        e && a && e.on(p.E_ANIM_STATE_CHENGED, a.caller, a.method, a.args);
      }
      static addAnimatorEventScript(t, e, a) {
        let n = t.getComponent(Ft);
        n || (n = t.addComponent(Ft)),
          n.setListener(e),
          e && a && e.on(p.E_ANIM_EVENT, a.caller, a.method);
      }
      static effSplash(t, e, a) {
        let n = t;
        if (n.__splash_eff) return;
        let u = 0.001 * e,
          m = 0,
          updateFunc = function () {
            (m += w.getFrameDelta()),
              m > u &&
                ((t.meshRenderer.enable = !t.meshRenderer.enable), (m = 0));
          };
        t.frameLoop(1, this, updateFunc),
          (n.__splash_eff = updateFunc),
          t.once(Laya.Event.REMOVED, this, this.stopSplashEff, [t]);
      }
      static stopSplashEff(t) {
        let e = t;
        e.__splash_eff &&
          ((t.meshRenderer.enable = !0),
          t.clearTimer(this, e.__splash_eff),
          (e.__splash_eff = null),
          t.off(Laya.Event.REMOVED, this, this.stopSplashEff));
      }
      static destroyBySign(t, e) {
        let a = Laya.Pool._poolDic;
        if (e) {
          for (const e in a)
            if (-1 != e.indexOf(t)) {
              let t = a[e];
              for (const e of t) e.destroy();
              t.clear(), delete a[e];
            }
          return;
        }
        let n = Laya.Pool.getPoolBySign(t);
        for (const t of n) t.destroy();
        n.clear(), delete a[t];
      }
      static checkPoolBySign(t) {
        return Laya.Pool._poolDic[t];
      }
      static moveAnim(t, e, a, n, u = 0, m, f, p, y) {
        let g = t;
        if (!g || g.__move_anim) return;
        (e = e.clone()), (a = a.clone()), (n *= 1e3), (u *= 1e3);
        let _ = e.clone();
        f ? (t.transform.localPosition = _) : (t.transform.position = _);
        let x = new Laya.Handler(this, function () {
            f ? (t.transform.localPosition = _) : (t.transform.position = _);
          }),
          exec = function (u, f) {
            let y = (u = !u) ? e : a;
            g.__move_anim = Laya.Tween.to(
              _,
              { x: y.x, y: y.y, z: y.z, update: x },
              n,
              null,
              Laya.Handler.create(this, function () {
                m ? exec(u, 0) : (qt.stopMoveAnim(t), p && p.run());
              }),
              f
            );
          };
        exec(!0, u), t.once(Laya.Event.REMOVED, this, this.stopMoveAnim, [t]);
      }
      static stopMoveAnim(t) {
        let e = t,
          a = e.__move_anim;
        a &&
          (Laya.Tween.clear(a),
          t.off(Laya.Event.REMOVED, this, this.stopMoveAnim),
          (e.__move_anim = null));
      }
      static jumpAnim(t, e, n, u, m, f = 0, p, y, g, _) {
        let x = t;
        if (!x || x.__jump_anim) return;
        (e = e.clone()), (n = n.clone());
        let b = [],
          v = new a(),
          S = this.sN,
          C = this.sT;
        a.subtract(n, e, C);
        let E = 0.5 * a.scalarLength(C);
        C.normalize(),
          a.cross(C, a.Up, S),
          S.normalize(),
          a.cross(S, C, S),
          S.normalize(u),
          C.normalize(E),
          a.add(e, C, C),
          a.add(C, S, v),
          b.push(e, v, n),
          (m *= 1e3),
          (f *= 1e3);
        let z = { t: 0 };
        y ? (t.transform.localPosition = e) : (t.transform.position = e);
        let A = new Laya.Handler(this, function () {
            let e = w.calcBezierPointEx(z.t, b);
            y ? (t.transform.localPosition = e) : (t.transform.position = e),
              _ && _();
          }),
          exec = function (e, a) {
            let n = (e = !e) ? 0 : 1;
            x.__jump_anim = Laya.Tween.to(
              z,
              { t: n, update: A },
              m,
              null,
              Laya.Handler.create(this, function () {
                p ? exec(e, 0) : (qt.stopJumpAnim(t), g && g.run());
              }),
              a
            );
          };
        exec(!0, f), t.once(Laya.Event.REMOVED, this, this.stopJumpAnim, [t]);
      }
      static stopJumpAnim(t) {
        let e = t,
          a = e.__jump_anim;
        a &&
          (Laya.Tween.clear(a),
          t.off(Laya.Event.REMOVED, this, this.stopJumpAnim),
          (e.__jump_anim = null));
      }
      static moveFollow(t, e, n, u, m, f, p) {
        let y = t;
        if (!y || y.__move_follow_anim) return;
        (n = n || 0.1), (u = u || 0.1);
        let g = this.sT,
          updateFunc = function () {
            if (t.destroyed || e.destroyed)
              return void qt.stopFollowAnim(t, e, !1);
            let y = t.transform.position,
              _ = e.transform.position;
            if (
              (f && (a.add(_, f, g), (_ = g)),
              a.subtract(_, y, g),
              a.scalarLengthSquared(g) < u)
            )
              this.stopFollowAnim(t, e, p), m && m.run();
            else {
              let e = Math.min(n, a.scalarLength(g));
              g.normalize(e), a.add(y, g, g), (t.transform.position = g);
            }
          };
        t.frameLoop(1, this, updateFunc),
          (y.__move_follow_anim = updateFunc),
          t.once(Laya.Event.REMOVED, this, this.stopFollowAnim, [t, e, p]);
        let _ = e;
        _.__move_follow_anim
          ? _.__move_follow_anim.push(t)
          : (_.__move_follow_anim = [t]),
          e.once(Laya.Event.REMOVED, this, this.stopFollowAnim, [null, e, p]);
      }
      static stopFollowAnim(t, e, a) {
        let n = t;
        if (n) {
          let u = n.__move_follow_anim;
          if (u) {
            w.getDefault3dScene().clearTimer(this, u),
              t.off(Laya.Event.REMOVED, this, this.stopFollowAnim),
              (n.__move_follow_anim = null);
            let m = e,
              f = m.__move_follow_anim,
              p = f.indexOf(t);
            -1 != p && f.splice(p, 1),
              a && t.destroy(),
              0 == f.length &&
                (e.off(Laya.Event.REMOVED, this, this.stopFollowAnim),
                (m.__move_follow_anim = null));
          }
        } else {
          let a = e;
          if (a.__move_follow_anim) {
            let n = a.__move_follow_anim,
              u = n.length;
            for (; u--; ) (t = n[u]), this.stopFollowAnim(t, e, !0);
            a.__move_follow_anim = null;
          }
        }
      }
      static moveToTarget(t, e, n, u = 0, m) {
        let f = { p: 0 },
          p = new a();
        a.subtract(t.transform.position, e.transform.position, p);
        let y = a.scalarLength(p),
          g = new Laya.Handler(this, () => {
            if (t.destroyed || e.destroyed) return;
            this.sN.from(p);
            let n = y * (1 - f.p);
            n > 0.001 ? this.sN.normalize(n) : this.sN.from(a.ZERO);
            let u = t.transform.position;
            a.add(e.transform.position, this.sN, u), (t.transform.position = u);
          });
        (t.__MoveToTarget = Laya.Tween.to(
          f,
          { p: 1, update: g },
          1e3 * n,
          null,
          Laya.Handler.create(this, () => {
            qt.stopMoveToTarget(t), m && m.run();
          }),
          1e3 * u
        )),
          t.on(Laya.Event.REMOVED, this, this.stopMoveToTarget, [t]);
      }
      static stopMoveToTarget(t) {
        if (t.__MoveToTarget) {
          let e = t.__MoveToTarget;
          Laya.Tween.clear(e),
            t.off(Laya.Event.REMOVED, this, this.stopMoveToTarget),
            (t.__MoveToTarget = null);
        }
      }
      static jumpToTarget(t, e, n, u, m, f = 0, p = 0.5, y, g) {
        if (!t || t.__jump_anim) return;
        let _ = { p: 0 },
          x = t.transform.position.clone(),
          b = new Laya.Handler(this, function () {
            if (t.destroyed || e.destroyed) return;
            let m = e.transform.position.clone();
            a.add(m, n, m);
            let f = [],
              y = new a(),
              g = this.sN,
              b = this.sT;
            a.subtract(m, x, b);
            let v = a.scalarLength(b) * p;
            b.normalize(),
              a.cross(b, a.Up, g),
              g.normalize(),
              a.cross(g, b, g),
              g.normalize(u),
              b.normalize(v),
              a.add(x, b, b),
              a.add(b, g, y),
              f.push(x, y, m);
            let S = w.calcBezierPointEx(_.p, f);
            t.transform.position = S;
          });
        (t.__JumpToTarget = Laya.Tween.to(
          _,
          { p: 1, update: b },
          1e3 * m,
          y,
          Laya.Handler.create(this, () => {
            qt.stopJumpToTarget(t), g && g.run();
          }),
          1e3 * f
        )),
          t.once(Laya.Event.REMOVED, this, this.stopJumpToTarget, [t]);
      }
      static stopJumpToTarget(t) {
        if (t.__JumpToTarget) {
          let e = t.__JumpToTarget;
          Laya.Tween.clear(e),
            t.off(Laya.Event.REMOVED, this, this.stopJumpToTarget),
            (t.__JumpToTarget = null);
        }
      }
      static rotateAnim(t, n, u, m = 0, f = "y", p = !0, y = !0, g, _, x) {
        let b = t;
        if (!b || b.__rotate_anim) return;
        (u *= 1e3), (m *= 1e3);
        let v = new a(),
          w = new e(),
          S = t.getComponent(jt),
          C = new Laya.Handler(this, function () {
            (v[f] = w.x - w.y),
              (w.y = w.x),
              t.transform.rotate(v, y, !1),
              _ && S && S.syncToBody(!0);
          }),
          exec = function () {
            b.__rotate_anim = Laya.Tween.to(
              w,
              { x: n, update: C },
              u,
              x,
              Laya.Handler.create(this, function () {
                (w.y = w.x = 0),
                  p ? exec() : (qt.stopRotateAnim(t), g && g.run());
              }),
              m
            );
          };
        exec(),
          (m = 0),
          t.on(Laya.Event.REMOVED, this, this.stopRotateAnim, [t]);
      }
      static stopRotateAnim(t) {
        let e = t;
        if (e.__rotate_anim) {
          let a = e.__rotate_anim;
          Laya.Tween.clear(a),
            t.off(Laya.Event.REMOVED, this, this.stopRotateAnim),
            (e.__rotate_anim = null);
        }
      }
      static rotateQuaternion(t, e, a, n = 0, u) {
        let m = { p: 0 },
          f = t.transform.rotation.clone(),
          p = new Laya.Handler(this, () => {
            let a = t.transform.rotation;
            Laya.Quaternion.lerp(f, e, m.p, a), (t.transform.rotation = a);
          });
        (t.__RotateQuaternion = Laya.Tween.to(
          m,
          { p: 1, update: p },
          1e3 * a,
          null,
          Laya.Handler.create(this, () => {
            qt.stopRotateQuaternion(t), u && u.run();
          }),
          1e3 * n
        )),
          t.on(Laya.Event.REMOVED, this, this.stopRotateQuaternion, [t]);
      }
      static stopRotateQuaternion(t) {
        if (t.__RotateQuaternion) {
          let e = t.__RotateQuaternion;
          Laya.Tween.clear(e),
            t.off(Laya.Event.REMOVED, this, this.stopRotateQuaternion),
            (t.__RotateQuaternion = null);
        }
      }
      static scaleAnim(t, e, n, u = 0, m) {
        let f = t;
        if (!f || f.__scale_anim) return;
        (n *= 1e3), (u *= 1e3);
        let p = new a(),
          y = t.transform.getWorldLossyScale();
        p.from(y);
        let g = new Laya.Handler(this, function () {
          t.transform.setWorldLossyScale(p);
        });
        (f.__scale_anim = Laya.Tween.to(
          p,
          { x: e.x, y: e.y, z: e.z, update: g },
          n,
          null,
          Laya.Handler.create(this, function () {
            qt.stopScaleAnim(t), m && m.run();
          }),
          u
        )),
          t.once(Laya.Event.REMOVED, this, this.stopScaleAnim, [t]);
      }
      static stopScaleAnim(t) {
        let e = t,
          a = e.__scale_anim;
        a &&
          (Laya.Tween.clear(a),
          t.off(Laya.Event.REMOVED, this, this.stopScaleAnim),
          (e.__scale_anim = null));
      }
      static setBoundBoxPos(t, e, n = !0, u) {
        let m = this.sT;
        t.getExtent(m);
        let f = this.sN;
        if (n)
          f.from(e),
            u &&
              (-1 != u.indexOf("x") && (f.x = 0),
              -1 != u.indexOf("y") && (f.y = 0),
              -1 != u.indexOf("z") && (f.z = 0)),
            t.setCenterAndExtent(f, m);
        else {
          let n = t;
          n.__anchor_delta || (t.getCenter(f), (n.__anchor_delta = f.clone())),
            f.from(n.__anchor_delta),
            u &&
              (-1 != u.indexOf("x") && (f.x = 0),
              -1 != u.indexOf("y") && (f.y = 0),
              -1 != u.indexOf("z") && (f.z = 0)),
            a.add(e, f, f),
            t.setCenterAndExtent(f, m);
        }
      }
      static playParticleSp(t, e = !0) {
        if (t instanceof Laya.ShuriKenParticle3D)
          (t.particleSystem.looping = e), t.play();
        else {
          let a = t.numChildren;
          for (; a--; ) {
            let n = t.getChildAt(a);
            (n.particleSystem.looping = e), n.play();
          }
        }
        t.__isParticlePlaying = !0;
      }
      static isParticleSpPlaying(t) {
        return t.__isParticlePlaying;
      }
      static stopParticleSp(t) {
        if (t instanceof Laya.ShuriKenParticle3D) t.stop();
        else {
          let e = t.numChildren;
          for (; e--; ) {
            t.getChildAt(e).stop();
          }
        }
        t.__isParticlePlaying = !1;
      }
      static setParticleColor(t, e) {
        t instanceof Laya.ShuriKenParticle3D &&
          (t.particleSystem.startColorConstant = e);
        let a = t.numChildren;
        for (; a--; ) {
          t.getChildAt(a).particleSystem.startColorConstant = e;
        }
      }
      static fade3D(t, e, a) {
        let n = t.meshRenderer.sharedMaterial;
        0 != e
          ? ((t.__fade3D_anim = Laya.Tween.to(
              n,
              { albedoColorA: a },
              1e3 * e,
              null,
              Laya.Handler.create(this, function () {
                (n.albedoColorA = a), qt.stopFade3D(t);
              })
            )),
            t.once(Laya.Event.REMOVED, this, this.stopFade3D, [t]))
          : (n.albedoColorA = a);
      }
      static stopFade3D(t) {
        let e = t,
          a = e.__fade3D_anim;
        a &&
          (Laya.Tween.clear(a),
          e.off(Laya.Event.REMOVED, this, this.stopFade3D),
          (e.__fade3D_anim = null));
      }
      static effColorSplash(t, e, a) {
        let n = t;
        if (n.__color_splash_anim) return;
        let u = w.getSpMaterial(t),
          m = u.shininess;
        (n.__color_splash_anim = { tween: null, shininess: m }),
          u instanceof Laya.PBRStandardMaterial &&
            (n.__color_splash_anim.emissionColor = u.emissionColor),
          (u.shininess = 0);
        let f = e.clone();
        const p = new Laya.Handler(this, function () {
          (u.specularColor = f),
            u instanceof Laya.PBRStandardMaterial && (u.emissionColor = f);
        });
        t.once(Laya.Event.REMOVED, this, this.stopColorSplashAnim, [t]),
          (function () {
            n.__color_splash_anim.tween = Laya.Tween.to(
              f,
              { x: 0, y: 0, z: 0, update: p },
              a,
              null,
              Laya.Handler.create(this, () => {
                qt.stopColorSplashAnim(t);
              })
            );
          })();
      }
      static stopColorSplashAnim(t) {
        let e = t;
        if (e.__color_splash_anim) {
          t.off(Laya.Event.REMOVED, this, this.stopColorSplashAnim);
          let a = w.getSpMaterial(t);
          (a.shininess = e.__color_splash_anim.shininess),
            a instanceof Laya.PBRStandardMaterial &&
              (a.emissionColor = e.__color_splash_anim.emissionColor),
            Laya.Tween.clear(e.__color_splash_anim.tween),
            (e.__color_splash_anim = null);
        }
      }
      static outline(t, e, a) {
        let n = w.getSpRenderer(t);
        if (n.material instanceof Xt) return;
        let u = new Xt();
        (u.albedoTexture = n.material.albedoTexture),
          e && (u.outlineColor = e),
          a && (u.outlineWidth = a),
          (n.material = u);
      }
      static screenShot() {
        let t = w.getDefaultCamera(),
          e = t._getRenderTextureFormat(),
          a = Laya.RenderContext3D.clientWidth,
          n = Laya.RenderContext3D.clientHeight,
          u = new Laya.RenderTexture(
            a,
            n,
            e,
            Laya.RenderTextureDepthFormat.DEPTH_16
          );
        (t.renderTarget = u), t.render(), (t.renderTarget = null);
        let m = new Uint8Array(a * n * 4);
        u.getData(0, 0, a, n, m), u.destroy();
        let f = new Laya.Texture2D(a, n, Laya.TextureFormat.R8G8B8A8, !1, !1);
        return f.setPixels(m), new Laya.Texture(f);
      }
      static enableMeshRender(t, e) {
        w.recurisNode(t, (t) => {
          t instanceof Laya.MeshSprite3D && (t.meshRenderer.enable = e);
        });
      }
      static dirOnConeEdge(t, e, n) {
        let u = this.sN,
          m = u,
          f = Math.sin(Math.rad(e)),
          p = Math.cos(Math.rad(e));
        (m.x = Math.cos(Math.rad(n))),
          (m.y = Math.sin(Math.rad(n))),
          (u.x = m.x * f),
          (u.z = m.y * f),
          (u.y = p),
          a.normalize(u, u);
        let y = t.clone();
        a.normalize(y, y);
        let g = fx.Utils.getDotRadian(a.Up, y);
        a.cross(a.Up, y, y), a.normalize(y, y);
        let _ = this.sRotMatY;
        return (
          Laya.Matrix4x4.createRotationAxis(y, g, _),
          a.TransformNormal(u, _, y),
          y
        );
      }
      static convertRotationFromRToL(t) {
        let e = this.sRotMatX;
        return (
          Laya.Matrix4x4.createFromQuaternion(t, e),
          Laya.Matrix4x4.multiply(this.convertRToLMat4x4, e, e),
          Laya.Matrix4x4.multiply(e, this.convertRToLMat4x4, e),
          Laya.Quaternion.createFromMatrix4x4(e, t),
          t
        );
      }
      static getChildrenByInstance(t, e, a) {
        let n = [];
        const anonymous = function (t) {
          for (const u of e)
            t instanceof u && ((a && -1 != t.name.indexOf(a)) || n.push(t));
          let u = t.getChildren();
          for (const t of u) anonymous(t);
        };
        return anonymous(t), n;
      }
      static getChildrenByCompoent(t, e, a = !1) {
        let n = [],
          u = t.getChildren();
        for (const t of u) {
          t.getComponent(e) && n.push(t);
        }
        if (a) {
          t.getComponent(e) && n.push(t);
        }
        return n;
      }
      static seekChildrenByCompoent(t, e, a = !1) {
        let n = [];
        const anonymous = function (t) {
          t.getComponent(e) && n.push(t);
          let a = t.getChildren();
          for (const t of a) anonymous(t);
        };
        let u = t.getChildren();
        for (const t of u) anonymous(t);
        if (a) {
          t.getComponent(e) && n.push(t);
        }
        return n;
      }
      static changeModelTexColor(t, e, a = "#FFFFFF", u, m) {
        let f,
          p = t;
        (p.__eff_change_texture_color && e) ||
          (e
            ? ((p.__eff_change_texture_color = !0),
              (f = new Laya.ColorFilter()),
              f.setColor(a),
              (f.specColor = new n(e.x / 255, e.y / 255, e.z / 255, e.w)))
            : (p.__eff_change_texture_color = void 0),
          (m = m || new n(1, 1, 1, 1)),
          w.recurisNode(t, (t) => {
            let e = w.getSpMaterials(t);
            if (e && e.length > 0)
              for (const t of e) {
                let e = t;
                f
                  ? ((t.colorFilter = f),
                    u &&
                      ((e.__rawIntensity = t.albedoIntensity),
                      (t.albedoIntensity = u)),
                    (e.__rawColor = t.albedoColor),
                    (t.albedoColor = m))
                  : ((t.colorFilter = void 0),
                    e.__rawIntensity &&
                      ((t.albedoIntensity = e.__rawIntensity),
                      (e.__rawIntensity = void 0)),
                    e.__rawColor &&
                      ((t.albedoColor = e.__rawColor),
                      (e.__rawColor = void 0)));
              }
          }));
      }
      static changeModelColor(t, e, a) {
        let n,
          u = t;
        (u.__eff_change_color && e) ||
          (e
            ? ((u.__eff_change_color = !0), (n = w.colorHexTo4F(e)))
            : (u.__eff_change_color = void 0),
          w.recurisNode(t, (t) => {
            let e = w.getSpMaterials(t);
            if (e && e.length > 0)
              for (const t of e) {
                let e = t;
                n
                  ? ((e.__rawColor = t.albedoColor.clone()),
                    (t.albedoColor = n),
                    a &&
                      ((e.__rawIntensity = t.albedoIntensity),
                      (t.albedoIntensity = a)))
                  : e.__rawColor &&
                    ((t.albedoColor = e.__rawColor),
                    (e.__rawColor = void 0),
                    e.__rawIntensity &&
                      ((t.albedoIntensity = e.__rawIntensity),
                      (e.__rawIntensity = void 0)));
              }
          }));
      }
      static transformBounds(t, e, a) {
        return t._tranform(e, a), a;
      }
      static playTillingAnim(t, e, a, n = 0, u, m) {
        let f = fx.Utils.getSpMaterial(t);
        if (f && f.tilingOffset) {
          let p = t;
          if (!p || p.__tilling_anim) return;
          a *= 1e3;
          let y = f.tilingOffset.clone(),
            g = e.clone(),
            _ = f.tilingOffset.clone(),
            x = new Laya.Handler(this, function () {
              f.tilingOffset = _;
            }),
            exec = function (e) {
              let n = g;
              (_ = y.clone()),
                (p.__tilling_anim = Laya.Tween.to(
                  _,
                  { x: n.x, y: n.y, z: n.z, w: n.w, update: x },
                  a,
                  null,
                  Laya.Handler.create(this, function () {
                    u ? exec(0) : (qt.stopTilingAnim(t), m && m.run());
                  }),
                  e
                ));
            };
          exec(n), t.once(Laya.Event.REMOVED, this, this.stopTilingAnim, [t]);
        }
      }
      static stopTilingAnim(t) {
        let e = t,
          a = e.__tilling_anim;
        a &&
          (Laya.Tween.clear(a),
          t.off(Laya.Event.REMOVED, this, this.stopTilingAnim),
          (e.__tilling_anim = null));
      }
      static setColor(t, e) {
        (this.colorMatrix[0] = e.x),
          (this.colorMatrix[6] = e.y),
          (this.colorMatrix[12] = e.z),
          (this.colorMatrix[18] = e.w),
          (t.filters = [new Laya.ColorFilter(this.colorMatrix)]);
      }
      static clone(t, e) {
        let a;
        if (t instanceof Laya.Image)
          (a = new Laya.Image()), this.cloneToImage(t, a, e);
        else if (t instanceof Laya.Box)
          (a = new Laya.Box()), this.cloneToBox(t, a);
        else {
          if (!(t instanceof Laya.Label))
            throw Error("clone type not implement !");
          (a = new Laya.Label()), this.cloneToLabel(t, a);
        }
        let n = t.getChildren();
        for (const t of n) {
          let n = this.clone(t, e);
          a.addChild(n);
        }
        return a;
      }
      static cloneToImage(t, e, a) {
        this.cloneToUIComp(t, e),
          (e.skin = t.skin),
          a && ((e.graphics = t.graphics), (e.source = t.source));
      }
      static cloneToBox(t, e) {
        this.cloneToUIComp(t, e), (e.bgColor = t.bgColor);
      }
      static cloneToLabel(t, e) {
        this.cloneToUIComp(t, e),
          (e.align = t.align),
          (e.bold = t.bold),
          (e.borderColor = t.borderColor),
          (e.color = t.color),
          (e.font = t.font),
          (e.fontSize = t.fontSize),
          (e.italic = t.italic),
          (e.leading = t.leading),
          (e.overflow = t.overflow),
          (e.padding = t.padding),
          (e.text = t.text),
          (e.underline = t.underline),
          (e.underlineColor = t.underlineColor),
          (e.valign = t.valign),
          (e.wordWrap = t.wordWrap);
      }
      static cloneToUIComp(t, e) {
        (e.alpha = t.alpha),
          (e.anchorX = t.anchorX),
          (e.anchorY = t.anchorY),
          (e.autoSize = t.autoSize),
          (e.blendMode = t.blendMode),
          (e.bottom = t.bottom),
          (e.cacheAs = t.cacheAs),
          (e.centerX = t.centerX),
          (e.centerY = t.centerY),
          (e.cid = t.cid),
          (e.customRenderEnable = t.customRenderEnable),
          (e.dataSource = t.dataSource),
          (e.destroyed = !1),
          (e.disabled = t.disabled),
          (e.drawCallOptimize = t.drawCallOptimize),
          t.filters && (e.filters = t.filters.splice(0)),
          (e.gray = t.gray),
          (e.height = t.height),
          (e.hitArea = t.hitArea),
          (e.hitTestPrior = t.hitTestPrior),
          (e.left = t.left),
          (e.mask = t.mask),
          (e.mouseEnabled = t.mouseEnabled),
          (e.mouseThrough = t.mouseThrough),
          (e.name = t.name),
          (e.pivotX = t.pivotX),
          (e.pivotY = t.pivotY),
          (e.right = t.right),
          (e.rotation = t.rotation),
          (e.scaleX = t.scaleX),
          (e.scaleY = t.scaleY),
          (e.scrollRect = t.scrollRect),
          (e.skewX = t.skewX),
          (e.skewY = t.skewY),
          (e.staticCache = t.staticCache),
          (e.tag = t.tag),
          (e.texture = t.texture),
          (e.toolTip = t.toolTip),
          (e.top = t.top),
          t.transform && (e.transform = t.transform.clone()),
          t.viewport && (e.viewport = t.viewport.clone()),
          (e.visible = t.visible),
          (e.width = t.width),
          (e.x = t.x),
          (e.y = t.y),
          (e.zOrder = t.zOrder);
      }
      static typeText(t, e, a, n) {
        this.stopTypeText(t);
        let u = 1 / a;
        u = Math.max(u, 0.033);
        let m = Math.ceil(u * a);
        m = Math.max(m, 1);
        let f = 0;
        const updateFunc = function () {
          (f = Math.min(f + m, e.length)),
            (t.text = e.substring(0, f)),
            f == e.length && (this.stopTypeText(t), n && n.run());
        };
        (t.text = ""),
          (t._typeUpdateFunc = updateFunc),
          t.timerLoop(1e3 * u, this, updateFunc);
      }
      static stopTypeText(t) {
        t._typeUpdateFunc &&
          (t.timer.clear(this, t._typeUpdateFunc), (t._typeUpdateFunc = null));
      }
    }
    (qt.sRotMatX = new Laya.Matrix4x4()),
      (qt.sRotMatY = new Laya.Matrix4x4()),
      (qt.sN = new a()),
      (qt.sT = new a()),
      (qt.sRotQ = new Laya.Quaternion()),
      (qt.colorMatrix = [
        0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0,
      ]),
      (qt.convertRToLMat4x4 = new Laya.Matrix4x4(
        -1,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        1
      ));
    class Qt extends Laya.Script3D {
      constructor() {
        super(),
          (this.temp = new a()),
          (this.delta = new a(0, 0.001, 0)),
          (this.autoDestroy = !0);
      }
      onAwake() {
        let t = this.owner;
        this.player = t;
      }
      init(t, e, a, n, u = !0, m) {
        let f = this.player,
          y = f;
        if (!y.height) {
          let t = w.get3dModelSize(f, null, m);
          (y.long = t.x), (y.height = t.y), (y.width = t.z);
        }
        n && (this.delta.from(n), (this.delta.y = n.y * y.height)),
          (this.autoDestroy = u);
        let g = qt.createShadow(t, e, a);
        f.parent.addChild(g),
          (g.active = !1),
          (this.shadow = g),
          g.once(Laya.Event.REMOVED, this, this.clear);
        let _ = g.meshRenderer.sharedMaterial;
        _.lock
          ? _.once(p.E_MATERIAL_LOADED, this, () => {
              (this.enabled = !0), (g.active = !0);
            })
          : g.timerOnce(100, this, () => {
              (this.enabled = !0), (g.active = !0);
            }),
          (this.enabled = !1);
      }
      onEnable() {
        this.shadow && (this.shadow.active = !0);
      }
      onDisable() {
        this.shadow && (this.shadow.active = !1);
      }
      onDestroy() {
        this.shadow &&
          !this.shadow.destroyed &&
          (console.log("shadow cleared !!"),
          Vt.instance.add(this.shadow),
          (this.shadow.active = !1),
          (this.shadow = null));
      }
      onUpdate() {
        if (!this.shadow) return;
        let t = this.player,
          e = this.player,
          a = this.shadow,
          n = this.temp,
          u = this.delta;
        n.from(t.transform.position);
        let m = n.y;
        if (
          (e.__shadowY || (e.__shadowY = n.y + u.y),
          (n.x += u.x),
          (n.y = e.__shadowY),
          (n.z += u.z),
          (a.transform.position = n),
          (m = m - e.__shadowY + u.y),
          m < 0 && this.autoDestroy)
        )
          return void this.destroy();
        let f = a.meshRenderer.material,
          p = Math.lerp(1.2, 0, m / 3);
        f.albedoColorA = p;
      }
      clear() {
        this.destroy();
      }
    }
    class Jt extends Laya.Material {
      constructor() {
        super(),
          (this.u_MainTex = Laya.Shader3D.propertyNameToID("u_MainTex")),
          (this.u_NoiseTex = Laya.Shader3D.propertyNameToID("u_NoiseTex")),
          (this.u_Wave = Laya.Shader3D.propertyNameToID("u_Wave")),
          Jt.init(),
          this.setShaderName("Water"),
          (this.waveOffset = new Laya.Vector4(50, 50, 0, 0));
      }
      set mainTexture(t) {
        this._shaderValues.setTexture(this.u_MainTex, t);
      }
      get mainTexture() {
        return this._shaderValues.getTexture(this.u_MainTex);
      }
      set normalTexture(t) {
        this._shaderValues.setTexture(this.u_NoiseTex, t);
      }
      get normalTexture() {
        return this._shaderValues.getTexture(this.u_NoiseTex);
      }
      set waveOffset(t) {
        this._shaderValues.setVector(this.u_Wave, t);
      }
      set fogStart(t) {
        this._shaderValues.setNumber(Jt.u_WaterFogStart, t);
      }
      set fogRange(t) {
        this._shaderValues.setNumber(Jt.u_WaterFogRange, t);
      }
      set fogColor(t) {
        t
          ? this._shaderValues.addDefine(Jt.WATERFOG_DEF)
          : this._shaderValues.removeDefine(Jt.WATERFOG_DEF),
          this._shaderValues.setVector3(Jt.u_WaterFogColor, t);
      }
      static init() {
        if (Laya.Shader3D.find("Water")) return;
        let t = {
            a_Position: Laya.VertexMesh.MESH_POSITION0,
            a_Normal: Laya.VertexMesh.MESH_NORMAL0,
            a_Textcoord: Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
          },
          e = {
            u_WorldMat: Laya.Shader3D.PERIOD_SPRITE,
            u_MvpMatrix: Laya.Shader3D.PERIOD_SPRITE,
            u_Time: Laya.Shader3D.PERIOD_SCENE,
            u_MainTex: Laya.Shader3D.PERIOD_MATERIAL,
            u_NoiseTex: Laya.Shader3D.PERIOD_MATERIAL,
            u_Wave: Laya.Shader3D.PERIOD_MATERIAL,
            u_WaterFogStart: Laya.Shader3D.PERIOD_MATERIAL,
            u_WaterFogRange: Laya.Shader3D.PERIOD_MATERIAL,
            u_WaterFogColor: Laya.Shader3D.PERIOD_MATERIAL,
          },
          a = Laya.Shader3D.add("Water"),
          n = new Laya.SubShader(t, e);
        a.addSubShader(n),
          n.addShaderPass(
            "#include 'Lighting.glsl';\nattribute vec4 a_Position;\nattribute vec2 a_Textcoord;\nuniform mat4 u_WorldMat;\nuniform mat4 u_MvpMatrix;\nvarying vec2 v_textcoord;\nvoid main(){\n  v_textcoord=a_Textcoord;\n  gl_Position=u_MvpMatrix*a_Position;\n  gl_Position=remapGLPositionZ(gl_Position);\n}",
            "#if defined(GL_FRAGMENT_PRECISION_HIGH)\nprecision highp float;\n#else\nprecision mediump float;\n#endif\n\nuniform sampler2D u_MainTex;\nuniform sampler2D u_NoiseTex;\nuniform float u_Time;\nuniform vec4 u_Wave;\nvarying vec2 v_textcoord;\nuniform float u_WaterFogStart;\nuniform float u_WaterFogRange;\nuniform vec3 u_WaterFogColor;\n\nvoid main(){\n  vec2 uv=v_textcoord*vec2(u_Wave.x,u_Wave.y);\n  uv.x-=floor(uv.x);\n  uv.y-=floor(uv.y);\n  float time=u_Time/8.0;\n  float _NoiseSpeedX=1.0;\n  float _NoiseSpeedY=1.0;\n  float _NoiseScaleX=0.2;\n  float _NoiseScaleY=0.2;\n  float _NoiseBrightOffset=0.25;\n  vec2 tuv=uv+vec2(time*_NoiseSpeedX, time*_NoiseSpeedY);\n  vec2 ouvxy=vec2(texture2D(u_NoiseTex,tuv).xy);\n  ouvxy-=_NoiseBrightOffset;\n  ouvxy*=vec2(_NoiseScaleX,_NoiseScaleY);\n  vec4 col=texture2D(u_MainTex, uv+ouvxy);\n  vec3 diffuse=col.rgb;\n  gl_FragColor=vec4(diffuse,1.0);\n\n  #ifdef WATERFOG\n    float lerpFact=clamp((1.0/gl_FragCoord.w-u_WaterFogStart)/u_WaterFogRange,0.0,1.0);\n    if(lerpFact>0.1){\n      gl_FragColor.rgb=mix(gl_FragColor.rgb,u_WaterFogColor,lerpFact/2.0+0.5);\n    }else{\n      gl_FragColor.rgb=mix(gl_FragColor.rgb,u_WaterFogColor,smoothstep(0.0,0.1,lerpFact)*0.5);\n    }\n  #endif\n}"
          ),
          (this.WATERFOG_DEF = Laya.Shader3D.getDefineByName("WATERFOG")),
          (this.u_WaterFogStart =
            Laya.Shader3D.propertyNameToID("u_WaterFogStart")),
          (this.u_WaterFogRange =
            Laya.Shader3D.propertyNameToID("u_WaterFogRange")),
          (this.u_WaterFogColor =
            Laya.Shader3D.propertyNameToID("u_WaterFogColor"));
      }
    }
    class Zt {
      constructor(t = !0) {
        (this.firstloginTimestamp = void 0),
          (this.logindays = void 0),
          (this.redBag = void 0),
          (this.redBagCnt = void 0),
          (this.noticeVer = void 0),
          t && w.warpObjectGetterSetter(this, this.dirty);
      }
      dirty(t) {
        Kt.instance.save(t, this[t]);
      }
    }
    class Kt extends it {
      constructor() {
        super(), (this.readySaveProps = []);
      }
      static get instance() {
        return this._instance || (this._instance = new Kt()), this._instance;
      }
      onInit(t) {
        let loadData = (t) => {
          for (const e in t)
            if (t.hasOwnProperty(e)) {
              let a = this.unserialize(e);
              null != a && "" !== a && (t[e] = a);
            }
          (t.openId = this.unserialize("openId")),
            (t.name = this.unserialize("name"));
        };
        if (t) {
          let e = new t();
          loadData(e);
          for (const t in this.mine)
            if (this.mine.hasOwnProperty(t)) {
              let a = this.mine[t];
              null != a && "" !== a && (e[t] = a);
            }
          this.mine = e;
        } else (this.mine = new Zt()), loadData(this.mine), this.initData();
      }
      initData() {
        if (
          (void 0 === this.mine.firstloginTimestamp
            ? ((this.mine.firstloginTimestamp = w.getTime()),
              (this.firstLogin = !0))
            : (this.firstLogin = !1),
          void 0 === this.mine.logindays)
        )
          (this.mine.logindays = 1), (this.newDay = !0);
        else {
          let t = w.getDayInYear(new Date(this.mine.firstloginTimestamp)),
            e = w.getDayInYear() - t + 1;
          e > this.mine.logindays
            ? ((this.mine.logindays = e), (this.newDay = !0))
            : (this.newDay = !1);
        }
        void 0 === this.mine.redBag &&
          ((this.mine.redBag = 0), (this.mine.redBagCnt = 0));
      }
      getMine() {
        return this.mine;
      }
      getMineTrimmed() {
        let t = {},
          e = this.mine;
        for (const a in e)
          if (e.hasOwnProperty(a) && "_" == a[0]) {
            let n = a.substring(1);
            if (n) {
              let u = e[a];
              null != u && "" !== u && (t[n] = u);
            }
          }
        return t;
      }
      getUserInfo() {
        return this.mine;
      }
      update(t) {
        let e = t;
        e.savedTimestamp
          ? (this.isFirstLogin() || this.mine.openId != e.openId) &&
            ((this.mine = new Zt()),
            w.assign(this.mine, e, !1),
            this.initData(),
            e.openId && this.serialize("openId", e.openId),
            e.name && this.serialize("name", e.name))
          : (w.assign(this.mine, e, !1),
            e.name && this.serialize("name", e.name),
            e.openId && this.serialize("openId", e.openId));
      }
      save(t, e) {
        t && this.event(p.E_PROP_CHANGED, [t, e]),
          this.readySaveProps.push(t),
          1 == this.readySaveProps.length &&
            Laya.CallLater.I.callLater(this, this._save);
      }
      _save() {
        this.saveToLocal(), this.saveToServer(), this.readySaveProps.clear();
      }
      saveToLocal() {
        let t = this.mine,
          e = this.readySaveProps;
        if (e && e.length > 0)
          for (const a of e) {
            let e = "_" + a;
            if (t.hasOwnProperty(e)) {
              const a = t[e];
              this.serialize(e, a);
            }
          }
      }
      saveToServer() {
        let t = Laya.ClassUtils.getRegClass("Sdk");
        if (1 !== t.instance.isLoginServer()) return;
        let e = this.getMineTrimmed();
        w.getLength(e) > 0 && t.instance.saveToServer(e);
      }
      serialize(t, e) {
        e instanceof Array
          ? Laya.LocalStorage.setItem(t, JSON.stringify(e))
          : e instanceof Object
          ? Laya.LocalStorage.setJSON(t, e)
          : null != e
          ? Laya.LocalStorage.setItem(t, e)
          : Laya.LocalStorage.removeItem(t);
      }
      unserialize(t) {
        let e = Laya.LocalStorage.getItem(t);
        if (e)
          try {
            e = JSON.parse(e);
          } catch (a) {
            console.log("unserialize error: ", t, e);
          }
        return e;
      }
      isNewDay() {
        return this.newDay;
      }
      isFirstLogin() {
        return this.firstLogin;
      }
      addRedBag(t) {
        (this.mine.redBag += t),
          (this.mine.redBag = Number(this.mine.redBag.toFixed(2))),
          this.mine.redBagCnt++;
      }
      isNewNotice(t) {
        return (
          !!Laya.ClassUtils.getRegClass(
            "Sdk"
          ).instance.getServerJsonCfgNoticeHtmlText() &&
          !!t &&
          (!this.mine.noticeVer ||
            !fx.Utils.compatibleVersion(t, this.mine.noticeVer))
        );
      }
      readNotice(t) {
        this.isNewNotice(t) && (this.mine.noticeVer = t);
      }
    }
    class $t {
      static setBase64Chars(t) {
        this.base64Chars = t;
      }
      static init() {
        if (!this.lookup) {
          this.lookup = new Uint8Array(256);
          for (var t = 0; t < this.base64Chars.length; t++)
            this.lookup[this.base64Chars.charCodeAt(t)] = t;
        }
      }
      static encode(t) {
        for (
          var e = new Uint8Array(t), a = e.length, n = "", u = 0;
          u < a;
          u += 3
        )
          (n += this.base64Chars[e[u] >> 2]),
            (n += this.base64Chars[((3 & e[u]) << 4) | (e[u + 1] >> 4)]),
            (n += this.base64Chars[((15 & e[u + 1]) << 2) | (e[u + 2] >> 6)]),
            (n += this.base64Chars[63 & e[u + 2]]);
        return (
          a % 3 == 2
            ? (n = n.substring(0, n.length - 1) + "=")
            : a % 3 == 1 && (n = n.substring(0, n.length - 2) + "=="),
          n
        );
      }
      static encodeStr(t) {
        let e = new Laya.Byte();
        return e.writeUTFString(t), this.encodeByte(e);
      }
      static encodeStr2(t) {
        let e = new Laya.Byte();
        e.writeUTFBytes(t);
        for (var a = this.encodeByte(e); 0 <= a.indexOf("+"); )
          a = a.replace("+", "%2B");
        for (; 0 <= a.indexOf("&"); ) a = a.replace("&", "%26");
        for (; 0 <= a.indexOf("="); ) a = a.replace("=", "%3D");
        return a;
      }
      static encodeByte(t, e = 0, a = -1) {
        return (
          (a = a < 0 ? t.length : a), this.encode(t.getUint8Array(e, a).buffer)
        );
      }
      static decodeToByte(t) {
        let e = new Laya.Byte(this.decode(t));
        return (e.pos = 0), e;
      }
      static decode(t) {
        this.init();
        var e,
          a,
          n,
          u,
          m = 0.75 * t.length,
          f = t.length,
          p = 0;
        "=" === t[t.length - 1] && (m--, "=" === t[t.length - 2] && m--);
        let y = new ArrayBuffer(m),
          g = new Uint8Array(y);
        for (let m = 0; m < f; m += 4)
          (e = this.lookup[t.charCodeAt(m)]),
            (a = this.lookup[t.charCodeAt(m + 1)]),
            (n = this.lookup[t.charCodeAt(m + 2)]),
            (u = this.lookup[t.charCodeAt(m + 3)]),
            (g[p++] = (e << 2) | (a >> 4)),
            (g[p++] = ((15 & a) << 4) | (n >> 2)),
            (g[p++] = ((3 & n) << 6) | (63 & u));
        return y;
      }
    }
    ($t.lookup = null),
      ($t.base64Chars =
        "SNPn2QBOR7A1ghiCj5klmY6opZqrEsDFdeG90HIJK8LMtuv3wxyzabTUVWXcf4+/");
    class te {
      constructor() {
        (this._size = 0),
          (this._size = 0),
          (this._keys = new Array()),
          (this._values = new Array());
      }
      contains(t) {
        return 0 <= this._keys.indexOf(t);
      }
      containsKey(t) {
        return this.contains(t);
      }
      containsValue(t) {
        return 0 <= this._values.indexOf(t);
      }
      put(t, e) {
        let a = this._keys.indexOf(t);
        a >= 0
          ? (this._values[a] = e)
          : (this._size++, this._keys.push(t), this._values.push(e));
      }
      remove(t) {
        let e = this._keys.indexOf(t);
        if (e < 0) return null;
        let a = this._values[e];
        return (
          this._keys.splice(e, 1), this._values.splice(e, 1), this._size--, a
        );
      }
      get(t) {
        let e = this._keys.indexOf(t);
        return e < 0 ? null : this._values[e];
      }
      getV(t) {
        return 0 <= t && t < this.length ? this._values[t] : null;
      }
      getK(t) {
        return 0 <= t && t < this.length ? this._keys[t] : null;
      }
      removeByIndex(t) {
        if (0 <= t && t < this.length) {
          var e = this._values[t];
          return (
            this._keys.splice(t, 1), this._values.splice(t, 1), this._size--, e
          );
        }
        return null;
      }
      size() {
        return this._size;
      }
      get length() {
        return this._size;
      }
      isEmpty() {
        return 0 == this._size;
      }
      putAll(t) {
        for (let e = 0; e < this._size; ++e) this.put(t._keys[e], t._values[e]);
      }
      clear() {
        this.isEmpty() ||
          ((this._values.length = 0),
          (this._keys.length = 0),
          (this._size = 0));
      }
      clone() {
        if (this.isEmpty()) return new te();
        let t = new te();
        t._size = this._size;
        for (let e = 0; e < this._size; ++e)
          (t._keys[e] = this._keys[e]), (t._values[e] = this._values[e]);
        return t;
      }
      putIfAbsent(t, e) {
        return (
          this.get(t) ||
          (this._size++, this._keys.push(t), this._values.push(e), null)
        );
      }
      computeIfAbsent(t, e) {
        var a = this.get(t);
        return (
          a ||
          ((e = e(t)),
          this._size++,
          this._keys.push(t),
          this._values.push(e),
          e)
        );
      }
      forEach(t) {
        for (let e = 0; e < this._size; ++e) t(this._keys[e], this._values[e]);
      }
      forEachSome(t) {
        for (
          let e = 0;
          e < this._size && t(this._keys[e], this._values[e]);
          ++e
        );
      }
      getKeys() {
        return this._keys;
      }
      getValues() {
        return this._values;
      }
      forEachValue(t) {
        for (let e = 0; e < this._size; ++e) t(this._values[e]);
      }
      getOrDefault(t, e) {
        return this.isEmpty()
          ? e
          : 0 <= (t = this._keys.indexOf(t))
          ? this._values[t]
          : e;
      }
      getEver() {
        return this.isEmpty() ? null : this._values[0];
      }
    }
    class ee extends Laya.HTMLDivElement {
      constructor(t = "HtmlText") {
        super(),
          (this._defaultStyle = "color:#000000;bold:true;font:30px Arial"),
          (this.name = t),
          (this.style.wordWrap = !1);
      }
      get defaultStyle() {
        return this._defaultStyle;
      }
      set defaultStyle(t) {
        this._defaultStyle = t;
      }
      parse(t) {
        let e = t.split("<br/>");
        return (
          (t = ""),
          e.forEach((e) => {
            let a = e.split(/(<span.+<\/span>)/g);
            0 == a.length && a.push(e);
            for (const e of a)
              e &&
                (this.isRichText(e)
                  ? (t += e)
                  : (t += this.defaultRichText(e)));
            t += "<br/>";
          }),
          t
        );
      }
      defaultRichText(t) {
        return `<span style='${this._defaultStyle}'>${t}</span>`;
      }
      isRichText(t) {
        return -1 != t.indexOf("<span");
      }
      setText(t) {
        t && ((t = this.parse(t)), (this.innerHTML = t));
      }
      addImg(t, e) {
        let a = "";
        a = e
          ? `<img src='${t}' style='${e}'></img>`
          : `<img src='${t}' ></img>`;
        let n = "",
          u = this._innerHTML;
        u && (n = u), (n += a), this.setText(n);
      }
      addText(t) {
        let e = "",
          a = this._innerHTML;
        a && (e = a), (e += t), this.setText(e);
      }
    }
    return (
      (t.AniParam = class {
        constructor(t, e, a, n, u, m, f) {
          (this.parent = t),
            (this.pos = e),
            (this.lbCaller = a),
            (this.lbCb = n),
            (this.completeCaller = u),
            (this.completeCb = m),
            (this.completeParams = f);
        }
      }),
      (t.AnimationImage = Rt),
      (t.AnimatorEventScript = Ft),
      (t.AnimatorStateScript = Ht),
      (t.AppBase = class {
        constructor(t, e) {
          (this.lastTimerScale = 1),
            console.log("Framework Ver: 1.4.0132"),
            (this.gameCfg = t);
          let a = sdk.Sdk;
          a.instance.initMiniAdapter(),
            this.initGraphicsSetting(a.instance.getSystemInfo()),
            console.log("Graphics: " + JSON.stringify(et)),
            (Config.useRetinalCanvas = et.enableRetinalCanvas),
            (t.config3d = t.config3d || new Config3D()),
            (t.config3d.enableMultiLight = et.enableMultiLight),
            (t.config3d.isAntialias = Config.isAntialias = et.enableAntialias),
            window.Laya3D
              ? (t.physic3dSetting &&
                  (Laya.Scene3D.physicsSettings = t.physic3dSetting),
                Laya3D.init(t.width, t.height, t.config3d))
              : Laya.init(t.width, t.height, Laya.WebGL),
            Laya.Physics && Laya.Physics.enable(),
            (Laya.stage.scaleMode = t.scaleMode),
            (Laya.stage.alignH = t.alignH),
            (Laya.stage.alignV = t.alignV),
            (Laya.stage.screenMode = t.screenMode),
            (Laya.stage.frameRate = Laya.Stage.FRAME_FAST),
            (Laya.URL.exportSceneToJson = t.exportSceneToJson),
            (t.debug || "true" == Laya.Utils.getQueryString("debug")) &&
              Laya.enableDebugPanel(),
            t.physicsDebug &&
              Laya.PhysicsDebugDraw &&
              Laya.PhysicsDebugDraw.enable(),
            t.stat && Laya.Stat.show(0, 100),
            Laya.alertGlobalError(!0),
            E.init(),
            a.instance.afterEngineInit(
              this.didEnterBackground.bind(this),
              this.willEnterForeground.bind(this)
            ),
            e
              ? Laya.ResourceVersion.enable(
                  e,
                  Laya.Handler.create(this, this.onManifestLoaded)
                )
              : z.instance.load(Laya.Handler.create(this, this.onLoaded));
        }
        didEnterBackground() {
          0 != Laya.timer.scale &&
            ((this.lastTimerScale = Laya.timer.scale),
            (Laya.timer.scale = 0),
            A.instance.event(p.E_APP_ON_PAUSE));
        }
        willEnterForeground(t) {
          (Laya.timer.scale = this.lastTimerScale),
            A.instance.event(p.E_APP_ON_RESUME, t);
        }
        launch(t) {
          return (
            Laya.AtlasInfoManager.enable("fileconfig.json"),
            w.isOnMiniGame() && sdk.Sdk.instance.checkUpdate(),
            this.onStageResize(),
            Laya.stage.on(Laya.Event.RESIZE, this, this.onStageResize),
            t
              ? tt.changeScene(t)
              : this.gameCfg.startScene
              ? tt.changeScene(this.gameCfg.startScene)
              : console.error("Launch Scene not found !!!"),
            this
          );
        }
        onStageResize() {
          w.isOnPC() &&
            sdk.Sdk.isOnPC() &&
            (document.title = `${Laya.stage.width}x${Laya.stage.height}`);
        }
        onManifestLoaded() {
          z.instance.load(Laya.Handler.create(this, this.onLoaded));
        }
        onLoaded() {}
        initGraphicsSetting(t) {
          if (!t) return;
          let e = et;
          if (t.deviceScore) {
            let a = t.deviceScore.overall;
            w.isNumber(a) && (e.enableShadow = a > 7);
            let n = t.deviceScore.gpu;
            w.isNumber(n) && (e.enableMultiLight = n > 7);
          } else if (t.benchmarkLevel) {
            let a = t.benchmarkLevel;
            w.isNumber(a) &&
              ((e.enableShadow = a > 20), (e.enableMultiLight = a > 15));
          }
        }
      }),
      (t.AudioContextPool = J),
      (t.AutoReleaseManager = Vt),
      (t.BTAction = ut),
      (t.BTActions = lt),
      (t.BTBaseNode = dt),
      (t.BTBlackboard = class {
        constructor() {
          (this._baseMemory = {}), (this._treeMemory = {});
        }
        _getTreeMemory(t) {
          return (
            this._treeMemory[t] ||
              (this._treeMemory[t] = {
                nodeMemory: {},
                openNodes: [],
                traversalDepth: 0,
                traversalCycle: 0,
              }),
            this._treeMemory[t]
          );
        }
        _getNodeMemory(t, e) {
          let a = t.nodeMemory;
          return a[e] || (a[e] = {}), a[e];
        }
        _getMemory(t, e) {
          let a = this._baseMemory;
          return (
            t &&
              ((a = this._getTreeMemory(t)),
              e && (a = this._getNodeMemory(a, e))),
            a
          );
        }
        set(t, e, a, n) {
          this._getMemory(a, n)[t] = e;
        }
        get(t, e, a) {
          return this._getMemory(e, a)[t];
        }
      }),
      (t.BTComposite = mt),
      (t.BTComposites = ht),
      (t.BTCondition = class extends dt {
        constructor({
          child: e = null,
          name: a = "Condition",
          title: n = "",
          properties: u,
        }) {
          super({
            category: t.BTCategory.CONDITION,
            name: a,
            title: n,
            properties: u,
          }),
            (this.child = e);
        }
        satisfy(t) {
          return !1;
        }
        tick(e) {
          if (e.blackboard.get("runningChild", e.tree.id, this.id)) {
            let a = this.child._execute(e);
            return (
              a != t.BTStatus.RUNNING &&
                e.blackboard.set("runningChild", !1, e.tree.id, this.id),
              a
            );
          }
          if (this.satisfy(e)) {
            if (this.child) {
              let a = this.child._execute(e);
              return (
                a == t.BTStatus.RUNNING &&
                  e.blackboard.set("runningChild", !0, e.tree.id, this.id),
                a
              );
            }
            return t.BTStatus.SUCCESS;
          }
          return t.BTStatus.FAILURE;
        }
        add(t) {
          this.child = t;
        }
      }),
      (t.BTConditions = ct),
      (t.BTContinuous = yt),
      (t.BTDecorator = ft),
      (t.BTDecorators = rt),
      (t.BTError = gt),
      (t.BTFailer = _t),
      (t.BTInverter = Mt),
      (t.BTLimiter = Ct),
      (t.BTMaxTime = Nt),
      (t.BTParallel = wt),
      (t.BTRepeatUntilFailure = Et),
      (t.BTRepeatUntilSuccess = Tt),
      (t.BTRepeater = It),
      (t.BTRunner = xt),
      (t.BTSequence = St),
      (t.BTSucceeder = bt),
      (t.BTTick = pt),
      (t.BTWait = vt),
      (t.BTWaitUtil = Lt),
      (t.Base64Encrypt = $t),
      (t.BaseData = class {
        constructor(t, e) {
          (this.id = t),
            (this.gid = w.getGID()),
            null != e &&
              ((this.iniName = e),
              (this.ini = z.instance.get(e, t)),
              w.assign(this, w.cloneDeep(this.ini), !1));
        }
        clone() {
          let t = w.getModule(this);
          return (
            this.iniName
              ? (t = new t(this.id, this.iniName))
              : ((t = new t()), w.assign(t, this, !1)),
            t
          );
        }
        from(t) {
          this.ini ? w.assign(this, t) : w.assign(this, t, !1);
        }
        getAtt(t, e = !1) {
          if (e && this.ini) return this.ini[t];
          var a = this[t];
          return null == a && null != this.ini && (a = this.ini[t]), a;
        }
        setAtt(t, e) {
          this[t] = e;
        }
      }),
      (t.BaseDataModel = class {
        constructor(t, e) {
          (this.dataModule = e), (this.name = t);
          let a = z.instance.get(t);
          a &&
            ((this.data = {}),
            (this.ini = a),
            (this._length = Object.keys(a).length));
        }
        get length() {
          return this._length;
        }
        get(t) {
          return this.getWith(t, this.dataModule);
        }
        getWith(t, e) {
          let a = this.data;
          if (a)
            return a[t]
              ? a[t]
              : this.ini[t]
              ? ((this.data[t] = new e(t, this.name)), this.data[t])
              : void 0;
        }
        getValues(t) {
          let e = [];
          return (
            this.recurisRaw((a) => {
              e.push(a[t]);
            }),
            e
          );
        }
        recurisRaw(t) {
          for (const e in this.ini) {
            let a = t(this.ini[e]);
            if (!1 === a) return a;
          }
        }
      }),
      (t.BaseDialog = R),
      (t.BaseEvent = p),
      (t.BaseEventDispatcher = k),
      (t.BaseExtend = E),
      (t.BaseLogic = it),
      (t.BaseScene = B),
      (t.BaseStorage = st),
      (t.BaseView = V),
      (t.BehaviorTree = class {
        constructor() {
          (this.id = w.createUUIDEx(5)),
            (this.title = "The behavior tree"),
            (this.description = "Default description"),
            (this.properties = {}),
            (this.root = null),
            (this.debug = null);
        }
        load(e, a) {
          (a = a || {}),
            (this.title = e.title || this.title),
            (this.description = e.description || this.description),
            (this.properties = e.properties || this.properties);
          let n,
            u,
            m,
            f = {};
          for (n in e.nodes) {
            let t;
            if (((u = e.nodes[n]), u.name in a)) t = a[u.name];
            else if (u.name in rt) t = rt[u.name];
            else if (u.name in ht) t = ht[u.name];
            else {
              if (!(u.name in lt))
                throw new EvalError(
                  'BehaviorTree.load: Invalid node name + "' + u.name + '".'
                );
              t = lt[u.name];
            }
            (m = new t(u.properties)),
              (m.id = u.id || m.id),
              (m.title = u.title || m.title),
              (m.description = u.description || m.description),
              (m.properties = u.properties || m.properties),
              (f[n] = m);
          }
          for (n in e.nodes)
            if (
              ((u = e.nodes[n]),
              (m = f[n]),
              m.category === t.BTCategory.COMPOSITE && u.children)
            )
              for (let t = 0; t < u.children.length; t++) {
                let e = u.children[t];
                m.children.push(f[e]);
              }
            else
              m.category === t.BTCategory.DECORATOR &&
                u.child &&
                (m.child = f[u.child]);
          this.root = f[e.root];
        }
        dump() {
          let e = {},
            a = [];
          if (
            ((e.title = this.title),
            (e.description = this.description),
            (e.root = this.root ? this.root.id : null),
            (e.properties = this.properties),
            (e.nodes = {}),
            (e.custom_nodes = []),
            !this.root)
          )
            return e;
          let n = [this.root];
          for (; n.length > 0; ) {
            let u = n.pop(),
              m = {};
            (m.id = u.id),
              (m.name = u.name),
              (m.title = u.title),
              (m.description = u.description),
              (m.properties = u.properties);
            let f = u.constructor && u.constructor.prototype,
              p = (f && f.name) || u.name;
            if (!rt[p] && !ht[p] && !lt[p] && a.indexOf(p) < 0) {
              let t = {};
              (t.name = p),
                (t.title = (f && f.title) || u.title),
                (t.category = u.category),
                a.push(p),
                e.custom_nodes.push(t);
            }
            if (u.category === t.BTCategory.COMPOSITE && u.children) {
              let t = [];
              for (let e = u.children.length - 1; e >= 0; e--)
                t.push(u.children[e].id), n.push(u.children[e]);
              m.children = t;
            } else
              u.category === t.BTCategory.DECORATOR &&
                u.child &&
                (n.push(u.child), (m.child = u.child.id));
            e.nodes[u.id] = m;
          }
          return e;
        }
        tick(t, e) {
          if (!e)
            throw "The blackboard parameter is obligatory and must be an instance of b3.Blackboard";
          if (!this.root) return;
          let a = new pt();
          (a.debug = this.debug),
            (a.target = t),
            (a.blackboard = e),
            (a.tree = this);
          let n = e.get("tick_frame", a.tree.id);
          null == n
            ? e.set("tick_frame", 0, a.tree.id)
            : e.set("tick_frame", n + 1, a.tree.id);
          let u,
            m = this.root._execute(a),
            f = e.get("openNodes", this.id),
            p = a._openNodes.slice(0),
            y = 0;
          for (
            u = 0;
            u < Math.min(f.length, p.length) && ((y = u + 1), f[u] === p[u]);
            u++
          );
          for (u = f.length - 1; u >= y; u--) f[u]._close(a);
          return (
            e.set("openNodes", p, this.id),
            e.set("nodeCount", a._nodeCount, this.id),
            m
          );
        }
      }),
      (t.Billboard = kt),
      (t.BlendShapeMaterial = zt),
      (t.BlendShapeMesh = Pt),
      (t.BlendShapeScript = At),
      (t.ByteUtil = class {
        static readShort(t) {
          return t.readInt16();
        }
        static writeShort(t, e) {
          t.writeInt16(e);
        }
        static readInt(t) {
          return t.readInt32();
        }
        static writeInt(t, e) {
          t.writeInt32(e);
        }
        static readFloat(t) {
          return t.readFloat32();
        }
        static writeFloat(t, e) {
          t.writeFloat32(e);
        }
        static readDouble(t) {
          return t.readFloat64();
        }
        static writeDouble(t, e) {
          t.writeFloat64(e);
        }
        static readBoolean(t) {
          return 1 == t.readInt16();
        }
        static writeBoolean(t, e) {
          this.writeShort(t, e ? 1 : 0);
        }
        static readString(t) {
          let e = t.readInt16();
          return e <= 0 ? "" : t.readUTFBytes(e);
        }
        static writeString(t, e) {
          if (e && "" != e) {
            let a = new Laya.Byte();
            a.writeUTFBytes(e);
            let n = a.length;
            t.writeInt16(n), n > 0 && t.writeUTFBytes(e);
          } else t.writeInt16(0);
        }
        static readStringArray(t) {
          let e = t.readInt16();
          if (e <= 0) return null;
          let a = [];
          for (let n = 0; n < e; ++n) a.push(this.readString(t));
          return a;
        }
        static writeStringArray(t, e) {
          if (!e || e.length <= 0) t.writeInt16(0);
          else {
            let a = e.length;
            t.writeInt16(a);
            for (let n = 0; n < a; ++n) this.writeString(t, e[n]);
          }
        }
        static readShortArray(t) {
          let e = t.readInt16();
          if (e <= 0) return null;
          let a = [];
          for (let n = 0; n < e; ++n) a.push(this.readShort(t));
          return a;
        }
        static writeShortArray(t, e) {
          if (!e || e.length <= 0) t.writeInt16(0);
          else {
            let a = e.length;
            t.writeInt16(a);
            for (let n = 0; n < a; ++n) this.writeShort(t, e[n]);
          }
        }
        static readIntArray(t) {
          let e = t.readInt16();
          if (e <= 0) return null;
          let a = [];
          for (let n = 0; n < e; ++n) a.push(this.readInt(t));
          return a;
        }
        static writeIntArray(t, e) {
          if (!e || e.length <= 0) t.writeInt16(0);
          else {
            let a = e.length;
            t.writeInt16(a);
            for (let n = 0; n < a; ++n) this.writeInt(t, e[n]);
          }
        }
        static readFloatArray(t) {
          let e = t.readInt16();
          if (e <= 0) return null;
          let a = [];
          for (let n = 0; n < e; ++n) a.push(this.readFloat(t));
          return a;
        }
        static writeFloatArray(t, e) {
          if (!e || e.length <= 0) t.writeInt16(0);
          else {
            let a = e.length;
            t.writeInt16(a);
            for (let n = 0; n < a; ++n) this.writeFloat(t, e[n]);
          }
        }
        static readDoubleArray(t) {
          let e = t.readInt16();
          if (e <= 0) return null;
          let a = [];
          for (let n = 0; n < e; ++n) a.push(this.readDouble(t));
          return a;
        }
        static writeDoubleArray(t, e) {
          if (!e || e.length <= 0) t.writeInt16(0);
          else {
            let a = e.length;
            t.writeInt16(a);
            for (let n = 0; n < a; ++n) this.writeDouble(t, e[n]);
          }
        }
      }),
      (t.CameraMoveScript = Wt),
      (t.CfgMgr = z),
      (t.CircleProgress3dMaterial = Gt),
      (t.CollideInfo = x),
      (t.Color = u),
      (t.DecalShadowScript = Qt),
      (t.Dialog = m),
      (t.Effect = $),
      (t.EventCenter = A),
      (t.EventDispatcher = f),
      (t.FX_VERSION = "1.4.0132"),
      (t.GraphicsCfg = et),
      (t.Helper = qt),
      (t.HtmlText = ee),
      (t.Http = Ot),
      (t.MD5 = class {
        constructor() {
          (this.hexcase = 0), (this.b64pad = "");
        }
        hex_md5(t) {
          return this.rstr2hex(this.rstr_md5(this.str2rstr_utf8(t)));
        }
        b64_md5(t) {
          return this.rstr2b64(this.rstr_md5(this.str2rstr_utf8(t)));
        }
        any_md5(t, e) {
          return this.rstr2any(this.rstr_md5(this.str2rstr_utf8(t)), e);
        }
        hex_hmac_md5(t, e) {
          return this.rstr2hex(
            this.rstr_hmac_md5(this.str2rstr_utf8(t), this.str2rstr_utf8(e))
          );
        }
        b64_hmac_md5(t, e) {
          return this.rstr2b64(
            this.rstr_hmac_md5(this.str2rstr_utf8(t), this.str2rstr_utf8(e))
          );
        }
        any_hmac_md5(t, e, a) {
          return this.rstr2any(
            this.rstr_hmac_md5(this.str2rstr_utf8(t), this.str2rstr_utf8(e)),
            a
          );
        }
        md5_vm_test() {
          return (
            "900150983cd24fb0d6963f7d28e17f72" ==
            this.hex_md5("abc").toLowerCase()
          );
        }
        rstr_md5(t) {
          return this.binl2rstr(this.binl_md5(this.rstr2binl(t), 8 * t.length));
        }
        rstr_hmac_md5(t, e) {
          var a = this.rstr2binl(t);
          a.length > 16 && (a = this.binl_md5(a, 8 * t.length));
          for (var n = Array(16), u = Array(16), m = 0; m < 16; m++)
            (n[m] = 909522486 ^ a[m]), (u[m] = 1549556828 ^ a[m]);
          var f = this.binl_md5(
            n.concat(this.rstr2binl(e)),
            512 + 8 * e.length
          );
          return this.binl2rstr(this.binl_md5(u.concat(f), 640));
        }
        rstr2hex(t) {
          try {
            this.hexcase;
          } catch (t) {
            this.hexcase = 0;
          }
          for (
            var e,
              a = this.hexcase ? "0123456789ABCDEF" : "0123456789abcdef",
              n = "",
              u = 0;
            u < t.length;
            u++
          )
            (e = t.charCodeAt(u)),
              (n += a.charAt((e >>> 4) & 15) + a.charAt(15 & e));
          return n;
        }
        rstr2b64(t) {
          try {
            this.b64pad;
          } catch (t) {
            this.b64pad = "";
          }
          for (var e = "", a = t.length, n = 0; n < a; n += 3)
            for (
              var u =
                  (t.charCodeAt(n) << 16) |
                  (n + 1 < a ? t.charCodeAt(n + 1) << 8 : 0) |
                  (n + 2 < a ? t.charCodeAt(n + 2) : 0),
                m = 0;
              m < 4;
              m++
            )
              8 * n + 6 * m > 8 * t.length
                ? (e += this.b64pad)
                : (e +=
                    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/".charAt(
                      (u >>> (6 * (3 - m))) & 63
                    ));
          return e;
        }
        rstr2any(t, e) {
          var a,
            n,
            u,
            m,
            f,
            p = e.length,
            y = Array(Math.ceil(t.length / 2));
          for (a = 0; a < y.length; a++)
            y[a] = (t.charCodeAt(2 * a) << 8) | t.charCodeAt(2 * a + 1);
          var g = Math.ceil(
              (8 * t.length) / (Math.log(e.length) / Math.log(2))
            ),
            _ = Array(g);
          for (n = 0; n < g; n++) {
            for (f = Array(), m = 0, a = 0; a < y.length; a++)
              (m = (m << 16) + y[a]),
                (m -= (u = Math.floor(m / p)) * p),
                (f.length > 0 || u > 0) && (f[f.length] = u);
            (_[n] = m), (y = f);
          }
          var x = "";
          for (a = _.length - 1; a >= 0; a--) x += e.charAt(_[a]);
          return x;
        }
        str2rstr_utf8(t) {
          for (var e, a, n = "", u = -1; ++u < t.length; )
            (e = t.charCodeAt(u)),
              (a = u + 1 < t.length ? t.charCodeAt(u + 1) : 0),
              55296 <= e &&
                e <= 56319 &&
                56320 <= a &&
                a <= 57343 &&
                ((e = 65536 + ((1023 & e) << 10) + (1023 & a)), u++),
              e <= 127
                ? (n += String.fromCharCode(e))
                : e <= 2047
                ? (n += String.fromCharCode(
                    192 | ((e >>> 6) & 31),
                    128 | (63 & e)
                  ))
                : e <= 65535
                ? (n += String.fromCharCode(
                    224 | ((e >>> 12) & 15),
                    128 | ((e >>> 6) & 63),
                    128 | (63 & e)
                  ))
                : e <= 2097151 &&
                  (n += String.fromCharCode(
                    240 | ((e >>> 18) & 7),
                    128 | ((e >>> 12) & 63),
                    128 | ((e >>> 6) & 63),
                    128 | (63 & e)
                  ));
          return n;
        }
        str2rstr_utf16le(t) {
          for (var e = "", a = 0; a < t.length; a++)
            e += String.fromCharCode(
              255 & t.charCodeAt(a),
              (t.charCodeAt(a) >>> 8) & 255
            );
          return e;
        }
        str2rstr_utf16be(t) {
          for (var e = "", a = 0; a < t.length; a++)
            e += String.fromCharCode(
              (t.charCodeAt(a) >>> 8) & 255,
              255 & t.charCodeAt(a)
            );
          return e;
        }
        rstr2binl(t) {
          for (var e = Array(t.length >> 2), a = 0; a < e.length; a++) e[a] = 0;
          for (a = 0; a < 8 * t.length; a += 8)
            e[a >> 5] |= (255 & t.charCodeAt(a / 8)) << a % 32;
          return e;
        }
        binl2rstr(t) {
          for (var e = "", a = 0; a < 32 * t.length; a += 8)
            e += String.fromCharCode((t[a >> 5] >>> a % 32) & 255);
          return e;
        }
        binl_md5(t, e) {
          (t[e >> 5] |= 128 << e % 32), (t[14 + (((e + 64) >>> 9) << 4)] = e);
          for (
            var a = 1732584193,
              n = -271733879,
              u = -1732584194,
              m = 271733878,
              f = 0;
            f < t.length;
            f += 16
          ) {
            var p = a,
              y = n,
              g = u,
              _ = m;
            (a = this.md5_ff(a, n, u, m, t[f + 0], 7, -680876936)),
              (m = this.md5_ff(m, a, n, u, t[f + 1], 12, -389564586)),
              (u = this.md5_ff(u, m, a, n, t[f + 2], 17, 606105819)),
              (n = this.md5_ff(n, u, m, a, t[f + 3], 22, -1044525330)),
              (a = this.md5_ff(a, n, u, m, t[f + 4], 7, -176418897)),
              (m = this.md5_ff(m, a, n, u, t[f + 5], 12, 1200080426)),
              (u = this.md5_ff(u, m, a, n, t[f + 6], 17, -1473231341)),
              (n = this.md5_ff(n, u, m, a, t[f + 7], 22, -45705983)),
              (a = this.md5_ff(a, n, u, m, t[f + 8], 7, 1770035416)),
              (m = this.md5_ff(m, a, n, u, t[f + 9], 12, -1958414417)),
              (u = this.md5_ff(u, m, a, n, t[f + 10], 17, -42063)),
              (n = this.md5_ff(n, u, m, a, t[f + 11], 22, -1990404162)),
              (a = this.md5_ff(a, n, u, m, t[f + 12], 7, 1804603682)),
              (m = this.md5_ff(m, a, n, u, t[f + 13], 12, -40341101)),
              (u = this.md5_ff(u, m, a, n, t[f + 14], 17, -1502002290)),
              (n = this.md5_ff(n, u, m, a, t[f + 15], 22, 1236535329)),
              (a = this.md5_gg(a, n, u, m, t[f + 1], 5, -165796510)),
              (m = this.md5_gg(m, a, n, u, t[f + 6], 9, -1069501632)),
              (u = this.md5_gg(u, m, a, n, t[f + 11], 14, 643717713)),
              (n = this.md5_gg(n, u, m, a, t[f + 0], 20, -373897302)),
              (a = this.md5_gg(a, n, u, m, t[f + 5], 5, -701558691)),
              (m = this.md5_gg(m, a, n, u, t[f + 10], 9, 38016083)),
              (u = this.md5_gg(u, m, a, n, t[f + 15], 14, -660478335)),
              (n = this.md5_gg(n, u, m, a, t[f + 4], 20, -405537848)),
              (a = this.md5_gg(a, n, u, m, t[f + 9], 5, 568446438)),
              (m = this.md5_gg(m, a, n, u, t[f + 14], 9, -1019803690)),
              (u = this.md5_gg(u, m, a, n, t[f + 3], 14, -187363961)),
              (n = this.md5_gg(n, u, m, a, t[f + 8], 20, 1163531501)),
              (a = this.md5_gg(a, n, u, m, t[f + 13], 5, -1444681467)),
              (m = this.md5_gg(m, a, n, u, t[f + 2], 9, -51403784)),
              (u = this.md5_gg(u, m, a, n, t[f + 7], 14, 1735328473)),
              (n = this.md5_gg(n, u, m, a, t[f + 12], 20, -1926607734)),
              (a = this.md5_hh(a, n, u, m, t[f + 5], 4, -378558)),
              (m = this.md5_hh(m, a, n, u, t[f + 8], 11, -2022574463)),
              (u = this.md5_hh(u, m, a, n, t[f + 11], 16, 1839030562)),
              (n = this.md5_hh(n, u, m, a, t[f + 14], 23, -35309556)),
              (a = this.md5_hh(a, n, u, m, t[f + 1], 4, -1530992060)),
              (m = this.md5_hh(m, a, n, u, t[f + 4], 11, 1272893353)),
              (u = this.md5_hh(u, m, a, n, t[f + 7], 16, -155497632)),
              (n = this.md5_hh(n, u, m, a, t[f + 10], 23, -1094730640)),
              (a = this.md5_hh(a, n, u, m, t[f + 13], 4, 681279174)),
              (m = this.md5_hh(m, a, n, u, t[f + 0], 11, -358537222)),
              (u = this.md5_hh(u, m, a, n, t[f + 3], 16, -722521979)),
              (n = this.md5_hh(n, u, m, a, t[f + 6], 23, 76029189)),
              (a = this.md5_hh(a, n, u, m, t[f + 9], 4, -640364487)),
              (m = this.md5_hh(m, a, n, u, t[f + 12], 11, -421815835)),
              (u = this.md5_hh(u, m, a, n, t[f + 15], 16, 530742520)),
              (n = this.md5_hh(n, u, m, a, t[f + 2], 23, -995338651)),
              (a = this.md5_ii(a, n, u, m, t[f + 0], 6, -198630844)),
              (m = this.md5_ii(m, a, n, u, t[f + 7], 10, 1126891415)),
              (u = this.md5_ii(u, m, a, n, t[f + 14], 15, -1416354905)),
              (n = this.md5_ii(n, u, m, a, t[f + 5], 21, -57434055)),
              (a = this.md5_ii(a, n, u, m, t[f + 12], 6, 1700485571)),
              (m = this.md5_ii(m, a, n, u, t[f + 3], 10, -1894986606)),
              (u = this.md5_ii(u, m, a, n, t[f + 10], 15, -1051523)),
              (n = this.md5_ii(n, u, m, a, t[f + 1], 21, -2054922799)),
              (a = this.md5_ii(a, n, u, m, t[f + 8], 6, 1873313359)),
              (m = this.md5_ii(m, a, n, u, t[f + 15], 10, -30611744)),
              (u = this.md5_ii(u, m, a, n, t[f + 6], 15, -1560198380)),
              (n = this.md5_ii(n, u, m, a, t[f + 13], 21, 1309151649)),
              (a = this.md5_ii(a, n, u, m, t[f + 4], 6, -145523070)),
              (m = this.md5_ii(m, a, n, u, t[f + 11], 10, -1120210379)),
              (u = this.md5_ii(u, m, a, n, t[f + 2], 15, 718787259)),
              (n = this.md5_ii(n, u, m, a, t[f + 9], 21, -343485551)),
              (a = this.safe_add(a, p)),
              (n = this.safe_add(n, y)),
              (u = this.safe_add(u, g)),
              (m = this.safe_add(m, _));
          }
          return [a, n, u, m];
        }
        md5_cmn(t, e, a, n, u, m) {
          return this.safe_add(
            this.bit_rol(
              this.safe_add(this.safe_add(e, t), this.safe_add(n, m)),
              u
            ),
            a
          );
        }
        md5_ff(t, e, a, n, u, m, f) {
          return this.md5_cmn((e & a) | (~e & n), t, e, u, m, f);
        }
        md5_gg(t, e, a, n, u, m, f) {
          return this.md5_cmn((e & n) | (a & ~n), t, e, u, m, f);
        }
        md5_hh(t, e, a, n, u, m, f) {
          return this.md5_cmn(e ^ a ^ n, t, e, u, m, f);
        }
        md5_ii(t, e, a, n, u, m, f) {
          return this.md5_cmn(a ^ (e | ~n), t, e, u, m, f);
        }
        safe_add(t, e) {
          var a = (65535 & t) + (65535 & e);
          return (((t >> 16) + (e >> 16) + (a >> 16)) << 16) | (65535 & a);
        }
        bit_rol(t, e) {
          return (t << e) | (t >>> (32 - e));
        }
      }),
      (t.MapEx = te),
      (t.MeshLine = Dt),
      (t.ModalDialogBox = class extends m {
        constructor(t, e, a) {
          if (
            (super(),
            (this.handler_close = Laya.Handler.create(this, function () {
              this.removeSelf();
            })),
            a.tex_bgMask &&
              ((this.img_bgmask = new Laya.Image()),
              (this.img_bgmask.name = "img_bg"),
              this.addChild(this.img_bgmask),
              (this.img_bgmask.left = 0),
              (this.img_bgmask.right = 0),
              (this.img_bgmask.top = 0),
              (this.img_bgmask.bottom = 0),
              (this.img_bgmask.skin = a.tex_bgMask),
              a.texSizegrid_bgMask &&
                (this.img_bgmask.sizeGrid = a.texSizegrid_bgMask)),
            (this.img_bg = new Laya.Image()),
            this.addChild(this.img_bg),
            a.tex_bg
              ? (this.img_bg.skin = a.tex_bg)
              : (console.log("模态弹出框背景纹理为空!!!"),
                (this.img_bg.width = 500),
                (this.img_bg.height = 400)),
            a.texSizegrid_bg && (this.img_bg.sizeGrid = a.texSizegrid_bg),
            (this.img_bg.centerX = 0),
            (this.img_bg.centerY = 0),
            !a.texSize_bg && (a.texSize_bg = { width: 600, height: 400 }),
            !a.texSize_bg.width && (a.texSize_bg.width = 600),
            !a.texSize_bg.height && (a.texSize_bg.height = 400),
            this.img_bg.size(a.texSize_bg.width, a.texSize_bg.height),
            (this.label_title = new Laya.Label()),
            this.img_bg.addChild(this.label_title),
            (this.label_title.fontSize = 40),
            (this.label_title.bold = !0),
            (this.label_title.color = "#ffffff"),
            (this.label_title.centerX = 0),
            (this.label_title.top = 25),
            (this.label_content = new Laya.Label()),
            this.img_bg.addChild(this.label_content),
            (this.label_content.fontSize = 36),
            (this.label_content.bold = !0),
            (this.label_content.color = "#ffffff"),
            (this.label_content.centerX = 0),
            (this.label_content.centerY = 0),
            a.contentLeading && (this.label_content.leading = a.contentLeading),
            a.tex_closeBtn
              ? ((this.btn_close = new Laya.Button()),
                this.img_bg.addChild(this.btn_close),
                (this.btn_close.skin = a.tex_closeBtn),
                (this.btn_close.stateNum = 1),
                (this.btn_close.anchorX = 1),
                (this.btn_close.anchorY = 1),
                (this.btn_close.top = 0),
                (this.btn_close.right = 0),
                a.handler_closeBtn
                  ? (this.handler_closeBtn = a.handler_cancelBtn)
                  : (this.handler_closeBtn = this.handler_close),
                this.btn_close.on(Laya.Event.CLICK, this, function () {
                  this.handler_closeBtn.run();
                }))
              : console.log("模态弹出框关闭按钮纹理为空!!!"),
            a.tex_sureBtn)
          ) {
            if (
              ((this.btn_sure = new Laya.Button()),
              this.img_bg.addChild(this.btn_sure),
              (this.btn_sure.stateNum = 1),
              (this.btn_sure.skin = a.tex_sureBtn),
              a.texSizegrid_sureBtn &&
                (this.btn_sure.sizeGrid = a.texSizegrid_sureBtn),
              this.btn_sure.size(200, 120),
              (this.handler_sureBtn = a.handler_sureBtn),
              this.btn_sure.on(Laya.Event.CLICK, this, function () {
                this.handler_sureBtn && this.handler_sureBtn.run(),
                  this.handler_close.run();
              }),
              a.font_sureBtn)
            ) {
              let t = Laya.loader.getRes(a.font_sureBtn);
              t
                ? ((this.font_btn_sure = new Laya.Image()),
                  this.btn_sure.addChild(this.font_btn_sure),
                  (this.font_btn_sure.source = t))
                : ((this.font_btn_sure = new Laya.Label()),
                  this.btn_sure.addChild(this.font_btn_sure),
                  (this.font_btn_sure.text = a.font_sureBtn),
                  (this.font_btn_sure.color = "#ffffff"),
                  (this.font_btn_sure.fontSize = 34),
                  (this.font_btn_sure.bold = !0)),
                !a.font_suereBtn_centeroffset &&
                  (a.font_suereBtn_centeroffset = new Laya.Point(0, 0)),
                (this.font_btn_sure.centerX = a.font_suereBtn_centeroffset.x),
                (this.font_btn_sure.centerY = a.font_suereBtn_centeroffset.y);
            }
          } else console.log("模态对话框确认按钮纹理缺失!!!");
          if (a.tex_cancelBtn) {
            if (
              ((this.btn_cancel = new Laya.Button()),
              this.img_bg.addChild(this.btn_cancel),
              (this.btn_cancel.stateNum = 1),
              (this.btn_cancel.skin = a.tex_cancelBtn),
              a.texSizegrid_cancelBtn &&
                (this.btn_cancel.sizeGrid = a.texSizegrid_cancelBtn),
              this.btn_cancel.size(200, 120),
              (this.handler_cancelBtn = a.handler_cancelBtn),
              this.btn_cancel.on(Laya.Event.CLICK, this, function () {
                this.handler_cancelBtn && this.handler_cancelBtn.run(),
                  this.handler_close.run();
              }),
              a.font_cancelBtn)
            ) {
              let t = Laya.loader.getRes(a.font_cancelBtn);
              t
                ? ((this.font_btn_cancel = new Laya.Image()),
                  this.btn_cancel.addChild(this.font_btn_cancel),
                  (this.font_btn_cancel.source = t))
                : ((this.font_btn_cancel = new Laya.Label()),
                  this.btn_cancel.addChild(this.font_btn_cancel),
                  (this.font_btn_cancel.text = a.font_cancelBtn),
                  (this.font_btn_cancel.color = "#ffffff"),
                  (this.font_btn_cancel.fontSize = 34),
                  (this.font_btn_cancel.bold = !0)),
                !a.font_cancelBtn_centeroffset &&
                  (a.font_cancelBtn_centeroffset = new Laya.Point(0, 0)),
                (this.font_btn_cancel.centerX =
                  a.font_cancelBtn_centeroffset.x),
                (this.font_btn_cancel.centerY =
                  a.font_cancelBtn_centeroffset.y);
            }
          } else console.log("模态对话框取消按钮纹理缺失!!!");
          this.btn_sure && this.btn_cancel
            ? ((this.btn_sure.centerX =
                (this.img_bg.width / 2 - this.btn_sure.width) / 2 +
                this.btn_sure.width / 2),
              (this.btn_sure.bottom = -this.btn_sure.height / 3),
              (this.btn_cancel.centerX =
                -(this.img_bg.width / 2 - this.btn_cancel.width) / 2 -
                this.btn_cancel.width / 2),
              (this.btn_cancel.bottom = -this.btn_cancel.height / 3))
            : this.btn_sure && !this.btn_cancel
            ? ((this.btn_sure.centerX = 0), (this.btn_sure.bottom = 0))
            : !this.btn_sure &&
              this.btn_cancel &&
              ((this.btn_cancel.centerX = 0), (this.btn_cancel.bottom = 0));
        }
        get label_title() {
          return this._label_title;
        }
        set label_title(t) {
          this._label_title = t;
        }
        get label_content() {
          return this._label_content;
        }
        set label_content(t) {
          this._label_content = t;
        }
        get img_bgmask() {
          return this._img_bgmask;
        }
        set img_bgmask(t) {
          this._img_bgmask = t;
        }
        get img_bg() {
          return this._img_bg;
        }
        set img_bg(t) {
          this._img_bg = t;
        }
        get btn_close() {
          return this._btn_close;
        }
        set btn_close(t) {
          this._btn_close = t;
        }
        get btn_sure() {
          return this._btn_sure;
        }
        set btn_sure(t) {
          this._btn_sure = t;
        }
        get font_btn_sure() {
          return this._font_btn_sure;
        }
        set font_btn_sure(t) {
          this._font_btn_sure = t;
        }
        get btn_cancel() {
          return this._btn_cancel;
        }
        set btn_cancel(t) {
          this._btn_cancel = t;
        }
        get font_btn_cancel() {
          return this._font_btn_cancel;
        }
        set font_btn_cancel(t) {
          this._font_btn_cancel = t;
        }
      }),
      (t.OutlineMaterial = Xt),
      (t.Physics = _),
      (t.PhysicsScript = jt),
      (t.Plane2d = g),
      (t.Plane3d = class {
        constructor(t, e, a, n) {
          (this.lb = t), (this.rb = e), (this.lt = a), (this.rt = n);
        }
        containPoint(t) {
          let e,
            a,
            n = [this.lb.x, this.rb.x, this.rt.x, this.lt.x],
            u = [this.lb.z, this.rb.z, this.rt.z, this.lt.z],
            m = !1;
          for (e = 0, a = 3; e < 4; a = e++)
            u[e] > t.z != u[a] > t.z &&
              t.x < ((n[a] - n[e]) * (t.z - u[e])) / (u[a] - u[e]) + n[e] &&
              (m = !m);
          return m;
        }
      }),
      (t.RES3D_GROUP_NAME = "3DRES_GROUP"),
      (t.SceneManager = tt),
      (t.Sequence = S),
      (t.Sequence3D = class {
        constructor(t, e) {
          (this._actions = e || []),
            (this._isRepeat = t),
            (this._addParallelCount =
              this._runningParallelCnt =
              this._actionIdx =
                0),
            (this._temp = new a()),
            (this._rotQ = new Laya.Quaternion());
        }
        get actions() {
          return this._actions;
        }
        get isRepeat() {
          return this._isRepeat;
        }
        set isRepeat(t) {
          this._isRepeat = t;
        }
        get actionIdx() {
          return this._actionIdx;
        }
        set actionIdx(t) {
          this._actionIdx = t;
        }
        run(t) {
          t = t || this._target;
          let e = this._actions;
          if (!e || 0 === e.length || !t || t.destroyed) return;
          t != this._target &&
            ((this._target = t), t.once(Laya.Event.REMOVED, this, this.stop));
          let a = this._actionIdx;
          if (a >= e.length) {
            if (!this._isRepeat) return void this.stop();
            a = this._actionIdx = 0;
          }
          let n = e[a];
          for (this._run(n); a++, (n = e[a]), n && n.isParallel; ) {
            (this._actionIdx = a), this._run(n) && this._runningParallelCnt++;
          }
        }
        _run(t) {
          if (!t.props || !w.isNumber(t.duration)) return !1;
          switch (t.t) {
            case "delay":
              Laya.timer.once(t.duration, this, this.runNext);
              break;
            case "exec":
              if (t.props.exec) {
                let e = t.target || this._target;
                t.props.exec.runWith(e);
              }
              this.runNext();
              break;
            case "from": {
              let e = t.props,
                a = t.target || this._target;
              "function" == typeof e && (e = e(a)),
                (t.tween = Laya.Tween.from(
                  a,
                  e,
                  t.duration,
                  t.ease,
                  Laya.Handler.create(this, () => {
                    (t.tween = null), this.runNext();
                  }),
                  t.delay
                ));
              break;
            }
            case "to": {
              let e = t.props,
                a = t.target || this._target;
              "function" == typeof e && (e = e(a)),
                (t.tween = Laya.Tween.to(
                  a,
                  e,
                  t.duration,
                  t.ease,
                  Laya.Handler.create(this, () => {
                    (t.tween = null), this.runNext();
                  }),
                  t.delay
                ));
              break;
            }
            default:
              throw Error(`Sequence3D unknown action type ${t.t} !!!`);
          }
          return !0;
        }
        runNext() {
          this._runningParallelCnt > 0
            ? this._runningParallelCnt--
            : (this._runningParallelCnt < 0 &&
                console.error(
                  "Sequence3D unexpected parallel count " +
                    this._runningParallelCnt
                ),
              this._actionIdx++,
              this.run());
        }
        stop() {
          for (const t of this._actions)
            t.tween && (t.tween.clear(), (t.tween = null));
          this._target && this._target.offAllCaller(this),
            (this._target = null),
            (this._actionIdx = 0);
        }
        pushAction(t) {
          this._addParallelCount > 0
            ? (this._addParallelCount--,
              (t.isParallel = !0),
              this._actions.push(t))
            : this._actions.push(t);
        }
        parallel(t) {
          return (this._addParallelCount = t), this;
        }
        delay(t) {
          let e = { t: "delay", target: null, props: {}, duration: t };
          return this.pushAction(e), this;
        }
        hide() {
          let t = {
            t: "exec",
            target: null,
            props: { exec: null },
            duration: 0,
          };
          return (
            (t.props.exec = Laya.Handler.create(this, () => {
              this._target.active = !1;
            })),
            this.pushAction(t),
            this
          );
        }
        show() {
          let t = {
            t: "exec",
            target: null,
            props: { exec: null },
            duration: 0,
          };
          return (
            (t.props.exec = Laya.Handler.create(this, () => {
              this._target.active = !0;
            })),
            this.pushAction(t),
            this
          );
        }
        removeNode(t) {
          let e = {
            t: "exec",
            target: null,
            props: { exec: null },
            duration: 0,
          };
          return (
            (e.props.exec = Laya.Handler.create(this, () => {
              t ? this._target.destroy() : this._target.removeSelf();
            })),
            this.pushAction(e),
            this
          );
        }
        scaleIn(t, e, n, u, m) {
          let f = {
            t: "from",
            target: new a(),
            props: (a) => (
              m
                ? a.from(this._target.transform.localScale)
                : a.from(this._target.transform.getWorldLossyScale()),
              {
                x: t,
                y: e,
                z: n,
                update: Laya.Handler.create(
                  this,
                  () => {
                    m
                      ? (this._target.transform.localScale = a)
                      : this._target.transform.setWorldLossyScale(a);
                  },
                  null,
                  !1
                ),
              }
            ),
            duration: u,
          };
          return this.pushAction(f), this;
        }
        scaleOut(t, e, n, u, m) {
          let f = {
            t: "to",
            target: new a(),
            props: (a) => (
              m
                ? a.from(this._target.transform.localScale)
                : a.from(this._target.transform.getWorldLossyScale()),
              {
                x: t,
                y: e,
                z: n,
                update: Laya.Handler.create(
                  this,
                  () => {
                    m
                      ? (this._target.transform.localScale = a)
                      : this._target.transform.setWorldLossyScale(a);
                  },
                  null,
                  !1
                ),
              }
            ),
            duration: u,
          };
          return this.pushAction(f), this;
        }
        pos(t, e, n, u, m, f) {
          let p = {
            t: "to",
            target: new a(t, e, n),
            props: (a) => (
              m
                ? a.from(this._target.transform.localPosition)
                : a.from(this._target.transform.position),
              {
                x: t,
                y: e,
                z: n,
                update: Laya.Handler.create(
                  this,
                  () => {
                    m
                      ? (this._target.transform.localPosition = a)
                      : (this._target.transform.position = a);
                  },
                  null,
                  !1
                ),
              }
            ),
            duration: u,
            ease: f,
          };
          return (
            0 == u &&
              ((p.t = "exec"),
              (p.ease = null),
              (p.props = {}),
              (p.props.exec = Laya.Handler.create(this, (t) => {
                m
                  ? (this._target.transform.localPosition = t)
                  : (this._target.transform.position = t);
              }))),
            this.pushAction(p),
            this
          );
        }
        rotate(t, e, a, n, u) {
          let m = {
            t: "to",
            target: { angle: 0 },
            props: {
              angle: t,
              update: Laya.Handler.create(
                this,
                () => {
                  let e = this._rotQ;
                  Laya.Quaternion.createFromAxisAngle(a, Math.rad(t), e);
                  let u = this._target;
                  n
                    ? (Laya.Quaternion.multiply(
                        e,
                        u.transform.localRotation,
                        e
                      ),
                      (u.transform.localRotation = e))
                    : (Laya.Quaternion.multiply(e, u.transform.rotation, e),
                      (u.transform.rotation = e));
                },
                null,
                !1
              ),
            },
            duration: e,
            ease: u,
          };
          return this.pushAction(m), this;
        }
        exec(t) {
          let e = { t: "exec", target: null, props: { exec: t }, duration: 0 };
          return this.pushAction(e), this;
        }
      }),
      (t.SoundManager = Z),
      (t.Trail = Ut),
      (t.UniformBezier = class {
        constructor(t, e) {
          if (t.length < 2)
            throw Error("UniformBezier control point count must >= 2 !!!");
          (this.temp = new a()),
            (Bt.sAutoHandleDistance = e.autoHandleDistance);
          let n,
            u = new Array();
          for (const e of t) {
            let t = new Bt(e.pos, e.rot, n, void 0);
            n && (n.nextSegment = t), (n = t), u.push(t);
          }
          for (const t of u) t.init(e.density, e.maxPointsPerUnit);
          let m = 0;
          for (const t of u) (t.start = m), (m += t.calcLength());
          (this.segments = u), (this.length = m);
        }
        getLength() {
          return this.length;
        }
        getPoint(t) {
          (t = Math.clamp(t, 0, 1)), (t *= this.length);
          let e = this.segments[Math.max(0, this.upperBound(t) - 1)];
          return (t = (t - e.start) / e.getLength()), e.getPoint(t);
        }
        upperBound(t) {
          let e;
          for (
            e = 0;
            e < this.segments.length && !(this.segments[e].start > t);
            ++e
          );
          return e;
        }
        getForward(t, e = 0.01) {
          t = Math.min(t, 0.99);
          let n = this.getPoint(t),
            u = this.getPoint(t + e);
          return a.subtract(u, n, n), n.normalize(), n;
        }
        getUp(t) {
          (t = Math.clamp(t, 0, 1)), (t *= this.length);
          let e = this.segments[Math.max(0, this.upperBound(t) - 1)];
          return (t = (t - e.start) / e.getLength()), e.getUp(t);
        }
        getNearestPointF(t) {
          let e,
            n,
            u,
            m = 1 / 0,
            f = this.temp;
          for (const p of this.segments) {
            let y = p.getNearestPointF(t),
              g = p.getPoint(y);
            a.subtract(g, t, f);
            let _ = a.scalarLengthSquared(f);
            _ <= m && ((m = _), (n = p), (e = y), (u = g));
          }
          return (e = (n.start + e * n.getLength()) / this.length), [u, e];
        }
      }),
      (t.UserInfoEntity = Zt),
      (t.UserLogic = Kt),
      (t.Utils = w),
      (t.Vector2 = e),
      (t.Vector3 = a),
      (t.Vector4 = n),
      (t.WaterMaterial = Jt),
      (t.WebSocket = class {
        constructor() {
          (this.byte = new Laya.Byte()),
            (this.byte.endian = Laya.Byte.LITTLE_ENDIAN),
            (this.ws = new Laya.Socket()),
            (this.ws.endian = Laya.Byte.LITTLE_ENDIAN),
            this.ws.on(Laya.Event.MESSAGE, this, this._onMessage),
            this.ws.on(Laya.Event.OPEN, this, this._onOpen),
            this.ws.on(Laya.Event.CLOSE, this, this._onClose),
            this.ws.on(Laya.Event.ERROR, this, this._onError);
        }
        isConnected() {
          return this.ws.connected;
        }
        _onMessage(t) {
          this.onMessage && this.onMessage(t);
        }
        _onOpen(t) {
          console.log("WebSocket onOpen"), this.onOpen && this.onOpen(t);
        }
        _onClose(t) {
          console.log("WebSocket onClose"),
            (this.token = void 0),
            this.onClose && this.onClose(t);
        }
        _onError(t) {
          console.log("WebSocket onError"), this.onError && this.onError(t);
        }
        connect(t, e) {
          return (
            console.log(`WebSocket connect ${t} port:${e}`),
            e ? this.ws.connect(t, e) : this.ws.connectByUrl(t),
            this
          );
        }
        close() {
          this.ws.close(), (this.token = void 0);
        }
        destroy() {
          this.ws.offAll();
          try {
            this.ws.cleanSocket();
          } catch (t) {}
          (this.ws = null), (this.token = void 0);
        }
        send(t) {
          return this.ws.send(t), this;
        }
      }),
      t
    );
  })({}));
